#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2670
#define LARGE_STATE_COUNT 571
#define SYMBOL_COUNT 404
#define ALIAS_COUNT 0
#define TOKEN_COUNT 195
#define EXTERNAL_TOKEN_COUNT 12
#define FIELD_COUNT 26
#define MAX_ALIAS_SEQUENCE_LENGTH 12
#define PRODUCTION_ID_COUNT 190

enum ts_symbol_identifiers {
  sym_name = 1,
  anon_sym_QMARK_GT = 2,
  sym_php_tag = 3,
  aux_sym_text_token1 = 4,
  anon_sym_SEMI = 5,
  anon_sym_AMP = 6,
  aux_sym_function_static_declaration_token1 = 7,
  anon_sym_COMMA = 8,
  anon_sym_EQ = 9,
  aux_sym_global_declaration_token1 = 10,
  aux_sym_namespace_definition_token1 = 11,
  aux_sym_namespace_use_declaration_token1 = 12,
  aux_sym_namespace_use_declaration_token2 = 13,
  aux_sym_namespace_use_declaration_token3 = 14,
  anon_sym_BSLASH = 15,
  aux_sym_namespace_aliasing_clause_token1 = 16,
  anon_sym_LBRACE = 17,
  anon_sym_RBRACE = 18,
  aux_sym_trait_declaration_token1 = 19,
  aux_sym_interface_declaration_token1 = 20,
  aux_sym_base_clause_token1 = 21,
  aux_sym_enum_declaration_token1 = 22,
  anon_sym_COLON = 23,
  anon_sym_string = 24,
  anon_sym_int = 25,
  aux_sym_enum_case_token1 = 26,
  aux_sym_class_declaration_token1 = 27,
  aux_sym_final_modifier_token1 = 28,
  aux_sym_abstract_modifier_token1 = 29,
  aux_sym_readonly_modifier_token1 = 30,
  aux_sym_class_interface_clause_token1 = 31,
  sym_var_modifier = 32,
  aux_sym_use_instead_of_clause_token1 = 33,
  aux_sym_visibility_modifier_token1 = 34,
  aux_sym_visibility_modifier_token2 = 35,
  aux_sym_visibility_modifier_token3 = 36,
  aux_sym__arrow_function_header_token1 = 37,
  anon_sym_EQ_GT = 38,
  anon_sym_LPAREN = 39,
  anon_sym_RPAREN = 40,
  anon_sym_DOT_DOT_DOT = 41,
  anon_sym_QMARK = 42,
  sym_bottom_type = 43,
  anon_sym_PIPE = 44,
  anon_sym_array = 45,
  aux_sym_primitive_type_token1 = 46,
  anon_sym_iterable = 47,
  anon_sym_bool = 48,
  anon_sym_float = 49,
  anon_sym_void = 50,
  anon_sym_mixed = 51,
  anon_sym_static = 52,
  anon_sym_false = 53,
  anon_sym_null = 54,
  anon_sym_true = 55,
  aux_sym_cast_type_token1 = 56,
  aux_sym_cast_type_token2 = 57,
  aux_sym_cast_type_token3 = 58,
  aux_sym_cast_type_token4 = 59,
  aux_sym_cast_type_token5 = 60,
  aux_sym_cast_type_token6 = 61,
  aux_sym_cast_type_token7 = 62,
  aux_sym_cast_type_token8 = 63,
  aux_sym_cast_type_token9 = 64,
  aux_sym_cast_type_token10 = 65,
  aux_sym_cast_type_token11 = 66,
  aux_sym_cast_type_token12 = 67,
  aux_sym_echo_statement_token1 = 68,
  anon_sym_unset = 69,
  aux_sym_declare_statement_token1 = 70,
  aux_sym_declare_statement_token2 = 71,
  anon_sym_ticks = 72,
  anon_sym_encoding = 73,
  anon_sym_strict_types = 74,
  sym_float = 75,
  aux_sym_try_statement_token1 = 76,
  aux_sym_catch_clause_token1 = 77,
  aux_sym_finally_clause_token1 = 78,
  aux_sym_goto_statement_token1 = 79,
  aux_sym_continue_statement_token1 = 80,
  aux_sym_break_statement_token1 = 81,
  sym_integer = 82,
  aux_sym_return_statement_token1 = 83,
  aux_sym_throw_expression_token1 = 84,
  aux_sym_while_statement_token1 = 85,
  aux_sym_while_statement_token2 = 86,
  aux_sym_do_statement_token1 = 87,
  aux_sym_for_statement_token1 = 88,
  aux_sym_for_statement_token2 = 89,
  aux_sym_foreach_statement_token1 = 90,
  aux_sym_foreach_statement_token2 = 91,
  aux_sym_if_statement_token1 = 92,
  aux_sym_if_statement_token2 = 93,
  aux_sym_else_if_clause_token1 = 94,
  aux_sym_else_clause_token1 = 95,
  aux_sym_match_expression_token1 = 96,
  aux_sym_match_default_expression_token1 = 97,
  aux_sym_switch_statement_token1 = 98,
  aux_sym_switch_block_token1 = 99,
  anon_sym_PLUS = 100,
  anon_sym_DASH = 101,
  anon_sym_TILDE = 102,
  anon_sym_BANG = 103,
  anon_sym_AT = 104,
  aux_sym_clone_expression_token1 = 105,
  anon_sym_COLON_COLON = 106,
  aux_sym_print_intrinsic_token1 = 107,
  aux_sym_object_creation_expression_token1 = 108,
  anon_sym_DASH_DASH = 109,
  anon_sym_PLUS_PLUS = 110,
  anon_sym_STAR_STAR_EQ = 111,
  anon_sym_STAR_EQ = 112,
  anon_sym_SLASH_EQ = 113,
  anon_sym_PERCENT_EQ = 114,
  anon_sym_PLUS_EQ = 115,
  anon_sym_DASH_EQ = 116,
  anon_sym_DOT_EQ = 117,
  anon_sym_LT_LT_EQ = 118,
  anon_sym_GT_GT_EQ = 119,
  anon_sym_AMP_EQ = 120,
  anon_sym_CARET_EQ = 121,
  anon_sym_PIPE_EQ = 122,
  anon_sym_QMARK_QMARK_EQ = 123,
  anon_sym_DASH_GT = 124,
  anon_sym_QMARK_DASH_GT = 125,
  aux_sym__list_destructing_token1 = 126,
  anon_sym_LBRACK = 127,
  anon_sym_RBRACK = 128,
  anon_sym_self = 129,
  anon_sym_parent = 130,
  aux_sym__argument_name_token1 = 131,
  aux_sym__argument_name_token2 = 132,
  anon_sym_POUND_LBRACK = 133,
  sym_escape_sequence = 134,
  anon_sym_BSLASHu = 135,
  anon_sym_SQUOTE = 136,
  anon_sym_LT_QMARK = 137,
  anon_sym_QMARK_GT2 = 138,
  aux_sym_encapsed_string_token1 = 139,
  anon_sym_DQUOTE = 140,
  aux_sym_string_token1 = 141,
  aux_sym_string_token2 = 142,
  sym_string_value = 143,
  anon_sym_LT_LT_LT = 144,
  anon_sym_DQUOTE2 = 145,
  sym__new_line = 146,
  anon_sym_ = 147,
  anon_sym_SQUOTE2 = 148,
  anon_sym_BQUOTE = 149,
  anon_sym_DOLLAR = 150,
  aux_sym_yield_expression_token1 = 151,
  aux_sym_yield_expression_token2 = 152,
  aux_sym_binary_expression_token1 = 153,
  anon_sym_QMARK_QMARK = 154,
  anon_sym_STAR_STAR = 155,
  aux_sym_binary_expression_token2 = 156,
  aux_sym_binary_expression_token3 = 157,
  aux_sym_binary_expression_token4 = 158,
  anon_sym_PIPE_PIPE = 159,
  anon_sym_AMP_AMP = 160,
  anon_sym_CARET = 161,
  anon_sym_EQ_EQ = 162,
  anon_sym_BANG_EQ = 163,
  anon_sym_LT_GT = 164,
  anon_sym_EQ_EQ_EQ = 165,
  anon_sym_BANG_EQ_EQ = 166,
  anon_sym_LT = 167,
  anon_sym_GT = 168,
  anon_sym_LT_EQ = 169,
  anon_sym_GT_EQ = 170,
  anon_sym_LT_EQ_GT = 171,
  anon_sym_LT_LT = 172,
  anon_sym_GT_GT = 173,
  anon_sym_DOT = 174,
  anon_sym_STAR = 175,
  anon_sym_SLASH = 176,
  anon_sym_PERCENT = 177,
  aux_sym_include_expression_token1 = 178,
  aux_sym_include_once_expression_token1 = 179,
  aux_sym_require_expression_token1 = 180,
  aux_sym_require_once_expression_token1 = 181,
  sym_comment = 182,
  sym__automatic_semicolon = 183,
  sym_encapsed_string_chars = 184,
  sym_encapsed_string_chars_after_variable = 185,
  sym_execution_string_chars = 186,
  sym_execution_string_chars_after_variable = 187,
  sym_encapsed_string_chars_heredoc = 188,
  sym_encapsed_string_chars_after_variable_heredoc = 189,
  sym__eof = 190,
  sym_heredoc_start = 191,
  sym_heredoc_end = 192,
  sym_nowdoc_string = 193,
  sym_sentinel_error = 194,
  sym_program = 195,
  sym_empty_statement = 196,
  sym_reference_modifier = 197,
  sym_function_static_declaration = 198,
  sym_static_variable_declaration = 199,
  sym_global_declaration = 200,
  sym_namespace_definition = 201,
  sym_namespace_use_declaration = 202,
  sym_namespace_use_clause = 203,
  sym_qualified_name = 204,
  sym_namespace_name_as_prefix = 205,
  sym_namespace_name = 206,
  sym_namespace_aliasing_clause = 207,
  sym_namespace_use_group = 208,
  sym_namespace_use_group_clause = 209,
  sym_trait_declaration = 210,
  sym_interface_declaration = 211,
  sym_base_clause = 212,
  sym_enum_declaration = 213,
  sym_enum_declaration_list = 214,
  sym__enum_member_declaration = 215,
  sym_enum_case = 216,
  sym_class_declaration = 217,
  sym_declaration_list = 218,
  sym_final_modifier = 219,
  sym_abstract_modifier = 220,
  sym_readonly_modifier = 221,
  sym_class_interface_clause = 222,
  sym__member_declaration = 223,
  sym_const_declaration = 224,
  sym__class_const_declaration = 225,
  sym__const_declaration = 226,
  sym_property_declaration = 227,
  sym__modifier = 228,
  sym_property_element = 229,
  sym_property_initializer = 230,
  sym_method_declaration = 231,
  sym_static_modifier = 232,
  sym_use_declaration = 233,
  sym_use_list = 234,
  sym_use_instead_of_clause = 235,
  sym_use_as_clause = 236,
  sym_visibility_modifier = 237,
  sym_function_definition = 238,
  sym__function_definition_header = 239,
  sym__arrow_function_header = 240,
  sym_arrow_function = 241,
  sym_formal_parameters = 242,
  sym_property_promotion_parameter = 243,
  sym_simple_parameter = 244,
  sym_variadic_parameter = 245,
  sym__type = 246,
  sym__types = 247,
  sym_named_type = 248,
  sym_optional_type = 249,
  sym_union_type = 250,
  sym_intersection_type = 251,
  sym_disjunctive_normal_form_type = 252,
  sym_primitive_type = 253,
  sym_cast_type = 254,
  sym__return_type = 255,
  sym_const_element = 256,
  sym_echo_statement = 257,
  sym_unset_statement = 258,
  sym_declare_statement = 259,
  sym_declare_directive = 260,
  sym_try_statement = 261,
  sym_catch_clause = 262,
  sym_type_list = 263,
  sym_finally_clause = 264,
  sym_goto_statement = 265,
  sym_continue_statement = 266,
  sym_break_statement = 267,
  sym_return_statement = 268,
  sym_throw_expression = 269,
  sym_while_statement = 270,
  sym_do_statement = 271,
  sym_for_statement = 272,
  sym__expressions = 273,
  sym_sequence_expression = 274,
  sym_foreach_statement = 275,
  sym_foreach_pair = 276,
  sym_if_statement = 277,
  sym_colon_block = 278,
  sym_else_if_clause = 279,
  sym_else_clause = 280,
  sym_else_if_clause_2 = 281,
  sym_else_clause_2 = 282,
  sym_match_expression = 283,
  sym_match_block = 284,
  sym_match_condition_list = 285,
  sym_match_conditional_expression = 286,
  sym_match_default_expression = 287,
  sym_switch_statement = 288,
  sym_switch_block = 289,
  sym_case_statement = 290,
  sym_default_statement = 291,
  sym_compound_statement = 292,
  sym_named_label_statement = 293,
  sym_expression_statement = 294,
  sym__expression = 295,
  sym__unary_expression = 296,
  sym_unary_op_expression = 297,
  sym_error_suppression_expression = 298,
  sym_clone_expression = 299,
  sym__primary_expression = 300,
  sym_parenthesized_expression = 301,
  sym_class_constant_access_expression = 302,
  sym_print_intrinsic = 303,
  sym_anonymous_function_creation_expression = 304,
  sym_anonymous_function_use_clause = 305,
  sym_object_creation_expression = 306,
  sym_update_expression = 307,
  sym_cast_expression = 308,
  sym_cast_variable = 309,
  sym_assignment_expression = 310,
  sym_reference_assignment_expression = 311,
  sym_conditional_expression = 312,
  sym_augmented_assignment_expression = 313,
  sym_member_access_expression = 314,
  sym_nullsafe_member_access_expression = 315,
  sym_scoped_property_access_expression = 316,
  sym_list_literal = 317,
  sym__list_destructing = 318,
  sym__array_destructing = 319,
  sym__array_destructing_element = 320,
  sym_function_call_expression = 321,
  sym_scoped_call_expression = 322,
  sym__scope_resolution_qualifier = 323,
  sym_relative_scope = 324,
  sym_variadic_placeholder = 325,
  sym_arguments = 326,
  sym_argument = 327,
  sym__argument_name = 328,
  sym_member_call_expression = 329,
  sym_nullsafe_member_call_expression = 330,
  sym_variadic_unpacking = 331,
  sym_subscript_expression = 332,
  sym__dereferencable_expression = 333,
  sym_array_creation_expression = 334,
  sym_attribute_group = 335,
  sym_attribute_list = 336,
  sym_attribute = 337,
  sym__complex_string_part = 338,
  sym__simple_string_member_access_expression = 339,
  sym__simple_string_subscript_unary_expression = 340,
  sym__simple_string_array_access_argument = 341,
  sym__simple_string_subscript_expression = 342,
  sym__simple_string_part = 343,
  aux_sym__interpolated_string_body = 344,
  aux_sym__interpolated_string_body_heredoc = 345,
  sym_encapsed_string = 346,
  sym_string = 347,
  sym_heredoc_body = 348,
  sym_heredoc = 349,
  sym_nowdoc_body = 350,
  sym_nowdoc = 351,
  aux_sym__interpolated_execution_operator_body = 352,
  sym_shell_command_expression = 353,
  sym_boolean = 354,
  sym_null = 355,
  sym__string = 356,
  sym_dynamic_variable_name = 357,
  sym_variable_name = 358,
  sym_variable_reference = 359,
  sym_by_ref = 360,
  sym_yield_expression = 361,
  sym_array_element_initializer = 362,
  sym_binary_expression = 363,
  sym_include_expression = 364,
  sym_include_once_expression = 365,
  sym_require_expression = 366,
  sym_require_once_expression = 367,
  sym__reserved_identifier = 368,
  aux_sym_program_repeat1 = 369,
  aux_sym_function_static_declaration_repeat1 = 370,
  aux_sym_global_declaration_repeat1 = 371,
  aux_sym_namespace_use_declaration_repeat1 = 372,
  aux_sym_namespace_name_repeat1 = 373,
  aux_sym_namespace_use_group_repeat1 = 374,
  aux_sym_base_clause_repeat1 = 375,
  aux_sym_enum_declaration_list_repeat1 = 376,
  aux_sym_declaration_list_repeat1 = 377,
  aux_sym__const_declaration_repeat1 = 378,
  aux_sym_property_declaration_repeat1 = 379,
  aux_sym_property_declaration_repeat2 = 380,
  aux_sym_use_list_repeat1 = 381,
  aux_sym_formal_parameters_repeat1 = 382,
  aux_sym_union_type_repeat1 = 383,
  aux_sym_intersection_type_repeat1 = 384,
  aux_sym_disjunctive_normal_form_type_repeat1 = 385,
  aux_sym_unset_statement_repeat1 = 386,
  aux_sym_try_statement_repeat1 = 387,
  aux_sym_type_list_repeat1 = 388,
  aux_sym_if_statement_repeat1 = 389,
  aux_sym_if_statement_repeat2 = 390,
  aux_sym_match_block_repeat1 = 391,
  aux_sym_match_condition_list_repeat1 = 392,
  aux_sym_switch_block_repeat1 = 393,
  aux_sym_anonymous_function_use_clause_repeat1 = 394,
  aux_sym__list_destructing_repeat1 = 395,
  aux_sym__array_destructing_repeat1 = 396,
  aux_sym_arguments_repeat1 = 397,
  aux_sym_array_creation_expression_repeat1 = 398,
  aux_sym_attribute_group_repeat1 = 399,
  aux_sym_attribute_list_repeat1 = 400,
  aux_sym_string_repeat1 = 401,
  aux_sym_heredoc_body_repeat1 = 402,
  aux_sym_nowdoc_body_repeat1 = 403,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_name] = "name",
  [anon_sym_QMARK_GT] = "\?>",
  [sym_php_tag] = "php_tag",
  [aux_sym_text_token1] = "text_token1",
  [anon_sym_SEMI] = ";",
  [anon_sym_AMP] = "&",
  [aux_sym_function_static_declaration_token1] = "static",
  [anon_sym_COMMA] = ",",
  [anon_sym_EQ] = "=",
  [aux_sym_global_declaration_token1] = "global",
  [aux_sym_namespace_definition_token1] = "namespace",
  [aux_sym_namespace_use_declaration_token1] = "use",
  [aux_sym_namespace_use_declaration_token2] = "function",
  [aux_sym_namespace_use_declaration_token3] = "const",
  [anon_sym_BSLASH] = "\\",
  [aux_sym_namespace_aliasing_clause_token1] = "as",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [aux_sym_trait_declaration_token1] = "trait",
  [aux_sym_interface_declaration_token1] = "interface",
  [aux_sym_base_clause_token1] = "extends",
  [aux_sym_enum_declaration_token1] = "enum",
  [anon_sym_COLON] = ":",
  [anon_sym_string] = "string",
  [anon_sym_int] = "int",
  [aux_sym_enum_case_token1] = "case",
  [aux_sym_class_declaration_token1] = "class",
  [aux_sym_final_modifier_token1] = "final",
  [aux_sym_abstract_modifier_token1] = "abstract",
  [aux_sym_readonly_modifier_token1] = "readonly",
  [aux_sym_class_interface_clause_token1] = "implements",
  [sym_var_modifier] = "var_modifier",
  [aux_sym_use_instead_of_clause_token1] = "insteadof",
  [aux_sym_visibility_modifier_token1] = "public",
  [aux_sym_visibility_modifier_token2] = "protected",
  [aux_sym_visibility_modifier_token3] = "private",
  [aux_sym__arrow_function_header_token1] = "fn",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "\?",
  [sym_bottom_type] = "bottom_type",
  [anon_sym_PIPE] = "|",
  [anon_sym_array] = "array",
  [aux_sym_primitive_type_token1] = "callable",
  [anon_sym_iterable] = "iterable",
  [anon_sym_bool] = "bool",
  [anon_sym_float] = "float",
  [anon_sym_void] = "void",
  [anon_sym_mixed] = "mixed",
  [anon_sym_static] = "static",
  [anon_sym_false] = "false",
  [anon_sym_null] = "null",
  [anon_sym_true] = "true",
  [aux_sym_cast_type_token1] = "cast_type_token1",
  [aux_sym_cast_type_token2] = "cast_type_token2",
  [aux_sym_cast_type_token3] = "cast_type_token3",
  [aux_sym_cast_type_token4] = "cast_type_token4",
  [aux_sym_cast_type_token5] = "cast_type_token5",
  [aux_sym_cast_type_token6] = "cast_type_token6",
  [aux_sym_cast_type_token7] = "cast_type_token7",
  [aux_sym_cast_type_token8] = "cast_type_token8",
  [aux_sym_cast_type_token9] = "cast_type_token9",
  [aux_sym_cast_type_token10] = "cast_type_token10",
  [aux_sym_cast_type_token11] = "cast_type_token11",
  [aux_sym_cast_type_token12] = "cast_type_token12",
  [aux_sym_echo_statement_token1] = "echo",
  [anon_sym_unset] = "unset",
  [aux_sym_declare_statement_token1] = "declare",
  [aux_sym_declare_statement_token2] = "enddeclare",
  [anon_sym_ticks] = "ticks",
  [anon_sym_encoding] = "encoding",
  [anon_sym_strict_types] = "strict_types",
  [sym_float] = "float",
  [aux_sym_try_statement_token1] = "try",
  [aux_sym_catch_clause_token1] = "catch",
  [aux_sym_finally_clause_token1] = "finally",
  [aux_sym_goto_statement_token1] = "goto",
  [aux_sym_continue_statement_token1] = "continue",
  [aux_sym_break_statement_token1] = "break",
  [sym_integer] = "integer",
  [aux_sym_return_statement_token1] = "return",
  [aux_sym_throw_expression_token1] = "throw",
  [aux_sym_while_statement_token1] = "while",
  [aux_sym_while_statement_token2] = "endwhile",
  [aux_sym_do_statement_token1] = "do",
  [aux_sym_for_statement_token1] = "for",
  [aux_sym_for_statement_token2] = "endfor",
  [aux_sym_foreach_statement_token1] = "foreach",
  [aux_sym_foreach_statement_token2] = "endforeach",
  [aux_sym_if_statement_token1] = "if",
  [aux_sym_if_statement_token2] = "endif",
  [aux_sym_else_if_clause_token1] = "elseif",
  [aux_sym_else_clause_token1] = "else",
  [aux_sym_match_expression_token1] = "match",
  [aux_sym_match_default_expression_token1] = "default",
  [aux_sym_switch_statement_token1] = "switch",
  [aux_sym_switch_block_token1] = "endswitch",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_TILDE] = "~",
  [anon_sym_BANG] = "!",
  [anon_sym_AT] = "@",
  [aux_sym_clone_expression_token1] = "clone",
  [anon_sym_COLON_COLON] = "::",
  [aux_sym_print_intrinsic_token1] = "print",
  [aux_sym_object_creation_expression_token1] = "new",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_DOT_EQ] = ".=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_QMARK_DASH_GT] = "\?->",
  [aux_sym__list_destructing_token1] = "list",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_self] = "self",
  [anon_sym_parent] = "parent",
  [aux_sym__argument_name_token1] = "_argument_name_token1",
  [aux_sym__argument_name_token2] = "_argument_name_token2",
  [anon_sym_POUND_LBRACK] = "#[",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_BSLASHu] = "string_value",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_LT_QMARK] = "string_value",
  [anon_sym_QMARK_GT2] = "string_value",
  [aux_sym_encapsed_string_token1] = "encapsed_string_token1",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [aux_sym_string_token2] = "escape_sequence",
  [sym_string_value] = "string_value",
  [anon_sym_LT_LT_LT] = "<<<",
  [anon_sym_DQUOTE2] = "\"",
  [sym__new_line] = "_new_line",
  [anon_sym_] = "nowdoc_string",
  [anon_sym_SQUOTE2] = "'",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR] = "$",
  [aux_sym_yield_expression_token1] = "yield",
  [aux_sym_yield_expression_token2] = "from",
  [aux_sym_binary_expression_token1] = "instanceof",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_STAR_STAR] = "**",
  [aux_sym_binary_expression_token2] = "and",
  [aux_sym_binary_expression_token3] = "or",
  [aux_sym_binary_expression_token4] = "xor",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_CARET] = "^",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_DOT] = ".",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [aux_sym_include_expression_token1] = "include",
  [aux_sym_include_once_expression_token1] = "include_once",
  [aux_sym_require_expression_token1] = "require",
  [aux_sym_require_once_expression_token1] = "require_once",
  [sym_comment] = "comment",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym_encapsed_string_chars] = "string_value",
  [sym_encapsed_string_chars_after_variable] = "string_value",
  [sym_execution_string_chars] = "string_value",
  [sym_execution_string_chars_after_variable] = "string_value",
  [sym_encapsed_string_chars_heredoc] = "string_value",
  [sym_encapsed_string_chars_after_variable_heredoc] = "string_value",
  [sym__eof] = "_eof",
  [sym_heredoc_start] = "heredoc_start",
  [sym_heredoc_end] = "heredoc_end",
  [sym_nowdoc_string] = "nowdoc_string",
  [sym_sentinel_error] = "sentinel_error",
  [sym_program] = "program",
  [sym_empty_statement] = "empty_statement",
  [sym_reference_modifier] = "reference_modifier",
  [sym_function_static_declaration] = "function_static_declaration",
  [sym_static_variable_declaration] = "static_variable_declaration",
  [sym_global_declaration] = "global_declaration",
  [sym_namespace_definition] = "namespace_definition",
  [sym_namespace_use_declaration] = "namespace_use_declaration",
  [sym_namespace_use_clause] = "namespace_use_clause",
  [sym_qualified_name] = "qualified_name",
  [sym_namespace_name_as_prefix] = "namespace_name_as_prefix",
  [sym_namespace_name] = "namespace_name",
  [sym_namespace_aliasing_clause] = "namespace_aliasing_clause",
  [sym_namespace_use_group] = "namespace_use_group",
  [sym_namespace_use_group_clause] = "namespace_use_group_clause",
  [sym_trait_declaration] = "trait_declaration",
  [sym_interface_declaration] = "interface_declaration",
  [sym_base_clause] = "base_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_declaration_list] = "enum_declaration_list",
  [sym__enum_member_declaration] = "_enum_member_declaration",
  [sym_enum_case] = "enum_case",
  [sym_class_declaration] = "class_declaration",
  [sym_declaration_list] = "declaration_list",
  [sym_final_modifier] = "final_modifier",
  [sym_abstract_modifier] = "abstract_modifier",
  [sym_readonly_modifier] = "readonly_modifier",
  [sym_class_interface_clause] = "class_interface_clause",
  [sym__member_declaration] = "_member_declaration",
  [sym_const_declaration] = "const_declaration",
  [sym__class_const_declaration] = "const_declaration",
  [sym__const_declaration] = "_const_declaration",
  [sym_property_declaration] = "property_declaration",
  [sym__modifier] = "_modifier",
  [sym_property_element] = "property_element",
  [sym_property_initializer] = "property_initializer",
  [sym_method_declaration] = "method_declaration",
  [sym_static_modifier] = "static_modifier",
  [sym_use_declaration] = "use_declaration",
  [sym_use_list] = "use_list",
  [sym_use_instead_of_clause] = "use_instead_of_clause",
  [sym_use_as_clause] = "use_as_clause",
  [sym_visibility_modifier] = "visibility_modifier",
  [sym_function_definition] = "function_definition",
  [sym__function_definition_header] = "_function_definition_header",
  [sym__arrow_function_header] = "_arrow_function_header",
  [sym_arrow_function] = "arrow_function",
  [sym_formal_parameters] = "formal_parameters",
  [sym_property_promotion_parameter] = "property_promotion_parameter",
  [sym_simple_parameter] = "simple_parameter",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym__type] = "_type",
  [sym__types] = "_types",
  [sym_named_type] = "named_type",
  [sym_optional_type] = "optional_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_disjunctive_normal_form_type] = "disjunctive_normal_form_type",
  [sym_primitive_type] = "primitive_type",
  [sym_cast_type] = "cast_type",
  [sym__return_type] = "_return_type",
  [sym_const_element] = "const_element",
  [sym_echo_statement] = "echo_statement",
  [sym_unset_statement] = "unset_statement",
  [sym_declare_statement] = "declare_statement",
  [sym_declare_directive] = "declare_directive",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_type_list] = "type_list",
  [sym_finally_clause] = "finally_clause",
  [sym_goto_statement] = "goto_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_break_statement] = "break_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_expression] = "throw_expression",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__expressions] = "_expressions",
  [sym_sequence_expression] = "sequence_expression",
  [sym_foreach_statement] = "foreach_statement",
  [sym_foreach_pair] = "pair",
  [sym_if_statement] = "if_statement",
  [sym_colon_block] = "colon_block",
  [sym_else_if_clause] = "else_if_clause",
  [sym_else_clause] = "else_clause",
  [sym_else_if_clause_2] = "else_if_clause",
  [sym_else_clause_2] = "else_clause",
  [sym_match_expression] = "match_expression",
  [sym_match_block] = "match_block",
  [sym_match_condition_list] = "match_condition_list",
  [sym_match_conditional_expression] = "match_conditional_expression",
  [sym_match_default_expression] = "match_default_expression",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_block] = "switch_block",
  [sym_case_statement] = "case_statement",
  [sym_default_statement] = "default_statement",
  [sym_compound_statement] = "compound_statement",
  [sym_named_label_statement] = "named_label_statement",
  [sym_expression_statement] = "expression_statement",
  [sym__expression] = "_expression",
  [sym__unary_expression] = "_unary_expression",
  [sym_unary_op_expression] = "unary_op_expression",
  [sym_error_suppression_expression] = "error_suppression_expression",
  [sym_clone_expression] = "clone_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_class_constant_access_expression] = "class_constant_access_expression",
  [sym_print_intrinsic] = "print_intrinsic",
  [sym_anonymous_function_creation_expression] = "anonymous_function_creation_expression",
  [sym_anonymous_function_use_clause] = "anonymous_function_use_clause",
  [sym_object_creation_expression] = "object_creation_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_cast_variable] = "cast_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_reference_assignment_expression] = "reference_assignment_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym_member_access_expression] = "member_access_expression",
  [sym_nullsafe_member_access_expression] = "nullsafe_member_access_expression",
  [sym_scoped_property_access_expression] = "scoped_property_access_expression",
  [sym_list_literal] = "list_literal",
  [sym__list_destructing] = "_list_destructing",
  [sym__array_destructing] = "_array_destructing",
  [sym__array_destructing_element] = "_array_destructing_element",
  [sym_function_call_expression] = "function_call_expression",
  [sym_scoped_call_expression] = "scoped_call_expression",
  [sym__scope_resolution_qualifier] = "_scope_resolution_qualifier",
  [sym_relative_scope] = "relative_scope",
  [sym_variadic_placeholder] = "variadic_placeholder",
  [sym_arguments] = "arguments",
  [sym_argument] = "argument",
  [sym__argument_name] = "_argument_name",
  [sym_member_call_expression] = "member_call_expression",
  [sym_nullsafe_member_call_expression] = "nullsafe_member_call_expression",
  [sym_variadic_unpacking] = "variadic_unpacking",
  [sym_subscript_expression] = "subscript_expression",
  [sym__dereferencable_expression] = "_dereferencable_expression",
  [sym_array_creation_expression] = "array_creation_expression",
  [sym_attribute_group] = "attribute_group",
  [sym_attribute_list] = "attribute_list",
  [sym_attribute] = "attribute",
  [sym__complex_string_part] = "_complex_string_part",
  [sym__simple_string_member_access_expression] = "member_access_expression",
  [sym__simple_string_subscript_unary_expression] = "unary_op_expression",
  [sym__simple_string_array_access_argument] = "_simple_string_array_access_argument",
  [sym__simple_string_subscript_expression] = "subscript_expression",
  [sym__simple_string_part] = "_simple_string_part",
  [aux_sym__interpolated_string_body] = "_interpolated_string_body",
  [aux_sym__interpolated_string_body_heredoc] = "_interpolated_string_body_heredoc",
  [sym_encapsed_string] = "encapsed_string",
  [sym_string] = "string",
  [sym_heredoc_body] = "heredoc_body",
  [sym_heredoc] = "heredoc",
  [sym_nowdoc_body] = "nowdoc_body",
  [sym_nowdoc] = "nowdoc",
  [aux_sym__interpolated_execution_operator_body] = "_interpolated_execution_operator_body",
  [sym_shell_command_expression] = "shell_command_expression",
  [sym_boolean] = "boolean",
  [sym_null] = "null",
  [sym__string] = "_string",
  [sym_dynamic_variable_name] = "dynamic_variable_name",
  [sym_variable_name] = "variable_name",
  [sym_variable_reference] = "by_ref",
  [sym_by_ref] = "by_ref",
  [sym_yield_expression] = "yield_expression",
  [sym_array_element_initializer] = "array_element_initializer",
  [sym_binary_expression] = "binary_expression",
  [sym_include_expression] = "include_expression",
  [sym_include_once_expression] = "include_once_expression",
  [sym_require_expression] = "require_expression",
  [sym_require_once_expression] = "require_once_expression",
  [sym__reserved_identifier] = "name",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_function_static_declaration_repeat1] = "function_static_declaration_repeat1",
  [aux_sym_global_declaration_repeat1] = "global_declaration_repeat1",
  [aux_sym_namespace_use_declaration_repeat1] = "namespace_use_declaration_repeat1",
  [aux_sym_namespace_name_repeat1] = "namespace_name_repeat1",
  [aux_sym_namespace_use_group_repeat1] = "namespace_use_group_repeat1",
  [aux_sym_base_clause_repeat1] = "base_clause_repeat1",
  [aux_sym_enum_declaration_list_repeat1] = "enum_declaration_list_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym__const_declaration_repeat1] = "_const_declaration_repeat1",
  [aux_sym_property_declaration_repeat1] = "property_declaration_repeat1",
  [aux_sym_property_declaration_repeat2] = "property_declaration_repeat2",
  [aux_sym_use_list_repeat1] = "use_list_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_union_type_repeat1] = "union_type_repeat1",
  [aux_sym_intersection_type_repeat1] = "intersection_type_repeat1",
  [aux_sym_disjunctive_normal_form_type_repeat1] = "disjunctive_normal_form_type_repeat1",
  [aux_sym_unset_statement_repeat1] = "unset_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_type_list_repeat1] = "type_list_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_if_statement_repeat2] = "if_statement_repeat2",
  [aux_sym_match_block_repeat1] = "match_block_repeat1",
  [aux_sym_match_condition_list_repeat1] = "match_condition_list_repeat1",
  [aux_sym_switch_block_repeat1] = "switch_block_repeat1",
  [aux_sym_anonymous_function_use_clause_repeat1] = "anonymous_function_use_clause_repeat1",
  [aux_sym__list_destructing_repeat1] = "_list_destructing_repeat1",
  [aux_sym__array_destructing_repeat1] = "_array_destructing_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym_array_creation_expression_repeat1] = "array_creation_expression_repeat1",
  [aux_sym_attribute_group_repeat1] = "attribute_group_repeat1",
  [aux_sym_attribute_list_repeat1] = "attribute_list_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym_nowdoc_body_repeat1] = "nowdoc_body_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_name] = sym_name,
  [anon_sym_QMARK_GT] = anon_sym_QMARK_GT,
  [sym_php_tag] = sym_php_tag,
  [aux_sym_text_token1] = aux_sym_text_token1,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_AMP] = anon_sym_AMP,
  [aux_sym_function_static_declaration_token1] = anon_sym_static,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_EQ] = anon_sym_EQ,
  [aux_sym_global_declaration_token1] = aux_sym_global_declaration_token1,
  [aux_sym_namespace_definition_token1] = aux_sym_namespace_definition_token1,
  [aux_sym_namespace_use_declaration_token1] = aux_sym_namespace_use_declaration_token1,
  [aux_sym_namespace_use_declaration_token2] = aux_sym_namespace_use_declaration_token2,
  [aux_sym_namespace_use_declaration_token3] = aux_sym_namespace_use_declaration_token3,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [aux_sym_namespace_aliasing_clause_token1] = aux_sym_namespace_aliasing_clause_token1,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [aux_sym_trait_declaration_token1] = aux_sym_trait_declaration_token1,
  [aux_sym_interface_declaration_token1] = aux_sym_interface_declaration_token1,
  [aux_sym_base_clause_token1] = aux_sym_base_clause_token1,
  [aux_sym_enum_declaration_token1] = aux_sym_enum_declaration_token1,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_int] = anon_sym_int,
  [aux_sym_enum_case_token1] = aux_sym_enum_case_token1,
  [aux_sym_class_declaration_token1] = aux_sym_class_declaration_token1,
  [aux_sym_final_modifier_token1] = aux_sym_final_modifier_token1,
  [aux_sym_abstract_modifier_token1] = aux_sym_abstract_modifier_token1,
  [aux_sym_readonly_modifier_token1] = aux_sym_readonly_modifier_token1,
  [aux_sym_class_interface_clause_token1] = aux_sym_class_interface_clause_token1,
  [sym_var_modifier] = sym_var_modifier,
  [aux_sym_use_instead_of_clause_token1] = aux_sym_use_instead_of_clause_token1,
  [aux_sym_visibility_modifier_token1] = aux_sym_visibility_modifier_token1,
  [aux_sym_visibility_modifier_token2] = aux_sym_visibility_modifier_token2,
  [aux_sym_visibility_modifier_token3] = aux_sym_visibility_modifier_token3,
  [aux_sym__arrow_function_header_token1] = aux_sym__arrow_function_header_token1,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [sym_bottom_type] = sym_bottom_type,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_array] = anon_sym_array,
  [aux_sym_primitive_type_token1] = aux_sym_primitive_type_token1,
  [anon_sym_iterable] = anon_sym_iterable,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_mixed] = anon_sym_mixed,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_null] = anon_sym_null,
  [anon_sym_true] = anon_sym_true,
  [aux_sym_cast_type_token1] = aux_sym_cast_type_token1,
  [aux_sym_cast_type_token2] = aux_sym_cast_type_token2,
  [aux_sym_cast_type_token3] = aux_sym_cast_type_token3,
  [aux_sym_cast_type_token4] = aux_sym_cast_type_token4,
  [aux_sym_cast_type_token5] = aux_sym_cast_type_token5,
  [aux_sym_cast_type_token6] = aux_sym_cast_type_token6,
  [aux_sym_cast_type_token7] = aux_sym_cast_type_token7,
  [aux_sym_cast_type_token8] = aux_sym_cast_type_token8,
  [aux_sym_cast_type_token9] = aux_sym_cast_type_token9,
  [aux_sym_cast_type_token10] = aux_sym_cast_type_token10,
  [aux_sym_cast_type_token11] = aux_sym_cast_type_token11,
  [aux_sym_cast_type_token12] = aux_sym_cast_type_token12,
  [aux_sym_echo_statement_token1] = aux_sym_echo_statement_token1,
  [anon_sym_unset] = anon_sym_unset,
  [aux_sym_declare_statement_token1] = aux_sym_declare_statement_token1,
  [aux_sym_declare_statement_token2] = aux_sym_declare_statement_token2,
  [anon_sym_ticks] = anon_sym_ticks,
  [anon_sym_encoding] = anon_sym_encoding,
  [anon_sym_strict_types] = anon_sym_strict_types,
  [sym_float] = sym_float,
  [aux_sym_try_statement_token1] = aux_sym_try_statement_token1,
  [aux_sym_catch_clause_token1] = aux_sym_catch_clause_token1,
  [aux_sym_finally_clause_token1] = aux_sym_finally_clause_token1,
  [aux_sym_goto_statement_token1] = aux_sym_goto_statement_token1,
  [aux_sym_continue_statement_token1] = aux_sym_continue_statement_token1,
  [aux_sym_break_statement_token1] = aux_sym_break_statement_token1,
  [sym_integer] = sym_integer,
  [aux_sym_return_statement_token1] = aux_sym_return_statement_token1,
  [aux_sym_throw_expression_token1] = aux_sym_throw_expression_token1,
  [aux_sym_while_statement_token1] = aux_sym_while_statement_token1,
  [aux_sym_while_statement_token2] = aux_sym_while_statement_token2,
  [aux_sym_do_statement_token1] = aux_sym_do_statement_token1,
  [aux_sym_for_statement_token1] = aux_sym_for_statement_token1,
  [aux_sym_for_statement_token2] = aux_sym_for_statement_token2,
  [aux_sym_foreach_statement_token1] = aux_sym_foreach_statement_token1,
  [aux_sym_foreach_statement_token2] = aux_sym_foreach_statement_token2,
  [aux_sym_if_statement_token1] = aux_sym_if_statement_token1,
  [aux_sym_if_statement_token2] = aux_sym_if_statement_token2,
  [aux_sym_else_if_clause_token1] = aux_sym_else_if_clause_token1,
  [aux_sym_else_clause_token1] = aux_sym_else_clause_token1,
  [aux_sym_match_expression_token1] = aux_sym_match_expression_token1,
  [aux_sym_match_default_expression_token1] = aux_sym_match_default_expression_token1,
  [aux_sym_switch_statement_token1] = aux_sym_switch_statement_token1,
  [aux_sym_switch_block_token1] = aux_sym_switch_block_token1,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_AT] = anon_sym_AT,
  [aux_sym_clone_expression_token1] = aux_sym_clone_expression_token1,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [aux_sym_print_intrinsic_token1] = aux_sym_print_intrinsic_token1,
  [aux_sym_object_creation_expression_token1] = aux_sym_object_creation_expression_token1,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_DOT_EQ] = anon_sym_DOT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_QMARK_DASH_GT] = anon_sym_QMARK_DASH_GT,
  [aux_sym__list_destructing_token1] = aux_sym__list_destructing_token1,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_self] = anon_sym_self,
  [anon_sym_parent] = anon_sym_parent,
  [aux_sym__argument_name_token1] = aux_sym__argument_name_token1,
  [aux_sym__argument_name_token2] = aux_sym__argument_name_token2,
  [anon_sym_POUND_LBRACK] = anon_sym_POUND_LBRACK,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_BSLASHu] = sym_string_value,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_LT_QMARK] = sym_string_value,
  [anon_sym_QMARK_GT2] = sym_string_value,
  [aux_sym_encapsed_string_token1] = aux_sym_encapsed_string_token1,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [aux_sym_string_token2] = sym_escape_sequence,
  [sym_string_value] = sym_string_value,
  [anon_sym_LT_LT_LT] = anon_sym_LT_LT_LT,
  [anon_sym_DQUOTE2] = anon_sym_DQUOTE,
  [sym__new_line] = sym__new_line,
  [anon_sym_] = sym_nowdoc_string,
  [anon_sym_SQUOTE2] = anon_sym_SQUOTE,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [aux_sym_yield_expression_token1] = aux_sym_yield_expression_token1,
  [aux_sym_yield_expression_token2] = aux_sym_yield_expression_token2,
  [aux_sym_binary_expression_token1] = aux_sym_binary_expression_token1,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [aux_sym_binary_expression_token2] = aux_sym_binary_expression_token2,
  [aux_sym_binary_expression_token3] = aux_sym_binary_expression_token3,
  [aux_sym_binary_expression_token4] = aux_sym_binary_expression_token4,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [aux_sym_include_expression_token1] = aux_sym_include_expression_token1,
  [aux_sym_include_once_expression_token1] = aux_sym_include_once_expression_token1,
  [aux_sym_require_expression_token1] = aux_sym_require_expression_token1,
  [aux_sym_require_once_expression_token1] = aux_sym_require_once_expression_token1,
  [sym_comment] = sym_comment,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym_encapsed_string_chars] = sym_string_value,
  [sym_encapsed_string_chars_after_variable] = sym_string_value,
  [sym_execution_string_chars] = sym_string_value,
  [sym_execution_string_chars_after_variable] = sym_string_value,
  [sym_encapsed_string_chars_heredoc] = sym_string_value,
  [sym_encapsed_string_chars_after_variable_heredoc] = sym_string_value,
  [sym__eof] = sym__eof,
  [sym_heredoc_start] = sym_heredoc_start,
  [sym_heredoc_end] = sym_heredoc_end,
  [sym_nowdoc_string] = sym_nowdoc_string,
  [sym_sentinel_error] = sym_sentinel_error,
  [sym_program] = sym_program,
  [sym_empty_statement] = sym_empty_statement,
  [sym_reference_modifier] = sym_reference_modifier,
  [sym_function_static_declaration] = sym_function_static_declaration,
  [sym_static_variable_declaration] = sym_static_variable_declaration,
  [sym_global_declaration] = sym_global_declaration,
  [sym_namespace_definition] = sym_namespace_definition,
  [sym_namespace_use_declaration] = sym_namespace_use_declaration,
  [sym_namespace_use_clause] = sym_namespace_use_clause,
  [sym_qualified_name] = sym_qualified_name,
  [sym_namespace_name_as_prefix] = sym_namespace_name_as_prefix,
  [sym_namespace_name] = sym_namespace_name,
  [sym_namespace_aliasing_clause] = sym_namespace_aliasing_clause,
  [sym_namespace_use_group] = sym_namespace_use_group,
  [sym_namespace_use_group_clause] = sym_namespace_use_group_clause,
  [sym_trait_declaration] = sym_trait_declaration,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_base_clause] = sym_base_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_declaration_list] = sym_enum_declaration_list,
  [sym__enum_member_declaration] = sym__enum_member_declaration,
  [sym_enum_case] = sym_enum_case,
  [sym_class_declaration] = sym_class_declaration,
  [sym_declaration_list] = sym_declaration_list,
  [sym_final_modifier] = sym_final_modifier,
  [sym_abstract_modifier] = sym_abstract_modifier,
  [sym_readonly_modifier] = sym_readonly_modifier,
  [sym_class_interface_clause] = sym_class_interface_clause,
  [sym__member_declaration] = sym__member_declaration,
  [sym_const_declaration] = sym_const_declaration,
  [sym__class_const_declaration] = sym_const_declaration,
  [sym__const_declaration] = sym__const_declaration,
  [sym_property_declaration] = sym_property_declaration,
  [sym__modifier] = sym__modifier,
  [sym_property_element] = sym_property_element,
  [sym_property_initializer] = sym_property_initializer,
  [sym_method_declaration] = sym_method_declaration,
  [sym_static_modifier] = sym_static_modifier,
  [sym_use_declaration] = sym_use_declaration,
  [sym_use_list] = sym_use_list,
  [sym_use_instead_of_clause] = sym_use_instead_of_clause,
  [sym_use_as_clause] = sym_use_as_clause,
  [sym_visibility_modifier] = sym_visibility_modifier,
  [sym_function_definition] = sym_function_definition,
  [sym__function_definition_header] = sym__function_definition_header,
  [sym__arrow_function_header] = sym__arrow_function_header,
  [sym_arrow_function] = sym_arrow_function,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_property_promotion_parameter] = sym_property_promotion_parameter,
  [sym_simple_parameter] = sym_simple_parameter,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym__type] = sym__type,
  [sym__types] = sym__types,
  [sym_named_type] = sym_named_type,
  [sym_optional_type] = sym_optional_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_disjunctive_normal_form_type] = sym_disjunctive_normal_form_type,
  [sym_primitive_type] = sym_primitive_type,
  [sym_cast_type] = sym_cast_type,
  [sym__return_type] = sym__return_type,
  [sym_const_element] = sym_const_element,
  [sym_echo_statement] = sym_echo_statement,
  [sym_unset_statement] = sym_unset_statement,
  [sym_declare_statement] = sym_declare_statement,
  [sym_declare_directive] = sym_declare_directive,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_type_list] = sym_type_list,
  [sym_finally_clause] = sym_finally_clause,
  [sym_goto_statement] = sym_goto_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_expression] = sym_throw_expression,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__expressions] = sym__expressions,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_foreach_statement] = sym_foreach_statement,
  [sym_foreach_pair] = sym_foreach_pair,
  [sym_if_statement] = sym_if_statement,
  [sym_colon_block] = sym_colon_block,
  [sym_else_if_clause] = sym_else_if_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_else_if_clause_2] = sym_else_if_clause,
  [sym_else_clause_2] = sym_else_clause,
  [sym_match_expression] = sym_match_expression,
  [sym_match_block] = sym_match_block,
  [sym_match_condition_list] = sym_match_condition_list,
  [sym_match_conditional_expression] = sym_match_conditional_expression,
  [sym_match_default_expression] = sym_match_default_expression,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_block] = sym_switch_block,
  [sym_case_statement] = sym_case_statement,
  [sym_default_statement] = sym_default_statement,
  [sym_compound_statement] = sym_compound_statement,
  [sym_named_label_statement] = sym_named_label_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym__expression] = sym__expression,
  [sym__unary_expression] = sym__unary_expression,
  [sym_unary_op_expression] = sym_unary_op_expression,
  [sym_error_suppression_expression] = sym_error_suppression_expression,
  [sym_clone_expression] = sym_clone_expression,
  [sym__primary_expression] = sym__primary_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_class_constant_access_expression] = sym_class_constant_access_expression,
  [sym_print_intrinsic] = sym_print_intrinsic,
  [sym_anonymous_function_creation_expression] = sym_anonymous_function_creation_expression,
  [sym_anonymous_function_use_clause] = sym_anonymous_function_use_clause,
  [sym_object_creation_expression] = sym_object_creation_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_cast_variable] = sym_cast_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_reference_assignment_expression] = sym_reference_assignment_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym_member_access_expression] = sym_member_access_expression,
  [sym_nullsafe_member_access_expression] = sym_nullsafe_member_access_expression,
  [sym_scoped_property_access_expression] = sym_scoped_property_access_expression,
  [sym_list_literal] = sym_list_literal,
  [sym__list_destructing] = sym__list_destructing,
  [sym__array_destructing] = sym__array_destructing,
  [sym__array_destructing_element] = sym__array_destructing_element,
  [sym_function_call_expression] = sym_function_call_expression,
  [sym_scoped_call_expression] = sym_scoped_call_expression,
  [sym__scope_resolution_qualifier] = sym__scope_resolution_qualifier,
  [sym_relative_scope] = sym_relative_scope,
  [sym_variadic_placeholder] = sym_variadic_placeholder,
  [sym_arguments] = sym_arguments,
  [sym_argument] = sym_argument,
  [sym__argument_name] = sym__argument_name,
  [sym_member_call_expression] = sym_member_call_expression,
  [sym_nullsafe_member_call_expression] = sym_nullsafe_member_call_expression,
  [sym_variadic_unpacking] = sym_variadic_unpacking,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym__dereferencable_expression] = sym__dereferencable_expression,
  [sym_array_creation_expression] = sym_array_creation_expression,
  [sym_attribute_group] = sym_attribute_group,
  [sym_attribute_list] = sym_attribute_list,
  [sym_attribute] = sym_attribute,
  [sym__complex_string_part] = sym__complex_string_part,
  [sym__simple_string_member_access_expression] = sym_member_access_expression,
  [sym__simple_string_subscript_unary_expression] = sym_unary_op_expression,
  [sym__simple_string_array_access_argument] = sym__simple_string_array_access_argument,
  [sym__simple_string_subscript_expression] = sym_subscript_expression,
  [sym__simple_string_part] = sym__simple_string_part,
  [aux_sym__interpolated_string_body] = aux_sym__interpolated_string_body,
  [aux_sym__interpolated_string_body_heredoc] = aux_sym__interpolated_string_body_heredoc,
  [sym_encapsed_string] = sym_encapsed_string,
  [sym_string] = sym_string,
  [sym_heredoc_body] = sym_heredoc_body,
  [sym_heredoc] = sym_heredoc,
  [sym_nowdoc_body] = sym_nowdoc_body,
  [sym_nowdoc] = sym_nowdoc,
  [aux_sym__interpolated_execution_operator_body] = aux_sym__interpolated_execution_operator_body,
  [sym_shell_command_expression] = sym_shell_command_expression,
  [sym_boolean] = sym_boolean,
  [sym_null] = sym_null,
  [sym__string] = sym__string,
  [sym_dynamic_variable_name] = sym_dynamic_variable_name,
  [sym_variable_name] = sym_variable_name,
  [sym_variable_reference] = sym_by_ref,
  [sym_by_ref] = sym_by_ref,
  [sym_yield_expression] = sym_yield_expression,
  [sym_array_element_initializer] = sym_array_element_initializer,
  [sym_binary_expression] = sym_binary_expression,
  [sym_include_expression] = sym_include_expression,
  [sym_include_once_expression] = sym_include_once_expression,
  [sym_require_expression] = sym_require_expression,
  [sym_require_once_expression] = sym_require_once_expression,
  [sym__reserved_identifier] = sym_name,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_function_static_declaration_repeat1] = aux_sym_function_static_declaration_repeat1,
  [aux_sym_global_declaration_repeat1] = aux_sym_global_declaration_repeat1,
  [aux_sym_namespace_use_declaration_repeat1] = aux_sym_namespace_use_declaration_repeat1,
  [aux_sym_namespace_name_repeat1] = aux_sym_namespace_name_repeat1,
  [aux_sym_namespace_use_group_repeat1] = aux_sym_namespace_use_group_repeat1,
  [aux_sym_base_clause_repeat1] = aux_sym_base_clause_repeat1,
  [aux_sym_enum_declaration_list_repeat1] = aux_sym_enum_declaration_list_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym__const_declaration_repeat1] = aux_sym__const_declaration_repeat1,
  [aux_sym_property_declaration_repeat1] = aux_sym_property_declaration_repeat1,
  [aux_sym_property_declaration_repeat2] = aux_sym_property_declaration_repeat2,
  [aux_sym_use_list_repeat1] = aux_sym_use_list_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_union_type_repeat1] = aux_sym_union_type_repeat1,
  [aux_sym_intersection_type_repeat1] = aux_sym_intersection_type_repeat1,
  [aux_sym_disjunctive_normal_form_type_repeat1] = aux_sym_disjunctive_normal_form_type_repeat1,
  [aux_sym_unset_statement_repeat1] = aux_sym_unset_statement_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_type_list_repeat1] = aux_sym_type_list_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_if_statement_repeat2] = aux_sym_if_statement_repeat2,
  [aux_sym_match_block_repeat1] = aux_sym_match_block_repeat1,
  [aux_sym_match_condition_list_repeat1] = aux_sym_match_condition_list_repeat1,
  [aux_sym_switch_block_repeat1] = aux_sym_switch_block_repeat1,
  [aux_sym_anonymous_function_use_clause_repeat1] = aux_sym_anonymous_function_use_clause_repeat1,
  [aux_sym__list_destructing_repeat1] = aux_sym__list_destructing_repeat1,
  [aux_sym__array_destructing_repeat1] = aux_sym__array_destructing_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym_array_creation_expression_repeat1] = aux_sym_array_creation_expression_repeat1,
  [aux_sym_attribute_group_repeat1] = aux_sym_attribute_group_repeat1,
  [aux_sym_attribute_list_repeat1] = aux_sym_attribute_list_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_heredoc_body_repeat1] = aux_sym_heredoc_body_repeat1,
  [aux_sym_nowdoc_body_repeat1] = aux_sym_nowdoc_body_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_name] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_php_tag] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_text_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_function_static_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_global_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namespace_definition_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namespace_use_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namespace_use_declaration_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namespace_use_declaration_token3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namespace_aliasing_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_trait_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_interface_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_base_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_enum_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_enum_case_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_class_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_final_modifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_abstract_modifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_readonly_modifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_class_interface_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_var_modifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_use_instead_of_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_visibility_modifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_visibility_modifier_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_visibility_modifier_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__arrow_function_header_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [sym_bottom_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_array] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_primitive_type_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iterable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mixed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_cast_type_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token5] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token6] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token7] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token8] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token9] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token10] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token11] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token12] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_echo_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_declare_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_declare_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ticks] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_encoding] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_strict_types] = {
    .visible = true,
    .named = false,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_try_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_catch_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_finally_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_goto_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_continue_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_break_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_return_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_throw_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_while_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_while_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_do_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_for_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_for_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_foreach_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_foreach_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_if_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_if_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_else_if_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_else_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_match_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_match_default_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_switch_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_switch_block_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_clone_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_print_intrinsic_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_object_creation_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__list_destructing_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_self] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_parent] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__argument_name_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__argument_name_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_POUND_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHu] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_QMARK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_GT2] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_encapsed_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = true,
    .named = true,
  },
  [sym_string_value] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [sym__new_line] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_yield_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_yield_expression_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_include_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_include_once_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_require_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_require_once_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_encapsed_string_chars] = {
    .visible = true,
    .named = true,
  },
  [sym_encapsed_string_chars_after_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_execution_string_chars] = {
    .visible = true,
    .named = true,
  },
  [sym_execution_string_chars_after_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_encapsed_string_chars_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym_encapsed_string_chars_after_variable_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym__eof] = {
    .visible = false,
    .named = true,
  },
  [sym_heredoc_start] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_end] = {
    .visible = true,
    .named = true,
  },
  [sym_nowdoc_string] = {
    .visible = true,
    .named = true,
  },
  [sym_sentinel_error] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_function_static_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_global_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_name_as_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_aliasing_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_group] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_group_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_base_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_member_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_enum_case] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_final_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_readonly_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class_interface_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__member_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_const_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__class_const_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__const_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__modifier] = {
    .visible = false,
    .named = true,
  },
  [sym_property_element] = {
    .visible = true,
    .named = true,
  },
  [sym_property_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_instead_of_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_use_as_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__function_definition_header] = {
    .visible = false,
    .named = true,
  },
  [sym__arrow_function_header] = {
    .visible = false,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_property_promotion_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__types] = {
    .visible = false,
    .named = true,
  },
  [sym_named_type] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_disjunctive_normal_form_type] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_type] = {
    .visible = true,
    .named = true,
  },
  [sym__return_type] = {
    .visible = false,
    .named = true,
  },
  [sym_const_element] = {
    .visible = true,
    .named = true,
  },
  [sym_echo_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_declare_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_declare_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expressions] = {
    .visible = false,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_colon_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_clause_2] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause_2] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_block] = {
    .visible = true,
    .named = true,
  },
  [sym_match_condition_list] = {
    .visible = true,
    .named = true,
  },
  [sym_match_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_default_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_block] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_default_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_named_label_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__unary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_unary_op_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_error_suppression_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_clone_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_constant_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_print_intrinsic] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function_use_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_nullsafe_member_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_property_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_list_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__list_destructing] = {
    .visible = false,
    .named = true,
  },
  [sym__array_destructing] = {
    .visible = false,
    .named = true,
  },
  [sym__array_destructing_element] = {
    .visible = false,
    .named = true,
  },
  [sym_function_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__scope_resolution_qualifier] = {
    .visible = false,
    .named = true,
  },
  [sym_relative_scope] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_placeholder] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_name] = {
    .visible = false,
    .named = true,
  },
  [sym_member_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_nullsafe_member_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_unpacking] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__dereferencable_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_group] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_list] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__complex_string_part] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_string_member_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_string_subscript_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_string_array_access_argument] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_string_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_string_part] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__interpolated_string_body] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__interpolated_string_body_heredoc] = {
    .visible = false,
    .named = false,
  },
  [sym_encapsed_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym_nowdoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_nowdoc] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__interpolated_execution_operator_body] = {
    .visible = false,
    .named = false,
  },
  [sym_shell_command_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_dynamic_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_by_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_element_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_include_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_include_once_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_require_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_require_once_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__reserved_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_static_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_use_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_use_group_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__const_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_property_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_property_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_intersection_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_disjunctive_normal_form_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_condition_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_anonymous_function_use_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_destructing_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__array_destructing_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_creation_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_group_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_nowdoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_attributes = 4,
  field_body = 5,
  field_condition = 6,
  field_conditional_expressions = 7,
  field_default_value = 8,
  field_end_tag = 9,
  field_function = 10,
  field_identifier = 11,
  field_left = 12,
  field_modifier = 13,
  field_name = 14,
  field_object = 15,
  field_operator = 16,
  field_parameters = 17,
  field_readonly = 18,
  field_reference_modifier = 19,
  field_return_expression = 20,
  field_return_type = 21,
  field_right = 22,
  field_scope = 23,
  field_type = 24,
  field_value = 25,
  field_visibility = 26,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attributes] = "attributes",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_conditional_expressions] = "conditional_expressions",
  [field_default_value] = "default_value",
  [field_end_tag] = "end_tag",
  [field_function] = "function",
  [field_identifier] = "identifier",
  [field_left] = "left",
  [field_modifier] = "modifier",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_readonly] = "readonly",
  [field_reference_modifier] = "reference_modifier",
  [field_return_expression] = "return_expression",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_type] = "type",
  [field_value] = "value",
  [field_visibility] = "visibility",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 1},
  [5] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 2},
  [10] = {.index = 10, .length = 5},
  [11] = {.index = 15, .length = 2},
  [12] = {.index = 17, .length = 1},
  [13] = {.index = 18, .length = 2},
  [14] = {.index = 20, .length = 2},
  [15] = {.index = 22, .length = 2},
  [16] = {.index = 24, .length = 2},
  [17] = {.index = 26, .length = 2},
  [19] = {.index = 28, .length = 2},
  [20] = {.index = 30, .length = 2},
  [21] = {.index = 32, .length = 1},
  [22] = {.index = 33, .length = 5},
  [23] = {.index = 38, .length = 3},
  [24] = {.index = 41, .length = 2},
  [25] = {.index = 43, .length = 2},
  [26] = {.index = 45, .length = 2},
  [27] = {.index = 47, .length = 2},
  [28] = {.index = 49, .length = 6},
  [29] = {.index = 55, .length = 2},
  [30] = {.index = 57, .length = 2},
  [31] = {.index = 59, .length = 2},
  [32] = {.index = 61, .length = 2},
  [33] = {.index = 63, .length = 2},
  [34] = {.index = 65, .length = 2},
  [35] = {.index = 67, .length = 3},
  [36] = {.index = 70, .length = 3},
  [37] = {.index = 73, .length = 3},
  [38] = {.index = 76, .length = 1},
  [39] = {.index = 77, .length = 3},
  [40] = {.index = 80, .length = 2},
  [41] = {.index = 82, .length = 1},
  [42] = {.index = 83, .length = 3},
  [43] = {.index = 86, .length = 2},
  [44] = {.index = 88, .length = 3},
  [45] = {.index = 91, .length = 2},
  [46] = {.index = 93, .length = 1},
  [47] = {.index = 94, .length = 3},
  [48] = {.index = 97, .length = 3},
  [49] = {.index = 100, .length = 1},
  [52] = {.index = 101, .length = 3},
  [53] = {.index = 1, .length = 1},
  [54] = {.index = 104, .length = 1},
  [55] = {.index = 105, .length = 1},
  [56] = {.index = 106, .length = 3},
  [57] = {.index = 109, .length = 2},
  [58] = {.index = 111, .length = 2},
  [59] = {.index = 113, .length = 2},
  [60] = {.index = 115, .length = 2},
  [61] = {.index = 117, .length = 3},
  [62] = {.index = 120, .length = 3},
  [63] = {.index = 123, .length = 3},
  [64] = {.index = 126, .length = 3},
  [65] = {.index = 129, .length = 3},
  [66] = {.index = 132, .length = 3},
  [67] = {.index = 135, .length = 2},
  [68] = {.index = 137, .length = 3},
  [69] = {.index = 140, .length = 3},
  [70] = {.index = 143, .length = 2},
  [71] = {.index = 145, .length = 2},
  [72] = {.index = 147, .length = 3},
  [73] = {.index = 150, .length = 3},
  [74] = {.index = 153, .length = 2},
  [75] = {.index = 155, .length = 3},
  [76] = {.index = 158, .length = 2},
  [77] = {.index = 160, .length = 3},
  [78] = {.index = 163, .length = 3},
  [79] = {.index = 166, .length = 3},
  [80] = {.index = 169, .length = 2},
  [81] = {.index = 171, .length = 4},
  [82] = {.index = 175, .length = 4},
  [83] = {.index = 179, .length = 3},
  [84] = {.index = 182, .length = 3},
  [85] = {.index = 185, .length = 2},
  [86] = {.index = 187, .length = 4},
  [87] = {.index = 191, .length = 2},
  [88] = {.index = 193, .length = 2},
  [89] = {.index = 193, .length = 2},
  [90] = {.index = 195, .length = 2},
  [91] = {.index = 197, .length = 4},
  [92] = {.index = 201, .length = 2},
  [93] = {.index = 203, .length = 3},
  [94] = {.index = 206, .length = 2},
  [95] = {.index = 208, .length = 4},
  [96] = {.index = 212, .length = 2},
  [97] = {.index = 214, .length = 3},
  [98] = {.index = 217, .length = 4},
  [99] = {.index = 221, .length = 3},
  [100] = {.index = 224, .length = 1},
  [101] = {.index = 225, .length = 3},
  [103] = {.index = 228, .length = 2},
  [104] = {.index = 230, .length = 3},
  [105] = {.index = 233, .length = 4},
  [106] = {.index = 237, .length = 4},
  [107] = {.index = 241, .length = 3},
  [108] = {.index = 244, .length = 3},
  [109] = {.index = 247, .length = 4},
  [110] = {.index = 251, .length = 4},
  [111] = {.index = 255, .length = 3},
  [112] = {.index = 258, .length = 3},
  [113] = {.index = 261, .length = 4},
  [114] = {.index = 265, .length = 3},
  [115] = {.index = 268, .length = 3},
  [116] = {.index = 271, .length = 3},
  [117] = {.index = 274, .length = 4},
  [118] = {.index = 278, .length = 3},
  [119] = {.index = 281, .length = 3},
  [120] = {.index = 284, .length = 3},
  [121] = {.index = 287, .length = 3},
  [122] = {.index = 290, .length = 4},
  [123] = {.index = 294, .length = 4},
  [124] = {.index = 298, .length = 3},
  [125] = {.index = 301, .length = 4},
  [126] = {.index = 305, .length = 3},
  [127] = {.index = 308, .length = 4},
  [128] = {.index = 312, .length = 3},
  [129] = {.index = 315, .length = 5},
  [130] = {.index = 320, .length = 4},
  [131] = {.index = 324, .length = 5},
  [132] = {.index = 329, .length = 2},
  [133] = {.index = 331, .length = 1},
  [134] = {.index = 332, .length = 2},
  [135] = {.index = 334, .length = 1},
  [138] = {.index = 335, .length = 3},
  [139] = {.index = 338, .length = 5},
  [140] = {.index = 343, .length = 3},
  [141] = {.index = 346, .length = 4},
  [142] = {.index = 350, .length = 3},
  [143] = {.index = 353, .length = 3},
  [144] = {.index = 356, .length = 4},
  [145] = {.index = 360, .length = 4},
  [146] = {.index = 364, .length = 3},
  [147] = {.index = 367, .length = 5},
  [148] = {.index = 372, .length = 4},
  [149] = {.index = 376, .length = 4},
  [150] = {.index = 380, .length = 3},
  [151] = {.index = 380, .length = 3},
  [152] = {.index = 383, .length = 4},
  [153] = {.index = 387, .length = 5},
  [154] = {.index = 392, .length = 4},
  [155] = {.index = 396, .length = 4},
  [156] = {.index = 400, .length = 4},
  [157] = {.index = 404, .length = 4},
  [158] = {.index = 408, .length = 4},
  [159] = {.index = 412, .length = 4},
  [160] = {.index = 416, .length = 5},
  [161] = {.index = 421, .length = 4},
  [162] = {.index = 425, .length = 4},
  [163] = {.index = 429, .length = 4},
  [164] = {.index = 433, .length = 1},
  [165] = {.index = 434, .length = 5},
  [166] = {.index = 439, .length = 6},
  [167] = {.index = 445, .length = 2},
  [168] = {.index = 447, .length = 1},
  [169] = {.index = 448, .length = 3},
  [170] = {.index = 451, .length = 5},
  [171] = {.index = 456, .length = 4},
  [172] = {.index = 460, .length = 5},
  [173] = {.index = 465, .length = 4},
  [174] = {.index = 469, .length = 4},
  [175] = {.index = 473, .length = 5},
  [176] = {.index = 478, .length = 3},
  [177] = {.index = 481, .length = 4},
  [178] = {.index = 485, .length = 5},
  [179] = {.index = 490, .length = 5},
  [180] = {.index = 495, .length = 5},
  [181] = {.index = 500, .length = 5},
  [182] = {.index = 505, .length = 5},
  [183] = {.index = 510, .length = 2},
  [184] = {.index = 512, .length = 2},
  [185] = {.index = 514, .length = 3},
  [186] = {.index = 517, .length = 5},
  [187] = {.index = 522, .length = 5},
  [188] = {.index = 527, .length = 6},
  [189] = {.index = 533, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_type, 0, .inherited = true},
  [1] =
    {field_name, 0},
  [2] =
    {field_body, 1},
  [3] =
    {field_parameters, 1},
  [4] =
    {field_argument, 1},
    {field_operator, 0},
  [6] =
    {field_name, 0, .inherited = true},
    {field_object, 0, .inherited = true},
  [8] =
    {field_arguments, 1},
    {field_function, 0},
  [10] =
    {field_body, 1},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_reference_modifier, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
  [15] =
    {field_argument, 0},
    {field_operator, 1},
  [17] =
    {field_name, 1},
  [18] =
    {field_body, 2},
    {field_name, 1},
  [20] =
    {field_name, 1},
    {field_parameters, 2},
  [22] =
    {field_body, 2},
    {field_parameters, 1},
  [24] =
    {field_parameters, 2},
    {field_reference_modifier, 1},
  [26] =
    {field_parameters, 1},
    {field_return_type, 2, .inherited = true},
  [28] =
    {field_body, 2},
    {field_condition, 1},
  [30] =
    {field_end_tag, 2},
    {field_identifier, 1},
  [32] =
    {field_parameters, 2},
  [33] =
    {field_attributes, 0, .inherited = true},
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_reference_modifier, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
  [38] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [41] =
    {field_left, 0},
    {field_right, 2},
  [43] =
    {field_name, 2},
    {field_scope, 0},
  [45] =
    {field_name, 2},
    {field_object, 0},
  [47] =
    {field_attributes, 0},
    {field_parameters, 2},
  [49] =
    {field_attributes, 0},
    {field_body, 2},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_reference_modifier, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [55] =
    {field_body, 3},
    {field_parameters, 2},
  [57] =
    {field_name, 0},
    {field_value, 2},
  [59] =
    {field_name, 1},
    {field_reference_modifier, 0},
  [61] =
    {field_name, 1},
    {field_visibility, 0},
  [63] =
    {field_name, 1},
    {field_type, 0},
  [65] =
    {field_attributes, 0},
    {field_name, 1},
  [67] =
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [70] =
    {field_name, 2},
    {field_parameters, 3},
    {field_reference_modifier, 1},
  [73] =
    {field_body, 3},
    {field_parameters, 2},
    {field_reference_modifier, 1},
  [76] =
    {field_return_type, 1},
  [77] =
    {field_body, 3},
    {field_parameters, 1},
    {field_return_type, 2, .inherited = true},
  [80] =
    {field_body, 3},
    {field_parameters, 1},
  [82] =
    {field_type, 1},
  [83] =
    {field_attributes, 0, .inherited = true},
    {field_modifier, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [86] =
    {field_body, 3},
    {field_name, 1},
  [88] =
    {field_parameters, 2},
    {field_reference_modifier, 1},
    {field_return_type, 3, .inherited = true},
  [91] =
    {field_type, 1},
    {field_value, 3},
  [93] =
    {field_alternative, 0},
  [94] =
    {field_alternative, 3},
    {field_body, 2},
    {field_condition, 1},
  [97] =
    {field_alternative, 3, .inherited = true},
    {field_body, 2},
    {field_condition, 1},
  [100] =
    {field_attributes, 1},
  [101] =
    {field_end_tag, 3},
    {field_identifier, 1},
    {field_value, 2},
  [104] =
    {field_reference_modifier, 0},
  [105] =
    {field_name, 0, .inherited = true},
  [106] =
    {field_body, 3},
    {field_modifier, 0},
    {field_name, 2},
  [109] =
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [111] =
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [113] =
    {field_alternative, 3},
    {field_condition, 0},
  [115] =
    {field_left, 0},
    {field_right, 3},
  [117] =
    {field_arguments, 3},
    {field_name, 2},
    {field_scope, 0},
  [120] =
    {field_arguments, 3},
    {field_name, 2},
    {field_object, 0},
  [123] =
    {field_attributes, 0},
    {field_body, 3},
    {field_parameters, 2},
  [126] =
    {field_attributes, 0},
    {field_body, 3},
    {field_name, 2},
  [129] =
    {field_attributes, 0},
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [132] =
    {field_attributes, 0},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [135] =
    {field_attributes, 0},
    {field_parameters, 3},
  [137] =
    {field_body, 4},
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [140] =
    {field_body, 4},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [143] =
    {field_body, 4},
    {field_parameters, 2},
  [145] =
    {field_name, 2},
    {field_reference_modifier, 0},
  [147] =
    {field_name, 2},
    {field_readonly, 1},
    {field_visibility, 0},
  [150] =
    {field_name, 2},
    {field_type, 1},
    {field_visibility, 0},
  [153] =
    {field_name, 2},
    {field_type, 0},
  [155] =
    {field_name, 2},
    {field_reference_modifier, 1},
    {field_type, 0},
  [158] =
    {field_attributes, 0},
    {field_name, 2},
  [160] =
    {field_attributes, 0},
    {field_name, 2},
    {field_reference_modifier, 1},
  [163] =
    {field_attributes, 0},
    {field_name, 2},
    {field_visibility, 1},
  [166] =
    {field_attributes, 0},
    {field_name, 2},
    {field_type, 1},
  [169] =
    {field_default_value, 2},
    {field_name, 0},
  [171] =
    {field_name, 2},
    {field_parameters, 3},
    {field_reference_modifier, 1},
    {field_return_type, 4, .inherited = true},
  [175] =
    {field_body, 4},
    {field_parameters, 2},
    {field_reference_modifier, 1},
    {field_return_type, 3, .inherited = true},
  [179] =
    {field_body, 4},
    {field_parameters, 2},
    {field_reference_modifier, 1},
  [182] =
    {field_body, 4},
    {field_parameters, 1},
    {field_return_type, 3, .inherited = true},
  [185] =
    {field_modifier, 0},
    {field_type, 1, .inherited = true},
  [187] =
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_reference_modifier, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
  [191] =
    {field_attributes, 0},
    {field_type, 1, .inherited = true},
  [193] =
    {field_body, 4},
    {field_name, 1},
  [195] =
    {field_body, 1},
    {field_condition, 3},
  [197] =
    {field_alternative, 3, .inherited = true},
    {field_alternative, 4},
    {field_body, 2},
    {field_condition, 1},
  [201] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [203] =
    {field_end_tag, 4},
    {field_identifier, 1},
    {field_value, 2},
  [206] =
    {field_end_tag, 4},
    {field_identifier, 2},
  [208] =
    {field_end_tag, 4},
    {field_identifier, 1},
    {field_identifier, 2},
    {field_identifier, 3},
  [212] =
    {field_name, 0, .inherited = true},
    {field_reference_modifier, 1},
  [214] =
    {field_body, 4},
    {field_modifier, 0},
    {field_name, 2},
  [217] =
    {field_body, 4},
    {field_modifier, 0},
    {field_modifier, 1},
    {field_name, 3},
  [221] =
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 4, .inherited = true},
  [224] =
    {field_type, 2},
  [225] =
    {field_alternative, 4},
    {field_body, 2},
    {field_condition, 0},
  [228] =
    {field_name, 3},
    {field_object, 0},
  [230] =
    {field_attributes, 0},
    {field_body, 4},
    {field_parameters, 3},
  [233] =
    {field_attributes, 0},
    {field_body, 4},
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [237] =
    {field_attributes, 0},
    {field_body, 4},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [241] =
    {field_attributes, 0},
    {field_body, 4},
    {field_parameters, 2},
  [244] =
    {field_attributes, 0},
    {field_body, 4},
    {field_name, 2},
  [247] =
    {field_attributes, 0},
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 4, .inherited = true},
  [251] =
    {field_attributes, 0},
    {field_body, 4},
    {field_modifier, 1},
    {field_name, 3},
  [255] =
    {field_attributes, 0},
    {field_parameters, 4},
    {field_reference_modifier, 3},
  [258] =
    {field_attributes, 0},
    {field_parameters, 3},
    {field_return_type, 4, .inherited = true},
  [261] =
    {field_body, 5},
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 4, .inherited = true},
  [265] =
    {field_body, 5},
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [268] =
    {field_body, 5},
    {field_parameters, 2},
    {field_return_type, 4, .inherited = true},
  [271] =
    {field_default_value, 3},
    {field_name, 1},
    {field_reference_modifier, 0},
  [274] =
    {field_name, 3},
    {field_readonly, 1},
    {field_type, 2},
    {field_visibility, 0},
  [278] =
    {field_default_value, 3},
    {field_name, 1},
    {field_visibility, 0},
  [281] =
    {field_name, 3},
    {field_reference_modifier, 1},
    {field_type, 0},
  [284] =
    {field_default_value, 3},
    {field_name, 1},
    {field_type, 0},
  [287] =
    {field_attributes, 0},
    {field_name, 3},
    {field_reference_modifier, 1},
  [290] =
    {field_attributes, 0},
    {field_name, 3},
    {field_readonly, 2},
    {field_visibility, 1},
  [294] =
    {field_attributes, 0},
    {field_name, 3},
    {field_type, 2},
    {field_visibility, 1},
  [298] =
    {field_attributes, 0},
    {field_name, 3},
    {field_type, 1},
  [301] =
    {field_attributes, 0},
    {field_name, 3},
    {field_reference_modifier, 2},
    {field_type, 1},
  [305] =
    {field_attributes, 0},
    {field_default_value, 3},
    {field_name, 1},
  [308] =
    {field_body, 5},
    {field_parameters, 2},
    {field_reference_modifier, 1},
    {field_return_type, 4, .inherited = true},
  [312] =
    {field_attributes, 0},
    {field_modifier, 1},
    {field_type, 2, .inherited = true},
  [315] =
    {field_attributes, 0},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_reference_modifier, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [320] =
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_reference_modifier, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [324] =
    {field_body, 2},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_reference_modifier, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [329] =
    {field_body, 5},
    {field_name, 1},
  [331] =
    {field_return_expression, 2},
  [332] =
    {field_conditional_expressions, 0},
    {field_return_expression, 2},
  [334] =
    {field_value, 1},
  [335] =
    {field_end_tag, 5},
    {field_identifier, 2},
    {field_value, 4},
  [338] =
    {field_end_tag, 5},
    {field_identifier, 1},
    {field_identifier, 2},
    {field_identifier, 3},
    {field_value, 4},
  [343] =
    {field_body, 5},
    {field_modifier, 0},
    {field_name, 2},
  [346] =
    {field_body, 5},
    {field_modifier, 0},
    {field_modifier, 1},
    {field_name, 3},
  [350] =
    {field_arguments, 5},
    {field_name, 3},
    {field_scope, 0},
  [353] =
    {field_arguments, 5},
    {field_name, 3},
    {field_object, 0},
  [356] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 4},
    {field_reference_modifier, 3},
  [360] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 3},
    {field_return_type, 4, .inherited = true},
  [364] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 3},
  [367] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 4, .inherited = true},
  [372] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [376] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 2},
    {field_return_type, 4, .inherited = true},
  [380] =
    {field_attributes, 0},
    {field_body, 5},
    {field_name, 2},
  [383] =
    {field_attributes, 0},
    {field_body, 5},
    {field_modifier, 1},
    {field_name, 3},
  [387] =
    {field_attributes, 0},
    {field_body, 5},
    {field_modifier, 1},
    {field_modifier, 2},
    {field_name, 4},
  [392] =
    {field_attributes, 0},
    {field_parameters, 4},
    {field_reference_modifier, 3},
    {field_return_type, 5, .inherited = true},
  [396] =
    {field_body, 6},
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 5, .inherited = true},
  [400] =
    {field_default_value, 4},
    {field_name, 2},
    {field_readonly, 1},
    {field_visibility, 0},
  [404] =
    {field_default_value, 4},
    {field_name, 2},
    {field_type, 1},
    {field_visibility, 0},
  [408] =
    {field_default_value, 4},
    {field_name, 2},
    {field_reference_modifier, 1},
    {field_type, 0},
  [412] =
    {field_attributes, 0},
    {field_default_value, 4},
    {field_name, 2},
    {field_reference_modifier, 1},
  [416] =
    {field_attributes, 0},
    {field_name, 4},
    {field_readonly, 2},
    {field_type, 3},
    {field_visibility, 1},
  [421] =
    {field_attributes, 0},
    {field_default_value, 4},
    {field_name, 2},
    {field_visibility, 1},
  [425] =
    {field_attributes, 0},
    {field_name, 4},
    {field_reference_modifier, 2},
    {field_type, 1},
  [429] =
    {field_attributes, 0},
    {field_default_value, 4},
    {field_name, 2},
    {field_type, 1},
  [433] =
    {field_attributes, 0},
  [434] =
    {field_attributes, 0},
    {field_name, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_reference_modifier, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
  [439] =
    {field_attributes, 0},
    {field_body, 3},
    {field_name, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_reference_modifier, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
  [445] =
    {field_body, 4},
    {field_type, 2},
  [447] =
    {field_body, 6},
  [448] =
    {field_end_tag, 6},
    {field_identifier, 2},
    {field_value, 4},
  [451] =
    {field_end_tag, 6},
    {field_identifier, 1},
    {field_identifier, 2},
    {field_identifier, 3},
    {field_value, 4},
  [456] =
    {field_body, 6},
    {field_modifier, 0},
    {field_modifier, 1},
    {field_name, 3},
  [460] =
    {field_attributes, 0},
    {field_body, 6},
    {field_parameters, 4},
    {field_reference_modifier, 3},
    {field_return_type, 5, .inherited = true},
  [465] =
    {field_attributes, 0},
    {field_body, 6},
    {field_parameters, 4},
    {field_reference_modifier, 3},
  [469] =
    {field_attributes, 0},
    {field_body, 6},
    {field_parameters, 3},
    {field_return_type, 5, .inherited = true},
  [473] =
    {field_attributes, 0},
    {field_body, 6},
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 5, .inherited = true},
  [478] =
    {field_attributes, 0},
    {field_body, 6},
    {field_name, 2},
  [481] =
    {field_attributes, 0},
    {field_body, 6},
    {field_modifier, 1},
    {field_name, 3},
  [485] =
    {field_attributes, 0},
    {field_body, 6},
    {field_modifier, 1},
    {field_modifier, 2},
    {field_name, 4},
  [490] =
    {field_default_value, 5},
    {field_name, 3},
    {field_readonly, 1},
    {field_type, 2},
    {field_visibility, 0},
  [495] =
    {field_attributes, 0},
    {field_default_value, 5},
    {field_name, 3},
    {field_readonly, 2},
    {field_visibility, 1},
  [500] =
    {field_attributes, 0},
    {field_default_value, 5},
    {field_name, 3},
    {field_type, 2},
    {field_visibility, 1},
  [505] =
    {field_attributes, 0},
    {field_default_value, 5},
    {field_name, 3},
    {field_reference_modifier, 2},
    {field_type, 1},
  [510] =
    {field_attributes, 0},
    {field_type, 2},
  [512] =
    {field_name, 1},
    {field_value, 3},
  [514] =
    {field_body, 5},
    {field_name, 3},
    {field_type, 2},
  [517] =
    {field_attributes, 0},
    {field_body, 7},
    {field_parameters, 4},
    {field_reference_modifier, 3},
    {field_return_type, 6, .inherited = true},
  [522] =
    {field_attributes, 0},
    {field_body, 7},
    {field_modifier, 1},
    {field_modifier, 2},
    {field_name, 4},
  [527] =
    {field_attributes, 0},
    {field_default_value, 6},
    {field_name, 4},
    {field_readonly, 2},
    {field_type, 3},
    {field_visibility, 1},
  [533] =
    {field_attributes, 0},
    {field_name, 2},
    {field_value, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [6] = {
    [0] = sym_list_literal,
  },
  [7] = {
    [0] = sym_string_value,
  },
  [18] = {
    [0] = anon_sym_array,
  },
  [50] = {
    [1] = sym_list_literal,
  },
  [51] = {
    [2] = sym_list_literal,
  },
  [53] = {
    [0] = sym_name,
  },
  [88] = {
    [3] = sym_primitive_type,
  },
  [102] = {
    [3] = sym_name,
  },
  [132] = {
    [3] = sym_primitive_type,
  },
  [136] = {
    [3] = sym_list_literal,
  },
  [137] = {
    [4] = sym_list_literal,
  },
  [150] = {
    [4] = sym_primitive_type,
  },
  [176] = {
    [4] = sym_primitive_type,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__expression, 2,
    sym__expression,
    sym_name,
  sym__list_destructing, 2,
    sym__list_destructing,
    sym_list_literal,
  sym__array_destructing, 2,
    sym__array_destructing,
    sym_list_literal,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 2,
  [10] = 8,
  [11] = 7,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 12,
  [17] = 12,
  [18] = 12,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 23,
  [27] = 27,
  [28] = 23,
  [29] = 19,
  [30] = 30,
  [31] = 27,
  [32] = 24,
  [33] = 33,
  [34] = 33,
  [35] = 35,
  [36] = 20,
  [37] = 37,
  [38] = 38,
  [39] = 22,
  [40] = 40,
  [41] = 35,
  [42] = 38,
  [43] = 30,
  [44] = 30,
  [45] = 22,
  [46] = 46,
  [47] = 20,
  [48] = 37,
  [49] = 40,
  [50] = 40,
  [51] = 30,
  [52] = 52,
  [53] = 21,
  [54] = 27,
  [55] = 55,
  [56] = 20,
  [57] = 57,
  [58] = 23,
  [59] = 24,
  [60] = 46,
  [61] = 55,
  [62] = 62,
  [63] = 62,
  [64] = 35,
  [65] = 38,
  [66] = 40,
  [67] = 27,
  [68] = 25,
  [69] = 24,
  [70] = 57,
  [71] = 30,
  [72] = 22,
  [73] = 52,
  [74] = 38,
  [75] = 40,
  [76] = 35,
  [77] = 77,
  [78] = 77,
  [79] = 79,
  [80] = 79,
  [81] = 81,
  [82] = 81,
  [83] = 77,
  [84] = 77,
  [85] = 85,
  [86] = 85,
  [87] = 85,
  [88] = 85,
  [89] = 89,
  [90] = 89,
  [91] = 91,
  [92] = 91,
  [93] = 91,
  [94] = 89,
  [95] = 89,
  [96] = 91,
  [97] = 89,
  [98] = 91,
  [99] = 91,
  [100] = 100,
  [101] = 100,
  [102] = 102,
  [103] = 102,
  [104] = 100,
  [105] = 100,
  [106] = 102,
  [107] = 100,
  [108] = 100,
  [109] = 102,
  [110] = 100,
  [111] = 102,
  [112] = 100,
  [113] = 113,
  [114] = 114,
  [115] = 114,
  [116] = 114,
  [117] = 117,
  [118] = 114,
  [119] = 117,
  [120] = 117,
  [121] = 117,
  [122] = 114,
  [123] = 114,
  [124] = 117,
  [125] = 114,
  [126] = 117,
  [127] = 127,
  [128] = 127,
  [129] = 113,
  [130] = 114,
  [131] = 117,
  [132] = 117,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 136,
  [139] = 139,
  [140] = 139,
  [141] = 137,
  [142] = 133,
  [143] = 135,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 146,
  [148] = 148,
  [149] = 145,
  [150] = 150,
  [151] = 144,
  [152] = 152,
  [153] = 152,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 159,
  [161] = 161,
  [162] = 162,
  [163] = 159,
  [164] = 157,
  [165] = 162,
  [166] = 158,
  [167] = 161,
  [168] = 168,
  [169] = 159,
  [170] = 161,
  [171] = 162,
  [172] = 168,
  [173] = 158,
  [174] = 168,
  [175] = 175,
  [176] = 175,
  [177] = 161,
  [178] = 157,
  [179] = 162,
  [180] = 158,
  [181] = 168,
  [182] = 175,
  [183] = 157,
  [184] = 175,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 187,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 187,
  [194] = 187,
  [195] = 187,
  [196] = 187,
  [197] = 190,
  [198] = 191,
  [199] = 199,
  [200] = 200,
  [201] = 199,
  [202] = 200,
  [203] = 203,
  [204] = 203,
  [205] = 203,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 209,
  [211] = 203,
  [212] = 209,
  [213] = 207,
  [214] = 209,
  [215] = 206,
  [216] = 207,
  [217] = 206,
  [218] = 206,
  [219] = 203,
  [220] = 220,
  [221] = 203,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 228,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 224,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 223,
  [251] = 251,
  [252] = 236,
  [253] = 253,
  [254] = 226,
  [255] = 229,
  [256] = 256,
  [257] = 234,
  [258] = 258,
  [259] = 259,
  [260] = 233,
  [261] = 261,
  [262] = 262,
  [263] = 258,
  [264] = 264,
  [265] = 231,
  [266] = 224,
  [267] = 251,
  [268] = 240,
  [269] = 235,
  [270] = 237,
  [271] = 241,
  [272] = 272,
  [273] = 242,
  [274] = 243,
  [275] = 258,
  [276] = 276,
  [277] = 228,
  [278] = 264,
  [279] = 279,
  [280] = 249,
  [281] = 281,
  [282] = 244,
  [283] = 283,
  [284] = 272,
  [285] = 245,
  [286] = 272,
  [287] = 246,
  [288] = 258,
  [289] = 247,
  [290] = 248,
  [291] = 228,
  [292] = 249,
  [293] = 248,
  [294] = 247,
  [295] = 281,
  [296] = 246,
  [297] = 245,
  [298] = 298,
  [299] = 223,
  [300] = 251,
  [301] = 235,
  [302] = 244,
  [303] = 235,
  [304] = 236,
  [305] = 305,
  [306] = 306,
  [307] = 253,
  [308] = 226,
  [309] = 243,
  [310] = 310,
  [311] = 311,
  [312] = 229,
  [313] = 234,
  [314] = 237,
  [315] = 315,
  [316] = 316,
  [317] = 306,
  [318] = 318,
  [319] = 283,
  [320] = 239,
  [321] = 276,
  [322] = 242,
  [323] = 241,
  [324] = 305,
  [325] = 235,
  [326] = 326,
  [327] = 240,
  [328] = 305,
  [329] = 329,
  [330] = 231,
  [331] = 281,
  [332] = 332,
  [333] = 272,
  [334] = 264,
  [335] = 228,
  [336] = 258,
  [337] = 237,
  [338] = 281,
  [339] = 339,
  [340] = 235,
  [341] = 305,
  [342] = 306,
  [343] = 276,
  [344] = 262,
  [345] = 261,
  [346] = 346,
  [347] = 259,
  [348] = 348,
  [349] = 228,
  [350] = 225,
  [351] = 227,
  [352] = 239,
  [353] = 233,
  [354] = 232,
  [355] = 272,
  [356] = 233,
  [357] = 237,
  [358] = 272,
  [359] = 258,
  [360] = 234,
  [361] = 262,
  [362] = 261,
  [363] = 363,
  [364] = 235,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 242,
  [369] = 232,
  [370] = 227,
  [371] = 235,
  [372] = 259,
  [373] = 348,
  [374] = 225,
  [375] = 348,
  [376] = 235,
  [377] = 237,
  [378] = 259,
  [379] = 261,
  [380] = 380,
  [381] = 262,
  [382] = 231,
  [383] = 383,
  [384] = 224,
  [385] = 385,
  [386] = 240,
  [387] = 241,
  [388] = 388,
  [389] = 235,
  [390] = 237,
  [391] = 243,
  [392] = 306,
  [393] = 348,
  [394] = 232,
  [395] = 395,
  [396] = 244,
  [397] = 229,
  [398] = 272,
  [399] = 245,
  [400] = 228,
  [401] = 246,
  [402] = 247,
  [403] = 248,
  [404] = 249,
  [405] = 223,
  [406] = 251,
  [407] = 239,
  [408] = 236,
  [409] = 253,
  [410] = 227,
  [411] = 283,
  [412] = 228,
  [413] = 413,
  [414] = 228,
  [415] = 225,
  [416] = 226,
  [417] = 237,
  [418] = 253,
  [419] = 237,
  [420] = 237,
  [421] = 276,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 424,
  [427] = 425,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 431,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 438,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 449,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 430,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 561,
  [563] = 561,
  [564] = 561,
  [565] = 561,
  [566] = 566,
  [567] = 567,
  [568] = 567,
  [569] = 567,
  [570] = 567,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 595,
  [597] = 579,
  [598] = 595,
  [599] = 577,
  [600] = 580,
  [601] = 601,
  [602] = 578,
  [603] = 580,
  [604] = 576,
  [605] = 575,
  [606] = 606,
  [607] = 587,
  [608] = 595,
  [609] = 609,
  [610] = 588,
  [611] = 593,
  [612] = 585,
  [613] = 582,
  [614] = 574,
  [615] = 581,
  [616] = 583,
  [617] = 591,
  [618] = 586,
  [619] = 590,
  [620] = 573,
  [621] = 621,
  [622] = 606,
  [623] = 584,
  [624] = 589,
  [625] = 621,
  [626] = 571,
  [627] = 592,
  [628] = 572,
  [629] = 629,
  [630] = 594,
  [631] = 594,
  [632] = 606,
  [633] = 633,
  [634] = 606,
  [635] = 635,
  [636] = 635,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 576,
  [643] = 575,
  [644] = 577,
  [645] = 578,
  [646] = 579,
  [647] = 647,
  [648] = 648,
  [649] = 583,
  [650] = 650,
  [651] = 648,
  [652] = 652,
  [653] = 652,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 590,
  [659] = 659,
  [660] = 593,
  [661] = 587,
  [662] = 571,
  [663] = 657,
  [664] = 592,
  [665] = 573,
  [666] = 582,
  [667] = 659,
  [668] = 589,
  [669] = 586,
  [670] = 585,
  [671] = 656,
  [672] = 672,
  [673] = 584,
  [674] = 674,
  [675] = 574,
  [676] = 572,
  [677] = 583,
  [678] = 591,
  [679] = 588,
  [680] = 581,
  [681] = 681,
  [682] = 682,
  [683] = 577,
  [684] = 684,
  [685] = 682,
  [686] = 577,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 579,
  [691] = 691,
  [692] = 576,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 575,
  [697] = 697,
  [698] = 672,
  [699] = 699,
  [700] = 578,
  [701] = 674,
  [702] = 702,
  [703] = 689,
  [704] = 704,
  [705] = 575,
  [706] = 576,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 579,
  [711] = 711,
  [712] = 578,
  [713] = 577,
  [714] = 575,
  [715] = 576,
  [716] = 650,
  [717] = 579,
  [718] = 578,
  [719] = 719,
  [720] = 593,
  [721] = 573,
  [722] = 574,
  [723] = 587,
  [724] = 571,
  [725] = 590,
  [726] = 566,
  [727] = 727,
  [728] = 728,
  [729] = 572,
  [730] = 730,
  [731] = 731,
  [732] = 591,
  [733] = 581,
  [734] = 588,
  [735] = 735,
  [736] = 736,
  [737] = 582,
  [738] = 584,
  [739] = 585,
  [740] = 586,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 589,
  [745] = 745,
  [746] = 592,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 431,
  [761] = 652,
  [762] = 654,
  [763] = 681,
  [764] = 655,
  [765] = 765,
  [766] = 650,
  [767] = 652,
  [768] = 768,
  [769] = 769,
  [770] = 702,
  [771] = 771,
  [772] = 430,
  [773] = 647,
  [774] = 774,
  [775] = 579,
  [776] = 576,
  [777] = 575,
  [778] = 577,
  [779] = 578,
  [780] = 780,
  [781] = 588,
  [782] = 591,
  [783] = 571,
  [784] = 581,
  [785] = 572,
  [786] = 573,
  [787] = 589,
  [788] = 592,
  [789] = 582,
  [790] = 593,
  [791] = 587,
  [792] = 584,
  [793] = 585,
  [794] = 586,
  [795] = 795,
  [796] = 574,
  [797] = 780,
  [798] = 798,
  [799] = 590,
  [800] = 583,
  [801] = 681,
  [802] = 802,
  [803] = 802,
  [804] = 449,
  [805] = 576,
  [806] = 672,
  [807] = 575,
  [808] = 702,
  [809] = 691,
  [810] = 810,
  [811] = 693,
  [812] = 579,
  [813] = 578,
  [814] = 577,
  [815] = 704,
  [816] = 674,
  [817] = 817,
  [818] = 707,
  [819] = 708,
  [820] = 709,
  [821] = 650,
  [822] = 817,
  [823] = 576,
  [824] = 682,
  [825] = 438,
  [826] = 711,
  [827] = 688,
  [828] = 639,
  [829] = 817,
  [830] = 579,
  [831] = 578,
  [832] = 832,
  [833] = 833,
  [834] = 810,
  [835] = 817,
  [836] = 575,
  [837] = 833,
  [838] = 682,
  [839] = 577,
  [840] = 689,
  [841] = 689,
  [842] = 842,
  [843] = 583,
  [844] = 810,
  [845] = 575,
  [846] = 576,
  [847] = 579,
  [848] = 672,
  [849] = 817,
  [850] = 578,
  [851] = 577,
  [852] = 832,
  [853] = 674,
  [854] = 590,
  [855] = 735,
  [856] = 757,
  [857] = 588,
  [858] = 731,
  [859] = 751,
  [860] = 755,
  [861] = 759,
  [862] = 581,
  [863] = 566,
  [864] = 727,
  [865] = 582,
  [866] = 571,
  [867] = 591,
  [868] = 589,
  [869] = 743,
  [870] = 754,
  [871] = 756,
  [872] = 702,
  [873] = 719,
  [874] = 742,
  [875] = 753,
  [876] = 584,
  [877] = 752,
  [878] = 585,
  [879] = 741,
  [880] = 586,
  [881] = 574,
  [882] = 730,
  [883] = 749,
  [884] = 750,
  [885] = 573,
  [886] = 736,
  [887] = 728,
  [888] = 702,
  [889] = 587,
  [890] = 745,
  [891] = 593,
  [892] = 592,
  [893] = 748,
  [894] = 747,
  [895] = 572,
  [896] = 765,
  [897] = 774,
  [898] = 681,
  [899] = 768,
  [900] = 771,
  [901] = 901,
  [902] = 902,
  [903] = 903,
  [904] = 904,
  [905] = 905,
  [906] = 906,
  [907] = 907,
  [908] = 908,
  [909] = 909,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 913,
  [914] = 914,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 918,
  [919] = 919,
  [920] = 920,
  [921] = 921,
  [922] = 922,
  [923] = 923,
  [924] = 924,
  [925] = 925,
  [926] = 926,
  [927] = 927,
  [928] = 928,
  [929] = 929,
  [930] = 572,
  [931] = 574,
  [932] = 932,
  [933] = 573,
  [934] = 571,
  [935] = 935,
  [936] = 936,
  [937] = 937,
  [938] = 938,
  [939] = 939,
  [940] = 940,
  [941] = 941,
  [942] = 942,
  [943] = 943,
  [944] = 944,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 948,
  [949] = 949,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 954,
  [955] = 955,
  [956] = 956,
  [957] = 957,
  [958] = 958,
  [959] = 959,
  [960] = 960,
  [961] = 961,
  [962] = 962,
  [963] = 963,
  [964] = 964,
  [965] = 965,
  [966] = 438,
  [967] = 449,
  [968] = 968,
  [969] = 969,
  [970] = 970,
  [971] = 971,
  [972] = 972,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 976,
  [977] = 977,
  [978] = 978,
  [979] = 979,
  [980] = 980,
  [981] = 981,
  [982] = 982,
  [983] = 983,
  [984] = 984,
  [985] = 985,
  [986] = 986,
  [987] = 987,
  [988] = 988,
  [989] = 989,
  [990] = 990,
  [991] = 991,
  [992] = 992,
  [993] = 993,
  [994] = 994,
  [995] = 995,
  [996] = 996,
  [997] = 997,
  [998] = 998,
  [999] = 999,
  [1000] = 975,
  [1001] = 997,
  [1002] = 993,
  [1003] = 994,
  [1004] = 990,
  [1005] = 987,
  [1006] = 969,
  [1007] = 976,
  [1008] = 985,
  [1009] = 968,
  [1010] = 977,
  [1011] = 984,
  [1012] = 974,
  [1013] = 973,
  [1014] = 972,
  [1015] = 1015,
  [1016] = 971,
  [1017] = 970,
  [1018] = 982,
  [1019] = 999,
  [1020] = 998,
  [1021] = 983,
  [1022] = 978,
  [1023] = 996,
  [1024] = 988,
  [1025] = 995,
  [1026] = 986,
  [1027] = 980,
  [1028] = 992,
  [1029] = 991,
  [1030] = 989,
  [1031] = 981,
  [1032] = 979,
  [1033] = 912,
  [1034] = 968,
  [1035] = 574,
  [1036] = 573,
  [1037] = 571,
  [1038] = 992,
  [1039] = 991,
  [1040] = 988,
  [1041] = 986,
  [1042] = 921,
  [1043] = 942,
  [1044] = 944,
  [1045] = 997,
  [1046] = 981,
  [1047] = 980,
  [1048] = 979,
  [1049] = 945,
  [1050] = 978,
  [1051] = 983,
  [1052] = 920,
  [1053] = 919,
  [1054] = 998,
  [1055] = 941,
  [1056] = 929,
  [1057] = 999,
  [1058] = 982,
  [1059] = 970,
  [1060] = 1060,
  [1061] = 903,
  [1062] = 971,
  [1063] = 1063,
  [1064] = 972,
  [1065] = 973,
  [1066] = 974,
  [1067] = 975,
  [1068] = 984,
  [1069] = 1060,
  [1070] = 943,
  [1071] = 928,
  [1072] = 918,
  [1073] = 917,
  [1074] = 916,
  [1075] = 915,
  [1076] = 430,
  [1077] = 914,
  [1078] = 913,
  [1079] = 904,
  [1080] = 937,
  [1081] = 1063,
  [1082] = 956,
  [1083] = 905,
  [1084] = 906,
  [1085] = 1063,
  [1086] = 954,
  [1087] = 953,
  [1088] = 936,
  [1089] = 907,
  [1090] = 940,
  [1091] = 939,
  [1092] = 996,
  [1093] = 995,
  [1094] = 431,
  [1095] = 955,
  [1096] = 927,
  [1097] = 910,
  [1098] = 926,
  [1099] = 950,
  [1100] = 938,
  [1101] = 957,
  [1102] = 958,
  [1103] = 990,
  [1104] = 977,
  [1105] = 965,
  [1106] = 951,
  [1107] = 911,
  [1108] = 994,
  [1109] = 947,
  [1110] = 901,
  [1111] = 1060,
  [1112] = 925,
  [1113] = 935,
  [1114] = 924,
  [1115] = 923,
  [1116] = 962,
  [1117] = 948,
  [1118] = 572,
  [1119] = 985,
  [1120] = 993,
  [1121] = 952,
  [1122] = 989,
  [1123] = 908,
  [1124] = 964,
  [1125] = 902,
  [1126] = 909,
  [1127] = 949,
  [1128] = 960,
  [1129] = 976,
  [1130] = 963,
  [1131] = 932,
  [1132] = 946,
  [1133] = 922,
  [1134] = 969,
  [1135] = 987,
  [1136] = 961,
  [1137] = 1137,
  [1138] = 988,
  [1139] = 968,
  [1140] = 989,
  [1141] = 992,
  [1142] = 983,
  [1143] = 970,
  [1144] = 985,
  [1145] = 971,
  [1146] = 972,
  [1147] = 998,
  [1148] = 976,
  [1149] = 999,
  [1150] = 975,
  [1151] = 969,
  [1152] = 981,
  [1153] = 982,
  [1154] = 973,
  [1155] = 974,
  [1156] = 986,
  [1157] = 993,
  [1158] = 994,
  [1159] = 997,
  [1160] = 990,
  [1161] = 991,
  [1162] = 980,
  [1163] = 1163,
  [1164] = 984,
  [1165] = 995,
  [1166] = 978,
  [1167] = 1167,
  [1168] = 977,
  [1169] = 1169,
  [1170] = 996,
  [1171] = 979,
  [1172] = 987,
  [1173] = 1173,
  [1174] = 1174,
  [1175] = 1175,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 987,
  [1179] = 1179,
  [1180] = 987,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 1183,
  [1184] = 1184,
  [1185] = 1185,
  [1186] = 1186,
  [1187] = 1187,
  [1188] = 1188,
  [1189] = 1175,
  [1190] = 1190,
  [1191] = 1191,
  [1192] = 1176,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1197,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 1202,
  [1203] = 1203,
  [1204] = 1198,
  [1205] = 1205,
  [1206] = 1206,
  [1207] = 1190,
  [1208] = 1185,
  [1209] = 1209,
  [1210] = 1190,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1175,
  [1217] = 1190,
  [1218] = 1185,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1222,
  [1223] = 1176,
  [1224] = 1187,
  [1225] = 1201,
  [1226] = 1182,
  [1227] = 1227,
  [1228] = 1185,
  [1229] = 1229,
  [1230] = 1230,
  [1231] = 1187,
  [1232] = 1187,
  [1233] = 1202,
  [1234] = 1234,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 1237,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 1237,
  [1241] = 1241,
  [1242] = 1237,
  [1243] = 1243,
  [1244] = 1238,
  [1245] = 1239,
  [1246] = 1237,
  [1247] = 1247,
  [1248] = 1235,
  [1249] = 1249,
  [1250] = 1238,
  [1251] = 1239,
  [1252] = 1235,
  [1253] = 1237,
  [1254] = 1254,
  [1255] = 1237,
  [1256] = 1249,
  [1257] = 1257,
  [1258] = 1243,
  [1259] = 1257,
  [1260] = 1238,
  [1261] = 1239,
  [1262] = 1257,
  [1263] = 1249,
  [1264] = 1239,
  [1265] = 1235,
  [1266] = 1237,
  [1267] = 1238,
  [1268] = 1239,
  [1269] = 1249,
  [1270] = 1235,
  [1271] = 1271,
  [1272] = 1241,
  [1273] = 1243,
  [1274] = 1238,
  [1275] = 1238,
  [1276] = 1239,
  [1277] = 1257,
  [1278] = 1278,
  [1279] = 1278,
  [1280] = 1249,
  [1281] = 1235,
  [1282] = 1238,
  [1283] = 1239,
  [1284] = 1237,
  [1285] = 1285,
  [1286] = 1286,
  [1287] = 1257,
  [1288] = 1288,
  [1289] = 1241,
  [1290] = 1239,
  [1291] = 1257,
  [1292] = 1271,
  [1293] = 1238,
  [1294] = 1243,
  [1295] = 1237,
  [1296] = 1249,
  [1297] = 1254,
  [1298] = 1254,
  [1299] = 1238,
  [1300] = 1278,
  [1301] = 1239,
  [1302] = 1254,
  [1303] = 1257,
  [1304] = 1304,
  [1305] = 1305,
  [1306] = 1306,
  [1307] = 1306,
  [1308] = 1308,
  [1309] = 1309,
  [1310] = 1305,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 1313,
  [1314] = 1314,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1318,
  [1319] = 1319,
  [1320] = 1320,
  [1321] = 1321,
  [1322] = 1317,
  [1323] = 1318,
  [1324] = 1324,
  [1325] = 1316,
  [1326] = 1317,
  [1327] = 1321,
  [1328] = 1321,
  [1329] = 1318,
  [1330] = 1330,
  [1331] = 1330,
  [1332] = 1332,
  [1333] = 1332,
  [1334] = 1330,
  [1335] = 1332,
  [1336] = 1336,
  [1337] = 1311,
  [1338] = 1336,
  [1339] = 1336,
  [1340] = 1312,
  [1341] = 1341,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 1344,
  [1345] = 1345,
  [1346] = 1346,
  [1347] = 1347,
  [1348] = 1348,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 1314,
  [1352] = 1315,
  [1353] = 1353,
  [1354] = 1015,
  [1355] = 1355,
  [1356] = 1319,
  [1357] = 1324,
  [1358] = 1358,
  [1359] = 1320,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 431,
  [1363] = 1363,
  [1364] = 430,
  [1365] = 1365,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 1368,
  [1369] = 1369,
  [1370] = 1370,
  [1371] = 1366,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1377,
  [1378] = 1378,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1365,
  [1382] = 1382,
  [1383] = 550,
  [1384] = 1384,
  [1385] = 1385,
  [1386] = 1386,
  [1387] = 1387,
  [1388] = 1388,
  [1389] = 456,
  [1390] = 1390,
  [1391] = 462,
  [1392] = 1392,
  [1393] = 1393,
  [1394] = 1394,
  [1395] = 1395,
  [1396] = 1396,
  [1397] = 1387,
  [1398] = 1398,
  [1399] = 587,
  [1400] = 1400,
  [1401] = 1398,
  [1402] = 1392,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 522,
  [1406] = 1404,
  [1407] = 485,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 1412,
  [1413] = 1413,
  [1414] = 558,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 515,
  [1418] = 1418,
  [1419] = 1419,
  [1420] = 1420,
  [1421] = 1421,
  [1422] = 1421,
  [1423] = 1419,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1428,
  [1429] = 1429,
  [1430] = 1430,
  [1431] = 1431,
  [1432] = 1432,
  [1433] = 1424,
  [1434] = 1434,
  [1435] = 1435,
  [1436] = 1431,
  [1437] = 1437,
  [1438] = 1426,
  [1439] = 1439,
  [1440] = 587,
  [1441] = 1441,
  [1442] = 1442,
  [1443] = 1443,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 688,
  [1448] = 593,
  [1449] = 1449,
  [1450] = 590,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 650,
  [1454] = 1454,
  [1455] = 587,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 1459,
  [1460] = 1441,
  [1461] = 1461,
  [1462] = 1462,
  [1463] = 1463,
  [1464] = 1452,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1471,
  [1472] = 1471,
  [1473] = 1468,
  [1474] = 1474,
  [1475] = 1468,
  [1476] = 1471,
  [1477] = 1471,
  [1478] = 1468,
  [1479] = 1474,
  [1480] = 1480,
  [1481] = 1471,
  [1482] = 1311,
  [1483] = 1471,
  [1484] = 1474,
  [1485] = 1474,
  [1486] = 1486,
  [1487] = 1286,
  [1488] = 1309,
  [1489] = 1489,
  [1490] = 1471,
  [1491] = 1313,
  [1492] = 1486,
  [1493] = 1468,
  [1494] = 1486,
  [1495] = 1474,
  [1496] = 1496,
  [1497] = 1471,
  [1498] = 1474,
  [1499] = 1499,
  [1500] = 1468,
  [1501] = 1501,
  [1502] = 1502,
  [1503] = 1474,
  [1504] = 1474,
  [1505] = 587,
  [1506] = 1486,
  [1507] = 1507,
  [1508] = 1468,
  [1509] = 1509,
  [1510] = 1510,
  [1511] = 1474,
  [1512] = 1512,
  [1513] = 1312,
  [1514] = 1471,
  [1515] = 1486,
  [1516] = 1471,
  [1517] = 1474,
  [1518] = 1474,
  [1519] = 1468,
  [1520] = 1468,
  [1521] = 1471,
  [1522] = 1468,
  [1523] = 1523,
  [1524] = 1524,
  [1525] = 1468,
  [1526] = 1526,
  [1527] = 1527,
  [1528] = 1471,
  [1529] = 1471,
  [1530] = 1530,
  [1531] = 1531,
  [1532] = 1532,
  [1533] = 1420,
  [1534] = 1534,
  [1535] = 1535,
  [1536] = 1536,
  [1537] = 422,
  [1538] = 423,
  [1539] = 1535,
  [1540] = 1457,
  [1541] = 1534,
  [1542] = 1542,
  [1543] = 1543,
  [1544] = 1544,
  [1545] = 1536,
  [1546] = 1542,
  [1547] = 1547,
  [1548] = 674,
  [1549] = 1547,
  [1550] = 1446,
  [1551] = 1443,
  [1552] = 1552,
  [1553] = 1553,
  [1554] = 1554,
  [1555] = 577,
  [1556] = 1451,
  [1557] = 1557,
  [1558] = 1558,
  [1559] = 1465,
  [1560] = 1560,
  [1561] = 1561,
  [1562] = 1562,
  [1563] = 587,
  [1564] = 798,
  [1565] = 1547,
  [1566] = 1566,
  [1567] = 672,
  [1568] = 1552,
  [1569] = 1403,
  [1570] = 593,
  [1571] = 1571,
  [1572] = 577,
  [1573] = 1573,
  [1574] = 1560,
  [1575] = 1575,
  [1576] = 590,
  [1577] = 1547,
  [1578] = 672,
  [1579] = 1560,
  [1580] = 674,
  [1581] = 1581,
  [1582] = 1560,
  [1583] = 1547,
  [1584] = 1552,
  [1585] = 672,
  [1586] = 1560,
  [1587] = 1420,
  [1588] = 674,
  [1589] = 1589,
  [1590] = 1560,
  [1591] = 1591,
  [1592] = 1592,
  [1593] = 424,
  [1594] = 1594,
  [1595] = 1595,
  [1596] = 1596,
  [1597] = 593,
  [1598] = 1598,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1594,
  [1602] = 1602,
  [1603] = 1603,
  [1604] = 1604,
  [1605] = 1605,
  [1606] = 1598,
  [1607] = 1607,
  [1608] = 1608,
  [1609] = 1609,
  [1610] = 1610,
  [1611] = 1611,
  [1612] = 1612,
  [1613] = 1613,
  [1614] = 590,
  [1615] = 1615,
  [1616] = 1616,
  [1617] = 1451,
  [1618] = 1595,
  [1619] = 1604,
  [1620] = 1465,
  [1621] = 587,
  [1622] = 425,
  [1623] = 424,
  [1624] = 1624,
  [1625] = 1611,
  [1626] = 1626,
  [1627] = 1627,
  [1628] = 1612,
  [1629] = 1443,
  [1630] = 1446,
  [1631] = 1631,
  [1632] = 1632,
  [1633] = 1609,
  [1634] = 1595,
  [1635] = 1599,
  [1636] = 1610,
  [1637] = 1612,
  [1638] = 1592,
  [1639] = 425,
  [1640] = 1596,
  [1641] = 1632,
  [1642] = 1642,
  [1643] = 1643,
  [1644] = 1643,
  [1645] = 1615,
  [1646] = 1602,
  [1647] = 1647,
  [1648] = 1648,
  [1649] = 1647,
  [1650] = 1624,
  [1651] = 1642,
  [1652] = 1652,
  [1653] = 1600,
  [1654] = 1626,
  [1655] = 1631,
  [1656] = 1652,
  [1657] = 1603,
  [1658] = 1605,
  [1659] = 1659,
  [1660] = 450,
  [1661] = 1661,
  [1662] = 1429,
  [1663] = 1428,
  [1664] = 1664,
  [1665] = 1665,
  [1666] = 1661,
  [1667] = 1667,
  [1668] = 1667,
  [1669] = 1661,
  [1670] = 1444,
  [1671] = 1671,
  [1672] = 1661,
  [1673] = 1673,
  [1674] = 1674,
  [1675] = 1430,
  [1676] = 1531,
  [1677] = 1526,
  [1678] = 1661,
  [1679] = 441,
  [1680] = 1671,
  [1681] = 443,
  [1682] = 1661,
  [1683] = 1661,
  [1684] = 1661,
  [1685] = 1661,
  [1686] = 1661,
  [1687] = 1687,
  [1688] = 1671,
  [1689] = 1689,
  [1690] = 1690,
  [1691] = 1501,
  [1692] = 1530,
  [1693] = 1527,
  [1694] = 1694,
  [1695] = 1695,
  [1696] = 1696,
  [1697] = 1697,
  [1698] = 1698,
  [1699] = 429,
  [1700] = 1532,
  [1701] = 1671,
  [1702] = 1501,
  [1703] = 1703,
  [1704] = 1442,
  [1705] = 1530,
  [1706] = 1706,
  [1707] = 1707,
  [1708] = 439,
  [1709] = 1709,
  [1710] = 1710,
  [1711] = 433,
  [1712] = 1712,
  [1713] = 1664,
  [1714] = 1648,
  [1715] = 440,
  [1716] = 442,
  [1717] = 1717,
  [1718] = 453,
  [1719] = 1527,
  [1720] = 1698,
  [1721] = 1671,
  [1722] = 451,
  [1723] = 1671,
  [1724] = 1703,
  [1725] = 1671,
  [1726] = 434,
  [1727] = 1671,
  [1728] = 447,
  [1729] = 1729,
  [1730] = 1712,
  [1731] = 1671,
  [1732] = 1671,
  [1733] = 1661,
  [1734] = 1671,
  [1735] = 1661,
  [1736] = 428,
  [1737] = 1674,
  [1738] = 1707,
  [1739] = 1739,
  [1740] = 452,
  [1741] = 445,
  [1742] = 1531,
  [1743] = 1526,
  [1744] = 432,
  [1745] = 448,
  [1746] = 1689,
  [1747] = 446,
  [1748] = 1748,
  [1749] = 444,
  [1750] = 435,
  [1751] = 437,
  [1752] = 1532,
  [1753] = 436,
  [1754] = 1754,
  [1755] = 1755,
  [1756] = 1756,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1760,
  [1761] = 1761,
  [1762] = 1762,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 639,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1769,
  [1770] = 1770,
  [1771] = 1771,
  [1772] = 1772,
  [1773] = 1773,
  [1774] = 1774,
  [1775] = 1755,
  [1776] = 1757,
  [1777] = 1777,
  [1778] = 1778,
  [1779] = 1467,
  [1780] = 1780,
  [1781] = 1780,
  [1782] = 1444,
  [1783] = 1761,
  [1784] = 1763,
  [1785] = 1785,
  [1786] = 1767,
  [1787] = 1755,
  [1788] = 1788,
  [1789] = 1789,
  [1790] = 1790,
  [1791] = 1791,
  [1792] = 1785,
  [1793] = 1793,
  [1794] = 1773,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1797,
  [1798] = 1798,
  [1799] = 1774,
  [1800] = 1800,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1805,
  [1806] = 1793,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1810,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1801,
  [1815] = 1811,
  [1816] = 1807,
  [1817] = 1817,
  [1818] = 1789,
  [1819] = 1819,
  [1820] = 1442,
  [1821] = 1821,
  [1822] = 1822,
  [1823] = 1823,
  [1824] = 1824,
  [1825] = 1825,
  [1826] = 1756,
  [1827] = 1827,
  [1828] = 1828,
  [1829] = 1829,
  [1830] = 1830,
  [1831] = 1831,
  [1832] = 1832,
  [1833] = 1833,
  [1834] = 1796,
  [1835] = 1835,
  [1836] = 1836,
  [1837] = 1837,
  [1838] = 1838,
  [1839] = 1839,
  [1840] = 1840,
  [1841] = 1774,
  [1842] = 1842,
  [1843] = 1791,
  [1844] = 1445,
  [1845] = 1845,
  [1846] = 1846,
  [1847] = 1847,
  [1848] = 1439,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1853,
  [1854] = 1854,
  [1855] = 1855,
  [1856] = 1803,
  [1857] = 1819,
  [1858] = 1770,
  [1859] = 1859,
  [1860] = 1808,
  [1861] = 1758,
  [1862] = 1821,
  [1863] = 1759,
  [1864] = 1842,
  [1865] = 1865,
  [1866] = 1761,
  [1867] = 1763,
  [1868] = 1868,
  [1869] = 1869,
  [1870] = 1765,
  [1871] = 1871,
  [1872] = 1835,
  [1873] = 1807,
  [1874] = 1874,
  [1875] = 1875,
  [1876] = 1802,
  [1877] = 1812,
  [1878] = 1810,
  [1879] = 1805,
  [1880] = 1880,
  [1881] = 1768,
  [1882] = 1882,
  [1883] = 1804,
  [1884] = 1807,
  [1885] = 1833,
  [1886] = 1463,
  [1887] = 1772,
  [1888] = 1809,
  [1889] = 1773,
  [1890] = 1785,
  [1891] = 1891,
  [1892] = 1748,
  [1893] = 1840,
  [1894] = 1798,
  [1895] = 1800,
  [1896] = 1850,
  [1897] = 1897,
  [1898] = 1827,
  [1899] = 1466,
  [1900] = 1900,
  [1901] = 1828,
  [1902] = 1902,
  [1903] = 1903,
  [1904] = 1852,
  [1905] = 1831,
  [1906] = 1767,
  [1907] = 1865,
  [1908] = 1778,
  [1909] = 1830,
  [1910] = 1837,
  [1911] = 1796,
  [1912] = 1903,
  [1913] = 1846,
  [1914] = 1914,
  [1915] = 553,
  [1916] = 535,
  [1917] = 1917,
  [1918] = 1918,
  [1919] = 1919,
  [1920] = 1920,
  [1921] = 541,
  [1922] = 548,
  [1923] = 554,
  [1924] = 1924,
  [1925] = 558,
  [1926] = 1926,
  [1927] = 502,
  [1928] = 1928,
  [1929] = 1929,
  [1930] = 1930,
  [1931] = 1931,
  [1932] = 1932,
  [1933] = 1933,
  [1934] = 1934,
  [1935] = 529,
  [1936] = 1936,
  [1937] = 1937,
  [1938] = 1938,
  [1939] = 1939,
  [1940] = 1940,
  [1941] = 1941,
  [1942] = 1942,
  [1943] = 1943,
  [1944] = 1944,
  [1945] = 1945,
  [1946] = 537,
  [1947] = 1947,
  [1948] = 1948,
  [1949] = 1949,
  [1950] = 473,
  [1951] = 1951,
  [1952] = 1952,
  [1953] = 1771,
  [1954] = 1954,
  [1955] = 550,
  [1956] = 555,
  [1957] = 1957,
  [1958] = 1958,
  [1959] = 1959,
  [1960] = 1960,
  [1961] = 1961,
  [1962] = 1962,
  [1963] = 506,
  [1964] = 1964,
  [1965] = 1965,
  [1966] = 1966,
  [1967] = 1967,
  [1968] = 1968,
  [1969] = 1969,
  [1970] = 1970,
  [1971] = 1971,
  [1972] = 1936,
  [1973] = 1973,
  [1974] = 1974,
  [1975] = 1975,
  [1976] = 518,
  [1977] = 514,
  [1978] = 510,
  [1979] = 1979,
  [1980] = 1944,
  [1981] = 1981,
  [1982] = 475,
  [1983] = 1983,
  [1984] = 504,
  [1985] = 1985,
  [1986] = 546,
  [1987] = 1987,
  [1988] = 1988,
  [1989] = 1989,
  [1990] = 1990,
  [1991] = 1991,
  [1992] = 1992,
  [1993] = 1993,
  [1994] = 527,
  [1995] = 1995,
  [1996] = 1934,
  [1997] = 1997,
  [1998] = 1991,
  [1999] = 1937,
  [2000] = 2000,
  [2001] = 2001,
  [2002] = 1914,
  [2003] = 1932,
  [2004] = 2004,
  [2005] = 2005,
  [2006] = 485,
  [2007] = 1981,
  [2008] = 2008,
  [2009] = 2009,
  [2010] = 501,
  [2011] = 466,
  [2012] = 1952,
  [2013] = 455,
  [2014] = 500,
  [2015] = 2015,
  [2016] = 461,
  [2017] = 499,
  [2018] = 2018,
  [2019] = 497,
  [2020] = 496,
  [2021] = 1974,
  [2022] = 2022,
  [2023] = 2023,
  [2024] = 2024,
  [2025] = 459,
  [2026] = 2026,
  [2027] = 2027,
  [2028] = 2028,
  [2029] = 1964,
  [2030] = 516,
  [2031] = 2031,
  [2032] = 2032,
  [2033] = 2033,
  [2034] = 2034,
  [2035] = 1969,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 457,
  [2039] = 509,
  [2040] = 2040,
  [2041] = 525,
  [2042] = 2042,
  [2043] = 1931,
  [2044] = 1939,
  [2045] = 486,
  [2046] = 2046,
  [2047] = 2047,
  [2048] = 2048,
  [2049] = 2049,
  [2050] = 2050,
  [2051] = 2051,
  [2052] = 484,
  [2053] = 2053,
  [2054] = 471,
  [2055] = 2055,
  [2056] = 2056,
  [2057] = 2057,
  [2058] = 2023,
  [2059] = 531,
  [2060] = 2060,
  [2061] = 495,
  [2062] = 512,
  [2063] = 2047,
  [2064] = 2034,
  [2065] = 489,
  [2066] = 483,
  [2067] = 491,
  [2068] = 2068,
  [2069] = 513,
  [2070] = 1941,
  [2071] = 2071,
  [2072] = 545,
  [2073] = 517,
  [2074] = 2074,
  [2075] = 2075,
  [2076] = 2076,
  [2077] = 482,
  [2078] = 2078,
  [2079] = 2079,
  [2080] = 521,
  [2081] = 519,
  [2082] = 520,
  [2083] = 2083,
  [2084] = 1697,
  [2085] = 470,
  [2086] = 481,
  [2087] = 477,
  [2088] = 1968,
  [2089] = 560,
  [2090] = 487,
  [2091] = 534,
  [2092] = 2092,
  [2093] = 1918,
  [2094] = 539,
  [2095] = 2032,
  [2096] = 2096,
  [2097] = 480,
  [2098] = 515,
  [2099] = 2099,
  [2100] = 456,
  [2101] = 523,
  [2102] = 559,
  [2103] = 2103,
  [2104] = 1918,
  [2105] = 479,
  [2106] = 547,
  [2107] = 544,
  [2108] = 2108,
  [2109] = 2109,
  [2110] = 522,
  [2111] = 540,
  [2112] = 1968,
  [2113] = 464,
  [2114] = 1968,
  [2115] = 2115,
  [2116] = 492,
  [2117] = 494,
  [2118] = 528,
  [2119] = 1918,
  [2120] = 2120,
  [2121] = 467,
  [2122] = 2122,
  [2123] = 543,
  [2124] = 530,
  [2125] = 488,
  [2126] = 557,
  [2127] = 478,
  [2128] = 476,
  [2129] = 2129,
  [2130] = 2130,
  [2131] = 2131,
  [2132] = 1918,
  [2133] = 2133,
  [2134] = 556,
  [2135] = 552,
  [2136] = 551,
  [2137] = 2068,
  [2138] = 472,
  [2139] = 549,
  [2140] = 2140,
  [2141] = 2120,
  [2142] = 1311,
  [2143] = 511,
  [2144] = 2144,
  [2145] = 508,
  [2146] = 2051,
  [2147] = 465,
  [2148] = 2148,
  [2149] = 1918,
  [2150] = 463,
  [2151] = 1968,
  [2152] = 507,
  [2153] = 1965,
  [2154] = 1968,
  [2155] = 1966,
  [2156] = 2156,
  [2157] = 1968,
  [2158] = 505,
  [2159] = 1673,
  [2160] = 2160,
  [2161] = 2161,
  [2162] = 2162,
  [2163] = 538,
  [2164] = 458,
  [2165] = 460,
  [2166] = 498,
  [2167] = 1958,
  [2168] = 503,
  [2169] = 1918,
  [2170] = 536,
  [2171] = 1509,
  [2172] = 462,
  [2173] = 2173,
  [2174] = 1968,
  [2175] = 533,
  [2176] = 490,
  [2177] = 468,
  [2178] = 493,
  [2179] = 532,
  [2180] = 469,
  [2181] = 524,
  [2182] = 1918,
  [2183] = 2183,
  [2184] = 2184,
  [2185] = 1664,
  [2186] = 2186,
  [2187] = 2187,
  [2188] = 2188,
  [2189] = 2189,
  [2190] = 2190,
  [2191] = 1962,
  [2192] = 2192,
  [2193] = 2193,
  [2194] = 2194,
  [2195] = 2195,
  [2196] = 2196,
  [2197] = 2197,
  [2198] = 2198,
  [2199] = 2199,
  [2200] = 2200,
  [2201] = 2201,
  [2202] = 2202,
  [2203] = 2203,
  [2204] = 2204,
  [2205] = 2205,
  [2206] = 2206,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 2209,
  [2210] = 2210,
  [2211] = 2211,
  [2212] = 2212,
  [2213] = 2213,
  [2214] = 2214,
  [2215] = 2215,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 2221,
  [2222] = 2222,
  [2223] = 2223,
  [2224] = 2224,
  [2225] = 2225,
  [2226] = 2226,
  [2227] = 2227,
  [2228] = 2228,
  [2229] = 2229,
  [2230] = 2230,
  [2231] = 2231,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2239,
  [2240] = 2240,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2243,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 2255,
  [2256] = 2243,
  [2257] = 2257,
  [2258] = 2258,
  [2259] = 2206,
  [2260] = 2241,
  [2261] = 2261,
  [2262] = 2243,
  [2263] = 2258,
  [2264] = 2264,
  [2265] = 2265,
  [2266] = 2266,
  [2267] = 2243,
  [2268] = 2268,
  [2269] = 2264,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2273,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2254,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 2219,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 2217,
  [2285] = 2285,
  [2286] = 2280,
  [2287] = 2220,
  [2288] = 2288,
  [2289] = 2236,
  [2290] = 2252,
  [2291] = 2291,
  [2292] = 2234,
  [2293] = 2293,
  [2294] = 2273,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 2288,
  [2298] = 2254,
  [2299] = 2203,
  [2300] = 2300,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2295,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2307,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2193,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2307,
  [2320] = 2320,
  [2321] = 2304,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2327,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2331,
  [2332] = 2188,
  [2333] = 2333,
  [2334] = 2310,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2338,
  [2339] = 2213,
  [2340] = 2340,
  [2341] = 2232,
  [2342] = 2336,
  [2343] = 2244,
  [2344] = 2246,
  [2345] = 2268,
  [2346] = 2247,
  [2347] = 2249,
  [2348] = 2348,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 2274,
  [2352] = 2352,
  [2353] = 2353,
  [2354] = 2353,
  [2355] = 2355,
  [2356] = 2356,
  [2357] = 2357,
  [2358] = 2328,
  [2359] = 1667,
  [2360] = 2360,
  [2361] = 2209,
  [2362] = 2362,
  [2363] = 2349,
  [2364] = 2313,
  [2365] = 2184,
  [2366] = 2233,
  [2367] = 2231,
  [2368] = 2315,
  [2369] = 2369,
  [2370] = 2370,
  [2371] = 2278,
  [2372] = 2285,
  [2373] = 2225,
  [2374] = 2224,
  [2375] = 2221,
  [2376] = 2216,
  [2377] = 2211,
  [2378] = 2378,
  [2379] = 2198,
  [2380] = 2192,
  [2381] = 2381,
  [2382] = 2196,
  [2383] = 2201,
  [2384] = 2384,
  [2385] = 2385,
  [2386] = 2348,
  [2387] = 2350,
  [2388] = 2355,
  [2389] = 2378,
  [2390] = 2340,
  [2391] = 2391,
  [2392] = 2392,
  [2393] = 2393,
  [2394] = 2381,
  [2395] = 2395,
  [2396] = 2396,
  [2397] = 2357,
  [2398] = 2398,
  [2399] = 2399,
  [2400] = 2312,
  [2401] = 2401,
  [2402] = 2402,
  [2403] = 2223,
  [2404] = 2404,
  [2405] = 2329,
  [2406] = 2244,
  [2407] = 2316,
  [2408] = 2227,
  [2409] = 2317,
  [2410] = 2229,
  [2411] = 2208,
  [2412] = 2412,
  [2413] = 2318,
  [2414] = 2320,
  [2415] = 2322,
  [2416] = 2197,
  [2417] = 2325,
  [2418] = 2398,
  [2419] = 2194,
  [2420] = 2326,
  [2421] = 2396,
  [2422] = 2186,
  [2423] = 1930,
  [2424] = 2187,
  [2425] = 2331,
  [2426] = 2254,
  [2427] = 2308,
  [2428] = 2251,
  [2429] = 2266,
  [2430] = 2430,
  [2431] = 2270,
  [2432] = 2306,
  [2433] = 2183,
  [2434] = 2362,
  [2435] = 2338,
  [2436] = 2436,
  [2437] = 2437,
  [2438] = 2335,
  [2439] = 2439,
  [2440] = 2337,
  [2441] = 2244,
  [2442] = 2333,
  [2443] = 2443,
  [2444] = 2293,
  [2445] = 2261,
  [2446] = 2291,
  [2447] = 2447,
  [2448] = 2448,
  [2449] = 2449,
  [2450] = 2450,
  [2451] = 2451,
  [2452] = 2452,
  [2453] = 2453,
  [2454] = 2454,
  [2455] = 2455,
  [2456] = 2456,
  [2457] = 2457,
  [2458] = 2458,
  [2459] = 2459,
  [2460] = 2450,
  [2461] = 2461,
  [2462] = 2462,
  [2463] = 2456,
  [2464] = 2464,
  [2465] = 2454,
  [2466] = 2466,
  [2467] = 2467,
  [2468] = 2468,
  [2469] = 2469,
  [2470] = 2470,
  [2471] = 2471,
  [2472] = 2472,
  [2473] = 2450,
  [2474] = 2474,
  [2475] = 2475,
  [2476] = 2476,
  [2477] = 2477,
  [2478] = 2478,
  [2479] = 2479,
  [2480] = 2480,
  [2481] = 2469,
  [2482] = 2482,
  [2483] = 2483,
  [2484] = 2484,
  [2485] = 2485,
  [2486] = 2486,
  [2487] = 2461,
  [2488] = 2488,
  [2489] = 2489,
  [2490] = 2490,
  [2491] = 2478,
  [2492] = 2488,
  [2493] = 2459,
  [2494] = 2494,
  [2495] = 2461,
  [2496] = 2462,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 2501,
  [2502] = 2459,
  [2503] = 2475,
  [2504] = 2504,
  [2505] = 2497,
  [2506] = 2506,
  [2507] = 2479,
  [2508] = 2508,
  [2509] = 2456,
  [2510] = 2454,
  [2511] = 2511,
  [2512] = 2512,
  [2513] = 2513,
  [2514] = 2514,
  [2515] = 2515,
  [2516] = 2464,
  [2517] = 2447,
  [2518] = 2489,
  [2519] = 2519,
  [2520] = 1995,
  [2521] = 2476,
  [2522] = 2455,
  [2523] = 2457,
  [2524] = 2458,
  [2525] = 2450,
  [2526] = 2526,
  [2527] = 2527,
  [2528] = 2528,
  [2529] = 2529,
  [2530] = 2530,
  [2531] = 2531,
  [2532] = 2469,
  [2533] = 2533,
  [2534] = 2458,
  [2535] = 2535,
  [2536] = 2457,
  [2537] = 2469,
  [2538] = 2538,
  [2539] = 2466,
  [2540] = 2469,
  [2541] = 2541,
  [2542] = 2455,
  [2543] = 2480,
  [2544] = 2514,
  [2545] = 2545,
  [2546] = 2546,
  [2547] = 2547,
  [2548] = 2484,
  [2549] = 2549,
  [2550] = 2515,
  [2551] = 2551,
  [2552] = 2552,
  [2553] = 2458,
  [2554] = 2457,
  [2555] = 2511,
  [2556] = 2455,
  [2557] = 2498,
  [2558] = 2551,
  [2559] = 2559,
  [2560] = 2538,
  [2561] = 2477,
  [2562] = 2562,
  [2563] = 2563,
  [2564] = 2564,
  [2565] = 2547,
  [2566] = 2545,
  [2567] = 2483,
  [2568] = 2535,
  [2569] = 2569,
  [2570] = 2533,
  [2571] = 2472,
  [2572] = 2485,
  [2573] = 2486,
  [2574] = 2499,
  [2575] = 2575,
  [2576] = 2466,
  [2577] = 2527,
  [2578] = 2578,
  [2579] = 2579,
  [2580] = 2458,
  [2581] = 2581,
  [2582] = 2466,
  [2583] = 2583,
  [2584] = 2584,
  [2585] = 2585,
  [2586] = 2586,
  [2587] = 2587,
  [2588] = 2480,
  [2589] = 2589,
  [2590] = 2590,
  [2591] = 2494,
  [2592] = 2592,
  [2593] = 2593,
  [2594] = 2594,
  [2595] = 2595,
  [2596] = 2454,
  [2597] = 2583,
  [2598] = 2448,
  [2599] = 2456,
  [2600] = 2500,
  [2601] = 2601,
  [2602] = 2459,
  [2603] = 2458,
  [2604] = 2461,
  [2605] = 2531,
  [2606] = 2606,
  [2607] = 2551,
  [2608] = 2458,
  [2609] = 2529,
  [2610] = 2458,
  [2611] = 2586,
  [2612] = 2578,
  [2613] = 2450,
  [2614] = 2614,
  [2615] = 2615,
  [2616] = 2545,
  [2617] = 2579,
  [2618] = 2584,
  [2619] = 2480,
  [2620] = 2494,
  [2621] = 2621,
  [2622] = 2484,
  [2623] = 2587,
  [2624] = 2448,
  [2625] = 2625,
  [2626] = 2626,
  [2627] = 2513,
  [2628] = 2458,
  [2629] = 2480,
  [2630] = 2452,
  [2631] = 2508,
  [2632] = 2458,
  [2633] = 2480,
  [2634] = 2634,
  [2635] = 2589,
  [2636] = 2615,
  [2637] = 2606,
  [2638] = 2593,
  [2639] = 2458,
  [2640] = 2452,
  [2641] = 2594,
  [2642] = 2480,
  [2643] = 2508,
  [2644] = 2575,
  [2645] = 2595,
  [2646] = 2559,
  [2647] = 2449,
  [2648] = 2494,
  [2649] = 2519,
  [2650] = 2512,
  [2651] = 2448,
  [2652] = 2606,
  [2653] = 2653,
  [2654] = 2559,
  [2655] = 2655,
  [2656] = 2606,
  [2657] = 2592,
  [2658] = 1971,
  [2659] = 2480,
  [2660] = 2458,
  [2661] = 2559,
  [2662] = 2458,
  [2663] = 2592,
  [2664] = 2664,
  [2665] = 2592,
  [2666] = 2590,
  [2667] = 2667,
  [2668] = 2590,
  [2669] = 2590,
};

static inline bool sym_escape_sequence_character_set_1(int32_t c) {
  return (c < 'e'
    ? (c < '\\'
      ? (c < '$'
        ? c == '"'
        : c <= '$')
      : (c <= '\\' || c == '`'))
    : (c <= 'f' || (c < 't'
      ? (c < 'r'
        ? c == 'n'
        : c <= 'r')
      : (c <= 't' || c == 'v'))));
}

static inline bool sym_name_character_set_1(int32_t c) {
  return (c < 161
    ? (c < '_'
      ? (c < 'A'
        ? (c >= '0' && c <= '9')
        : c <= 'Z')
      : (c <= '_' || (c < 128
        ? (c >= 'a' && c <= 'z')
        : c <= 159)))
    : (c <= 8202 || (c < 57344
      ? (c < 8289
        ? (c >= 8204 && c <= 8287)
        : c <= 55295)
      : (c <= 65278 || (c >= 65280 && c <= 65535)))));
}

static inline bool sym_name_character_set_2(int32_t c) {
  return (c < 161
    ? (c < 'a'
      ? (c < '_'
        ? (c >= 'A' && c <= 'Z')
        : c <= '_')
      : (c <= 'z' || (c >= 128 && c <= 159)))
    : (c <= 8202 || (c < 57344
      ? (c < 8289
        ? (c >= 8204 && c <= 8287)
        : c <= 55295)
      : (c <= 65278 || (c >= 65280 && c <= 65535)))));
}

static inline bool sym_name_character_set_3(int32_t c) {
  return (c < 161
    ? (c < '_'
      ? (c < 'B'
        ? (c >= '0' && c <= '9')
        : c <= 'Z')
      : (c <= '_' || (c < 128
        ? (c >= 'b' && c <= 'z')
        : c <= 159)))
    : (c <= 8202 || (c < 57344
      ? (c < 8289
        ? (c >= 8204 && c <= 8287)
        : c <= 55295)
      : (c <= 65278 || (c >= 65280 && c <= 65535)))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(76);
      if (lookahead == '!') ADVANCE(134);
      if (lookahead == '"') ADVANCE(184);
      if (lookahead == '#') ADVANCE(272);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '%') ADVANCE(226);
      if (lookahead == '&') ADVANCE(83);
      if (lookahead == '\'') ADVANCE(188);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == ')') ADVANCE(96);
      if (lookahead == '*') ADVANCE(221);
      if (lookahead == '+') ADVANCE(126);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '-') ADVANCE(129);
      if (lookahead == '.') ADVANCE(219);
      if (lookahead == '/') ADVANCE(224);
      if (lookahead == '0') ADVANCE(116);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(86);
      if (lookahead == '>') ADVANCE(208);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '@') ADVANCE(135);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(89);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '^') ADVANCE(198);
      if (lookahead == '_') ADVANCE(266);
      if (lookahead == '`') ADVANCE(189);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '|') ADVANCE(104);
      if (lookahead == '}') ADVANCE(91);
      if (lookahead == '~') ADVANCE(132);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(254);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(227);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(230);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(231);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(249);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(264);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(257);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(253);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(247);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(118);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(73)
      if (('C' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(269);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(269);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead != 0 &&
          lookahead != '>') ADVANCE(270);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(185);
      if (lookahead == '\r') ADVANCE(185);
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '\'') ADVANCE(167);
      if (lookahead == '-') ADVANCE(39);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '<') ADVANCE(44);
      if (lookahead == '?') ADVANCE(41);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '{') ADVANCE(90);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(4)
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(185);
      if (lookahead == '\r') ADVANCE(185);
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '\'') ADVANCE(167);
      if (lookahead == '-') ADVANCE(39);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '<') ADVANCE(44);
      if (lookahead == '?') ADVANCE(41);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(45);
      if (lookahead == '{') ADVANCE(90);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(4)
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(186);
      if (lookahead == '\r') ADVANCE(186);
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '/') ADVANCE(25);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(5)
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(134);
      if (lookahead == '"') ADVANCE(171);
      if (lookahead == '#') ADVANCE(272);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '%') ADVANCE(225);
      if (lookahead == '&') ADVANCE(82);
      if (lookahead == '\'') ADVANCE(167);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == ')') ADVANCE(96);
      if (lookahead == '*') ADVANCE(222);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '-') ADVANCE(128);
      if (lookahead == '.') ADVANCE(219);
      if (lookahead == '/') ADVANCE(223);
      if (lookahead == '0') ADVANCE(116);
      if (lookahead == ':') ADVANCE(92);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(38);
      if (lookahead == '>') ADVANCE(209);
      if (lookahead == '?') ADVANCE(102);
      if (lookahead == '@') ADVANCE(135);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '^') ADVANCE(197);
      if (lookahead == '_') ADVANCE(266);
      if (lookahead == '`') ADVANCE(189);
      if (lookahead == '|') ADVANCE(105);
      if (lookahead == '}') ADVANCE(91);
      if (lookahead == '~') ADVANCE(132);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(254);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(228);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(230);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(232);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(264);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(262);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(253);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(118);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('C' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(133);
      if (lookahead == '"') ADVANCE(171);
      if (lookahead == '#') ADVANCE(272);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '&') ADVANCE(81);
      if (lookahead == '\'') ADVANCE(167);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == ')') ADVANCE(96);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '-') ADVANCE(128);
      if (lookahead == '.') ADVANCE(112);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '0') ADVANCE(116);
      if (lookahead == '<') ADVANCE(33);
      if (lookahead == '@') ADVANCE(135);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '_') ADVANCE(266);
      if (lookahead == '`') ADVANCE(189);
      if (lookahead == '~') ADVANCE(132);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(254);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(228);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(230);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(232);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(264);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(262);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(253);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(118);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(7)
      if (('C' <= lookahead && lookahead <= 'Z') ||
          ('c' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(133);
      if (lookahead == '"') ADVANCE(171);
      if (lookahead == '#') ADVANCE(272);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '\'') ADVANCE(167);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == '-') ADVANCE(128);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '0') ADVANCE(116);
      if (lookahead == '<') ADVANCE(33);
      if (lookahead == '@') ADVANCE(135);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == '_') ADVANCE(266);
      if (lookahead == '`') ADVANCE(189);
      if (lookahead == '~') ADVANCE(132);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(254);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(227);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(230);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(231);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(249);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(264);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(257);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(253);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(247);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(118);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(8)
      if (('C' <= lookahead && lookahead <= 'Z') ||
          ('c' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '%') ADVANCE(225);
      if (lookahead == '&') ADVANCE(82);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == ')') ADVANCE(96);
      if (lookahead == '*') ADVANCE(222);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(218);
      if (lookahead == '/') ADVANCE(223);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(207);
      if (lookahead == '=') ADVANCE(38);
      if (lookahead == '>') ADVANCE(209);
      if (lookahead == '?') ADVANCE(101);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '^') ADVANCE(197);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '|') ADVANCE(105);
      if (lookahead == '}') ADVANCE(91);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(262);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '%') ADVANCE(226);
      if (lookahead == '&') ADVANCE(83);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == ')') ADVANCE(96);
      if (lookahead == '*') ADVANCE(221);
      if (lookahead == '+') ADVANCE(126);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '-') ADVANCE(129);
      if (lookahead == '.') ADVANCE(220);
      if (lookahead == '/') ADVANCE(224);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(206);
      if (lookahead == '=') ADVANCE(86);
      if (lookahead == '>') ADVANCE(208);
      if (lookahead == '?') ADVANCE(100);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '^') ADVANCE(198);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '|') ADVANCE(104);
      if (lookahead == '}') ADVANCE(91);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '%') ADVANCE(225);
      if (lookahead == '&') ADVANCE(82);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == ')') ADVANCE(96);
      if (lookahead == '*') ADVANCE(222);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(218);
      if (lookahead == '/') ADVANCE(223);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(207);
      if (lookahead == '=') ADVANCE(38);
      if (lookahead == '>') ADVANCE(209);
      if (lookahead == '?') ADVANCE(101);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '^') ADVANCE(197);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '|') ADVANCE(105);
      if (lookahead == '}') ADVANCE(91);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '%') ADVANCE(225);
      if (lookahead == '&') ADVANCE(82);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == ')') ADVANCE(96);
      if (lookahead == '*') ADVANCE(222);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(218);
      if (lookahead == '/') ADVANCE(223);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(207);
      if (lookahead == '=') ADVANCE(86);
      if (lookahead == '>') ADVANCE(209);
      if (lookahead == '?') ADVANCE(101);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '^') ADVANCE(197);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '|') ADVANCE(105);
      if (lookahead == '}') ADVANCE(91);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(37);
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '%') ADVANCE(225);
      if (lookahead == '&') ADVANCE(82);
      if (lookahead == ')') ADVANCE(96);
      if (lookahead == '*') ADVANCE(222);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(218);
      if (lookahead == '/') ADVANCE(223);
      if (lookahead == ':') ADVANCE(92);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(207);
      if (lookahead == '=') ADVANCE(38);
      if (lookahead == '>') ADVANCE(209);
      if (lookahead == '?') ADVANCE(102);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '^') ADVANCE(197);
      if (lookahead == '|') ADVANCE(105);
      if (lookahead == '}') ADVANCE(91);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(184);
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '&') ADVANCE(81);
      if (lookahead == '\'') ADVANCE(188);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '0') ADVANCE(121);
      if (lookahead == ':') ADVANCE(92);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '=') ADVANCE(40);
      if (lookahead == '?') ADVANCE(98);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '}') ADVANCE(91);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(22)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '\'') ADVANCE(172);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(171);
      if (lookahead == '#') ADVANCE(272);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '\'') ADVANCE(167);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '<') ADVANCE(33);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(254);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(228);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(262);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('C' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('c' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(171);
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '&') ADVANCE(81);
      if (lookahead == '\'') ADVANCE(167);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == ')') ADVANCE(96);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '-') ADVANCE(39);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '0') ADVANCE(121);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == '<') ADVANCE(33);
      if (lookahead == '?') ADVANCE(29);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '}') ADVANCE(91);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(254);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(228);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(262);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      if (('C' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('c' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(171);
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '\'') ADVANCE(167);
      if (lookahead == '-') ADVANCE(39);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '0') ADVANCE(116);
      if (lookahead == '<') ADVANCE(35);
      if (lookahead == '?') ADVANCE(41);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '_') ADVANCE(66);
      if (lookahead == '`') ADVANCE(189);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(15);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(48);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(49);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(59);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(56);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(118);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(171);
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '\'') ADVANCE(167);
      if (lookahead == '-') ADVANCE(39);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '0') ADVANCE(116);
      if (lookahead == '<') ADVANCE(35);
      if (lookahead == '?') ADVANCE(41);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(45);
      if (lookahead == '_') ADVANCE(66);
      if (lookahead == '`') ADVANCE(189);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(15);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(48);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(49);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(59);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(56);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(118);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      END_STATE();
    case 20:
      if (lookahead == '#') ADVANCE(272);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '&') ADVANCE(81);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == ')') ADVANCE(96);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '?') ADVANCE(98);
      if (lookahead == '\\') ADVANCE(88);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 21:
      if (lookahead == '#') ADVANCE(272);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '}') ADVANCE(91);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(262);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(21)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 22:
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '&') ADVANCE(81);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '0') ADVANCE(121);
      if (lookahead == ':') ADVANCE(92);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '=') ADVANCE(40);
      if (lookahead == '?') ADVANCE(98);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '}') ADVANCE(91);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(22)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 23:
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == ')') ADVANCE(96);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '-') ADVANCE(39);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == '?') ADVANCE(29);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == '{') ADVANCE(90);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(23)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 24:
      if (lookahead == '#') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(167);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead == '\\') ADVANCE(47);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(176);
      if (lookahead != 0) ADVANCE(182);
      END_STATE();
    case 25:
      if (lookahead == '*') ADVANCE(27);
      if (lookahead == '/') ADVANCE(270);
      END_STATE();
    case 26:
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead != 0) ADVANCE(27);
      END_STATE();
    case 27:
      if (lookahead == '*') ADVANCE(26);
      if (lookahead != 0) ADVANCE(27);
      END_STATE();
    case 28:
      if (lookahead == '*') ADVANCE(178);
      if (lookahead == '\'' ||
          lookahead == '\\') ADVANCE(27);
      if (lookahead != 0) ADVANCE(179);
      END_STATE();
    case 29:
      if (lookahead == '-') ADVANCE(42);
      END_STATE();
    case 30:
      if (lookahead == '.') ADVANCE(32);
      END_STATE();
    case 31:
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '_') ADVANCE(66);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(31);
      END_STATE();
    case 32:
      if (lookahead == '.') ADVANCE(97);
      END_STATE();
    case 33:
      if (lookahead == '<') ADVANCE(36);
      END_STATE();
    case 34:
      if (lookahead == '<') ADVANCE(36);
      if (lookahead == '?') ADVANCE(79);
      END_STATE();
    case 35:
      if (lookahead == '<') ADVANCE(36);
      if (lookahead == '?') ADVANCE(168);
      END_STATE();
    case 36:
      if (lookahead == '<') ADVANCE(183);
      END_STATE();
    case 37:
      if (lookahead == '=') ADVANCE(200);
      END_STATE();
    case 38:
      if (lookahead == '=') ADVANCE(199);
      if (lookahead == '>') ADVANCE(94);
      END_STATE();
    case 39:
      if (lookahead == '>') ADVANCE(152);
      END_STATE();
    case 40:
      if (lookahead == '>') ADVANCE(94);
      END_STATE();
    case 41:
      if (lookahead == '>') ADVANCE(169);
      END_STATE();
    case 42:
      if (lookahead == '>') ADVANCE(153);
      END_STATE();
    case 43:
      if (lookahead == '>') ADVANCE(77);
      END_STATE();
    case 44:
      if (lookahead == '?') ADVANCE(168);
      END_STATE();
    case 45:
      if (lookahead == 'u') ADVANCE(165);
      END_STATE();
    case 46:
      if (lookahead == '}') ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 47:
      if (lookahead == '\'' ||
          lookahead == '\\') ADVANCE(173);
      if (lookahead != 0) ADVANCE(182);
      END_STATE();
    case 48:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(115);
      END_STATE();
    case 49:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(52);
      END_STATE();
    case 50:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(158);
      END_STATE();
    case 51:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(55);
      END_STATE();
    case 52:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(57);
      END_STATE();
    case 53:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(156);
      END_STATE();
    case 54:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(53);
      END_STATE();
    case 55:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(78);
      END_STATE();
    case 56:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(58);
      END_STATE();
    case 57:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(50);
      END_STATE();
    case 58:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(50);
      END_STATE();
    case 59:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(54);
      END_STATE();
    case 60:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(119);
      END_STATE();
    case 61:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(117);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(122);
      END_STATE();
    case 63:
      if (sym_escape_sequence_character_set_1(lookahead)) ADVANCE(161);
      if (lookahead == 'u') ADVANCE(166);
      if (lookahead == 'x') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(163);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(118);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(113);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(31);
      END_STATE();
    case 67:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(115);
      END_STATE();
    case 68:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(123);
      END_STATE();
    case 69:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(120);
      END_STATE();
    case 70:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(164);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 72:
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(182);
      END_STATE();
    case 73:
      if (eof) ADVANCE(76);
      if (lookahead == '!') ADVANCE(134);
      if (lookahead == '"') ADVANCE(171);
      if (lookahead == '#') ADVANCE(272);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '%') ADVANCE(226);
      if (lookahead == '&') ADVANCE(83);
      if (lookahead == '\'') ADVANCE(167);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == ')') ADVANCE(96);
      if (lookahead == '*') ADVANCE(221);
      if (lookahead == '+') ADVANCE(126);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '-') ADVANCE(129);
      if (lookahead == '.') ADVANCE(219);
      if (lookahead == '/') ADVANCE(224);
      if (lookahead == '0') ADVANCE(116);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(86);
      if (lookahead == '>') ADVANCE(208);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '@') ADVANCE(135);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(89);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '^') ADVANCE(198);
      if (lookahead == '_') ADVANCE(266);
      if (lookahead == '`') ADVANCE(189);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '|') ADVANCE(104);
      if (lookahead == '}') ADVANCE(91);
      if (lookahead == '~') ADVANCE(132);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(254);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(227);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(230);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(231);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(249);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(264);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(257);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(253);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(247);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(118);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(73)
      if (('C' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 74:
      if (eof) ADVANCE(76);
      if (lookahead == '!') ADVANCE(133);
      if (lookahead == '"') ADVANCE(171);
      if (lookahead == '#') ADVANCE(272);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '&') ADVANCE(81);
      if (lookahead == '\'') ADVANCE(167);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == ')') ADVANCE(96);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '-') ADVANCE(128);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '0') ADVANCE(116);
      if (lookahead == ':') ADVANCE(92);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(34);
      if (lookahead == '=') ADVANCE(40);
      if (lookahead == '?') ADVANCE(43);
      if (lookahead == '@') ADVANCE(135);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '_') ADVANCE(266);
      if (lookahead == '`') ADVANCE(189);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '}') ADVANCE(91);
      if (lookahead == '~') ADVANCE(132);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(254);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(228);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(230);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(232);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(264);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(262);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(253);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(118);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(74)
      if (('C' <= lookahead && lookahead <= 'Z') ||
          ('c' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 75:
      if (eof) ADVANCE(76);
      if (lookahead == '"') ADVANCE(171);
      if (lookahead == '#') ADVANCE(273);
      if (lookahead == '$') ADVANCE(190);
      if (lookahead == '&') ADVANCE(81);
      if (lookahead == '\'') ADVANCE(167);
      if (lookahead == '(') ADVANCE(95);
      if (lookahead == ')') ADVANCE(96);
      if (lookahead == ',') ADVANCE(85);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '0') ADVANCE(121);
      if (lookahead == ':') ADVANCE(93);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '=') ADVANCE(87);
      if (lookahead == '?') ADVANCE(98);
      if (lookahead == '\\') ADVANCE(88);
      if (lookahead == ']') ADVANCE(155);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '|') ADVANCE(103);
      if (lookahead == '}') ADVANCE(91);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(262);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(75)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_QMARK_GT);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_php_tag);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_php_tag);
      if (lookahead == '=') ADVANCE(78);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(51);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(196);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(196);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(aux_sym_function_static_declaration_token1);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(199);
      if (lookahead == '>') ADVANCE(94);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(94);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (lookahead == '\'' ||
          lookahead == '\\') ADVANCE(173);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(136);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '-') ADVANCE(42);
      if (lookahead == '>') ADVANCE(169);
      if (lookahead == '?') ADVANCE(192);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '-') ADVANCE(42);
      if (lookahead == '?') ADVANCE(192);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '-') ADVANCE(42);
      if (lookahead == '?') ADVANCE(191);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(191);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(150);
      if (lookahead == '|') ADVANCE(195);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(195);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(aux_sym_cast_type_token1);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(aux_sym_cast_type_token3);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(aux_sym_cast_type_token6);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(aux_sym_cast_type_token8);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(aux_sym_cast_type_token11);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(aux_sym_cast_type_token12);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == '_') ADVANCE(65);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(113);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(65);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(113);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(267);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(114);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 159) ||
          (161 <= lookahead && lookahead <= 8202) ||
          (8204 <= lookahead && lookahead <= 8287) ||
          (8289 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65278) ||
          (65280 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(115);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '_') ADVANCE(61);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(60);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(48);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(122);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(69);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(117);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '_') ADVANCE(61);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(48);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(117);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '_') ADVANCE(64);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(118);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(60);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(119);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(120);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(62);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(60);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(122);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(122);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(122);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(123);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(138);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == '=') ADVANCE(143);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(137);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(137);
      if (lookahead == '=') ADVANCE(144);
      if (lookahead == '>') ADVANCE(152);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(137);
      if (lookahead == '>') ADVANCE(152);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(152);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(200);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_DOT_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_QMARK_DASH_GT);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym__argument_name_token1);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym__argument_name_token1);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym__argument_name_token2);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym__argument_name_token2);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACK);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(161);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(162);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(161);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_BSLASHu);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_BSLASHu);
      if (lookahead == '{') ADVANCE(71);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_LT_QMARK);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_QMARK_GT2);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym_encapsed_string_token1);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '\n') ADVANCE(182);
      if (lookahead == '\r') ADVANCE(175);
      if (lookahead == '>') ADVANCE(182);
      if (lookahead == '\\') ADVANCE(271);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(180);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '\n') ADVANCE(182);
      if (lookahead == '\\') ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(182);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '#') ADVANCE(181);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead == '\\') ADVANCE(47);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(176);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(182);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '*') ADVANCE(179);
      if (lookahead == '/') ADVANCE(180);
      if (lookahead == '\\') ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(182);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '*') ADVANCE(178);
      if (lookahead == '/') ADVANCE(182);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(179);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '*') ADVANCE(178);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '?') ADVANCE(174);
      if (lookahead == '\\') ADVANCE(271);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(180);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '\\') ADVANCE(271);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == '?' ||
          lookahead == '[') ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(180);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '\\') ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(182);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym__new_line);
      if (lookahead == '\n') ADVANCE(185);
      if (lookahead == '\r') ADVANCE(185);
      if (lookahead == '?') ADVANCE(41);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym__new_line);
      if (lookahead == '\n') ADVANCE(186);
      if (lookahead == '\r') ADVANCE(186);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_SQUOTE2);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(151);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(139);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(202);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(203);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(214);
      if (lookahead == '=') ADVANCE(210);
      if (lookahead == '>') ADVANCE(201);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(215);
      if (lookahead == '=') ADVANCE(210);
      if (lookahead == '>') ADVANCE(201);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(213);
      if (lookahead == '=') ADVANCE(210);
      if (lookahead == '>') ADVANCE(201);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(211);
      if (lookahead == '>') ADVANCE(217);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(211);
      if (lookahead == '>') ADVANCE(216);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(212);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '<') ADVANCE(183);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == '_') ADVANCE(65);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(113);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(194);
      if (lookahead == '=') ADVANCE(140);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(193);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=') ADVANCE(141);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(142);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '\'') ADVANCE(172);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(251);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '"') ADVANCE(170);
      if (lookahead == '\'') ADVANCE(172);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '_') ADVANCE(266);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(230);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(229);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 159) ||
          (161 <= lookahead && lookahead <= 8202) ||
          (8204 <= lookahead && lookahead <= 8287) ||
          (8289 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65278) ||
          (65280 <= lookahead && lookahead <= 65535)) ADVANCE(268);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(114);
      if (sym_name_character_set_2(lookahead)) ADVANCE(268);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(246);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(250);
      if (sym_name_character_set_3(lookahead)) ADVANCE(268);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(246);
      if (sym_name_character_set_3(lookahead)) ADVANCE(268);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(265);
      if (sym_name_character_set_3(lookahead)) ADVANCE(268);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(261);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(242);
      if (sym_name_character_set_3(lookahead)) ADVANCE(268);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(261);
      if (sym_name_character_set_3(lookahead)) ADVANCE(268);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(259);
      if (sym_name_character_set_3(lookahead)) ADVANCE(268);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(84);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(159);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(260);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(110);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(237);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(248);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(107);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(157);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(244);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(255);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(256);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(240);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(258);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(236);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(243);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(233);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(263);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(252);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(238);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(239);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(234);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(108);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(109);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(111);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(241);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(235);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(238);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(245);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(106);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_name);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(229);
      if (sym_name_character_set_2(lookahead)) ADVANCE(268);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_name);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(114);
      if (sym_name_character_set_2(lookahead)) ADVANCE(268);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_name);
      if (sym_name_character_set_1(lookahead)) ADVANCE(268);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '?') ADVANCE(2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(270);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '?') ADVANCE(174);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(182);
      if (lookahead == '\'' ||
          lookahead == '\\') ADVANCE(270);
      if (lookahead != 0) ADVANCE(180);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '[') ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '?') ADVANCE(270);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '?' &&
          lookahead != '[') ADVANCE(270);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'A') ADVANCE(1);
      if (lookahead == 'B') ADVANCE(2);
      if (lookahead == 'E') ADVANCE(3);
      if (lookahead == 'F') ADVANCE(4);
      if (lookahead == 'I') ADVANCE(5);
      if (lookahead == 'M') ADVANCE(6);
      if (lookahead == 'N') ADVANCE(7);
      if (lookahead == 'P') ADVANCE(8);
      if (lookahead == 'S') ADVANCE(9);
      if (lookahead == 'T') ADVANCE(10);
      if (lookahead == 'U') ADVANCE(11);
      if (lookahead == 'V') ADVANCE(12);
      if (lookahead == 'a') ADVANCE(13);
      if (lookahead == 'b') ADVANCE(14);
      if (lookahead == 'e') ADVANCE(15);
      if (lookahead == 'f') ADVANCE(16);
      if (lookahead == 'i') ADVANCE(17);
      if (lookahead == 'm') ADVANCE(18);
      if (lookahead == 'n') ADVANCE(19);
      if (lookahead == 'p') ADVANCE(20);
      if (lookahead == 's') ADVANCE(21);
      if (lookahead == 't') ADVANCE(22);
      if (lookahead == 'u') ADVANCE(23);
      if (lookahead == 'v') ADVANCE(24);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(25);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(26);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(28);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(29);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(30);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(31);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(32);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(33);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(34);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(35);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(36);
      END_STATE();
    case 2:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(37);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(38);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(39);
      END_STATE();
    case 3:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(40);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(41);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(42);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(43);
      END_STATE();
    case 4:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(44);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(45);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(46);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(47);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 5:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(49);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(50);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(51);
      END_STATE();
    case 6:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(52);
      END_STATE();
    case 7:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(53);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(54);
      END_STATE();
    case 8:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(55);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(56);
      END_STATE();
    case 9:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(57);
      END_STATE();
    case 10:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(58);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(59);
      END_STATE();
    case 11:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(60);
      END_STATE();
    case 12:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(61);
      END_STATE();
    case 13:
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(34);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(35);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(36);
      END_STATE();
    case 14:
      if (lookahead == 'O') ADVANCE(38);
      if (lookahead == 'o') ADVANCE(63);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(37);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(39);
      END_STATE();
    case 15:
      if (lookahead == 'N') ADVANCE(42);
      if (lookahead == 'n') ADVANCE(64);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(40);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(41);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(43);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(65);
      if (lookahead == 'l') ADVANCE(66);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(44);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(45);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(46);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(47);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 17:
      if (lookahead == 'N') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(67);
      if (lookahead == 't') ADVANCE(68);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(49);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(50);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(69);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(52);
      END_STATE();
    case 19:
      if (lookahead == 'E') ADVANCE(54);
      if (lookahead == 'e') ADVANCE(70);
      if (lookahead == 'u') ADVANCE(71);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(53);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(72);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(55);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(56);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(73);
      if (lookahead == 't') ADVANCE(74);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(57);
      END_STATE();
    case 22:
      if (lookahead == 'R') ADVANCE(59);
      if (lookahead == 'i') ADVANCE(75);
      if (lookahead == 'r') ADVANCE(76);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(58);
      END_STATE();
    case 23:
      if (lookahead == 'n') ADVANCE(77);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(60);
      END_STATE();
    case 24:
      if (lookahead == 'o') ADVANCE(78);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(61);
      END_STATE();
    case 25:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(79);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(80);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(81);
      END_STATE();
    case 26:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(82);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(83);
      END_STATE();
    case 27:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(84);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(85);
      END_STATE();
    case 28:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(86);
      END_STATE();
    case 29:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(87);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(88);
      END_STATE();
    case 30:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(89);
      END_STATE();
    case 31:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(90);
      END_STATE();
    case 32:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(91);
      END_STATE();
    case 33:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(92);
      END_STATE();
    case 34:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(93);
      END_STATE();
    case 35:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(94);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(aux_sym_namespace_aliasing_clause_token1);
      END_STATE();
    case 37:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(95);
      END_STATE();
    case 38:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 39:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 40:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(98);
      END_STATE();
    case 41:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(99);
      END_STATE();
    case 42:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(100);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(101);
      END_STATE();
    case 43:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(102);
      END_STATE();
    case 44:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(103);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(aux_sym__arrow_function_header_token1);
      END_STATE();
    case 46:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(104);
      END_STATE();
    case 47:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(105);
      END_STATE();
    case 48:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(106);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(aux_sym_if_statement_token1);
      END_STATE();
    case 50:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(107);
      END_STATE();
    case 51:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(108);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(109);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(110);
      END_STATE();
    case 52:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(111);
      END_STATE();
    case 53:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(112);
      END_STATE();
    case 54:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(113);
      END_STATE();
    case 55:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(114);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(115);
      END_STATE();
    case 56:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(116);
      END_STATE();
    case 57:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 58:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(118);
      END_STATE();
    case 59:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(119);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(120);
      END_STATE();
    case 60:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 61:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(122);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 63:
      if (lookahead == 'O') ADVANCE(96);
      if (lookahead == 'o') ADVANCE(124);
      END_STATE();
    case 64:
      if (lookahead == 'c') ADVANCE(125);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(100);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(101);
      END_STATE();
    case 65:
      if (lookahead == 'l') ADVANCE(126);
      END_STATE();
    case 66:
      if (lookahead == 'o') ADVANCE(127);
      END_STATE();
    case 67:
      if (lookahead == 'T') ADVANCE(110);
      if (lookahead == 't') ADVANCE(128);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(108);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(109);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(129);
      END_STATE();
    case 69:
      if (lookahead == 'x') ADVANCE(130);
      END_STATE();
    case 70:
      if (lookahead == 'v') ADVANCE(131);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(113);
      END_STATE();
    case 71:
      if (lookahead == 'l') ADVANCE(132);
      END_STATE();
    case 72:
      if (lookahead == 'r') ADVANCE(133);
      END_STATE();
    case 73:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 74:
      if (lookahead == 'a') ADVANCE(135);
      if (lookahead == 'r') ADVANCE(136);
      END_STATE();
    case 75:
      if (lookahead == 'c') ADVANCE(137);
      END_STATE();
    case 76:
      if (lookahead == 'u') ADVANCE(138);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(119);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(120);
      END_STATE();
    case 77:
      if (lookahead == 's') ADVANCE(139);
      END_STATE();
    case 78:
      if (lookahead == 'i') ADVANCE(140);
      END_STATE();
    case 79:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(141);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(142);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(143);
      END_STATE();
    case 80:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(144);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(145);
      END_STATE();
    case 81:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(146);
      END_STATE();
    case 82:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(147);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(aux_sym_do_statement_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(149);
      END_STATE();
    case 84:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(150);
      END_STATE();
    case 85:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(151);
      END_STATE();
    case 86:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(152);
      END_STATE();
    case 87:
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(153);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(aux_sym_binary_expression_token3);
      END_STATE();
    case 89:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(154);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(155);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(156);
      END_STATE();
    case 90:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(157);
      END_STATE();
    case 91:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(158);
      END_STATE();
    case 92:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 93:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(160);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym_binary_expression_token2);
      END_STATE();
    case 95:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(161);
      END_STATE();
    case 96:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(162);
      END_STATE();
    case 97:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(163);
      END_STATE();
    case 98:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(164);
      END_STATE();
    case 99:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(165);
      END_STATE();
    case 100:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(166);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(167);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(168);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(169);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(170);
      END_STATE();
    case 101:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(171);
      END_STATE();
    case 102:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 103:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(173);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(aux_sym_for_statement_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(174);
      END_STATE();
    case 105:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(175);
      END_STATE();
    case 106:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(176);
      END_STATE();
    case 107:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(177);
      END_STATE();
    case 108:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(178);
      END_STATE();
    case 109:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(179);
      END_STATE();
    case 110:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 111:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(181);
      END_STATE();
    case 112:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(aux_sym_object_creation_expression_token1);
      END_STATE();
    case 114:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(183);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(184);
      END_STATE();
    case 115:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(185);
      END_STATE();
    case 116:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(186);
      END_STATE();
    case 117:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(187);
      END_STATE();
    case 118:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(188);
      END_STATE();
    case 119:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(189);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(aux_sym_try_statement_token1);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(aux_sym_namespace_use_declaration_token1);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_var_modifier);
      END_STATE();
    case 123:
      if (lookahead == 'a') ADVANCE(190);
      END_STATE();
    case 124:
      if (lookahead == 'L') ADVANCE(162);
      if (lookahead == 'l') ADVANCE(191);
      END_STATE();
    case 125:
      if (lookahead == 'o') ADVANCE(192);
      END_STATE();
    case 126:
      if (lookahead == 's') ADVANCE(193);
      END_STATE();
    case 127:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 129:
      if (lookahead == 'r') ADVANCE(195);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(196);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(197);
      END_STATE();
    case 132:
      if (lookahead == 'l') ADVANCE(198);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 134:
      if (lookahead == 'f') ADVANCE(200);
      END_STATE();
    case 135:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 136:
      if (lookahead == 'i') ADVANCE(202);
      END_STATE();
    case 137:
      if (lookahead == 'k') ADVANCE(203);
      END_STATE();
    case 138:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 139:
      if (lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 140:
      if (lookahead == 'd') ADVANCE(206);
      END_STATE();
    case 141:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(207);
      END_STATE();
    case 142:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(208);
      END_STATE();
    case 143:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(209);
      END_STATE();
    case 144:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(210);
      END_STATE();
    case 145:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(211);
      END_STATE();
    case 146:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(212);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(213);
      END_STATE();
    case 147:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(214);
      END_STATE();
    case 148:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(215);
      END_STATE();
    case 149:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(216);
      END_STATE();
    case 150:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(217);
      END_STATE();
    case 151:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(218);
      END_STATE();
    case 152:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(219);
      END_STATE();
    case 153:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(220);
      END_STATE();
    case 154:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(221);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(222);
      END_STATE();
    case 155:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(223);
      END_STATE();
    case 156:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(224);
      END_STATE();
    case 157:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(225);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_binary_expression_token4);
      END_STATE();
    case 159:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(226);
      END_STATE();
    case 160:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(227);
      END_STATE();
    case 161:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(228);
      END_STATE();
    case 162:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(229);
      END_STATE();
    case 163:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(230);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_echo_statement_token1);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_else_clause_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(231);
      END_STATE();
    case 166:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(232);
      END_STATE();
    case 167:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(233);
      END_STATE();
    case 168:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(234);
      END_STATE();
    case 169:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(235);
      END_STATE();
    case 170:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(236);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym_enum_declaration_token1);
      END_STATE();
    case 172:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(237);
      END_STATE();
    case 173:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(238);
      END_STATE();
    case 174:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(239);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym_yield_expression_token2);
      END_STATE();
    case 176:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(240);
      END_STATE();
    case 177:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 178:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(242);
      END_STATE();
    case 179:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(243);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 180:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(245);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(246);
      END_STATE();
    case 181:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(247);
      END_STATE();
    case 182:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(248);
      END_STATE();
    case 183:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(249);
      END_STATE();
    case 184:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(250);
      END_STATE();
    case 185:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(251);
      END_STATE();
    case 186:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(252);
      END_STATE();
    case 187:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(253);
      END_STATE();
    case 188:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(254);
      END_STATE();
    case 189:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(255);
      END_STATE();
    case 190:
      if (lookahead == 'y') ADVANCE(256);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_bool);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(229);
      END_STATE();
    case 192:
      if (lookahead == 'd') ADVANCE(257);
      END_STATE();
    case 193:
      if (lookahead == 'e') ADVANCE(258);
      END_STATE();
    case 194:
      if (lookahead == 't') ADVANCE(259);
      END_STATE();
    case 195:
      if (lookahead == 'a') ADVANCE(260);
      END_STATE();
    case 196:
      if (lookahead == 'd') ADVANCE(261);
      END_STATE();
    case 197:
      if (lookahead == 'r') ADVANCE(262);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_null);
      END_STATE();
    case 199:
      if (lookahead == 'n') ADVANCE(263);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_self);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(264);
      END_STATE();
    case 202:
      if (lookahead == 'c') ADVANCE(265);
      if (lookahead == 'n') ADVANCE(266);
      END_STATE();
    case 203:
      if (lookahead == 's') ADVANCE(267);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 205:
      if (lookahead == 't') ADVANCE(268);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 207:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(269);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(aux_sym_enum_case_token1);
      END_STATE();
    case 209:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(270);
      END_STATE();
    case 210:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(271);
      END_STATE();
    case 211:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 212:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(273);
      END_STATE();
    case 213:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(274);
      END_STATE();
    case 214:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(275);
      END_STATE();
    case 215:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(276);
      END_STATE();
    case 216:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(277);
      END_STATE();
    case 217:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(278);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(aux_sym_goto_statement_token1);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(aux_sym__list_destructing_token1);
      END_STATE();
    case 220:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(279);
      END_STATE();
    case 221:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(280);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(aux_sym_cast_type_token10);
      END_STATE();
    case 223:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(281);
      END_STATE();
    case 224:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(282);
      END_STATE();
    case 225:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(283);
      END_STATE();
    case 226:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(284);
      END_STATE();
    case 227:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(285);
      END_STATE();
    case 228:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(286);
      END_STATE();
    case 229:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(287);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(aux_sym_break_statement_token1);
      END_STATE();
    case 231:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(288);
      END_STATE();
    case 232:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(289);
      END_STATE();
    case 233:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(290);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(aux_sym_if_statement_token2);
      END_STATE();
    case 235:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(291);
      END_STATE();
    case 236:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(292);
      END_STATE();
    case 237:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(293);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(aux_sym_final_modifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(294);
      END_STATE();
    case 239:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(295);
      END_STATE();
    case 240:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(296);
      END_STATE();
    case 241:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(297);
      END_STATE();
    case 242:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(298);
      END_STATE();
    case 243:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(299);
      END_STATE();
    case 244:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(300);
      END_STATE();
    case 245:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(301);
      END_STATE();
    case 246:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(302);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(aux_sym_match_expression_token1);
      END_STATE();
    case 248:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(303);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(aux_sym_print_intrinsic_token1);
      END_STATE();
    case 250:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(304);
      END_STATE();
    case 251:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(305);
      END_STATE();
    case 252:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(306);
      END_STATE();
    case 253:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(307);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(aux_sym_throw_expression_token1);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(aux_sym_trait_declaration_token1);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_array);
      END_STATE();
    case 257:
      if (lookahead == 'i') ADVANCE(308);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 260:
      if (lookahead == 'b') ADVANCE(309);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_mixed);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_bottom_type);
      END_STATE();
    case 263:
      if (lookahead == 't') ADVANCE(310);
      END_STATE();
    case 264:
      if (lookahead == 'c') ADVANCE(311);
      END_STATE();
    case 265:
      if (lookahead == 't') ADVANCE(312);
      END_STATE();
    case 266:
      if (lookahead == 'g') ADVANCE(313);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_ticks);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_unset);
      END_STATE();
    case 269:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(314);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(aux_sym_catch_clause_token1);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(aux_sym_class_declaration_token1);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(aux_sym_clone_expression_token1);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(aux_sym_namespace_use_declaration_token3);
      END_STATE();
    case 274:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(315);
      END_STATE();
    case 275:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(316);
      END_STATE();
    case 276:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(317);
      END_STATE();
    case 277:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(318);
      END_STATE();
    case 278:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(319);
      END_STATE();
    case 279:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(320);
      END_STATE();
    case 280:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(321);
      END_STATE();
    case 281:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(322);
      END_STATE();
    case 282:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(323);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(aux_sym_while_statement_token1);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(aux_sym_yield_expression_token1);
      END_STATE();
    case 285:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(324);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(aux_sym_cast_type_token2);
      END_STATE();
    case 287:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(aux_sym_else_if_clause_token1);
      END_STATE();
    case 289:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(326);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(aux_sym_for_statement_token2);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(327);
      END_STATE();
    case 291:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(328);
      END_STATE();
    case 292:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(329);
      END_STATE();
    case 293:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(330);
      END_STATE();
    case 294:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(331);
      END_STATE();
    case 295:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(332);
      END_STATE();
    case 296:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(333);
      END_STATE();
    case 297:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(334);
      END_STATE();
    case 298:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(335);
      END_STATE();
    case 299:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(336);
      END_STATE();
    case 300:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(337);
      END_STATE();
    case 301:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(338);
      END_STATE();
    case 302:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(339);
      END_STATE();
    case 303:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(340);
      END_STATE();
    case 304:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(341);
      END_STATE();
    case 305:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(342);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(aux_sym_visibility_modifier_token1);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(aux_sym_switch_statement_token1);
      END_STATE();
    case 308:
      if (lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 309:
      if (lookahead == 'l') ADVANCE(344);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_parent);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 312:
      if (lookahead == '_') ADVANCE(345);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 314:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(346);
      END_STATE();
    case 315:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(347);
      END_STATE();
    case 316:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(348);
      END_STATE();
    case 317:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(349);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(aux_sym_cast_type_token5);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(aux_sym_global_declaration_token1);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(aux_sym_cast_type_token9);
      END_STATE();
    case 321:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(350);
      END_STATE();
    case 322:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(351);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(aux_sym_return_statement_token1);
      END_STATE();
    case 324:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(352);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(aux_sym_cast_type_token4);
      END_STATE();
    case 326:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(353);
      END_STATE();
    case 327:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(354);
      END_STATE();
    case 328:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(355);
      END_STATE();
    case 329:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(356);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(aux_sym_base_clause_token1);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(aux_sym_finally_clause_token1);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(aux_sym_foreach_statement_token1);
      END_STATE();
    case 333:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(357);
      END_STATE();
    case 334:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(358);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(aux_sym_include_expression_token1);
      if (lookahead == '_') ADVANCE(359);
      END_STATE();
    case 336:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(360);
      END_STATE();
    case 337:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(361);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(aux_sym_cast_type_token7);
      END_STATE();
    case 339:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(362);
      END_STATE();
    case 340:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(363);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(aux_sym_visibility_modifier_token3);
      END_STATE();
    case 342:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(364);
      END_STATE();
    case 343:
      if (lookahead == 'g') ADVANCE(365);
      END_STATE();
    case 344:
      if (lookahead == 'e') ADVANCE(366);
      END_STATE();
    case 345:
      if (lookahead == 't') ADVANCE(367);
      END_STATE();
    case 346:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(368);
      END_STATE();
    case 347:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(369);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(aux_sym_declare_statement_token1);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(aux_sym_match_default_expression_token1);
      END_STATE();
    case 350:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(370);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(aux_sym_require_expression_token1);
      if (lookahead == '_') ADVANCE(371);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(aux_sym_abstract_modifier_token1);
      END_STATE();
    case 353:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(372);
      END_STATE();
    case 354:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(373);
      END_STATE();
    case 355:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(374);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(aux_sym_while_statement_token2);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(aux_sym_namespace_use_declaration_token2);
      END_STATE();
    case 358:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(375);
      END_STATE();
    case 359:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(376);
      END_STATE();
    case 360:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(377);
      END_STATE();
    case 361:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(378);
      END_STATE();
    case 362:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(379);
      END_STATE();
    case 363:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(380);
      END_STATE();
    case 364:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(381);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_encoding);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_iterable);
      END_STATE();
    case 367:
      if (lookahead == 'y') ADVANCE(382);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(aux_sym_primitive_type_token1);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(aux_sym_continue_statement_token1);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(aux_sym_readonly_modifier_token1);
      END_STATE();
    case 371:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(383);
      END_STATE();
    case 372:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(384);
      END_STATE();
    case 373:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(385);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(aux_sym_switch_block_token1);
      END_STATE();
    case 375:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(386);
      END_STATE();
    case 376:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(387);
      END_STATE();
    case 377:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(388);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(aux_sym_use_instead_of_clause_token1);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(aux_sym_interface_declaration_token1);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(aux_sym_namespace_definition_token1);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(aux_sym_visibility_modifier_token2);
      END_STATE();
    case 382:
      if (lookahead == 'p') ADVANCE(389);
      END_STATE();
    case 383:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(390);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(aux_sym_declare_statement_token2);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(aux_sym_foreach_statement_token2);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(aux_sym_class_interface_clause_token1);
      END_STATE();
    case 387:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(391);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(aux_sym_binary_expression_token1);
      END_STATE();
    case 389:
      if (lookahead == 'e') ADVANCE(392);
      END_STATE();
    case 390:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(393);
      END_STATE();
    case 391:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(394);
      END_STATE();
    case 392:
      if (lookahead == 's') ADVANCE(395);
      END_STATE();
    case 393:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(396);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(aux_sym_include_once_expression_token1);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_strict_types);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(aux_sym_require_once_expression_token1);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 74},
  [2] = {.lex_state = 74},
  [3] = {.lex_state = 74},
  [4] = {.lex_state = 74},
  [5] = {.lex_state = 74},
  [6] = {.lex_state = 74},
  [7] = {.lex_state = 74},
  [8] = {.lex_state = 74},
  [9] = {.lex_state = 74},
  [10] = {.lex_state = 74},
  [11] = {.lex_state = 74},
  [12] = {.lex_state = 74, .external_lex_state = 2},
  [13] = {.lex_state = 74},
  [14] = {.lex_state = 74},
  [15] = {.lex_state = 74},
  [16] = {.lex_state = 74, .external_lex_state = 2},
  [17] = {.lex_state = 74, .external_lex_state = 2},
  [18] = {.lex_state = 74, .external_lex_state = 2},
  [19] = {.lex_state = 74},
  [20] = {.lex_state = 74, .external_lex_state = 2},
  [21] = {.lex_state = 74},
  [22] = {.lex_state = 74, .external_lex_state = 2},
  [23] = {.lex_state = 74, .external_lex_state = 2},
  [24] = {.lex_state = 74, .external_lex_state = 2},
  [25] = {.lex_state = 74},
  [26] = {.lex_state = 74, .external_lex_state = 2},
  [27] = {.lex_state = 74, .external_lex_state = 2},
  [28] = {.lex_state = 74, .external_lex_state = 2},
  [29] = {.lex_state = 74},
  [30] = {.lex_state = 74},
  [31] = {.lex_state = 74, .external_lex_state = 2},
  [32] = {.lex_state = 74, .external_lex_state = 2},
  [33] = {.lex_state = 74},
  [34] = {.lex_state = 74},
  [35] = {.lex_state = 74},
  [36] = {.lex_state = 74, .external_lex_state = 2},
  [37] = {.lex_state = 74},
  [38] = {.lex_state = 74},
  [39] = {.lex_state = 74, .external_lex_state = 2},
  [40] = {.lex_state = 74},
  [41] = {.lex_state = 74},
  [42] = {.lex_state = 74},
  [43] = {.lex_state = 74},
  [44] = {.lex_state = 74},
  [45] = {.lex_state = 74, .external_lex_state = 2},
  [46] = {.lex_state = 74},
  [47] = {.lex_state = 74, .external_lex_state = 2},
  [48] = {.lex_state = 74},
  [49] = {.lex_state = 74},
  [50] = {.lex_state = 74},
  [51] = {.lex_state = 74},
  [52] = {.lex_state = 74},
  [53] = {.lex_state = 74},
  [54] = {.lex_state = 74, .external_lex_state = 2},
  [55] = {.lex_state = 74},
  [56] = {.lex_state = 74, .external_lex_state = 2},
  [57] = {.lex_state = 74},
  [58] = {.lex_state = 74, .external_lex_state = 2},
  [59] = {.lex_state = 74, .external_lex_state = 2},
  [60] = {.lex_state = 74},
  [61] = {.lex_state = 74},
  [62] = {.lex_state = 74},
  [63] = {.lex_state = 74},
  [64] = {.lex_state = 74},
  [65] = {.lex_state = 74},
  [66] = {.lex_state = 74},
  [67] = {.lex_state = 74, .external_lex_state = 2},
  [68] = {.lex_state = 74},
  [69] = {.lex_state = 74, .external_lex_state = 2},
  [70] = {.lex_state = 74},
  [71] = {.lex_state = 74},
  [72] = {.lex_state = 74, .external_lex_state = 2},
  [73] = {.lex_state = 74},
  [74] = {.lex_state = 74},
  [75] = {.lex_state = 74},
  [76] = {.lex_state = 74},
  [77] = {.lex_state = 74},
  [78] = {.lex_state = 74},
  [79] = {.lex_state = 74},
  [80] = {.lex_state = 74},
  [81] = {.lex_state = 74},
  [82] = {.lex_state = 74},
  [83] = {.lex_state = 74},
  [84] = {.lex_state = 74},
  [85] = {.lex_state = 6},
  [86] = {.lex_state = 6},
  [87] = {.lex_state = 6, .external_lex_state = 2},
  [88] = {.lex_state = 6},
  [89] = {.lex_state = 8},
  [90] = {.lex_state = 8},
  [91] = {.lex_state = 8},
  [92] = {.lex_state = 8},
  [93] = {.lex_state = 8},
  [94] = {.lex_state = 8},
  [95] = {.lex_state = 8},
  [96] = {.lex_state = 8},
  [97] = {.lex_state = 8},
  [98] = {.lex_state = 8},
  [99] = {.lex_state = 8},
  [100] = {.lex_state = 7},
  [101] = {.lex_state = 7},
  [102] = {.lex_state = 7},
  [103] = {.lex_state = 7},
  [104] = {.lex_state = 7},
  [105] = {.lex_state = 7},
  [106] = {.lex_state = 7},
  [107] = {.lex_state = 7},
  [108] = {.lex_state = 7},
  [109] = {.lex_state = 7},
  [110] = {.lex_state = 7},
  [111] = {.lex_state = 7},
  [112] = {.lex_state = 7},
  [113] = {.lex_state = 7},
  [114] = {.lex_state = 7},
  [115] = {.lex_state = 7},
  [116] = {.lex_state = 7},
  [117] = {.lex_state = 7},
  [118] = {.lex_state = 7},
  [119] = {.lex_state = 7},
  [120] = {.lex_state = 7},
  [121] = {.lex_state = 7},
  [122] = {.lex_state = 7},
  [123] = {.lex_state = 7},
  [124] = {.lex_state = 7},
  [125] = {.lex_state = 7},
  [126] = {.lex_state = 7},
  [127] = {.lex_state = 7},
  [128] = {.lex_state = 7},
  [129] = {.lex_state = 7},
  [130] = {.lex_state = 7},
  [131] = {.lex_state = 7},
  [132] = {.lex_state = 7},
  [133] = {.lex_state = 74},
  [134] = {.lex_state = 7},
  [135] = {.lex_state = 7},
  [136] = {.lex_state = 7},
  [137] = {.lex_state = 7},
  [138] = {.lex_state = 7},
  [139] = {.lex_state = 7},
  [140] = {.lex_state = 7},
  [141] = {.lex_state = 7},
  [142] = {.lex_state = 74},
  [143] = {.lex_state = 7},
  [144] = {.lex_state = 74},
  [145] = {.lex_state = 7},
  [146] = {.lex_state = 74},
  [147] = {.lex_state = 74},
  [148] = {.lex_state = 74},
  [149] = {.lex_state = 7},
  [150] = {.lex_state = 74},
  [151] = {.lex_state = 74},
  [152] = {.lex_state = 74},
  [153] = {.lex_state = 74},
  [154] = {.lex_state = 74},
  [155] = {.lex_state = 74},
  [156] = {.lex_state = 7},
  [157] = {.lex_state = 74},
  [158] = {.lex_state = 74},
  [159] = {.lex_state = 74},
  [160] = {.lex_state = 74},
  [161] = {.lex_state = 74},
  [162] = {.lex_state = 74},
  [163] = {.lex_state = 74},
  [164] = {.lex_state = 74},
  [165] = {.lex_state = 74},
  [166] = {.lex_state = 74},
  [167] = {.lex_state = 74},
  [168] = {.lex_state = 74},
  [169] = {.lex_state = 74},
  [170] = {.lex_state = 74},
  [171] = {.lex_state = 74},
  [172] = {.lex_state = 74},
  [173] = {.lex_state = 74},
  [174] = {.lex_state = 74},
  [175] = {.lex_state = 74},
  [176] = {.lex_state = 74},
  [177] = {.lex_state = 74},
  [178] = {.lex_state = 74},
  [179] = {.lex_state = 74},
  [180] = {.lex_state = 74},
  [181] = {.lex_state = 74},
  [182] = {.lex_state = 74},
  [183] = {.lex_state = 74},
  [184] = {.lex_state = 74},
  [185] = {.lex_state = 7},
  [186] = {.lex_state = 74},
  [187] = {.lex_state = 74},
  [188] = {.lex_state = 74},
  [189] = {.lex_state = 7},
  [190] = {.lex_state = 74, .external_lex_state = 2},
  [191] = {.lex_state = 74},
  [192] = {.lex_state = 74},
  [193] = {.lex_state = 74},
  [194] = {.lex_state = 74},
  [195] = {.lex_state = 74},
  [196] = {.lex_state = 74},
  [197] = {.lex_state = 74, .external_lex_state = 2},
  [198] = {.lex_state = 74},
  [199] = {.lex_state = 74, .external_lex_state = 2},
  [200] = {.lex_state = 74, .external_lex_state = 2},
  [201] = {.lex_state = 74, .external_lex_state = 2},
  [202] = {.lex_state = 74, .external_lex_state = 2},
  [203] = {.lex_state = 74},
  [204] = {.lex_state = 74},
  [205] = {.lex_state = 74},
  [206] = {.lex_state = 74},
  [207] = {.lex_state = 74},
  [208] = {.lex_state = 74},
  [209] = {.lex_state = 74},
  [210] = {.lex_state = 74},
  [211] = {.lex_state = 74},
  [212] = {.lex_state = 74},
  [213] = {.lex_state = 74},
  [214] = {.lex_state = 74},
  [215] = {.lex_state = 74},
  [216] = {.lex_state = 74},
  [217] = {.lex_state = 74},
  [218] = {.lex_state = 74},
  [219] = {.lex_state = 74},
  [220] = {.lex_state = 74},
  [221] = {.lex_state = 74},
  [222] = {.lex_state = 74},
  [223] = {.lex_state = 74},
  [224] = {.lex_state = 74},
  [225] = {.lex_state = 74},
  [226] = {.lex_state = 74},
  [227] = {.lex_state = 74},
  [228] = {.lex_state = 74},
  [229] = {.lex_state = 74},
  [230] = {.lex_state = 74},
  [231] = {.lex_state = 74},
  [232] = {.lex_state = 74},
  [233] = {.lex_state = 74},
  [234] = {.lex_state = 74},
  [235] = {.lex_state = 74},
  [236] = {.lex_state = 74},
  [237] = {.lex_state = 74},
  [238] = {.lex_state = 74},
  [239] = {.lex_state = 74},
  [240] = {.lex_state = 74},
  [241] = {.lex_state = 74},
  [242] = {.lex_state = 74},
  [243] = {.lex_state = 74},
  [244] = {.lex_state = 74},
  [245] = {.lex_state = 74},
  [246] = {.lex_state = 74},
  [247] = {.lex_state = 74},
  [248] = {.lex_state = 74},
  [249] = {.lex_state = 74},
  [250] = {.lex_state = 74},
  [251] = {.lex_state = 74},
  [252] = {.lex_state = 74},
  [253] = {.lex_state = 74},
  [254] = {.lex_state = 74},
  [255] = {.lex_state = 74},
  [256] = {.lex_state = 74},
  [257] = {.lex_state = 74},
  [258] = {.lex_state = 74},
  [259] = {.lex_state = 74},
  [260] = {.lex_state = 74},
  [261] = {.lex_state = 74},
  [262] = {.lex_state = 74},
  [263] = {.lex_state = 74},
  [264] = {.lex_state = 74},
  [265] = {.lex_state = 74},
  [266] = {.lex_state = 74},
  [267] = {.lex_state = 74},
  [268] = {.lex_state = 74},
  [269] = {.lex_state = 74},
  [270] = {.lex_state = 74},
  [271] = {.lex_state = 74},
  [272] = {.lex_state = 74},
  [273] = {.lex_state = 74},
  [274] = {.lex_state = 74},
  [275] = {.lex_state = 74},
  [276] = {.lex_state = 74},
  [277] = {.lex_state = 74},
  [278] = {.lex_state = 74},
  [279] = {.lex_state = 74},
  [280] = {.lex_state = 74},
  [281] = {.lex_state = 74},
  [282] = {.lex_state = 74},
  [283] = {.lex_state = 74},
  [284] = {.lex_state = 74},
  [285] = {.lex_state = 74},
  [286] = {.lex_state = 74},
  [287] = {.lex_state = 74},
  [288] = {.lex_state = 74},
  [289] = {.lex_state = 74},
  [290] = {.lex_state = 74},
  [291] = {.lex_state = 74},
  [292] = {.lex_state = 74},
  [293] = {.lex_state = 74},
  [294] = {.lex_state = 74},
  [295] = {.lex_state = 74},
  [296] = {.lex_state = 74},
  [297] = {.lex_state = 74},
  [298] = {.lex_state = 74},
  [299] = {.lex_state = 74},
  [300] = {.lex_state = 74},
  [301] = {.lex_state = 74},
  [302] = {.lex_state = 74},
  [303] = {.lex_state = 74},
  [304] = {.lex_state = 74},
  [305] = {.lex_state = 74},
  [306] = {.lex_state = 74},
  [307] = {.lex_state = 74},
  [308] = {.lex_state = 74},
  [309] = {.lex_state = 74},
  [310] = {.lex_state = 74},
  [311] = {.lex_state = 74},
  [312] = {.lex_state = 74},
  [313] = {.lex_state = 74},
  [314] = {.lex_state = 74},
  [315] = {.lex_state = 74},
  [316] = {.lex_state = 74},
  [317] = {.lex_state = 74},
  [318] = {.lex_state = 74},
  [319] = {.lex_state = 74},
  [320] = {.lex_state = 74},
  [321] = {.lex_state = 74},
  [322] = {.lex_state = 74},
  [323] = {.lex_state = 74},
  [324] = {.lex_state = 74},
  [325] = {.lex_state = 74},
  [326] = {.lex_state = 74},
  [327] = {.lex_state = 74},
  [328] = {.lex_state = 74},
  [329] = {.lex_state = 74},
  [330] = {.lex_state = 74},
  [331] = {.lex_state = 74},
  [332] = {.lex_state = 74},
  [333] = {.lex_state = 74},
  [334] = {.lex_state = 74},
  [335] = {.lex_state = 74},
  [336] = {.lex_state = 74},
  [337] = {.lex_state = 74},
  [338] = {.lex_state = 74},
  [339] = {.lex_state = 74},
  [340] = {.lex_state = 74},
  [341] = {.lex_state = 74},
  [342] = {.lex_state = 74},
  [343] = {.lex_state = 74},
  [344] = {.lex_state = 74},
  [345] = {.lex_state = 74},
  [346] = {.lex_state = 74},
  [347] = {.lex_state = 74},
  [348] = {.lex_state = 74},
  [349] = {.lex_state = 74},
  [350] = {.lex_state = 74},
  [351] = {.lex_state = 74},
  [352] = {.lex_state = 74},
  [353] = {.lex_state = 74},
  [354] = {.lex_state = 74},
  [355] = {.lex_state = 74},
  [356] = {.lex_state = 74},
  [357] = {.lex_state = 74},
  [358] = {.lex_state = 74},
  [359] = {.lex_state = 74},
  [360] = {.lex_state = 74},
  [361] = {.lex_state = 74},
  [362] = {.lex_state = 74},
  [363] = {.lex_state = 74},
  [364] = {.lex_state = 74},
  [365] = {.lex_state = 74},
  [366] = {.lex_state = 74},
  [367] = {.lex_state = 74},
  [368] = {.lex_state = 74},
  [369] = {.lex_state = 74},
  [370] = {.lex_state = 74},
  [371] = {.lex_state = 74},
  [372] = {.lex_state = 74},
  [373] = {.lex_state = 74},
  [374] = {.lex_state = 74},
  [375] = {.lex_state = 74},
  [376] = {.lex_state = 74},
  [377] = {.lex_state = 74},
  [378] = {.lex_state = 74},
  [379] = {.lex_state = 74},
  [380] = {.lex_state = 74},
  [381] = {.lex_state = 74},
  [382] = {.lex_state = 74},
  [383] = {.lex_state = 74},
  [384] = {.lex_state = 74},
  [385] = {.lex_state = 74},
  [386] = {.lex_state = 74},
  [387] = {.lex_state = 74},
  [388] = {.lex_state = 74},
  [389] = {.lex_state = 74},
  [390] = {.lex_state = 74},
  [391] = {.lex_state = 74},
  [392] = {.lex_state = 74},
  [393] = {.lex_state = 74},
  [394] = {.lex_state = 74},
  [395] = {.lex_state = 74},
  [396] = {.lex_state = 74},
  [397] = {.lex_state = 74},
  [398] = {.lex_state = 74},
  [399] = {.lex_state = 74},
  [400] = {.lex_state = 74},
  [401] = {.lex_state = 74},
  [402] = {.lex_state = 74},
  [403] = {.lex_state = 74},
  [404] = {.lex_state = 74},
  [405] = {.lex_state = 74},
  [406] = {.lex_state = 74},
  [407] = {.lex_state = 74},
  [408] = {.lex_state = 74},
  [409] = {.lex_state = 74},
  [410] = {.lex_state = 74},
  [411] = {.lex_state = 74},
  [412] = {.lex_state = 74},
  [413] = {.lex_state = 74},
  [414] = {.lex_state = 74},
  [415] = {.lex_state = 74},
  [416] = {.lex_state = 74},
  [417] = {.lex_state = 74},
  [418] = {.lex_state = 74},
  [419] = {.lex_state = 74},
  [420] = {.lex_state = 74},
  [421] = {.lex_state = 74},
  [422] = {.lex_state = 74},
  [423] = {.lex_state = 74},
  [424] = {.lex_state = 74},
  [425] = {.lex_state = 74},
  [426] = {.lex_state = 74},
  [427] = {.lex_state = 74},
  [428] = {.lex_state = 74},
  [429] = {.lex_state = 74},
  [430] = {.lex_state = 74},
  [431] = {.lex_state = 74},
  [432] = {.lex_state = 74},
  [433] = {.lex_state = 74},
  [434] = {.lex_state = 74, .external_lex_state = 2},
  [435] = {.lex_state = 74, .external_lex_state = 2},
  [436] = {.lex_state = 74, .external_lex_state = 2},
  [437] = {.lex_state = 74, .external_lex_state = 2},
  [438] = {.lex_state = 74, .external_lex_state = 2},
  [439] = {.lex_state = 74, .external_lex_state = 2},
  [440] = {.lex_state = 74, .external_lex_state = 2},
  [441] = {.lex_state = 74, .external_lex_state = 2},
  [442] = {.lex_state = 74, .external_lex_state = 2},
  [443] = {.lex_state = 74, .external_lex_state = 2},
  [444] = {.lex_state = 74, .external_lex_state = 2},
  [445] = {.lex_state = 74, .external_lex_state = 2},
  [446] = {.lex_state = 74, .external_lex_state = 2},
  [447] = {.lex_state = 74, .external_lex_state = 2},
  [448] = {.lex_state = 74, .external_lex_state = 2},
  [449] = {.lex_state = 74, .external_lex_state = 2},
  [450] = {.lex_state = 74, .external_lex_state = 2},
  [451] = {.lex_state = 74, .external_lex_state = 2},
  [452] = {.lex_state = 74, .external_lex_state = 2},
  [453] = {.lex_state = 74, .external_lex_state = 2},
  [454] = {.lex_state = 74},
  [455] = {.lex_state = 74},
  [456] = {.lex_state = 74},
  [457] = {.lex_state = 74},
  [458] = {.lex_state = 74},
  [459] = {.lex_state = 74},
  [460] = {.lex_state = 74},
  [461] = {.lex_state = 74},
  [462] = {.lex_state = 74},
  [463] = {.lex_state = 74},
  [464] = {.lex_state = 74},
  [465] = {.lex_state = 74},
  [466] = {.lex_state = 74},
  [467] = {.lex_state = 74},
  [468] = {.lex_state = 74},
  [469] = {.lex_state = 74},
  [470] = {.lex_state = 74},
  [471] = {.lex_state = 74},
  [472] = {.lex_state = 74},
  [473] = {.lex_state = 74},
  [474] = {.lex_state = 74},
  [475] = {.lex_state = 74},
  [476] = {.lex_state = 74},
  [477] = {.lex_state = 74},
  [478] = {.lex_state = 74},
  [479] = {.lex_state = 74},
  [480] = {.lex_state = 74},
  [481] = {.lex_state = 74},
  [482] = {.lex_state = 74},
  [483] = {.lex_state = 74},
  [484] = {.lex_state = 74},
  [485] = {.lex_state = 74},
  [486] = {.lex_state = 74},
  [487] = {.lex_state = 74},
  [488] = {.lex_state = 74},
  [489] = {.lex_state = 74},
  [490] = {.lex_state = 74},
  [491] = {.lex_state = 74},
  [492] = {.lex_state = 74},
  [493] = {.lex_state = 74},
  [494] = {.lex_state = 74},
  [495] = {.lex_state = 74},
  [496] = {.lex_state = 74},
  [497] = {.lex_state = 74},
  [498] = {.lex_state = 74},
  [499] = {.lex_state = 74},
  [500] = {.lex_state = 74},
  [501] = {.lex_state = 74},
  [502] = {.lex_state = 74},
  [503] = {.lex_state = 74},
  [504] = {.lex_state = 74},
  [505] = {.lex_state = 74},
  [506] = {.lex_state = 74},
  [507] = {.lex_state = 74},
  [508] = {.lex_state = 74},
  [509] = {.lex_state = 74},
  [510] = {.lex_state = 74},
  [511] = {.lex_state = 74},
  [512] = {.lex_state = 74},
  [513] = {.lex_state = 74},
  [514] = {.lex_state = 74},
  [515] = {.lex_state = 74},
  [516] = {.lex_state = 74},
  [517] = {.lex_state = 74},
  [518] = {.lex_state = 74},
  [519] = {.lex_state = 74},
  [520] = {.lex_state = 74},
  [521] = {.lex_state = 74},
  [522] = {.lex_state = 74},
  [523] = {.lex_state = 74},
  [524] = {.lex_state = 74},
  [525] = {.lex_state = 74},
  [526] = {.lex_state = 74},
  [527] = {.lex_state = 74},
  [528] = {.lex_state = 74},
  [529] = {.lex_state = 74},
  [530] = {.lex_state = 74},
  [531] = {.lex_state = 74},
  [532] = {.lex_state = 74},
  [533] = {.lex_state = 74},
  [534] = {.lex_state = 74},
  [535] = {.lex_state = 74},
  [536] = {.lex_state = 74},
  [537] = {.lex_state = 74},
  [538] = {.lex_state = 74},
  [539] = {.lex_state = 74},
  [540] = {.lex_state = 74},
  [541] = {.lex_state = 74},
  [542] = {.lex_state = 74},
  [543] = {.lex_state = 74},
  [544] = {.lex_state = 74},
  [545] = {.lex_state = 74},
  [546] = {.lex_state = 74},
  [547] = {.lex_state = 74},
  [548] = {.lex_state = 74},
  [549] = {.lex_state = 74},
  [550] = {.lex_state = 74},
  [551] = {.lex_state = 74},
  [552] = {.lex_state = 74},
  [553] = {.lex_state = 74},
  [554] = {.lex_state = 74},
  [555] = {.lex_state = 74},
  [556] = {.lex_state = 74},
  [557] = {.lex_state = 74},
  [558] = {.lex_state = 74},
  [559] = {.lex_state = 74},
  [560] = {.lex_state = 74},
  [561] = {.lex_state = 74},
  [562] = {.lex_state = 74},
  [563] = {.lex_state = 74},
  [564] = {.lex_state = 74},
  [565] = {.lex_state = 74},
  [566] = {.lex_state = 74},
  [567] = {.lex_state = 74},
  [568] = {.lex_state = 74},
  [569] = {.lex_state = 74},
  [570] = {.lex_state = 74},
  [571] = {.lex_state = 10},
  [572] = {.lex_state = 10},
  [573] = {.lex_state = 10},
  [574] = {.lex_state = 10},
  [575] = {.lex_state = 10},
  [576] = {.lex_state = 10},
  [577] = {.lex_state = 10},
  [578] = {.lex_state = 10},
  [579] = {.lex_state = 10},
  [580] = {.lex_state = 10},
  [581] = {.lex_state = 10},
  [582] = {.lex_state = 10},
  [583] = {.lex_state = 10},
  [584] = {.lex_state = 10},
  [585] = {.lex_state = 10},
  [586] = {.lex_state = 10},
  [587] = {.lex_state = 10},
  [588] = {.lex_state = 10},
  [589] = {.lex_state = 10},
  [590] = {.lex_state = 10},
  [591] = {.lex_state = 10},
  [592] = {.lex_state = 10},
  [593] = {.lex_state = 10},
  [594] = {.lex_state = 10},
  [595] = {.lex_state = 10},
  [596] = {.lex_state = 10},
  [597] = {.lex_state = 10, .external_lex_state = 2},
  [598] = {.lex_state = 10, .external_lex_state = 2},
  [599] = {.lex_state = 10, .external_lex_state = 2},
  [600] = {.lex_state = 10, .external_lex_state = 2},
  [601] = {.lex_state = 10},
  [602] = {.lex_state = 10, .external_lex_state = 2},
  [603] = {.lex_state = 10},
  [604] = {.lex_state = 10, .external_lex_state = 2},
  [605] = {.lex_state = 10, .external_lex_state = 2},
  [606] = {.lex_state = 10},
  [607] = {.lex_state = 10, .external_lex_state = 2},
  [608] = {.lex_state = 10},
  [609] = {.lex_state = 10},
  [610] = {.lex_state = 10, .external_lex_state = 2},
  [611] = {.lex_state = 10, .external_lex_state = 2},
  [612] = {.lex_state = 10, .external_lex_state = 2},
  [613] = {.lex_state = 10, .external_lex_state = 2},
  [614] = {.lex_state = 10, .external_lex_state = 2},
  [615] = {.lex_state = 10, .external_lex_state = 2},
  [616] = {.lex_state = 10, .external_lex_state = 2},
  [617] = {.lex_state = 10, .external_lex_state = 2},
  [618] = {.lex_state = 10, .external_lex_state = 2},
  [619] = {.lex_state = 10, .external_lex_state = 2},
  [620] = {.lex_state = 10, .external_lex_state = 2},
  [621] = {.lex_state = 10},
  [622] = {.lex_state = 10},
  [623] = {.lex_state = 10, .external_lex_state = 2},
  [624] = {.lex_state = 10, .external_lex_state = 2},
  [625] = {.lex_state = 10},
  [626] = {.lex_state = 10, .external_lex_state = 2},
  [627] = {.lex_state = 10, .external_lex_state = 2},
  [628] = {.lex_state = 10, .external_lex_state = 2},
  [629] = {.lex_state = 10},
  [630] = {.lex_state = 10},
  [631] = {.lex_state = 10, .external_lex_state = 2},
  [632] = {.lex_state = 10, .external_lex_state = 2},
  [633] = {.lex_state = 10},
  [634] = {.lex_state = 10},
  [635] = {.lex_state = 10},
  [636] = {.lex_state = 10},
  [637] = {.lex_state = 10},
  [638] = {.lex_state = 10},
  [639] = {.lex_state = 9},
  [640] = {.lex_state = 75},
  [641] = {.lex_state = 75},
  [642] = {.lex_state = 11},
  [643] = {.lex_state = 11},
  [644] = {.lex_state = 11},
  [645] = {.lex_state = 11},
  [646] = {.lex_state = 11},
  [647] = {.lex_state = 12},
  [648] = {.lex_state = 20},
  [649] = {.lex_state = 12},
  [650] = {.lex_state = 11},
  [651] = {.lex_state = 20},
  [652] = {.lex_state = 12},
  [653] = {.lex_state = 12},
  [654] = {.lex_state = 12},
  [655] = {.lex_state = 11},
  [656] = {.lex_state = 20},
  [657] = {.lex_state = 20},
  [658] = {.lex_state = 11},
  [659] = {.lex_state = 16},
  [660] = {.lex_state = 11},
  [661] = {.lex_state = 11},
  [662] = {.lex_state = 11},
  [663] = {.lex_state = 20},
  [664] = {.lex_state = 11},
  [665] = {.lex_state = 11},
  [666] = {.lex_state = 11},
  [667] = {.lex_state = 16},
  [668] = {.lex_state = 11},
  [669] = {.lex_state = 11},
  [670] = {.lex_state = 11},
  [671] = {.lex_state = 20},
  [672] = {.lex_state = 12},
  [673] = {.lex_state = 11},
  [674] = {.lex_state = 12},
  [675] = {.lex_state = 11},
  [676] = {.lex_state = 11},
  [677] = {.lex_state = 11},
  [678] = {.lex_state = 11},
  [679] = {.lex_state = 11},
  [680] = {.lex_state = 11},
  [681] = {.lex_state = 11},
  [682] = {.lex_state = 12},
  [683] = {.lex_state = 12},
  [684] = {.lex_state = 17},
  [685] = {.lex_state = 12},
  [686] = {.lex_state = 12},
  [687] = {.lex_state = 17},
  [688] = {.lex_state = 12},
  [689] = {.lex_state = 12},
  [690] = {.lex_state = 12},
  [691] = {.lex_state = 12},
  [692] = {.lex_state = 12},
  [693] = {.lex_state = 12},
  [694] = {.lex_state = 17},
  [695] = {.lex_state = 17},
  [696] = {.lex_state = 12},
  [697] = {.lex_state = 17},
  [698] = {.lex_state = 12},
  [699] = {.lex_state = 20},
  [700] = {.lex_state = 12},
  [701] = {.lex_state = 12},
  [702] = {.lex_state = 12},
  [703] = {.lex_state = 12},
  [704] = {.lex_state = 12},
  [705] = {.lex_state = 12},
  [706] = {.lex_state = 12},
  [707] = {.lex_state = 12},
  [708] = {.lex_state = 12},
  [709] = {.lex_state = 12},
  [710] = {.lex_state = 12},
  [711] = {.lex_state = 11},
  [712] = {.lex_state = 12},
  [713] = {.lex_state = 12},
  [714] = {.lex_state = 12},
  [715] = {.lex_state = 12},
  [716] = {.lex_state = 12},
  [717] = {.lex_state = 12},
  [718] = {.lex_state = 12},
  [719] = {.lex_state = 12},
  [720] = {.lex_state = 12},
  [721] = {.lex_state = 12},
  [722] = {.lex_state = 12},
  [723] = {.lex_state = 12},
  [724] = {.lex_state = 12},
  [725] = {.lex_state = 12},
  [726] = {.lex_state = 12},
  [727] = {.lex_state = 12},
  [728] = {.lex_state = 12},
  [729] = {.lex_state = 12},
  [730] = {.lex_state = 12},
  [731] = {.lex_state = 12},
  [732] = {.lex_state = 12},
  [733] = {.lex_state = 12},
  [734] = {.lex_state = 12},
  [735] = {.lex_state = 12},
  [736] = {.lex_state = 12},
  [737] = {.lex_state = 12},
  [738] = {.lex_state = 12},
  [739] = {.lex_state = 12},
  [740] = {.lex_state = 12},
  [741] = {.lex_state = 12},
  [742] = {.lex_state = 12},
  [743] = {.lex_state = 12},
  [744] = {.lex_state = 12},
  [745] = {.lex_state = 12},
  [746] = {.lex_state = 12},
  [747] = {.lex_state = 12},
  [748] = {.lex_state = 12},
  [749] = {.lex_state = 12},
  [750] = {.lex_state = 12},
  [751] = {.lex_state = 12},
  [752] = {.lex_state = 12},
  [753] = {.lex_state = 12},
  [754] = {.lex_state = 12},
  [755] = {.lex_state = 12},
  [756] = {.lex_state = 12},
  [757] = {.lex_state = 12},
  [758] = {.lex_state = 17},
  [759] = {.lex_state = 12},
  [760] = {.lex_state = 13},
  [761] = {.lex_state = 12, .external_lex_state = 2},
  [762] = {.lex_state = 12, .external_lex_state = 2},
  [763] = {.lex_state = 12},
  [764] = {.lex_state = 11, .external_lex_state = 2},
  [765] = {.lex_state = 12},
  [766] = {.lex_state = 11, .external_lex_state = 2},
  [767] = {.lex_state = 12, .external_lex_state = 2},
  [768] = {.lex_state = 12},
  [769] = {.lex_state = 7},
  [770] = {.lex_state = 12},
  [771] = {.lex_state = 12},
  [772] = {.lex_state = 13},
  [773] = {.lex_state = 12, .external_lex_state = 2},
  [774] = {.lex_state = 12},
  [775] = {.lex_state = 11, .external_lex_state = 2},
  [776] = {.lex_state = 11, .external_lex_state = 2},
  [777] = {.lex_state = 11, .external_lex_state = 2},
  [778] = {.lex_state = 11, .external_lex_state = 2},
  [779] = {.lex_state = 11, .external_lex_state = 2},
  [780] = {.lex_state = 12, .external_lex_state = 2},
  [781] = {.lex_state = 11, .external_lex_state = 2},
  [782] = {.lex_state = 11, .external_lex_state = 2},
  [783] = {.lex_state = 11, .external_lex_state = 2},
  [784] = {.lex_state = 11, .external_lex_state = 2},
  [785] = {.lex_state = 11, .external_lex_state = 2},
  [786] = {.lex_state = 11, .external_lex_state = 2},
  [787] = {.lex_state = 11, .external_lex_state = 2},
  [788] = {.lex_state = 11, .external_lex_state = 2},
  [789] = {.lex_state = 11, .external_lex_state = 2},
  [790] = {.lex_state = 11, .external_lex_state = 2},
  [791] = {.lex_state = 11, .external_lex_state = 2},
  [792] = {.lex_state = 11, .external_lex_state = 2},
  [793] = {.lex_state = 11, .external_lex_state = 2},
  [794] = {.lex_state = 11, .external_lex_state = 2},
  [795] = {.lex_state = 12},
  [796] = {.lex_state = 11, .external_lex_state = 2},
  [797] = {.lex_state = 12, .external_lex_state = 2},
  [798] = {.lex_state = 7},
  [799] = {.lex_state = 11, .external_lex_state = 2},
  [800] = {.lex_state = 11, .external_lex_state = 2},
  [801] = {.lex_state = 11, .external_lex_state = 2},
  [802] = {.lex_state = 17},
  [803] = {.lex_state = 17},
  [804] = {.lex_state = 13},
  [805] = {.lex_state = 12, .external_lex_state = 2},
  [806] = {.lex_state = 12, .external_lex_state = 2},
  [807] = {.lex_state = 12, .external_lex_state = 2},
  [808] = {.lex_state = 12, .external_lex_state = 2},
  [809] = {.lex_state = 12, .external_lex_state = 2},
  [810] = {.lex_state = 17},
  [811] = {.lex_state = 12, .external_lex_state = 2},
  [812] = {.lex_state = 12, .external_lex_state = 2},
  [813] = {.lex_state = 12, .external_lex_state = 2},
  [814] = {.lex_state = 12, .external_lex_state = 2},
  [815] = {.lex_state = 12, .external_lex_state = 2},
  [816] = {.lex_state = 12, .external_lex_state = 2},
  [817] = {.lex_state = 17},
  [818] = {.lex_state = 12, .external_lex_state = 2},
  [819] = {.lex_state = 12, .external_lex_state = 2},
  [820] = {.lex_state = 12, .external_lex_state = 2},
  [821] = {.lex_state = 12, .external_lex_state = 2},
  [822] = {.lex_state = 17},
  [823] = {.lex_state = 12, .external_lex_state = 2},
  [824] = {.lex_state = 12, .external_lex_state = 2},
  [825] = {.lex_state = 13},
  [826] = {.lex_state = 11, .external_lex_state = 2},
  [827] = {.lex_state = 12, .external_lex_state = 2},
  [828] = {.lex_state = 12, .external_lex_state = 2},
  [829] = {.lex_state = 17},
  [830] = {.lex_state = 12, .external_lex_state = 2},
  [831] = {.lex_state = 12, .external_lex_state = 2},
  [832] = {.lex_state = 17},
  [833] = {.lex_state = 17},
  [834] = {.lex_state = 17},
  [835] = {.lex_state = 17},
  [836] = {.lex_state = 12, .external_lex_state = 2},
  [837] = {.lex_state = 17},
  [838] = {.lex_state = 12, .external_lex_state = 2},
  [839] = {.lex_state = 12, .external_lex_state = 2},
  [840] = {.lex_state = 12, .external_lex_state = 2},
  [841] = {.lex_state = 12, .external_lex_state = 2},
  [842] = {.lex_state = 17},
  [843] = {.lex_state = 12, .external_lex_state = 2},
  [844] = {.lex_state = 17},
  [845] = {.lex_state = 12, .external_lex_state = 2},
  [846] = {.lex_state = 12, .external_lex_state = 2},
  [847] = {.lex_state = 12, .external_lex_state = 2},
  [848] = {.lex_state = 12, .external_lex_state = 2},
  [849] = {.lex_state = 17},
  [850] = {.lex_state = 12, .external_lex_state = 2},
  [851] = {.lex_state = 12, .external_lex_state = 2},
  [852] = {.lex_state = 17},
  [853] = {.lex_state = 12, .external_lex_state = 2},
  [854] = {.lex_state = 12, .external_lex_state = 2},
  [855] = {.lex_state = 12, .external_lex_state = 2},
  [856] = {.lex_state = 12, .external_lex_state = 2},
  [857] = {.lex_state = 12, .external_lex_state = 2},
  [858] = {.lex_state = 12, .external_lex_state = 2},
  [859] = {.lex_state = 12, .external_lex_state = 2},
  [860] = {.lex_state = 12, .external_lex_state = 2},
  [861] = {.lex_state = 12, .external_lex_state = 2},
  [862] = {.lex_state = 12, .external_lex_state = 2},
  [863] = {.lex_state = 12, .external_lex_state = 2},
  [864] = {.lex_state = 12, .external_lex_state = 2},
  [865] = {.lex_state = 12, .external_lex_state = 2},
  [866] = {.lex_state = 12, .external_lex_state = 2},
  [867] = {.lex_state = 12, .external_lex_state = 2},
  [868] = {.lex_state = 12, .external_lex_state = 2},
  [869] = {.lex_state = 12, .external_lex_state = 2},
  [870] = {.lex_state = 12, .external_lex_state = 2},
  [871] = {.lex_state = 12, .external_lex_state = 2},
  [872] = {.lex_state = 12},
  [873] = {.lex_state = 12, .external_lex_state = 2},
  [874] = {.lex_state = 12, .external_lex_state = 2},
  [875] = {.lex_state = 12, .external_lex_state = 2},
  [876] = {.lex_state = 12, .external_lex_state = 2},
  [877] = {.lex_state = 12, .external_lex_state = 2},
  [878] = {.lex_state = 12, .external_lex_state = 2},
  [879] = {.lex_state = 12, .external_lex_state = 2},
  [880] = {.lex_state = 12, .external_lex_state = 2},
  [881] = {.lex_state = 12, .external_lex_state = 2},
  [882] = {.lex_state = 12, .external_lex_state = 2},
  [883] = {.lex_state = 12, .external_lex_state = 2},
  [884] = {.lex_state = 12, .external_lex_state = 2},
  [885] = {.lex_state = 12, .external_lex_state = 2},
  [886] = {.lex_state = 12, .external_lex_state = 2},
  [887] = {.lex_state = 12, .external_lex_state = 2},
  [888] = {.lex_state = 12},
  [889] = {.lex_state = 12, .external_lex_state = 2},
  [890] = {.lex_state = 12, .external_lex_state = 2},
  [891] = {.lex_state = 12, .external_lex_state = 2},
  [892] = {.lex_state = 12, .external_lex_state = 2},
  [893] = {.lex_state = 12, .external_lex_state = 2},
  [894] = {.lex_state = 12, .external_lex_state = 2},
  [895] = {.lex_state = 12, .external_lex_state = 2},
  [896] = {.lex_state = 12, .external_lex_state = 2},
  [897] = {.lex_state = 12, .external_lex_state = 2},
  [898] = {.lex_state = 12, .external_lex_state = 2},
  [899] = {.lex_state = 12, .external_lex_state = 2},
  [900] = {.lex_state = 12, .external_lex_state = 2},
  [901] = {.lex_state = 13},
  [902] = {.lex_state = 13},
  [903] = {.lex_state = 13},
  [904] = {.lex_state = 13},
  [905] = {.lex_state = 13},
  [906] = {.lex_state = 13},
  [907] = {.lex_state = 13},
  [908] = {.lex_state = 13},
  [909] = {.lex_state = 13},
  [910] = {.lex_state = 13},
  [911] = {.lex_state = 13},
  [912] = {.lex_state = 13},
  [913] = {.lex_state = 13},
  [914] = {.lex_state = 13},
  [915] = {.lex_state = 13},
  [916] = {.lex_state = 13},
  [917] = {.lex_state = 13},
  [918] = {.lex_state = 13},
  [919] = {.lex_state = 13},
  [920] = {.lex_state = 13},
  [921] = {.lex_state = 13},
  [922] = {.lex_state = 13},
  [923] = {.lex_state = 13},
  [924] = {.lex_state = 13},
  [925] = {.lex_state = 13},
  [926] = {.lex_state = 13},
  [927] = {.lex_state = 13},
  [928] = {.lex_state = 13},
  [929] = {.lex_state = 13},
  [930] = {.lex_state = 13},
  [931] = {.lex_state = 13},
  [932] = {.lex_state = 13},
  [933] = {.lex_state = 13},
  [934] = {.lex_state = 13},
  [935] = {.lex_state = 13},
  [936] = {.lex_state = 13},
  [937] = {.lex_state = 13},
  [938] = {.lex_state = 13},
  [939] = {.lex_state = 13},
  [940] = {.lex_state = 13},
  [941] = {.lex_state = 13},
  [942] = {.lex_state = 13},
  [943] = {.lex_state = 13},
  [944] = {.lex_state = 13},
  [945] = {.lex_state = 13},
  [946] = {.lex_state = 13},
  [947] = {.lex_state = 13},
  [948] = {.lex_state = 13},
  [949] = {.lex_state = 13},
  [950] = {.lex_state = 13},
  [951] = {.lex_state = 13},
  [952] = {.lex_state = 13},
  [953] = {.lex_state = 13},
  [954] = {.lex_state = 13},
  [955] = {.lex_state = 13},
  [956] = {.lex_state = 13},
  [957] = {.lex_state = 13},
  [958] = {.lex_state = 13},
  [959] = {.lex_state = 14},
  [960] = {.lex_state = 13},
  [961] = {.lex_state = 13},
  [962] = {.lex_state = 13},
  [963] = {.lex_state = 13},
  [964] = {.lex_state = 13},
  [965] = {.lex_state = 13},
  [966] = {.lex_state = 13, .external_lex_state = 2},
  [967] = {.lex_state = 13, .external_lex_state = 2},
  [968] = {.lex_state = 13},
  [969] = {.lex_state = 13},
  [970] = {.lex_state = 13},
  [971] = {.lex_state = 13},
  [972] = {.lex_state = 13},
  [973] = {.lex_state = 13},
  [974] = {.lex_state = 13},
  [975] = {.lex_state = 13},
  [976] = {.lex_state = 13},
  [977] = {.lex_state = 13},
  [978] = {.lex_state = 13},
  [979] = {.lex_state = 13},
  [980] = {.lex_state = 13},
  [981] = {.lex_state = 13},
  [982] = {.lex_state = 13},
  [983] = {.lex_state = 13},
  [984] = {.lex_state = 13},
  [985] = {.lex_state = 13},
  [986] = {.lex_state = 13},
  [987] = {.lex_state = 13},
  [988] = {.lex_state = 13},
  [989] = {.lex_state = 13},
  [990] = {.lex_state = 13},
  [991] = {.lex_state = 13},
  [992] = {.lex_state = 13},
  [993] = {.lex_state = 13},
  [994] = {.lex_state = 13},
  [995] = {.lex_state = 13},
  [996] = {.lex_state = 13},
  [997] = {.lex_state = 13},
  [998] = {.lex_state = 13},
  [999] = {.lex_state = 13},
  [1000] = {.lex_state = 13},
  [1001] = {.lex_state = 13},
  [1002] = {.lex_state = 13},
  [1003] = {.lex_state = 13},
  [1004] = {.lex_state = 13},
  [1005] = {.lex_state = 13},
  [1006] = {.lex_state = 13},
  [1007] = {.lex_state = 13},
  [1008] = {.lex_state = 13},
  [1009] = {.lex_state = 13},
  [1010] = {.lex_state = 13},
  [1011] = {.lex_state = 13},
  [1012] = {.lex_state = 13},
  [1013] = {.lex_state = 13},
  [1014] = {.lex_state = 13},
  [1015] = {.lex_state = 75},
  [1016] = {.lex_state = 13},
  [1017] = {.lex_state = 13},
  [1018] = {.lex_state = 13},
  [1019] = {.lex_state = 13},
  [1020] = {.lex_state = 13},
  [1021] = {.lex_state = 13},
  [1022] = {.lex_state = 13},
  [1023] = {.lex_state = 13},
  [1024] = {.lex_state = 13},
  [1025] = {.lex_state = 13},
  [1026] = {.lex_state = 13},
  [1027] = {.lex_state = 13},
  [1028] = {.lex_state = 13},
  [1029] = {.lex_state = 13},
  [1030] = {.lex_state = 13},
  [1031] = {.lex_state = 13},
  [1032] = {.lex_state = 13},
  [1033] = {.lex_state = 13, .external_lex_state = 2},
  [1034] = {.lex_state = 13, .external_lex_state = 2},
  [1035] = {.lex_state = 13, .external_lex_state = 2},
  [1036] = {.lex_state = 13, .external_lex_state = 2},
  [1037] = {.lex_state = 13, .external_lex_state = 2},
  [1038] = {.lex_state = 13, .external_lex_state = 2},
  [1039] = {.lex_state = 13, .external_lex_state = 2},
  [1040] = {.lex_state = 13, .external_lex_state = 2},
  [1041] = {.lex_state = 13, .external_lex_state = 2},
  [1042] = {.lex_state = 13, .external_lex_state = 2},
  [1043] = {.lex_state = 13, .external_lex_state = 2},
  [1044] = {.lex_state = 13, .external_lex_state = 2},
  [1045] = {.lex_state = 13, .external_lex_state = 2},
  [1046] = {.lex_state = 13, .external_lex_state = 2},
  [1047] = {.lex_state = 13, .external_lex_state = 2},
  [1048] = {.lex_state = 13, .external_lex_state = 2},
  [1049] = {.lex_state = 13, .external_lex_state = 2},
  [1050] = {.lex_state = 13, .external_lex_state = 2},
  [1051] = {.lex_state = 13, .external_lex_state = 2},
  [1052] = {.lex_state = 13, .external_lex_state = 2},
  [1053] = {.lex_state = 13, .external_lex_state = 2},
  [1054] = {.lex_state = 13, .external_lex_state = 2},
  [1055] = {.lex_state = 13, .external_lex_state = 2},
  [1056] = {.lex_state = 13, .external_lex_state = 2},
  [1057] = {.lex_state = 13, .external_lex_state = 2},
  [1058] = {.lex_state = 13, .external_lex_state = 2},
  [1059] = {.lex_state = 13, .external_lex_state = 2},
  [1060] = {.lex_state = 75},
  [1061] = {.lex_state = 13, .external_lex_state = 2},
  [1062] = {.lex_state = 13, .external_lex_state = 2},
  [1063] = {.lex_state = 75},
  [1064] = {.lex_state = 13, .external_lex_state = 2},
  [1065] = {.lex_state = 13, .external_lex_state = 2},
  [1066] = {.lex_state = 13, .external_lex_state = 2},
  [1067] = {.lex_state = 13, .external_lex_state = 2},
  [1068] = {.lex_state = 13, .external_lex_state = 2},
  [1069] = {.lex_state = 75},
  [1070] = {.lex_state = 13, .external_lex_state = 2},
  [1071] = {.lex_state = 13, .external_lex_state = 2},
  [1072] = {.lex_state = 13, .external_lex_state = 2},
  [1073] = {.lex_state = 13, .external_lex_state = 2},
  [1074] = {.lex_state = 13, .external_lex_state = 2},
  [1075] = {.lex_state = 13, .external_lex_state = 2},
  [1076] = {.lex_state = 13, .external_lex_state = 2},
  [1077] = {.lex_state = 13, .external_lex_state = 2},
  [1078] = {.lex_state = 13, .external_lex_state = 2},
  [1079] = {.lex_state = 13, .external_lex_state = 2},
  [1080] = {.lex_state = 13, .external_lex_state = 2},
  [1081] = {.lex_state = 75},
  [1082] = {.lex_state = 13, .external_lex_state = 2},
  [1083] = {.lex_state = 13, .external_lex_state = 2},
  [1084] = {.lex_state = 13, .external_lex_state = 2},
  [1085] = {.lex_state = 75},
  [1086] = {.lex_state = 13, .external_lex_state = 2},
  [1087] = {.lex_state = 13, .external_lex_state = 2},
  [1088] = {.lex_state = 13, .external_lex_state = 2},
  [1089] = {.lex_state = 13, .external_lex_state = 2},
  [1090] = {.lex_state = 13, .external_lex_state = 2},
  [1091] = {.lex_state = 13, .external_lex_state = 2},
  [1092] = {.lex_state = 13, .external_lex_state = 2},
  [1093] = {.lex_state = 13, .external_lex_state = 2},
  [1094] = {.lex_state = 13, .external_lex_state = 2},
  [1095] = {.lex_state = 13, .external_lex_state = 2},
  [1096] = {.lex_state = 13, .external_lex_state = 2},
  [1097] = {.lex_state = 13, .external_lex_state = 2},
  [1098] = {.lex_state = 13, .external_lex_state = 2},
  [1099] = {.lex_state = 13, .external_lex_state = 2},
  [1100] = {.lex_state = 13, .external_lex_state = 2},
  [1101] = {.lex_state = 13, .external_lex_state = 2},
  [1102] = {.lex_state = 13, .external_lex_state = 2},
  [1103] = {.lex_state = 13, .external_lex_state = 2},
  [1104] = {.lex_state = 13, .external_lex_state = 2},
  [1105] = {.lex_state = 13, .external_lex_state = 2},
  [1106] = {.lex_state = 13, .external_lex_state = 2},
  [1107] = {.lex_state = 13, .external_lex_state = 2},
  [1108] = {.lex_state = 13, .external_lex_state = 2},
  [1109] = {.lex_state = 13, .external_lex_state = 2},
  [1110] = {.lex_state = 13, .external_lex_state = 2},
  [1111] = {.lex_state = 75},
  [1112] = {.lex_state = 13, .external_lex_state = 2},
  [1113] = {.lex_state = 13, .external_lex_state = 2},
  [1114] = {.lex_state = 13, .external_lex_state = 2},
  [1115] = {.lex_state = 13, .external_lex_state = 2},
  [1116] = {.lex_state = 13, .external_lex_state = 2},
  [1117] = {.lex_state = 13, .external_lex_state = 2},
  [1118] = {.lex_state = 13, .external_lex_state = 2},
  [1119] = {.lex_state = 13, .external_lex_state = 2},
  [1120] = {.lex_state = 13, .external_lex_state = 2},
  [1121] = {.lex_state = 13, .external_lex_state = 2},
  [1122] = {.lex_state = 13, .external_lex_state = 2},
  [1123] = {.lex_state = 13, .external_lex_state = 2},
  [1124] = {.lex_state = 13, .external_lex_state = 2},
  [1125] = {.lex_state = 13, .external_lex_state = 2},
  [1126] = {.lex_state = 13, .external_lex_state = 2},
  [1127] = {.lex_state = 13, .external_lex_state = 2},
  [1128] = {.lex_state = 13, .external_lex_state = 2},
  [1129] = {.lex_state = 13, .external_lex_state = 2},
  [1130] = {.lex_state = 13, .external_lex_state = 2},
  [1131] = {.lex_state = 13, .external_lex_state = 2},
  [1132] = {.lex_state = 13, .external_lex_state = 2},
  [1133] = {.lex_state = 13, .external_lex_state = 2},
  [1134] = {.lex_state = 13, .external_lex_state = 2},
  [1135] = {.lex_state = 13, .external_lex_state = 2},
  [1136] = {.lex_state = 13, .external_lex_state = 2},
  [1137] = {.lex_state = 14},
  [1138] = {.lex_state = 13},
  [1139] = {.lex_state = 13},
  [1140] = {.lex_state = 13},
  [1141] = {.lex_state = 13},
  [1142] = {.lex_state = 13},
  [1143] = {.lex_state = 13},
  [1144] = {.lex_state = 13},
  [1145] = {.lex_state = 13},
  [1146] = {.lex_state = 13},
  [1147] = {.lex_state = 13},
  [1148] = {.lex_state = 13},
  [1149] = {.lex_state = 13},
  [1150] = {.lex_state = 13},
  [1151] = {.lex_state = 13},
  [1152] = {.lex_state = 13},
  [1153] = {.lex_state = 13},
  [1154] = {.lex_state = 13},
  [1155] = {.lex_state = 13},
  [1156] = {.lex_state = 13},
  [1157] = {.lex_state = 13},
  [1158] = {.lex_state = 13},
  [1159] = {.lex_state = 13},
  [1160] = {.lex_state = 13},
  [1161] = {.lex_state = 13},
  [1162] = {.lex_state = 13},
  [1163] = {.lex_state = 13},
  [1164] = {.lex_state = 13},
  [1165] = {.lex_state = 13},
  [1166] = {.lex_state = 13},
  [1167] = {.lex_state = 14},
  [1168] = {.lex_state = 13},
  [1169] = {.lex_state = 13},
  [1170] = {.lex_state = 13},
  [1171] = {.lex_state = 13},
  [1172] = {.lex_state = 13},
  [1173] = {.lex_state = 13, .external_lex_state = 2},
  [1174] = {.lex_state = 13},
  [1175] = {.lex_state = 13, .external_lex_state = 2},
  [1176] = {.lex_state = 13, .external_lex_state = 2},
  [1177] = {.lex_state = 13, .external_lex_state = 2},
  [1178] = {.lex_state = 13},
  [1179] = {.lex_state = 13},
  [1180] = {.lex_state = 13},
  [1181] = {.lex_state = 13, .external_lex_state = 2},
  [1182] = {.lex_state = 13, .external_lex_state = 2},
  [1183] = {.lex_state = 13},
  [1184] = {.lex_state = 13},
  [1185] = {.lex_state = 21},
  [1186] = {.lex_state = 13},
  [1187] = {.lex_state = 13},
  [1188] = {.lex_state = 13},
  [1189] = {.lex_state = 13},
  [1190] = {.lex_state = 21},
  [1191] = {.lex_state = 13},
  [1192] = {.lex_state = 13},
  [1193] = {.lex_state = 13},
  [1194] = {.lex_state = 13},
  [1195] = {.lex_state = 13},
  [1196] = {.lex_state = 13},
  [1197] = {.lex_state = 13},
  [1198] = {.lex_state = 13, .external_lex_state = 2},
  [1199] = {.lex_state = 13},
  [1200] = {.lex_state = 75},
  [1201] = {.lex_state = 13, .external_lex_state = 2},
  [1202] = {.lex_state = 13, .external_lex_state = 2},
  [1203] = {.lex_state = 13},
  [1204] = {.lex_state = 13, .external_lex_state = 2},
  [1205] = {.lex_state = 21},
  [1206] = {.lex_state = 13},
  [1207] = {.lex_state = 21},
  [1208] = {.lex_state = 21},
  [1209] = {.lex_state = 13},
  [1210] = {.lex_state = 21},
  [1211] = {.lex_state = 13},
  [1212] = {.lex_state = 13},
  [1213] = {.lex_state = 13},
  [1214] = {.lex_state = 13},
  [1215] = {.lex_state = 13},
  [1216] = {.lex_state = 13},
  [1217] = {.lex_state = 21},
  [1218] = {.lex_state = 21},
  [1219] = {.lex_state = 14},
  [1220] = {.lex_state = 13},
  [1221] = {.lex_state = 13},
  [1222] = {.lex_state = 13},
  [1223] = {.lex_state = 13},
  [1224] = {.lex_state = 13},
  [1225] = {.lex_state = 13, .external_lex_state = 2},
  [1226] = {.lex_state = 13, .external_lex_state = 2},
  [1227] = {.lex_state = 14},
  [1228] = {.lex_state = 21},
  [1229] = {.lex_state = 13},
  [1230] = {.lex_state = 13},
  [1231] = {.lex_state = 13},
  [1232] = {.lex_state = 13},
  [1233] = {.lex_state = 13, .external_lex_state = 2},
  [1234] = {.lex_state = 75},
  [1235] = {.lex_state = 13},
  [1236] = {.lex_state = 13},
  [1237] = {.lex_state = 13},
  [1238] = {.lex_state = 13},
  [1239] = {.lex_state = 13},
  [1240] = {.lex_state = 13},
  [1241] = {.lex_state = 13},
  [1242] = {.lex_state = 13},
  [1243] = {.lex_state = 13},
  [1244] = {.lex_state = 13},
  [1245] = {.lex_state = 13},
  [1246] = {.lex_state = 13},
  [1247] = {.lex_state = 13},
  [1248] = {.lex_state = 13},
  [1249] = {.lex_state = 13},
  [1250] = {.lex_state = 13},
  [1251] = {.lex_state = 13},
  [1252] = {.lex_state = 13},
  [1253] = {.lex_state = 13},
  [1254] = {.lex_state = 13},
  [1255] = {.lex_state = 13},
  [1256] = {.lex_state = 13},
  [1257] = {.lex_state = 13},
  [1258] = {.lex_state = 13},
  [1259] = {.lex_state = 13},
  [1260] = {.lex_state = 13},
  [1261] = {.lex_state = 13},
  [1262] = {.lex_state = 13},
  [1263] = {.lex_state = 13},
  [1264] = {.lex_state = 13},
  [1265] = {.lex_state = 13},
  [1266] = {.lex_state = 13},
  [1267] = {.lex_state = 13},
  [1268] = {.lex_state = 13},
  [1269] = {.lex_state = 13},
  [1270] = {.lex_state = 13},
  [1271] = {.lex_state = 14},
  [1272] = {.lex_state = 13},
  [1273] = {.lex_state = 13},
  [1274] = {.lex_state = 13},
  [1275] = {.lex_state = 13},
  [1276] = {.lex_state = 13},
  [1277] = {.lex_state = 13},
  [1278] = {.lex_state = 13},
  [1279] = {.lex_state = 13},
  [1280] = {.lex_state = 13},
  [1281] = {.lex_state = 13},
  [1282] = {.lex_state = 13},
  [1283] = {.lex_state = 13},
  [1284] = {.lex_state = 13},
  [1285] = {.lex_state = 13},
  [1286] = {.lex_state = 75},
  [1287] = {.lex_state = 13},
  [1288] = {.lex_state = 13},
  [1289] = {.lex_state = 13},
  [1290] = {.lex_state = 13},
  [1291] = {.lex_state = 13},
  [1292] = {.lex_state = 14},
  [1293] = {.lex_state = 13},
  [1294] = {.lex_state = 13},
  [1295] = {.lex_state = 13},
  [1296] = {.lex_state = 13},
  [1297] = {.lex_state = 13},
  [1298] = {.lex_state = 13},
  [1299] = {.lex_state = 13},
  [1300] = {.lex_state = 13},
  [1301] = {.lex_state = 13},
  [1302] = {.lex_state = 13},
  [1303] = {.lex_state = 13},
  [1304] = {.lex_state = 21},
  [1305] = {.lex_state = 21},
  [1306] = {.lex_state = 21},
  [1307] = {.lex_state = 21},
  [1308] = {.lex_state = 75},
  [1309] = {.lex_state = 75},
  [1310] = {.lex_state = 21},
  [1311] = {.lex_state = 75},
  [1312] = {.lex_state = 75},
  [1313] = {.lex_state = 75},
  [1314] = {.lex_state = 20},
  [1315] = {.lex_state = 20},
  [1316] = {.lex_state = 14},
  [1317] = {.lex_state = 14},
  [1318] = {.lex_state = 14},
  [1319] = {.lex_state = 20},
  [1320] = {.lex_state = 20},
  [1321] = {.lex_state = 14},
  [1322] = {.lex_state = 14},
  [1323] = {.lex_state = 14},
  [1324] = {.lex_state = 20},
  [1325] = {.lex_state = 14},
  [1326] = {.lex_state = 14},
  [1327] = {.lex_state = 14},
  [1328] = {.lex_state = 14},
  [1329] = {.lex_state = 14},
  [1330] = {.lex_state = 14},
  [1331] = {.lex_state = 14},
  [1332] = {.lex_state = 14},
  [1333] = {.lex_state = 14},
  [1334] = {.lex_state = 14},
  [1335] = {.lex_state = 14},
  [1336] = {.lex_state = 14},
  [1337] = {.lex_state = 14},
  [1338] = {.lex_state = 14},
  [1339] = {.lex_state = 14},
  [1340] = {.lex_state = 14},
  [1341] = {.lex_state = 75},
  [1342] = {.lex_state = 3, .external_lex_state = 3},
  [1343] = {.lex_state = 75},
  [1344] = {.lex_state = 3, .external_lex_state = 3},
  [1345] = {.lex_state = 3, .external_lex_state = 3},
  [1346] = {.lex_state = 75},
  [1347] = {.lex_state = 3, .external_lex_state = 4},
  [1348] = {.lex_state = 3, .external_lex_state = 3},
  [1349] = {.lex_state = 75},
  [1350] = {.lex_state = 3, .external_lex_state = 3},
  [1351] = {.lex_state = 21},
  [1352] = {.lex_state = 21},
  [1353] = {.lex_state = 17},
  [1354] = {.lex_state = 75},
  [1355] = {.lex_state = 18},
  [1356] = {.lex_state = 21},
  [1357] = {.lex_state = 21},
  [1358] = {.lex_state = 18, .external_lex_state = 4},
  [1359] = {.lex_state = 21},
  [1360] = {.lex_state = 21},
  [1361] = {.lex_state = 21},
  [1362] = {.lex_state = 21},
  [1363] = {.lex_state = 21},
  [1364] = {.lex_state = 21},
  [1365] = {.lex_state = 18, .external_lex_state = 5},
  [1366] = {.lex_state = 18, .external_lex_state = 5},
  [1367] = {.lex_state = 21},
  [1368] = {.lex_state = 21},
  [1369] = {.lex_state = 21},
  [1370] = {.lex_state = 21},
  [1371] = {.lex_state = 18, .external_lex_state = 5},
  [1372] = {.lex_state = 21},
  [1373] = {.lex_state = 18, .external_lex_state = 5},
  [1374] = {.lex_state = 21},
  [1375] = {.lex_state = 21},
  [1376] = {.lex_state = 21},
  [1377] = {.lex_state = 21},
  [1378] = {.lex_state = 21},
  [1379] = {.lex_state = 21},
  [1380] = {.lex_state = 21},
  [1381] = {.lex_state = 18, .external_lex_state = 5},
  [1382] = {.lex_state = 21},
  [1383] = {.lex_state = 21},
  [1384] = {.lex_state = 21},
  [1385] = {.lex_state = 21},
  [1386] = {.lex_state = 21},
  [1387] = {.lex_state = 75},
  [1388] = {.lex_state = 21},
  [1389] = {.lex_state = 21},
  [1390] = {.lex_state = 21},
  [1391] = {.lex_state = 21},
  [1392] = {.lex_state = 18, .external_lex_state = 6},
  [1393] = {.lex_state = 21},
  [1394] = {.lex_state = 18, .external_lex_state = 6},
  [1395] = {.lex_state = 3, .external_lex_state = 7},
  [1396] = {.lex_state = 21},
  [1397] = {.lex_state = 75},
  [1398] = {.lex_state = 75},
  [1399] = {.lex_state = 3, .external_lex_state = 7},
  [1400] = {.lex_state = 21},
  [1401] = {.lex_state = 75},
  [1402] = {.lex_state = 18, .external_lex_state = 6},
  [1403] = {.lex_state = 75},
  [1404] = {.lex_state = 18, .external_lex_state = 6},
  [1405] = {.lex_state = 21},
  [1406] = {.lex_state = 18, .external_lex_state = 6},
  [1407] = {.lex_state = 21},
  [1408] = {.lex_state = 21},
  [1409] = {.lex_state = 21},
  [1410] = {.lex_state = 21},
  [1411] = {.lex_state = 21},
  [1412] = {.lex_state = 21},
  [1413] = {.lex_state = 21},
  [1414] = {.lex_state = 21},
  [1415] = {.lex_state = 21},
  [1416] = {.lex_state = 21},
  [1417] = {.lex_state = 21},
  [1418] = {.lex_state = 21},
  [1419] = {.lex_state = 75},
  [1420] = {.lex_state = 75},
  [1421] = {.lex_state = 75},
  [1422] = {.lex_state = 75},
  [1423] = {.lex_state = 75},
  [1424] = {.lex_state = 23},
  [1425] = {.lex_state = 17},
  [1426] = {.lex_state = 75},
  [1427] = {.lex_state = 23},
  [1428] = {.lex_state = 75},
  [1429] = {.lex_state = 75},
  [1430] = {.lex_state = 75},
  [1431] = {.lex_state = 75},
  [1432] = {.lex_state = 75},
  [1433] = {.lex_state = 23},
  [1434] = {.lex_state = 75},
  [1435] = {.lex_state = 17},
  [1436] = {.lex_state = 75},
  [1437] = {.lex_state = 23},
  [1438] = {.lex_state = 75},
  [1439] = {.lex_state = 75},
  [1440] = {.lex_state = 18, .external_lex_state = 8},
  [1441] = {.lex_state = 75},
  [1442] = {.lex_state = 75},
  [1443] = {.lex_state = 3, .external_lex_state = 3},
  [1444] = {.lex_state = 75},
  [1445] = {.lex_state = 75},
  [1446] = {.lex_state = 3, .external_lex_state = 3},
  [1447] = {.lex_state = 17},
  [1448] = {.lex_state = 3, .external_lex_state = 3},
  [1449] = {.lex_state = 3, .external_lex_state = 3},
  [1450] = {.lex_state = 3, .external_lex_state = 3},
  [1451] = {.lex_state = 3, .external_lex_state = 3},
  [1452] = {.lex_state = 17},
  [1453] = {.lex_state = 17},
  [1454] = {.lex_state = 75},
  [1455] = {.lex_state = 3, .external_lex_state = 3},
  [1456] = {.lex_state = 75},
  [1457] = {.lex_state = 23},
  [1458] = {.lex_state = 75},
  [1459] = {.lex_state = 3, .external_lex_state = 3},
  [1460] = {.lex_state = 75},
  [1461] = {.lex_state = 17},
  [1462] = {.lex_state = 18, .external_lex_state = 8},
  [1463] = {.lex_state = 75},
  [1464] = {.lex_state = 17},
  [1465] = {.lex_state = 3, .external_lex_state = 3},
  [1466] = {.lex_state = 75},
  [1467] = {.lex_state = 75},
  [1468] = {.lex_state = 75},
  [1469] = {.lex_state = 75},
  [1470] = {.lex_state = 17},
  [1471] = {.lex_state = 75},
  [1472] = {.lex_state = 75},
  [1473] = {.lex_state = 75},
  [1474] = {.lex_state = 75},
  [1475] = {.lex_state = 75},
  [1476] = {.lex_state = 75},
  [1477] = {.lex_state = 75},
  [1478] = {.lex_state = 75},
  [1479] = {.lex_state = 75},
  [1480] = {.lex_state = 18, .external_lex_state = 9},
  [1481] = {.lex_state = 75},
  [1482] = {.lex_state = 75},
  [1483] = {.lex_state = 75},
  [1484] = {.lex_state = 75},
  [1485] = {.lex_state = 75},
  [1486] = {.lex_state = 17},
  [1487] = {.lex_state = 75},
  [1488] = {.lex_state = 75},
  [1489] = {.lex_state = 17},
  [1490] = {.lex_state = 75},
  [1491] = {.lex_state = 75},
  [1492] = {.lex_state = 17},
  [1493] = {.lex_state = 75},
  [1494] = {.lex_state = 17},
  [1495] = {.lex_state = 75},
  [1496] = {.lex_state = 75},
  [1497] = {.lex_state = 75},
  [1498] = {.lex_state = 75},
  [1499] = {.lex_state = 75},
  [1500] = {.lex_state = 75},
  [1501] = {.lex_state = 75},
  [1502] = {.lex_state = 17},
  [1503] = {.lex_state = 75},
  [1504] = {.lex_state = 75},
  [1505] = {.lex_state = 18, .external_lex_state = 9},
  [1506] = {.lex_state = 17},
  [1507] = {.lex_state = 17},
  [1508] = {.lex_state = 75},
  [1509] = {.lex_state = 75},
  [1510] = {.lex_state = 17},
  [1511] = {.lex_state = 75},
  [1512] = {.lex_state = 17},
  [1513] = {.lex_state = 75},
  [1514] = {.lex_state = 75},
  [1515] = {.lex_state = 17},
  [1516] = {.lex_state = 75},
  [1517] = {.lex_state = 75},
  [1518] = {.lex_state = 75},
  [1519] = {.lex_state = 75},
  [1520] = {.lex_state = 75},
  [1521] = {.lex_state = 75},
  [1522] = {.lex_state = 75},
  [1523] = {.lex_state = 17},
  [1524] = {.lex_state = 17},
  [1525] = {.lex_state = 75},
  [1526] = {.lex_state = 75},
  [1527] = {.lex_state = 75},
  [1528] = {.lex_state = 75},
  [1529] = {.lex_state = 75},
  [1530] = {.lex_state = 75},
  [1531] = {.lex_state = 75},
  [1532] = {.lex_state = 75},
  [1533] = {.lex_state = 75, .external_lex_state = 2},
  [1534] = {.lex_state = 14},
  [1535] = {.lex_state = 17},
  [1536] = {.lex_state = 14},
  [1537] = {.lex_state = 14},
  [1538] = {.lex_state = 14},
  [1539] = {.lex_state = 17},
  [1540] = {.lex_state = 23},
  [1541] = {.lex_state = 14},
  [1542] = {.lex_state = 14},
  [1543] = {.lex_state = 75, .external_lex_state = 2},
  [1544] = {.lex_state = 17},
  [1545] = {.lex_state = 14},
  [1546] = {.lex_state = 14},
  [1547] = {.lex_state = 17},
  [1548] = {.lex_state = 17},
  [1549] = {.lex_state = 17},
  [1550] = {.lex_state = 18, .external_lex_state = 5},
  [1551] = {.lex_state = 18, .external_lex_state = 5},
  [1552] = {.lex_state = 14},
  [1553] = {.lex_state = 14},
  [1554] = {.lex_state = 17},
  [1555] = {.lex_state = 17},
  [1556] = {.lex_state = 18, .external_lex_state = 5},
  [1557] = {.lex_state = 14},
  [1558] = {.lex_state = 17},
  [1559] = {.lex_state = 18, .external_lex_state = 5},
  [1560] = {.lex_state = 17},
  [1561] = {.lex_state = 18, .external_lex_state = 5},
  [1562] = {.lex_state = 14, .external_lex_state = 2},
  [1563] = {.lex_state = 18, .external_lex_state = 5},
  [1564] = {.lex_state = 75},
  [1565] = {.lex_state = 17},
  [1566] = {.lex_state = 23},
  [1567] = {.lex_state = 17},
  [1568] = {.lex_state = 14},
  [1569] = {.lex_state = 75, .external_lex_state = 2},
  [1570] = {.lex_state = 18, .external_lex_state = 5},
  [1571] = {.lex_state = 75},
  [1572] = {.lex_state = 17},
  [1573] = {.lex_state = 75},
  [1574] = {.lex_state = 17},
  [1575] = {.lex_state = 17},
  [1576] = {.lex_state = 18, .external_lex_state = 5},
  [1577] = {.lex_state = 17},
  [1578] = {.lex_state = 17},
  [1579] = {.lex_state = 17},
  [1580] = {.lex_state = 17},
  [1581] = {.lex_state = 18, .external_lex_state = 5},
  [1582] = {.lex_state = 17},
  [1583] = {.lex_state = 17},
  [1584] = {.lex_state = 14},
  [1585] = {.lex_state = 17},
  [1586] = {.lex_state = 17},
  [1587] = {.lex_state = 75},
  [1588] = {.lex_state = 17},
  [1589] = {.lex_state = 75},
  [1590] = {.lex_state = 17},
  [1591] = {.lex_state = 75},
  [1592] = {.lex_state = 14},
  [1593] = {.lex_state = 14},
  [1594] = {.lex_state = 14},
  [1595] = {.lex_state = 75},
  [1596] = {.lex_state = 14},
  [1597] = {.lex_state = 18, .external_lex_state = 6},
  [1598] = {.lex_state = 14},
  [1599] = {.lex_state = 14},
  [1600] = {.lex_state = 14},
  [1601] = {.lex_state = 14},
  [1602] = {.lex_state = 14},
  [1603] = {.lex_state = 14},
  [1604] = {.lex_state = 14},
  [1605] = {.lex_state = 14},
  [1606] = {.lex_state = 14},
  [1607] = {.lex_state = 18, .external_lex_state = 6},
  [1608] = {.lex_state = 75, .external_lex_state = 2},
  [1609] = {.lex_state = 14},
  [1610] = {.lex_state = 14},
  [1611] = {.lex_state = 14},
  [1612] = {.lex_state = 75},
  [1613] = {.lex_state = 75, .external_lex_state = 2},
  [1614] = {.lex_state = 18, .external_lex_state = 6},
  [1615] = {.lex_state = 14},
  [1616] = {.lex_state = 75},
  [1617] = {.lex_state = 18, .external_lex_state = 6},
  [1618] = {.lex_state = 75},
  [1619] = {.lex_state = 14},
  [1620] = {.lex_state = 18, .external_lex_state = 6},
  [1621] = {.lex_state = 18, .external_lex_state = 6},
  [1622] = {.lex_state = 14},
  [1623] = {.lex_state = 14},
  [1624] = {.lex_state = 14},
  [1625] = {.lex_state = 14},
  [1626] = {.lex_state = 14},
  [1627] = {.lex_state = 14},
  [1628] = {.lex_state = 75},
  [1629] = {.lex_state = 18, .external_lex_state = 6},
  [1630] = {.lex_state = 18, .external_lex_state = 6},
  [1631] = {.lex_state = 14},
  [1632] = {.lex_state = 14},
  [1633] = {.lex_state = 14},
  [1634] = {.lex_state = 75},
  [1635] = {.lex_state = 14},
  [1636] = {.lex_state = 14},
  [1637] = {.lex_state = 75},
  [1638] = {.lex_state = 14},
  [1639] = {.lex_state = 14},
  [1640] = {.lex_state = 14},
  [1641] = {.lex_state = 14},
  [1642] = {.lex_state = 14},
  [1643] = {.lex_state = 14},
  [1644] = {.lex_state = 14},
  [1645] = {.lex_state = 14},
  [1646] = {.lex_state = 14},
  [1647] = {.lex_state = 14},
  [1648] = {.lex_state = 75, .external_lex_state = 2},
  [1649] = {.lex_state = 14},
  [1650] = {.lex_state = 14},
  [1651] = {.lex_state = 14},
  [1652] = {.lex_state = 14},
  [1653] = {.lex_state = 14},
  [1654] = {.lex_state = 14},
  [1655] = {.lex_state = 14},
  [1656] = {.lex_state = 14},
  [1657] = {.lex_state = 14},
  [1658] = {.lex_state = 14},
  [1659] = {.lex_state = 75},
  [1660] = {.lex_state = 14, .external_lex_state = 2},
  [1661] = {.lex_state = 14},
  [1662] = {.lex_state = 75, .external_lex_state = 2},
  [1663] = {.lex_state = 75, .external_lex_state = 2},
  [1664] = {.lex_state = 14},
  [1665] = {.lex_state = 75},
  [1666] = {.lex_state = 14},
  [1667] = {.lex_state = 75, .external_lex_state = 2},
  [1668] = {.lex_state = 14},
  [1669] = {.lex_state = 14},
  [1670] = {.lex_state = 75, .external_lex_state = 2},
  [1671] = {.lex_state = 17},
  [1672] = {.lex_state = 14},
  [1673] = {.lex_state = 75, .external_lex_state = 2},
  [1674] = {.lex_state = 14},
  [1675] = {.lex_state = 75, .external_lex_state = 2},
  [1676] = {.lex_state = 75, .external_lex_state = 2},
  [1677] = {.lex_state = 75, .external_lex_state = 2},
  [1678] = {.lex_state = 14},
  [1679] = {.lex_state = 14, .external_lex_state = 2},
  [1680] = {.lex_state = 17},
  [1681] = {.lex_state = 14, .external_lex_state = 2},
  [1682] = {.lex_state = 14},
  [1683] = {.lex_state = 14},
  [1684] = {.lex_state = 14},
  [1685] = {.lex_state = 14},
  [1686] = {.lex_state = 14},
  [1687] = {.lex_state = 75},
  [1688] = {.lex_state = 17},
  [1689] = {.lex_state = 75, .external_lex_state = 2},
  [1690] = {.lex_state = 14},
  [1691] = {.lex_state = 75},
  [1692] = {.lex_state = 75},
  [1693] = {.lex_state = 75},
  [1694] = {.lex_state = 75},
  [1695] = {.lex_state = 75},
  [1696] = {.lex_state = 75, .external_lex_state = 2},
  [1697] = {.lex_state = 75, .external_lex_state = 2},
  [1698] = {.lex_state = 14},
  [1699] = {.lex_state = 14},
  [1700] = {.lex_state = 75, .external_lex_state = 2},
  [1701] = {.lex_state = 17},
  [1702] = {.lex_state = 75, .external_lex_state = 2},
  [1703] = {.lex_state = 14},
  [1704] = {.lex_state = 75, .external_lex_state = 2},
  [1705] = {.lex_state = 75, .external_lex_state = 2},
  [1706] = {.lex_state = 14},
  [1707] = {.lex_state = 14},
  [1708] = {.lex_state = 14, .external_lex_state = 2},
  [1709] = {.lex_state = 14},
  [1710] = {.lex_state = 14, .external_lex_state = 2},
  [1711] = {.lex_state = 14},
  [1712] = {.lex_state = 75, .external_lex_state = 2},
  [1713] = {.lex_state = 75, .external_lex_state = 2},
  [1714] = {.lex_state = 14},
  [1715] = {.lex_state = 14, .external_lex_state = 2},
  [1716] = {.lex_state = 14, .external_lex_state = 2},
  [1717] = {.lex_state = 75},
  [1718] = {.lex_state = 14, .external_lex_state = 2},
  [1719] = {.lex_state = 75, .external_lex_state = 2},
  [1720] = {.lex_state = 14},
  [1721] = {.lex_state = 17},
  [1722] = {.lex_state = 14, .external_lex_state = 2},
  [1723] = {.lex_state = 17},
  [1724] = {.lex_state = 14},
  [1725] = {.lex_state = 17},
  [1726] = {.lex_state = 14, .external_lex_state = 2},
  [1727] = {.lex_state = 17},
  [1728] = {.lex_state = 14, .external_lex_state = 2},
  [1729] = {.lex_state = 14},
  [1730] = {.lex_state = 75, .external_lex_state = 2},
  [1731] = {.lex_state = 17},
  [1732] = {.lex_state = 17},
  [1733] = {.lex_state = 14},
  [1734] = {.lex_state = 17},
  [1735] = {.lex_state = 14},
  [1736] = {.lex_state = 14},
  [1737] = {.lex_state = 14},
  [1738] = {.lex_state = 14},
  [1739] = {.lex_state = 75},
  [1740] = {.lex_state = 14, .external_lex_state = 2},
  [1741] = {.lex_state = 14, .external_lex_state = 2},
  [1742] = {.lex_state = 75},
  [1743] = {.lex_state = 75},
  [1744] = {.lex_state = 14},
  [1745] = {.lex_state = 14, .external_lex_state = 2},
  [1746] = {.lex_state = 14},
  [1747] = {.lex_state = 14, .external_lex_state = 2},
  [1748] = {.lex_state = 75, .external_lex_state = 2},
  [1749] = {.lex_state = 14, .external_lex_state = 2},
  [1750] = {.lex_state = 14, .external_lex_state = 2},
  [1751] = {.lex_state = 14, .external_lex_state = 2},
  [1752] = {.lex_state = 75},
  [1753] = {.lex_state = 14, .external_lex_state = 2},
  [1754] = {.lex_state = 75},
  [1755] = {.lex_state = 75, .external_lex_state = 2},
  [1756] = {.lex_state = 14},
  [1757] = {.lex_state = 14},
  [1758] = {.lex_state = 14},
  [1759] = {.lex_state = 75},
  [1760] = {.lex_state = 75, .external_lex_state = 2},
  [1761] = {.lex_state = 75, .external_lex_state = 2},
  [1762] = {.lex_state = 75, .external_lex_state = 2},
  [1763] = {.lex_state = 75, .external_lex_state = 2},
  [1764] = {.lex_state = 75, .external_lex_state = 2},
  [1765] = {.lex_state = 14},
  [1766] = {.lex_state = 75},
  [1767] = {.lex_state = 75, .external_lex_state = 2},
  [1768] = {.lex_state = 75, .external_lex_state = 2},
  [1769] = {.lex_state = 75},
  [1770] = {.lex_state = 75},
  [1771] = {.lex_state = 75, .external_lex_state = 2},
  [1772] = {.lex_state = 75},
  [1773] = {.lex_state = 75, .external_lex_state = 2},
  [1774] = {.lex_state = 75, .external_lex_state = 2},
  [1775] = {.lex_state = 75, .external_lex_state = 2},
  [1776] = {.lex_state = 75, .external_lex_state = 2},
  [1777] = {.lex_state = 75},
  [1778] = {.lex_state = 75},
  [1779] = {.lex_state = 75, .external_lex_state = 2},
  [1780] = {.lex_state = 75, .external_lex_state = 2},
  [1781] = {.lex_state = 14},
  [1782] = {.lex_state = 75},
  [1783] = {.lex_state = 75, .external_lex_state = 2},
  [1784] = {.lex_state = 75, .external_lex_state = 2},
  [1785] = {.lex_state = 75, .external_lex_state = 2},
  [1786] = {.lex_state = 75, .external_lex_state = 2},
  [1787] = {.lex_state = 75, .external_lex_state = 2},
  [1788] = {.lex_state = 14},
  [1789] = {.lex_state = 75},
  [1790] = {.lex_state = 14},
  [1791] = {.lex_state = 14},
  [1792] = {.lex_state = 75, .external_lex_state = 2},
  [1793] = {.lex_state = 14},
  [1794] = {.lex_state = 75, .external_lex_state = 2},
  [1795] = {.lex_state = 14},
  [1796] = {.lex_state = 75, .external_lex_state = 2},
  [1797] = {.lex_state = 75, .external_lex_state = 2},
  [1798] = {.lex_state = 14},
  [1799] = {.lex_state = 75, .external_lex_state = 2},
  [1800] = {.lex_state = 14},
  [1801] = {.lex_state = 75},
  [1802] = {.lex_state = 14},
  [1803] = {.lex_state = 14},
  [1804] = {.lex_state = 14},
  [1805] = {.lex_state = 75, .external_lex_state = 2},
  [1806] = {.lex_state = 75, .external_lex_state = 2},
  [1807] = {.lex_state = 14},
  [1808] = {.lex_state = 75},
  [1809] = {.lex_state = 75},
  [1810] = {.lex_state = 75, .external_lex_state = 2},
  [1811] = {.lex_state = 24},
  [1812] = {.lex_state = 75, .external_lex_state = 2},
  [1813] = {.lex_state = 75, .external_lex_state = 2},
  [1814] = {.lex_state = 75},
  [1815] = {.lex_state = 24},
  [1816] = {.lex_state = 14},
  [1817] = {.lex_state = 75},
  [1818] = {.lex_state = 75},
  [1819] = {.lex_state = 14},
  [1820] = {.lex_state = 75},
  [1821] = {.lex_state = 75},
  [1822] = {.lex_state = 75},
  [1823] = {.lex_state = 5, .external_lex_state = 10},
  [1824] = {.lex_state = 75},
  [1825] = {.lex_state = 75},
  [1826] = {.lex_state = 14},
  [1827] = {.lex_state = 75, .external_lex_state = 2},
  [1828] = {.lex_state = 75, .external_lex_state = 2},
  [1829] = {.lex_state = 75, .external_lex_state = 2},
  [1830] = {.lex_state = 75, .external_lex_state = 2},
  [1831] = {.lex_state = 14},
  [1832] = {.lex_state = 75, .external_lex_state = 2},
  [1833] = {.lex_state = 75},
  [1834] = {.lex_state = 75, .external_lex_state = 2},
  [1835] = {.lex_state = 75},
  [1836] = {.lex_state = 75},
  [1837] = {.lex_state = 14},
  [1838] = {.lex_state = 75, .external_lex_state = 2},
  [1839] = {.lex_state = 75, .external_lex_state = 2},
  [1840] = {.lex_state = 75},
  [1841] = {.lex_state = 75, .external_lex_state = 2},
  [1842] = {.lex_state = 24},
  [1843] = {.lex_state = 14},
  [1844] = {.lex_state = 75, .external_lex_state = 2},
  [1845] = {.lex_state = 14},
  [1846] = {.lex_state = 75},
  [1847] = {.lex_state = 75},
  [1848] = {.lex_state = 75, .external_lex_state = 2},
  [1849] = {.lex_state = 75, .external_lex_state = 2},
  [1850] = {.lex_state = 14},
  [1851] = {.lex_state = 24},
  [1852] = {.lex_state = 14},
  [1853] = {.lex_state = 75, .external_lex_state = 2},
  [1854] = {.lex_state = 75, .external_lex_state = 2},
  [1855] = {.lex_state = 75, .external_lex_state = 2},
  [1856] = {.lex_state = 75, .external_lex_state = 2},
  [1857] = {.lex_state = 14},
  [1858] = {.lex_state = 75},
  [1859] = {.lex_state = 14},
  [1860] = {.lex_state = 75},
  [1861] = {.lex_state = 14},
  [1862] = {.lex_state = 75},
  [1863] = {.lex_state = 75},
  [1864] = {.lex_state = 24},
  [1865] = {.lex_state = 75, .external_lex_state = 2},
  [1866] = {.lex_state = 75, .external_lex_state = 2},
  [1867] = {.lex_state = 75, .external_lex_state = 2},
  [1868] = {.lex_state = 75, .external_lex_state = 2},
  [1869] = {.lex_state = 75},
  [1870] = {.lex_state = 14},
  [1871] = {.lex_state = 75, .external_lex_state = 2},
  [1872] = {.lex_state = 75},
  [1873] = {.lex_state = 14},
  [1874] = {.lex_state = 75},
  [1875] = {.lex_state = 5, .external_lex_state = 10},
  [1876] = {.lex_state = 14},
  [1877] = {.lex_state = 75, .external_lex_state = 2},
  [1878] = {.lex_state = 75, .external_lex_state = 2},
  [1879] = {.lex_state = 75, .external_lex_state = 2},
  [1880] = {.lex_state = 75, .external_lex_state = 2},
  [1881] = {.lex_state = 75, .external_lex_state = 2},
  [1882] = {.lex_state = 75, .external_lex_state = 2},
  [1883] = {.lex_state = 14},
  [1884] = {.lex_state = 14},
  [1885] = {.lex_state = 75},
  [1886] = {.lex_state = 75, .external_lex_state = 2},
  [1887] = {.lex_state = 75},
  [1888] = {.lex_state = 75},
  [1889] = {.lex_state = 75, .external_lex_state = 2},
  [1890] = {.lex_state = 75, .external_lex_state = 2},
  [1891] = {.lex_state = 75},
  [1892] = {.lex_state = 14},
  [1893] = {.lex_state = 75},
  [1894] = {.lex_state = 14},
  [1895] = {.lex_state = 14},
  [1896] = {.lex_state = 14},
  [1897] = {.lex_state = 75},
  [1898] = {.lex_state = 75, .external_lex_state = 2},
  [1899] = {.lex_state = 75, .external_lex_state = 2},
  [1900] = {.lex_state = 75, .external_lex_state = 2},
  [1901] = {.lex_state = 75, .external_lex_state = 2},
  [1902] = {.lex_state = 75},
  [1903] = {.lex_state = 75, .external_lex_state = 2},
  [1904] = {.lex_state = 14},
  [1905] = {.lex_state = 14},
  [1906] = {.lex_state = 75, .external_lex_state = 2},
  [1907] = {.lex_state = 14},
  [1908] = {.lex_state = 75},
  [1909] = {.lex_state = 75, .external_lex_state = 2},
  [1910] = {.lex_state = 14},
  [1911] = {.lex_state = 75, .external_lex_state = 2},
  [1912] = {.lex_state = 75, .external_lex_state = 2},
  [1913] = {.lex_state = 75},
  [1914] = {.lex_state = 75},
  [1915] = {.lex_state = 14},
  [1916] = {.lex_state = 14},
  [1917] = {.lex_state = 75},
  [1918] = {.lex_state = 75},
  [1919] = {.lex_state = 75, .external_lex_state = 2},
  [1920] = {.lex_state = 75},
  [1921] = {.lex_state = 14},
  [1922] = {.lex_state = 14},
  [1923] = {.lex_state = 14},
  [1924] = {.lex_state = 75},
  [1925] = {.lex_state = 14},
  [1926] = {.lex_state = 75},
  [1927] = {.lex_state = 14},
  [1928] = {.lex_state = 75, .external_lex_state = 2},
  [1929] = {.lex_state = 75},
  [1930] = {.lex_state = 75, .external_lex_state = 2},
  [1931] = {.lex_state = 14},
  [1932] = {.lex_state = 75},
  [1933] = {.lex_state = 75},
  [1934] = {.lex_state = 75},
  [1935] = {.lex_state = 14},
  [1936] = {.lex_state = 75},
  [1937] = {.lex_state = 75},
  [1938] = {.lex_state = 75},
  [1939] = {.lex_state = 14},
  [1940] = {.lex_state = 14},
  [1941] = {.lex_state = 75},
  [1942] = {.lex_state = 75},
  [1943] = {.lex_state = 75},
  [1944] = {.lex_state = 75},
  [1945] = {.lex_state = 75, .external_lex_state = 2},
  [1946] = {.lex_state = 14},
  [1947] = {.lex_state = 75},
  [1948] = {.lex_state = 75},
  [1949] = {.lex_state = 75},
  [1950] = {.lex_state = 14},
  [1951] = {.lex_state = 75},
  [1952] = {.lex_state = 75},
  [1953] = {.lex_state = 14},
  [1954] = {.lex_state = 75},
  [1955] = {.lex_state = 14},
  [1956] = {.lex_state = 14},
  [1957] = {.lex_state = 75},
  [1958] = {.lex_state = 75},
  [1959] = {.lex_state = 75},
  [1960] = {.lex_state = 75},
  [1961] = {.lex_state = 75},
  [1962] = {.lex_state = 75, .external_lex_state = 2},
  [1963] = {.lex_state = 14},
  [1964] = {.lex_state = 75},
  [1965] = {.lex_state = 5, .external_lex_state = 11},
  [1966] = {.lex_state = 5, .external_lex_state = 11},
  [1967] = {.lex_state = 75},
  [1968] = {.lex_state = 75},
  [1969] = {.lex_state = 75},
  [1970] = {.lex_state = 75},
  [1971] = {.lex_state = 75, .external_lex_state = 2},
  [1972] = {.lex_state = 75},
  [1973] = {.lex_state = 75},
  [1974] = {.lex_state = 5, .external_lex_state = 11},
  [1975] = {.lex_state = 75},
  [1976] = {.lex_state = 14},
  [1977] = {.lex_state = 14},
  [1978] = {.lex_state = 14},
  [1979] = {.lex_state = 75},
  [1980] = {.lex_state = 75},
  [1981] = {.lex_state = 75},
  [1982] = {.lex_state = 14},
  [1983] = {.lex_state = 75, .external_lex_state = 2},
  [1984] = {.lex_state = 14},
  [1985] = {.lex_state = 75},
  [1986] = {.lex_state = 14},
  [1987] = {.lex_state = 75, .external_lex_state = 2},
  [1988] = {.lex_state = 75},
  [1989] = {.lex_state = 14},
  [1990] = {.lex_state = 75},
  [1991] = {.lex_state = 75},
  [1992] = {.lex_state = 75},
  [1993] = {.lex_state = 75},
  [1994] = {.lex_state = 14},
  [1995] = {.lex_state = 75, .external_lex_state = 2},
  [1996] = {.lex_state = 75},
  [1997] = {.lex_state = 75},
  [1998] = {.lex_state = 75},
  [1999] = {.lex_state = 75},
  [2000] = {.lex_state = 75},
  [2001] = {.lex_state = 75},
  [2002] = {.lex_state = 75},
  [2003] = {.lex_state = 75},
  [2004] = {.lex_state = 75},
  [2005] = {.lex_state = 75, .external_lex_state = 2},
  [2006] = {.lex_state = 14},
  [2007] = {.lex_state = 75},
  [2008] = {.lex_state = 75},
  [2009] = {.lex_state = 75},
  [2010] = {.lex_state = 14},
  [2011] = {.lex_state = 14},
  [2012] = {.lex_state = 75},
  [2013] = {.lex_state = 14},
  [2014] = {.lex_state = 14},
  [2015] = {.lex_state = 75, .external_lex_state = 2},
  [2016] = {.lex_state = 14},
  [2017] = {.lex_state = 14},
  [2018] = {.lex_state = 75},
  [2019] = {.lex_state = 14},
  [2020] = {.lex_state = 14},
  [2021] = {.lex_state = 5, .external_lex_state = 11},
  [2022] = {.lex_state = 75},
  [2023] = {.lex_state = 14},
  [2024] = {.lex_state = 187, .external_lex_state = 12},
  [2025] = {.lex_state = 14},
  [2026] = {.lex_state = 75},
  [2027] = {.lex_state = 75},
  [2028] = {.lex_state = 75},
  [2029] = {.lex_state = 75},
  [2030] = {.lex_state = 14},
  [2031] = {.lex_state = 75},
  [2032] = {.lex_state = 14},
  [2033] = {.lex_state = 75},
  [2034] = {.lex_state = 14},
  [2035] = {.lex_state = 75},
  [2036] = {.lex_state = 75},
  [2037] = {.lex_state = 75},
  [2038] = {.lex_state = 14},
  [2039] = {.lex_state = 14},
  [2040] = {.lex_state = 75},
  [2041] = {.lex_state = 14},
  [2042] = {.lex_state = 75},
  [2043] = {.lex_state = 14},
  [2044] = {.lex_state = 14},
  [2045] = {.lex_state = 14},
  [2046] = {.lex_state = 75},
  [2047] = {.lex_state = 75, .external_lex_state = 13},
  [2048] = {.lex_state = 75},
  [2049] = {.lex_state = 14},
  [2050] = {.lex_state = 75},
  [2051] = {.lex_state = 14},
  [2052] = {.lex_state = 14},
  [2053] = {.lex_state = 75},
  [2054] = {.lex_state = 14},
  [2055] = {.lex_state = 75},
  [2056] = {.lex_state = 75},
  [2057] = {.lex_state = 75},
  [2058] = {.lex_state = 14},
  [2059] = {.lex_state = 14},
  [2060] = {.lex_state = 75},
  [2061] = {.lex_state = 14},
  [2062] = {.lex_state = 14},
  [2063] = {.lex_state = 75, .external_lex_state = 13},
  [2064] = {.lex_state = 14},
  [2065] = {.lex_state = 14},
  [2066] = {.lex_state = 14},
  [2067] = {.lex_state = 14},
  [2068] = {.lex_state = 75},
  [2069] = {.lex_state = 14},
  [2070] = {.lex_state = 75},
  [2071] = {.lex_state = 75},
  [2072] = {.lex_state = 14},
  [2073] = {.lex_state = 14},
  [2074] = {.lex_state = 75},
  [2075] = {.lex_state = 75},
  [2076] = {.lex_state = 75},
  [2077] = {.lex_state = 14},
  [2078] = {.lex_state = 75},
  [2079] = {.lex_state = 14, .external_lex_state = 2},
  [2080] = {.lex_state = 14},
  [2081] = {.lex_state = 14},
  [2082] = {.lex_state = 14},
  [2083] = {.lex_state = 75},
  [2084] = {.lex_state = 75},
  [2085] = {.lex_state = 14},
  [2086] = {.lex_state = 14},
  [2087] = {.lex_state = 14},
  [2088] = {.lex_state = 75},
  [2089] = {.lex_state = 14},
  [2090] = {.lex_state = 14},
  [2091] = {.lex_state = 14},
  [2092] = {.lex_state = 75},
  [2093] = {.lex_state = 75},
  [2094] = {.lex_state = 14},
  [2095] = {.lex_state = 14},
  [2096] = {.lex_state = 75},
  [2097] = {.lex_state = 14},
  [2098] = {.lex_state = 14},
  [2099] = {.lex_state = 75},
  [2100] = {.lex_state = 14},
  [2101] = {.lex_state = 14},
  [2102] = {.lex_state = 14},
  [2103] = {.lex_state = 75, .external_lex_state = 2},
  [2104] = {.lex_state = 75},
  [2105] = {.lex_state = 14},
  [2106] = {.lex_state = 14},
  [2107] = {.lex_state = 14},
  [2108] = {.lex_state = 75},
  [2109] = {.lex_state = 75},
  [2110] = {.lex_state = 14},
  [2111] = {.lex_state = 14},
  [2112] = {.lex_state = 75},
  [2113] = {.lex_state = 14},
  [2114] = {.lex_state = 75},
  [2115] = {.lex_state = 75},
  [2116] = {.lex_state = 14},
  [2117] = {.lex_state = 14},
  [2118] = {.lex_state = 14},
  [2119] = {.lex_state = 75},
  [2120] = {.lex_state = 75},
  [2121] = {.lex_state = 14},
  [2122] = {.lex_state = 75},
  [2123] = {.lex_state = 14},
  [2124] = {.lex_state = 14},
  [2125] = {.lex_state = 14},
  [2126] = {.lex_state = 14},
  [2127] = {.lex_state = 14},
  [2128] = {.lex_state = 14},
  [2129] = {.lex_state = 75},
  [2130] = {.lex_state = 75},
  [2131] = {.lex_state = 75},
  [2132] = {.lex_state = 75},
  [2133] = {.lex_state = 75},
  [2134] = {.lex_state = 14},
  [2135] = {.lex_state = 14},
  [2136] = {.lex_state = 14},
  [2137] = {.lex_state = 75},
  [2138] = {.lex_state = 14},
  [2139] = {.lex_state = 14},
  [2140] = {.lex_state = 75},
  [2141] = {.lex_state = 75},
  [2142] = {.lex_state = 14, .external_lex_state = 2},
  [2143] = {.lex_state = 14},
  [2144] = {.lex_state = 75},
  [2145] = {.lex_state = 14},
  [2146] = {.lex_state = 14},
  [2147] = {.lex_state = 14},
  [2148] = {.lex_state = 75},
  [2149] = {.lex_state = 75},
  [2150] = {.lex_state = 14},
  [2151] = {.lex_state = 75},
  [2152] = {.lex_state = 14},
  [2153] = {.lex_state = 5, .external_lex_state = 11},
  [2154] = {.lex_state = 75},
  [2155] = {.lex_state = 5, .external_lex_state = 11},
  [2156] = {.lex_state = 75},
  [2157] = {.lex_state = 75},
  [2158] = {.lex_state = 14},
  [2159] = {.lex_state = 75},
  [2160] = {.lex_state = 75},
  [2161] = {.lex_state = 75, .external_lex_state = 2},
  [2162] = {.lex_state = 75},
  [2163] = {.lex_state = 14},
  [2164] = {.lex_state = 14},
  [2165] = {.lex_state = 14},
  [2166] = {.lex_state = 14},
  [2167] = {.lex_state = 75},
  [2168] = {.lex_state = 14},
  [2169] = {.lex_state = 75},
  [2170] = {.lex_state = 14},
  [2171] = {.lex_state = 75, .external_lex_state = 2},
  [2172] = {.lex_state = 14},
  [2173] = {.lex_state = 75},
  [2174] = {.lex_state = 75},
  [2175] = {.lex_state = 14},
  [2176] = {.lex_state = 14},
  [2177] = {.lex_state = 14},
  [2178] = {.lex_state = 14},
  [2179] = {.lex_state = 14},
  [2180] = {.lex_state = 14},
  [2181] = {.lex_state = 14},
  [2182] = {.lex_state = 75},
  [2183] = {.lex_state = 75, .external_lex_state = 2},
  [2184] = {.lex_state = 75},
  [2185] = {.lex_state = 75},
  [2186] = {.lex_state = 75},
  [2187] = {.lex_state = 75},
  [2188] = {.lex_state = 14},
  [2189] = {.lex_state = 75},
  [2190] = {.lex_state = 75},
  [2191] = {.lex_state = 75},
  [2192] = {.lex_state = 75},
  [2193] = {.lex_state = 75},
  [2194] = {.lex_state = 75},
  [2195] = {.lex_state = 75},
  [2196] = {.lex_state = 5, .external_lex_state = 11},
  [2197] = {.lex_state = 75},
  [2198] = {.lex_state = 75},
  [2199] = {.lex_state = 75, .external_lex_state = 2},
  [2200] = {.lex_state = 75},
  [2201] = {.lex_state = 5, .external_lex_state = 11},
  [2202] = {.lex_state = 14},
  [2203] = {.lex_state = 75},
  [2204] = {.lex_state = 75},
  [2205] = {.lex_state = 75},
  [2206] = {.lex_state = 14},
  [2207] = {.lex_state = 75},
  [2208] = {.lex_state = 75},
  [2209] = {.lex_state = 14},
  [2210] = {.lex_state = 75},
  [2211] = {.lex_state = 75},
  [2212] = {.lex_state = 75},
  [2213] = {.lex_state = 75},
  [2214] = {.lex_state = 75},
  [2215] = {.lex_state = 75},
  [2216] = {.lex_state = 75},
  [2217] = {.lex_state = 75, .external_lex_state = 2},
  [2218] = {.lex_state = 75},
  [2219] = {.lex_state = 75},
  [2220] = {.lex_state = 75, .external_lex_state = 2},
  [2221] = {.lex_state = 75},
  [2222] = {.lex_state = 75, .external_lex_state = 2},
  [2223] = {.lex_state = 75, .external_lex_state = 2},
  [2224] = {.lex_state = 75},
  [2225] = {.lex_state = 75},
  [2226] = {.lex_state = 75},
  [2227] = {.lex_state = 75, .external_lex_state = 2},
  [2228] = {.lex_state = 14},
  [2229] = {.lex_state = 75},
  [2230] = {.lex_state = 75},
  [2231] = {.lex_state = 75},
  [2232] = {.lex_state = 75},
  [2233] = {.lex_state = 75, .external_lex_state = 2},
  [2234] = {.lex_state = 14},
  [2235] = {.lex_state = 75},
  [2236] = {.lex_state = 75, .external_lex_state = 2},
  [2237] = {.lex_state = 75, .external_lex_state = 2},
  [2238] = {.lex_state = 75},
  [2239] = {.lex_state = 75},
  [2240] = {.lex_state = 75, .external_lex_state = 2},
  [2241] = {.lex_state = 75},
  [2242] = {.lex_state = 75, .external_lex_state = 2},
  [2243] = {.lex_state = 75},
  [2244] = {.lex_state = 75},
  [2245] = {.lex_state = 75},
  [2246] = {.lex_state = 75},
  [2247] = {.lex_state = 75},
  [2248] = {.lex_state = 75},
  [2249] = {.lex_state = 75},
  [2250] = {.lex_state = 75},
  [2251] = {.lex_state = 75},
  [2252] = {.lex_state = 75, .external_lex_state = 2},
  [2253] = {.lex_state = 75},
  [2254] = {.lex_state = 75},
  [2255] = {.lex_state = 75},
  [2256] = {.lex_state = 75},
  [2257] = {.lex_state = 75},
  [2258] = {.lex_state = 75},
  [2259] = {.lex_state = 14},
  [2260] = {.lex_state = 75},
  [2261] = {.lex_state = 75},
  [2262] = {.lex_state = 75},
  [2263] = {.lex_state = 75},
  [2264] = {.lex_state = 75},
  [2265] = {.lex_state = 75},
  [2266] = {.lex_state = 75},
  [2267] = {.lex_state = 75},
  [2268] = {.lex_state = 14},
  [2269] = {.lex_state = 75},
  [2270] = {.lex_state = 75, .external_lex_state = 2},
  [2271] = {.lex_state = 75},
  [2272] = {.lex_state = 75},
  [2273] = {.lex_state = 75, .external_lex_state = 2},
  [2274] = {.lex_state = 75},
  [2275] = {.lex_state = 75},
  [2276] = {.lex_state = 75},
  [2277] = {.lex_state = 75},
  [2278] = {.lex_state = 5, .external_lex_state = 11},
  [2279] = {.lex_state = 75},
  [2280] = {.lex_state = 75},
  [2281] = {.lex_state = 75},
  [2282] = {.lex_state = 75},
  [2283] = {.lex_state = 75},
  [2284] = {.lex_state = 75, .external_lex_state = 2},
  [2285] = {.lex_state = 75},
  [2286] = {.lex_state = 75},
  [2287] = {.lex_state = 75, .external_lex_state = 2},
  [2288] = {.lex_state = 75},
  [2289] = {.lex_state = 75, .external_lex_state = 2},
  [2290] = {.lex_state = 75, .external_lex_state = 2},
  [2291] = {.lex_state = 75},
  [2292] = {.lex_state = 14},
  [2293] = {.lex_state = 75},
  [2294] = {.lex_state = 75, .external_lex_state = 2},
  [2295] = {.lex_state = 75},
  [2296] = {.lex_state = 75},
  [2297] = {.lex_state = 75},
  [2298] = {.lex_state = 75},
  [2299] = {.lex_state = 75},
  [2300] = {.lex_state = 75},
  [2301] = {.lex_state = 75},
  [2302] = {.lex_state = 75},
  [2303] = {.lex_state = 75},
  [2304] = {.lex_state = 75},
  [2305] = {.lex_state = 75},
  [2306] = {.lex_state = 75, .external_lex_state = 2},
  [2307] = {.lex_state = 75},
  [2308] = {.lex_state = 75, .external_lex_state = 2},
  [2309] = {.lex_state = 75},
  [2310] = {.lex_state = 75},
  [2311] = {.lex_state = 75},
  [2312] = {.lex_state = 75},
  [2313] = {.lex_state = 75, .external_lex_state = 2},
  [2314] = {.lex_state = 75},
  [2315] = {.lex_state = 75, .external_lex_state = 2},
  [2316] = {.lex_state = 75},
  [2317] = {.lex_state = 75},
  [2318] = {.lex_state = 75},
  [2319] = {.lex_state = 75},
  [2320] = {.lex_state = 75},
  [2321] = {.lex_state = 75},
  [2322] = {.lex_state = 75},
  [2323] = {.lex_state = 75},
  [2324] = {.lex_state = 75},
  [2325] = {.lex_state = 75},
  [2326] = {.lex_state = 75},
  [2327] = {.lex_state = 75},
  [2328] = {.lex_state = 75, .external_lex_state = 2},
  [2329] = {.lex_state = 75},
  [2330] = {.lex_state = 75},
  [2331] = {.lex_state = 75},
  [2332] = {.lex_state = 14},
  [2333] = {.lex_state = 75, .external_lex_state = 2},
  [2334] = {.lex_state = 75},
  [2335] = {.lex_state = 75, .external_lex_state = 2},
  [2336] = {.lex_state = 75},
  [2337] = {.lex_state = 75},
  [2338] = {.lex_state = 75, .external_lex_state = 2},
  [2339] = {.lex_state = 75},
  [2340] = {.lex_state = 75, .external_lex_state = 2},
  [2341] = {.lex_state = 75},
  [2342] = {.lex_state = 75},
  [2343] = {.lex_state = 75},
  [2344] = {.lex_state = 75},
  [2345] = {.lex_state = 14},
  [2346] = {.lex_state = 75},
  [2347] = {.lex_state = 75},
  [2348] = {.lex_state = 75},
  [2349] = {.lex_state = 75, .external_lex_state = 2},
  [2350] = {.lex_state = 75},
  [2351] = {.lex_state = 75},
  [2352] = {.lex_state = 75},
  [2353] = {.lex_state = 75},
  [2354] = {.lex_state = 75},
  [2355] = {.lex_state = 75, .external_lex_state = 2},
  [2356] = {.lex_state = 14},
  [2357] = {.lex_state = 75},
  [2358] = {.lex_state = 75},
  [2359] = {.lex_state = 75},
  [2360] = {.lex_state = 75},
  [2361] = {.lex_state = 14},
  [2362] = {.lex_state = 75},
  [2363] = {.lex_state = 75, .external_lex_state = 2},
  [2364] = {.lex_state = 75, .external_lex_state = 2},
  [2365] = {.lex_state = 75},
  [2366] = {.lex_state = 75, .external_lex_state = 2},
  [2367] = {.lex_state = 75},
  [2368] = {.lex_state = 75, .external_lex_state = 2},
  [2369] = {.lex_state = 75, .external_lex_state = 2},
  [2370] = {.lex_state = 75},
  [2371] = {.lex_state = 5, .external_lex_state = 11},
  [2372] = {.lex_state = 75},
  [2373] = {.lex_state = 75},
  [2374] = {.lex_state = 75},
  [2375] = {.lex_state = 75},
  [2376] = {.lex_state = 75},
  [2377] = {.lex_state = 75},
  [2378] = {.lex_state = 75, .external_lex_state = 2},
  [2379] = {.lex_state = 75},
  [2380] = {.lex_state = 75},
  [2381] = {.lex_state = 75, .external_lex_state = 2},
  [2382] = {.lex_state = 5, .external_lex_state = 11},
  [2383] = {.lex_state = 5, .external_lex_state = 11},
  [2384] = {.lex_state = 75},
  [2385] = {.lex_state = 75, .external_lex_state = 2},
  [2386] = {.lex_state = 75},
  [2387] = {.lex_state = 75},
  [2388] = {.lex_state = 75, .external_lex_state = 2},
  [2389] = {.lex_state = 75, .external_lex_state = 2},
  [2390] = {.lex_state = 75, .external_lex_state = 2},
  [2391] = {.lex_state = 75},
  [2392] = {.lex_state = 75},
  [2393] = {.lex_state = 75},
  [2394] = {.lex_state = 75, .external_lex_state = 2},
  [2395] = {.lex_state = 75},
  [2396] = {.lex_state = 75, .external_lex_state = 2},
  [2397] = {.lex_state = 75},
  [2398] = {.lex_state = 75},
  [2399] = {.lex_state = 75},
  [2400] = {.lex_state = 75},
  [2401] = {.lex_state = 75, .external_lex_state = 2},
  [2402] = {.lex_state = 75},
  [2403] = {.lex_state = 75, .external_lex_state = 2},
  [2404] = {.lex_state = 75},
  [2405] = {.lex_state = 75},
  [2406] = {.lex_state = 75},
  [2407] = {.lex_state = 75},
  [2408] = {.lex_state = 75, .external_lex_state = 2},
  [2409] = {.lex_state = 75},
  [2410] = {.lex_state = 75},
  [2411] = {.lex_state = 75},
  [2412] = {.lex_state = 75},
  [2413] = {.lex_state = 75},
  [2414] = {.lex_state = 75},
  [2415] = {.lex_state = 75},
  [2416] = {.lex_state = 75},
  [2417] = {.lex_state = 75},
  [2418] = {.lex_state = 75},
  [2419] = {.lex_state = 75},
  [2420] = {.lex_state = 75},
  [2421] = {.lex_state = 75, .external_lex_state = 2},
  [2422] = {.lex_state = 75},
  [2423] = {.lex_state = 75},
  [2424] = {.lex_state = 75},
  [2425] = {.lex_state = 75},
  [2426] = {.lex_state = 75},
  [2427] = {.lex_state = 75, .external_lex_state = 2},
  [2428] = {.lex_state = 75},
  [2429] = {.lex_state = 75},
  [2430] = {.lex_state = 5, .external_lex_state = 11},
  [2431] = {.lex_state = 75, .external_lex_state = 2},
  [2432] = {.lex_state = 75, .external_lex_state = 2},
  [2433] = {.lex_state = 75, .external_lex_state = 2},
  [2434] = {.lex_state = 75},
  [2435] = {.lex_state = 75, .external_lex_state = 2},
  [2436] = {.lex_state = 75},
  [2437] = {.lex_state = 75},
  [2438] = {.lex_state = 75, .external_lex_state = 2},
  [2439] = {.lex_state = 75},
  [2440] = {.lex_state = 75},
  [2441] = {.lex_state = 75},
  [2442] = {.lex_state = 75, .external_lex_state = 2},
  [2443] = {.lex_state = 75},
  [2444] = {.lex_state = 75},
  [2445] = {.lex_state = 75},
  [2446] = {.lex_state = 75},
  [2447] = {.lex_state = 75, .external_lex_state = 11},
  [2448] = {.lex_state = 75},
  [2449] = {.lex_state = 75, .external_lex_state = 11},
  [2450] = {.lex_state = 75},
  [2451] = {.lex_state = 75},
  [2452] = {.lex_state = 75},
  [2453] = {.lex_state = 75},
  [2454] = {.lex_state = 75},
  [2455] = {.lex_state = 75},
  [2456] = {.lex_state = 75},
  [2457] = {.lex_state = 75},
  [2458] = {.lex_state = 75},
  [2459] = {.lex_state = 75},
  [2460] = {.lex_state = 75},
  [2461] = {.lex_state = 75},
  [2462] = {.lex_state = 75},
  [2463] = {.lex_state = 75},
  [2464] = {.lex_state = 75, .external_lex_state = 11},
  [2465] = {.lex_state = 75},
  [2466] = {.lex_state = 75},
  [2467] = {.lex_state = 75},
  [2468] = {.lex_state = 75},
  [2469] = {.lex_state = 75},
  [2470] = {.lex_state = 14},
  [2471] = {.lex_state = 75},
  [2472] = {.lex_state = 14},
  [2473] = {.lex_state = 75},
  [2474] = {.lex_state = 14},
  [2475] = {.lex_state = 75},
  [2476] = {.lex_state = 14},
  [2477] = {.lex_state = 14},
  [2478] = {.lex_state = 75},
  [2479] = {.lex_state = 14},
  [2480] = {.lex_state = 75},
  [2481] = {.lex_state = 75},
  [2482] = {.lex_state = 75},
  [2483] = {.lex_state = 75},
  [2484] = {.lex_state = 14},
  [2485] = {.lex_state = 75, .external_lex_state = 13},
  [2486] = {.lex_state = 75, .external_lex_state = 13},
  [2487] = {.lex_state = 75},
  [2488] = {.lex_state = 14},
  [2489] = {.lex_state = 14},
  [2490] = {.lex_state = 14},
  [2491] = {.lex_state = 75},
  [2492] = {.lex_state = 14},
  [2493] = {.lex_state = 75},
  [2494] = {.lex_state = 75},
  [2495] = {.lex_state = 75},
  [2496] = {.lex_state = 75},
  [2497] = {.lex_state = 75},
  [2498] = {.lex_state = 14},
  [2499] = {.lex_state = 14},
  [2500] = {.lex_state = 75},
  [2501] = {.lex_state = 75},
  [2502] = {.lex_state = 75},
  [2503] = {.lex_state = 75},
  [2504] = {.lex_state = 75},
  [2505] = {.lex_state = 75},
  [2506] = {.lex_state = 14},
  [2507] = {.lex_state = 14},
  [2508] = {.lex_state = 75},
  [2509] = {.lex_state = 75},
  [2510] = {.lex_state = 75},
  [2511] = {.lex_state = 14},
  [2512] = {.lex_state = 75},
  [2513] = {.lex_state = 14},
  [2514] = {.lex_state = 14},
  [2515] = {.lex_state = 14},
  [2516] = {.lex_state = 75, .external_lex_state = 11},
  [2517] = {.lex_state = 75, .external_lex_state = 11},
  [2518] = {.lex_state = 14},
  [2519] = {.lex_state = 14},
  [2520] = {.lex_state = 75},
  [2521] = {.lex_state = 14},
  [2522] = {.lex_state = 75},
  [2523] = {.lex_state = 75},
  [2524] = {.lex_state = 75},
  [2525] = {.lex_state = 75},
  [2526] = {.lex_state = 75},
  [2527] = {.lex_state = 14},
  [2528] = {.lex_state = 14},
  [2529] = {.lex_state = 14},
  [2530] = {.lex_state = 75},
  [2531] = {.lex_state = 14},
  [2532] = {.lex_state = 75},
  [2533] = {.lex_state = 14},
  [2534] = {.lex_state = 75},
  [2535] = {.lex_state = 14},
  [2536] = {.lex_state = 75},
  [2537] = {.lex_state = 75},
  [2538] = {.lex_state = 14},
  [2539] = {.lex_state = 75},
  [2540] = {.lex_state = 75},
  [2541] = {.lex_state = 75},
  [2542] = {.lex_state = 75},
  [2543] = {.lex_state = 75},
  [2544] = {.lex_state = 14},
  [2545] = {.lex_state = 14},
  [2546] = {.lex_state = 14},
  [2547] = {.lex_state = 14},
  [2548] = {.lex_state = 14},
  [2549] = {.lex_state = 75},
  [2550] = {.lex_state = 14},
  [2551] = {.lex_state = 14},
  [2552] = {.lex_state = 75},
  [2553] = {.lex_state = 75},
  [2554] = {.lex_state = 75},
  [2555] = {.lex_state = 14},
  [2556] = {.lex_state = 75},
  [2557] = {.lex_state = 14},
  [2558] = {.lex_state = 14},
  [2559] = {.lex_state = 75},
  [2560] = {.lex_state = 14},
  [2561] = {.lex_state = 14},
  [2562] = {.lex_state = 75},
  [2563] = {.lex_state = 75},
  [2564] = {.lex_state = 75},
  [2565] = {.lex_state = 14},
  [2566] = {.lex_state = 14},
  [2567] = {.lex_state = 75},
  [2568] = {.lex_state = 14},
  [2569] = {.lex_state = 14},
  [2570] = {.lex_state = 14},
  [2571] = {.lex_state = 14},
  [2572] = {.lex_state = 75, .external_lex_state = 13},
  [2573] = {.lex_state = 75, .external_lex_state = 13},
  [2574] = {.lex_state = 14},
  [2575] = {.lex_state = 75},
  [2576] = {.lex_state = 75},
  [2577] = {.lex_state = 14},
  [2578] = {.lex_state = 75},
  [2579] = {.lex_state = 75},
  [2580] = {.lex_state = 75},
  [2581] = {.lex_state = 14},
  [2582] = {.lex_state = 75},
  [2583] = {.lex_state = 14},
  [2584] = {.lex_state = 75},
  [2585] = {.lex_state = 75},
  [2586] = {.lex_state = 14},
  [2587] = {.lex_state = 75},
  [2588] = {.lex_state = 75},
  [2589] = {.lex_state = 14},
  [2590] = {.lex_state = 75},
  [2591] = {.lex_state = 75},
  [2592] = {.lex_state = 75},
  [2593] = {.lex_state = 14},
  [2594] = {.lex_state = 14},
  [2595] = {.lex_state = 14},
  [2596] = {.lex_state = 75},
  [2597] = {.lex_state = 14},
  [2598] = {.lex_state = 75},
  [2599] = {.lex_state = 75},
  [2600] = {.lex_state = 75},
  [2601] = {.lex_state = 75},
  [2602] = {.lex_state = 75},
  [2603] = {.lex_state = 75},
  [2604] = {.lex_state = 75},
  [2605] = {.lex_state = 14},
  [2606] = {.lex_state = 75},
  [2607] = {.lex_state = 14},
  [2608] = {.lex_state = 75},
  [2609] = {.lex_state = 14},
  [2610] = {.lex_state = 75},
  [2611] = {.lex_state = 14},
  [2612] = {.lex_state = 75},
  [2613] = {.lex_state = 75},
  [2614] = {.lex_state = 75},
  [2615] = {.lex_state = 75},
  [2616] = {.lex_state = 14},
  [2617] = {.lex_state = 75},
  [2618] = {.lex_state = 75},
  [2619] = {.lex_state = 75},
  [2620] = {.lex_state = 75},
  [2621] = {.lex_state = 14},
  [2622] = {.lex_state = 14},
  [2623] = {.lex_state = 75},
  [2624] = {.lex_state = 75},
  [2625] = {.lex_state = 75},
  [2626] = {.lex_state = 75},
  [2627] = {.lex_state = 14},
  [2628] = {.lex_state = 75},
  [2629] = {.lex_state = 75},
  [2630] = {.lex_state = 75},
  [2631] = {.lex_state = 75},
  [2632] = {.lex_state = 75},
  [2633] = {.lex_state = 75},
  [2634] = {.lex_state = 75},
  [2635] = {.lex_state = 14},
  [2636] = {.lex_state = 75},
  [2637] = {.lex_state = 75},
  [2638] = {.lex_state = 14},
  [2639] = {.lex_state = 75},
  [2640] = {.lex_state = 75},
  [2641] = {.lex_state = 14},
  [2642] = {.lex_state = 75},
  [2643] = {.lex_state = 75},
  [2644] = {.lex_state = 75},
  [2645] = {.lex_state = 14},
  [2646] = {.lex_state = 75},
  [2647] = {.lex_state = 75, .external_lex_state = 11},
  [2648] = {.lex_state = 75},
  [2649] = {.lex_state = 14},
  [2650] = {.lex_state = 75},
  [2651] = {.lex_state = 75},
  [2652] = {.lex_state = 75},
  [2653] = {.lex_state = 75},
  [2654] = {.lex_state = 75},
  [2655] = {.lex_state = 75},
  [2656] = {.lex_state = 75},
  [2657] = {.lex_state = 75},
  [2658] = {.lex_state = 75},
  [2659] = {.lex_state = 75},
  [2660] = {.lex_state = 75},
  [2661] = {.lex_state = 75},
  [2662] = {.lex_state = 75},
  [2663] = {.lex_state = 75},
  [2664] = {.lex_state = 75},
  [2665] = {.lex_state = 75},
  [2666] = {.lex_state = 75},
  [2667] = {.lex_state = 75},
  [2668] = {.lex_state = 75},
  [2669] = {.lex_state = 75},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_name] = ACTIONS(1),
    [anon_sym_QMARK_GT] = ACTIONS(1),
    [aux_sym_text_token1] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [aux_sym_global_declaration_token1] = ACTIONS(1),
    [aux_sym_namespace_definition_token1] = ACTIONS(1),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [aux_sym_namespace_aliasing_clause_token1] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [aux_sym_trait_declaration_token1] = ACTIONS(1),
    [aux_sym_interface_declaration_token1] = ACTIONS(1),
    [aux_sym_base_clause_token1] = ACTIONS(1),
    [aux_sym_enum_declaration_token1] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [aux_sym_enum_case_token1] = ACTIONS(1),
    [aux_sym_class_declaration_token1] = ACTIONS(1),
    [aux_sym_final_modifier_token1] = ACTIONS(1),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1),
    [aux_sym_class_interface_clause_token1] = ACTIONS(1),
    [sym_var_modifier] = ACTIONS(1),
    [aux_sym_use_instead_of_clause_token1] = ACTIONS(1),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [sym_bottom_type] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_array] = ACTIONS(1),
    [aux_sym_primitive_type_token1] = ACTIONS(1),
    [anon_sym_iterable] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_mixed] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_null] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [aux_sym_cast_type_token1] = ACTIONS(1),
    [aux_sym_cast_type_token2] = ACTIONS(1),
    [aux_sym_cast_type_token3] = ACTIONS(1),
    [aux_sym_cast_type_token4] = ACTIONS(1),
    [aux_sym_cast_type_token5] = ACTIONS(1),
    [aux_sym_cast_type_token6] = ACTIONS(1),
    [aux_sym_cast_type_token7] = ACTIONS(1),
    [aux_sym_cast_type_token8] = ACTIONS(1),
    [aux_sym_cast_type_token9] = ACTIONS(1),
    [aux_sym_cast_type_token10] = ACTIONS(1),
    [aux_sym_cast_type_token11] = ACTIONS(1),
    [aux_sym_cast_type_token12] = ACTIONS(1),
    [aux_sym_echo_statement_token1] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(1),
    [aux_sym_declare_statement_token1] = ACTIONS(1),
    [aux_sym_declare_statement_token2] = ACTIONS(1),
    [anon_sym_ticks] = ACTIONS(1),
    [anon_sym_encoding] = ACTIONS(1),
    [anon_sym_strict_types] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [aux_sym_try_statement_token1] = ACTIONS(1),
    [aux_sym_catch_clause_token1] = ACTIONS(1),
    [aux_sym_finally_clause_token1] = ACTIONS(1),
    [aux_sym_goto_statement_token1] = ACTIONS(1),
    [aux_sym_continue_statement_token1] = ACTIONS(1),
    [aux_sym_break_statement_token1] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [aux_sym_return_statement_token1] = ACTIONS(1),
    [aux_sym_throw_expression_token1] = ACTIONS(1),
    [aux_sym_while_statement_token1] = ACTIONS(1),
    [aux_sym_while_statement_token2] = ACTIONS(1),
    [aux_sym_do_statement_token1] = ACTIONS(1),
    [aux_sym_for_statement_token1] = ACTIONS(1),
    [aux_sym_for_statement_token2] = ACTIONS(1),
    [aux_sym_foreach_statement_token1] = ACTIONS(1),
    [aux_sym_foreach_statement_token2] = ACTIONS(1),
    [aux_sym_if_statement_token1] = ACTIONS(1),
    [aux_sym_if_statement_token2] = ACTIONS(1),
    [aux_sym_else_if_clause_token1] = ACTIONS(1),
    [aux_sym_else_clause_token1] = ACTIONS(1),
    [aux_sym_match_expression_token1] = ACTIONS(1),
    [aux_sym_match_default_expression_token1] = ACTIONS(1),
    [aux_sym_switch_statement_token1] = ACTIONS(1),
    [aux_sym_switch_block_token1] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [aux_sym_clone_expression_token1] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_QMARK_DASH_GT] = ACTIONS(1),
    [aux_sym__list_destructing_token1] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_self] = ACTIONS(1),
    [anon_sym_parent] = ACTIONS(1),
    [aux_sym__argument_name_token1] = ACTIONS(1),
    [aux_sym__argument_name_token2] = ACTIONS(1),
    [anon_sym_POUND_LBRACK] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_QMARK_GT2] = ACTIONS(1),
    [aux_sym_encapsed_string_token1] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [aux_sym_string_token1] = ACTIONS(1),
    [aux_sym_string_token2] = ACTIONS(1),
    [anon_sym_DQUOTE2] = ACTIONS(1),
    [anon_sym_SQUOTE2] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [aux_sym_yield_expression_token1] = ACTIONS(1),
    [aux_sym_yield_expression_token2] = ACTIONS(1),
    [aux_sym_binary_expression_token1] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [aux_sym_binary_expression_token2] = ACTIONS(1),
    [aux_sym_binary_expression_token3] = ACTIONS(1),
    [aux_sym_binary_expression_token4] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [aux_sym_include_expression_token1] = ACTIONS(1),
    [aux_sym_include_once_expression_token1] = ACTIONS(1),
    [aux_sym_require_expression_token1] = ACTIONS(1),
    [aux_sym_require_once_expression_token1] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym_encapsed_string_chars] = ACTIONS(1),
    [sym_encapsed_string_chars_after_variable] = ACTIONS(1),
    [sym_execution_string_chars] = ACTIONS(1),
    [sym_execution_string_chars_after_variable] = ACTIONS(1),
    [sym_encapsed_string_chars_heredoc] = ACTIONS(1),
    [sym_encapsed_string_chars_after_variable_heredoc] = ACTIONS(1),
    [sym__eof] = ACTIONS(1),
    [sym_heredoc_start] = ACTIONS(1),
    [sym_heredoc_end] = ACTIONS(1),
    [sym_nowdoc_string] = ACTIONS(1),
    [sym_sentinel_error] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(2552),
    [sym_empty_statement] = STATE(15),
    [sym_function_static_declaration] = STATE(15),
    [sym_global_declaration] = STATE(15),
    [sym_namespace_definition] = STATE(15),
    [sym_namespace_use_declaration] = STATE(15),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(15),
    [sym_interface_declaration] = STATE(15),
    [sym_enum_declaration] = STATE(15),
    [sym_class_declaration] = STATE(15),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(15),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(15),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(15),
    [sym_unset_statement] = STATE(15),
    [sym_declare_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_goto_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_foreach_statement] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(15),
    [sym_compound_statement] = STATE(15),
    [sym_named_label_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_name] = ACTIONS(7),
    [anon_sym_QMARK_GT] = ACTIONS(9),
    [sym_php_tag] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [ts_builtin_sym_end] = ACTIONS(133),
    [sym_name] = ACTIONS(135),
    [anon_sym_QMARK_GT] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(138),
    [aux_sym_function_static_declaration_token1] = ACTIONS(141),
    [aux_sym_global_declaration_token1] = ACTIONS(144),
    [aux_sym_namespace_definition_token1] = ACTIONS(147),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(150),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(153),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(156),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(162),
    [anon_sym_RBRACE] = ACTIONS(133),
    [aux_sym_trait_declaration_token1] = ACTIONS(165),
    [aux_sym_interface_declaration_token1] = ACTIONS(168),
    [aux_sym_enum_declaration_token1] = ACTIONS(171),
    [aux_sym_enum_case_token1] = ACTIONS(174),
    [aux_sym_class_declaration_token1] = ACTIONS(176),
    [aux_sym_final_modifier_token1] = ACTIONS(179),
    [aux_sym_abstract_modifier_token1] = ACTIONS(182),
    [aux_sym_readonly_modifier_token1] = ACTIONS(185),
    [aux_sym_visibility_modifier_token1] = ACTIONS(188),
    [aux_sym_visibility_modifier_token2] = ACTIONS(188),
    [aux_sym_visibility_modifier_token3] = ACTIONS(188),
    [aux_sym__arrow_function_header_token1] = ACTIONS(191),
    [anon_sym_LPAREN] = ACTIONS(194),
    [aux_sym_cast_type_token1] = ACTIONS(197),
    [aux_sym_echo_statement_token1] = ACTIONS(200),
    [anon_sym_unset] = ACTIONS(203),
    [aux_sym_declare_statement_token1] = ACTIONS(206),
    [aux_sym_declare_statement_token2] = ACTIONS(174),
    [sym_float] = ACTIONS(209),
    [aux_sym_try_statement_token1] = ACTIONS(212),
    [aux_sym_goto_statement_token1] = ACTIONS(215),
    [aux_sym_continue_statement_token1] = ACTIONS(218),
    [aux_sym_break_statement_token1] = ACTIONS(221),
    [sym_integer] = ACTIONS(209),
    [aux_sym_return_statement_token1] = ACTIONS(224),
    [aux_sym_throw_expression_token1] = ACTIONS(227),
    [aux_sym_while_statement_token1] = ACTIONS(230),
    [aux_sym_while_statement_token2] = ACTIONS(174),
    [aux_sym_do_statement_token1] = ACTIONS(233),
    [aux_sym_for_statement_token1] = ACTIONS(236),
    [aux_sym_for_statement_token2] = ACTIONS(174),
    [aux_sym_foreach_statement_token1] = ACTIONS(239),
    [aux_sym_foreach_statement_token2] = ACTIONS(174),
    [aux_sym_if_statement_token1] = ACTIONS(242),
    [aux_sym_if_statement_token2] = ACTIONS(174),
    [aux_sym_match_expression_token1] = ACTIONS(245),
    [aux_sym_match_default_expression_token1] = ACTIONS(174),
    [aux_sym_switch_statement_token1] = ACTIONS(248),
    [aux_sym_switch_block_token1] = ACTIONS(174),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_TILDE] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(254),
    [anon_sym_AT] = ACTIONS(257),
    [aux_sym_clone_expression_token1] = ACTIONS(260),
    [aux_sym_print_intrinsic_token1] = ACTIONS(263),
    [aux_sym_object_creation_expression_token1] = ACTIONS(266),
    [anon_sym_DASH_DASH] = ACTIONS(269),
    [anon_sym_PLUS_PLUS] = ACTIONS(269),
    [aux_sym__list_destructing_token1] = ACTIONS(272),
    [anon_sym_LBRACK] = ACTIONS(275),
    [anon_sym_self] = ACTIONS(278),
    [anon_sym_parent] = ACTIONS(278),
    [aux_sym__argument_name_token1] = ACTIONS(281),
    [aux_sym__argument_name_token2] = ACTIONS(284),
    [anon_sym_POUND_LBRACK] = ACTIONS(287),
    [anon_sym_SQUOTE] = ACTIONS(290),
    [aux_sym_encapsed_string_token1] = ACTIONS(293),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [aux_sym_string_token1] = ACTIONS(290),
    [anon_sym_LT_LT_LT] = ACTIONS(296),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(302),
    [aux_sym_yield_expression_token1] = ACTIONS(305),
    [aux_sym_include_expression_token1] = ACTIONS(308),
    [aux_sym_include_once_expression_token1] = ACTIONS(311),
    [aux_sym_require_expression_token1] = ACTIONS(314),
    [aux_sym_require_once_expression_token1] = ACTIONS(317),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_empty_statement] = STATE(6),
    [sym_function_static_declaration] = STATE(6),
    [sym_global_declaration] = STATE(6),
    [sym_namespace_definition] = STATE(6),
    [sym_namespace_use_declaration] = STATE(6),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(6),
    [sym_interface_declaration] = STATE(6),
    [sym_enum_declaration] = STATE(6),
    [sym_class_declaration] = STATE(6),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(6),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(6),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(6),
    [sym_unset_statement] = STATE(6),
    [sym_declare_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_goto_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_foreach_statement] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(6),
    [sym_compound_statement] = STATE(6),
    [sym_named_label_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(320),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_enum_case_token1] = ACTIONS(322),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_match_default_expression_token1] = ACTIONS(322),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [aux_sym_switch_block_token1] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym_empty_statement] = STATE(5),
    [sym_function_static_declaration] = STATE(5),
    [sym_global_declaration] = STATE(5),
    [sym_namespace_definition] = STATE(5),
    [sym_namespace_use_declaration] = STATE(5),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(5),
    [sym_interface_declaration] = STATE(5),
    [sym_enum_declaration] = STATE(5),
    [sym_class_declaration] = STATE(5),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(5),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(5),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(5),
    [sym_unset_statement] = STATE(5),
    [sym_declare_statement] = STATE(5),
    [sym_try_statement] = STATE(5),
    [sym_goto_statement] = STATE(5),
    [sym_continue_statement] = STATE(5),
    [sym_break_statement] = STATE(5),
    [sym_return_statement] = STATE(5),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(5),
    [sym_do_statement] = STATE(5),
    [sym_for_statement] = STATE(5),
    [sym_foreach_statement] = STATE(5),
    [sym_if_statement] = STATE(5),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(5),
    [sym_compound_statement] = STATE(5),
    [sym_named_label_statement] = STATE(5),
    [sym_expression_statement] = STATE(5),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(5),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(324),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_enum_case_token1] = ACTIONS(326),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_match_default_expression_token1] = ACTIONS(326),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [aux_sym_switch_block_token1] = ACTIONS(326),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(328),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_enum_case_token1] = ACTIONS(330),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_match_default_expression_token1] = ACTIONS(330),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [aux_sym_switch_block_token1] = ACTIONS(330),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(332),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_enum_case_token1] = ACTIONS(334),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_match_default_expression_token1] = ACTIONS(334),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [aux_sym_switch_block_token1] = ACTIONS(334),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym_empty_statement] = STATE(8),
    [sym_function_static_declaration] = STATE(8),
    [sym_global_declaration] = STATE(8),
    [sym_namespace_definition] = STATE(8),
    [sym_namespace_use_declaration] = STATE(8),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(8),
    [sym_interface_declaration] = STATE(8),
    [sym_enum_declaration] = STATE(8),
    [sym_class_declaration] = STATE(8),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(8),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(8),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(8),
    [sym_unset_statement] = STATE(8),
    [sym_declare_statement] = STATE(8),
    [sym_try_statement] = STATE(8),
    [sym_goto_statement] = STATE(8),
    [sym_continue_statement] = STATE(8),
    [sym_break_statement] = STATE(8),
    [sym_return_statement] = STATE(8),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(8),
    [sym_do_statement] = STATE(8),
    [sym_for_statement] = STATE(8),
    [sym_foreach_statement] = STATE(8),
    [sym_if_statement] = STATE(8),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(8),
    [sym_compound_statement] = STATE(8),
    [sym_named_label_statement] = STATE(8),
    [sym_expression_statement] = STATE(8),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(8),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_while_statement_token2] = ACTIONS(336),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_foreach_statement_token2] = ACTIONS(336),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_if_statement_token2] = ACTIONS(336),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_while_statement_token2] = ACTIONS(338),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_foreach_statement_token2] = ACTIONS(338),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_if_statement_token2] = ACTIONS(338),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym_empty_statement] = STATE(9),
    [sym_function_static_declaration] = STATE(9),
    [sym_global_declaration] = STATE(9),
    [sym_namespace_definition] = STATE(9),
    [sym_namespace_use_declaration] = STATE(9),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(9),
    [sym_interface_declaration] = STATE(9),
    [sym_enum_declaration] = STATE(9),
    [sym_class_declaration] = STATE(9),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(9),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(9),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(9),
    [sym_unset_statement] = STATE(9),
    [sym_declare_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_goto_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_foreach_statement] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(9),
    [sym_compound_statement] = STATE(9),
    [sym_named_label_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(138),
    [aux_sym_function_static_declaration_token1] = ACTIONS(141),
    [aux_sym_global_declaration_token1] = ACTIONS(144),
    [aux_sym_namespace_definition_token1] = ACTIONS(147),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(150),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(153),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(156),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(162),
    [aux_sym_trait_declaration_token1] = ACTIONS(165),
    [aux_sym_interface_declaration_token1] = ACTIONS(168),
    [aux_sym_enum_declaration_token1] = ACTIONS(171),
    [aux_sym_class_declaration_token1] = ACTIONS(176),
    [aux_sym_final_modifier_token1] = ACTIONS(179),
    [aux_sym_abstract_modifier_token1] = ACTIONS(182),
    [aux_sym_readonly_modifier_token1] = ACTIONS(185),
    [aux_sym_visibility_modifier_token1] = ACTIONS(188),
    [aux_sym_visibility_modifier_token2] = ACTIONS(188),
    [aux_sym_visibility_modifier_token3] = ACTIONS(188),
    [aux_sym__arrow_function_header_token1] = ACTIONS(191),
    [anon_sym_LPAREN] = ACTIONS(194),
    [aux_sym_cast_type_token1] = ACTIONS(197),
    [aux_sym_echo_statement_token1] = ACTIONS(200),
    [anon_sym_unset] = ACTIONS(203),
    [aux_sym_declare_statement_token1] = ACTIONS(340),
    [sym_float] = ACTIONS(209),
    [aux_sym_try_statement_token1] = ACTIONS(212),
    [aux_sym_goto_statement_token1] = ACTIONS(215),
    [aux_sym_continue_statement_token1] = ACTIONS(218),
    [aux_sym_break_statement_token1] = ACTIONS(221),
    [sym_integer] = ACTIONS(209),
    [aux_sym_return_statement_token1] = ACTIONS(224),
    [aux_sym_throw_expression_token1] = ACTIONS(227),
    [aux_sym_while_statement_token1] = ACTIONS(343),
    [aux_sym_do_statement_token1] = ACTIONS(233),
    [aux_sym_for_statement_token1] = ACTIONS(346),
    [aux_sym_foreach_statement_token1] = ACTIONS(349),
    [aux_sym_if_statement_token1] = ACTIONS(352),
    [aux_sym_if_statement_token2] = ACTIONS(174),
    [aux_sym_else_if_clause_token1] = ACTIONS(174),
    [aux_sym_else_clause_token1] = ACTIONS(174),
    [aux_sym_match_expression_token1] = ACTIONS(245),
    [aux_sym_switch_statement_token1] = ACTIONS(248),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_TILDE] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(254),
    [anon_sym_AT] = ACTIONS(257),
    [aux_sym_clone_expression_token1] = ACTIONS(260),
    [aux_sym_print_intrinsic_token1] = ACTIONS(263),
    [aux_sym_object_creation_expression_token1] = ACTIONS(266),
    [anon_sym_DASH_DASH] = ACTIONS(269),
    [anon_sym_PLUS_PLUS] = ACTIONS(269),
    [aux_sym__list_destructing_token1] = ACTIONS(272),
    [anon_sym_LBRACK] = ACTIONS(275),
    [anon_sym_self] = ACTIONS(278),
    [anon_sym_parent] = ACTIONS(278),
    [aux_sym__argument_name_token1] = ACTIONS(281),
    [aux_sym__argument_name_token2] = ACTIONS(284),
    [anon_sym_POUND_LBRACK] = ACTIONS(287),
    [anon_sym_SQUOTE] = ACTIONS(290),
    [aux_sym_encapsed_string_token1] = ACTIONS(293),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [aux_sym_string_token1] = ACTIONS(290),
    [anon_sym_LT_LT_LT] = ACTIONS(296),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(302),
    [aux_sym_yield_expression_token1] = ACTIONS(305),
    [aux_sym_include_expression_token1] = ACTIONS(308),
    [aux_sym_include_once_expression_token1] = ACTIONS(311),
    [aux_sym_require_expression_token1] = ACTIONS(314),
    [aux_sym_require_once_expression_token1] = ACTIONS(317),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_empty_statement] = STATE(9),
    [sym_function_static_declaration] = STATE(9),
    [sym_global_declaration] = STATE(9),
    [sym_namespace_definition] = STATE(9),
    [sym_namespace_use_declaration] = STATE(9),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(9),
    [sym_interface_declaration] = STATE(9),
    [sym_enum_declaration] = STATE(9),
    [sym_class_declaration] = STATE(9),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(9),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(9),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(9),
    [sym_unset_statement] = STATE(9),
    [sym_declare_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_goto_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_foreach_statement] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(9),
    [sym_compound_statement] = STATE(9),
    [sym_named_label_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(355),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(357),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(359),
    [aux_sym_foreach_statement_token1] = ACTIONS(361),
    [aux_sym_if_statement_token1] = ACTIONS(363),
    [aux_sym_if_statement_token2] = ACTIONS(338),
    [aux_sym_else_if_clause_token1] = ACTIONS(338),
    [aux_sym_else_clause_token1] = ACTIONS(338),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym_empty_statement] = STATE(10),
    [sym_function_static_declaration] = STATE(10),
    [sym_global_declaration] = STATE(10),
    [sym_namespace_definition] = STATE(10),
    [sym_namespace_use_declaration] = STATE(10),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(10),
    [sym_interface_declaration] = STATE(10),
    [sym_enum_declaration] = STATE(10),
    [sym_class_declaration] = STATE(10),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(10),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(10),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(10),
    [sym_unset_statement] = STATE(10),
    [sym_declare_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_goto_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_foreach_statement] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(10),
    [sym_compound_statement] = STATE(10),
    [sym_named_label_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(355),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(357),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(359),
    [aux_sym_foreach_statement_token1] = ACTIONS(361),
    [aux_sym_if_statement_token1] = ACTIONS(363),
    [aux_sym_if_statement_token2] = ACTIONS(336),
    [aux_sym_else_if_clause_token1] = ACTIONS(336),
    [aux_sym_else_clause_token1] = ACTIONS(336),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym_empty_statement] = STATE(2066),
    [sym_function_static_declaration] = STATE(2066),
    [sym_global_declaration] = STATE(2066),
    [sym_namespace_definition] = STATE(2066),
    [sym_namespace_use_declaration] = STATE(2066),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2066),
    [sym_interface_declaration] = STATE(2066),
    [sym_enum_declaration] = STATE(2066),
    [sym_class_declaration] = STATE(2066),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2066),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2066),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2066),
    [sym_unset_statement] = STATE(2066),
    [sym_declare_statement] = STATE(2066),
    [sym_try_statement] = STATE(2066),
    [sym_goto_statement] = STATE(2066),
    [sym_continue_statement] = STATE(2066),
    [sym_break_statement] = STATE(2066),
    [sym_return_statement] = STATE(2066),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2066),
    [sym_do_statement] = STATE(2066),
    [sym_for_statement] = STATE(2066),
    [sym_foreach_statement] = STATE(2066),
    [sym_if_statement] = STATE(2066),
    [sym_colon_block] = STATE(2492),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2066),
    [sym_compound_statement] = STATE(2066),
    [sym_named_label_statement] = STATE(2066),
    [sym_expression_statement] = STATE(2066),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(367),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(387),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(395),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(407),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(411),
    [aux_sym_foreach_statement_token1] = ACTIONS(413),
    [aux_sym_if_statement_token1] = ACTIONS(415),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(419),
  },
  [13] = {
    [sym_empty_statement] = STATE(14),
    [sym_function_static_declaration] = STATE(14),
    [sym_global_declaration] = STATE(14),
    [sym_namespace_definition] = STATE(14),
    [sym_namespace_use_declaration] = STATE(14),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(14),
    [sym_interface_declaration] = STATE(14),
    [sym_enum_declaration] = STATE(14),
    [sym_class_declaration] = STATE(14),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(14),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(14),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(14),
    [sym_unset_statement] = STATE(14),
    [sym_declare_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_goto_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_foreach_statement] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(14),
    [sym_compound_statement] = STATE(14),
    [sym_named_label_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [ts_builtin_sym_end] = ACTIONS(421),
    [sym_name] = ACTIONS(7),
    [anon_sym_QMARK_GT] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [ts_builtin_sym_end] = ACTIONS(425),
    [sym_name] = ACTIONS(7),
    [anon_sym_QMARK_GT] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [ts_builtin_sym_end] = ACTIONS(421),
    [sym_name] = ACTIONS(7),
    [anon_sym_QMARK_GT] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym_empty_statement] = STATE(2066),
    [sym_function_static_declaration] = STATE(2066),
    [sym_global_declaration] = STATE(2066),
    [sym_namespace_definition] = STATE(2066),
    [sym_namespace_use_declaration] = STATE(2066),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2066),
    [sym_interface_declaration] = STATE(2066),
    [sym_enum_declaration] = STATE(2066),
    [sym_class_declaration] = STATE(2066),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2066),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2066),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2066),
    [sym_unset_statement] = STATE(2066),
    [sym_declare_statement] = STATE(2066),
    [sym_try_statement] = STATE(2066),
    [sym_goto_statement] = STATE(2066),
    [sym_continue_statement] = STATE(2066),
    [sym_break_statement] = STATE(2066),
    [sym_return_statement] = STATE(2066),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2066),
    [sym_do_statement] = STATE(2066),
    [sym_for_statement] = STATE(2066),
    [sym_foreach_statement] = STATE(2066),
    [sym_if_statement] = STATE(2066),
    [sym_colon_block] = STATE(2492),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2066),
    [sym_compound_statement] = STATE(2066),
    [sym_named_label_statement] = STATE(2066),
    [sym_expression_statement] = STATE(2066),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(367),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(387),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(429),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(431),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(433),
    [aux_sym_foreach_statement_token1] = ACTIONS(435),
    [aux_sym_if_statement_token1] = ACTIONS(437),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(419),
  },
  [17] = {
    [sym_empty_statement] = STATE(483),
    [sym_function_static_declaration] = STATE(483),
    [sym_global_declaration] = STATE(483),
    [sym_namespace_definition] = STATE(483),
    [sym_namespace_use_declaration] = STATE(483),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(483),
    [sym_interface_declaration] = STATE(483),
    [sym_enum_declaration] = STATE(483),
    [sym_class_declaration] = STATE(483),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(483),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(483),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(483),
    [sym_unset_statement] = STATE(483),
    [sym_declare_statement] = STATE(483),
    [sym_try_statement] = STATE(483),
    [sym_goto_statement] = STATE(483),
    [sym_continue_statement] = STATE(483),
    [sym_break_statement] = STATE(483),
    [sym_return_statement] = STATE(483),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(483),
    [sym_do_statement] = STATE(483),
    [sym_for_statement] = STATE(483),
    [sym_foreach_statement] = STATE(483),
    [sym_if_statement] = STATE(483),
    [sym_colon_block] = STATE(2488),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(483),
    [sym_compound_statement] = STATE(483),
    [sym_named_label_statement] = STATE(483),
    [sym_expression_statement] = STATE(483),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(439),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(387),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(355),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(357),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(359),
    [aux_sym_foreach_statement_token1] = ACTIONS(361),
    [aux_sym_if_statement_token1] = ACTIONS(363),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(441),
  },
  [18] = {
    [sym_empty_statement] = STATE(483),
    [sym_function_static_declaration] = STATE(483),
    [sym_global_declaration] = STATE(483),
    [sym_namespace_definition] = STATE(483),
    [sym_namespace_use_declaration] = STATE(483),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(483),
    [sym_interface_declaration] = STATE(483),
    [sym_enum_declaration] = STATE(483),
    [sym_class_declaration] = STATE(483),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(483),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(483),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(483),
    [sym_unset_statement] = STATE(483),
    [sym_declare_statement] = STATE(483),
    [sym_try_statement] = STATE(483),
    [sym_goto_statement] = STATE(483),
    [sym_continue_statement] = STATE(483),
    [sym_break_statement] = STATE(483),
    [sym_return_statement] = STATE(483),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(483),
    [sym_do_statement] = STATE(483),
    [sym_for_statement] = STATE(483),
    [sym_foreach_statement] = STATE(483),
    [sym_if_statement] = STATE(483),
    [sym_colon_block] = STATE(2488),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(483),
    [sym_compound_statement] = STATE(483),
    [sym_named_label_statement] = STATE(483),
    [sym_expression_statement] = STATE(483),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(439),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(387),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(441),
  },
  [19] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(443),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym_empty_statement] = STATE(2136),
    [sym_function_static_declaration] = STATE(2136),
    [sym_global_declaration] = STATE(2136),
    [sym_namespace_definition] = STATE(2136),
    [sym_namespace_use_declaration] = STATE(2136),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2136),
    [sym_interface_declaration] = STATE(2136),
    [sym_enum_declaration] = STATE(2136),
    [sym_class_declaration] = STATE(2136),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2136),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2136),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2136),
    [sym_unset_statement] = STATE(2136),
    [sym_declare_statement] = STATE(2136),
    [sym_try_statement] = STATE(2136),
    [sym_goto_statement] = STATE(2136),
    [sym_continue_statement] = STATE(2136),
    [sym_break_statement] = STATE(2136),
    [sym_return_statement] = STATE(2136),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2136),
    [sym_do_statement] = STATE(2136),
    [sym_for_statement] = STATE(2136),
    [sym_foreach_statement] = STATE(2136),
    [sym_if_statement] = STATE(2136),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2136),
    [sym_compound_statement] = STATE(2136),
    [sym_named_label_statement] = STATE(2136),
    [sym_expression_statement] = STATE(2136),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(445),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(447),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(429),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(431),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(433),
    [aux_sym_foreach_statement_token1] = ACTIONS(435),
    [aux_sym_if_statement_token1] = ACTIONS(437),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(449),
  },
  [21] = {
    [sym_empty_statement] = STATE(29),
    [sym_function_static_declaration] = STATE(29),
    [sym_global_declaration] = STATE(29),
    [sym_namespace_definition] = STATE(29),
    [sym_namespace_use_declaration] = STATE(29),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(29),
    [sym_interface_declaration] = STATE(29),
    [sym_enum_declaration] = STATE(29),
    [sym_class_declaration] = STATE(29),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(29),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(29),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(29),
    [sym_unset_statement] = STATE(29),
    [sym_declare_statement] = STATE(29),
    [sym_try_statement] = STATE(29),
    [sym_goto_statement] = STATE(29),
    [sym_continue_statement] = STATE(29),
    [sym_break_statement] = STATE(29),
    [sym_return_statement] = STATE(29),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(29),
    [sym_do_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_foreach_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(29),
    [sym_compound_statement] = STATE(29),
    [sym_named_label_statement] = STATE(29),
    [sym_expression_statement] = STATE(29),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(29),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(451),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_empty_statement] = STATE(2038),
    [sym_function_static_declaration] = STATE(2038),
    [sym_global_declaration] = STATE(2038),
    [sym_namespace_definition] = STATE(2038),
    [sym_namespace_use_declaration] = STATE(2038),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2038),
    [sym_interface_declaration] = STATE(2038),
    [sym_enum_declaration] = STATE(2038),
    [sym_class_declaration] = STATE(2038),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2038),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2038),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2038),
    [sym_unset_statement] = STATE(2038),
    [sym_declare_statement] = STATE(2038),
    [sym_try_statement] = STATE(2038),
    [sym_goto_statement] = STATE(2038),
    [sym_continue_statement] = STATE(2038),
    [sym_break_statement] = STATE(2038),
    [sym_return_statement] = STATE(2038),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2038),
    [sym_do_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_foreach_statement] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2038),
    [sym_compound_statement] = STATE(2038),
    [sym_named_label_statement] = STATE(2038),
    [sym_expression_statement] = STATE(2038),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(453),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(455),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(395),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(407),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(411),
    [aux_sym_foreach_statement_token1] = ACTIONS(413),
    [aux_sym_if_statement_token1] = ACTIONS(415),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(457),
  },
  [23] = {
    [sym_empty_statement] = STATE(2105),
    [sym_function_static_declaration] = STATE(2105),
    [sym_global_declaration] = STATE(2105),
    [sym_namespace_definition] = STATE(2105),
    [sym_namespace_use_declaration] = STATE(2105),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2105),
    [sym_interface_declaration] = STATE(2105),
    [sym_enum_declaration] = STATE(2105),
    [sym_class_declaration] = STATE(2105),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2105),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2105),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2105),
    [sym_unset_statement] = STATE(2105),
    [sym_declare_statement] = STATE(2105),
    [sym_try_statement] = STATE(2105),
    [sym_goto_statement] = STATE(2105),
    [sym_continue_statement] = STATE(2105),
    [sym_break_statement] = STATE(2105),
    [sym_return_statement] = STATE(2105),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2105),
    [sym_do_statement] = STATE(2105),
    [sym_for_statement] = STATE(2105),
    [sym_foreach_statement] = STATE(2105),
    [sym_if_statement] = STATE(2105),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2105),
    [sym_compound_statement] = STATE(2105),
    [sym_named_label_statement] = STATE(2105),
    [sym_expression_statement] = STATE(2105),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(459),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(461),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(395),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(407),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(411),
    [aux_sym_foreach_statement_token1] = ACTIONS(413),
    [aux_sym_if_statement_token1] = ACTIONS(415),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(463),
  },
  [24] = {
    [sym_empty_statement] = STATE(523),
    [sym_function_static_declaration] = STATE(523),
    [sym_global_declaration] = STATE(523),
    [sym_namespace_definition] = STATE(523),
    [sym_namespace_use_declaration] = STATE(523),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(523),
    [sym_interface_declaration] = STATE(523),
    [sym_enum_declaration] = STATE(523),
    [sym_class_declaration] = STATE(523),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(523),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(523),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(523),
    [sym_unset_statement] = STATE(523),
    [sym_declare_statement] = STATE(523),
    [sym_try_statement] = STATE(523),
    [sym_goto_statement] = STATE(523),
    [sym_continue_statement] = STATE(523),
    [sym_break_statement] = STATE(523),
    [sym_return_statement] = STATE(523),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(523),
    [sym_do_statement] = STATE(523),
    [sym_for_statement] = STATE(523),
    [sym_foreach_statement] = STATE(523),
    [sym_if_statement] = STATE(523),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(523),
    [sym_compound_statement] = STATE(523),
    [sym_named_label_statement] = STATE(523),
    [sym_expression_statement] = STATE(523),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(465),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(467),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(355),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(357),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(359),
    [aux_sym_foreach_statement_token1] = ACTIONS(361),
    [aux_sym_if_statement_token1] = ACTIONS(363),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(469),
  },
  [25] = {
    [sym_empty_statement] = STATE(52),
    [sym_function_static_declaration] = STATE(52),
    [sym_global_declaration] = STATE(52),
    [sym_namespace_definition] = STATE(52),
    [sym_namespace_use_declaration] = STATE(52),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(52),
    [sym_interface_declaration] = STATE(52),
    [sym_enum_declaration] = STATE(52),
    [sym_class_declaration] = STATE(52),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(52),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(52),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(52),
    [sym_unset_statement] = STATE(52),
    [sym_declare_statement] = STATE(52),
    [sym_try_statement] = STATE(52),
    [sym_goto_statement] = STATE(52),
    [sym_continue_statement] = STATE(52),
    [sym_break_statement] = STATE(52),
    [sym_return_statement] = STATE(52),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(52),
    [sym_do_statement] = STATE(52),
    [sym_for_statement] = STATE(52),
    [sym_foreach_statement] = STATE(52),
    [sym_if_statement] = STATE(52),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(52),
    [sym_compound_statement] = STATE(52),
    [sym_named_label_statement] = STATE(52),
    [sym_expression_statement] = STATE(52),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(52),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(471),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym_empty_statement] = STATE(479),
    [sym_function_static_declaration] = STATE(479),
    [sym_global_declaration] = STATE(479),
    [sym_namespace_definition] = STATE(479),
    [sym_namespace_use_declaration] = STATE(479),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(479),
    [sym_interface_declaration] = STATE(479),
    [sym_enum_declaration] = STATE(479),
    [sym_class_declaration] = STATE(479),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(479),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(479),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(479),
    [sym_unset_statement] = STATE(479),
    [sym_declare_statement] = STATE(479),
    [sym_try_statement] = STATE(479),
    [sym_goto_statement] = STATE(479),
    [sym_continue_statement] = STATE(479),
    [sym_break_statement] = STATE(479),
    [sym_return_statement] = STATE(479),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(479),
    [sym_do_statement] = STATE(479),
    [sym_for_statement] = STATE(479),
    [sym_foreach_statement] = STATE(479),
    [sym_if_statement] = STATE(479),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(479),
    [sym_compound_statement] = STATE(479),
    [sym_named_label_statement] = STATE(479),
    [sym_expression_statement] = STATE(479),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(473),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(475),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(477),
  },
  [27] = {
    [sym_empty_statement] = STATE(509),
    [sym_function_static_declaration] = STATE(509),
    [sym_global_declaration] = STATE(509),
    [sym_namespace_definition] = STATE(509),
    [sym_namespace_use_declaration] = STATE(509),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(509),
    [sym_interface_declaration] = STATE(509),
    [sym_enum_declaration] = STATE(509),
    [sym_class_declaration] = STATE(509),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(509),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(509),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(509),
    [sym_unset_statement] = STATE(509),
    [sym_declare_statement] = STATE(509),
    [sym_try_statement] = STATE(509),
    [sym_goto_statement] = STATE(509),
    [sym_continue_statement] = STATE(509),
    [sym_break_statement] = STATE(509),
    [sym_return_statement] = STATE(509),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(509),
    [sym_do_statement] = STATE(509),
    [sym_for_statement] = STATE(509),
    [sym_foreach_statement] = STATE(509),
    [sym_if_statement] = STATE(509),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(509),
    [sym_compound_statement] = STATE(509),
    [sym_named_label_statement] = STATE(509),
    [sym_expression_statement] = STATE(509),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(479),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(481),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(355),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(357),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(359),
    [aux_sym_foreach_statement_token1] = ACTIONS(361),
    [aux_sym_if_statement_token1] = ACTIONS(363),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(483),
  },
  [28] = {
    [sym_empty_statement] = STATE(479),
    [sym_function_static_declaration] = STATE(479),
    [sym_global_declaration] = STATE(479),
    [sym_namespace_definition] = STATE(479),
    [sym_namespace_use_declaration] = STATE(479),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(479),
    [sym_interface_declaration] = STATE(479),
    [sym_enum_declaration] = STATE(479),
    [sym_class_declaration] = STATE(479),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(479),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(479),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(479),
    [sym_unset_statement] = STATE(479),
    [sym_declare_statement] = STATE(479),
    [sym_try_statement] = STATE(479),
    [sym_goto_statement] = STATE(479),
    [sym_continue_statement] = STATE(479),
    [sym_break_statement] = STATE(479),
    [sym_return_statement] = STATE(479),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(479),
    [sym_do_statement] = STATE(479),
    [sym_for_statement] = STATE(479),
    [sym_foreach_statement] = STATE(479),
    [sym_if_statement] = STATE(479),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(479),
    [sym_compound_statement] = STATE(479),
    [sym_named_label_statement] = STATE(479),
    [sym_expression_statement] = STATE(479),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(473),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(475),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(355),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(357),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(359),
    [aux_sym_foreach_statement_token1] = ACTIONS(361),
    [aux_sym_if_statement_token1] = ACTIONS(363),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(477),
  },
  [29] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(485),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(487),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym_empty_statement] = STATE(2039),
    [sym_function_static_declaration] = STATE(2039),
    [sym_global_declaration] = STATE(2039),
    [sym_namespace_definition] = STATE(2039),
    [sym_namespace_use_declaration] = STATE(2039),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2039),
    [sym_interface_declaration] = STATE(2039),
    [sym_enum_declaration] = STATE(2039),
    [sym_class_declaration] = STATE(2039),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2039),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2039),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2039),
    [sym_unset_statement] = STATE(2039),
    [sym_declare_statement] = STATE(2039),
    [sym_try_statement] = STATE(2039),
    [sym_goto_statement] = STATE(2039),
    [sym_continue_statement] = STATE(2039),
    [sym_break_statement] = STATE(2039),
    [sym_return_statement] = STATE(2039),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2039),
    [sym_do_statement] = STATE(2039),
    [sym_for_statement] = STATE(2039),
    [sym_foreach_statement] = STATE(2039),
    [sym_if_statement] = STATE(2039),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2039),
    [sym_compound_statement] = STATE(2039),
    [sym_named_label_statement] = STATE(2039),
    [sym_expression_statement] = STATE(2039),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(489),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(491),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(395),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(407),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(411),
    [aux_sym_foreach_statement_token1] = ACTIONS(413),
    [aux_sym_if_statement_token1] = ACTIONS(415),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(493),
  },
  [32] = {
    [sym_empty_statement] = STATE(2101),
    [sym_function_static_declaration] = STATE(2101),
    [sym_global_declaration] = STATE(2101),
    [sym_namespace_definition] = STATE(2101),
    [sym_namespace_use_declaration] = STATE(2101),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2101),
    [sym_interface_declaration] = STATE(2101),
    [sym_enum_declaration] = STATE(2101),
    [sym_class_declaration] = STATE(2101),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2101),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2101),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2101),
    [sym_unset_statement] = STATE(2101),
    [sym_declare_statement] = STATE(2101),
    [sym_try_statement] = STATE(2101),
    [sym_goto_statement] = STATE(2101),
    [sym_continue_statement] = STATE(2101),
    [sym_break_statement] = STATE(2101),
    [sym_return_statement] = STATE(2101),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2101),
    [sym_do_statement] = STATE(2101),
    [sym_for_statement] = STATE(2101),
    [sym_foreach_statement] = STATE(2101),
    [sym_if_statement] = STATE(2101),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2101),
    [sym_compound_statement] = STATE(2101),
    [sym_named_label_statement] = STATE(2101),
    [sym_expression_statement] = STATE(2101),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(495),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(497),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(395),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(407),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(411),
    [aux_sym_foreach_statement_token1] = ACTIONS(413),
    [aux_sym_if_statement_token1] = ACTIONS(415),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(499),
  },
  [33] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [aux_sym_declare_statement_token2] = ACTIONS(501),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [34] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [aux_sym_declare_statement_token2] = ACTIONS(503),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym_empty_statement] = STATE(2080),
    [sym_function_static_declaration] = STATE(2080),
    [sym_global_declaration] = STATE(2080),
    [sym_namespace_definition] = STATE(2080),
    [sym_namespace_use_declaration] = STATE(2080),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2080),
    [sym_interface_declaration] = STATE(2080),
    [sym_enum_declaration] = STATE(2080),
    [sym_class_declaration] = STATE(2080),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2080),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2080),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2080),
    [sym_unset_statement] = STATE(2080),
    [sym_declare_statement] = STATE(2080),
    [sym_try_statement] = STATE(2080),
    [sym_goto_statement] = STATE(2080),
    [sym_continue_statement] = STATE(2080),
    [sym_break_statement] = STATE(2080),
    [sym_return_statement] = STATE(2080),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2080),
    [sym_do_statement] = STATE(2080),
    [sym_for_statement] = STATE(2080),
    [sym_foreach_statement] = STATE(2080),
    [sym_if_statement] = STATE(2080),
    [sym_colon_block] = STATE(2538),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2080),
    [sym_compound_statement] = STATE(2080),
    [sym_named_label_statement] = STATE(2080),
    [sym_expression_statement] = STATE(2080),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(505),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(387),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(429),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(431),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(433),
    [aux_sym_foreach_statement_token1] = ACTIONS(435),
    [aux_sym_if_statement_token1] = ACTIONS(437),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym_empty_statement] = STATE(551),
    [sym_function_static_declaration] = STATE(551),
    [sym_global_declaration] = STATE(551),
    [sym_namespace_definition] = STATE(551),
    [sym_namespace_use_declaration] = STATE(551),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(551),
    [sym_interface_declaration] = STATE(551),
    [sym_enum_declaration] = STATE(551),
    [sym_class_declaration] = STATE(551),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(551),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(551),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(551),
    [sym_unset_statement] = STATE(551),
    [sym_declare_statement] = STATE(551),
    [sym_try_statement] = STATE(551),
    [sym_goto_statement] = STATE(551),
    [sym_continue_statement] = STATE(551),
    [sym_break_statement] = STATE(551),
    [sym_return_statement] = STATE(551),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(551),
    [sym_do_statement] = STATE(551),
    [sym_for_statement] = STATE(551),
    [sym_foreach_statement] = STATE(551),
    [sym_if_statement] = STATE(551),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(551),
    [sym_compound_statement] = STATE(551),
    [sym_named_label_statement] = STATE(551),
    [sym_expression_statement] = STATE(551),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(507),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(509),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(355),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(357),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(359),
    [aux_sym_foreach_statement_token1] = ACTIONS(361),
    [aux_sym_if_statement_token1] = ACTIONS(363),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(511),
  },
  [37] = {
    [sym_empty_statement] = STATE(34),
    [sym_function_static_declaration] = STATE(34),
    [sym_global_declaration] = STATE(34),
    [sym_namespace_definition] = STATE(34),
    [sym_namespace_use_declaration] = STATE(34),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(34),
    [sym_interface_declaration] = STATE(34),
    [sym_enum_declaration] = STATE(34),
    [sym_class_declaration] = STATE(34),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(34),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(34),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(34),
    [sym_unset_statement] = STATE(34),
    [sym_declare_statement] = STATE(34),
    [sym_try_statement] = STATE(34),
    [sym_goto_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(34),
    [sym_do_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_foreach_statement] = STATE(34),
    [sym_if_statement] = STATE(34),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(34),
    [sym_compound_statement] = STATE(34),
    [sym_named_label_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(34),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [aux_sym_declare_statement_token2] = ACTIONS(513),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [38] = {
    [sym_empty_statement] = STATE(1623),
    [sym_function_static_declaration] = STATE(1623),
    [sym_global_declaration] = STATE(1623),
    [sym_namespace_definition] = STATE(1623),
    [sym_namespace_use_declaration] = STATE(1623),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(1623),
    [sym_interface_declaration] = STATE(1623),
    [sym_enum_declaration] = STATE(1623),
    [sym_class_declaration] = STATE(1623),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(1623),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(1623),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(1623),
    [sym_unset_statement] = STATE(1623),
    [sym_declare_statement] = STATE(1623),
    [sym_try_statement] = STATE(1623),
    [sym_goto_statement] = STATE(1623),
    [sym_continue_statement] = STATE(1623),
    [sym_break_statement] = STATE(1623),
    [sym_return_statement] = STATE(1623),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(1623),
    [sym_do_statement] = STATE(1623),
    [sym_for_statement] = STATE(1623),
    [sym_foreach_statement] = STATE(1623),
    [sym_if_statement] = STATE(1623),
    [sym_colon_block] = STATE(1654),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(1623),
    [sym_compound_statement] = STATE(1623),
    [sym_named_label_statement] = STATE(1623),
    [sym_expression_statement] = STATE(1623),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(505),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(515),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(429),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(431),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(433),
    [aux_sym_foreach_statement_token1] = ACTIONS(435),
    [aux_sym_if_statement_token1] = ACTIONS(437),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [39] = {
    [sym_empty_statement] = STATE(457),
    [sym_function_static_declaration] = STATE(457),
    [sym_global_declaration] = STATE(457),
    [sym_namespace_definition] = STATE(457),
    [sym_namespace_use_declaration] = STATE(457),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(457),
    [sym_interface_declaration] = STATE(457),
    [sym_enum_declaration] = STATE(457),
    [sym_class_declaration] = STATE(457),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(457),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(457),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(457),
    [sym_unset_statement] = STATE(457),
    [sym_declare_statement] = STATE(457),
    [sym_try_statement] = STATE(457),
    [sym_goto_statement] = STATE(457),
    [sym_continue_statement] = STATE(457),
    [sym_break_statement] = STATE(457),
    [sym_return_statement] = STATE(457),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(457),
    [sym_do_statement] = STATE(457),
    [sym_for_statement] = STATE(457),
    [sym_foreach_statement] = STATE(457),
    [sym_if_statement] = STATE(457),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(457),
    [sym_compound_statement] = STATE(457),
    [sym_named_label_statement] = STATE(457),
    [sym_expression_statement] = STATE(457),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(517),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(519),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(355),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(357),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(359),
    [aux_sym_foreach_statement_token1] = ACTIONS(361),
    [aux_sym_if_statement_token1] = ACTIONS(363),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(521),
  },
  [40] = {
    [sym_empty_statement] = STATE(44),
    [sym_function_static_declaration] = STATE(44),
    [sym_global_declaration] = STATE(44),
    [sym_namespace_definition] = STATE(44),
    [sym_namespace_use_declaration] = STATE(44),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(44),
    [sym_interface_declaration] = STATE(44),
    [sym_enum_declaration] = STATE(44),
    [sym_class_declaration] = STATE(44),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(44),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(44),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(44),
    [sym_unset_statement] = STATE(44),
    [sym_declare_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_foreach_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_named_label_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(44),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(523),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [sym_empty_statement] = STATE(521),
    [sym_function_static_declaration] = STATE(521),
    [sym_global_declaration] = STATE(521),
    [sym_namespace_definition] = STATE(521),
    [sym_namespace_use_declaration] = STATE(521),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(521),
    [sym_interface_declaration] = STATE(521),
    [sym_enum_declaration] = STATE(521),
    [sym_class_declaration] = STATE(521),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(521),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(521),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(521),
    [sym_unset_statement] = STATE(521),
    [sym_declare_statement] = STATE(521),
    [sym_try_statement] = STATE(521),
    [sym_goto_statement] = STATE(521),
    [sym_continue_statement] = STATE(521),
    [sym_break_statement] = STATE(521),
    [sym_return_statement] = STATE(521),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(521),
    [sym_do_statement] = STATE(521),
    [sym_for_statement] = STATE(521),
    [sym_foreach_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_colon_block] = STATE(2560),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(521),
    [sym_compound_statement] = STATE(521),
    [sym_named_label_statement] = STATE(521),
    [sym_expression_statement] = STATE(521),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(387),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(355),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(357),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(359),
    [aux_sym_foreach_statement_token1] = ACTIONS(361),
    [aux_sym_if_statement_token1] = ACTIONS(363),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym_empty_statement] = STATE(426),
    [sym_function_static_declaration] = STATE(426),
    [sym_global_declaration] = STATE(426),
    [sym_namespace_definition] = STATE(426),
    [sym_namespace_use_declaration] = STATE(426),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(426),
    [sym_interface_declaration] = STATE(426),
    [sym_enum_declaration] = STATE(426),
    [sym_class_declaration] = STATE(426),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(426),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(426),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(426),
    [sym_unset_statement] = STATE(426),
    [sym_declare_statement] = STATE(426),
    [sym_try_statement] = STATE(426),
    [sym_goto_statement] = STATE(426),
    [sym_continue_statement] = STATE(426),
    [sym_break_statement] = STATE(426),
    [sym_return_statement] = STATE(426),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(426),
    [sym_do_statement] = STATE(426),
    [sym_for_statement] = STATE(426),
    [sym_foreach_statement] = STATE(426),
    [sym_if_statement] = STATE(426),
    [sym_colon_block] = STATE(1626),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(426),
    [sym_compound_statement] = STATE(426),
    [sym_named_label_statement] = STATE(426),
    [sym_expression_statement] = STATE(426),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(515),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(355),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(357),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(359),
    [aux_sym_foreach_statement_token1] = ACTIONS(361),
    [aux_sym_if_statement_token1] = ACTIONS(363),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(525),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [44] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(527),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym_empty_statement] = STATE(2038),
    [sym_function_static_declaration] = STATE(2038),
    [sym_global_declaration] = STATE(2038),
    [sym_namespace_definition] = STATE(2038),
    [sym_namespace_use_declaration] = STATE(2038),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2038),
    [sym_interface_declaration] = STATE(2038),
    [sym_enum_declaration] = STATE(2038),
    [sym_class_declaration] = STATE(2038),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2038),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2038),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2038),
    [sym_unset_statement] = STATE(2038),
    [sym_declare_statement] = STATE(2038),
    [sym_try_statement] = STATE(2038),
    [sym_goto_statement] = STATE(2038),
    [sym_continue_statement] = STATE(2038),
    [sym_break_statement] = STATE(2038),
    [sym_return_statement] = STATE(2038),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2038),
    [sym_do_statement] = STATE(2038),
    [sym_for_statement] = STATE(2038),
    [sym_foreach_statement] = STATE(2038),
    [sym_if_statement] = STATE(2038),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2038),
    [sym_compound_statement] = STATE(2038),
    [sym_named_label_statement] = STATE(2038),
    [sym_expression_statement] = STATE(2038),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(453),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(455),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(429),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(431),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(433),
    [aux_sym_foreach_statement_token1] = ACTIONS(435),
    [aux_sym_if_statement_token1] = ACTIONS(437),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(457),
  },
  [46] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(529),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym_empty_statement] = STATE(551),
    [sym_function_static_declaration] = STATE(551),
    [sym_global_declaration] = STATE(551),
    [sym_namespace_definition] = STATE(551),
    [sym_namespace_use_declaration] = STATE(551),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(551),
    [sym_interface_declaration] = STATE(551),
    [sym_enum_declaration] = STATE(551),
    [sym_class_declaration] = STATE(551),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(551),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(551),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(551),
    [sym_unset_statement] = STATE(551),
    [sym_declare_statement] = STATE(551),
    [sym_try_statement] = STATE(551),
    [sym_goto_statement] = STATE(551),
    [sym_continue_statement] = STATE(551),
    [sym_break_statement] = STATE(551),
    [sym_return_statement] = STATE(551),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(551),
    [sym_do_statement] = STATE(551),
    [sym_for_statement] = STATE(551),
    [sym_foreach_statement] = STATE(551),
    [sym_if_statement] = STATE(551),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(551),
    [sym_compound_statement] = STATE(551),
    [sym_named_label_statement] = STATE(551),
    [sym_expression_statement] = STATE(551),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(507),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(509),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(511),
  },
  [48] = {
    [sym_empty_statement] = STATE(33),
    [sym_function_static_declaration] = STATE(33),
    [sym_global_declaration] = STATE(33),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_use_declaration] = STATE(33),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(33),
    [sym_interface_declaration] = STATE(33),
    [sym_enum_declaration] = STATE(33),
    [sym_class_declaration] = STATE(33),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(33),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(33),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(33),
    [sym_unset_statement] = STATE(33),
    [sym_declare_statement] = STATE(33),
    [sym_try_statement] = STATE(33),
    [sym_goto_statement] = STATE(33),
    [sym_continue_statement] = STATE(33),
    [sym_break_statement] = STATE(33),
    [sym_return_statement] = STATE(33),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(33),
    [sym_do_statement] = STATE(33),
    [sym_for_statement] = STATE(33),
    [sym_foreach_statement] = STATE(33),
    [sym_if_statement] = STATE(33),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(33),
    [sym_compound_statement] = STATE(33),
    [sym_named_label_statement] = STATE(33),
    [sym_expression_statement] = STATE(33),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(33),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [aux_sym_declare_statement_token2] = ACTIONS(531),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [sym_empty_statement] = STATE(43),
    [sym_function_static_declaration] = STATE(43),
    [sym_global_declaration] = STATE(43),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_use_declaration] = STATE(43),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(43),
    [sym_interface_declaration] = STATE(43),
    [sym_enum_declaration] = STATE(43),
    [sym_class_declaration] = STATE(43),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(43),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(43),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(43),
    [sym_unset_statement] = STATE(43),
    [sym_declare_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_goto_statement] = STATE(43),
    [sym_continue_statement] = STATE(43),
    [sym_break_statement] = STATE(43),
    [sym_return_statement] = STATE(43),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(43),
    [sym_do_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_foreach_statement] = STATE(43),
    [sym_if_statement] = STATE(43),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(43),
    [sym_compound_statement] = STATE(43),
    [sym_named_label_statement] = STATE(43),
    [sym_expression_statement] = STATE(43),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(43),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(533),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym_empty_statement] = STATE(30),
    [sym_function_static_declaration] = STATE(30),
    [sym_global_declaration] = STATE(30),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_use_declaration] = STATE(30),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(30),
    [sym_interface_declaration] = STATE(30),
    [sym_enum_declaration] = STATE(30),
    [sym_class_declaration] = STATE(30),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(30),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(30),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(30),
    [sym_unset_statement] = STATE(30),
    [sym_declare_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_goto_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_foreach_statement] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(30),
    [sym_compound_statement] = STATE(30),
    [sym_named_label_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(30),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(535),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(537),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(539),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym_empty_statement] = STATE(19),
    [sym_function_static_declaration] = STATE(19),
    [sym_global_declaration] = STATE(19),
    [sym_namespace_definition] = STATE(19),
    [sym_namespace_use_declaration] = STATE(19),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(19),
    [sym_interface_declaration] = STATE(19),
    [sym_enum_declaration] = STATE(19),
    [sym_class_declaration] = STATE(19),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(19),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(19),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(19),
    [sym_unset_statement] = STATE(19),
    [sym_declare_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_goto_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_foreach_statement] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(19),
    [sym_compound_statement] = STATE(19),
    [sym_named_label_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(539),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym_empty_statement] = STATE(509),
    [sym_function_static_declaration] = STATE(509),
    [sym_global_declaration] = STATE(509),
    [sym_namespace_definition] = STATE(509),
    [sym_namespace_use_declaration] = STATE(509),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(509),
    [sym_interface_declaration] = STATE(509),
    [sym_enum_declaration] = STATE(509),
    [sym_class_declaration] = STATE(509),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(509),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(509),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(509),
    [sym_unset_statement] = STATE(509),
    [sym_declare_statement] = STATE(509),
    [sym_try_statement] = STATE(509),
    [sym_goto_statement] = STATE(509),
    [sym_continue_statement] = STATE(509),
    [sym_break_statement] = STATE(509),
    [sym_return_statement] = STATE(509),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(509),
    [sym_do_statement] = STATE(509),
    [sym_for_statement] = STATE(509),
    [sym_foreach_statement] = STATE(509),
    [sym_if_statement] = STATE(509),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(509),
    [sym_compound_statement] = STATE(509),
    [sym_named_label_statement] = STATE(509),
    [sym_expression_statement] = STATE(509),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(479),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(481),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(483),
  },
  [55] = {
    [sym_empty_statement] = STATE(63),
    [sym_function_static_declaration] = STATE(63),
    [sym_global_declaration] = STATE(63),
    [sym_namespace_definition] = STATE(63),
    [sym_namespace_use_declaration] = STATE(63),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(63),
    [sym_interface_declaration] = STATE(63),
    [sym_enum_declaration] = STATE(63),
    [sym_class_declaration] = STATE(63),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(63),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(63),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(63),
    [sym_unset_statement] = STATE(63),
    [sym_declare_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_goto_statement] = STATE(63),
    [sym_continue_statement] = STATE(63),
    [sym_break_statement] = STATE(63),
    [sym_return_statement] = STATE(63),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(63),
    [sym_do_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_foreach_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(63),
    [sym_compound_statement] = STATE(63),
    [sym_named_label_statement] = STATE(63),
    [sym_expression_statement] = STATE(63),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(63),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(529),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym_empty_statement] = STATE(2136),
    [sym_function_static_declaration] = STATE(2136),
    [sym_global_declaration] = STATE(2136),
    [sym_namespace_definition] = STATE(2136),
    [sym_namespace_use_declaration] = STATE(2136),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2136),
    [sym_interface_declaration] = STATE(2136),
    [sym_enum_declaration] = STATE(2136),
    [sym_class_declaration] = STATE(2136),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2136),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2136),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2136),
    [sym_unset_statement] = STATE(2136),
    [sym_declare_statement] = STATE(2136),
    [sym_try_statement] = STATE(2136),
    [sym_goto_statement] = STATE(2136),
    [sym_continue_statement] = STATE(2136),
    [sym_break_statement] = STATE(2136),
    [sym_return_statement] = STATE(2136),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2136),
    [sym_do_statement] = STATE(2136),
    [sym_for_statement] = STATE(2136),
    [sym_foreach_statement] = STATE(2136),
    [sym_if_statement] = STATE(2136),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2136),
    [sym_compound_statement] = STATE(2136),
    [sym_named_label_statement] = STATE(2136),
    [sym_expression_statement] = STATE(2136),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(445),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(447),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(395),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(407),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(411),
    [aux_sym_foreach_statement_token1] = ACTIONS(413),
    [aux_sym_if_statement_token1] = ACTIONS(415),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(449),
  },
  [57] = {
    [sym_empty_statement] = STATE(60),
    [sym_function_static_declaration] = STATE(60),
    [sym_global_declaration] = STATE(60),
    [sym_namespace_definition] = STATE(60),
    [sym_namespace_use_declaration] = STATE(60),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(60),
    [sym_interface_declaration] = STATE(60),
    [sym_enum_declaration] = STATE(60),
    [sym_class_declaration] = STATE(60),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(60),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(60),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(60),
    [sym_unset_statement] = STATE(60),
    [sym_declare_statement] = STATE(60),
    [sym_try_statement] = STATE(60),
    [sym_goto_statement] = STATE(60),
    [sym_continue_statement] = STATE(60),
    [sym_break_statement] = STATE(60),
    [sym_return_statement] = STATE(60),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(60),
    [sym_do_statement] = STATE(60),
    [sym_for_statement] = STATE(60),
    [sym_foreach_statement] = STATE(60),
    [sym_if_statement] = STATE(60),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(60),
    [sym_compound_statement] = STATE(60),
    [sym_named_label_statement] = STATE(60),
    [sym_expression_statement] = STATE(60),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(60),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(443),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym_empty_statement] = STATE(2105),
    [sym_function_static_declaration] = STATE(2105),
    [sym_global_declaration] = STATE(2105),
    [sym_namespace_definition] = STATE(2105),
    [sym_namespace_use_declaration] = STATE(2105),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2105),
    [sym_interface_declaration] = STATE(2105),
    [sym_enum_declaration] = STATE(2105),
    [sym_class_declaration] = STATE(2105),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2105),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2105),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2105),
    [sym_unset_statement] = STATE(2105),
    [sym_declare_statement] = STATE(2105),
    [sym_try_statement] = STATE(2105),
    [sym_goto_statement] = STATE(2105),
    [sym_continue_statement] = STATE(2105),
    [sym_break_statement] = STATE(2105),
    [sym_return_statement] = STATE(2105),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2105),
    [sym_do_statement] = STATE(2105),
    [sym_for_statement] = STATE(2105),
    [sym_foreach_statement] = STATE(2105),
    [sym_if_statement] = STATE(2105),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2105),
    [sym_compound_statement] = STATE(2105),
    [sym_named_label_statement] = STATE(2105),
    [sym_expression_statement] = STATE(2105),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(459),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(461),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(429),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(431),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(433),
    [aux_sym_foreach_statement_token1] = ACTIONS(435),
    [aux_sym_if_statement_token1] = ACTIONS(437),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(463),
  },
  [59] = {
    [sym_empty_statement] = STATE(523),
    [sym_function_static_declaration] = STATE(523),
    [sym_global_declaration] = STATE(523),
    [sym_namespace_definition] = STATE(523),
    [sym_namespace_use_declaration] = STATE(523),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(523),
    [sym_interface_declaration] = STATE(523),
    [sym_enum_declaration] = STATE(523),
    [sym_class_declaration] = STATE(523),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(523),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(523),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(523),
    [sym_unset_statement] = STATE(523),
    [sym_declare_statement] = STATE(523),
    [sym_try_statement] = STATE(523),
    [sym_goto_statement] = STATE(523),
    [sym_continue_statement] = STATE(523),
    [sym_break_statement] = STATE(523),
    [sym_return_statement] = STATE(523),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(523),
    [sym_do_statement] = STATE(523),
    [sym_for_statement] = STATE(523),
    [sym_foreach_statement] = STATE(523),
    [sym_if_statement] = STATE(523),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(523),
    [sym_compound_statement] = STATE(523),
    [sym_named_label_statement] = STATE(523),
    [sym_expression_statement] = STATE(523),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(465),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(467),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(469),
  },
  [60] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(541),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym_empty_statement] = STATE(62),
    [sym_function_static_declaration] = STATE(62),
    [sym_global_declaration] = STATE(62),
    [sym_namespace_definition] = STATE(62),
    [sym_namespace_use_declaration] = STATE(62),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(62),
    [sym_interface_declaration] = STATE(62),
    [sym_enum_declaration] = STATE(62),
    [sym_class_declaration] = STATE(62),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(62),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(62),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(62),
    [sym_unset_statement] = STATE(62),
    [sym_declare_statement] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_goto_statement] = STATE(62),
    [sym_continue_statement] = STATE(62),
    [sym_break_statement] = STATE(62),
    [sym_return_statement] = STATE(62),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(62),
    [sym_do_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_foreach_statement] = STATE(62),
    [sym_if_statement] = STATE(62),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(62),
    [sym_compound_statement] = STATE(62),
    [sym_named_label_statement] = STATE(62),
    [sym_expression_statement] = STATE(62),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(62),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(541),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(543),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(545),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym_empty_statement] = STATE(2080),
    [sym_function_static_declaration] = STATE(2080),
    [sym_global_declaration] = STATE(2080),
    [sym_namespace_definition] = STATE(2080),
    [sym_namespace_use_declaration] = STATE(2080),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2080),
    [sym_interface_declaration] = STATE(2080),
    [sym_enum_declaration] = STATE(2080),
    [sym_class_declaration] = STATE(2080),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2080),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2080),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2080),
    [sym_unset_statement] = STATE(2080),
    [sym_declare_statement] = STATE(2080),
    [sym_try_statement] = STATE(2080),
    [sym_goto_statement] = STATE(2080),
    [sym_continue_statement] = STATE(2080),
    [sym_break_statement] = STATE(2080),
    [sym_return_statement] = STATE(2080),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2080),
    [sym_do_statement] = STATE(2080),
    [sym_for_statement] = STATE(2080),
    [sym_foreach_statement] = STATE(2080),
    [sym_if_statement] = STATE(2080),
    [sym_colon_block] = STATE(2538),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2080),
    [sym_compound_statement] = STATE(2080),
    [sym_named_label_statement] = STATE(2080),
    [sym_expression_statement] = STATE(2080),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(505),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(387),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(395),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(407),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(411),
    [aux_sym_foreach_statement_token1] = ACTIONS(413),
    [aux_sym_if_statement_token1] = ACTIONS(415),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [65] = {
    [sym_empty_statement] = STATE(1593),
    [sym_function_static_declaration] = STATE(1593),
    [sym_global_declaration] = STATE(1593),
    [sym_namespace_definition] = STATE(1593),
    [sym_namespace_use_declaration] = STATE(1593),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(1593),
    [sym_interface_declaration] = STATE(1593),
    [sym_enum_declaration] = STATE(1593),
    [sym_class_declaration] = STATE(1593),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(1593),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(1593),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(1593),
    [sym_unset_statement] = STATE(1593),
    [sym_declare_statement] = STATE(1593),
    [sym_try_statement] = STATE(1593),
    [sym_goto_statement] = STATE(1593),
    [sym_continue_statement] = STATE(1593),
    [sym_break_statement] = STATE(1593),
    [sym_return_statement] = STATE(1593),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(1593),
    [sym_do_statement] = STATE(1593),
    [sym_for_statement] = STATE(1593),
    [sym_foreach_statement] = STATE(1593),
    [sym_if_statement] = STATE(1593),
    [sym_colon_block] = STATE(1654),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(1593),
    [sym_compound_statement] = STATE(1593),
    [sym_named_label_statement] = STATE(1593),
    [sym_expression_statement] = STATE(1593),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(505),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(515),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(429),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(431),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(433),
    [aux_sym_foreach_statement_token1] = ACTIONS(435),
    [aux_sym_if_statement_token1] = ACTIONS(437),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym_empty_statement] = STATE(51),
    [sym_function_static_declaration] = STATE(51),
    [sym_global_declaration] = STATE(51),
    [sym_namespace_definition] = STATE(51),
    [sym_namespace_use_declaration] = STATE(51),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(51),
    [sym_interface_declaration] = STATE(51),
    [sym_enum_declaration] = STATE(51),
    [sym_class_declaration] = STATE(51),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(51),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(51),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(51),
    [sym_unset_statement] = STATE(51),
    [sym_declare_statement] = STATE(51),
    [sym_try_statement] = STATE(51),
    [sym_goto_statement] = STATE(51),
    [sym_continue_statement] = STATE(51),
    [sym_break_statement] = STATE(51),
    [sym_return_statement] = STATE(51),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(51),
    [sym_do_statement] = STATE(51),
    [sym_for_statement] = STATE(51),
    [sym_foreach_statement] = STATE(51),
    [sym_if_statement] = STATE(51),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(51),
    [sym_compound_statement] = STATE(51),
    [sym_named_label_statement] = STATE(51),
    [sym_expression_statement] = STATE(51),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(51),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(547),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [sym_empty_statement] = STATE(2039),
    [sym_function_static_declaration] = STATE(2039),
    [sym_global_declaration] = STATE(2039),
    [sym_namespace_definition] = STATE(2039),
    [sym_namespace_use_declaration] = STATE(2039),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2039),
    [sym_interface_declaration] = STATE(2039),
    [sym_enum_declaration] = STATE(2039),
    [sym_class_declaration] = STATE(2039),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2039),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2039),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2039),
    [sym_unset_statement] = STATE(2039),
    [sym_declare_statement] = STATE(2039),
    [sym_try_statement] = STATE(2039),
    [sym_goto_statement] = STATE(2039),
    [sym_continue_statement] = STATE(2039),
    [sym_break_statement] = STATE(2039),
    [sym_return_statement] = STATE(2039),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2039),
    [sym_do_statement] = STATE(2039),
    [sym_for_statement] = STATE(2039),
    [sym_foreach_statement] = STATE(2039),
    [sym_if_statement] = STATE(2039),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2039),
    [sym_compound_statement] = STATE(2039),
    [sym_named_label_statement] = STATE(2039),
    [sym_expression_statement] = STATE(2039),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(489),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(491),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(429),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(431),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(433),
    [aux_sym_foreach_statement_token1] = ACTIONS(435),
    [aux_sym_if_statement_token1] = ACTIONS(437),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(493),
  },
  [68] = {
    [sym_empty_statement] = STATE(73),
    [sym_function_static_declaration] = STATE(73),
    [sym_global_declaration] = STATE(73),
    [sym_namespace_definition] = STATE(73),
    [sym_namespace_use_declaration] = STATE(73),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(73),
    [sym_interface_declaration] = STATE(73),
    [sym_enum_declaration] = STATE(73),
    [sym_class_declaration] = STATE(73),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(73),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(73),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(73),
    [sym_unset_statement] = STATE(73),
    [sym_declare_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_goto_statement] = STATE(73),
    [sym_continue_statement] = STATE(73),
    [sym_break_statement] = STATE(73),
    [sym_return_statement] = STATE(73),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(73),
    [sym_do_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_foreach_statement] = STATE(73),
    [sym_if_statement] = STATE(73),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(73),
    [sym_compound_statement] = STATE(73),
    [sym_named_label_statement] = STATE(73),
    [sym_expression_statement] = STATE(73),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(73),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(549),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym_empty_statement] = STATE(2101),
    [sym_function_static_declaration] = STATE(2101),
    [sym_global_declaration] = STATE(2101),
    [sym_namespace_definition] = STATE(2101),
    [sym_namespace_use_declaration] = STATE(2101),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2101),
    [sym_interface_declaration] = STATE(2101),
    [sym_enum_declaration] = STATE(2101),
    [sym_class_declaration] = STATE(2101),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2101),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2101),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2101),
    [sym_unset_statement] = STATE(2101),
    [sym_declare_statement] = STATE(2101),
    [sym_try_statement] = STATE(2101),
    [sym_goto_statement] = STATE(2101),
    [sym_continue_statement] = STATE(2101),
    [sym_break_statement] = STATE(2101),
    [sym_return_statement] = STATE(2101),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2101),
    [sym_do_statement] = STATE(2101),
    [sym_for_statement] = STATE(2101),
    [sym_foreach_statement] = STATE(2101),
    [sym_if_statement] = STATE(2101),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2101),
    [sym_compound_statement] = STATE(2101),
    [sym_named_label_statement] = STATE(2101),
    [sym_expression_statement] = STATE(2101),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(495),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(497),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(429),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(431),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(433),
    [aux_sym_foreach_statement_token1] = ACTIONS(435),
    [aux_sym_if_statement_token1] = ACTIONS(437),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(499),
  },
  [70] = {
    [sym_empty_statement] = STATE(46),
    [sym_function_static_declaration] = STATE(46),
    [sym_global_declaration] = STATE(46),
    [sym_namespace_definition] = STATE(46),
    [sym_namespace_use_declaration] = STATE(46),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(46),
    [sym_interface_declaration] = STATE(46),
    [sym_enum_declaration] = STATE(46),
    [sym_class_declaration] = STATE(46),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(46),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(46),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(46),
    [sym_unset_statement] = STATE(46),
    [sym_declare_statement] = STATE(46),
    [sym_try_statement] = STATE(46),
    [sym_goto_statement] = STATE(46),
    [sym_continue_statement] = STATE(46),
    [sym_break_statement] = STATE(46),
    [sym_return_statement] = STATE(46),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(46),
    [sym_do_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_foreach_statement] = STATE(46),
    [sym_if_statement] = STATE(46),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(46),
    [sym_compound_statement] = STATE(46),
    [sym_named_label_statement] = STATE(46),
    [sym_expression_statement] = STATE(46),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(46),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(485),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(551),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [sym_empty_statement] = STATE(457),
    [sym_function_static_declaration] = STATE(457),
    [sym_global_declaration] = STATE(457),
    [sym_namespace_definition] = STATE(457),
    [sym_namespace_use_declaration] = STATE(457),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(457),
    [sym_interface_declaration] = STATE(457),
    [sym_enum_declaration] = STATE(457),
    [sym_class_declaration] = STATE(457),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(457),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(457),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(457),
    [sym_unset_statement] = STATE(457),
    [sym_declare_statement] = STATE(457),
    [sym_try_statement] = STATE(457),
    [sym_goto_statement] = STATE(457),
    [sym_continue_statement] = STATE(457),
    [sym_break_statement] = STATE(457),
    [sym_return_statement] = STATE(457),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(457),
    [sym_do_statement] = STATE(457),
    [sym_for_statement] = STATE(457),
    [sym_foreach_statement] = STATE(457),
    [sym_if_statement] = STATE(457),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(457),
    [sym_compound_statement] = STATE(457),
    [sym_named_label_statement] = STATE(457),
    [sym_expression_statement] = STATE(457),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(517),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(519),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(521),
  },
  [73] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(451),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [sym_empty_statement] = STATE(424),
    [sym_function_static_declaration] = STATE(424),
    [sym_global_declaration] = STATE(424),
    [sym_namespace_definition] = STATE(424),
    [sym_namespace_use_declaration] = STATE(424),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(424),
    [sym_interface_declaration] = STATE(424),
    [sym_enum_declaration] = STATE(424),
    [sym_class_declaration] = STATE(424),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(424),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(424),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(424),
    [sym_unset_statement] = STATE(424),
    [sym_declare_statement] = STATE(424),
    [sym_try_statement] = STATE(424),
    [sym_goto_statement] = STATE(424),
    [sym_continue_statement] = STATE(424),
    [sym_break_statement] = STATE(424),
    [sym_return_statement] = STATE(424),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(424),
    [sym_do_statement] = STATE(424),
    [sym_for_statement] = STATE(424),
    [sym_foreach_statement] = STATE(424),
    [sym_if_statement] = STATE(424),
    [sym_colon_block] = STATE(1626),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(424),
    [sym_compound_statement] = STATE(424),
    [sym_named_label_statement] = STATE(424),
    [sym_expression_statement] = STATE(424),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(515),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(355),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(357),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(359),
    [aux_sym_foreach_statement_token1] = ACTIONS(361),
    [aux_sym_if_statement_token1] = ACTIONS(363),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym_empty_statement] = STATE(71),
    [sym_function_static_declaration] = STATE(71),
    [sym_global_declaration] = STATE(71),
    [sym_namespace_definition] = STATE(71),
    [sym_namespace_use_declaration] = STATE(71),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(71),
    [sym_interface_declaration] = STATE(71),
    [sym_enum_declaration] = STATE(71),
    [sym_class_declaration] = STATE(71),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(71),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(71),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(71),
    [sym_unset_statement] = STATE(71),
    [sym_declare_statement] = STATE(71),
    [sym_try_statement] = STATE(71),
    [sym_goto_statement] = STATE(71),
    [sym_continue_statement] = STATE(71),
    [sym_break_statement] = STATE(71),
    [sym_return_statement] = STATE(71),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(71),
    [sym_do_statement] = STATE(71),
    [sym_for_statement] = STATE(71),
    [sym_foreach_statement] = STATE(71),
    [sym_if_statement] = STATE(71),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(71),
    [sym_compound_statement] = STATE(71),
    [sym_named_label_statement] = STATE(71),
    [sym_expression_statement] = STATE(71),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_program_repeat1] = STATE(71),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(553),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym_empty_statement] = STATE(521),
    [sym_function_static_declaration] = STATE(521),
    [sym_global_declaration] = STATE(521),
    [sym_namespace_definition] = STATE(521),
    [sym_namespace_use_declaration] = STATE(521),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(521),
    [sym_interface_declaration] = STATE(521),
    [sym_enum_declaration] = STATE(521),
    [sym_class_declaration] = STATE(521),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(521),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(521),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(521),
    [sym_unset_statement] = STATE(521),
    [sym_declare_statement] = STATE(521),
    [sym_try_statement] = STATE(521),
    [sym_goto_statement] = STATE(521),
    [sym_continue_statement] = STATE(521),
    [sym_break_statement] = STATE(521),
    [sym_return_statement] = STATE(521),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(521),
    [sym_do_statement] = STATE(521),
    [sym_for_statement] = STATE(521),
    [sym_foreach_statement] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_colon_block] = STATE(2560),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(521),
    [sym_compound_statement] = STATE(521),
    [sym_named_label_statement] = STATE(521),
    [sym_expression_statement] = STATE(521),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(387),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [sym_empty_statement] = STATE(2061),
    [sym_function_static_declaration] = STATE(2061),
    [sym_global_declaration] = STATE(2061),
    [sym_namespace_definition] = STATE(2061),
    [sym_namespace_use_declaration] = STATE(2061),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2061),
    [sym_interface_declaration] = STATE(2061),
    [sym_enum_declaration] = STATE(2061),
    [sym_class_declaration] = STATE(2061),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2061),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2061),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2061),
    [sym_unset_statement] = STATE(2061),
    [sym_declare_statement] = STATE(2061),
    [sym_try_statement] = STATE(2061),
    [sym_goto_statement] = STATE(2061),
    [sym_continue_statement] = STATE(2061),
    [sym_break_statement] = STATE(2061),
    [sym_return_statement] = STATE(2061),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2061),
    [sym_do_statement] = STATE(2061),
    [sym_for_statement] = STATE(2061),
    [sym_foreach_statement] = STATE(2061),
    [sym_if_statement] = STATE(2061),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2061),
    [sym_compound_statement] = STATE(2061),
    [sym_named_label_statement] = STATE(2061),
    [sym_expression_statement] = STATE(2061),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(505),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(395),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(407),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(411),
    [aux_sym_foreach_statement_token1] = ACTIONS(413),
    [aux_sym_if_statement_token1] = ACTIONS(415),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [sym_empty_statement] = STATE(495),
    [sym_function_static_declaration] = STATE(495),
    [sym_global_declaration] = STATE(495),
    [sym_namespace_definition] = STATE(495),
    [sym_namespace_use_declaration] = STATE(495),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(495),
    [sym_interface_declaration] = STATE(495),
    [sym_enum_declaration] = STATE(495),
    [sym_class_declaration] = STATE(495),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(495),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(495),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(495),
    [sym_unset_statement] = STATE(495),
    [sym_declare_statement] = STATE(495),
    [sym_try_statement] = STATE(495),
    [sym_goto_statement] = STATE(495),
    [sym_continue_statement] = STATE(495),
    [sym_break_statement] = STATE(495),
    [sym_return_statement] = STATE(495),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(495),
    [sym_do_statement] = STATE(495),
    [sym_for_statement] = STATE(495),
    [sym_foreach_statement] = STATE(495),
    [sym_if_statement] = STATE(495),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(495),
    [sym_compound_statement] = STATE(495),
    [sym_named_label_statement] = STATE(495),
    [sym_expression_statement] = STATE(495),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym_empty_statement] = STATE(2571),
    [sym_function_static_declaration] = STATE(2571),
    [sym_global_declaration] = STATE(2571),
    [sym_namespace_definition] = STATE(2571),
    [sym_namespace_use_declaration] = STATE(2571),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2571),
    [sym_interface_declaration] = STATE(2571),
    [sym_enum_declaration] = STATE(2571),
    [sym_class_declaration] = STATE(2571),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2571),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2571),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2571),
    [sym_unset_statement] = STATE(2571),
    [sym_declare_statement] = STATE(2571),
    [sym_try_statement] = STATE(2571),
    [sym_goto_statement] = STATE(2571),
    [sym_continue_statement] = STATE(2571),
    [sym_break_statement] = STATE(2571),
    [sym_return_statement] = STATE(2571),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2571),
    [sym_do_statement] = STATE(2571),
    [sym_for_statement] = STATE(2571),
    [sym_foreach_statement] = STATE(2571),
    [sym_if_statement] = STATE(2571),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2571),
    [sym_compound_statement] = STATE(2571),
    [sym_named_label_statement] = STATE(2571),
    [sym_expression_statement] = STATE(2571),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(505),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(395),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(407),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(411),
    [aux_sym_foreach_statement_token1] = ACTIONS(413),
    [aux_sym_if_statement_token1] = ACTIONS(415),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym_empty_statement] = STATE(2472),
    [sym_function_static_declaration] = STATE(2472),
    [sym_global_declaration] = STATE(2472),
    [sym_namespace_definition] = STATE(2472),
    [sym_namespace_use_declaration] = STATE(2472),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2472),
    [sym_interface_declaration] = STATE(2472),
    [sym_enum_declaration] = STATE(2472),
    [sym_class_declaration] = STATE(2472),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2472),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2472),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2472),
    [sym_unset_statement] = STATE(2472),
    [sym_declare_statement] = STATE(2472),
    [sym_try_statement] = STATE(2472),
    [sym_goto_statement] = STATE(2472),
    [sym_continue_statement] = STATE(2472),
    [sym_break_statement] = STATE(2472),
    [sym_return_statement] = STATE(2472),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2472),
    [sym_do_statement] = STATE(2472),
    [sym_for_statement] = STATE(2472),
    [sym_foreach_statement] = STATE(2472),
    [sym_if_statement] = STATE(2472),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2472),
    [sym_compound_statement] = STATE(2472),
    [sym_named_label_statement] = STATE(2472),
    [sym_expression_statement] = STATE(2472),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(505),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(395),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(407),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(411),
    [aux_sym_foreach_statement_token1] = ACTIONS(413),
    [aux_sym_if_statement_token1] = ACTIONS(415),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [sym_empty_statement] = STATE(2143),
    [sym_function_static_declaration] = STATE(2143),
    [sym_global_declaration] = STATE(2143),
    [sym_namespace_definition] = STATE(2143),
    [sym_namespace_use_declaration] = STATE(2143),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2143),
    [sym_interface_declaration] = STATE(2143),
    [sym_enum_declaration] = STATE(2143),
    [sym_class_declaration] = STATE(2143),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2143),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2143),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2143),
    [sym_unset_statement] = STATE(2143),
    [sym_declare_statement] = STATE(2143),
    [sym_try_statement] = STATE(2143),
    [sym_goto_statement] = STATE(2143),
    [sym_continue_statement] = STATE(2143),
    [sym_break_statement] = STATE(2143),
    [sym_return_statement] = STATE(2143),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2143),
    [sym_do_statement] = STATE(2143),
    [sym_for_statement] = STATE(2143),
    [sym_foreach_statement] = STATE(2143),
    [sym_if_statement] = STATE(2143),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2143),
    [sym_compound_statement] = STATE(2143),
    [sym_named_label_statement] = STATE(2143),
    [sym_expression_statement] = STATE(2143),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(505),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(429),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(431),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(433),
    [aux_sym_foreach_statement_token1] = ACTIONS(435),
    [aux_sym_if_statement_token1] = ACTIONS(437),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [sym_empty_statement] = STATE(511),
    [sym_function_static_declaration] = STATE(511),
    [sym_global_declaration] = STATE(511),
    [sym_namespace_definition] = STATE(511),
    [sym_namespace_use_declaration] = STATE(511),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(511),
    [sym_interface_declaration] = STATE(511),
    [sym_enum_declaration] = STATE(511),
    [sym_class_declaration] = STATE(511),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(511),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(511),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(511),
    [sym_unset_statement] = STATE(511),
    [sym_declare_statement] = STATE(511),
    [sym_try_statement] = STATE(511),
    [sym_goto_statement] = STATE(511),
    [sym_continue_statement] = STATE(511),
    [sym_break_statement] = STATE(511),
    [sym_return_statement] = STATE(511),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(511),
    [sym_do_statement] = STATE(511),
    [sym_for_statement] = STATE(511),
    [sym_foreach_statement] = STATE(511),
    [sym_if_statement] = STATE(511),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(511),
    [sym_compound_statement] = STATE(511),
    [sym_named_label_statement] = STATE(511),
    [sym_expression_statement] = STATE(511),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(355),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(357),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(359),
    [aux_sym_foreach_statement_token1] = ACTIONS(361),
    [aux_sym_if_statement_token1] = ACTIONS(363),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [sym_empty_statement] = STATE(2061),
    [sym_function_static_declaration] = STATE(2061),
    [sym_global_declaration] = STATE(2061),
    [sym_namespace_definition] = STATE(2061),
    [sym_namespace_use_declaration] = STATE(2061),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(2061),
    [sym_interface_declaration] = STATE(2061),
    [sym_enum_declaration] = STATE(2061),
    [sym_class_declaration] = STATE(2061),
    [sym_final_modifier] = STATE(2058),
    [sym_abstract_modifier] = STATE(2058),
    [sym_readonly_modifier] = STATE(2565),
    [sym_const_declaration] = STATE(2061),
    [sym__const_declaration] = STATE(2178),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2566),
    [sym_function_definition] = STATE(2061),
    [sym__function_definition_header] = STATE(2280),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(2061),
    [sym_unset_statement] = STATE(2061),
    [sym_declare_statement] = STATE(2061),
    [sym_try_statement] = STATE(2061),
    [sym_goto_statement] = STATE(2061),
    [sym_continue_statement] = STATE(2061),
    [sym_break_statement] = STATE(2061),
    [sym_return_statement] = STATE(2061),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(2061),
    [sym_do_statement] = STATE(2061),
    [sym_for_statement] = STATE(2061),
    [sym_foreach_statement] = STATE(2061),
    [sym_if_statement] = STATE(2061),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(2061),
    [sym_compound_statement] = STATE(2061),
    [sym_named_label_statement] = STATE(2061),
    [sym_expression_statement] = STATE(2061),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1398),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(505),
    [aux_sym_function_static_declaration_token1] = ACTIONS(369),
    [aux_sym_global_declaration_token1] = ACTIONS(371),
    [aux_sym_namespace_definition_token1] = ACTIONS(373),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(375),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(377),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(379),
    [aux_sym_trait_declaration_token1] = ACTIONS(381),
    [aux_sym_interface_declaration_token1] = ACTIONS(383),
    [aux_sym_enum_declaration_token1] = ACTIONS(385),
    [aux_sym_class_declaration_token1] = ACTIONS(389),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(391),
    [anon_sym_unset] = ACTIONS(393),
    [aux_sym_declare_statement_token1] = ACTIONS(429),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(397),
    [aux_sym_goto_statement_token1] = ACTIONS(399),
    [aux_sym_continue_statement_token1] = ACTIONS(401),
    [aux_sym_break_statement_token1] = ACTIONS(403),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(405),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(431),
    [aux_sym_do_statement_token1] = ACTIONS(409),
    [aux_sym_for_statement_token1] = ACTIONS(433),
    [aux_sym_foreach_statement_token1] = ACTIONS(435),
    [aux_sym_if_statement_token1] = ACTIONS(437),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [84] = {
    [sym_empty_statement] = STATE(495),
    [sym_function_static_declaration] = STATE(495),
    [sym_global_declaration] = STATE(495),
    [sym_namespace_definition] = STATE(495),
    [sym_namespace_use_declaration] = STATE(495),
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_trait_declaration] = STATE(495),
    [sym_interface_declaration] = STATE(495),
    [sym_enum_declaration] = STATE(495),
    [sym_class_declaration] = STATE(495),
    [sym_final_modifier] = STATE(2023),
    [sym_abstract_modifier] = STATE(2023),
    [sym_readonly_modifier] = STATE(2547),
    [sym_const_declaration] = STATE(495),
    [sym__const_declaration] = STATE(493),
    [sym_static_modifier] = STATE(2546),
    [sym_visibility_modifier] = STATE(2545),
    [sym_function_definition] = STATE(495),
    [sym__function_definition_header] = STATE(2286),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_echo_statement] = STATE(495),
    [sym_unset_statement] = STATE(495),
    [sym_declare_statement] = STATE(495),
    [sym_try_statement] = STATE(495),
    [sym_goto_statement] = STATE(495),
    [sym_continue_statement] = STATE(495),
    [sym_break_statement] = STATE(495),
    [sym_return_statement] = STATE(495),
    [sym_throw_expression] = STATE(1123),
    [sym_while_statement] = STATE(495),
    [sym_do_statement] = STATE(495),
    [sym_for_statement] = STATE(495),
    [sym_foreach_statement] = STATE(495),
    [sym_if_statement] = STATE(495),
    [sym_match_expression] = STATE(1049),
    [sym_switch_statement] = STATE(495),
    [sym_compound_statement] = STATE(495),
    [sym_named_label_statement] = STATE(495),
    [sym_expression_statement] = STATE(495),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1401),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(355),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(357),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(359),
    [aux_sym_foreach_statement_token1] = ACTIONS(361),
    [aux_sym_if_statement_token1] = ACTIONS(363),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(987),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(961),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym_AMP] = ACTIONS(559),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym_namespace_aliasing_clause_token1] = ACTIONS(567),
    [anon_sym_RBRACE] = ACTIONS(557),
    [anon_sym_COLON] = ACTIONS(557),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_LPAREN] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(567),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_yield_expression_token2] = ACTIONS(613),
    [aux_sym_binary_expression_token1] = ACTIONS(567),
    [anon_sym_QMARK_QMARK] = ACTIONS(557),
    [anon_sym_STAR_STAR] = ACTIONS(557),
    [aux_sym_binary_expression_token2] = ACTIONS(567),
    [aux_sym_binary_expression_token3] = ACTIONS(567),
    [aux_sym_binary_expression_token4] = ACTIONS(567),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_CARET] = ACTIONS(557),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_GT] = ACTIONS(557),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(557),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ_GT] = ACTIONS(557),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_PERCENT] = ACTIONS(557),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1005),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(961),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym_AMP] = ACTIONS(559),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(557),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(557),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(567),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(557),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_yield_expression_token2] = ACTIONS(643),
    [aux_sym_binary_expression_token1] = ACTIONS(567),
    [anon_sym_QMARK_QMARK] = ACTIONS(557),
    [anon_sym_STAR_STAR] = ACTIONS(557),
    [aux_sym_binary_expression_token2] = ACTIONS(567),
    [aux_sym_binary_expression_token3] = ACTIONS(567),
    [aux_sym_binary_expression_token4] = ACTIONS(567),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_CARET] = ACTIONS(557),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_GT] = ACTIONS(557),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(557),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ_GT] = ACTIONS(557),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_PERCENT] = ACTIONS(557),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1135),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_variadic_unpacking] = STATE(1099),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_by_ref] = STATE(1099),
    [sym_yield_expression] = STATE(1049),
    [sym_array_element_initializer] = STATE(1136),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym_AMP] = ACTIONS(655),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [anon_sym_COMMA] = ACTIONS(557),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(661),
    [anon_sym_QMARK] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(567),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(87),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_yield_expression_token2] = ACTIONS(663),
    [aux_sym_binary_expression_token1] = ACTIONS(567),
    [anon_sym_QMARK_QMARK] = ACTIONS(557),
    [anon_sym_STAR_STAR] = ACTIONS(557),
    [aux_sym_binary_expression_token2] = ACTIONS(567),
    [aux_sym_binary_expression_token3] = ACTIONS(567),
    [aux_sym_binary_expression_token4] = ACTIONS(567),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_CARET] = ACTIONS(557),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_GT] = ACTIONS(557),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(557),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ_GT] = ACTIONS(557),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_PERCENT] = ACTIONS(557),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(557),
  },
  [88] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1172),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(961),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(559),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(557),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [anon_sym_QMARK] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(567),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_yield_expression_token2] = ACTIONS(685),
    [aux_sym_binary_expression_token1] = ACTIONS(567),
    [anon_sym_QMARK_QMARK] = ACTIONS(557),
    [anon_sym_STAR_STAR] = ACTIONS(557),
    [aux_sym_binary_expression_token2] = ACTIONS(567),
    [aux_sym_binary_expression_token3] = ACTIONS(567),
    [aux_sym_binary_expression_token4] = ACTIONS(567),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_CARET] = ACTIONS(557),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_GT] = ACTIONS(557),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(557),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ_GT] = ACTIONS(557),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(557),
    [anon_sym_PERCENT] = ACTIONS(557),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_cast_type] = STATE(2525),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1278),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_cast_type] = STATE(2450),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1300),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_cast_type] = STATE(2469),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1278),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [92] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_cast_type] = STATE(2481),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1278),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_cast_type] = STATE(2481),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1300),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_cast_type] = STATE(2460),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1278),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [95] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_cast_type] = STATE(2613),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1278),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_cast_type] = STATE(2532),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1278),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [97] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_cast_type] = STATE(2473),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1278),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_cast_type] = STATE(2537),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1278),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_cast_type] = STATE(2540),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1278),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_variadic_placeholder] = STATE(2629),
    [sym_argument] = STATE(2104),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(705),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_variadic_placeholder] = STATE(2619),
    [sym_argument] = STATE(2093),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(727),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [102] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1174),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(635),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(635),
    [sym_nullsafe_member_access_expression] = STATE(635),
    [sym_scoped_property_access_expression] = STATE(635),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2000),
    [sym__array_destructing_element] = STATE(2001),
    [sym_function_call_expression] = STATE(625),
    [sym_scoped_call_expression] = STATE(625),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(625),
    [sym_nullsafe_member_call_expression] = STATE(625),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(625),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(625),
    [sym_variable_name] = STATE(625),
    [sym_by_ref] = STATE(2384),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(1914),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym__array_destructing_repeat1] = STATE(2004),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(733),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(735),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [103] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1174),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(635),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(635),
    [sym_nullsafe_member_access_expression] = STATE(635),
    [sym_scoped_property_access_expression] = STATE(635),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2000),
    [sym__array_destructing_element] = STATE(2001),
    [sym_function_call_expression] = STATE(625),
    [sym_scoped_call_expression] = STATE(625),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(625),
    [sym_nullsafe_member_call_expression] = STATE(625),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(625),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(625),
    [sym_variable_name] = STATE(625),
    [sym_by_ref] = STATE(2384),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(1914),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym__array_destructing_repeat1] = STATE(2004),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(733),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(737),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [104] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_variadic_placeholder] = STATE(2588),
    [sym_argument] = STATE(2119),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(739),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [105] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_variadic_placeholder] = STATE(2480),
    [sym_argument] = STATE(1918),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(743),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [106] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1174),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(635),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(635),
    [sym_nullsafe_member_access_expression] = STATE(635),
    [sym_scoped_property_access_expression] = STATE(635),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2000),
    [sym__array_destructing_element] = STATE(2001),
    [sym_function_call_expression] = STATE(625),
    [sym_scoped_call_expression] = STATE(625),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(625),
    [sym_nullsafe_member_call_expression] = STATE(625),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(625),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(625),
    [sym_variable_name] = STATE(625),
    [sym_by_ref] = STATE(2384),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(1914),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym__array_destructing_repeat1] = STATE(2004),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(733),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(747),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [107] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_variadic_placeholder] = STATE(2633),
    [sym_argument] = STATE(2132),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(749),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [108] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_variadic_placeholder] = STATE(2659),
    [sym_argument] = STATE(2182),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(753),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(755),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [109] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1174),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(635),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(635),
    [sym_nullsafe_member_access_expression] = STATE(635),
    [sym_scoped_property_access_expression] = STATE(635),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2000),
    [sym__array_destructing_element] = STATE(2001),
    [sym_function_call_expression] = STATE(625),
    [sym_scoped_call_expression] = STATE(625),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(625),
    [sym_nullsafe_member_call_expression] = STATE(625),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(625),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(625),
    [sym_variable_name] = STATE(625),
    [sym_by_ref] = STATE(2384),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(2002),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym__array_destructing_repeat1] = STATE(2004),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(757),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(759),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [110] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_variadic_placeholder] = STATE(2543),
    [sym_argument] = STATE(2169),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(761),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(763),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [111] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1174),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(635),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(635),
    [sym_nullsafe_member_access_expression] = STATE(635),
    [sym_scoped_property_access_expression] = STATE(635),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2000),
    [sym__array_destructing_element] = STATE(2001),
    [sym_function_call_expression] = STATE(625),
    [sym_scoped_call_expression] = STATE(625),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(625),
    [sym_nullsafe_member_call_expression] = STATE(625),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(625),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(625),
    [sym_variable_name] = STATE(625),
    [sym_by_ref] = STATE(2384),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(1914),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym__array_destructing_repeat1] = STATE(2004),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(733),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(765),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [112] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_variadic_placeholder] = STATE(2642),
    [sym_argument] = STATE(2149),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(767),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [113] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(2002),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(771),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(773),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [114] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [115] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [116] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(779),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [117] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [118] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [120] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(787),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1178),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(2070),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(801),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [128] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1178),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(1941),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(805),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [129] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(1914),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(809),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(811),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [130] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [131] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [132] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [133] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym_match_condition_list] = STATE(2504),
    [sym_match_conditional_expression] = STATE(2012),
    [sym_match_default_expression] = STATE(2012),
    [sym__expression] = STATE(1179),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(819),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(821),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [aux_sym_match_default_expression_token1] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [sym_reference_modifier] = STATE(189),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2250),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [135] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(2140),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(825),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [136] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1178),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(2140),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [137] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1178),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(2140),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1178),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(2140),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [139] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(2140),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(833),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [140] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(2140),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(835),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [141] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1178),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(2140),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [142] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym_match_condition_list] = STATE(2504),
    [sym_match_conditional_expression] = STATE(1952),
    [sym_match_default_expression] = STATE(1952),
    [sym__expression] = STATE(1179),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(839),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(841),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [aux_sym_match_default_expression_token1] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [143] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(2140),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(843),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [144] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym_match_condition_list] = STATE(2504),
    [sym_match_conditional_expression] = STATE(2412),
    [sym_match_default_expression] = STATE(2412),
    [sym__expression] = STATE(1179),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(845),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [aux_sym_match_default_expression_token1] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [145] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(2140),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [146] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym_match_condition_list] = STATE(2504),
    [sym_match_conditional_expression] = STATE(2412),
    [sym_match_default_expression] = STATE(2412),
    [sym__expression] = STATE(1179),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(847),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [aux_sym_match_default_expression_token1] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [147] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym_match_condition_list] = STATE(2504),
    [sym_match_conditional_expression] = STATE(2412),
    [sym_match_default_expression] = STATE(2412),
    [sym__expression] = STATE(1179),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(849),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [aux_sym_match_default_expression_token1] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [148] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1247),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(629),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(629),
    [sym_nullsafe_member_access_expression] = STATE(629),
    [sym_scoped_property_access_expression] = STATE(629),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(1891),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(601),
    [sym_scoped_call_expression] = STATE(601),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(601),
    [sym_nullsafe_member_call_expression] = STATE(601),
    [sym_subscript_expression] = STATE(601),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(601),
    [sym_variable_name] = STATE(601),
    [sym_by_ref] = STATE(1943),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym__list_destructing_repeat1] = STATE(1933),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(851),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(855),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [149] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1178),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(945),
    [sym_array_element_initializer] = STATE(2140),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [150] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1285),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2000),
    [sym__array_destructing_element] = STATE(2360),
    [sym_function_call_expression] = STATE(621),
    [sym_scoped_call_expression] = STATE(621),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(621),
    [sym_nullsafe_member_call_expression] = STATE(621),
    [sym_subscript_expression] = STATE(621),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(621),
    [sym_variable_name] = STATE(621),
    [sym_by_ref] = STATE(2360),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(857),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(853),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(859),
    [anon_sym_RBRACK] = ACTIONS(857),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [151] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym_match_condition_list] = STATE(2504),
    [sym_match_conditional_expression] = STATE(2412),
    [sym_match_default_expression] = STATE(2412),
    [sym__expression] = STATE(1179),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(861),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [aux_sym_match_default_expression_token1] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [152] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1285),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2000),
    [sym__array_destructing_element] = STATE(2360),
    [sym_function_call_expression] = STATE(621),
    [sym_scoped_call_expression] = STATE(621),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(621),
    [sym_nullsafe_member_call_expression] = STATE(621),
    [sym_subscript_expression] = STATE(621),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(621),
    [sym_variable_name] = STATE(621),
    [sym_by_ref] = STATE(2360),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(857),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(853),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(859),
    [anon_sym_RBRACK] = ACTIONS(863),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [153] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1285),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2000),
    [sym__array_destructing_element] = STATE(2360),
    [sym_function_call_expression] = STATE(621),
    [sym_scoped_call_expression] = STATE(621),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(621),
    [sym_nullsafe_member_call_expression] = STATE(621),
    [sym_subscript_expression] = STATE(621),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(621),
    [sym_variable_name] = STATE(621),
    [sym_by_ref] = STATE(2360),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(857),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(853),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(859),
    [anon_sym_RBRACK] = ACTIONS(866),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [154] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym_match_condition_list] = STATE(2504),
    [sym_match_conditional_expression] = STATE(2412),
    [sym_match_default_expression] = STATE(2412),
    [sym__expression] = STATE(1179),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [aux_sym_match_default_expression_token1] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [155] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1236),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(637),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(637),
    [sym_nullsafe_member_access_expression] = STATE(637),
    [sym_scoped_property_access_expression] = STATE(637),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2092),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(609),
    [sym_scoped_call_expression] = STATE(609),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(609),
    [sym_nullsafe_member_call_expression] = STATE(609),
    [sym_subscript_expression] = STATE(609),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(609),
    [sym_variable_name] = STATE(609),
    [sym_by_ref] = STATE(2230),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(869),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_RPAREN] = ACTIONS(869),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [sym_reference_modifier] = STATE(185),
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1221),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2195),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1512),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [157] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2596),
    [sym_sequence_expression] = STATE(2596),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1192),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(871),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [158] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2604),
    [sym_sequence_expression] = STATE(2604),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1192),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(873),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [159] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2661),
    [sym_sequence_expression] = STATE(2661),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(875),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [160] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2654),
    [sym_sequence_expression] = STATE(2654),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(877),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [161] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_foreach_pair] = STATE(2599),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1187),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2244),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_by_ref] = STATE(2599),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [162] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2651),
    [sym_sequence_expression] = STATE(2651),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(879),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2559),
    [sym_sequence_expression] = STATE(2559),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(881),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [164] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2465),
    [sym_sequence_expression] = STATE(2465),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1192),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(883),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [165] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2448),
    [sym_sequence_expression] = STATE(2448),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(885),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2495),
    [sym_sequence_expression] = STATE(2495),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1192),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(887),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [167] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_foreach_pair] = STATE(2463),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1231),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2406),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_by_ref] = STATE(2463),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [168] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2648),
    [sym_sequence_expression] = STATE(2648),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(889),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [169] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2646),
    [sym_sequence_expression] = STATE(2646),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(891),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [170] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_foreach_pair] = STATE(2456),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1232),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2441),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_by_ref] = STATE(2456),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [171] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2624),
    [sym_sequence_expression] = STATE(2624),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(893),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [172] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2620),
    [sym_sequence_expression] = STATE(2620),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(895),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [173] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2487),
    [sym_sequence_expression] = STATE(2487),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1192),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(897),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [174] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2494),
    [sym_sequence_expression] = STATE(2494),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(899),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [175] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2602),
    [sym_sequence_expression] = STATE(2602),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1192),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(901),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [176] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2502),
    [sym_sequence_expression] = STATE(2502),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1192),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(903),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [177] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_foreach_pair] = STATE(2509),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1224),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2343),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_by_ref] = STATE(2509),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [178] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2510),
    [sym_sequence_expression] = STATE(2510),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1192),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(905),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [179] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2598),
    [sym_sequence_expression] = STATE(2598),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(907),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [180] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2461),
    [sym_sequence_expression] = STATE(2461),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1192),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(909),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [181] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2591),
    [sym_sequence_expression] = STATE(2591),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(911),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [182] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2459),
    [sym_sequence_expression] = STATE(2459),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1192),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(913),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [183] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2454),
    [sym_sequence_expression] = STATE(2454),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1192),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(915),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [184] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__expressions] = STATE(2493),
    [sym_sequence_expression] = STATE(2493),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1192),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(917),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [185] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1206),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2282),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1470),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [186] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1002),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2131),
    [sym_function_call_expression] = STATE(633),
    [sym_scoped_call_expression] = STATE(633),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(633),
    [sym_nullsafe_member_call_expression] = STATE(633),
    [sym_subscript_expression] = STATE(633),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(633),
    [sym_variable_name] = STATE(633),
    [sym_by_ref] = STATE(2214),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [187] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1120),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_by_ref] = STATE(1109),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(919),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [188] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1157),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_by_ref] = STATE(947),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [189] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_variadic_unpacking] = STATE(2200),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1523),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [190] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1182),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(921),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(921),
  },
  [191] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym__expressions] = STATE(2306),
    [sym_sequence_expression] = STATE(2306),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1176),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [192] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1288),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2352),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_by_ref] = STATE(2501),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [193] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1157),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_by_ref] = STATE(947),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(923),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [194] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1002),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(947),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(731),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [195] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1002),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(947),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(923),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [196] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(993),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_by_ref] = STATE(947),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(923),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [197] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(925),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(925),
  },
  [198] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym__expressions] = STATE(2432),
    [sym_sequence_expression] = STATE(2432),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1176),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [199] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1225),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(927),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(927),
  },
  [200] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(929),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(929),
  },
  [201] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1201),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(931),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(931),
  },
  [202] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1202),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(933),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(933),
  },
  [203] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1280),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(935),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1269),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(937),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [205] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1249),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(939),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [206] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1298),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_COLON] = ACTIONS(941),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [207] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_sequence_expression] = STATE(2328),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1175),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [208] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1230),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [209] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1039),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(945),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [210] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1161),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(947),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [211] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1296),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(949),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [212] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(991),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(951),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [213] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_sequence_expression] = STATE(2358),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1189),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [214] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1029),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(953),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [215] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1302),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_COLON] = ACTIONS(955),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [216] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_sequence_expression] = STATE(2358),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [217] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1297),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_COLON] = ACTIONS(957),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [218] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1254),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_COLON] = ACTIONS(959),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [219] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1263),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(961),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [220] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1140),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(963),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [221] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1256),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(965),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [222] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1230),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [223] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(978),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [224] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(984),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [225] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1004),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [226] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(986),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [227] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(957),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [228] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1237),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [229] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(988),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [230] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1266),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [231] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1104),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [232] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(955),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1003),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [234] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(992),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [235] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1250),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [236] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(980),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [237] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1276),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [238] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1068),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [239] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(995),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [240] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1067),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [241] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1066),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [242] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1065),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [243] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1064),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [244] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1062),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [245] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1059),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [246] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1058),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [247] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1057),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [248] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1054),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [249] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1051),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [250] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1050),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [251] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1048),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [252] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1047),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [253] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1046),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [254] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1041),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [255] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1040),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [256] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1209),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [257] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1038),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [258] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1270),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [259] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1007),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [260] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1158),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [261] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1008),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [262] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1009),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [263] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1265),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [264] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1289),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [265] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1010),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [266] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1011),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [267] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(979),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [268] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1000),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [269] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1267),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [270] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1264),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [271] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1012),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [272] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1259),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [273] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1013),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [274] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1014),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [275] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1252),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [276] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(996),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [277] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1255),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [278] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1272),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [279] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1173),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [280] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(983),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [281] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(989),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [282] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1016),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [283] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1278),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [284] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1303),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [285] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1017),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [286] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1277),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [287] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1018),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [288] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1281),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [289] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1019),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [290] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1020),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [291] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1284),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [292] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1021),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [293] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(998),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [294] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(999),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [295] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1030),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [296] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(982),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [297] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(970),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [298] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1193),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [299] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1022),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [300] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1032),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [301] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1238),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [302] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(971),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [303] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1299),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [304] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1027),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [305] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(997),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [306] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1258),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [307] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1031),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [308] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1026),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [309] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(972),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [310] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1214),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [311] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1213),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [312] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1024),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [313] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1028),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [314] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1301),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [315] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1212),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [316] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1211),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [317] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1294),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [318] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1177),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [319] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1279),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [320] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1025),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [321] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1023),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [322] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(973),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [323] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(974),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [324] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1001),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [325] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1275),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [326] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1196),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [327] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(975),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [328] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1159),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [329] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1203),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [330] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(977),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [331] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1140),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [332] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1181),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [333] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1262),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [334] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1241),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [335] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1242),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [336] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1248),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [337] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1261),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [338] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1122),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [339] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1191),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [340] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1260),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [341] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1045),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [342] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1273),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [343] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1170),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [344] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(968),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [345] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(985),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [346] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1184),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [347] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(976),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [348] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(969),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [349] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1253),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [350] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(990),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [351] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(957),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [352] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1165),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [353] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1108),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [354] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(955),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [355] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1257),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [356] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(994),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [357] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1268),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [358] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1291),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [359] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1235),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [360] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1141),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [361] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1034),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [362] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1119),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [363] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1186),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [364] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1274),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [365] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1188),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [366] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1183),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [367] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1229),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [368] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1154),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [369] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(955),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [370] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(957),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [371] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1244),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [372] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1129),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [373] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1134),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [374] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1160),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [375] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1151),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [376] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1293),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [377] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1251),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [378] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1148),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [379] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1144),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [380] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [381] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1139),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [382] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1168),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [383] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1197),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [384] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1164),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [385] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1220),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [386] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1150),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [387] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1155),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [388] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1199),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [389] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1282),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [390] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1283),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [391] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1146),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [392] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1243),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [393] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1006),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [394] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1095),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [395] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1230),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(622),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(622),
    [sym_nullsafe_member_access_expression] = STATE(622),
    [sym_scoped_property_access_expression] = STATE(622),
    [sym_list_literal] = STATE(2457),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [396] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1145),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [397] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1138),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [398] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1287),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [399] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1143),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [400] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1246),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [401] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1153),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [402] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1149),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [403] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1147),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [404] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1142),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [405] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1166),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [406] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1171),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [407] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1093),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [408] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1162),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [409] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1152),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [410] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1101),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [411] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1300),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [412] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1240),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [413] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1194),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [414] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1295),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [415] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1103),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [416] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1156),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2523),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [417] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1239),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [418] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(981),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [419] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1290),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [420] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym_match_expression] = STATE(945),
    [sym__expression] = STATE(1245),
    [sym__unary_expression] = STATE(946),
    [sym_unary_op_expression] = STATE(946),
    [sym_error_suppression_expression] = STATE(945),
    [sym_clone_expression] = STATE(946),
    [sym__primary_expression] = STATE(946),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(946),
    [sym_cast_variable] = STATE(606),
    [sym_assignment_expression] = STATE(945),
    [sym_reference_assignment_expression] = STATE(945),
    [sym_conditional_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_member_access_expression] = STATE(606),
    [sym_nullsafe_member_access_expression] = STATE(606),
    [sym_scoped_property_access_expression] = STATE(606),
    [sym_list_literal] = STATE(2554),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(595),
    [sym_scoped_call_expression] = STATE(595),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(595),
    [sym_nullsafe_member_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(595),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(595),
    [sym_variable_name] = STATE(595),
    [sym_yield_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_include_expression] = STATE(945),
    [sym_include_once_expression] = STATE(945),
    [sym_require_expression] = STATE(945),
    [sym_require_once_expression] = STATE(945),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [421] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym_match_expression] = STATE(1049),
    [sym__expression] = STATE(1092),
    [sym__unary_expression] = STATE(1132),
    [sym_unary_op_expression] = STATE(1132),
    [sym_error_suppression_expression] = STATE(1049),
    [sym_clone_expression] = STATE(1132),
    [sym__primary_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1132),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1049),
    [sym_reference_assignment_expression] = STATE(1049),
    [sym_conditional_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2536),
    [sym__list_destructing] = STATE(2302),
    [sym__array_destructing] = STATE(2302),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_yield_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_include_expression] = STATE(1049),
    [sym_include_once_expression] = STATE(1049),
    [sym_require_expression] = STATE(1049),
    [sym_require_once_expression] = STATE(1049),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [422] = {
    [sym_catch_clause] = STATE(423),
    [sym_finally_clause] = STATE(423),
    [aux_sym_try_statement_repeat1] = STATE(423),
    [ts_builtin_sym_end] = ACTIONS(969),
    [sym_name] = ACTIONS(971),
    [anon_sym_QMARK_GT] = ACTIONS(969),
    [anon_sym_SEMI] = ACTIONS(969),
    [aux_sym_function_static_declaration_token1] = ACTIONS(971),
    [aux_sym_global_declaration_token1] = ACTIONS(971),
    [aux_sym_namespace_definition_token1] = ACTIONS(971),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(971),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(971),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(971),
    [anon_sym_BSLASH] = ACTIONS(969),
    [anon_sym_LBRACE] = ACTIONS(969),
    [anon_sym_RBRACE] = ACTIONS(969),
    [aux_sym_trait_declaration_token1] = ACTIONS(971),
    [aux_sym_interface_declaration_token1] = ACTIONS(971),
    [aux_sym_enum_declaration_token1] = ACTIONS(971),
    [aux_sym_enum_case_token1] = ACTIONS(971),
    [aux_sym_class_declaration_token1] = ACTIONS(971),
    [aux_sym_final_modifier_token1] = ACTIONS(971),
    [aux_sym_abstract_modifier_token1] = ACTIONS(971),
    [aux_sym_readonly_modifier_token1] = ACTIONS(971),
    [aux_sym_visibility_modifier_token1] = ACTIONS(971),
    [aux_sym_visibility_modifier_token2] = ACTIONS(971),
    [aux_sym_visibility_modifier_token3] = ACTIONS(971),
    [aux_sym__arrow_function_header_token1] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(969),
    [aux_sym_cast_type_token1] = ACTIONS(971),
    [aux_sym_echo_statement_token1] = ACTIONS(971),
    [anon_sym_unset] = ACTIONS(971),
    [aux_sym_declare_statement_token1] = ACTIONS(971),
    [aux_sym_declare_statement_token2] = ACTIONS(971),
    [sym_float] = ACTIONS(971),
    [aux_sym_try_statement_token1] = ACTIONS(971),
    [aux_sym_catch_clause_token1] = ACTIONS(973),
    [aux_sym_finally_clause_token1] = ACTIONS(975),
    [aux_sym_goto_statement_token1] = ACTIONS(971),
    [aux_sym_continue_statement_token1] = ACTIONS(971),
    [aux_sym_break_statement_token1] = ACTIONS(971),
    [sym_integer] = ACTIONS(971),
    [aux_sym_return_statement_token1] = ACTIONS(971),
    [aux_sym_throw_expression_token1] = ACTIONS(971),
    [aux_sym_while_statement_token1] = ACTIONS(971),
    [aux_sym_while_statement_token2] = ACTIONS(971),
    [aux_sym_do_statement_token1] = ACTIONS(971),
    [aux_sym_for_statement_token1] = ACTIONS(971),
    [aux_sym_for_statement_token2] = ACTIONS(971),
    [aux_sym_foreach_statement_token1] = ACTIONS(971),
    [aux_sym_foreach_statement_token2] = ACTIONS(971),
    [aux_sym_if_statement_token1] = ACTIONS(971),
    [aux_sym_if_statement_token2] = ACTIONS(971),
    [aux_sym_else_if_clause_token1] = ACTIONS(971),
    [aux_sym_else_clause_token1] = ACTIONS(971),
    [aux_sym_match_expression_token1] = ACTIONS(971),
    [aux_sym_match_default_expression_token1] = ACTIONS(971),
    [aux_sym_switch_statement_token1] = ACTIONS(971),
    [aux_sym_switch_block_token1] = ACTIONS(971),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_TILDE] = ACTIONS(969),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_AT] = ACTIONS(969),
    [aux_sym_clone_expression_token1] = ACTIONS(971),
    [aux_sym_print_intrinsic_token1] = ACTIONS(971),
    [aux_sym_object_creation_expression_token1] = ACTIONS(971),
    [anon_sym_DASH_DASH] = ACTIONS(969),
    [anon_sym_PLUS_PLUS] = ACTIONS(969),
    [aux_sym__list_destructing_token1] = ACTIONS(971),
    [anon_sym_LBRACK] = ACTIONS(969),
    [anon_sym_self] = ACTIONS(971),
    [anon_sym_parent] = ACTIONS(971),
    [aux_sym__argument_name_token1] = ACTIONS(971),
    [aux_sym__argument_name_token2] = ACTIONS(971),
    [anon_sym_POUND_LBRACK] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(969),
    [aux_sym_encapsed_string_token1] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(969),
    [aux_sym_string_token1] = ACTIONS(969),
    [anon_sym_LT_LT_LT] = ACTIONS(969),
    [anon_sym_BQUOTE] = ACTIONS(969),
    [anon_sym_DOLLAR] = ACTIONS(969),
    [aux_sym_yield_expression_token1] = ACTIONS(971),
    [aux_sym_include_expression_token1] = ACTIONS(971),
    [aux_sym_include_once_expression_token1] = ACTIONS(971),
    [aux_sym_require_expression_token1] = ACTIONS(971),
    [aux_sym_require_once_expression_token1] = ACTIONS(971),
    [sym_comment] = ACTIONS(3),
  },
  [423] = {
    [sym_catch_clause] = STATE(423),
    [sym_finally_clause] = STATE(423),
    [aux_sym_try_statement_repeat1] = STATE(423),
    [ts_builtin_sym_end] = ACTIONS(977),
    [sym_name] = ACTIONS(979),
    [anon_sym_QMARK_GT] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(977),
    [aux_sym_function_static_declaration_token1] = ACTIONS(979),
    [aux_sym_global_declaration_token1] = ACTIONS(979),
    [aux_sym_namespace_definition_token1] = ACTIONS(979),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(979),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(979),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(979),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [aux_sym_trait_declaration_token1] = ACTIONS(979),
    [aux_sym_interface_declaration_token1] = ACTIONS(979),
    [aux_sym_enum_declaration_token1] = ACTIONS(979),
    [aux_sym_enum_case_token1] = ACTIONS(979),
    [aux_sym_class_declaration_token1] = ACTIONS(979),
    [aux_sym_final_modifier_token1] = ACTIONS(979),
    [aux_sym_abstract_modifier_token1] = ACTIONS(979),
    [aux_sym_readonly_modifier_token1] = ACTIONS(979),
    [aux_sym_visibility_modifier_token1] = ACTIONS(979),
    [aux_sym_visibility_modifier_token2] = ACTIONS(979),
    [aux_sym_visibility_modifier_token3] = ACTIONS(979),
    [aux_sym__arrow_function_header_token1] = ACTIONS(979),
    [anon_sym_LPAREN] = ACTIONS(977),
    [aux_sym_cast_type_token1] = ACTIONS(979),
    [aux_sym_echo_statement_token1] = ACTIONS(979),
    [anon_sym_unset] = ACTIONS(979),
    [aux_sym_declare_statement_token1] = ACTIONS(979),
    [aux_sym_declare_statement_token2] = ACTIONS(979),
    [sym_float] = ACTIONS(979),
    [aux_sym_try_statement_token1] = ACTIONS(979),
    [aux_sym_catch_clause_token1] = ACTIONS(981),
    [aux_sym_finally_clause_token1] = ACTIONS(984),
    [aux_sym_goto_statement_token1] = ACTIONS(979),
    [aux_sym_continue_statement_token1] = ACTIONS(979),
    [aux_sym_break_statement_token1] = ACTIONS(979),
    [sym_integer] = ACTIONS(979),
    [aux_sym_return_statement_token1] = ACTIONS(979),
    [aux_sym_throw_expression_token1] = ACTIONS(979),
    [aux_sym_while_statement_token1] = ACTIONS(979),
    [aux_sym_while_statement_token2] = ACTIONS(979),
    [aux_sym_do_statement_token1] = ACTIONS(979),
    [aux_sym_for_statement_token1] = ACTIONS(979),
    [aux_sym_for_statement_token2] = ACTIONS(979),
    [aux_sym_foreach_statement_token1] = ACTIONS(979),
    [aux_sym_foreach_statement_token2] = ACTIONS(979),
    [aux_sym_if_statement_token1] = ACTIONS(979),
    [aux_sym_if_statement_token2] = ACTIONS(979),
    [aux_sym_else_if_clause_token1] = ACTIONS(979),
    [aux_sym_else_clause_token1] = ACTIONS(979),
    [aux_sym_match_expression_token1] = ACTIONS(979),
    [aux_sym_match_default_expression_token1] = ACTIONS(979),
    [aux_sym_switch_statement_token1] = ACTIONS(979),
    [aux_sym_switch_block_token1] = ACTIONS(979),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AT] = ACTIONS(977),
    [aux_sym_clone_expression_token1] = ACTIONS(979),
    [aux_sym_print_intrinsic_token1] = ACTIONS(979),
    [aux_sym_object_creation_expression_token1] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(977),
    [aux_sym__list_destructing_token1] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(977),
    [anon_sym_self] = ACTIONS(979),
    [anon_sym_parent] = ACTIONS(979),
    [aux_sym__argument_name_token1] = ACTIONS(979),
    [aux_sym__argument_name_token2] = ACTIONS(979),
    [anon_sym_POUND_LBRACK] = ACTIONS(977),
    [anon_sym_SQUOTE] = ACTIONS(977),
    [aux_sym_encapsed_string_token1] = ACTIONS(977),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [aux_sym_string_token1] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(977),
    [aux_sym_yield_expression_token1] = ACTIONS(979),
    [aux_sym_include_expression_token1] = ACTIONS(979),
    [aux_sym_include_once_expression_token1] = ACTIONS(979),
    [aux_sym_require_expression_token1] = ACTIONS(979),
    [aux_sym_require_once_expression_token1] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
  },
  [424] = {
    [sym_else_if_clause] = STATE(540),
    [sym_else_clause] = STATE(537),
    [aux_sym_if_statement_repeat1] = STATE(427),
    [ts_builtin_sym_end] = ACTIONS(987),
    [sym_name] = ACTIONS(989),
    [anon_sym_QMARK_GT] = ACTIONS(987),
    [anon_sym_SEMI] = ACTIONS(987),
    [aux_sym_function_static_declaration_token1] = ACTIONS(989),
    [aux_sym_global_declaration_token1] = ACTIONS(989),
    [aux_sym_namespace_definition_token1] = ACTIONS(989),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(989),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(989),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [aux_sym_trait_declaration_token1] = ACTIONS(989),
    [aux_sym_interface_declaration_token1] = ACTIONS(989),
    [aux_sym_enum_declaration_token1] = ACTIONS(989),
    [aux_sym_enum_case_token1] = ACTIONS(989),
    [aux_sym_class_declaration_token1] = ACTIONS(989),
    [aux_sym_final_modifier_token1] = ACTIONS(989),
    [aux_sym_abstract_modifier_token1] = ACTIONS(989),
    [aux_sym_readonly_modifier_token1] = ACTIONS(989),
    [aux_sym_visibility_modifier_token1] = ACTIONS(989),
    [aux_sym_visibility_modifier_token2] = ACTIONS(989),
    [aux_sym_visibility_modifier_token3] = ACTIONS(989),
    [aux_sym__arrow_function_header_token1] = ACTIONS(989),
    [anon_sym_LPAREN] = ACTIONS(987),
    [aux_sym_cast_type_token1] = ACTIONS(989),
    [aux_sym_echo_statement_token1] = ACTIONS(989),
    [anon_sym_unset] = ACTIONS(989),
    [aux_sym_declare_statement_token1] = ACTIONS(989),
    [aux_sym_declare_statement_token2] = ACTIONS(989),
    [sym_float] = ACTIONS(989),
    [aux_sym_try_statement_token1] = ACTIONS(989),
    [aux_sym_goto_statement_token1] = ACTIONS(989),
    [aux_sym_continue_statement_token1] = ACTIONS(989),
    [aux_sym_break_statement_token1] = ACTIONS(989),
    [sym_integer] = ACTIONS(989),
    [aux_sym_return_statement_token1] = ACTIONS(989),
    [aux_sym_throw_expression_token1] = ACTIONS(989),
    [aux_sym_while_statement_token1] = ACTIONS(989),
    [aux_sym_while_statement_token2] = ACTIONS(989),
    [aux_sym_do_statement_token1] = ACTIONS(989),
    [aux_sym_for_statement_token1] = ACTIONS(989),
    [aux_sym_for_statement_token2] = ACTIONS(989),
    [aux_sym_foreach_statement_token1] = ACTIONS(989),
    [aux_sym_foreach_statement_token2] = ACTIONS(989),
    [aux_sym_if_statement_token1] = ACTIONS(989),
    [aux_sym_if_statement_token2] = ACTIONS(989),
    [aux_sym_else_if_clause_token1] = ACTIONS(991),
    [aux_sym_else_clause_token1] = ACTIONS(993),
    [aux_sym_match_expression_token1] = ACTIONS(989),
    [aux_sym_match_default_expression_token1] = ACTIONS(989),
    [aux_sym_switch_statement_token1] = ACTIONS(989),
    [aux_sym_switch_block_token1] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(989),
    [anon_sym_DASH] = ACTIONS(989),
    [anon_sym_TILDE] = ACTIONS(987),
    [anon_sym_BANG] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(987),
    [aux_sym_clone_expression_token1] = ACTIONS(989),
    [aux_sym_print_intrinsic_token1] = ACTIONS(989),
    [aux_sym_object_creation_expression_token1] = ACTIONS(989),
    [anon_sym_DASH_DASH] = ACTIONS(987),
    [anon_sym_PLUS_PLUS] = ACTIONS(987),
    [aux_sym__list_destructing_token1] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_self] = ACTIONS(989),
    [anon_sym_parent] = ACTIONS(989),
    [aux_sym__argument_name_token1] = ACTIONS(989),
    [aux_sym__argument_name_token2] = ACTIONS(989),
    [anon_sym_POUND_LBRACK] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(987),
    [aux_sym_encapsed_string_token1] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [aux_sym_string_token1] = ACTIONS(987),
    [anon_sym_LT_LT_LT] = ACTIONS(987),
    [anon_sym_BQUOTE] = ACTIONS(987),
    [anon_sym_DOLLAR] = ACTIONS(987),
    [aux_sym_yield_expression_token1] = ACTIONS(989),
    [aux_sym_include_expression_token1] = ACTIONS(989),
    [aux_sym_include_once_expression_token1] = ACTIONS(989),
    [aux_sym_require_expression_token1] = ACTIONS(989),
    [aux_sym_require_once_expression_token1] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
  },
  [425] = {
    [sym_else_if_clause] = STATE(540),
    [sym_else_clause] = STATE(489),
    [aux_sym_if_statement_repeat1] = STATE(428),
    [ts_builtin_sym_end] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [anon_sym_QMARK_GT] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(995),
    [aux_sym_function_static_declaration_token1] = ACTIONS(997),
    [aux_sym_global_declaration_token1] = ACTIONS(997),
    [aux_sym_namespace_definition_token1] = ACTIONS(997),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(997),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(997),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(997),
    [anon_sym_BSLASH] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_RBRACE] = ACTIONS(995),
    [aux_sym_trait_declaration_token1] = ACTIONS(997),
    [aux_sym_interface_declaration_token1] = ACTIONS(997),
    [aux_sym_enum_declaration_token1] = ACTIONS(997),
    [aux_sym_enum_case_token1] = ACTIONS(997),
    [aux_sym_class_declaration_token1] = ACTIONS(997),
    [aux_sym_final_modifier_token1] = ACTIONS(997),
    [aux_sym_abstract_modifier_token1] = ACTIONS(997),
    [aux_sym_readonly_modifier_token1] = ACTIONS(997),
    [aux_sym_visibility_modifier_token1] = ACTIONS(997),
    [aux_sym_visibility_modifier_token2] = ACTIONS(997),
    [aux_sym_visibility_modifier_token3] = ACTIONS(997),
    [aux_sym__arrow_function_header_token1] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(995),
    [aux_sym_cast_type_token1] = ACTIONS(997),
    [aux_sym_echo_statement_token1] = ACTIONS(997),
    [anon_sym_unset] = ACTIONS(997),
    [aux_sym_declare_statement_token1] = ACTIONS(997),
    [aux_sym_declare_statement_token2] = ACTIONS(997),
    [sym_float] = ACTIONS(997),
    [aux_sym_try_statement_token1] = ACTIONS(997),
    [aux_sym_goto_statement_token1] = ACTIONS(997),
    [aux_sym_continue_statement_token1] = ACTIONS(997),
    [aux_sym_break_statement_token1] = ACTIONS(997),
    [sym_integer] = ACTIONS(997),
    [aux_sym_return_statement_token1] = ACTIONS(997),
    [aux_sym_throw_expression_token1] = ACTIONS(997),
    [aux_sym_while_statement_token1] = ACTIONS(997),
    [aux_sym_while_statement_token2] = ACTIONS(997),
    [aux_sym_do_statement_token1] = ACTIONS(997),
    [aux_sym_for_statement_token1] = ACTIONS(997),
    [aux_sym_for_statement_token2] = ACTIONS(997),
    [aux_sym_foreach_statement_token1] = ACTIONS(997),
    [aux_sym_foreach_statement_token2] = ACTIONS(997),
    [aux_sym_if_statement_token1] = ACTIONS(997),
    [aux_sym_if_statement_token2] = ACTIONS(997),
    [aux_sym_else_if_clause_token1] = ACTIONS(999),
    [aux_sym_else_clause_token1] = ACTIONS(1002),
    [aux_sym_match_expression_token1] = ACTIONS(997),
    [aux_sym_match_default_expression_token1] = ACTIONS(997),
    [aux_sym_switch_statement_token1] = ACTIONS(997),
    [aux_sym_switch_block_token1] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [aux_sym_clone_expression_token1] = ACTIONS(997),
    [aux_sym_print_intrinsic_token1] = ACTIONS(997),
    [aux_sym_object_creation_expression_token1] = ACTIONS(997),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [aux_sym__list_destructing_token1] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_self] = ACTIONS(997),
    [anon_sym_parent] = ACTIONS(997),
    [aux_sym__argument_name_token1] = ACTIONS(997),
    [aux_sym__argument_name_token2] = ACTIONS(997),
    [anon_sym_POUND_LBRACK] = ACTIONS(995),
    [anon_sym_SQUOTE] = ACTIONS(995),
    [aux_sym_encapsed_string_token1] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [aux_sym_string_token1] = ACTIONS(995),
    [anon_sym_LT_LT_LT] = ACTIONS(995),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_DOLLAR] = ACTIONS(995),
    [aux_sym_yield_expression_token1] = ACTIONS(997),
    [aux_sym_include_expression_token1] = ACTIONS(997),
    [aux_sym_include_once_expression_token1] = ACTIONS(997),
    [aux_sym_require_expression_token1] = ACTIONS(997),
    [aux_sym_require_once_expression_token1] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
  },
  [426] = {
    [sym_else_if_clause] = STATE(540),
    [sym_else_clause] = STATE(537),
    [aux_sym_if_statement_repeat1] = STATE(425),
    [ts_builtin_sym_end] = ACTIONS(987),
    [sym_name] = ACTIONS(989),
    [anon_sym_QMARK_GT] = ACTIONS(987),
    [anon_sym_SEMI] = ACTIONS(987),
    [aux_sym_function_static_declaration_token1] = ACTIONS(989),
    [aux_sym_global_declaration_token1] = ACTIONS(989),
    [aux_sym_namespace_definition_token1] = ACTIONS(989),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(989),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(989),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [aux_sym_trait_declaration_token1] = ACTIONS(989),
    [aux_sym_interface_declaration_token1] = ACTIONS(989),
    [aux_sym_enum_declaration_token1] = ACTIONS(989),
    [aux_sym_enum_case_token1] = ACTIONS(989),
    [aux_sym_class_declaration_token1] = ACTIONS(989),
    [aux_sym_final_modifier_token1] = ACTIONS(989),
    [aux_sym_abstract_modifier_token1] = ACTIONS(989),
    [aux_sym_readonly_modifier_token1] = ACTIONS(989),
    [aux_sym_visibility_modifier_token1] = ACTIONS(989),
    [aux_sym_visibility_modifier_token2] = ACTIONS(989),
    [aux_sym_visibility_modifier_token3] = ACTIONS(989),
    [aux_sym__arrow_function_header_token1] = ACTIONS(989),
    [anon_sym_LPAREN] = ACTIONS(987),
    [aux_sym_cast_type_token1] = ACTIONS(989),
    [aux_sym_echo_statement_token1] = ACTIONS(989),
    [anon_sym_unset] = ACTIONS(989),
    [aux_sym_declare_statement_token1] = ACTIONS(989),
    [aux_sym_declare_statement_token2] = ACTIONS(989),
    [sym_float] = ACTIONS(989),
    [aux_sym_try_statement_token1] = ACTIONS(989),
    [aux_sym_goto_statement_token1] = ACTIONS(989),
    [aux_sym_continue_statement_token1] = ACTIONS(989),
    [aux_sym_break_statement_token1] = ACTIONS(989),
    [sym_integer] = ACTIONS(989),
    [aux_sym_return_statement_token1] = ACTIONS(989),
    [aux_sym_throw_expression_token1] = ACTIONS(989),
    [aux_sym_while_statement_token1] = ACTIONS(989),
    [aux_sym_while_statement_token2] = ACTIONS(989),
    [aux_sym_do_statement_token1] = ACTIONS(989),
    [aux_sym_for_statement_token1] = ACTIONS(989),
    [aux_sym_for_statement_token2] = ACTIONS(989),
    [aux_sym_foreach_statement_token1] = ACTIONS(989),
    [aux_sym_foreach_statement_token2] = ACTIONS(989),
    [aux_sym_if_statement_token1] = ACTIONS(989),
    [aux_sym_if_statement_token2] = ACTIONS(989),
    [aux_sym_else_if_clause_token1] = ACTIONS(1005),
    [aux_sym_else_clause_token1] = ACTIONS(1008),
    [aux_sym_match_expression_token1] = ACTIONS(989),
    [aux_sym_match_default_expression_token1] = ACTIONS(989),
    [aux_sym_switch_statement_token1] = ACTIONS(989),
    [aux_sym_switch_block_token1] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(989),
    [anon_sym_DASH] = ACTIONS(989),
    [anon_sym_TILDE] = ACTIONS(987),
    [anon_sym_BANG] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(987),
    [aux_sym_clone_expression_token1] = ACTIONS(989),
    [aux_sym_print_intrinsic_token1] = ACTIONS(989),
    [aux_sym_object_creation_expression_token1] = ACTIONS(989),
    [anon_sym_DASH_DASH] = ACTIONS(987),
    [anon_sym_PLUS_PLUS] = ACTIONS(987),
    [aux_sym__list_destructing_token1] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_self] = ACTIONS(989),
    [anon_sym_parent] = ACTIONS(989),
    [aux_sym__argument_name_token1] = ACTIONS(989),
    [aux_sym__argument_name_token2] = ACTIONS(989),
    [anon_sym_POUND_LBRACK] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(987),
    [aux_sym_encapsed_string_token1] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [aux_sym_string_token1] = ACTIONS(987),
    [anon_sym_LT_LT_LT] = ACTIONS(987),
    [anon_sym_BQUOTE] = ACTIONS(987),
    [anon_sym_DOLLAR] = ACTIONS(987),
    [aux_sym_yield_expression_token1] = ACTIONS(989),
    [aux_sym_include_expression_token1] = ACTIONS(989),
    [aux_sym_include_once_expression_token1] = ACTIONS(989),
    [aux_sym_require_expression_token1] = ACTIONS(989),
    [aux_sym_require_once_expression_token1] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
  },
  [427] = {
    [sym_else_if_clause] = STATE(540),
    [sym_else_clause] = STATE(489),
    [aux_sym_if_statement_repeat1] = STATE(428),
    [ts_builtin_sym_end] = ACTIONS(995),
    [sym_name] = ACTIONS(997),
    [anon_sym_QMARK_GT] = ACTIONS(995),
    [anon_sym_SEMI] = ACTIONS(995),
    [aux_sym_function_static_declaration_token1] = ACTIONS(997),
    [aux_sym_global_declaration_token1] = ACTIONS(997),
    [aux_sym_namespace_definition_token1] = ACTIONS(997),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(997),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(997),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(997),
    [anon_sym_BSLASH] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_RBRACE] = ACTIONS(995),
    [aux_sym_trait_declaration_token1] = ACTIONS(997),
    [aux_sym_interface_declaration_token1] = ACTIONS(997),
    [aux_sym_enum_declaration_token1] = ACTIONS(997),
    [aux_sym_enum_case_token1] = ACTIONS(997),
    [aux_sym_class_declaration_token1] = ACTIONS(997),
    [aux_sym_final_modifier_token1] = ACTIONS(997),
    [aux_sym_abstract_modifier_token1] = ACTIONS(997),
    [aux_sym_readonly_modifier_token1] = ACTIONS(997),
    [aux_sym_visibility_modifier_token1] = ACTIONS(997),
    [aux_sym_visibility_modifier_token2] = ACTIONS(997),
    [aux_sym_visibility_modifier_token3] = ACTIONS(997),
    [aux_sym__arrow_function_header_token1] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(995),
    [aux_sym_cast_type_token1] = ACTIONS(997),
    [aux_sym_echo_statement_token1] = ACTIONS(997),
    [anon_sym_unset] = ACTIONS(997),
    [aux_sym_declare_statement_token1] = ACTIONS(997),
    [aux_sym_declare_statement_token2] = ACTIONS(997),
    [sym_float] = ACTIONS(997),
    [aux_sym_try_statement_token1] = ACTIONS(997),
    [aux_sym_goto_statement_token1] = ACTIONS(997),
    [aux_sym_continue_statement_token1] = ACTIONS(997),
    [aux_sym_break_statement_token1] = ACTIONS(997),
    [sym_integer] = ACTIONS(997),
    [aux_sym_return_statement_token1] = ACTIONS(997),
    [aux_sym_throw_expression_token1] = ACTIONS(997),
    [aux_sym_while_statement_token1] = ACTIONS(997),
    [aux_sym_while_statement_token2] = ACTIONS(997),
    [aux_sym_do_statement_token1] = ACTIONS(997),
    [aux_sym_for_statement_token1] = ACTIONS(997),
    [aux_sym_for_statement_token2] = ACTIONS(997),
    [aux_sym_foreach_statement_token1] = ACTIONS(997),
    [aux_sym_foreach_statement_token2] = ACTIONS(997),
    [aux_sym_if_statement_token1] = ACTIONS(997),
    [aux_sym_if_statement_token2] = ACTIONS(997),
    [aux_sym_else_if_clause_token1] = ACTIONS(991),
    [aux_sym_else_clause_token1] = ACTIONS(993),
    [aux_sym_match_expression_token1] = ACTIONS(997),
    [aux_sym_match_default_expression_token1] = ACTIONS(997),
    [aux_sym_switch_statement_token1] = ACTIONS(997),
    [aux_sym_switch_block_token1] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [aux_sym_clone_expression_token1] = ACTIONS(997),
    [aux_sym_print_intrinsic_token1] = ACTIONS(997),
    [aux_sym_object_creation_expression_token1] = ACTIONS(997),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [aux_sym__list_destructing_token1] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_self] = ACTIONS(997),
    [anon_sym_parent] = ACTIONS(997),
    [aux_sym__argument_name_token1] = ACTIONS(997),
    [aux_sym__argument_name_token2] = ACTIONS(997),
    [anon_sym_POUND_LBRACK] = ACTIONS(995),
    [anon_sym_SQUOTE] = ACTIONS(995),
    [aux_sym_encapsed_string_token1] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(995),
    [aux_sym_string_token1] = ACTIONS(995),
    [anon_sym_LT_LT_LT] = ACTIONS(995),
    [anon_sym_BQUOTE] = ACTIONS(995),
    [anon_sym_DOLLAR] = ACTIONS(995),
    [aux_sym_yield_expression_token1] = ACTIONS(997),
    [aux_sym_include_expression_token1] = ACTIONS(997),
    [aux_sym_include_once_expression_token1] = ACTIONS(997),
    [aux_sym_require_expression_token1] = ACTIONS(997),
    [aux_sym_require_once_expression_token1] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
  },
  [428] = {
    [sym_else_if_clause] = STATE(540),
    [aux_sym_if_statement_repeat1] = STATE(428),
    [ts_builtin_sym_end] = ACTIONS(1011),
    [sym_name] = ACTIONS(1013),
    [anon_sym_QMARK_GT] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1011),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1013),
    [aux_sym_global_declaration_token1] = ACTIONS(1013),
    [aux_sym_namespace_definition_token1] = ACTIONS(1013),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1013),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1013),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1013),
    [anon_sym_BSLASH] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1011),
    [aux_sym_trait_declaration_token1] = ACTIONS(1013),
    [aux_sym_interface_declaration_token1] = ACTIONS(1013),
    [aux_sym_enum_declaration_token1] = ACTIONS(1013),
    [aux_sym_enum_case_token1] = ACTIONS(1013),
    [aux_sym_class_declaration_token1] = ACTIONS(1013),
    [aux_sym_final_modifier_token1] = ACTIONS(1013),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1013),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1013),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1013),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1013),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1013),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [aux_sym_cast_type_token1] = ACTIONS(1013),
    [aux_sym_echo_statement_token1] = ACTIONS(1013),
    [anon_sym_unset] = ACTIONS(1013),
    [aux_sym_declare_statement_token1] = ACTIONS(1013),
    [aux_sym_declare_statement_token2] = ACTIONS(1013),
    [sym_float] = ACTIONS(1013),
    [aux_sym_try_statement_token1] = ACTIONS(1013),
    [aux_sym_goto_statement_token1] = ACTIONS(1013),
    [aux_sym_continue_statement_token1] = ACTIONS(1013),
    [aux_sym_break_statement_token1] = ACTIONS(1013),
    [sym_integer] = ACTIONS(1013),
    [aux_sym_return_statement_token1] = ACTIONS(1013),
    [aux_sym_throw_expression_token1] = ACTIONS(1013),
    [aux_sym_while_statement_token1] = ACTIONS(1013),
    [aux_sym_while_statement_token2] = ACTIONS(1013),
    [aux_sym_do_statement_token1] = ACTIONS(1013),
    [aux_sym_for_statement_token1] = ACTIONS(1013),
    [aux_sym_for_statement_token2] = ACTIONS(1013),
    [aux_sym_foreach_statement_token1] = ACTIONS(1013),
    [aux_sym_foreach_statement_token2] = ACTIONS(1013),
    [aux_sym_if_statement_token1] = ACTIONS(1013),
    [aux_sym_if_statement_token2] = ACTIONS(1013),
    [aux_sym_else_if_clause_token1] = ACTIONS(1015),
    [aux_sym_else_clause_token1] = ACTIONS(1013),
    [aux_sym_match_expression_token1] = ACTIONS(1013),
    [aux_sym_match_default_expression_token1] = ACTIONS(1013),
    [aux_sym_switch_statement_token1] = ACTIONS(1013),
    [aux_sym_switch_block_token1] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_AT] = ACTIONS(1011),
    [aux_sym_clone_expression_token1] = ACTIONS(1013),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1013),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1011),
    [anon_sym_PLUS_PLUS] = ACTIONS(1011),
    [aux_sym__list_destructing_token1] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1011),
    [anon_sym_self] = ACTIONS(1013),
    [anon_sym_parent] = ACTIONS(1013),
    [aux_sym__argument_name_token1] = ACTIONS(1013),
    [aux_sym__argument_name_token2] = ACTIONS(1013),
    [anon_sym_POUND_LBRACK] = ACTIONS(1011),
    [anon_sym_SQUOTE] = ACTIONS(1011),
    [aux_sym_encapsed_string_token1] = ACTIONS(1011),
    [anon_sym_DQUOTE] = ACTIONS(1011),
    [aux_sym_string_token1] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [anon_sym_BQUOTE] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(1011),
    [aux_sym_yield_expression_token1] = ACTIONS(1013),
    [aux_sym_include_expression_token1] = ACTIONS(1013),
    [aux_sym_include_once_expression_token1] = ACTIONS(1013),
    [aux_sym_require_expression_token1] = ACTIONS(1013),
    [aux_sym_require_once_expression_token1] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(1018),
    [sym_name] = ACTIONS(1020),
    [anon_sym_QMARK_GT] = ACTIONS(1018),
    [anon_sym_SEMI] = ACTIONS(1018),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1020),
    [aux_sym_global_declaration_token1] = ACTIONS(1020),
    [aux_sym_namespace_definition_token1] = ACTIONS(1020),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1020),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1020),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1020),
    [anon_sym_BSLASH] = ACTIONS(1018),
    [anon_sym_LBRACE] = ACTIONS(1018),
    [anon_sym_RBRACE] = ACTIONS(1018),
    [aux_sym_trait_declaration_token1] = ACTIONS(1020),
    [aux_sym_interface_declaration_token1] = ACTIONS(1020),
    [aux_sym_enum_declaration_token1] = ACTIONS(1020),
    [aux_sym_enum_case_token1] = ACTIONS(1020),
    [aux_sym_class_declaration_token1] = ACTIONS(1020),
    [aux_sym_final_modifier_token1] = ACTIONS(1020),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1020),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1020),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1020),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1020),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1020),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1020),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [aux_sym_cast_type_token1] = ACTIONS(1020),
    [aux_sym_echo_statement_token1] = ACTIONS(1020),
    [anon_sym_unset] = ACTIONS(1020),
    [aux_sym_declare_statement_token1] = ACTIONS(1020),
    [aux_sym_declare_statement_token2] = ACTIONS(1020),
    [sym_float] = ACTIONS(1020),
    [aux_sym_try_statement_token1] = ACTIONS(1020),
    [aux_sym_catch_clause_token1] = ACTIONS(1020),
    [aux_sym_finally_clause_token1] = ACTIONS(1020),
    [aux_sym_goto_statement_token1] = ACTIONS(1020),
    [aux_sym_continue_statement_token1] = ACTIONS(1020),
    [aux_sym_break_statement_token1] = ACTIONS(1020),
    [sym_integer] = ACTIONS(1020),
    [aux_sym_return_statement_token1] = ACTIONS(1020),
    [aux_sym_throw_expression_token1] = ACTIONS(1020),
    [aux_sym_while_statement_token1] = ACTIONS(1020),
    [aux_sym_while_statement_token2] = ACTIONS(1020),
    [aux_sym_do_statement_token1] = ACTIONS(1020),
    [aux_sym_for_statement_token1] = ACTIONS(1020),
    [aux_sym_for_statement_token2] = ACTIONS(1020),
    [aux_sym_foreach_statement_token1] = ACTIONS(1020),
    [aux_sym_foreach_statement_token2] = ACTIONS(1020),
    [aux_sym_if_statement_token1] = ACTIONS(1020),
    [aux_sym_if_statement_token2] = ACTIONS(1020),
    [aux_sym_else_if_clause_token1] = ACTIONS(1020),
    [aux_sym_else_clause_token1] = ACTIONS(1020),
    [aux_sym_match_expression_token1] = ACTIONS(1020),
    [aux_sym_match_default_expression_token1] = ACTIONS(1020),
    [aux_sym_switch_statement_token1] = ACTIONS(1020),
    [aux_sym_switch_block_token1] = ACTIONS(1020),
    [anon_sym_PLUS] = ACTIONS(1020),
    [anon_sym_DASH] = ACTIONS(1020),
    [anon_sym_TILDE] = ACTIONS(1018),
    [anon_sym_BANG] = ACTIONS(1018),
    [anon_sym_AT] = ACTIONS(1018),
    [aux_sym_clone_expression_token1] = ACTIONS(1020),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1020),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1020),
    [anon_sym_DASH_DASH] = ACTIONS(1018),
    [anon_sym_PLUS_PLUS] = ACTIONS(1018),
    [aux_sym__list_destructing_token1] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1018),
    [anon_sym_self] = ACTIONS(1020),
    [anon_sym_parent] = ACTIONS(1020),
    [aux_sym__argument_name_token1] = ACTIONS(1020),
    [aux_sym__argument_name_token2] = ACTIONS(1020),
    [anon_sym_POUND_LBRACK] = ACTIONS(1018),
    [anon_sym_SQUOTE] = ACTIONS(1018),
    [aux_sym_encapsed_string_token1] = ACTIONS(1018),
    [anon_sym_DQUOTE] = ACTIONS(1018),
    [aux_sym_string_token1] = ACTIONS(1018),
    [anon_sym_LT_LT_LT] = ACTIONS(1018),
    [anon_sym_BQUOTE] = ACTIONS(1018),
    [anon_sym_DOLLAR] = ACTIONS(1018),
    [aux_sym_yield_expression_token1] = ACTIONS(1020),
    [aux_sym_include_expression_token1] = ACTIONS(1020),
    [aux_sym_include_once_expression_token1] = ACTIONS(1020),
    [aux_sym_require_expression_token1] = ACTIONS(1020),
    [aux_sym_require_once_expression_token1] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(1022),
    [sym_name] = ACTIONS(1024),
    [anon_sym_QMARK_GT] = ACTIONS(1022),
    [anon_sym_SEMI] = ACTIONS(1022),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1024),
    [aux_sym_global_declaration_token1] = ACTIONS(1024),
    [aux_sym_namespace_definition_token1] = ACTIONS(1024),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1024),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1024),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1024),
    [anon_sym_BSLASH] = ACTIONS(1022),
    [anon_sym_LBRACE] = ACTIONS(1022),
    [anon_sym_RBRACE] = ACTIONS(1022),
    [aux_sym_trait_declaration_token1] = ACTIONS(1024),
    [aux_sym_interface_declaration_token1] = ACTIONS(1024),
    [aux_sym_enum_declaration_token1] = ACTIONS(1024),
    [aux_sym_enum_case_token1] = ACTIONS(1024),
    [aux_sym_class_declaration_token1] = ACTIONS(1024),
    [aux_sym_final_modifier_token1] = ACTIONS(1024),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1024),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1024),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1024),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1024),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1024),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1024),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [aux_sym_cast_type_token1] = ACTIONS(1024),
    [aux_sym_echo_statement_token1] = ACTIONS(1024),
    [anon_sym_unset] = ACTIONS(1024),
    [aux_sym_declare_statement_token1] = ACTIONS(1024),
    [aux_sym_declare_statement_token2] = ACTIONS(1024),
    [sym_float] = ACTIONS(1024),
    [aux_sym_try_statement_token1] = ACTIONS(1024),
    [aux_sym_catch_clause_token1] = ACTIONS(1024),
    [aux_sym_finally_clause_token1] = ACTIONS(1024),
    [aux_sym_goto_statement_token1] = ACTIONS(1024),
    [aux_sym_continue_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1024),
    [sym_integer] = ACTIONS(1024),
    [aux_sym_return_statement_token1] = ACTIONS(1024),
    [aux_sym_throw_expression_token1] = ACTIONS(1024),
    [aux_sym_while_statement_token1] = ACTIONS(1024),
    [aux_sym_while_statement_token2] = ACTIONS(1024),
    [aux_sym_do_statement_token1] = ACTIONS(1024),
    [aux_sym_for_statement_token1] = ACTIONS(1024),
    [aux_sym_for_statement_token2] = ACTIONS(1024),
    [aux_sym_foreach_statement_token1] = ACTIONS(1024),
    [aux_sym_foreach_statement_token2] = ACTIONS(1024),
    [aux_sym_if_statement_token1] = ACTIONS(1024),
    [aux_sym_if_statement_token2] = ACTIONS(1024),
    [aux_sym_else_if_clause_token1] = ACTIONS(1024),
    [aux_sym_else_clause_token1] = ACTIONS(1024),
    [aux_sym_match_expression_token1] = ACTIONS(1024),
    [aux_sym_match_default_expression_token1] = ACTIONS(1024),
    [aux_sym_switch_statement_token1] = ACTIONS(1024),
    [aux_sym_switch_block_token1] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(1022),
    [aux_sym_clone_expression_token1] = ACTIONS(1024),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1024),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1024),
    [anon_sym_DASH_DASH] = ACTIONS(1022),
    [anon_sym_PLUS_PLUS] = ACTIONS(1022),
    [aux_sym__list_destructing_token1] = ACTIONS(1024),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [anon_sym_self] = ACTIONS(1024),
    [anon_sym_parent] = ACTIONS(1024),
    [aux_sym__argument_name_token1] = ACTIONS(1024),
    [aux_sym__argument_name_token2] = ACTIONS(1024),
    [anon_sym_POUND_LBRACK] = ACTIONS(1022),
    [anon_sym_SQUOTE] = ACTIONS(1022),
    [aux_sym_encapsed_string_token1] = ACTIONS(1022),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [aux_sym_string_token1] = ACTIONS(1022),
    [anon_sym_LT_LT_LT] = ACTIONS(1022),
    [anon_sym_BQUOTE] = ACTIONS(1022),
    [anon_sym_DOLLAR] = ACTIONS(1022),
    [aux_sym_yield_expression_token1] = ACTIONS(1024),
    [aux_sym_include_expression_token1] = ACTIONS(1024),
    [aux_sym_include_once_expression_token1] = ACTIONS(1024),
    [aux_sym_require_expression_token1] = ACTIONS(1024),
    [aux_sym_require_once_expression_token1] = ACTIONS(1024),
    [sym_comment] = ACTIONS(3),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(1026),
    [sym_name] = ACTIONS(1028),
    [anon_sym_QMARK_GT] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1026),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1028),
    [aux_sym_global_declaration_token1] = ACTIONS(1028),
    [aux_sym_namespace_definition_token1] = ACTIONS(1028),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1028),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1028),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1028),
    [anon_sym_BSLASH] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1026),
    [anon_sym_RBRACE] = ACTIONS(1026),
    [aux_sym_trait_declaration_token1] = ACTIONS(1028),
    [aux_sym_interface_declaration_token1] = ACTIONS(1028),
    [aux_sym_enum_declaration_token1] = ACTIONS(1028),
    [aux_sym_enum_case_token1] = ACTIONS(1028),
    [aux_sym_class_declaration_token1] = ACTIONS(1028),
    [aux_sym_final_modifier_token1] = ACTIONS(1028),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1028),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1028),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1028),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1028),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1028),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1028),
    [anon_sym_LPAREN] = ACTIONS(1026),
    [aux_sym_cast_type_token1] = ACTIONS(1028),
    [aux_sym_echo_statement_token1] = ACTIONS(1028),
    [anon_sym_unset] = ACTIONS(1028),
    [aux_sym_declare_statement_token1] = ACTIONS(1028),
    [aux_sym_declare_statement_token2] = ACTIONS(1028),
    [sym_float] = ACTIONS(1028),
    [aux_sym_try_statement_token1] = ACTIONS(1028),
    [aux_sym_catch_clause_token1] = ACTIONS(1028),
    [aux_sym_finally_clause_token1] = ACTIONS(1028),
    [aux_sym_goto_statement_token1] = ACTIONS(1028),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_break_statement_token1] = ACTIONS(1028),
    [sym_integer] = ACTIONS(1028),
    [aux_sym_return_statement_token1] = ACTIONS(1028),
    [aux_sym_throw_expression_token1] = ACTIONS(1028),
    [aux_sym_while_statement_token1] = ACTIONS(1028),
    [aux_sym_while_statement_token2] = ACTIONS(1028),
    [aux_sym_do_statement_token1] = ACTIONS(1028),
    [aux_sym_for_statement_token1] = ACTIONS(1028),
    [aux_sym_for_statement_token2] = ACTIONS(1028),
    [aux_sym_foreach_statement_token1] = ACTIONS(1028),
    [aux_sym_foreach_statement_token2] = ACTIONS(1028),
    [aux_sym_if_statement_token1] = ACTIONS(1028),
    [aux_sym_if_statement_token2] = ACTIONS(1028),
    [aux_sym_else_if_clause_token1] = ACTIONS(1028),
    [aux_sym_else_clause_token1] = ACTIONS(1028),
    [aux_sym_match_expression_token1] = ACTIONS(1028),
    [aux_sym_match_default_expression_token1] = ACTIONS(1028),
    [aux_sym_switch_statement_token1] = ACTIONS(1028),
    [aux_sym_switch_block_token1] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1028),
    [anon_sym_DASH] = ACTIONS(1028),
    [anon_sym_TILDE] = ACTIONS(1026),
    [anon_sym_BANG] = ACTIONS(1026),
    [anon_sym_AT] = ACTIONS(1026),
    [aux_sym_clone_expression_token1] = ACTIONS(1028),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1028),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1028),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [aux_sym__list_destructing_token1] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1026),
    [anon_sym_self] = ACTIONS(1028),
    [anon_sym_parent] = ACTIONS(1028),
    [aux_sym__argument_name_token1] = ACTIONS(1028),
    [aux_sym__argument_name_token2] = ACTIONS(1028),
    [anon_sym_POUND_LBRACK] = ACTIONS(1026),
    [anon_sym_SQUOTE] = ACTIONS(1026),
    [aux_sym_encapsed_string_token1] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [aux_sym_string_token1] = ACTIONS(1026),
    [anon_sym_LT_LT_LT] = ACTIONS(1026),
    [anon_sym_BQUOTE] = ACTIONS(1026),
    [anon_sym_DOLLAR] = ACTIONS(1026),
    [aux_sym_yield_expression_token1] = ACTIONS(1028),
    [aux_sym_include_expression_token1] = ACTIONS(1028),
    [aux_sym_include_once_expression_token1] = ACTIONS(1028),
    [aux_sym_require_expression_token1] = ACTIONS(1028),
    [aux_sym_require_once_expression_token1] = ACTIONS(1028),
    [sym_comment] = ACTIONS(3),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(1030),
    [sym_name] = ACTIONS(1032),
    [anon_sym_QMARK_GT] = ACTIONS(1030),
    [anon_sym_SEMI] = ACTIONS(1030),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1032),
    [aux_sym_global_declaration_token1] = ACTIONS(1032),
    [aux_sym_namespace_definition_token1] = ACTIONS(1032),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1032),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1032),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1032),
    [anon_sym_BSLASH] = ACTIONS(1030),
    [anon_sym_LBRACE] = ACTIONS(1030),
    [anon_sym_RBRACE] = ACTIONS(1030),
    [aux_sym_trait_declaration_token1] = ACTIONS(1032),
    [aux_sym_interface_declaration_token1] = ACTIONS(1032),
    [aux_sym_enum_declaration_token1] = ACTIONS(1032),
    [aux_sym_enum_case_token1] = ACTIONS(1032),
    [aux_sym_class_declaration_token1] = ACTIONS(1032),
    [aux_sym_final_modifier_token1] = ACTIONS(1032),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1032),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1032),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1032),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1032),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1032),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1032),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [aux_sym_cast_type_token1] = ACTIONS(1032),
    [aux_sym_echo_statement_token1] = ACTIONS(1032),
    [anon_sym_unset] = ACTIONS(1032),
    [aux_sym_declare_statement_token1] = ACTIONS(1032),
    [aux_sym_declare_statement_token2] = ACTIONS(1032),
    [sym_float] = ACTIONS(1032),
    [aux_sym_try_statement_token1] = ACTIONS(1032),
    [aux_sym_catch_clause_token1] = ACTIONS(1032),
    [aux_sym_finally_clause_token1] = ACTIONS(1032),
    [aux_sym_goto_statement_token1] = ACTIONS(1032),
    [aux_sym_continue_statement_token1] = ACTIONS(1032),
    [aux_sym_break_statement_token1] = ACTIONS(1032),
    [sym_integer] = ACTIONS(1032),
    [aux_sym_return_statement_token1] = ACTIONS(1032),
    [aux_sym_throw_expression_token1] = ACTIONS(1032),
    [aux_sym_while_statement_token1] = ACTIONS(1032),
    [aux_sym_while_statement_token2] = ACTIONS(1032),
    [aux_sym_do_statement_token1] = ACTIONS(1032),
    [aux_sym_for_statement_token1] = ACTIONS(1032),
    [aux_sym_for_statement_token2] = ACTIONS(1032),
    [aux_sym_foreach_statement_token1] = ACTIONS(1032),
    [aux_sym_foreach_statement_token2] = ACTIONS(1032),
    [aux_sym_if_statement_token1] = ACTIONS(1032),
    [aux_sym_if_statement_token2] = ACTIONS(1032),
    [aux_sym_else_if_clause_token1] = ACTIONS(1032),
    [aux_sym_else_clause_token1] = ACTIONS(1032),
    [aux_sym_match_expression_token1] = ACTIONS(1032),
    [aux_sym_match_default_expression_token1] = ACTIONS(1032),
    [aux_sym_switch_statement_token1] = ACTIONS(1032),
    [aux_sym_switch_block_token1] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1032),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_TILDE] = ACTIONS(1030),
    [anon_sym_BANG] = ACTIONS(1030),
    [anon_sym_AT] = ACTIONS(1030),
    [aux_sym_clone_expression_token1] = ACTIONS(1032),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1032),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1030),
    [aux_sym__list_destructing_token1] = ACTIONS(1032),
    [anon_sym_LBRACK] = ACTIONS(1030),
    [anon_sym_self] = ACTIONS(1032),
    [anon_sym_parent] = ACTIONS(1032),
    [aux_sym__argument_name_token1] = ACTIONS(1032),
    [aux_sym__argument_name_token2] = ACTIONS(1032),
    [anon_sym_POUND_LBRACK] = ACTIONS(1030),
    [anon_sym_SQUOTE] = ACTIONS(1030),
    [aux_sym_encapsed_string_token1] = ACTIONS(1030),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [aux_sym_string_token1] = ACTIONS(1030),
    [anon_sym_LT_LT_LT] = ACTIONS(1030),
    [anon_sym_BQUOTE] = ACTIONS(1030),
    [anon_sym_DOLLAR] = ACTIONS(1030),
    [aux_sym_yield_expression_token1] = ACTIONS(1032),
    [aux_sym_include_expression_token1] = ACTIONS(1032),
    [aux_sym_include_once_expression_token1] = ACTIONS(1032),
    [aux_sym_require_expression_token1] = ACTIONS(1032),
    [aux_sym_require_once_expression_token1] = ACTIONS(1032),
    [sym_comment] = ACTIONS(3),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(1034),
    [sym_name] = ACTIONS(1036),
    [anon_sym_QMARK_GT] = ACTIONS(1034),
    [anon_sym_SEMI] = ACTIONS(1034),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1036),
    [aux_sym_global_declaration_token1] = ACTIONS(1036),
    [aux_sym_namespace_definition_token1] = ACTIONS(1036),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1036),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1036),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1036),
    [anon_sym_BSLASH] = ACTIONS(1034),
    [anon_sym_LBRACE] = ACTIONS(1034),
    [anon_sym_RBRACE] = ACTIONS(1034),
    [aux_sym_trait_declaration_token1] = ACTIONS(1036),
    [aux_sym_interface_declaration_token1] = ACTIONS(1036),
    [aux_sym_enum_declaration_token1] = ACTIONS(1036),
    [aux_sym_enum_case_token1] = ACTIONS(1036),
    [aux_sym_class_declaration_token1] = ACTIONS(1036),
    [aux_sym_final_modifier_token1] = ACTIONS(1036),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1036),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1036),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1036),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1036),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1036),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1036),
    [anon_sym_LPAREN] = ACTIONS(1034),
    [aux_sym_cast_type_token1] = ACTIONS(1036),
    [aux_sym_echo_statement_token1] = ACTIONS(1036),
    [anon_sym_unset] = ACTIONS(1036),
    [aux_sym_declare_statement_token1] = ACTIONS(1036),
    [aux_sym_declare_statement_token2] = ACTIONS(1036),
    [sym_float] = ACTIONS(1036),
    [aux_sym_try_statement_token1] = ACTIONS(1036),
    [aux_sym_catch_clause_token1] = ACTIONS(1036),
    [aux_sym_finally_clause_token1] = ACTIONS(1036),
    [aux_sym_goto_statement_token1] = ACTIONS(1036),
    [aux_sym_continue_statement_token1] = ACTIONS(1036),
    [aux_sym_break_statement_token1] = ACTIONS(1036),
    [sym_integer] = ACTIONS(1036),
    [aux_sym_return_statement_token1] = ACTIONS(1036),
    [aux_sym_throw_expression_token1] = ACTIONS(1036),
    [aux_sym_while_statement_token1] = ACTIONS(1036),
    [aux_sym_while_statement_token2] = ACTIONS(1036),
    [aux_sym_do_statement_token1] = ACTIONS(1036),
    [aux_sym_for_statement_token1] = ACTIONS(1036),
    [aux_sym_for_statement_token2] = ACTIONS(1036),
    [aux_sym_foreach_statement_token1] = ACTIONS(1036),
    [aux_sym_foreach_statement_token2] = ACTIONS(1036),
    [aux_sym_if_statement_token1] = ACTIONS(1036),
    [aux_sym_if_statement_token2] = ACTIONS(1036),
    [aux_sym_else_if_clause_token1] = ACTIONS(1036),
    [aux_sym_else_clause_token1] = ACTIONS(1036),
    [aux_sym_match_expression_token1] = ACTIONS(1036),
    [aux_sym_match_default_expression_token1] = ACTIONS(1036),
    [aux_sym_switch_statement_token1] = ACTIONS(1036),
    [aux_sym_switch_block_token1] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AT] = ACTIONS(1034),
    [aux_sym_clone_expression_token1] = ACTIONS(1036),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1036),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1036),
    [anon_sym_DASH_DASH] = ACTIONS(1034),
    [anon_sym_PLUS_PLUS] = ACTIONS(1034),
    [aux_sym__list_destructing_token1] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(1034),
    [anon_sym_self] = ACTIONS(1036),
    [anon_sym_parent] = ACTIONS(1036),
    [aux_sym__argument_name_token1] = ACTIONS(1036),
    [aux_sym__argument_name_token2] = ACTIONS(1036),
    [anon_sym_POUND_LBRACK] = ACTIONS(1034),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [aux_sym_encapsed_string_token1] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [aux_sym_string_token1] = ACTIONS(1034),
    [anon_sym_LT_LT_LT] = ACTIONS(1034),
    [anon_sym_BQUOTE] = ACTIONS(1034),
    [anon_sym_DOLLAR] = ACTIONS(1034),
    [aux_sym_yield_expression_token1] = ACTIONS(1036),
    [aux_sym_include_expression_token1] = ACTIONS(1036),
    [aux_sym_include_once_expression_token1] = ACTIONS(1036),
    [aux_sym_require_expression_token1] = ACTIONS(1036),
    [aux_sym_require_once_expression_token1] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(1038),
    [sym_name] = ACTIONS(1040),
    [anon_sym_QMARK_GT] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1042),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1040),
    [aux_sym_global_declaration_token1] = ACTIONS(1040),
    [aux_sym_namespace_definition_token1] = ACTIONS(1040),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1040),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1040),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1040),
    [anon_sym_BSLASH] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_RBRACE] = ACTIONS(1038),
    [aux_sym_trait_declaration_token1] = ACTIONS(1040),
    [aux_sym_interface_declaration_token1] = ACTIONS(1040),
    [aux_sym_enum_declaration_token1] = ACTIONS(1040),
    [aux_sym_enum_case_token1] = ACTIONS(1040),
    [aux_sym_class_declaration_token1] = ACTIONS(1040),
    [aux_sym_final_modifier_token1] = ACTIONS(1040),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1040),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1040),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1040),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1040),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1040),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1040),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_cast_type_token1] = ACTIONS(1040),
    [aux_sym_echo_statement_token1] = ACTIONS(1040),
    [anon_sym_unset] = ACTIONS(1040),
    [aux_sym_declare_statement_token1] = ACTIONS(1040),
    [aux_sym_declare_statement_token2] = ACTIONS(1040),
    [sym_float] = ACTIONS(1040),
    [aux_sym_try_statement_token1] = ACTIONS(1040),
    [aux_sym_goto_statement_token1] = ACTIONS(1040),
    [aux_sym_continue_statement_token1] = ACTIONS(1040),
    [aux_sym_break_statement_token1] = ACTIONS(1040),
    [sym_integer] = ACTIONS(1040),
    [aux_sym_return_statement_token1] = ACTIONS(1040),
    [aux_sym_throw_expression_token1] = ACTIONS(1040),
    [aux_sym_while_statement_token1] = ACTIONS(1040),
    [aux_sym_while_statement_token2] = ACTIONS(1040),
    [aux_sym_do_statement_token1] = ACTIONS(1040),
    [aux_sym_for_statement_token1] = ACTIONS(1040),
    [aux_sym_for_statement_token2] = ACTIONS(1040),
    [aux_sym_foreach_statement_token1] = ACTIONS(1040),
    [aux_sym_foreach_statement_token2] = ACTIONS(1040),
    [aux_sym_if_statement_token1] = ACTIONS(1040),
    [aux_sym_if_statement_token2] = ACTIONS(1040),
    [aux_sym_else_if_clause_token1] = ACTIONS(1040),
    [aux_sym_else_clause_token1] = ACTIONS(1040),
    [aux_sym_match_expression_token1] = ACTIONS(1040),
    [aux_sym_match_default_expression_token1] = ACTIONS(1040),
    [aux_sym_switch_statement_token1] = ACTIONS(1040),
    [aux_sym_switch_block_token1] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1040),
    [anon_sym_DASH] = ACTIONS(1040),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AT] = ACTIONS(1038),
    [aux_sym_clone_expression_token1] = ACTIONS(1040),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1040),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1040),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [aux_sym__list_destructing_token1] = ACTIONS(1040),
    [anon_sym_LBRACK] = ACTIONS(1038),
    [anon_sym_self] = ACTIONS(1040),
    [anon_sym_parent] = ACTIONS(1040),
    [aux_sym__argument_name_token1] = ACTIONS(1040),
    [aux_sym__argument_name_token2] = ACTIONS(1040),
    [anon_sym_POUND_LBRACK] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [aux_sym_encapsed_string_token1] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [aux_sym_string_token1] = ACTIONS(1038),
    [anon_sym_LT_LT_LT] = ACTIONS(1038),
    [anon_sym_BQUOTE] = ACTIONS(1038),
    [anon_sym_DOLLAR] = ACTIONS(1038),
    [aux_sym_yield_expression_token1] = ACTIONS(1040),
    [aux_sym_include_expression_token1] = ACTIONS(1040),
    [aux_sym_include_once_expression_token1] = ACTIONS(1040),
    [aux_sym_require_expression_token1] = ACTIONS(1040),
    [aux_sym_require_once_expression_token1] = ACTIONS(1040),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1042),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(1044),
    [sym_name] = ACTIONS(1046),
    [anon_sym_QMARK_GT] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1048),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1046),
    [aux_sym_global_declaration_token1] = ACTIONS(1046),
    [aux_sym_namespace_definition_token1] = ACTIONS(1046),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1046),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1046),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1046),
    [anon_sym_BSLASH] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1044),
    [anon_sym_RBRACE] = ACTIONS(1044),
    [aux_sym_trait_declaration_token1] = ACTIONS(1046),
    [aux_sym_interface_declaration_token1] = ACTIONS(1046),
    [aux_sym_enum_declaration_token1] = ACTIONS(1046),
    [aux_sym_enum_case_token1] = ACTIONS(1046),
    [aux_sym_class_declaration_token1] = ACTIONS(1046),
    [aux_sym_final_modifier_token1] = ACTIONS(1046),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1046),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1046),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1046),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1046),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1046),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1046),
    [anon_sym_LPAREN] = ACTIONS(1044),
    [aux_sym_cast_type_token1] = ACTIONS(1046),
    [aux_sym_echo_statement_token1] = ACTIONS(1046),
    [anon_sym_unset] = ACTIONS(1046),
    [aux_sym_declare_statement_token1] = ACTIONS(1046),
    [aux_sym_declare_statement_token2] = ACTIONS(1046),
    [sym_float] = ACTIONS(1046),
    [aux_sym_try_statement_token1] = ACTIONS(1046),
    [aux_sym_goto_statement_token1] = ACTIONS(1046),
    [aux_sym_continue_statement_token1] = ACTIONS(1046),
    [aux_sym_break_statement_token1] = ACTIONS(1046),
    [sym_integer] = ACTIONS(1046),
    [aux_sym_return_statement_token1] = ACTIONS(1046),
    [aux_sym_throw_expression_token1] = ACTIONS(1046),
    [aux_sym_while_statement_token1] = ACTIONS(1046),
    [aux_sym_while_statement_token2] = ACTIONS(1046),
    [aux_sym_do_statement_token1] = ACTIONS(1046),
    [aux_sym_for_statement_token1] = ACTIONS(1046),
    [aux_sym_for_statement_token2] = ACTIONS(1046),
    [aux_sym_foreach_statement_token1] = ACTIONS(1046),
    [aux_sym_foreach_statement_token2] = ACTIONS(1046),
    [aux_sym_if_statement_token1] = ACTIONS(1046),
    [aux_sym_if_statement_token2] = ACTIONS(1046),
    [aux_sym_else_if_clause_token1] = ACTIONS(1046),
    [aux_sym_else_clause_token1] = ACTIONS(1046),
    [aux_sym_match_expression_token1] = ACTIONS(1046),
    [aux_sym_match_default_expression_token1] = ACTIONS(1046),
    [aux_sym_switch_statement_token1] = ACTIONS(1046),
    [aux_sym_switch_block_token1] = ACTIONS(1046),
    [anon_sym_PLUS] = ACTIONS(1046),
    [anon_sym_DASH] = ACTIONS(1046),
    [anon_sym_TILDE] = ACTIONS(1044),
    [anon_sym_BANG] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(1044),
    [aux_sym_clone_expression_token1] = ACTIONS(1046),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1046),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1046),
    [anon_sym_DASH_DASH] = ACTIONS(1044),
    [anon_sym_PLUS_PLUS] = ACTIONS(1044),
    [aux_sym__list_destructing_token1] = ACTIONS(1046),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_self] = ACTIONS(1046),
    [anon_sym_parent] = ACTIONS(1046),
    [aux_sym__argument_name_token1] = ACTIONS(1046),
    [aux_sym__argument_name_token2] = ACTIONS(1046),
    [anon_sym_POUND_LBRACK] = ACTIONS(1044),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [aux_sym_encapsed_string_token1] = ACTIONS(1044),
    [anon_sym_DQUOTE] = ACTIONS(1044),
    [aux_sym_string_token1] = ACTIONS(1044),
    [anon_sym_LT_LT_LT] = ACTIONS(1044),
    [anon_sym_BQUOTE] = ACTIONS(1044),
    [anon_sym_DOLLAR] = ACTIONS(1044),
    [aux_sym_yield_expression_token1] = ACTIONS(1046),
    [aux_sym_include_expression_token1] = ACTIONS(1046),
    [aux_sym_include_once_expression_token1] = ACTIONS(1046),
    [aux_sym_require_expression_token1] = ACTIONS(1046),
    [aux_sym_require_once_expression_token1] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1048),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(1050),
    [sym_name] = ACTIONS(1052),
    [anon_sym_QMARK_GT] = ACTIONS(1050),
    [anon_sym_SEMI] = ACTIONS(1054),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1052),
    [aux_sym_global_declaration_token1] = ACTIONS(1052),
    [aux_sym_namespace_definition_token1] = ACTIONS(1052),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1052),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1052),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1052),
    [anon_sym_BSLASH] = ACTIONS(1050),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_RBRACE] = ACTIONS(1050),
    [aux_sym_trait_declaration_token1] = ACTIONS(1052),
    [aux_sym_interface_declaration_token1] = ACTIONS(1052),
    [aux_sym_enum_declaration_token1] = ACTIONS(1052),
    [aux_sym_enum_case_token1] = ACTIONS(1052),
    [aux_sym_class_declaration_token1] = ACTIONS(1052),
    [aux_sym_final_modifier_token1] = ACTIONS(1052),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1052),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1052),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1052),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1052),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1052),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1052),
    [anon_sym_LPAREN] = ACTIONS(1050),
    [aux_sym_cast_type_token1] = ACTIONS(1052),
    [aux_sym_echo_statement_token1] = ACTIONS(1052),
    [anon_sym_unset] = ACTIONS(1052),
    [aux_sym_declare_statement_token1] = ACTIONS(1052),
    [aux_sym_declare_statement_token2] = ACTIONS(1052),
    [sym_float] = ACTIONS(1052),
    [aux_sym_try_statement_token1] = ACTIONS(1052),
    [aux_sym_goto_statement_token1] = ACTIONS(1052),
    [aux_sym_continue_statement_token1] = ACTIONS(1052),
    [aux_sym_break_statement_token1] = ACTIONS(1052),
    [sym_integer] = ACTIONS(1052),
    [aux_sym_return_statement_token1] = ACTIONS(1052),
    [aux_sym_throw_expression_token1] = ACTIONS(1052),
    [aux_sym_while_statement_token1] = ACTIONS(1052),
    [aux_sym_while_statement_token2] = ACTIONS(1052),
    [aux_sym_do_statement_token1] = ACTIONS(1052),
    [aux_sym_for_statement_token1] = ACTIONS(1052),
    [aux_sym_for_statement_token2] = ACTIONS(1052),
    [aux_sym_foreach_statement_token1] = ACTIONS(1052),
    [aux_sym_foreach_statement_token2] = ACTIONS(1052),
    [aux_sym_if_statement_token1] = ACTIONS(1052),
    [aux_sym_if_statement_token2] = ACTIONS(1052),
    [aux_sym_else_if_clause_token1] = ACTIONS(1052),
    [aux_sym_else_clause_token1] = ACTIONS(1052),
    [aux_sym_match_expression_token1] = ACTIONS(1052),
    [aux_sym_match_default_expression_token1] = ACTIONS(1052),
    [aux_sym_switch_statement_token1] = ACTIONS(1052),
    [aux_sym_switch_block_token1] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_TILDE] = ACTIONS(1050),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_AT] = ACTIONS(1050),
    [aux_sym_clone_expression_token1] = ACTIONS(1052),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1052),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1050),
    [aux_sym__list_destructing_token1] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(1050),
    [anon_sym_self] = ACTIONS(1052),
    [anon_sym_parent] = ACTIONS(1052),
    [aux_sym__argument_name_token1] = ACTIONS(1052),
    [aux_sym__argument_name_token2] = ACTIONS(1052),
    [anon_sym_POUND_LBRACK] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [aux_sym_encapsed_string_token1] = ACTIONS(1050),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [aux_sym_string_token1] = ACTIONS(1050),
    [anon_sym_LT_LT_LT] = ACTIONS(1050),
    [anon_sym_BQUOTE] = ACTIONS(1050),
    [anon_sym_DOLLAR] = ACTIONS(1050),
    [aux_sym_yield_expression_token1] = ACTIONS(1052),
    [aux_sym_include_expression_token1] = ACTIONS(1052),
    [aux_sym_include_once_expression_token1] = ACTIONS(1052),
    [aux_sym_require_expression_token1] = ACTIONS(1052),
    [aux_sym_require_once_expression_token1] = ACTIONS(1052),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1054),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(1056),
    [sym_name] = ACTIONS(1058),
    [anon_sym_QMARK_GT] = ACTIONS(1056),
    [anon_sym_SEMI] = ACTIONS(1060),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1058),
    [aux_sym_global_declaration_token1] = ACTIONS(1058),
    [aux_sym_namespace_definition_token1] = ACTIONS(1058),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1058),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1058),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1058),
    [anon_sym_BSLASH] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1056),
    [anon_sym_RBRACE] = ACTIONS(1056),
    [aux_sym_trait_declaration_token1] = ACTIONS(1058),
    [aux_sym_interface_declaration_token1] = ACTIONS(1058),
    [aux_sym_enum_declaration_token1] = ACTIONS(1058),
    [aux_sym_enum_case_token1] = ACTIONS(1058),
    [aux_sym_class_declaration_token1] = ACTIONS(1058),
    [aux_sym_final_modifier_token1] = ACTIONS(1058),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1058),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1058),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1058),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1058),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1058),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1058),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [aux_sym_cast_type_token1] = ACTIONS(1058),
    [aux_sym_echo_statement_token1] = ACTIONS(1058),
    [anon_sym_unset] = ACTIONS(1058),
    [aux_sym_declare_statement_token1] = ACTIONS(1058),
    [aux_sym_declare_statement_token2] = ACTIONS(1058),
    [sym_float] = ACTIONS(1058),
    [aux_sym_try_statement_token1] = ACTIONS(1058),
    [aux_sym_goto_statement_token1] = ACTIONS(1058),
    [aux_sym_continue_statement_token1] = ACTIONS(1058),
    [aux_sym_break_statement_token1] = ACTIONS(1058),
    [sym_integer] = ACTIONS(1058),
    [aux_sym_return_statement_token1] = ACTIONS(1058),
    [aux_sym_throw_expression_token1] = ACTIONS(1058),
    [aux_sym_while_statement_token1] = ACTIONS(1058),
    [aux_sym_while_statement_token2] = ACTIONS(1058),
    [aux_sym_do_statement_token1] = ACTIONS(1058),
    [aux_sym_for_statement_token1] = ACTIONS(1058),
    [aux_sym_for_statement_token2] = ACTIONS(1058),
    [aux_sym_foreach_statement_token1] = ACTIONS(1058),
    [aux_sym_foreach_statement_token2] = ACTIONS(1058),
    [aux_sym_if_statement_token1] = ACTIONS(1058),
    [aux_sym_if_statement_token2] = ACTIONS(1058),
    [aux_sym_else_if_clause_token1] = ACTIONS(1058),
    [aux_sym_else_clause_token1] = ACTIONS(1058),
    [aux_sym_match_expression_token1] = ACTIONS(1058),
    [aux_sym_match_default_expression_token1] = ACTIONS(1058),
    [aux_sym_switch_statement_token1] = ACTIONS(1058),
    [aux_sym_switch_block_token1] = ACTIONS(1058),
    [anon_sym_PLUS] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1058),
    [anon_sym_TILDE] = ACTIONS(1056),
    [anon_sym_BANG] = ACTIONS(1056),
    [anon_sym_AT] = ACTIONS(1056),
    [aux_sym_clone_expression_token1] = ACTIONS(1058),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1058),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1058),
    [anon_sym_DASH_DASH] = ACTIONS(1056),
    [anon_sym_PLUS_PLUS] = ACTIONS(1056),
    [aux_sym__list_destructing_token1] = ACTIONS(1058),
    [anon_sym_LBRACK] = ACTIONS(1056),
    [anon_sym_self] = ACTIONS(1058),
    [anon_sym_parent] = ACTIONS(1058),
    [aux_sym__argument_name_token1] = ACTIONS(1058),
    [aux_sym__argument_name_token2] = ACTIONS(1058),
    [anon_sym_POUND_LBRACK] = ACTIONS(1056),
    [anon_sym_SQUOTE] = ACTIONS(1056),
    [aux_sym_encapsed_string_token1] = ACTIONS(1056),
    [anon_sym_DQUOTE] = ACTIONS(1056),
    [aux_sym_string_token1] = ACTIONS(1056),
    [anon_sym_LT_LT_LT] = ACTIONS(1056),
    [anon_sym_BQUOTE] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1056),
    [aux_sym_yield_expression_token1] = ACTIONS(1058),
    [aux_sym_include_expression_token1] = ACTIONS(1058),
    [aux_sym_include_once_expression_token1] = ACTIONS(1058),
    [aux_sym_require_expression_token1] = ACTIONS(1058),
    [aux_sym_require_once_expression_token1] = ACTIONS(1058),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1060),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(1062),
    [sym_name] = ACTIONS(1064),
    [anon_sym_QMARK_GT] = ACTIONS(1062),
    [anon_sym_SEMI] = ACTIONS(1062),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1064),
    [aux_sym_global_declaration_token1] = ACTIONS(1064),
    [aux_sym_namespace_definition_token1] = ACTIONS(1064),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1064),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1064),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1064),
    [anon_sym_BSLASH] = ACTIONS(1062),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_RBRACE] = ACTIONS(1062),
    [aux_sym_trait_declaration_token1] = ACTIONS(1064),
    [aux_sym_interface_declaration_token1] = ACTIONS(1064),
    [aux_sym_enum_declaration_token1] = ACTIONS(1064),
    [aux_sym_enum_case_token1] = ACTIONS(1064),
    [aux_sym_class_declaration_token1] = ACTIONS(1064),
    [aux_sym_final_modifier_token1] = ACTIONS(1064),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1064),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1064),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1064),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1064),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1064),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [aux_sym_cast_type_token1] = ACTIONS(1064),
    [aux_sym_echo_statement_token1] = ACTIONS(1064),
    [anon_sym_unset] = ACTIONS(1064),
    [aux_sym_declare_statement_token1] = ACTIONS(1064),
    [aux_sym_declare_statement_token2] = ACTIONS(1064),
    [sym_float] = ACTIONS(1064),
    [aux_sym_try_statement_token1] = ACTIONS(1064),
    [aux_sym_goto_statement_token1] = ACTIONS(1064),
    [aux_sym_continue_statement_token1] = ACTIONS(1064),
    [aux_sym_break_statement_token1] = ACTIONS(1064),
    [sym_integer] = ACTIONS(1064),
    [aux_sym_return_statement_token1] = ACTIONS(1064),
    [aux_sym_throw_expression_token1] = ACTIONS(1064),
    [aux_sym_while_statement_token1] = ACTIONS(1064),
    [aux_sym_while_statement_token2] = ACTIONS(1064),
    [aux_sym_do_statement_token1] = ACTIONS(1064),
    [aux_sym_for_statement_token1] = ACTIONS(1064),
    [aux_sym_for_statement_token2] = ACTIONS(1064),
    [aux_sym_foreach_statement_token1] = ACTIONS(1064),
    [aux_sym_foreach_statement_token2] = ACTIONS(1064),
    [aux_sym_if_statement_token1] = ACTIONS(1064),
    [aux_sym_if_statement_token2] = ACTIONS(1064),
    [aux_sym_else_if_clause_token1] = ACTIONS(1064),
    [aux_sym_else_clause_token1] = ACTIONS(1064),
    [aux_sym_match_expression_token1] = ACTIONS(1064),
    [aux_sym_match_default_expression_token1] = ACTIONS(1064),
    [aux_sym_switch_statement_token1] = ACTIONS(1064),
    [aux_sym_switch_block_token1] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_BANG] = ACTIONS(1062),
    [anon_sym_AT] = ACTIONS(1062),
    [aux_sym_clone_expression_token1] = ACTIONS(1064),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1064),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1064),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [aux_sym__list_destructing_token1] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1062),
    [anon_sym_self] = ACTIONS(1064),
    [anon_sym_parent] = ACTIONS(1064),
    [aux_sym__argument_name_token1] = ACTIONS(1064),
    [aux_sym__argument_name_token2] = ACTIONS(1064),
    [anon_sym_POUND_LBRACK] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [aux_sym_encapsed_string_token1] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [aux_sym_string_token1] = ACTIONS(1062),
    [anon_sym_LT_LT_LT] = ACTIONS(1062),
    [anon_sym_BQUOTE] = ACTIONS(1062),
    [anon_sym_DOLLAR] = ACTIONS(1062),
    [aux_sym_yield_expression_token1] = ACTIONS(1064),
    [aux_sym_include_expression_token1] = ACTIONS(1064),
    [aux_sym_include_once_expression_token1] = ACTIONS(1064),
    [aux_sym_require_expression_token1] = ACTIONS(1064),
    [aux_sym_require_once_expression_token1] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1062),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(1066),
    [sym_name] = ACTIONS(1068),
    [anon_sym_QMARK_GT] = ACTIONS(1066),
    [anon_sym_SEMI] = ACTIONS(1070),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1068),
    [aux_sym_global_declaration_token1] = ACTIONS(1068),
    [aux_sym_namespace_definition_token1] = ACTIONS(1068),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1068),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1068),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1068),
    [anon_sym_BSLASH] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_RBRACE] = ACTIONS(1066),
    [aux_sym_trait_declaration_token1] = ACTIONS(1068),
    [aux_sym_interface_declaration_token1] = ACTIONS(1068),
    [aux_sym_enum_declaration_token1] = ACTIONS(1068),
    [aux_sym_enum_case_token1] = ACTIONS(1068),
    [aux_sym_class_declaration_token1] = ACTIONS(1068),
    [aux_sym_final_modifier_token1] = ACTIONS(1068),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1068),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1068),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1068),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1068),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1068),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1068),
    [anon_sym_LPAREN] = ACTIONS(1066),
    [aux_sym_cast_type_token1] = ACTIONS(1068),
    [aux_sym_echo_statement_token1] = ACTIONS(1068),
    [anon_sym_unset] = ACTIONS(1068),
    [aux_sym_declare_statement_token1] = ACTIONS(1068),
    [aux_sym_declare_statement_token2] = ACTIONS(1068),
    [sym_float] = ACTIONS(1068),
    [aux_sym_try_statement_token1] = ACTIONS(1068),
    [aux_sym_goto_statement_token1] = ACTIONS(1068),
    [aux_sym_continue_statement_token1] = ACTIONS(1068),
    [aux_sym_break_statement_token1] = ACTIONS(1068),
    [sym_integer] = ACTIONS(1068),
    [aux_sym_return_statement_token1] = ACTIONS(1068),
    [aux_sym_throw_expression_token1] = ACTIONS(1068),
    [aux_sym_while_statement_token1] = ACTIONS(1068),
    [aux_sym_while_statement_token2] = ACTIONS(1068),
    [aux_sym_do_statement_token1] = ACTIONS(1068),
    [aux_sym_for_statement_token1] = ACTIONS(1068),
    [aux_sym_for_statement_token2] = ACTIONS(1068),
    [aux_sym_foreach_statement_token1] = ACTIONS(1068),
    [aux_sym_foreach_statement_token2] = ACTIONS(1068),
    [aux_sym_if_statement_token1] = ACTIONS(1068),
    [aux_sym_if_statement_token2] = ACTIONS(1068),
    [aux_sym_else_if_clause_token1] = ACTIONS(1068),
    [aux_sym_else_clause_token1] = ACTIONS(1068),
    [aux_sym_match_expression_token1] = ACTIONS(1068),
    [aux_sym_match_default_expression_token1] = ACTIONS(1068),
    [aux_sym_switch_statement_token1] = ACTIONS(1068),
    [aux_sym_switch_block_token1] = ACTIONS(1068),
    [anon_sym_PLUS] = ACTIONS(1068),
    [anon_sym_DASH] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1066),
    [anon_sym_AT] = ACTIONS(1066),
    [aux_sym_clone_expression_token1] = ACTIONS(1068),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1068),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [aux_sym__list_destructing_token1] = ACTIONS(1068),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_self] = ACTIONS(1068),
    [anon_sym_parent] = ACTIONS(1068),
    [aux_sym__argument_name_token1] = ACTIONS(1068),
    [aux_sym__argument_name_token2] = ACTIONS(1068),
    [anon_sym_POUND_LBRACK] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(1066),
    [aux_sym_encapsed_string_token1] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1066),
    [aux_sym_string_token1] = ACTIONS(1066),
    [anon_sym_LT_LT_LT] = ACTIONS(1066),
    [anon_sym_BQUOTE] = ACTIONS(1066),
    [anon_sym_DOLLAR] = ACTIONS(1066),
    [aux_sym_yield_expression_token1] = ACTIONS(1068),
    [aux_sym_include_expression_token1] = ACTIONS(1068),
    [aux_sym_include_once_expression_token1] = ACTIONS(1068),
    [aux_sym_require_expression_token1] = ACTIONS(1068),
    [aux_sym_require_once_expression_token1] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1070),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(1072),
    [sym_name] = ACTIONS(1074),
    [anon_sym_QMARK_GT] = ACTIONS(1072),
    [anon_sym_SEMI] = ACTIONS(1076),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1074),
    [aux_sym_global_declaration_token1] = ACTIONS(1074),
    [aux_sym_namespace_definition_token1] = ACTIONS(1074),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1074),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1074),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1074),
    [anon_sym_BSLASH] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1072),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [aux_sym_trait_declaration_token1] = ACTIONS(1074),
    [aux_sym_interface_declaration_token1] = ACTIONS(1074),
    [aux_sym_enum_declaration_token1] = ACTIONS(1074),
    [aux_sym_enum_case_token1] = ACTIONS(1074),
    [aux_sym_class_declaration_token1] = ACTIONS(1074),
    [aux_sym_final_modifier_token1] = ACTIONS(1074),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1074),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1074),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1074),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1074),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1074),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [aux_sym_cast_type_token1] = ACTIONS(1074),
    [aux_sym_echo_statement_token1] = ACTIONS(1074),
    [anon_sym_unset] = ACTIONS(1074),
    [aux_sym_declare_statement_token1] = ACTIONS(1074),
    [aux_sym_declare_statement_token2] = ACTIONS(1074),
    [sym_float] = ACTIONS(1074),
    [aux_sym_try_statement_token1] = ACTIONS(1074),
    [aux_sym_goto_statement_token1] = ACTIONS(1074),
    [aux_sym_continue_statement_token1] = ACTIONS(1074),
    [aux_sym_break_statement_token1] = ACTIONS(1074),
    [sym_integer] = ACTIONS(1074),
    [aux_sym_return_statement_token1] = ACTIONS(1074),
    [aux_sym_throw_expression_token1] = ACTIONS(1074),
    [aux_sym_while_statement_token1] = ACTIONS(1074),
    [aux_sym_while_statement_token2] = ACTIONS(1074),
    [aux_sym_do_statement_token1] = ACTIONS(1074),
    [aux_sym_for_statement_token1] = ACTIONS(1074),
    [aux_sym_for_statement_token2] = ACTIONS(1074),
    [aux_sym_foreach_statement_token1] = ACTIONS(1074),
    [aux_sym_foreach_statement_token2] = ACTIONS(1074),
    [aux_sym_if_statement_token1] = ACTIONS(1074),
    [aux_sym_if_statement_token2] = ACTIONS(1074),
    [aux_sym_else_if_clause_token1] = ACTIONS(1074),
    [aux_sym_else_clause_token1] = ACTIONS(1074),
    [aux_sym_match_expression_token1] = ACTIONS(1074),
    [aux_sym_match_default_expression_token1] = ACTIONS(1074),
    [aux_sym_switch_statement_token1] = ACTIONS(1074),
    [aux_sym_switch_block_token1] = ACTIONS(1074),
    [anon_sym_PLUS] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_AT] = ACTIONS(1072),
    [aux_sym_clone_expression_token1] = ACTIONS(1074),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1074),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1072),
    [anon_sym_PLUS_PLUS] = ACTIONS(1072),
    [aux_sym__list_destructing_token1] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_self] = ACTIONS(1074),
    [anon_sym_parent] = ACTIONS(1074),
    [aux_sym__argument_name_token1] = ACTIONS(1074),
    [aux_sym__argument_name_token2] = ACTIONS(1074),
    [anon_sym_POUND_LBRACK] = ACTIONS(1072),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [aux_sym_encapsed_string_token1] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [aux_sym_string_token1] = ACTIONS(1072),
    [anon_sym_LT_LT_LT] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1072),
    [aux_sym_yield_expression_token1] = ACTIONS(1074),
    [aux_sym_include_expression_token1] = ACTIONS(1074),
    [aux_sym_include_once_expression_token1] = ACTIONS(1074),
    [aux_sym_require_expression_token1] = ACTIONS(1074),
    [aux_sym_require_once_expression_token1] = ACTIONS(1074),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1076),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(1078),
    [sym_name] = ACTIONS(1080),
    [anon_sym_QMARK_GT] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1082),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1080),
    [aux_sym_global_declaration_token1] = ACTIONS(1080),
    [aux_sym_namespace_definition_token1] = ACTIONS(1080),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1080),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1080),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1080),
    [anon_sym_BSLASH] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(1078),
    [aux_sym_trait_declaration_token1] = ACTIONS(1080),
    [aux_sym_interface_declaration_token1] = ACTIONS(1080),
    [aux_sym_enum_declaration_token1] = ACTIONS(1080),
    [aux_sym_enum_case_token1] = ACTIONS(1080),
    [aux_sym_class_declaration_token1] = ACTIONS(1080),
    [aux_sym_final_modifier_token1] = ACTIONS(1080),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1080),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1080),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1080),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1080),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1080),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [aux_sym_cast_type_token1] = ACTIONS(1080),
    [aux_sym_echo_statement_token1] = ACTIONS(1080),
    [anon_sym_unset] = ACTIONS(1080),
    [aux_sym_declare_statement_token1] = ACTIONS(1080),
    [aux_sym_declare_statement_token2] = ACTIONS(1080),
    [sym_float] = ACTIONS(1080),
    [aux_sym_try_statement_token1] = ACTIONS(1080),
    [aux_sym_goto_statement_token1] = ACTIONS(1080),
    [aux_sym_continue_statement_token1] = ACTIONS(1080),
    [aux_sym_break_statement_token1] = ACTIONS(1080),
    [sym_integer] = ACTIONS(1080),
    [aux_sym_return_statement_token1] = ACTIONS(1080),
    [aux_sym_throw_expression_token1] = ACTIONS(1080),
    [aux_sym_while_statement_token1] = ACTIONS(1080),
    [aux_sym_while_statement_token2] = ACTIONS(1080),
    [aux_sym_do_statement_token1] = ACTIONS(1080),
    [aux_sym_for_statement_token1] = ACTIONS(1080),
    [aux_sym_for_statement_token2] = ACTIONS(1080),
    [aux_sym_foreach_statement_token1] = ACTIONS(1080),
    [aux_sym_foreach_statement_token2] = ACTIONS(1080),
    [aux_sym_if_statement_token1] = ACTIONS(1080),
    [aux_sym_if_statement_token2] = ACTIONS(1080),
    [aux_sym_else_if_clause_token1] = ACTIONS(1080),
    [aux_sym_else_clause_token1] = ACTIONS(1080),
    [aux_sym_match_expression_token1] = ACTIONS(1080),
    [aux_sym_match_default_expression_token1] = ACTIONS(1080),
    [aux_sym_switch_statement_token1] = ACTIONS(1080),
    [aux_sym_switch_block_token1] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_TILDE] = ACTIONS(1078),
    [anon_sym_BANG] = ACTIONS(1078),
    [anon_sym_AT] = ACTIONS(1078),
    [aux_sym_clone_expression_token1] = ACTIONS(1080),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1080),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1080),
    [anon_sym_DASH_DASH] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1078),
    [aux_sym__list_destructing_token1] = ACTIONS(1080),
    [anon_sym_LBRACK] = ACTIONS(1078),
    [anon_sym_self] = ACTIONS(1080),
    [anon_sym_parent] = ACTIONS(1080),
    [aux_sym__argument_name_token1] = ACTIONS(1080),
    [aux_sym__argument_name_token2] = ACTIONS(1080),
    [anon_sym_POUND_LBRACK] = ACTIONS(1078),
    [anon_sym_SQUOTE] = ACTIONS(1078),
    [aux_sym_encapsed_string_token1] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [aux_sym_string_token1] = ACTIONS(1078),
    [anon_sym_LT_LT_LT] = ACTIONS(1078),
    [anon_sym_BQUOTE] = ACTIONS(1078),
    [anon_sym_DOLLAR] = ACTIONS(1078),
    [aux_sym_yield_expression_token1] = ACTIONS(1080),
    [aux_sym_include_expression_token1] = ACTIONS(1080),
    [aux_sym_include_once_expression_token1] = ACTIONS(1080),
    [aux_sym_require_expression_token1] = ACTIONS(1080),
    [aux_sym_require_once_expression_token1] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1082),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(1084),
    [sym_name] = ACTIONS(1086),
    [anon_sym_QMARK_GT] = ACTIONS(1084),
    [anon_sym_SEMI] = ACTIONS(1088),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1086),
    [aux_sym_global_declaration_token1] = ACTIONS(1086),
    [aux_sym_namespace_definition_token1] = ACTIONS(1086),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1086),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1086),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1086),
    [anon_sym_BSLASH] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1084),
    [anon_sym_RBRACE] = ACTIONS(1084),
    [aux_sym_trait_declaration_token1] = ACTIONS(1086),
    [aux_sym_interface_declaration_token1] = ACTIONS(1086),
    [aux_sym_enum_declaration_token1] = ACTIONS(1086),
    [aux_sym_enum_case_token1] = ACTIONS(1086),
    [aux_sym_class_declaration_token1] = ACTIONS(1086),
    [aux_sym_final_modifier_token1] = ACTIONS(1086),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1086),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1086),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1086),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1086),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1086),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1086),
    [anon_sym_LPAREN] = ACTIONS(1084),
    [aux_sym_cast_type_token1] = ACTIONS(1086),
    [aux_sym_echo_statement_token1] = ACTIONS(1086),
    [anon_sym_unset] = ACTIONS(1086),
    [aux_sym_declare_statement_token1] = ACTIONS(1086),
    [aux_sym_declare_statement_token2] = ACTIONS(1086),
    [sym_float] = ACTIONS(1086),
    [aux_sym_try_statement_token1] = ACTIONS(1086),
    [aux_sym_goto_statement_token1] = ACTIONS(1086),
    [aux_sym_continue_statement_token1] = ACTIONS(1086),
    [aux_sym_break_statement_token1] = ACTIONS(1086),
    [sym_integer] = ACTIONS(1086),
    [aux_sym_return_statement_token1] = ACTIONS(1086),
    [aux_sym_throw_expression_token1] = ACTIONS(1086),
    [aux_sym_while_statement_token1] = ACTIONS(1086),
    [aux_sym_while_statement_token2] = ACTIONS(1086),
    [aux_sym_do_statement_token1] = ACTIONS(1086),
    [aux_sym_for_statement_token1] = ACTIONS(1086),
    [aux_sym_for_statement_token2] = ACTIONS(1086),
    [aux_sym_foreach_statement_token1] = ACTIONS(1086),
    [aux_sym_foreach_statement_token2] = ACTIONS(1086),
    [aux_sym_if_statement_token1] = ACTIONS(1086),
    [aux_sym_if_statement_token2] = ACTIONS(1086),
    [aux_sym_else_if_clause_token1] = ACTIONS(1086),
    [aux_sym_else_clause_token1] = ACTIONS(1086),
    [aux_sym_match_expression_token1] = ACTIONS(1086),
    [aux_sym_match_default_expression_token1] = ACTIONS(1086),
    [aux_sym_switch_statement_token1] = ACTIONS(1086),
    [aux_sym_switch_block_token1] = ACTIONS(1086),
    [anon_sym_PLUS] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1084),
    [anon_sym_BANG] = ACTIONS(1084),
    [anon_sym_AT] = ACTIONS(1084),
    [aux_sym_clone_expression_token1] = ACTIONS(1086),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1086),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1086),
    [anon_sym_DASH_DASH] = ACTIONS(1084),
    [anon_sym_PLUS_PLUS] = ACTIONS(1084),
    [aux_sym__list_destructing_token1] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1084),
    [anon_sym_self] = ACTIONS(1086),
    [anon_sym_parent] = ACTIONS(1086),
    [aux_sym__argument_name_token1] = ACTIONS(1086),
    [aux_sym__argument_name_token2] = ACTIONS(1086),
    [anon_sym_POUND_LBRACK] = ACTIONS(1084),
    [anon_sym_SQUOTE] = ACTIONS(1084),
    [aux_sym_encapsed_string_token1] = ACTIONS(1084),
    [anon_sym_DQUOTE] = ACTIONS(1084),
    [aux_sym_string_token1] = ACTIONS(1084),
    [anon_sym_LT_LT_LT] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1084),
    [anon_sym_DOLLAR] = ACTIONS(1084),
    [aux_sym_yield_expression_token1] = ACTIONS(1086),
    [aux_sym_include_expression_token1] = ACTIONS(1086),
    [aux_sym_include_once_expression_token1] = ACTIONS(1086),
    [aux_sym_require_expression_token1] = ACTIONS(1086),
    [aux_sym_require_once_expression_token1] = ACTIONS(1086),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1088),
  },
  [443] = {
    [ts_builtin_sym_end] = ACTIONS(1090),
    [sym_name] = ACTIONS(1092),
    [anon_sym_QMARK_GT] = ACTIONS(1090),
    [anon_sym_SEMI] = ACTIONS(1094),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1092),
    [aux_sym_global_declaration_token1] = ACTIONS(1092),
    [aux_sym_namespace_definition_token1] = ACTIONS(1092),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1092),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1092),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1092),
    [anon_sym_BSLASH] = ACTIONS(1090),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_RBRACE] = ACTIONS(1090),
    [aux_sym_trait_declaration_token1] = ACTIONS(1092),
    [aux_sym_interface_declaration_token1] = ACTIONS(1092),
    [aux_sym_enum_declaration_token1] = ACTIONS(1092),
    [aux_sym_enum_case_token1] = ACTIONS(1092),
    [aux_sym_class_declaration_token1] = ACTIONS(1092),
    [aux_sym_final_modifier_token1] = ACTIONS(1092),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1092),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1092),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1092),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1092),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1092),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1092),
    [anon_sym_LPAREN] = ACTIONS(1090),
    [aux_sym_cast_type_token1] = ACTIONS(1092),
    [aux_sym_echo_statement_token1] = ACTIONS(1092),
    [anon_sym_unset] = ACTIONS(1092),
    [aux_sym_declare_statement_token1] = ACTIONS(1092),
    [aux_sym_declare_statement_token2] = ACTIONS(1092),
    [sym_float] = ACTIONS(1092),
    [aux_sym_try_statement_token1] = ACTIONS(1092),
    [aux_sym_goto_statement_token1] = ACTIONS(1092),
    [aux_sym_continue_statement_token1] = ACTIONS(1092),
    [aux_sym_break_statement_token1] = ACTIONS(1092),
    [sym_integer] = ACTIONS(1092),
    [aux_sym_return_statement_token1] = ACTIONS(1092),
    [aux_sym_throw_expression_token1] = ACTIONS(1092),
    [aux_sym_while_statement_token1] = ACTIONS(1092),
    [aux_sym_while_statement_token2] = ACTIONS(1092),
    [aux_sym_do_statement_token1] = ACTIONS(1092),
    [aux_sym_for_statement_token1] = ACTIONS(1092),
    [aux_sym_for_statement_token2] = ACTIONS(1092),
    [aux_sym_foreach_statement_token1] = ACTIONS(1092),
    [aux_sym_foreach_statement_token2] = ACTIONS(1092),
    [aux_sym_if_statement_token1] = ACTIONS(1092),
    [aux_sym_if_statement_token2] = ACTIONS(1092),
    [aux_sym_else_if_clause_token1] = ACTIONS(1092),
    [aux_sym_else_clause_token1] = ACTIONS(1092),
    [aux_sym_match_expression_token1] = ACTIONS(1092),
    [aux_sym_match_default_expression_token1] = ACTIONS(1092),
    [aux_sym_switch_statement_token1] = ACTIONS(1092),
    [aux_sym_switch_block_token1] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_BANG] = ACTIONS(1090),
    [anon_sym_AT] = ACTIONS(1090),
    [aux_sym_clone_expression_token1] = ACTIONS(1092),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1092),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1092),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [aux_sym__list_destructing_token1] = ACTIONS(1092),
    [anon_sym_LBRACK] = ACTIONS(1090),
    [anon_sym_self] = ACTIONS(1092),
    [anon_sym_parent] = ACTIONS(1092),
    [aux_sym__argument_name_token1] = ACTIONS(1092),
    [aux_sym__argument_name_token2] = ACTIONS(1092),
    [anon_sym_POUND_LBRACK] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [aux_sym_encapsed_string_token1] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [aux_sym_string_token1] = ACTIONS(1090),
    [anon_sym_LT_LT_LT] = ACTIONS(1090),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [anon_sym_DOLLAR] = ACTIONS(1090),
    [aux_sym_yield_expression_token1] = ACTIONS(1092),
    [aux_sym_include_expression_token1] = ACTIONS(1092),
    [aux_sym_include_once_expression_token1] = ACTIONS(1092),
    [aux_sym_require_expression_token1] = ACTIONS(1092),
    [aux_sym_require_once_expression_token1] = ACTIONS(1092),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1094),
  },
  [444] = {
    [ts_builtin_sym_end] = ACTIONS(1096),
    [sym_name] = ACTIONS(1098),
    [anon_sym_QMARK_GT] = ACTIONS(1096),
    [anon_sym_SEMI] = ACTIONS(1100),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1098),
    [aux_sym_global_declaration_token1] = ACTIONS(1098),
    [aux_sym_namespace_definition_token1] = ACTIONS(1098),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1098),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1098),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1098),
    [anon_sym_BSLASH] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1096),
    [anon_sym_RBRACE] = ACTIONS(1096),
    [aux_sym_trait_declaration_token1] = ACTIONS(1098),
    [aux_sym_interface_declaration_token1] = ACTIONS(1098),
    [aux_sym_enum_declaration_token1] = ACTIONS(1098),
    [aux_sym_enum_case_token1] = ACTIONS(1098),
    [aux_sym_class_declaration_token1] = ACTIONS(1098),
    [aux_sym_final_modifier_token1] = ACTIONS(1098),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1098),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1098),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1098),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1098),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1098),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1098),
    [anon_sym_LPAREN] = ACTIONS(1096),
    [aux_sym_cast_type_token1] = ACTIONS(1098),
    [aux_sym_echo_statement_token1] = ACTIONS(1098),
    [anon_sym_unset] = ACTIONS(1098),
    [aux_sym_declare_statement_token1] = ACTIONS(1098),
    [aux_sym_declare_statement_token2] = ACTIONS(1098),
    [sym_float] = ACTIONS(1098),
    [aux_sym_try_statement_token1] = ACTIONS(1098),
    [aux_sym_goto_statement_token1] = ACTIONS(1098),
    [aux_sym_continue_statement_token1] = ACTIONS(1098),
    [aux_sym_break_statement_token1] = ACTIONS(1098),
    [sym_integer] = ACTIONS(1098),
    [aux_sym_return_statement_token1] = ACTIONS(1098),
    [aux_sym_throw_expression_token1] = ACTIONS(1098),
    [aux_sym_while_statement_token1] = ACTIONS(1098),
    [aux_sym_while_statement_token2] = ACTIONS(1098),
    [aux_sym_do_statement_token1] = ACTIONS(1098),
    [aux_sym_for_statement_token1] = ACTIONS(1098),
    [aux_sym_for_statement_token2] = ACTIONS(1098),
    [aux_sym_foreach_statement_token1] = ACTIONS(1098),
    [aux_sym_foreach_statement_token2] = ACTIONS(1098),
    [aux_sym_if_statement_token1] = ACTIONS(1098),
    [aux_sym_if_statement_token2] = ACTIONS(1098),
    [aux_sym_else_if_clause_token1] = ACTIONS(1098),
    [aux_sym_else_clause_token1] = ACTIONS(1098),
    [aux_sym_match_expression_token1] = ACTIONS(1098),
    [aux_sym_match_default_expression_token1] = ACTIONS(1098),
    [aux_sym_switch_statement_token1] = ACTIONS(1098),
    [aux_sym_switch_block_token1] = ACTIONS(1098),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1096),
    [anon_sym_BANG] = ACTIONS(1096),
    [anon_sym_AT] = ACTIONS(1096),
    [aux_sym_clone_expression_token1] = ACTIONS(1098),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1098),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1098),
    [anon_sym_DASH_DASH] = ACTIONS(1096),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [aux_sym__list_destructing_token1] = ACTIONS(1098),
    [anon_sym_LBRACK] = ACTIONS(1096),
    [anon_sym_self] = ACTIONS(1098),
    [anon_sym_parent] = ACTIONS(1098),
    [aux_sym__argument_name_token1] = ACTIONS(1098),
    [aux_sym__argument_name_token2] = ACTIONS(1098),
    [anon_sym_POUND_LBRACK] = ACTIONS(1096),
    [anon_sym_SQUOTE] = ACTIONS(1096),
    [aux_sym_encapsed_string_token1] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1096),
    [aux_sym_string_token1] = ACTIONS(1096),
    [anon_sym_LT_LT_LT] = ACTIONS(1096),
    [anon_sym_BQUOTE] = ACTIONS(1096),
    [anon_sym_DOLLAR] = ACTIONS(1096),
    [aux_sym_yield_expression_token1] = ACTIONS(1098),
    [aux_sym_include_expression_token1] = ACTIONS(1098),
    [aux_sym_include_once_expression_token1] = ACTIONS(1098),
    [aux_sym_require_expression_token1] = ACTIONS(1098),
    [aux_sym_require_once_expression_token1] = ACTIONS(1098),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1100),
  },
  [445] = {
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_name] = ACTIONS(1104),
    [anon_sym_QMARK_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1106),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1104),
    [aux_sym_global_declaration_token1] = ACTIONS(1104),
    [aux_sym_namespace_definition_token1] = ACTIONS(1104),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1104),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1104),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1104),
    [anon_sym_BSLASH] = ACTIONS(1102),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_RBRACE] = ACTIONS(1102),
    [aux_sym_trait_declaration_token1] = ACTIONS(1104),
    [aux_sym_interface_declaration_token1] = ACTIONS(1104),
    [aux_sym_enum_declaration_token1] = ACTIONS(1104),
    [aux_sym_enum_case_token1] = ACTIONS(1104),
    [aux_sym_class_declaration_token1] = ACTIONS(1104),
    [aux_sym_final_modifier_token1] = ACTIONS(1104),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1104),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1104),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1104),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1104),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1104),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [aux_sym_cast_type_token1] = ACTIONS(1104),
    [aux_sym_echo_statement_token1] = ACTIONS(1104),
    [anon_sym_unset] = ACTIONS(1104),
    [aux_sym_declare_statement_token1] = ACTIONS(1104),
    [aux_sym_declare_statement_token2] = ACTIONS(1104),
    [sym_float] = ACTIONS(1104),
    [aux_sym_try_statement_token1] = ACTIONS(1104),
    [aux_sym_goto_statement_token1] = ACTIONS(1104),
    [aux_sym_continue_statement_token1] = ACTIONS(1104),
    [aux_sym_break_statement_token1] = ACTIONS(1104),
    [sym_integer] = ACTIONS(1104),
    [aux_sym_return_statement_token1] = ACTIONS(1104),
    [aux_sym_throw_expression_token1] = ACTIONS(1104),
    [aux_sym_while_statement_token1] = ACTIONS(1104),
    [aux_sym_while_statement_token2] = ACTIONS(1104),
    [aux_sym_do_statement_token1] = ACTIONS(1104),
    [aux_sym_for_statement_token1] = ACTIONS(1104),
    [aux_sym_for_statement_token2] = ACTIONS(1104),
    [aux_sym_foreach_statement_token1] = ACTIONS(1104),
    [aux_sym_foreach_statement_token2] = ACTIONS(1104),
    [aux_sym_if_statement_token1] = ACTIONS(1104),
    [aux_sym_if_statement_token2] = ACTIONS(1104),
    [aux_sym_else_if_clause_token1] = ACTIONS(1104),
    [aux_sym_else_clause_token1] = ACTIONS(1104),
    [aux_sym_match_expression_token1] = ACTIONS(1104),
    [aux_sym_match_default_expression_token1] = ACTIONS(1104),
    [aux_sym_switch_statement_token1] = ACTIONS(1104),
    [aux_sym_switch_block_token1] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_AT] = ACTIONS(1102),
    [aux_sym_clone_expression_token1] = ACTIONS(1104),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1104),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1104),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [aux_sym__list_destructing_token1] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_self] = ACTIONS(1104),
    [anon_sym_parent] = ACTIONS(1104),
    [aux_sym__argument_name_token1] = ACTIONS(1104),
    [aux_sym__argument_name_token2] = ACTIONS(1104),
    [anon_sym_POUND_LBRACK] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [aux_sym_encapsed_string_token1] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [aux_sym_string_token1] = ACTIONS(1102),
    [anon_sym_LT_LT_LT] = ACTIONS(1102),
    [anon_sym_BQUOTE] = ACTIONS(1102),
    [anon_sym_DOLLAR] = ACTIONS(1102),
    [aux_sym_yield_expression_token1] = ACTIONS(1104),
    [aux_sym_include_expression_token1] = ACTIONS(1104),
    [aux_sym_include_once_expression_token1] = ACTIONS(1104),
    [aux_sym_require_expression_token1] = ACTIONS(1104),
    [aux_sym_require_once_expression_token1] = ACTIONS(1104),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1106),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(1108),
    [sym_name] = ACTIONS(1110),
    [anon_sym_QMARK_GT] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(1112),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1110),
    [aux_sym_global_declaration_token1] = ACTIONS(1110),
    [aux_sym_namespace_definition_token1] = ACTIONS(1110),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1110),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1110),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1110),
    [anon_sym_BSLASH] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1108),
    [anon_sym_RBRACE] = ACTIONS(1108),
    [aux_sym_trait_declaration_token1] = ACTIONS(1110),
    [aux_sym_interface_declaration_token1] = ACTIONS(1110),
    [aux_sym_enum_declaration_token1] = ACTIONS(1110),
    [aux_sym_enum_case_token1] = ACTIONS(1110),
    [aux_sym_class_declaration_token1] = ACTIONS(1110),
    [aux_sym_final_modifier_token1] = ACTIONS(1110),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1110),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1110),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1110),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1110),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1110),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1110),
    [anon_sym_LPAREN] = ACTIONS(1108),
    [aux_sym_cast_type_token1] = ACTIONS(1110),
    [aux_sym_echo_statement_token1] = ACTIONS(1110),
    [anon_sym_unset] = ACTIONS(1110),
    [aux_sym_declare_statement_token1] = ACTIONS(1110),
    [aux_sym_declare_statement_token2] = ACTIONS(1110),
    [sym_float] = ACTIONS(1110),
    [aux_sym_try_statement_token1] = ACTIONS(1110),
    [aux_sym_goto_statement_token1] = ACTIONS(1110),
    [aux_sym_continue_statement_token1] = ACTIONS(1110),
    [aux_sym_break_statement_token1] = ACTIONS(1110),
    [sym_integer] = ACTIONS(1110),
    [aux_sym_return_statement_token1] = ACTIONS(1110),
    [aux_sym_throw_expression_token1] = ACTIONS(1110),
    [aux_sym_while_statement_token1] = ACTIONS(1110),
    [aux_sym_while_statement_token2] = ACTIONS(1110),
    [aux_sym_do_statement_token1] = ACTIONS(1110),
    [aux_sym_for_statement_token1] = ACTIONS(1110),
    [aux_sym_for_statement_token2] = ACTIONS(1110),
    [aux_sym_foreach_statement_token1] = ACTIONS(1110),
    [aux_sym_foreach_statement_token2] = ACTIONS(1110),
    [aux_sym_if_statement_token1] = ACTIONS(1110),
    [aux_sym_if_statement_token2] = ACTIONS(1110),
    [aux_sym_else_if_clause_token1] = ACTIONS(1110),
    [aux_sym_else_clause_token1] = ACTIONS(1110),
    [aux_sym_match_expression_token1] = ACTIONS(1110),
    [aux_sym_match_default_expression_token1] = ACTIONS(1110),
    [aux_sym_switch_statement_token1] = ACTIONS(1110),
    [aux_sym_switch_block_token1] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1108),
    [anon_sym_BANG] = ACTIONS(1108),
    [anon_sym_AT] = ACTIONS(1108),
    [aux_sym_clone_expression_token1] = ACTIONS(1110),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1110),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1110),
    [anon_sym_DASH_DASH] = ACTIONS(1108),
    [anon_sym_PLUS_PLUS] = ACTIONS(1108),
    [aux_sym__list_destructing_token1] = ACTIONS(1110),
    [anon_sym_LBRACK] = ACTIONS(1108),
    [anon_sym_self] = ACTIONS(1110),
    [anon_sym_parent] = ACTIONS(1110),
    [aux_sym__argument_name_token1] = ACTIONS(1110),
    [aux_sym__argument_name_token2] = ACTIONS(1110),
    [anon_sym_POUND_LBRACK] = ACTIONS(1108),
    [anon_sym_SQUOTE] = ACTIONS(1108),
    [aux_sym_encapsed_string_token1] = ACTIONS(1108),
    [anon_sym_DQUOTE] = ACTIONS(1108),
    [aux_sym_string_token1] = ACTIONS(1108),
    [anon_sym_LT_LT_LT] = ACTIONS(1108),
    [anon_sym_BQUOTE] = ACTIONS(1108),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [aux_sym_yield_expression_token1] = ACTIONS(1110),
    [aux_sym_include_expression_token1] = ACTIONS(1110),
    [aux_sym_include_once_expression_token1] = ACTIONS(1110),
    [aux_sym_require_expression_token1] = ACTIONS(1110),
    [aux_sym_require_once_expression_token1] = ACTIONS(1110),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1112),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(1114),
    [sym_name] = ACTIONS(1116),
    [anon_sym_QMARK_GT] = ACTIONS(1114),
    [anon_sym_SEMI] = ACTIONS(1118),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1116),
    [aux_sym_global_declaration_token1] = ACTIONS(1116),
    [aux_sym_namespace_definition_token1] = ACTIONS(1116),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1116),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1116),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1116),
    [anon_sym_BSLASH] = ACTIONS(1114),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [aux_sym_trait_declaration_token1] = ACTIONS(1116),
    [aux_sym_interface_declaration_token1] = ACTIONS(1116),
    [aux_sym_enum_declaration_token1] = ACTIONS(1116),
    [aux_sym_enum_case_token1] = ACTIONS(1116),
    [aux_sym_class_declaration_token1] = ACTIONS(1116),
    [aux_sym_final_modifier_token1] = ACTIONS(1116),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1116),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1116),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1116),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1116),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1116),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1116),
    [anon_sym_LPAREN] = ACTIONS(1114),
    [aux_sym_cast_type_token1] = ACTIONS(1116),
    [aux_sym_echo_statement_token1] = ACTIONS(1116),
    [anon_sym_unset] = ACTIONS(1116),
    [aux_sym_declare_statement_token1] = ACTIONS(1116),
    [aux_sym_declare_statement_token2] = ACTIONS(1116),
    [sym_float] = ACTIONS(1116),
    [aux_sym_try_statement_token1] = ACTIONS(1116),
    [aux_sym_goto_statement_token1] = ACTIONS(1116),
    [aux_sym_continue_statement_token1] = ACTIONS(1116),
    [aux_sym_break_statement_token1] = ACTIONS(1116),
    [sym_integer] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1116),
    [aux_sym_throw_expression_token1] = ACTIONS(1116),
    [aux_sym_while_statement_token1] = ACTIONS(1116),
    [aux_sym_while_statement_token2] = ACTIONS(1116),
    [aux_sym_do_statement_token1] = ACTIONS(1116),
    [aux_sym_for_statement_token1] = ACTIONS(1116),
    [aux_sym_for_statement_token2] = ACTIONS(1116),
    [aux_sym_foreach_statement_token1] = ACTIONS(1116),
    [aux_sym_foreach_statement_token2] = ACTIONS(1116),
    [aux_sym_if_statement_token1] = ACTIONS(1116),
    [aux_sym_if_statement_token2] = ACTIONS(1116),
    [aux_sym_else_if_clause_token1] = ACTIONS(1116),
    [aux_sym_else_clause_token1] = ACTIONS(1116),
    [aux_sym_match_expression_token1] = ACTIONS(1116),
    [aux_sym_match_default_expression_token1] = ACTIONS(1116),
    [aux_sym_switch_statement_token1] = ACTIONS(1116),
    [aux_sym_switch_block_token1] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_AT] = ACTIONS(1114),
    [aux_sym_clone_expression_token1] = ACTIONS(1116),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1116),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1116),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [aux_sym__list_destructing_token1] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1114),
    [anon_sym_self] = ACTIONS(1116),
    [anon_sym_parent] = ACTIONS(1116),
    [aux_sym__argument_name_token1] = ACTIONS(1116),
    [aux_sym__argument_name_token2] = ACTIONS(1116),
    [anon_sym_POUND_LBRACK] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [aux_sym_encapsed_string_token1] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1114),
    [aux_sym_string_token1] = ACTIONS(1114),
    [anon_sym_LT_LT_LT] = ACTIONS(1114),
    [anon_sym_BQUOTE] = ACTIONS(1114),
    [anon_sym_DOLLAR] = ACTIONS(1114),
    [aux_sym_yield_expression_token1] = ACTIONS(1116),
    [aux_sym_include_expression_token1] = ACTIONS(1116),
    [aux_sym_include_once_expression_token1] = ACTIONS(1116),
    [aux_sym_require_expression_token1] = ACTIONS(1116),
    [aux_sym_require_once_expression_token1] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1118),
  },
  [448] = {
    [ts_builtin_sym_end] = ACTIONS(1120),
    [sym_name] = ACTIONS(1122),
    [anon_sym_QMARK_GT] = ACTIONS(1120),
    [anon_sym_SEMI] = ACTIONS(1124),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1122),
    [aux_sym_global_declaration_token1] = ACTIONS(1122),
    [aux_sym_namespace_definition_token1] = ACTIONS(1122),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1122),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1122),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1122),
    [anon_sym_BSLASH] = ACTIONS(1120),
    [anon_sym_LBRACE] = ACTIONS(1120),
    [anon_sym_RBRACE] = ACTIONS(1120),
    [aux_sym_trait_declaration_token1] = ACTIONS(1122),
    [aux_sym_interface_declaration_token1] = ACTIONS(1122),
    [aux_sym_enum_declaration_token1] = ACTIONS(1122),
    [aux_sym_enum_case_token1] = ACTIONS(1122),
    [aux_sym_class_declaration_token1] = ACTIONS(1122),
    [aux_sym_final_modifier_token1] = ACTIONS(1122),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1122),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1122),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1122),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1122),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1122),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1122),
    [anon_sym_LPAREN] = ACTIONS(1120),
    [aux_sym_cast_type_token1] = ACTIONS(1122),
    [aux_sym_echo_statement_token1] = ACTIONS(1122),
    [anon_sym_unset] = ACTIONS(1122),
    [aux_sym_declare_statement_token1] = ACTIONS(1122),
    [aux_sym_declare_statement_token2] = ACTIONS(1122),
    [sym_float] = ACTIONS(1122),
    [aux_sym_try_statement_token1] = ACTIONS(1122),
    [aux_sym_goto_statement_token1] = ACTIONS(1122),
    [aux_sym_continue_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1122),
    [sym_integer] = ACTIONS(1122),
    [aux_sym_return_statement_token1] = ACTIONS(1122),
    [aux_sym_throw_expression_token1] = ACTIONS(1122),
    [aux_sym_while_statement_token1] = ACTIONS(1122),
    [aux_sym_while_statement_token2] = ACTIONS(1122),
    [aux_sym_do_statement_token1] = ACTIONS(1122),
    [aux_sym_for_statement_token1] = ACTIONS(1122),
    [aux_sym_for_statement_token2] = ACTIONS(1122),
    [aux_sym_foreach_statement_token1] = ACTIONS(1122),
    [aux_sym_foreach_statement_token2] = ACTIONS(1122),
    [aux_sym_if_statement_token1] = ACTIONS(1122),
    [aux_sym_if_statement_token2] = ACTIONS(1122),
    [aux_sym_else_if_clause_token1] = ACTIONS(1122),
    [aux_sym_else_clause_token1] = ACTIONS(1122),
    [aux_sym_match_expression_token1] = ACTIONS(1122),
    [aux_sym_match_default_expression_token1] = ACTIONS(1122),
    [aux_sym_switch_statement_token1] = ACTIONS(1122),
    [aux_sym_switch_block_token1] = ACTIONS(1122),
    [anon_sym_PLUS] = ACTIONS(1122),
    [anon_sym_DASH] = ACTIONS(1122),
    [anon_sym_TILDE] = ACTIONS(1120),
    [anon_sym_BANG] = ACTIONS(1120),
    [anon_sym_AT] = ACTIONS(1120),
    [aux_sym_clone_expression_token1] = ACTIONS(1122),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1122),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1122),
    [anon_sym_DASH_DASH] = ACTIONS(1120),
    [anon_sym_PLUS_PLUS] = ACTIONS(1120),
    [aux_sym__list_destructing_token1] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1120),
    [anon_sym_self] = ACTIONS(1122),
    [anon_sym_parent] = ACTIONS(1122),
    [aux_sym__argument_name_token1] = ACTIONS(1122),
    [aux_sym__argument_name_token2] = ACTIONS(1122),
    [anon_sym_POUND_LBRACK] = ACTIONS(1120),
    [anon_sym_SQUOTE] = ACTIONS(1120),
    [aux_sym_encapsed_string_token1] = ACTIONS(1120),
    [anon_sym_DQUOTE] = ACTIONS(1120),
    [aux_sym_string_token1] = ACTIONS(1120),
    [anon_sym_LT_LT_LT] = ACTIONS(1120),
    [anon_sym_BQUOTE] = ACTIONS(1120),
    [anon_sym_DOLLAR] = ACTIONS(1120),
    [aux_sym_yield_expression_token1] = ACTIONS(1122),
    [aux_sym_include_expression_token1] = ACTIONS(1122),
    [aux_sym_include_once_expression_token1] = ACTIONS(1122),
    [aux_sym_require_expression_token1] = ACTIONS(1122),
    [aux_sym_require_once_expression_token1] = ACTIONS(1122),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1124),
  },
  [449] = {
    [ts_builtin_sym_end] = ACTIONS(1126),
    [sym_name] = ACTIONS(1128),
    [anon_sym_QMARK_GT] = ACTIONS(1126),
    [anon_sym_SEMI] = ACTIONS(1126),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1128),
    [aux_sym_global_declaration_token1] = ACTIONS(1128),
    [aux_sym_namespace_definition_token1] = ACTIONS(1128),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1128),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1128),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1128),
    [anon_sym_BSLASH] = ACTIONS(1126),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_RBRACE] = ACTIONS(1126),
    [aux_sym_trait_declaration_token1] = ACTIONS(1128),
    [aux_sym_interface_declaration_token1] = ACTIONS(1128),
    [aux_sym_enum_declaration_token1] = ACTIONS(1128),
    [aux_sym_enum_case_token1] = ACTIONS(1128),
    [aux_sym_class_declaration_token1] = ACTIONS(1128),
    [aux_sym_final_modifier_token1] = ACTIONS(1128),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1128),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1128),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1128),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1128),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1128),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1128),
    [anon_sym_LPAREN] = ACTIONS(1126),
    [aux_sym_cast_type_token1] = ACTIONS(1128),
    [aux_sym_echo_statement_token1] = ACTIONS(1128),
    [anon_sym_unset] = ACTIONS(1128),
    [aux_sym_declare_statement_token1] = ACTIONS(1128),
    [aux_sym_declare_statement_token2] = ACTIONS(1128),
    [sym_float] = ACTIONS(1128),
    [aux_sym_try_statement_token1] = ACTIONS(1128),
    [aux_sym_goto_statement_token1] = ACTIONS(1128),
    [aux_sym_continue_statement_token1] = ACTIONS(1128),
    [aux_sym_break_statement_token1] = ACTIONS(1128),
    [sym_integer] = ACTIONS(1128),
    [aux_sym_return_statement_token1] = ACTIONS(1128),
    [aux_sym_throw_expression_token1] = ACTIONS(1128),
    [aux_sym_while_statement_token1] = ACTIONS(1128),
    [aux_sym_while_statement_token2] = ACTIONS(1128),
    [aux_sym_do_statement_token1] = ACTIONS(1128),
    [aux_sym_for_statement_token1] = ACTIONS(1128),
    [aux_sym_for_statement_token2] = ACTIONS(1128),
    [aux_sym_foreach_statement_token1] = ACTIONS(1128),
    [aux_sym_foreach_statement_token2] = ACTIONS(1128),
    [aux_sym_if_statement_token1] = ACTIONS(1128),
    [aux_sym_if_statement_token2] = ACTIONS(1128),
    [aux_sym_else_if_clause_token1] = ACTIONS(1128),
    [aux_sym_else_clause_token1] = ACTIONS(1128),
    [aux_sym_match_expression_token1] = ACTIONS(1128),
    [aux_sym_match_default_expression_token1] = ACTIONS(1128),
    [aux_sym_switch_statement_token1] = ACTIONS(1128),
    [aux_sym_switch_block_token1] = ACTIONS(1128),
    [anon_sym_PLUS] = ACTIONS(1128),
    [anon_sym_DASH] = ACTIONS(1128),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_BANG] = ACTIONS(1126),
    [anon_sym_AT] = ACTIONS(1126),
    [aux_sym_clone_expression_token1] = ACTIONS(1128),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1128),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1128),
    [anon_sym_DASH_DASH] = ACTIONS(1126),
    [anon_sym_PLUS_PLUS] = ACTIONS(1126),
    [aux_sym__list_destructing_token1] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(1126),
    [anon_sym_self] = ACTIONS(1128),
    [anon_sym_parent] = ACTIONS(1128),
    [aux_sym__argument_name_token1] = ACTIONS(1128),
    [aux_sym__argument_name_token2] = ACTIONS(1128),
    [anon_sym_POUND_LBRACK] = ACTIONS(1126),
    [anon_sym_SQUOTE] = ACTIONS(1126),
    [aux_sym_encapsed_string_token1] = ACTIONS(1126),
    [anon_sym_DQUOTE] = ACTIONS(1126),
    [aux_sym_string_token1] = ACTIONS(1126),
    [anon_sym_LT_LT_LT] = ACTIONS(1126),
    [anon_sym_BQUOTE] = ACTIONS(1126),
    [anon_sym_DOLLAR] = ACTIONS(1126),
    [aux_sym_yield_expression_token1] = ACTIONS(1128),
    [aux_sym_include_expression_token1] = ACTIONS(1128),
    [aux_sym_include_once_expression_token1] = ACTIONS(1128),
    [aux_sym_require_expression_token1] = ACTIONS(1128),
    [aux_sym_require_once_expression_token1] = ACTIONS(1128),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1126),
  },
  [450] = {
    [ts_builtin_sym_end] = ACTIONS(1130),
    [sym_name] = ACTIONS(1132),
    [anon_sym_QMARK_GT] = ACTIONS(1130),
    [anon_sym_SEMI] = ACTIONS(1134),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1132),
    [aux_sym_global_declaration_token1] = ACTIONS(1132),
    [aux_sym_namespace_definition_token1] = ACTIONS(1132),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1132),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1132),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1132),
    [anon_sym_BSLASH] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(1130),
    [anon_sym_RBRACE] = ACTIONS(1130),
    [aux_sym_trait_declaration_token1] = ACTIONS(1132),
    [aux_sym_interface_declaration_token1] = ACTIONS(1132),
    [aux_sym_enum_declaration_token1] = ACTIONS(1132),
    [aux_sym_enum_case_token1] = ACTIONS(1132),
    [aux_sym_class_declaration_token1] = ACTIONS(1132),
    [aux_sym_final_modifier_token1] = ACTIONS(1132),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1132),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1132),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1132),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1132),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1132),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1132),
    [anon_sym_LPAREN] = ACTIONS(1130),
    [aux_sym_cast_type_token1] = ACTIONS(1132),
    [aux_sym_echo_statement_token1] = ACTIONS(1132),
    [anon_sym_unset] = ACTIONS(1132),
    [aux_sym_declare_statement_token1] = ACTIONS(1132),
    [aux_sym_declare_statement_token2] = ACTIONS(1132),
    [sym_float] = ACTIONS(1132),
    [aux_sym_try_statement_token1] = ACTIONS(1132),
    [aux_sym_goto_statement_token1] = ACTIONS(1132),
    [aux_sym_continue_statement_token1] = ACTIONS(1132),
    [aux_sym_break_statement_token1] = ACTIONS(1132),
    [sym_integer] = ACTIONS(1132),
    [aux_sym_return_statement_token1] = ACTIONS(1132),
    [aux_sym_throw_expression_token1] = ACTIONS(1132),
    [aux_sym_while_statement_token1] = ACTIONS(1132),
    [aux_sym_while_statement_token2] = ACTIONS(1132),
    [aux_sym_do_statement_token1] = ACTIONS(1132),
    [aux_sym_for_statement_token1] = ACTIONS(1132),
    [aux_sym_for_statement_token2] = ACTIONS(1132),
    [aux_sym_foreach_statement_token1] = ACTIONS(1132),
    [aux_sym_foreach_statement_token2] = ACTIONS(1132),
    [aux_sym_if_statement_token1] = ACTIONS(1132),
    [aux_sym_if_statement_token2] = ACTIONS(1132),
    [aux_sym_else_if_clause_token1] = ACTIONS(1132),
    [aux_sym_else_clause_token1] = ACTIONS(1132),
    [aux_sym_match_expression_token1] = ACTIONS(1132),
    [aux_sym_match_default_expression_token1] = ACTIONS(1132),
    [aux_sym_switch_statement_token1] = ACTIONS(1132),
    [aux_sym_switch_block_token1] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1130),
    [anon_sym_BANG] = ACTIONS(1130),
    [anon_sym_AT] = ACTIONS(1130),
    [aux_sym_clone_expression_token1] = ACTIONS(1132),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1132),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1132),
    [anon_sym_DASH_DASH] = ACTIONS(1130),
    [anon_sym_PLUS_PLUS] = ACTIONS(1130),
    [aux_sym__list_destructing_token1] = ACTIONS(1132),
    [anon_sym_LBRACK] = ACTIONS(1130),
    [anon_sym_self] = ACTIONS(1132),
    [anon_sym_parent] = ACTIONS(1132),
    [aux_sym__argument_name_token1] = ACTIONS(1132),
    [aux_sym__argument_name_token2] = ACTIONS(1132),
    [anon_sym_POUND_LBRACK] = ACTIONS(1130),
    [anon_sym_SQUOTE] = ACTIONS(1130),
    [aux_sym_encapsed_string_token1] = ACTIONS(1130),
    [anon_sym_DQUOTE] = ACTIONS(1130),
    [aux_sym_string_token1] = ACTIONS(1130),
    [anon_sym_LT_LT_LT] = ACTIONS(1130),
    [anon_sym_BQUOTE] = ACTIONS(1130),
    [anon_sym_DOLLAR] = ACTIONS(1130),
    [aux_sym_yield_expression_token1] = ACTIONS(1132),
    [aux_sym_include_expression_token1] = ACTIONS(1132),
    [aux_sym_include_once_expression_token1] = ACTIONS(1132),
    [aux_sym_require_expression_token1] = ACTIONS(1132),
    [aux_sym_require_once_expression_token1] = ACTIONS(1132),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1134),
  },
  [451] = {
    [ts_builtin_sym_end] = ACTIONS(1136),
    [sym_name] = ACTIONS(1138),
    [anon_sym_QMARK_GT] = ACTIONS(1136),
    [anon_sym_SEMI] = ACTIONS(1140),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1138),
    [aux_sym_global_declaration_token1] = ACTIONS(1138),
    [aux_sym_namespace_definition_token1] = ACTIONS(1138),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1138),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1138),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1138),
    [anon_sym_BSLASH] = ACTIONS(1136),
    [anon_sym_LBRACE] = ACTIONS(1136),
    [anon_sym_RBRACE] = ACTIONS(1136),
    [aux_sym_trait_declaration_token1] = ACTIONS(1138),
    [aux_sym_interface_declaration_token1] = ACTIONS(1138),
    [aux_sym_enum_declaration_token1] = ACTIONS(1138),
    [aux_sym_enum_case_token1] = ACTIONS(1138),
    [aux_sym_class_declaration_token1] = ACTIONS(1138),
    [aux_sym_final_modifier_token1] = ACTIONS(1138),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1138),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1138),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1138),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1138),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1138),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1138),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [aux_sym_cast_type_token1] = ACTIONS(1138),
    [aux_sym_echo_statement_token1] = ACTIONS(1138),
    [anon_sym_unset] = ACTIONS(1138),
    [aux_sym_declare_statement_token1] = ACTIONS(1138),
    [aux_sym_declare_statement_token2] = ACTIONS(1138),
    [sym_float] = ACTIONS(1138),
    [aux_sym_try_statement_token1] = ACTIONS(1138),
    [aux_sym_goto_statement_token1] = ACTIONS(1138),
    [aux_sym_continue_statement_token1] = ACTIONS(1138),
    [aux_sym_break_statement_token1] = ACTIONS(1138),
    [sym_integer] = ACTIONS(1138),
    [aux_sym_return_statement_token1] = ACTIONS(1138),
    [aux_sym_throw_expression_token1] = ACTIONS(1138),
    [aux_sym_while_statement_token1] = ACTIONS(1138),
    [aux_sym_while_statement_token2] = ACTIONS(1138),
    [aux_sym_do_statement_token1] = ACTIONS(1138),
    [aux_sym_for_statement_token1] = ACTIONS(1138),
    [aux_sym_for_statement_token2] = ACTIONS(1138),
    [aux_sym_foreach_statement_token1] = ACTIONS(1138),
    [aux_sym_foreach_statement_token2] = ACTIONS(1138),
    [aux_sym_if_statement_token1] = ACTIONS(1138),
    [aux_sym_if_statement_token2] = ACTIONS(1138),
    [aux_sym_else_if_clause_token1] = ACTIONS(1138),
    [aux_sym_else_clause_token1] = ACTIONS(1138),
    [aux_sym_match_expression_token1] = ACTIONS(1138),
    [aux_sym_match_default_expression_token1] = ACTIONS(1138),
    [aux_sym_switch_statement_token1] = ACTIONS(1138),
    [aux_sym_switch_block_token1] = ACTIONS(1138),
    [anon_sym_PLUS] = ACTIONS(1138),
    [anon_sym_DASH] = ACTIONS(1138),
    [anon_sym_TILDE] = ACTIONS(1136),
    [anon_sym_BANG] = ACTIONS(1136),
    [anon_sym_AT] = ACTIONS(1136),
    [aux_sym_clone_expression_token1] = ACTIONS(1138),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1138),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1138),
    [anon_sym_DASH_DASH] = ACTIONS(1136),
    [anon_sym_PLUS_PLUS] = ACTIONS(1136),
    [aux_sym__list_destructing_token1] = ACTIONS(1138),
    [anon_sym_LBRACK] = ACTIONS(1136),
    [anon_sym_self] = ACTIONS(1138),
    [anon_sym_parent] = ACTIONS(1138),
    [aux_sym__argument_name_token1] = ACTIONS(1138),
    [aux_sym__argument_name_token2] = ACTIONS(1138),
    [anon_sym_POUND_LBRACK] = ACTIONS(1136),
    [anon_sym_SQUOTE] = ACTIONS(1136),
    [aux_sym_encapsed_string_token1] = ACTIONS(1136),
    [anon_sym_DQUOTE] = ACTIONS(1136),
    [aux_sym_string_token1] = ACTIONS(1136),
    [anon_sym_LT_LT_LT] = ACTIONS(1136),
    [anon_sym_BQUOTE] = ACTIONS(1136),
    [anon_sym_DOLLAR] = ACTIONS(1136),
    [aux_sym_yield_expression_token1] = ACTIONS(1138),
    [aux_sym_include_expression_token1] = ACTIONS(1138),
    [aux_sym_include_once_expression_token1] = ACTIONS(1138),
    [aux_sym_require_expression_token1] = ACTIONS(1138),
    [aux_sym_require_once_expression_token1] = ACTIONS(1138),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1140),
  },
  [452] = {
    [ts_builtin_sym_end] = ACTIONS(1142),
    [sym_name] = ACTIONS(1144),
    [anon_sym_QMARK_GT] = ACTIONS(1142),
    [anon_sym_SEMI] = ACTIONS(1146),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1144),
    [aux_sym_global_declaration_token1] = ACTIONS(1144),
    [aux_sym_namespace_definition_token1] = ACTIONS(1144),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1144),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1144),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1144),
    [anon_sym_BSLASH] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1142),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [aux_sym_trait_declaration_token1] = ACTIONS(1144),
    [aux_sym_interface_declaration_token1] = ACTIONS(1144),
    [aux_sym_enum_declaration_token1] = ACTIONS(1144),
    [aux_sym_enum_case_token1] = ACTIONS(1144),
    [aux_sym_class_declaration_token1] = ACTIONS(1144),
    [aux_sym_final_modifier_token1] = ACTIONS(1144),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1144),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1144),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1144),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1144),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1144),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1144),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [aux_sym_cast_type_token1] = ACTIONS(1144),
    [aux_sym_echo_statement_token1] = ACTIONS(1144),
    [anon_sym_unset] = ACTIONS(1144),
    [aux_sym_declare_statement_token1] = ACTIONS(1144),
    [aux_sym_declare_statement_token2] = ACTIONS(1144),
    [sym_float] = ACTIONS(1144),
    [aux_sym_try_statement_token1] = ACTIONS(1144),
    [aux_sym_goto_statement_token1] = ACTIONS(1144),
    [aux_sym_continue_statement_token1] = ACTIONS(1144),
    [aux_sym_break_statement_token1] = ACTIONS(1144),
    [sym_integer] = ACTIONS(1144),
    [aux_sym_return_statement_token1] = ACTIONS(1144),
    [aux_sym_throw_expression_token1] = ACTIONS(1144),
    [aux_sym_while_statement_token1] = ACTIONS(1144),
    [aux_sym_while_statement_token2] = ACTIONS(1144),
    [aux_sym_do_statement_token1] = ACTIONS(1144),
    [aux_sym_for_statement_token1] = ACTIONS(1144),
    [aux_sym_for_statement_token2] = ACTIONS(1144),
    [aux_sym_foreach_statement_token1] = ACTIONS(1144),
    [aux_sym_foreach_statement_token2] = ACTIONS(1144),
    [aux_sym_if_statement_token1] = ACTIONS(1144),
    [aux_sym_if_statement_token2] = ACTIONS(1144),
    [aux_sym_else_if_clause_token1] = ACTIONS(1144),
    [aux_sym_else_clause_token1] = ACTIONS(1144),
    [aux_sym_match_expression_token1] = ACTIONS(1144),
    [aux_sym_match_default_expression_token1] = ACTIONS(1144),
    [aux_sym_switch_statement_token1] = ACTIONS(1144),
    [aux_sym_switch_block_token1] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1144),
    [anon_sym_DASH] = ACTIONS(1144),
    [anon_sym_TILDE] = ACTIONS(1142),
    [anon_sym_BANG] = ACTIONS(1142),
    [anon_sym_AT] = ACTIONS(1142),
    [aux_sym_clone_expression_token1] = ACTIONS(1144),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1144),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1144),
    [anon_sym_DASH_DASH] = ACTIONS(1142),
    [anon_sym_PLUS_PLUS] = ACTIONS(1142),
    [aux_sym__list_destructing_token1] = ACTIONS(1144),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_self] = ACTIONS(1144),
    [anon_sym_parent] = ACTIONS(1144),
    [aux_sym__argument_name_token1] = ACTIONS(1144),
    [aux_sym__argument_name_token2] = ACTIONS(1144),
    [anon_sym_POUND_LBRACK] = ACTIONS(1142),
    [anon_sym_SQUOTE] = ACTIONS(1142),
    [aux_sym_encapsed_string_token1] = ACTIONS(1142),
    [anon_sym_DQUOTE] = ACTIONS(1142),
    [aux_sym_string_token1] = ACTIONS(1142),
    [anon_sym_LT_LT_LT] = ACTIONS(1142),
    [anon_sym_BQUOTE] = ACTIONS(1142),
    [anon_sym_DOLLAR] = ACTIONS(1142),
    [aux_sym_yield_expression_token1] = ACTIONS(1144),
    [aux_sym_include_expression_token1] = ACTIONS(1144),
    [aux_sym_include_once_expression_token1] = ACTIONS(1144),
    [aux_sym_require_expression_token1] = ACTIONS(1144),
    [aux_sym_require_once_expression_token1] = ACTIONS(1144),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1146),
  },
  [453] = {
    [ts_builtin_sym_end] = ACTIONS(1148),
    [sym_name] = ACTIONS(1150),
    [anon_sym_QMARK_GT] = ACTIONS(1148),
    [anon_sym_SEMI] = ACTIONS(1152),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1150),
    [aux_sym_global_declaration_token1] = ACTIONS(1150),
    [aux_sym_namespace_definition_token1] = ACTIONS(1150),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1150),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1150),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1150),
    [anon_sym_BSLASH] = ACTIONS(1148),
    [anon_sym_LBRACE] = ACTIONS(1148),
    [anon_sym_RBRACE] = ACTIONS(1148),
    [aux_sym_trait_declaration_token1] = ACTIONS(1150),
    [aux_sym_interface_declaration_token1] = ACTIONS(1150),
    [aux_sym_enum_declaration_token1] = ACTIONS(1150),
    [aux_sym_enum_case_token1] = ACTIONS(1150),
    [aux_sym_class_declaration_token1] = ACTIONS(1150),
    [aux_sym_final_modifier_token1] = ACTIONS(1150),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1150),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1150),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1150),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1150),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1150),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1150),
    [anon_sym_LPAREN] = ACTIONS(1148),
    [aux_sym_cast_type_token1] = ACTIONS(1150),
    [aux_sym_echo_statement_token1] = ACTIONS(1150),
    [anon_sym_unset] = ACTIONS(1150),
    [aux_sym_declare_statement_token1] = ACTIONS(1150),
    [aux_sym_declare_statement_token2] = ACTIONS(1150),
    [sym_float] = ACTIONS(1150),
    [aux_sym_try_statement_token1] = ACTIONS(1150),
    [aux_sym_goto_statement_token1] = ACTIONS(1150),
    [aux_sym_continue_statement_token1] = ACTIONS(1150),
    [aux_sym_break_statement_token1] = ACTIONS(1150),
    [sym_integer] = ACTIONS(1150),
    [aux_sym_return_statement_token1] = ACTIONS(1150),
    [aux_sym_throw_expression_token1] = ACTIONS(1150),
    [aux_sym_while_statement_token1] = ACTIONS(1150),
    [aux_sym_while_statement_token2] = ACTIONS(1150),
    [aux_sym_do_statement_token1] = ACTIONS(1150),
    [aux_sym_for_statement_token1] = ACTIONS(1150),
    [aux_sym_for_statement_token2] = ACTIONS(1150),
    [aux_sym_foreach_statement_token1] = ACTIONS(1150),
    [aux_sym_foreach_statement_token2] = ACTIONS(1150),
    [aux_sym_if_statement_token1] = ACTIONS(1150),
    [aux_sym_if_statement_token2] = ACTIONS(1150),
    [aux_sym_else_if_clause_token1] = ACTIONS(1150),
    [aux_sym_else_clause_token1] = ACTIONS(1150),
    [aux_sym_match_expression_token1] = ACTIONS(1150),
    [aux_sym_match_default_expression_token1] = ACTIONS(1150),
    [aux_sym_switch_statement_token1] = ACTIONS(1150),
    [aux_sym_switch_block_token1] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_TILDE] = ACTIONS(1148),
    [anon_sym_BANG] = ACTIONS(1148),
    [anon_sym_AT] = ACTIONS(1148),
    [aux_sym_clone_expression_token1] = ACTIONS(1150),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1150),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1150),
    [anon_sym_DASH_DASH] = ACTIONS(1148),
    [anon_sym_PLUS_PLUS] = ACTIONS(1148),
    [aux_sym__list_destructing_token1] = ACTIONS(1150),
    [anon_sym_LBRACK] = ACTIONS(1148),
    [anon_sym_self] = ACTIONS(1150),
    [anon_sym_parent] = ACTIONS(1150),
    [aux_sym__argument_name_token1] = ACTIONS(1150),
    [aux_sym__argument_name_token2] = ACTIONS(1150),
    [anon_sym_POUND_LBRACK] = ACTIONS(1148),
    [anon_sym_SQUOTE] = ACTIONS(1148),
    [aux_sym_encapsed_string_token1] = ACTIONS(1148),
    [anon_sym_DQUOTE] = ACTIONS(1148),
    [aux_sym_string_token1] = ACTIONS(1148),
    [anon_sym_LT_LT_LT] = ACTIONS(1148),
    [anon_sym_BQUOTE] = ACTIONS(1148),
    [anon_sym_DOLLAR] = ACTIONS(1148),
    [aux_sym_yield_expression_token1] = ACTIONS(1150),
    [aux_sym_include_expression_token1] = ACTIONS(1150),
    [aux_sym_include_once_expression_token1] = ACTIONS(1150),
    [aux_sym_require_expression_token1] = ACTIONS(1150),
    [aux_sym_require_once_expression_token1] = ACTIONS(1150),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1152),
  },
  [454] = {
    [ts_builtin_sym_end] = ACTIONS(1026),
    [sym_name] = ACTIONS(1028),
    [anon_sym_QMARK_GT] = ACTIONS(1026),
    [anon_sym_SEMI] = ACTIONS(1026),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1028),
    [aux_sym_global_declaration_token1] = ACTIONS(1028),
    [aux_sym_namespace_definition_token1] = ACTIONS(1028),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1028),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1028),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1028),
    [anon_sym_BSLASH] = ACTIONS(1026),
    [anon_sym_LBRACE] = ACTIONS(1026),
    [anon_sym_RBRACE] = ACTIONS(1026),
    [aux_sym_trait_declaration_token1] = ACTIONS(1028),
    [aux_sym_interface_declaration_token1] = ACTIONS(1028),
    [aux_sym_enum_declaration_token1] = ACTIONS(1028),
    [aux_sym_enum_case_token1] = ACTIONS(1028),
    [aux_sym_class_declaration_token1] = ACTIONS(1028),
    [aux_sym_final_modifier_token1] = ACTIONS(1028),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1028),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1028),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1028),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1028),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1028),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1028),
    [anon_sym_LPAREN] = ACTIONS(1026),
    [aux_sym_cast_type_token1] = ACTIONS(1028),
    [aux_sym_echo_statement_token1] = ACTIONS(1028),
    [anon_sym_unset] = ACTIONS(1028),
    [aux_sym_declare_statement_token1] = ACTIONS(1028),
    [aux_sym_declare_statement_token2] = ACTIONS(1028),
    [sym_float] = ACTIONS(1028),
    [aux_sym_try_statement_token1] = ACTIONS(1028),
    [aux_sym_goto_statement_token1] = ACTIONS(1028),
    [aux_sym_continue_statement_token1] = ACTIONS(1028),
    [aux_sym_break_statement_token1] = ACTIONS(1028),
    [sym_integer] = ACTIONS(1028),
    [aux_sym_return_statement_token1] = ACTIONS(1028),
    [aux_sym_throw_expression_token1] = ACTIONS(1028),
    [aux_sym_while_statement_token1] = ACTIONS(1028),
    [aux_sym_while_statement_token2] = ACTIONS(1028),
    [aux_sym_do_statement_token1] = ACTIONS(1028),
    [aux_sym_for_statement_token1] = ACTIONS(1028),
    [aux_sym_for_statement_token2] = ACTIONS(1028),
    [aux_sym_foreach_statement_token1] = ACTIONS(1028),
    [aux_sym_foreach_statement_token2] = ACTIONS(1028),
    [aux_sym_if_statement_token1] = ACTIONS(1028),
    [aux_sym_if_statement_token2] = ACTIONS(1028),
    [aux_sym_else_if_clause_token1] = ACTIONS(1028),
    [aux_sym_else_clause_token1] = ACTIONS(1028),
    [aux_sym_match_expression_token1] = ACTIONS(1028),
    [aux_sym_match_default_expression_token1] = ACTIONS(1028),
    [aux_sym_switch_statement_token1] = ACTIONS(1028),
    [aux_sym_switch_block_token1] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1028),
    [anon_sym_DASH] = ACTIONS(1028),
    [anon_sym_TILDE] = ACTIONS(1026),
    [anon_sym_BANG] = ACTIONS(1026),
    [anon_sym_AT] = ACTIONS(1026),
    [aux_sym_clone_expression_token1] = ACTIONS(1028),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1028),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1028),
    [anon_sym_DASH_DASH] = ACTIONS(1026),
    [anon_sym_PLUS_PLUS] = ACTIONS(1026),
    [aux_sym__list_destructing_token1] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1026),
    [anon_sym_self] = ACTIONS(1028),
    [anon_sym_parent] = ACTIONS(1028),
    [aux_sym__argument_name_token1] = ACTIONS(1028),
    [aux_sym__argument_name_token2] = ACTIONS(1028),
    [anon_sym_POUND_LBRACK] = ACTIONS(1026),
    [anon_sym_SQUOTE] = ACTIONS(1026),
    [aux_sym_encapsed_string_token1] = ACTIONS(1026),
    [anon_sym_DQUOTE] = ACTIONS(1026),
    [aux_sym_string_token1] = ACTIONS(1026),
    [anon_sym_LT_LT_LT] = ACTIONS(1026),
    [anon_sym_BQUOTE] = ACTIONS(1026),
    [anon_sym_DOLLAR] = ACTIONS(1026),
    [aux_sym_yield_expression_token1] = ACTIONS(1028),
    [aux_sym_include_expression_token1] = ACTIONS(1028),
    [aux_sym_include_once_expression_token1] = ACTIONS(1028),
    [aux_sym_require_expression_token1] = ACTIONS(1028),
    [aux_sym_require_once_expression_token1] = ACTIONS(1028),
    [sym_comment] = ACTIONS(3),
  },
  [455] = {
    [ts_builtin_sym_end] = ACTIONS(1154),
    [sym_name] = ACTIONS(1156),
    [anon_sym_QMARK_GT] = ACTIONS(1154),
    [anon_sym_SEMI] = ACTIONS(1154),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1156),
    [aux_sym_global_declaration_token1] = ACTIONS(1156),
    [aux_sym_namespace_definition_token1] = ACTIONS(1156),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1156),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1156),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1156),
    [anon_sym_BSLASH] = ACTIONS(1154),
    [anon_sym_LBRACE] = ACTIONS(1154),
    [anon_sym_RBRACE] = ACTIONS(1154),
    [aux_sym_trait_declaration_token1] = ACTIONS(1156),
    [aux_sym_interface_declaration_token1] = ACTIONS(1156),
    [aux_sym_enum_declaration_token1] = ACTIONS(1156),
    [aux_sym_enum_case_token1] = ACTIONS(1156),
    [aux_sym_class_declaration_token1] = ACTIONS(1156),
    [aux_sym_final_modifier_token1] = ACTIONS(1156),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1156),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1156),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1156),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1156),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1156),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1156),
    [anon_sym_LPAREN] = ACTIONS(1154),
    [aux_sym_cast_type_token1] = ACTIONS(1156),
    [aux_sym_echo_statement_token1] = ACTIONS(1156),
    [anon_sym_unset] = ACTIONS(1156),
    [aux_sym_declare_statement_token1] = ACTIONS(1156),
    [aux_sym_declare_statement_token2] = ACTIONS(1156),
    [sym_float] = ACTIONS(1156),
    [aux_sym_try_statement_token1] = ACTIONS(1156),
    [aux_sym_goto_statement_token1] = ACTIONS(1156),
    [aux_sym_continue_statement_token1] = ACTIONS(1156),
    [aux_sym_break_statement_token1] = ACTIONS(1156),
    [sym_integer] = ACTIONS(1156),
    [aux_sym_return_statement_token1] = ACTIONS(1156),
    [aux_sym_throw_expression_token1] = ACTIONS(1156),
    [aux_sym_while_statement_token1] = ACTIONS(1156),
    [aux_sym_while_statement_token2] = ACTIONS(1156),
    [aux_sym_do_statement_token1] = ACTIONS(1156),
    [aux_sym_for_statement_token1] = ACTIONS(1156),
    [aux_sym_for_statement_token2] = ACTIONS(1156),
    [aux_sym_foreach_statement_token1] = ACTIONS(1156),
    [aux_sym_foreach_statement_token2] = ACTIONS(1156),
    [aux_sym_if_statement_token1] = ACTIONS(1156),
    [aux_sym_if_statement_token2] = ACTIONS(1156),
    [aux_sym_else_if_clause_token1] = ACTIONS(1156),
    [aux_sym_else_clause_token1] = ACTIONS(1156),
    [aux_sym_match_expression_token1] = ACTIONS(1156),
    [aux_sym_match_default_expression_token1] = ACTIONS(1156),
    [aux_sym_switch_statement_token1] = ACTIONS(1156),
    [aux_sym_switch_block_token1] = ACTIONS(1156),
    [anon_sym_PLUS] = ACTIONS(1156),
    [anon_sym_DASH] = ACTIONS(1156),
    [anon_sym_TILDE] = ACTIONS(1154),
    [anon_sym_BANG] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(1154),
    [aux_sym_clone_expression_token1] = ACTIONS(1156),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1156),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1156),
    [anon_sym_DASH_DASH] = ACTIONS(1154),
    [anon_sym_PLUS_PLUS] = ACTIONS(1154),
    [aux_sym__list_destructing_token1] = ACTIONS(1156),
    [anon_sym_LBRACK] = ACTIONS(1154),
    [anon_sym_self] = ACTIONS(1156),
    [anon_sym_parent] = ACTIONS(1156),
    [aux_sym__argument_name_token1] = ACTIONS(1156),
    [aux_sym__argument_name_token2] = ACTIONS(1156),
    [anon_sym_POUND_LBRACK] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1154),
    [aux_sym_encapsed_string_token1] = ACTIONS(1154),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [aux_sym_string_token1] = ACTIONS(1154),
    [anon_sym_LT_LT_LT] = ACTIONS(1154),
    [anon_sym_BQUOTE] = ACTIONS(1154),
    [anon_sym_DOLLAR] = ACTIONS(1154),
    [aux_sym_yield_expression_token1] = ACTIONS(1156),
    [aux_sym_include_expression_token1] = ACTIONS(1156),
    [aux_sym_include_once_expression_token1] = ACTIONS(1156),
    [aux_sym_require_expression_token1] = ACTIONS(1156),
    [aux_sym_require_once_expression_token1] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
  },
  [456] = {
    [ts_builtin_sym_end] = ACTIONS(1158),
    [sym_name] = ACTIONS(1160),
    [anon_sym_QMARK_GT] = ACTIONS(1158),
    [anon_sym_SEMI] = ACTIONS(1158),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1160),
    [aux_sym_global_declaration_token1] = ACTIONS(1160),
    [aux_sym_namespace_definition_token1] = ACTIONS(1160),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1160),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1160),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1160),
    [anon_sym_BSLASH] = ACTIONS(1158),
    [anon_sym_LBRACE] = ACTIONS(1158),
    [anon_sym_RBRACE] = ACTIONS(1158),
    [aux_sym_trait_declaration_token1] = ACTIONS(1160),
    [aux_sym_interface_declaration_token1] = ACTIONS(1160),
    [aux_sym_enum_declaration_token1] = ACTIONS(1160),
    [aux_sym_enum_case_token1] = ACTIONS(1160),
    [aux_sym_class_declaration_token1] = ACTIONS(1160),
    [aux_sym_final_modifier_token1] = ACTIONS(1160),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1160),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1160),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1160),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1160),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1160),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1160),
    [anon_sym_LPAREN] = ACTIONS(1158),
    [aux_sym_cast_type_token1] = ACTIONS(1160),
    [aux_sym_echo_statement_token1] = ACTIONS(1160),
    [anon_sym_unset] = ACTIONS(1160),
    [aux_sym_declare_statement_token1] = ACTIONS(1160),
    [aux_sym_declare_statement_token2] = ACTIONS(1160),
    [sym_float] = ACTIONS(1160),
    [aux_sym_try_statement_token1] = ACTIONS(1160),
    [aux_sym_goto_statement_token1] = ACTIONS(1160),
    [aux_sym_continue_statement_token1] = ACTIONS(1160),
    [aux_sym_break_statement_token1] = ACTIONS(1160),
    [sym_integer] = ACTIONS(1160),
    [aux_sym_return_statement_token1] = ACTIONS(1160),
    [aux_sym_throw_expression_token1] = ACTIONS(1160),
    [aux_sym_while_statement_token1] = ACTIONS(1160),
    [aux_sym_while_statement_token2] = ACTIONS(1160),
    [aux_sym_do_statement_token1] = ACTIONS(1160),
    [aux_sym_for_statement_token1] = ACTIONS(1160),
    [aux_sym_for_statement_token2] = ACTIONS(1160),
    [aux_sym_foreach_statement_token1] = ACTIONS(1160),
    [aux_sym_foreach_statement_token2] = ACTIONS(1160),
    [aux_sym_if_statement_token1] = ACTIONS(1160),
    [aux_sym_if_statement_token2] = ACTIONS(1160),
    [aux_sym_else_if_clause_token1] = ACTIONS(1160),
    [aux_sym_else_clause_token1] = ACTIONS(1160),
    [aux_sym_match_expression_token1] = ACTIONS(1160),
    [aux_sym_match_default_expression_token1] = ACTIONS(1160),
    [aux_sym_switch_statement_token1] = ACTIONS(1160),
    [aux_sym_switch_block_token1] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1160),
    [anon_sym_DASH] = ACTIONS(1160),
    [anon_sym_TILDE] = ACTIONS(1158),
    [anon_sym_BANG] = ACTIONS(1158),
    [anon_sym_AT] = ACTIONS(1158),
    [aux_sym_clone_expression_token1] = ACTIONS(1160),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1160),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1160),
    [anon_sym_DASH_DASH] = ACTIONS(1158),
    [anon_sym_PLUS_PLUS] = ACTIONS(1158),
    [aux_sym__list_destructing_token1] = ACTIONS(1160),
    [anon_sym_LBRACK] = ACTIONS(1158),
    [anon_sym_self] = ACTIONS(1160),
    [anon_sym_parent] = ACTIONS(1160),
    [aux_sym__argument_name_token1] = ACTIONS(1160),
    [aux_sym__argument_name_token2] = ACTIONS(1160),
    [anon_sym_POUND_LBRACK] = ACTIONS(1158),
    [anon_sym_SQUOTE] = ACTIONS(1158),
    [aux_sym_encapsed_string_token1] = ACTIONS(1158),
    [anon_sym_DQUOTE] = ACTIONS(1158),
    [aux_sym_string_token1] = ACTIONS(1158),
    [anon_sym_LT_LT_LT] = ACTIONS(1158),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1158),
    [aux_sym_yield_expression_token1] = ACTIONS(1160),
    [aux_sym_include_expression_token1] = ACTIONS(1160),
    [aux_sym_include_once_expression_token1] = ACTIONS(1160),
    [aux_sym_require_expression_token1] = ACTIONS(1160),
    [aux_sym_require_once_expression_token1] = ACTIONS(1160),
    [sym_comment] = ACTIONS(3),
  },
  [457] = {
    [ts_builtin_sym_end] = ACTIONS(1162),
    [sym_name] = ACTIONS(1164),
    [anon_sym_QMARK_GT] = ACTIONS(1162),
    [anon_sym_SEMI] = ACTIONS(1162),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1164),
    [aux_sym_global_declaration_token1] = ACTIONS(1164),
    [aux_sym_namespace_definition_token1] = ACTIONS(1164),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1164),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1164),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1164),
    [anon_sym_BSLASH] = ACTIONS(1162),
    [anon_sym_LBRACE] = ACTIONS(1162),
    [anon_sym_RBRACE] = ACTIONS(1162),
    [aux_sym_trait_declaration_token1] = ACTIONS(1164),
    [aux_sym_interface_declaration_token1] = ACTIONS(1164),
    [aux_sym_enum_declaration_token1] = ACTIONS(1164),
    [aux_sym_enum_case_token1] = ACTIONS(1164),
    [aux_sym_class_declaration_token1] = ACTIONS(1164),
    [aux_sym_final_modifier_token1] = ACTIONS(1164),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1164),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1164),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1164),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1164),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1164),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1164),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [aux_sym_cast_type_token1] = ACTIONS(1164),
    [aux_sym_echo_statement_token1] = ACTIONS(1164),
    [anon_sym_unset] = ACTIONS(1164),
    [aux_sym_declare_statement_token1] = ACTIONS(1164),
    [aux_sym_declare_statement_token2] = ACTIONS(1164),
    [sym_float] = ACTIONS(1164),
    [aux_sym_try_statement_token1] = ACTIONS(1164),
    [aux_sym_goto_statement_token1] = ACTIONS(1164),
    [aux_sym_continue_statement_token1] = ACTIONS(1164),
    [aux_sym_break_statement_token1] = ACTIONS(1164),
    [sym_integer] = ACTIONS(1164),
    [aux_sym_return_statement_token1] = ACTIONS(1164),
    [aux_sym_throw_expression_token1] = ACTIONS(1164),
    [aux_sym_while_statement_token1] = ACTIONS(1164),
    [aux_sym_while_statement_token2] = ACTIONS(1164),
    [aux_sym_do_statement_token1] = ACTIONS(1164),
    [aux_sym_for_statement_token1] = ACTIONS(1164),
    [aux_sym_for_statement_token2] = ACTIONS(1164),
    [aux_sym_foreach_statement_token1] = ACTIONS(1164),
    [aux_sym_foreach_statement_token2] = ACTIONS(1164),
    [aux_sym_if_statement_token1] = ACTIONS(1164),
    [aux_sym_if_statement_token2] = ACTIONS(1164),
    [aux_sym_else_if_clause_token1] = ACTIONS(1164),
    [aux_sym_else_clause_token1] = ACTIONS(1164),
    [aux_sym_match_expression_token1] = ACTIONS(1164),
    [aux_sym_match_default_expression_token1] = ACTIONS(1164),
    [aux_sym_switch_statement_token1] = ACTIONS(1164),
    [aux_sym_switch_block_token1] = ACTIONS(1164),
    [anon_sym_PLUS] = ACTIONS(1164),
    [anon_sym_DASH] = ACTIONS(1164),
    [anon_sym_TILDE] = ACTIONS(1162),
    [anon_sym_BANG] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(1162),
    [aux_sym_clone_expression_token1] = ACTIONS(1164),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1164),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1164),
    [anon_sym_DASH_DASH] = ACTIONS(1162),
    [anon_sym_PLUS_PLUS] = ACTIONS(1162),
    [aux_sym__list_destructing_token1] = ACTIONS(1164),
    [anon_sym_LBRACK] = ACTIONS(1162),
    [anon_sym_self] = ACTIONS(1164),
    [anon_sym_parent] = ACTIONS(1164),
    [aux_sym__argument_name_token1] = ACTIONS(1164),
    [aux_sym__argument_name_token2] = ACTIONS(1164),
    [anon_sym_POUND_LBRACK] = ACTIONS(1162),
    [anon_sym_SQUOTE] = ACTIONS(1162),
    [aux_sym_encapsed_string_token1] = ACTIONS(1162),
    [anon_sym_DQUOTE] = ACTIONS(1162),
    [aux_sym_string_token1] = ACTIONS(1162),
    [anon_sym_LT_LT_LT] = ACTIONS(1162),
    [anon_sym_BQUOTE] = ACTIONS(1162),
    [anon_sym_DOLLAR] = ACTIONS(1162),
    [aux_sym_yield_expression_token1] = ACTIONS(1164),
    [aux_sym_include_expression_token1] = ACTIONS(1164),
    [aux_sym_include_once_expression_token1] = ACTIONS(1164),
    [aux_sym_require_expression_token1] = ACTIONS(1164),
    [aux_sym_require_once_expression_token1] = ACTIONS(1164),
    [sym_comment] = ACTIONS(3),
  },
  [458] = {
    [ts_builtin_sym_end] = ACTIONS(1166),
    [sym_name] = ACTIONS(1168),
    [anon_sym_QMARK_GT] = ACTIONS(1166),
    [anon_sym_SEMI] = ACTIONS(1166),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1168),
    [aux_sym_global_declaration_token1] = ACTIONS(1168),
    [aux_sym_namespace_definition_token1] = ACTIONS(1168),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1168),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1168),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1168),
    [anon_sym_BSLASH] = ACTIONS(1166),
    [anon_sym_LBRACE] = ACTIONS(1166),
    [anon_sym_RBRACE] = ACTIONS(1166),
    [aux_sym_trait_declaration_token1] = ACTIONS(1168),
    [aux_sym_interface_declaration_token1] = ACTIONS(1168),
    [aux_sym_enum_declaration_token1] = ACTIONS(1168),
    [aux_sym_enum_case_token1] = ACTIONS(1168),
    [aux_sym_class_declaration_token1] = ACTIONS(1168),
    [aux_sym_final_modifier_token1] = ACTIONS(1168),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1168),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1168),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1168),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1168),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1168),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1168),
    [anon_sym_LPAREN] = ACTIONS(1166),
    [aux_sym_cast_type_token1] = ACTIONS(1168),
    [aux_sym_echo_statement_token1] = ACTIONS(1168),
    [anon_sym_unset] = ACTIONS(1168),
    [aux_sym_declare_statement_token1] = ACTIONS(1168),
    [aux_sym_declare_statement_token2] = ACTIONS(1168),
    [sym_float] = ACTIONS(1168),
    [aux_sym_try_statement_token1] = ACTIONS(1168),
    [aux_sym_goto_statement_token1] = ACTIONS(1168),
    [aux_sym_continue_statement_token1] = ACTIONS(1168),
    [aux_sym_break_statement_token1] = ACTIONS(1168),
    [sym_integer] = ACTIONS(1168),
    [aux_sym_return_statement_token1] = ACTIONS(1168),
    [aux_sym_throw_expression_token1] = ACTIONS(1168),
    [aux_sym_while_statement_token1] = ACTIONS(1168),
    [aux_sym_while_statement_token2] = ACTIONS(1168),
    [aux_sym_do_statement_token1] = ACTIONS(1168),
    [aux_sym_for_statement_token1] = ACTIONS(1168),
    [aux_sym_for_statement_token2] = ACTIONS(1168),
    [aux_sym_foreach_statement_token1] = ACTIONS(1168),
    [aux_sym_foreach_statement_token2] = ACTIONS(1168),
    [aux_sym_if_statement_token1] = ACTIONS(1168),
    [aux_sym_if_statement_token2] = ACTIONS(1168),
    [aux_sym_else_if_clause_token1] = ACTIONS(1168),
    [aux_sym_else_clause_token1] = ACTIONS(1168),
    [aux_sym_match_expression_token1] = ACTIONS(1168),
    [aux_sym_match_default_expression_token1] = ACTIONS(1168),
    [aux_sym_switch_statement_token1] = ACTIONS(1168),
    [aux_sym_switch_block_token1] = ACTIONS(1168),
    [anon_sym_PLUS] = ACTIONS(1168),
    [anon_sym_DASH] = ACTIONS(1168),
    [anon_sym_TILDE] = ACTIONS(1166),
    [anon_sym_BANG] = ACTIONS(1166),
    [anon_sym_AT] = ACTIONS(1166),
    [aux_sym_clone_expression_token1] = ACTIONS(1168),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1168),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1168),
    [anon_sym_DASH_DASH] = ACTIONS(1166),
    [anon_sym_PLUS_PLUS] = ACTIONS(1166),
    [aux_sym__list_destructing_token1] = ACTIONS(1168),
    [anon_sym_LBRACK] = ACTIONS(1166),
    [anon_sym_self] = ACTIONS(1168),
    [anon_sym_parent] = ACTIONS(1168),
    [aux_sym__argument_name_token1] = ACTIONS(1168),
    [aux_sym__argument_name_token2] = ACTIONS(1168),
    [anon_sym_POUND_LBRACK] = ACTIONS(1166),
    [anon_sym_SQUOTE] = ACTIONS(1166),
    [aux_sym_encapsed_string_token1] = ACTIONS(1166),
    [anon_sym_DQUOTE] = ACTIONS(1166),
    [aux_sym_string_token1] = ACTIONS(1166),
    [anon_sym_LT_LT_LT] = ACTIONS(1166),
    [anon_sym_BQUOTE] = ACTIONS(1166),
    [anon_sym_DOLLAR] = ACTIONS(1166),
    [aux_sym_yield_expression_token1] = ACTIONS(1168),
    [aux_sym_include_expression_token1] = ACTIONS(1168),
    [aux_sym_include_once_expression_token1] = ACTIONS(1168),
    [aux_sym_require_expression_token1] = ACTIONS(1168),
    [aux_sym_require_once_expression_token1] = ACTIONS(1168),
    [sym_comment] = ACTIONS(3),
  },
  [459] = {
    [ts_builtin_sym_end] = ACTIONS(1170),
    [sym_name] = ACTIONS(1172),
    [anon_sym_QMARK_GT] = ACTIONS(1170),
    [anon_sym_SEMI] = ACTIONS(1170),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1172),
    [aux_sym_global_declaration_token1] = ACTIONS(1172),
    [aux_sym_namespace_definition_token1] = ACTIONS(1172),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1172),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1172),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1172),
    [anon_sym_BSLASH] = ACTIONS(1170),
    [anon_sym_LBRACE] = ACTIONS(1170),
    [anon_sym_RBRACE] = ACTIONS(1170),
    [aux_sym_trait_declaration_token1] = ACTIONS(1172),
    [aux_sym_interface_declaration_token1] = ACTIONS(1172),
    [aux_sym_enum_declaration_token1] = ACTIONS(1172),
    [aux_sym_enum_case_token1] = ACTIONS(1172),
    [aux_sym_class_declaration_token1] = ACTIONS(1172),
    [aux_sym_final_modifier_token1] = ACTIONS(1172),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1172),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1172),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1172),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1172),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1172),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1172),
    [anon_sym_LPAREN] = ACTIONS(1170),
    [aux_sym_cast_type_token1] = ACTIONS(1172),
    [aux_sym_echo_statement_token1] = ACTIONS(1172),
    [anon_sym_unset] = ACTIONS(1172),
    [aux_sym_declare_statement_token1] = ACTIONS(1172),
    [aux_sym_declare_statement_token2] = ACTIONS(1172),
    [sym_float] = ACTIONS(1172),
    [aux_sym_try_statement_token1] = ACTIONS(1172),
    [aux_sym_goto_statement_token1] = ACTIONS(1172),
    [aux_sym_continue_statement_token1] = ACTIONS(1172),
    [aux_sym_break_statement_token1] = ACTIONS(1172),
    [sym_integer] = ACTIONS(1172),
    [aux_sym_return_statement_token1] = ACTIONS(1172),
    [aux_sym_throw_expression_token1] = ACTIONS(1172),
    [aux_sym_while_statement_token1] = ACTIONS(1172),
    [aux_sym_while_statement_token2] = ACTIONS(1172),
    [aux_sym_do_statement_token1] = ACTIONS(1172),
    [aux_sym_for_statement_token1] = ACTIONS(1172),
    [aux_sym_for_statement_token2] = ACTIONS(1172),
    [aux_sym_foreach_statement_token1] = ACTIONS(1172),
    [aux_sym_foreach_statement_token2] = ACTIONS(1172),
    [aux_sym_if_statement_token1] = ACTIONS(1172),
    [aux_sym_if_statement_token2] = ACTIONS(1172),
    [aux_sym_else_if_clause_token1] = ACTIONS(1172),
    [aux_sym_else_clause_token1] = ACTIONS(1172),
    [aux_sym_match_expression_token1] = ACTIONS(1172),
    [aux_sym_match_default_expression_token1] = ACTIONS(1172),
    [aux_sym_switch_statement_token1] = ACTIONS(1172),
    [aux_sym_switch_block_token1] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(1172),
    [anon_sym_DASH] = ACTIONS(1172),
    [anon_sym_TILDE] = ACTIONS(1170),
    [anon_sym_BANG] = ACTIONS(1170),
    [anon_sym_AT] = ACTIONS(1170),
    [aux_sym_clone_expression_token1] = ACTIONS(1172),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1172),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1172),
    [anon_sym_DASH_DASH] = ACTIONS(1170),
    [anon_sym_PLUS_PLUS] = ACTIONS(1170),
    [aux_sym__list_destructing_token1] = ACTIONS(1172),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_self] = ACTIONS(1172),
    [anon_sym_parent] = ACTIONS(1172),
    [aux_sym__argument_name_token1] = ACTIONS(1172),
    [aux_sym__argument_name_token2] = ACTIONS(1172),
    [anon_sym_POUND_LBRACK] = ACTIONS(1170),
    [anon_sym_SQUOTE] = ACTIONS(1170),
    [aux_sym_encapsed_string_token1] = ACTIONS(1170),
    [anon_sym_DQUOTE] = ACTIONS(1170),
    [aux_sym_string_token1] = ACTIONS(1170),
    [anon_sym_LT_LT_LT] = ACTIONS(1170),
    [anon_sym_BQUOTE] = ACTIONS(1170),
    [anon_sym_DOLLAR] = ACTIONS(1170),
    [aux_sym_yield_expression_token1] = ACTIONS(1172),
    [aux_sym_include_expression_token1] = ACTIONS(1172),
    [aux_sym_include_once_expression_token1] = ACTIONS(1172),
    [aux_sym_require_expression_token1] = ACTIONS(1172),
    [aux_sym_require_once_expression_token1] = ACTIONS(1172),
    [sym_comment] = ACTIONS(3),
  },
  [460] = {
    [ts_builtin_sym_end] = ACTIONS(1174),
    [sym_name] = ACTIONS(1176),
    [anon_sym_QMARK_GT] = ACTIONS(1174),
    [anon_sym_SEMI] = ACTIONS(1174),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1176),
    [aux_sym_global_declaration_token1] = ACTIONS(1176),
    [aux_sym_namespace_definition_token1] = ACTIONS(1176),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1176),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1176),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1176),
    [anon_sym_BSLASH] = ACTIONS(1174),
    [anon_sym_LBRACE] = ACTIONS(1174),
    [anon_sym_RBRACE] = ACTIONS(1174),
    [aux_sym_trait_declaration_token1] = ACTIONS(1176),
    [aux_sym_interface_declaration_token1] = ACTIONS(1176),
    [aux_sym_enum_declaration_token1] = ACTIONS(1176),
    [aux_sym_enum_case_token1] = ACTIONS(1176),
    [aux_sym_class_declaration_token1] = ACTIONS(1176),
    [aux_sym_final_modifier_token1] = ACTIONS(1176),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1176),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1176),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1176),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1176),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1176),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1176),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [aux_sym_cast_type_token1] = ACTIONS(1176),
    [aux_sym_echo_statement_token1] = ACTIONS(1176),
    [anon_sym_unset] = ACTIONS(1176),
    [aux_sym_declare_statement_token1] = ACTIONS(1176),
    [aux_sym_declare_statement_token2] = ACTIONS(1176),
    [sym_float] = ACTIONS(1176),
    [aux_sym_try_statement_token1] = ACTIONS(1176),
    [aux_sym_goto_statement_token1] = ACTIONS(1176),
    [aux_sym_continue_statement_token1] = ACTIONS(1176),
    [aux_sym_break_statement_token1] = ACTIONS(1176),
    [sym_integer] = ACTIONS(1176),
    [aux_sym_return_statement_token1] = ACTIONS(1176),
    [aux_sym_throw_expression_token1] = ACTIONS(1176),
    [aux_sym_while_statement_token1] = ACTIONS(1176),
    [aux_sym_while_statement_token2] = ACTIONS(1176),
    [aux_sym_do_statement_token1] = ACTIONS(1176),
    [aux_sym_for_statement_token1] = ACTIONS(1176),
    [aux_sym_for_statement_token2] = ACTIONS(1176),
    [aux_sym_foreach_statement_token1] = ACTIONS(1176),
    [aux_sym_foreach_statement_token2] = ACTIONS(1176),
    [aux_sym_if_statement_token1] = ACTIONS(1176),
    [aux_sym_if_statement_token2] = ACTIONS(1176),
    [aux_sym_else_if_clause_token1] = ACTIONS(1176),
    [aux_sym_else_clause_token1] = ACTIONS(1176),
    [aux_sym_match_expression_token1] = ACTIONS(1176),
    [aux_sym_match_default_expression_token1] = ACTIONS(1176),
    [aux_sym_switch_statement_token1] = ACTIONS(1176),
    [aux_sym_switch_block_token1] = ACTIONS(1176),
    [anon_sym_PLUS] = ACTIONS(1176),
    [anon_sym_DASH] = ACTIONS(1176),
    [anon_sym_TILDE] = ACTIONS(1174),
    [anon_sym_BANG] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(1174),
    [aux_sym_clone_expression_token1] = ACTIONS(1176),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1176),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1176),
    [anon_sym_DASH_DASH] = ACTIONS(1174),
    [anon_sym_PLUS_PLUS] = ACTIONS(1174),
    [aux_sym__list_destructing_token1] = ACTIONS(1176),
    [anon_sym_LBRACK] = ACTIONS(1174),
    [anon_sym_self] = ACTIONS(1176),
    [anon_sym_parent] = ACTIONS(1176),
    [aux_sym__argument_name_token1] = ACTIONS(1176),
    [aux_sym__argument_name_token2] = ACTIONS(1176),
    [anon_sym_POUND_LBRACK] = ACTIONS(1174),
    [anon_sym_SQUOTE] = ACTIONS(1174),
    [aux_sym_encapsed_string_token1] = ACTIONS(1174),
    [anon_sym_DQUOTE] = ACTIONS(1174),
    [aux_sym_string_token1] = ACTIONS(1174),
    [anon_sym_LT_LT_LT] = ACTIONS(1174),
    [anon_sym_BQUOTE] = ACTIONS(1174),
    [anon_sym_DOLLAR] = ACTIONS(1174),
    [aux_sym_yield_expression_token1] = ACTIONS(1176),
    [aux_sym_include_expression_token1] = ACTIONS(1176),
    [aux_sym_include_once_expression_token1] = ACTIONS(1176),
    [aux_sym_require_expression_token1] = ACTIONS(1176),
    [aux_sym_require_once_expression_token1] = ACTIONS(1176),
    [sym_comment] = ACTIONS(3),
  },
  [461] = {
    [ts_builtin_sym_end] = ACTIONS(1178),
    [sym_name] = ACTIONS(1180),
    [anon_sym_QMARK_GT] = ACTIONS(1178),
    [anon_sym_SEMI] = ACTIONS(1178),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1180),
    [aux_sym_global_declaration_token1] = ACTIONS(1180),
    [aux_sym_namespace_definition_token1] = ACTIONS(1180),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1180),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1180),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1180),
    [anon_sym_BSLASH] = ACTIONS(1178),
    [anon_sym_LBRACE] = ACTIONS(1178),
    [anon_sym_RBRACE] = ACTIONS(1178),
    [aux_sym_trait_declaration_token1] = ACTIONS(1180),
    [aux_sym_interface_declaration_token1] = ACTIONS(1180),
    [aux_sym_enum_declaration_token1] = ACTIONS(1180),
    [aux_sym_enum_case_token1] = ACTIONS(1180),
    [aux_sym_class_declaration_token1] = ACTIONS(1180),
    [aux_sym_final_modifier_token1] = ACTIONS(1180),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1180),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1180),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1180),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1180),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1180),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1180),
    [anon_sym_LPAREN] = ACTIONS(1178),
    [aux_sym_cast_type_token1] = ACTIONS(1180),
    [aux_sym_echo_statement_token1] = ACTIONS(1180),
    [anon_sym_unset] = ACTIONS(1180),
    [aux_sym_declare_statement_token1] = ACTIONS(1180),
    [aux_sym_declare_statement_token2] = ACTIONS(1180),
    [sym_float] = ACTIONS(1180),
    [aux_sym_try_statement_token1] = ACTIONS(1180),
    [aux_sym_goto_statement_token1] = ACTIONS(1180),
    [aux_sym_continue_statement_token1] = ACTIONS(1180),
    [aux_sym_break_statement_token1] = ACTIONS(1180),
    [sym_integer] = ACTIONS(1180),
    [aux_sym_return_statement_token1] = ACTIONS(1180),
    [aux_sym_throw_expression_token1] = ACTIONS(1180),
    [aux_sym_while_statement_token1] = ACTIONS(1180),
    [aux_sym_while_statement_token2] = ACTIONS(1180),
    [aux_sym_do_statement_token1] = ACTIONS(1180),
    [aux_sym_for_statement_token1] = ACTIONS(1180),
    [aux_sym_for_statement_token2] = ACTIONS(1180),
    [aux_sym_foreach_statement_token1] = ACTIONS(1180),
    [aux_sym_foreach_statement_token2] = ACTIONS(1180),
    [aux_sym_if_statement_token1] = ACTIONS(1180),
    [aux_sym_if_statement_token2] = ACTIONS(1180),
    [aux_sym_else_if_clause_token1] = ACTIONS(1180),
    [aux_sym_else_clause_token1] = ACTIONS(1180),
    [aux_sym_match_expression_token1] = ACTIONS(1180),
    [aux_sym_match_default_expression_token1] = ACTIONS(1180),
    [aux_sym_switch_statement_token1] = ACTIONS(1180),
    [aux_sym_switch_block_token1] = ACTIONS(1180),
    [anon_sym_PLUS] = ACTIONS(1180),
    [anon_sym_DASH] = ACTIONS(1180),
    [anon_sym_TILDE] = ACTIONS(1178),
    [anon_sym_BANG] = ACTIONS(1178),
    [anon_sym_AT] = ACTIONS(1178),
    [aux_sym_clone_expression_token1] = ACTIONS(1180),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1180),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1180),
    [anon_sym_DASH_DASH] = ACTIONS(1178),
    [anon_sym_PLUS_PLUS] = ACTIONS(1178),
    [aux_sym__list_destructing_token1] = ACTIONS(1180),
    [anon_sym_LBRACK] = ACTIONS(1178),
    [anon_sym_self] = ACTIONS(1180),
    [anon_sym_parent] = ACTIONS(1180),
    [aux_sym__argument_name_token1] = ACTIONS(1180),
    [aux_sym__argument_name_token2] = ACTIONS(1180),
    [anon_sym_POUND_LBRACK] = ACTIONS(1178),
    [anon_sym_SQUOTE] = ACTIONS(1178),
    [aux_sym_encapsed_string_token1] = ACTIONS(1178),
    [anon_sym_DQUOTE] = ACTIONS(1178),
    [aux_sym_string_token1] = ACTIONS(1178),
    [anon_sym_LT_LT_LT] = ACTIONS(1178),
    [anon_sym_BQUOTE] = ACTIONS(1178),
    [anon_sym_DOLLAR] = ACTIONS(1178),
    [aux_sym_yield_expression_token1] = ACTIONS(1180),
    [aux_sym_include_expression_token1] = ACTIONS(1180),
    [aux_sym_include_once_expression_token1] = ACTIONS(1180),
    [aux_sym_require_expression_token1] = ACTIONS(1180),
    [aux_sym_require_once_expression_token1] = ACTIONS(1180),
    [sym_comment] = ACTIONS(3),
  },
  [462] = {
    [ts_builtin_sym_end] = ACTIONS(1182),
    [sym_name] = ACTIONS(1184),
    [anon_sym_QMARK_GT] = ACTIONS(1182),
    [anon_sym_SEMI] = ACTIONS(1182),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1184),
    [aux_sym_global_declaration_token1] = ACTIONS(1184),
    [aux_sym_namespace_definition_token1] = ACTIONS(1184),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1184),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1184),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1184),
    [anon_sym_BSLASH] = ACTIONS(1182),
    [anon_sym_LBRACE] = ACTIONS(1182),
    [anon_sym_RBRACE] = ACTIONS(1182),
    [aux_sym_trait_declaration_token1] = ACTIONS(1184),
    [aux_sym_interface_declaration_token1] = ACTIONS(1184),
    [aux_sym_enum_declaration_token1] = ACTIONS(1184),
    [aux_sym_enum_case_token1] = ACTIONS(1184),
    [aux_sym_class_declaration_token1] = ACTIONS(1184),
    [aux_sym_final_modifier_token1] = ACTIONS(1184),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1184),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1184),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1184),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1184),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1184),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1184),
    [anon_sym_LPAREN] = ACTIONS(1182),
    [aux_sym_cast_type_token1] = ACTIONS(1184),
    [aux_sym_echo_statement_token1] = ACTIONS(1184),
    [anon_sym_unset] = ACTIONS(1184),
    [aux_sym_declare_statement_token1] = ACTIONS(1184),
    [aux_sym_declare_statement_token2] = ACTIONS(1184),
    [sym_float] = ACTIONS(1184),
    [aux_sym_try_statement_token1] = ACTIONS(1184),
    [aux_sym_goto_statement_token1] = ACTIONS(1184),
    [aux_sym_continue_statement_token1] = ACTIONS(1184),
    [aux_sym_break_statement_token1] = ACTIONS(1184),
    [sym_integer] = ACTIONS(1184),
    [aux_sym_return_statement_token1] = ACTIONS(1184),
    [aux_sym_throw_expression_token1] = ACTIONS(1184),
    [aux_sym_while_statement_token1] = ACTIONS(1184),
    [aux_sym_while_statement_token2] = ACTIONS(1184),
    [aux_sym_do_statement_token1] = ACTIONS(1184),
    [aux_sym_for_statement_token1] = ACTIONS(1184),
    [aux_sym_for_statement_token2] = ACTIONS(1184),
    [aux_sym_foreach_statement_token1] = ACTIONS(1184),
    [aux_sym_foreach_statement_token2] = ACTIONS(1184),
    [aux_sym_if_statement_token1] = ACTIONS(1184),
    [aux_sym_if_statement_token2] = ACTIONS(1184),
    [aux_sym_else_if_clause_token1] = ACTIONS(1184),
    [aux_sym_else_clause_token1] = ACTIONS(1184),
    [aux_sym_match_expression_token1] = ACTIONS(1184),
    [aux_sym_match_default_expression_token1] = ACTIONS(1184),
    [aux_sym_switch_statement_token1] = ACTIONS(1184),
    [aux_sym_switch_block_token1] = ACTIONS(1184),
    [anon_sym_PLUS] = ACTIONS(1184),
    [anon_sym_DASH] = ACTIONS(1184),
    [anon_sym_TILDE] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1182),
    [anon_sym_AT] = ACTIONS(1182),
    [aux_sym_clone_expression_token1] = ACTIONS(1184),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1184),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1184),
    [anon_sym_DASH_DASH] = ACTIONS(1182),
    [anon_sym_PLUS_PLUS] = ACTIONS(1182),
    [aux_sym__list_destructing_token1] = ACTIONS(1184),
    [anon_sym_LBRACK] = ACTIONS(1182),
    [anon_sym_self] = ACTIONS(1184),
    [anon_sym_parent] = ACTIONS(1184),
    [aux_sym__argument_name_token1] = ACTIONS(1184),
    [aux_sym__argument_name_token2] = ACTIONS(1184),
    [anon_sym_POUND_LBRACK] = ACTIONS(1182),
    [anon_sym_SQUOTE] = ACTIONS(1182),
    [aux_sym_encapsed_string_token1] = ACTIONS(1182),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [aux_sym_string_token1] = ACTIONS(1182),
    [anon_sym_LT_LT_LT] = ACTIONS(1182),
    [anon_sym_BQUOTE] = ACTIONS(1182),
    [anon_sym_DOLLAR] = ACTIONS(1182),
    [aux_sym_yield_expression_token1] = ACTIONS(1184),
    [aux_sym_include_expression_token1] = ACTIONS(1184),
    [aux_sym_include_once_expression_token1] = ACTIONS(1184),
    [aux_sym_require_expression_token1] = ACTIONS(1184),
    [aux_sym_require_once_expression_token1] = ACTIONS(1184),
    [sym_comment] = ACTIONS(3),
  },
  [463] = {
    [ts_builtin_sym_end] = ACTIONS(1186),
    [sym_name] = ACTIONS(1188),
    [anon_sym_QMARK_GT] = ACTIONS(1186),
    [anon_sym_SEMI] = ACTIONS(1186),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1188),
    [aux_sym_global_declaration_token1] = ACTIONS(1188),
    [aux_sym_namespace_definition_token1] = ACTIONS(1188),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1188),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1188),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1188),
    [anon_sym_BSLASH] = ACTIONS(1186),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_RBRACE] = ACTIONS(1186),
    [aux_sym_trait_declaration_token1] = ACTIONS(1188),
    [aux_sym_interface_declaration_token1] = ACTIONS(1188),
    [aux_sym_enum_declaration_token1] = ACTIONS(1188),
    [aux_sym_enum_case_token1] = ACTIONS(1188),
    [aux_sym_class_declaration_token1] = ACTIONS(1188),
    [aux_sym_final_modifier_token1] = ACTIONS(1188),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1188),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1188),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1188),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1188),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1188),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1186),
    [aux_sym_cast_type_token1] = ACTIONS(1188),
    [aux_sym_echo_statement_token1] = ACTIONS(1188),
    [anon_sym_unset] = ACTIONS(1188),
    [aux_sym_declare_statement_token1] = ACTIONS(1188),
    [aux_sym_declare_statement_token2] = ACTIONS(1188),
    [sym_float] = ACTIONS(1188),
    [aux_sym_try_statement_token1] = ACTIONS(1188),
    [aux_sym_goto_statement_token1] = ACTIONS(1188),
    [aux_sym_continue_statement_token1] = ACTIONS(1188),
    [aux_sym_break_statement_token1] = ACTIONS(1188),
    [sym_integer] = ACTIONS(1188),
    [aux_sym_return_statement_token1] = ACTIONS(1188),
    [aux_sym_throw_expression_token1] = ACTIONS(1188),
    [aux_sym_while_statement_token1] = ACTIONS(1188),
    [aux_sym_while_statement_token2] = ACTIONS(1188),
    [aux_sym_do_statement_token1] = ACTIONS(1188),
    [aux_sym_for_statement_token1] = ACTIONS(1188),
    [aux_sym_for_statement_token2] = ACTIONS(1188),
    [aux_sym_foreach_statement_token1] = ACTIONS(1188),
    [aux_sym_foreach_statement_token2] = ACTIONS(1188),
    [aux_sym_if_statement_token1] = ACTIONS(1188),
    [aux_sym_if_statement_token2] = ACTIONS(1188),
    [aux_sym_else_if_clause_token1] = ACTIONS(1188),
    [aux_sym_else_clause_token1] = ACTIONS(1188),
    [aux_sym_match_expression_token1] = ACTIONS(1188),
    [aux_sym_match_default_expression_token1] = ACTIONS(1188),
    [aux_sym_switch_statement_token1] = ACTIONS(1188),
    [aux_sym_switch_block_token1] = ACTIONS(1188),
    [anon_sym_PLUS] = ACTIONS(1188),
    [anon_sym_DASH] = ACTIONS(1188),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_BANG] = ACTIONS(1186),
    [anon_sym_AT] = ACTIONS(1186),
    [aux_sym_clone_expression_token1] = ACTIONS(1188),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1188),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1188),
    [anon_sym_DASH_DASH] = ACTIONS(1186),
    [anon_sym_PLUS_PLUS] = ACTIONS(1186),
    [aux_sym__list_destructing_token1] = ACTIONS(1188),
    [anon_sym_LBRACK] = ACTIONS(1186),
    [anon_sym_self] = ACTIONS(1188),
    [anon_sym_parent] = ACTIONS(1188),
    [aux_sym__argument_name_token1] = ACTIONS(1188),
    [aux_sym__argument_name_token2] = ACTIONS(1188),
    [anon_sym_POUND_LBRACK] = ACTIONS(1186),
    [anon_sym_SQUOTE] = ACTIONS(1186),
    [aux_sym_encapsed_string_token1] = ACTIONS(1186),
    [anon_sym_DQUOTE] = ACTIONS(1186),
    [aux_sym_string_token1] = ACTIONS(1186),
    [anon_sym_LT_LT_LT] = ACTIONS(1186),
    [anon_sym_BQUOTE] = ACTIONS(1186),
    [anon_sym_DOLLAR] = ACTIONS(1186),
    [aux_sym_yield_expression_token1] = ACTIONS(1188),
    [aux_sym_include_expression_token1] = ACTIONS(1188),
    [aux_sym_include_once_expression_token1] = ACTIONS(1188),
    [aux_sym_require_expression_token1] = ACTIONS(1188),
    [aux_sym_require_once_expression_token1] = ACTIONS(1188),
    [sym_comment] = ACTIONS(3),
  },
  [464] = {
    [ts_builtin_sym_end] = ACTIONS(1190),
    [sym_name] = ACTIONS(1192),
    [anon_sym_QMARK_GT] = ACTIONS(1190),
    [anon_sym_SEMI] = ACTIONS(1190),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1192),
    [aux_sym_global_declaration_token1] = ACTIONS(1192),
    [aux_sym_namespace_definition_token1] = ACTIONS(1192),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1192),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1192),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1192),
    [anon_sym_BSLASH] = ACTIONS(1190),
    [anon_sym_LBRACE] = ACTIONS(1190),
    [anon_sym_RBRACE] = ACTIONS(1190),
    [aux_sym_trait_declaration_token1] = ACTIONS(1192),
    [aux_sym_interface_declaration_token1] = ACTIONS(1192),
    [aux_sym_enum_declaration_token1] = ACTIONS(1192),
    [aux_sym_enum_case_token1] = ACTIONS(1192),
    [aux_sym_class_declaration_token1] = ACTIONS(1192),
    [aux_sym_final_modifier_token1] = ACTIONS(1192),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1192),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1192),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1192),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1192),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1192),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1192),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [aux_sym_cast_type_token1] = ACTIONS(1192),
    [aux_sym_echo_statement_token1] = ACTIONS(1192),
    [anon_sym_unset] = ACTIONS(1192),
    [aux_sym_declare_statement_token1] = ACTIONS(1192),
    [aux_sym_declare_statement_token2] = ACTIONS(1192),
    [sym_float] = ACTIONS(1192),
    [aux_sym_try_statement_token1] = ACTIONS(1192),
    [aux_sym_goto_statement_token1] = ACTIONS(1192),
    [aux_sym_continue_statement_token1] = ACTIONS(1192),
    [aux_sym_break_statement_token1] = ACTIONS(1192),
    [sym_integer] = ACTIONS(1192),
    [aux_sym_return_statement_token1] = ACTIONS(1192),
    [aux_sym_throw_expression_token1] = ACTIONS(1192),
    [aux_sym_while_statement_token1] = ACTIONS(1192),
    [aux_sym_while_statement_token2] = ACTIONS(1192),
    [aux_sym_do_statement_token1] = ACTIONS(1192),
    [aux_sym_for_statement_token1] = ACTIONS(1192),
    [aux_sym_for_statement_token2] = ACTIONS(1192),
    [aux_sym_foreach_statement_token1] = ACTIONS(1192),
    [aux_sym_foreach_statement_token2] = ACTIONS(1192),
    [aux_sym_if_statement_token1] = ACTIONS(1192),
    [aux_sym_if_statement_token2] = ACTIONS(1192),
    [aux_sym_else_if_clause_token1] = ACTIONS(1192),
    [aux_sym_else_clause_token1] = ACTIONS(1192),
    [aux_sym_match_expression_token1] = ACTIONS(1192),
    [aux_sym_match_default_expression_token1] = ACTIONS(1192),
    [aux_sym_switch_statement_token1] = ACTIONS(1192),
    [aux_sym_switch_block_token1] = ACTIONS(1192),
    [anon_sym_PLUS] = ACTIONS(1192),
    [anon_sym_DASH] = ACTIONS(1192),
    [anon_sym_TILDE] = ACTIONS(1190),
    [anon_sym_BANG] = ACTIONS(1190),
    [anon_sym_AT] = ACTIONS(1190),
    [aux_sym_clone_expression_token1] = ACTIONS(1192),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1192),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1192),
    [anon_sym_DASH_DASH] = ACTIONS(1190),
    [anon_sym_PLUS_PLUS] = ACTIONS(1190),
    [aux_sym__list_destructing_token1] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1190),
    [anon_sym_self] = ACTIONS(1192),
    [anon_sym_parent] = ACTIONS(1192),
    [aux_sym__argument_name_token1] = ACTIONS(1192),
    [aux_sym__argument_name_token2] = ACTIONS(1192),
    [anon_sym_POUND_LBRACK] = ACTIONS(1190),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [aux_sym_encapsed_string_token1] = ACTIONS(1190),
    [anon_sym_DQUOTE] = ACTIONS(1190),
    [aux_sym_string_token1] = ACTIONS(1190),
    [anon_sym_LT_LT_LT] = ACTIONS(1190),
    [anon_sym_BQUOTE] = ACTIONS(1190),
    [anon_sym_DOLLAR] = ACTIONS(1190),
    [aux_sym_yield_expression_token1] = ACTIONS(1192),
    [aux_sym_include_expression_token1] = ACTIONS(1192),
    [aux_sym_include_once_expression_token1] = ACTIONS(1192),
    [aux_sym_require_expression_token1] = ACTIONS(1192),
    [aux_sym_require_once_expression_token1] = ACTIONS(1192),
    [sym_comment] = ACTIONS(3),
  },
  [465] = {
    [ts_builtin_sym_end] = ACTIONS(1194),
    [sym_name] = ACTIONS(1196),
    [anon_sym_QMARK_GT] = ACTIONS(1194),
    [anon_sym_SEMI] = ACTIONS(1194),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1196),
    [aux_sym_global_declaration_token1] = ACTIONS(1196),
    [aux_sym_namespace_definition_token1] = ACTIONS(1196),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1196),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1196),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1196),
    [anon_sym_BSLASH] = ACTIONS(1194),
    [anon_sym_LBRACE] = ACTIONS(1194),
    [anon_sym_RBRACE] = ACTIONS(1194),
    [aux_sym_trait_declaration_token1] = ACTIONS(1196),
    [aux_sym_interface_declaration_token1] = ACTIONS(1196),
    [aux_sym_enum_declaration_token1] = ACTIONS(1196),
    [aux_sym_enum_case_token1] = ACTIONS(1196),
    [aux_sym_class_declaration_token1] = ACTIONS(1196),
    [aux_sym_final_modifier_token1] = ACTIONS(1196),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1196),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1196),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1196),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1196),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1196),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1196),
    [anon_sym_LPAREN] = ACTIONS(1194),
    [aux_sym_cast_type_token1] = ACTIONS(1196),
    [aux_sym_echo_statement_token1] = ACTIONS(1196),
    [anon_sym_unset] = ACTIONS(1196),
    [aux_sym_declare_statement_token1] = ACTIONS(1196),
    [aux_sym_declare_statement_token2] = ACTIONS(1196),
    [sym_float] = ACTIONS(1196),
    [aux_sym_try_statement_token1] = ACTIONS(1196),
    [aux_sym_goto_statement_token1] = ACTIONS(1196),
    [aux_sym_continue_statement_token1] = ACTIONS(1196),
    [aux_sym_break_statement_token1] = ACTIONS(1196),
    [sym_integer] = ACTIONS(1196),
    [aux_sym_return_statement_token1] = ACTIONS(1196),
    [aux_sym_throw_expression_token1] = ACTIONS(1196),
    [aux_sym_while_statement_token1] = ACTIONS(1196),
    [aux_sym_while_statement_token2] = ACTIONS(1196),
    [aux_sym_do_statement_token1] = ACTIONS(1196),
    [aux_sym_for_statement_token1] = ACTIONS(1196),
    [aux_sym_for_statement_token2] = ACTIONS(1196),
    [aux_sym_foreach_statement_token1] = ACTIONS(1196),
    [aux_sym_foreach_statement_token2] = ACTIONS(1196),
    [aux_sym_if_statement_token1] = ACTIONS(1196),
    [aux_sym_if_statement_token2] = ACTIONS(1196),
    [aux_sym_else_if_clause_token1] = ACTIONS(1196),
    [aux_sym_else_clause_token1] = ACTIONS(1196),
    [aux_sym_match_expression_token1] = ACTIONS(1196),
    [aux_sym_match_default_expression_token1] = ACTIONS(1196),
    [aux_sym_switch_statement_token1] = ACTIONS(1196),
    [aux_sym_switch_block_token1] = ACTIONS(1196),
    [anon_sym_PLUS] = ACTIONS(1196),
    [anon_sym_DASH] = ACTIONS(1196),
    [anon_sym_TILDE] = ACTIONS(1194),
    [anon_sym_BANG] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1194),
    [aux_sym_clone_expression_token1] = ACTIONS(1196),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1196),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1196),
    [anon_sym_DASH_DASH] = ACTIONS(1194),
    [anon_sym_PLUS_PLUS] = ACTIONS(1194),
    [aux_sym__list_destructing_token1] = ACTIONS(1196),
    [anon_sym_LBRACK] = ACTIONS(1194),
    [anon_sym_self] = ACTIONS(1196),
    [anon_sym_parent] = ACTIONS(1196),
    [aux_sym__argument_name_token1] = ACTIONS(1196),
    [aux_sym__argument_name_token2] = ACTIONS(1196),
    [anon_sym_POUND_LBRACK] = ACTIONS(1194),
    [anon_sym_SQUOTE] = ACTIONS(1194),
    [aux_sym_encapsed_string_token1] = ACTIONS(1194),
    [anon_sym_DQUOTE] = ACTIONS(1194),
    [aux_sym_string_token1] = ACTIONS(1194),
    [anon_sym_LT_LT_LT] = ACTIONS(1194),
    [anon_sym_BQUOTE] = ACTIONS(1194),
    [anon_sym_DOLLAR] = ACTIONS(1194),
    [aux_sym_yield_expression_token1] = ACTIONS(1196),
    [aux_sym_include_expression_token1] = ACTIONS(1196),
    [aux_sym_include_once_expression_token1] = ACTIONS(1196),
    [aux_sym_require_expression_token1] = ACTIONS(1196),
    [aux_sym_require_once_expression_token1] = ACTIONS(1196),
    [sym_comment] = ACTIONS(3),
  },
  [466] = {
    [ts_builtin_sym_end] = ACTIONS(1198),
    [sym_name] = ACTIONS(1200),
    [anon_sym_QMARK_GT] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1198),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1200),
    [aux_sym_global_declaration_token1] = ACTIONS(1200),
    [aux_sym_namespace_definition_token1] = ACTIONS(1200),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1200),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1200),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1200),
    [anon_sym_BSLASH] = ACTIONS(1198),
    [anon_sym_LBRACE] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [aux_sym_trait_declaration_token1] = ACTIONS(1200),
    [aux_sym_interface_declaration_token1] = ACTIONS(1200),
    [aux_sym_enum_declaration_token1] = ACTIONS(1200),
    [aux_sym_enum_case_token1] = ACTIONS(1200),
    [aux_sym_class_declaration_token1] = ACTIONS(1200),
    [aux_sym_final_modifier_token1] = ACTIONS(1200),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1200),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1200),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1200),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1200),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1200),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1200),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [aux_sym_cast_type_token1] = ACTIONS(1200),
    [aux_sym_echo_statement_token1] = ACTIONS(1200),
    [anon_sym_unset] = ACTIONS(1200),
    [aux_sym_declare_statement_token1] = ACTIONS(1200),
    [aux_sym_declare_statement_token2] = ACTIONS(1200),
    [sym_float] = ACTIONS(1200),
    [aux_sym_try_statement_token1] = ACTIONS(1200),
    [aux_sym_goto_statement_token1] = ACTIONS(1200),
    [aux_sym_continue_statement_token1] = ACTIONS(1200),
    [aux_sym_break_statement_token1] = ACTIONS(1200),
    [sym_integer] = ACTIONS(1200),
    [aux_sym_return_statement_token1] = ACTIONS(1200),
    [aux_sym_throw_expression_token1] = ACTIONS(1200),
    [aux_sym_while_statement_token1] = ACTIONS(1200),
    [aux_sym_while_statement_token2] = ACTIONS(1200),
    [aux_sym_do_statement_token1] = ACTIONS(1200),
    [aux_sym_for_statement_token1] = ACTIONS(1200),
    [aux_sym_for_statement_token2] = ACTIONS(1200),
    [aux_sym_foreach_statement_token1] = ACTIONS(1200),
    [aux_sym_foreach_statement_token2] = ACTIONS(1200),
    [aux_sym_if_statement_token1] = ACTIONS(1200),
    [aux_sym_if_statement_token2] = ACTIONS(1200),
    [aux_sym_else_if_clause_token1] = ACTIONS(1200),
    [aux_sym_else_clause_token1] = ACTIONS(1200),
    [aux_sym_match_expression_token1] = ACTIONS(1200),
    [aux_sym_match_default_expression_token1] = ACTIONS(1200),
    [aux_sym_switch_statement_token1] = ACTIONS(1200),
    [aux_sym_switch_block_token1] = ACTIONS(1200),
    [anon_sym_PLUS] = ACTIONS(1200),
    [anon_sym_DASH] = ACTIONS(1200),
    [anon_sym_TILDE] = ACTIONS(1198),
    [anon_sym_BANG] = ACTIONS(1198),
    [anon_sym_AT] = ACTIONS(1198),
    [aux_sym_clone_expression_token1] = ACTIONS(1200),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1200),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1200),
    [anon_sym_DASH_DASH] = ACTIONS(1198),
    [anon_sym_PLUS_PLUS] = ACTIONS(1198),
    [aux_sym__list_destructing_token1] = ACTIONS(1200),
    [anon_sym_LBRACK] = ACTIONS(1198),
    [anon_sym_self] = ACTIONS(1200),
    [anon_sym_parent] = ACTIONS(1200),
    [aux_sym__argument_name_token1] = ACTIONS(1200),
    [aux_sym__argument_name_token2] = ACTIONS(1200),
    [anon_sym_POUND_LBRACK] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(1198),
    [aux_sym_encapsed_string_token1] = ACTIONS(1198),
    [anon_sym_DQUOTE] = ACTIONS(1198),
    [aux_sym_string_token1] = ACTIONS(1198),
    [anon_sym_LT_LT_LT] = ACTIONS(1198),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [anon_sym_DOLLAR] = ACTIONS(1198),
    [aux_sym_yield_expression_token1] = ACTIONS(1200),
    [aux_sym_include_expression_token1] = ACTIONS(1200),
    [aux_sym_include_once_expression_token1] = ACTIONS(1200),
    [aux_sym_require_expression_token1] = ACTIONS(1200),
    [aux_sym_require_once_expression_token1] = ACTIONS(1200),
    [sym_comment] = ACTIONS(3),
  },
  [467] = {
    [ts_builtin_sym_end] = ACTIONS(1202),
    [sym_name] = ACTIONS(1204),
    [anon_sym_QMARK_GT] = ACTIONS(1202),
    [anon_sym_SEMI] = ACTIONS(1202),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1204),
    [aux_sym_global_declaration_token1] = ACTIONS(1204),
    [aux_sym_namespace_definition_token1] = ACTIONS(1204),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1204),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1204),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1204),
    [anon_sym_BSLASH] = ACTIONS(1202),
    [anon_sym_LBRACE] = ACTIONS(1202),
    [anon_sym_RBRACE] = ACTIONS(1202),
    [aux_sym_trait_declaration_token1] = ACTIONS(1204),
    [aux_sym_interface_declaration_token1] = ACTIONS(1204),
    [aux_sym_enum_declaration_token1] = ACTIONS(1204),
    [aux_sym_enum_case_token1] = ACTIONS(1204),
    [aux_sym_class_declaration_token1] = ACTIONS(1204),
    [aux_sym_final_modifier_token1] = ACTIONS(1204),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1204),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1204),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1204),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1204),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1204),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1204),
    [anon_sym_LPAREN] = ACTIONS(1202),
    [aux_sym_cast_type_token1] = ACTIONS(1204),
    [aux_sym_echo_statement_token1] = ACTIONS(1204),
    [anon_sym_unset] = ACTIONS(1204),
    [aux_sym_declare_statement_token1] = ACTIONS(1204),
    [aux_sym_declare_statement_token2] = ACTIONS(1204),
    [sym_float] = ACTIONS(1204),
    [aux_sym_try_statement_token1] = ACTIONS(1204),
    [aux_sym_goto_statement_token1] = ACTIONS(1204),
    [aux_sym_continue_statement_token1] = ACTIONS(1204),
    [aux_sym_break_statement_token1] = ACTIONS(1204),
    [sym_integer] = ACTIONS(1204),
    [aux_sym_return_statement_token1] = ACTIONS(1204),
    [aux_sym_throw_expression_token1] = ACTIONS(1204),
    [aux_sym_while_statement_token1] = ACTIONS(1204),
    [aux_sym_while_statement_token2] = ACTIONS(1204),
    [aux_sym_do_statement_token1] = ACTIONS(1204),
    [aux_sym_for_statement_token1] = ACTIONS(1204),
    [aux_sym_for_statement_token2] = ACTIONS(1204),
    [aux_sym_foreach_statement_token1] = ACTIONS(1204),
    [aux_sym_foreach_statement_token2] = ACTIONS(1204),
    [aux_sym_if_statement_token1] = ACTIONS(1204),
    [aux_sym_if_statement_token2] = ACTIONS(1204),
    [aux_sym_else_if_clause_token1] = ACTIONS(1204),
    [aux_sym_else_clause_token1] = ACTIONS(1204),
    [aux_sym_match_expression_token1] = ACTIONS(1204),
    [aux_sym_match_default_expression_token1] = ACTIONS(1204),
    [aux_sym_switch_statement_token1] = ACTIONS(1204),
    [aux_sym_switch_block_token1] = ACTIONS(1204),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1202),
    [anon_sym_BANG] = ACTIONS(1202),
    [anon_sym_AT] = ACTIONS(1202),
    [aux_sym_clone_expression_token1] = ACTIONS(1204),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1204),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1204),
    [anon_sym_DASH_DASH] = ACTIONS(1202),
    [anon_sym_PLUS_PLUS] = ACTIONS(1202),
    [aux_sym__list_destructing_token1] = ACTIONS(1204),
    [anon_sym_LBRACK] = ACTIONS(1202),
    [anon_sym_self] = ACTIONS(1204),
    [anon_sym_parent] = ACTIONS(1204),
    [aux_sym__argument_name_token1] = ACTIONS(1204),
    [aux_sym__argument_name_token2] = ACTIONS(1204),
    [anon_sym_POUND_LBRACK] = ACTIONS(1202),
    [anon_sym_SQUOTE] = ACTIONS(1202),
    [aux_sym_encapsed_string_token1] = ACTIONS(1202),
    [anon_sym_DQUOTE] = ACTIONS(1202),
    [aux_sym_string_token1] = ACTIONS(1202),
    [anon_sym_LT_LT_LT] = ACTIONS(1202),
    [anon_sym_BQUOTE] = ACTIONS(1202),
    [anon_sym_DOLLAR] = ACTIONS(1202),
    [aux_sym_yield_expression_token1] = ACTIONS(1204),
    [aux_sym_include_expression_token1] = ACTIONS(1204),
    [aux_sym_include_once_expression_token1] = ACTIONS(1204),
    [aux_sym_require_expression_token1] = ACTIONS(1204),
    [aux_sym_require_once_expression_token1] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
  },
  [468] = {
    [ts_builtin_sym_end] = ACTIONS(1206),
    [sym_name] = ACTIONS(1208),
    [anon_sym_QMARK_GT] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1208),
    [aux_sym_global_declaration_token1] = ACTIONS(1208),
    [aux_sym_namespace_definition_token1] = ACTIONS(1208),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1208),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1208),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1208),
    [anon_sym_BSLASH] = ACTIONS(1206),
    [anon_sym_LBRACE] = ACTIONS(1206),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [aux_sym_trait_declaration_token1] = ACTIONS(1208),
    [aux_sym_interface_declaration_token1] = ACTIONS(1208),
    [aux_sym_enum_declaration_token1] = ACTIONS(1208),
    [aux_sym_enum_case_token1] = ACTIONS(1208),
    [aux_sym_class_declaration_token1] = ACTIONS(1208),
    [aux_sym_final_modifier_token1] = ACTIONS(1208),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1208),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1208),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1208),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1208),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1208),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1208),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [aux_sym_cast_type_token1] = ACTIONS(1208),
    [aux_sym_echo_statement_token1] = ACTIONS(1208),
    [anon_sym_unset] = ACTIONS(1208),
    [aux_sym_declare_statement_token1] = ACTIONS(1208),
    [aux_sym_declare_statement_token2] = ACTIONS(1208),
    [sym_float] = ACTIONS(1208),
    [aux_sym_try_statement_token1] = ACTIONS(1208),
    [aux_sym_goto_statement_token1] = ACTIONS(1208),
    [aux_sym_continue_statement_token1] = ACTIONS(1208),
    [aux_sym_break_statement_token1] = ACTIONS(1208),
    [sym_integer] = ACTIONS(1208),
    [aux_sym_return_statement_token1] = ACTIONS(1208),
    [aux_sym_throw_expression_token1] = ACTIONS(1208),
    [aux_sym_while_statement_token1] = ACTIONS(1208),
    [aux_sym_while_statement_token2] = ACTIONS(1208),
    [aux_sym_do_statement_token1] = ACTIONS(1208),
    [aux_sym_for_statement_token1] = ACTIONS(1208),
    [aux_sym_for_statement_token2] = ACTIONS(1208),
    [aux_sym_foreach_statement_token1] = ACTIONS(1208),
    [aux_sym_foreach_statement_token2] = ACTIONS(1208),
    [aux_sym_if_statement_token1] = ACTIONS(1208),
    [aux_sym_if_statement_token2] = ACTIONS(1208),
    [aux_sym_else_if_clause_token1] = ACTIONS(1208),
    [aux_sym_else_clause_token1] = ACTIONS(1208),
    [aux_sym_match_expression_token1] = ACTIONS(1208),
    [aux_sym_match_default_expression_token1] = ACTIONS(1208),
    [aux_sym_switch_statement_token1] = ACTIONS(1208),
    [aux_sym_switch_block_token1] = ACTIONS(1208),
    [anon_sym_PLUS] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1208),
    [anon_sym_TILDE] = ACTIONS(1206),
    [anon_sym_BANG] = ACTIONS(1206),
    [anon_sym_AT] = ACTIONS(1206),
    [aux_sym_clone_expression_token1] = ACTIONS(1208),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1208),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1208),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [aux_sym__list_destructing_token1] = ACTIONS(1208),
    [anon_sym_LBRACK] = ACTIONS(1206),
    [anon_sym_self] = ACTIONS(1208),
    [anon_sym_parent] = ACTIONS(1208),
    [aux_sym__argument_name_token1] = ACTIONS(1208),
    [aux_sym__argument_name_token2] = ACTIONS(1208),
    [anon_sym_POUND_LBRACK] = ACTIONS(1206),
    [anon_sym_SQUOTE] = ACTIONS(1206),
    [aux_sym_encapsed_string_token1] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [aux_sym_string_token1] = ACTIONS(1206),
    [anon_sym_LT_LT_LT] = ACTIONS(1206),
    [anon_sym_BQUOTE] = ACTIONS(1206),
    [anon_sym_DOLLAR] = ACTIONS(1206),
    [aux_sym_yield_expression_token1] = ACTIONS(1208),
    [aux_sym_include_expression_token1] = ACTIONS(1208),
    [aux_sym_include_once_expression_token1] = ACTIONS(1208),
    [aux_sym_require_expression_token1] = ACTIONS(1208),
    [aux_sym_require_once_expression_token1] = ACTIONS(1208),
    [sym_comment] = ACTIONS(3),
  },
  [469] = {
    [ts_builtin_sym_end] = ACTIONS(1210),
    [sym_name] = ACTIONS(1212),
    [anon_sym_QMARK_GT] = ACTIONS(1210),
    [anon_sym_SEMI] = ACTIONS(1210),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1212),
    [aux_sym_global_declaration_token1] = ACTIONS(1212),
    [aux_sym_namespace_definition_token1] = ACTIONS(1212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1212),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1212),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1212),
    [anon_sym_BSLASH] = ACTIONS(1210),
    [anon_sym_LBRACE] = ACTIONS(1210),
    [anon_sym_RBRACE] = ACTIONS(1210),
    [aux_sym_trait_declaration_token1] = ACTIONS(1212),
    [aux_sym_interface_declaration_token1] = ACTIONS(1212),
    [aux_sym_enum_declaration_token1] = ACTIONS(1212),
    [aux_sym_enum_case_token1] = ACTIONS(1212),
    [aux_sym_class_declaration_token1] = ACTIONS(1212),
    [aux_sym_final_modifier_token1] = ACTIONS(1212),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1212),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1212),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1212),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1212),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1212),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1212),
    [anon_sym_LPAREN] = ACTIONS(1210),
    [aux_sym_cast_type_token1] = ACTIONS(1212),
    [aux_sym_echo_statement_token1] = ACTIONS(1212),
    [anon_sym_unset] = ACTIONS(1212),
    [aux_sym_declare_statement_token1] = ACTIONS(1212),
    [aux_sym_declare_statement_token2] = ACTIONS(1212),
    [sym_float] = ACTIONS(1212),
    [aux_sym_try_statement_token1] = ACTIONS(1212),
    [aux_sym_goto_statement_token1] = ACTIONS(1212),
    [aux_sym_continue_statement_token1] = ACTIONS(1212),
    [aux_sym_break_statement_token1] = ACTIONS(1212),
    [sym_integer] = ACTIONS(1212),
    [aux_sym_return_statement_token1] = ACTIONS(1212),
    [aux_sym_throw_expression_token1] = ACTIONS(1212),
    [aux_sym_while_statement_token1] = ACTIONS(1212),
    [aux_sym_while_statement_token2] = ACTIONS(1212),
    [aux_sym_do_statement_token1] = ACTIONS(1212),
    [aux_sym_for_statement_token1] = ACTIONS(1212),
    [aux_sym_for_statement_token2] = ACTIONS(1212),
    [aux_sym_foreach_statement_token1] = ACTIONS(1212),
    [aux_sym_foreach_statement_token2] = ACTIONS(1212),
    [aux_sym_if_statement_token1] = ACTIONS(1212),
    [aux_sym_if_statement_token2] = ACTIONS(1212),
    [aux_sym_else_if_clause_token1] = ACTIONS(1212),
    [aux_sym_else_clause_token1] = ACTIONS(1212),
    [aux_sym_match_expression_token1] = ACTIONS(1212),
    [aux_sym_match_default_expression_token1] = ACTIONS(1212),
    [aux_sym_switch_statement_token1] = ACTIONS(1212),
    [aux_sym_switch_block_token1] = ACTIONS(1212),
    [anon_sym_PLUS] = ACTIONS(1212),
    [anon_sym_DASH] = ACTIONS(1212),
    [anon_sym_TILDE] = ACTIONS(1210),
    [anon_sym_BANG] = ACTIONS(1210),
    [anon_sym_AT] = ACTIONS(1210),
    [aux_sym_clone_expression_token1] = ACTIONS(1212),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1212),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1212),
    [anon_sym_DASH_DASH] = ACTIONS(1210),
    [anon_sym_PLUS_PLUS] = ACTIONS(1210),
    [aux_sym__list_destructing_token1] = ACTIONS(1212),
    [anon_sym_LBRACK] = ACTIONS(1210),
    [anon_sym_self] = ACTIONS(1212),
    [anon_sym_parent] = ACTIONS(1212),
    [aux_sym__argument_name_token1] = ACTIONS(1212),
    [aux_sym__argument_name_token2] = ACTIONS(1212),
    [anon_sym_POUND_LBRACK] = ACTIONS(1210),
    [anon_sym_SQUOTE] = ACTIONS(1210),
    [aux_sym_encapsed_string_token1] = ACTIONS(1210),
    [anon_sym_DQUOTE] = ACTIONS(1210),
    [aux_sym_string_token1] = ACTIONS(1210),
    [anon_sym_LT_LT_LT] = ACTIONS(1210),
    [anon_sym_BQUOTE] = ACTIONS(1210),
    [anon_sym_DOLLAR] = ACTIONS(1210),
    [aux_sym_yield_expression_token1] = ACTIONS(1212),
    [aux_sym_include_expression_token1] = ACTIONS(1212),
    [aux_sym_include_once_expression_token1] = ACTIONS(1212),
    [aux_sym_require_expression_token1] = ACTIONS(1212),
    [aux_sym_require_once_expression_token1] = ACTIONS(1212),
    [sym_comment] = ACTIONS(3),
  },
  [470] = {
    [ts_builtin_sym_end] = ACTIONS(1214),
    [sym_name] = ACTIONS(1216),
    [anon_sym_QMARK_GT] = ACTIONS(1214),
    [anon_sym_SEMI] = ACTIONS(1214),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1216),
    [aux_sym_global_declaration_token1] = ACTIONS(1216),
    [aux_sym_namespace_definition_token1] = ACTIONS(1216),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1216),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1216),
    [anon_sym_BSLASH] = ACTIONS(1214),
    [anon_sym_LBRACE] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [aux_sym_trait_declaration_token1] = ACTIONS(1216),
    [aux_sym_interface_declaration_token1] = ACTIONS(1216),
    [aux_sym_enum_declaration_token1] = ACTIONS(1216),
    [aux_sym_enum_case_token1] = ACTIONS(1216),
    [aux_sym_class_declaration_token1] = ACTIONS(1216),
    [aux_sym_final_modifier_token1] = ACTIONS(1216),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1216),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1216),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1216),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1216),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1216),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1216),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [aux_sym_cast_type_token1] = ACTIONS(1216),
    [aux_sym_echo_statement_token1] = ACTIONS(1216),
    [anon_sym_unset] = ACTIONS(1216),
    [aux_sym_declare_statement_token1] = ACTIONS(1216),
    [aux_sym_declare_statement_token2] = ACTIONS(1216),
    [sym_float] = ACTIONS(1216),
    [aux_sym_try_statement_token1] = ACTIONS(1216),
    [aux_sym_goto_statement_token1] = ACTIONS(1216),
    [aux_sym_continue_statement_token1] = ACTIONS(1216),
    [aux_sym_break_statement_token1] = ACTIONS(1216),
    [sym_integer] = ACTIONS(1216),
    [aux_sym_return_statement_token1] = ACTIONS(1216),
    [aux_sym_throw_expression_token1] = ACTIONS(1216),
    [aux_sym_while_statement_token1] = ACTIONS(1216),
    [aux_sym_while_statement_token2] = ACTIONS(1216),
    [aux_sym_do_statement_token1] = ACTIONS(1216),
    [aux_sym_for_statement_token1] = ACTIONS(1216),
    [aux_sym_for_statement_token2] = ACTIONS(1216),
    [aux_sym_foreach_statement_token1] = ACTIONS(1216),
    [aux_sym_foreach_statement_token2] = ACTIONS(1216),
    [aux_sym_if_statement_token1] = ACTIONS(1216),
    [aux_sym_if_statement_token2] = ACTIONS(1216),
    [aux_sym_else_if_clause_token1] = ACTIONS(1216),
    [aux_sym_else_clause_token1] = ACTIONS(1216),
    [aux_sym_match_expression_token1] = ACTIONS(1216),
    [aux_sym_match_default_expression_token1] = ACTIONS(1216),
    [aux_sym_switch_statement_token1] = ACTIONS(1216),
    [aux_sym_switch_block_token1] = ACTIONS(1216),
    [anon_sym_PLUS] = ACTIONS(1216),
    [anon_sym_DASH] = ACTIONS(1216),
    [anon_sym_TILDE] = ACTIONS(1214),
    [anon_sym_BANG] = ACTIONS(1214),
    [anon_sym_AT] = ACTIONS(1214),
    [aux_sym_clone_expression_token1] = ACTIONS(1216),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1216),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1216),
    [anon_sym_DASH_DASH] = ACTIONS(1214),
    [anon_sym_PLUS_PLUS] = ACTIONS(1214),
    [aux_sym__list_destructing_token1] = ACTIONS(1216),
    [anon_sym_LBRACK] = ACTIONS(1214),
    [anon_sym_self] = ACTIONS(1216),
    [anon_sym_parent] = ACTIONS(1216),
    [aux_sym__argument_name_token1] = ACTIONS(1216),
    [aux_sym__argument_name_token2] = ACTIONS(1216),
    [anon_sym_POUND_LBRACK] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(1214),
    [aux_sym_encapsed_string_token1] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(1214),
    [aux_sym_string_token1] = ACTIONS(1214),
    [anon_sym_LT_LT_LT] = ACTIONS(1214),
    [anon_sym_BQUOTE] = ACTIONS(1214),
    [anon_sym_DOLLAR] = ACTIONS(1214),
    [aux_sym_yield_expression_token1] = ACTIONS(1216),
    [aux_sym_include_expression_token1] = ACTIONS(1216),
    [aux_sym_include_once_expression_token1] = ACTIONS(1216),
    [aux_sym_require_expression_token1] = ACTIONS(1216),
    [aux_sym_require_once_expression_token1] = ACTIONS(1216),
    [sym_comment] = ACTIONS(3),
  },
  [471] = {
    [ts_builtin_sym_end] = ACTIONS(1218),
    [sym_name] = ACTIONS(1220),
    [anon_sym_QMARK_GT] = ACTIONS(1218),
    [anon_sym_SEMI] = ACTIONS(1218),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1220),
    [aux_sym_global_declaration_token1] = ACTIONS(1220),
    [aux_sym_namespace_definition_token1] = ACTIONS(1220),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1220),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1220),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1220),
    [anon_sym_BSLASH] = ACTIONS(1218),
    [anon_sym_LBRACE] = ACTIONS(1218),
    [anon_sym_RBRACE] = ACTIONS(1218),
    [aux_sym_trait_declaration_token1] = ACTIONS(1220),
    [aux_sym_interface_declaration_token1] = ACTIONS(1220),
    [aux_sym_enum_declaration_token1] = ACTIONS(1220),
    [aux_sym_enum_case_token1] = ACTIONS(1220),
    [aux_sym_class_declaration_token1] = ACTIONS(1220),
    [aux_sym_final_modifier_token1] = ACTIONS(1220),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1220),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1220),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1220),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1220),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1218),
    [aux_sym_cast_type_token1] = ACTIONS(1220),
    [aux_sym_echo_statement_token1] = ACTIONS(1220),
    [anon_sym_unset] = ACTIONS(1220),
    [aux_sym_declare_statement_token1] = ACTIONS(1220),
    [aux_sym_declare_statement_token2] = ACTIONS(1220),
    [sym_float] = ACTIONS(1220),
    [aux_sym_try_statement_token1] = ACTIONS(1220),
    [aux_sym_goto_statement_token1] = ACTIONS(1220),
    [aux_sym_continue_statement_token1] = ACTIONS(1220),
    [aux_sym_break_statement_token1] = ACTIONS(1220),
    [sym_integer] = ACTIONS(1220),
    [aux_sym_return_statement_token1] = ACTIONS(1220),
    [aux_sym_throw_expression_token1] = ACTIONS(1220),
    [aux_sym_while_statement_token1] = ACTIONS(1220),
    [aux_sym_while_statement_token2] = ACTIONS(1220),
    [aux_sym_do_statement_token1] = ACTIONS(1220),
    [aux_sym_for_statement_token1] = ACTIONS(1220),
    [aux_sym_for_statement_token2] = ACTIONS(1220),
    [aux_sym_foreach_statement_token1] = ACTIONS(1220),
    [aux_sym_foreach_statement_token2] = ACTIONS(1220),
    [aux_sym_if_statement_token1] = ACTIONS(1220),
    [aux_sym_if_statement_token2] = ACTIONS(1220),
    [aux_sym_else_if_clause_token1] = ACTIONS(1220),
    [aux_sym_else_clause_token1] = ACTIONS(1220),
    [aux_sym_match_expression_token1] = ACTIONS(1220),
    [aux_sym_match_default_expression_token1] = ACTIONS(1220),
    [aux_sym_switch_statement_token1] = ACTIONS(1220),
    [aux_sym_switch_block_token1] = ACTIONS(1220),
    [anon_sym_PLUS] = ACTIONS(1220),
    [anon_sym_DASH] = ACTIONS(1220),
    [anon_sym_TILDE] = ACTIONS(1218),
    [anon_sym_BANG] = ACTIONS(1218),
    [anon_sym_AT] = ACTIONS(1218),
    [aux_sym_clone_expression_token1] = ACTIONS(1220),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1220),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1220),
    [anon_sym_DASH_DASH] = ACTIONS(1218),
    [anon_sym_PLUS_PLUS] = ACTIONS(1218),
    [aux_sym__list_destructing_token1] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_self] = ACTIONS(1220),
    [anon_sym_parent] = ACTIONS(1220),
    [aux_sym__argument_name_token1] = ACTIONS(1220),
    [aux_sym__argument_name_token2] = ACTIONS(1220),
    [anon_sym_POUND_LBRACK] = ACTIONS(1218),
    [anon_sym_SQUOTE] = ACTIONS(1218),
    [aux_sym_encapsed_string_token1] = ACTIONS(1218),
    [anon_sym_DQUOTE] = ACTIONS(1218),
    [aux_sym_string_token1] = ACTIONS(1218),
    [anon_sym_LT_LT_LT] = ACTIONS(1218),
    [anon_sym_BQUOTE] = ACTIONS(1218),
    [anon_sym_DOLLAR] = ACTIONS(1218),
    [aux_sym_yield_expression_token1] = ACTIONS(1220),
    [aux_sym_include_expression_token1] = ACTIONS(1220),
    [aux_sym_include_once_expression_token1] = ACTIONS(1220),
    [aux_sym_require_expression_token1] = ACTIONS(1220),
    [aux_sym_require_once_expression_token1] = ACTIONS(1220),
    [sym_comment] = ACTIONS(3),
  },
  [472] = {
    [ts_builtin_sym_end] = ACTIONS(1222),
    [sym_name] = ACTIONS(1224),
    [anon_sym_QMARK_GT] = ACTIONS(1222),
    [anon_sym_SEMI] = ACTIONS(1222),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1224),
    [aux_sym_global_declaration_token1] = ACTIONS(1224),
    [aux_sym_namespace_definition_token1] = ACTIONS(1224),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1224),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1224),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1224),
    [anon_sym_BSLASH] = ACTIONS(1222),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_RBRACE] = ACTIONS(1222),
    [aux_sym_trait_declaration_token1] = ACTIONS(1224),
    [aux_sym_interface_declaration_token1] = ACTIONS(1224),
    [aux_sym_enum_declaration_token1] = ACTIONS(1224),
    [aux_sym_enum_case_token1] = ACTIONS(1224),
    [aux_sym_class_declaration_token1] = ACTIONS(1224),
    [aux_sym_final_modifier_token1] = ACTIONS(1224),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1224),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1224),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1224),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1224),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1224),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1224),
    [anon_sym_LPAREN] = ACTIONS(1222),
    [aux_sym_cast_type_token1] = ACTIONS(1224),
    [aux_sym_echo_statement_token1] = ACTIONS(1224),
    [anon_sym_unset] = ACTIONS(1224),
    [aux_sym_declare_statement_token1] = ACTIONS(1224),
    [aux_sym_declare_statement_token2] = ACTIONS(1224),
    [sym_float] = ACTIONS(1224),
    [aux_sym_try_statement_token1] = ACTIONS(1224),
    [aux_sym_goto_statement_token1] = ACTIONS(1224),
    [aux_sym_continue_statement_token1] = ACTIONS(1224),
    [aux_sym_break_statement_token1] = ACTIONS(1224),
    [sym_integer] = ACTIONS(1224),
    [aux_sym_return_statement_token1] = ACTIONS(1224),
    [aux_sym_throw_expression_token1] = ACTIONS(1224),
    [aux_sym_while_statement_token1] = ACTIONS(1224),
    [aux_sym_while_statement_token2] = ACTIONS(1224),
    [aux_sym_do_statement_token1] = ACTIONS(1224),
    [aux_sym_for_statement_token1] = ACTIONS(1224),
    [aux_sym_for_statement_token2] = ACTIONS(1224),
    [aux_sym_foreach_statement_token1] = ACTIONS(1224),
    [aux_sym_foreach_statement_token2] = ACTIONS(1224),
    [aux_sym_if_statement_token1] = ACTIONS(1224),
    [aux_sym_if_statement_token2] = ACTIONS(1224),
    [aux_sym_else_if_clause_token1] = ACTIONS(1224),
    [aux_sym_else_clause_token1] = ACTIONS(1224),
    [aux_sym_match_expression_token1] = ACTIONS(1224),
    [aux_sym_match_default_expression_token1] = ACTIONS(1224),
    [aux_sym_switch_statement_token1] = ACTIONS(1224),
    [aux_sym_switch_block_token1] = ACTIONS(1224),
    [anon_sym_PLUS] = ACTIONS(1224),
    [anon_sym_DASH] = ACTIONS(1224),
    [anon_sym_TILDE] = ACTIONS(1222),
    [anon_sym_BANG] = ACTIONS(1222),
    [anon_sym_AT] = ACTIONS(1222),
    [aux_sym_clone_expression_token1] = ACTIONS(1224),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1224),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1224),
    [anon_sym_DASH_DASH] = ACTIONS(1222),
    [anon_sym_PLUS_PLUS] = ACTIONS(1222),
    [aux_sym__list_destructing_token1] = ACTIONS(1224),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [anon_sym_self] = ACTIONS(1224),
    [anon_sym_parent] = ACTIONS(1224),
    [aux_sym__argument_name_token1] = ACTIONS(1224),
    [aux_sym__argument_name_token2] = ACTIONS(1224),
    [anon_sym_POUND_LBRACK] = ACTIONS(1222),
    [anon_sym_SQUOTE] = ACTIONS(1222),
    [aux_sym_encapsed_string_token1] = ACTIONS(1222),
    [anon_sym_DQUOTE] = ACTIONS(1222),
    [aux_sym_string_token1] = ACTIONS(1222),
    [anon_sym_LT_LT_LT] = ACTIONS(1222),
    [anon_sym_BQUOTE] = ACTIONS(1222),
    [anon_sym_DOLLAR] = ACTIONS(1222),
    [aux_sym_yield_expression_token1] = ACTIONS(1224),
    [aux_sym_include_expression_token1] = ACTIONS(1224),
    [aux_sym_include_once_expression_token1] = ACTIONS(1224),
    [aux_sym_require_expression_token1] = ACTIONS(1224),
    [aux_sym_require_once_expression_token1] = ACTIONS(1224),
    [sym_comment] = ACTIONS(3),
  },
  [473] = {
    [ts_builtin_sym_end] = ACTIONS(1226),
    [sym_name] = ACTIONS(1228),
    [anon_sym_QMARK_GT] = ACTIONS(1226),
    [anon_sym_SEMI] = ACTIONS(1226),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1228),
    [aux_sym_global_declaration_token1] = ACTIONS(1228),
    [aux_sym_namespace_definition_token1] = ACTIONS(1228),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1228),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1228),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1228),
    [anon_sym_BSLASH] = ACTIONS(1226),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_RBRACE] = ACTIONS(1226),
    [aux_sym_trait_declaration_token1] = ACTIONS(1228),
    [aux_sym_interface_declaration_token1] = ACTIONS(1228),
    [aux_sym_enum_declaration_token1] = ACTIONS(1228),
    [aux_sym_enum_case_token1] = ACTIONS(1228),
    [aux_sym_class_declaration_token1] = ACTIONS(1228),
    [aux_sym_final_modifier_token1] = ACTIONS(1228),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1228),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1228),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1228),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1228),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1228),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [aux_sym_cast_type_token1] = ACTIONS(1228),
    [aux_sym_echo_statement_token1] = ACTIONS(1228),
    [anon_sym_unset] = ACTIONS(1228),
    [aux_sym_declare_statement_token1] = ACTIONS(1228),
    [aux_sym_declare_statement_token2] = ACTIONS(1228),
    [sym_float] = ACTIONS(1228),
    [aux_sym_try_statement_token1] = ACTIONS(1228),
    [aux_sym_goto_statement_token1] = ACTIONS(1228),
    [aux_sym_continue_statement_token1] = ACTIONS(1228),
    [aux_sym_break_statement_token1] = ACTIONS(1228),
    [sym_integer] = ACTIONS(1228),
    [aux_sym_return_statement_token1] = ACTIONS(1228),
    [aux_sym_throw_expression_token1] = ACTIONS(1228),
    [aux_sym_while_statement_token1] = ACTIONS(1228),
    [aux_sym_while_statement_token2] = ACTIONS(1228),
    [aux_sym_do_statement_token1] = ACTIONS(1228),
    [aux_sym_for_statement_token1] = ACTIONS(1228),
    [aux_sym_for_statement_token2] = ACTIONS(1228),
    [aux_sym_foreach_statement_token1] = ACTIONS(1228),
    [aux_sym_foreach_statement_token2] = ACTIONS(1228),
    [aux_sym_if_statement_token1] = ACTIONS(1228),
    [aux_sym_if_statement_token2] = ACTIONS(1228),
    [aux_sym_else_if_clause_token1] = ACTIONS(1228),
    [aux_sym_else_clause_token1] = ACTIONS(1228),
    [aux_sym_match_expression_token1] = ACTIONS(1228),
    [aux_sym_match_default_expression_token1] = ACTIONS(1228),
    [aux_sym_switch_statement_token1] = ACTIONS(1228),
    [aux_sym_switch_block_token1] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(1228),
    [anon_sym_DASH] = ACTIONS(1228),
    [anon_sym_TILDE] = ACTIONS(1226),
    [anon_sym_BANG] = ACTIONS(1226),
    [anon_sym_AT] = ACTIONS(1226),
    [aux_sym_clone_expression_token1] = ACTIONS(1228),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1228),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1228),
    [anon_sym_DASH_DASH] = ACTIONS(1226),
    [anon_sym_PLUS_PLUS] = ACTIONS(1226),
    [aux_sym__list_destructing_token1] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_self] = ACTIONS(1228),
    [anon_sym_parent] = ACTIONS(1228),
    [aux_sym__argument_name_token1] = ACTIONS(1228),
    [aux_sym__argument_name_token2] = ACTIONS(1228),
    [anon_sym_POUND_LBRACK] = ACTIONS(1226),
    [anon_sym_SQUOTE] = ACTIONS(1226),
    [aux_sym_encapsed_string_token1] = ACTIONS(1226),
    [anon_sym_DQUOTE] = ACTIONS(1226),
    [aux_sym_string_token1] = ACTIONS(1226),
    [anon_sym_LT_LT_LT] = ACTIONS(1226),
    [anon_sym_BQUOTE] = ACTIONS(1226),
    [anon_sym_DOLLAR] = ACTIONS(1226),
    [aux_sym_yield_expression_token1] = ACTIONS(1228),
    [aux_sym_include_expression_token1] = ACTIONS(1228),
    [aux_sym_include_once_expression_token1] = ACTIONS(1228),
    [aux_sym_require_expression_token1] = ACTIONS(1228),
    [aux_sym_require_once_expression_token1] = ACTIONS(1228),
    [sym_comment] = ACTIONS(3),
  },
  [474] = {
    [ts_builtin_sym_end] = ACTIONS(1062),
    [sym_name] = ACTIONS(1064),
    [anon_sym_QMARK_GT] = ACTIONS(1062),
    [anon_sym_SEMI] = ACTIONS(1062),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1064),
    [aux_sym_global_declaration_token1] = ACTIONS(1064),
    [aux_sym_namespace_definition_token1] = ACTIONS(1064),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1064),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1064),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1064),
    [anon_sym_BSLASH] = ACTIONS(1062),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_RBRACE] = ACTIONS(1062),
    [aux_sym_trait_declaration_token1] = ACTIONS(1064),
    [aux_sym_interface_declaration_token1] = ACTIONS(1064),
    [aux_sym_enum_declaration_token1] = ACTIONS(1064),
    [aux_sym_enum_case_token1] = ACTIONS(1064),
    [aux_sym_class_declaration_token1] = ACTIONS(1064),
    [aux_sym_final_modifier_token1] = ACTIONS(1064),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1064),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1064),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1064),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1064),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1064),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [aux_sym_cast_type_token1] = ACTIONS(1064),
    [aux_sym_echo_statement_token1] = ACTIONS(1064),
    [anon_sym_unset] = ACTIONS(1064),
    [aux_sym_declare_statement_token1] = ACTIONS(1064),
    [aux_sym_declare_statement_token2] = ACTIONS(1064),
    [sym_float] = ACTIONS(1064),
    [aux_sym_try_statement_token1] = ACTIONS(1064),
    [aux_sym_goto_statement_token1] = ACTIONS(1064),
    [aux_sym_continue_statement_token1] = ACTIONS(1064),
    [aux_sym_break_statement_token1] = ACTIONS(1064),
    [sym_integer] = ACTIONS(1064),
    [aux_sym_return_statement_token1] = ACTIONS(1064),
    [aux_sym_throw_expression_token1] = ACTIONS(1064),
    [aux_sym_while_statement_token1] = ACTIONS(1064),
    [aux_sym_while_statement_token2] = ACTIONS(1064),
    [aux_sym_do_statement_token1] = ACTIONS(1064),
    [aux_sym_for_statement_token1] = ACTIONS(1064),
    [aux_sym_for_statement_token2] = ACTIONS(1064),
    [aux_sym_foreach_statement_token1] = ACTIONS(1064),
    [aux_sym_foreach_statement_token2] = ACTIONS(1064),
    [aux_sym_if_statement_token1] = ACTIONS(1064),
    [aux_sym_if_statement_token2] = ACTIONS(1064),
    [aux_sym_else_if_clause_token1] = ACTIONS(1064),
    [aux_sym_else_clause_token1] = ACTIONS(1064),
    [aux_sym_match_expression_token1] = ACTIONS(1064),
    [aux_sym_match_default_expression_token1] = ACTIONS(1064),
    [aux_sym_switch_statement_token1] = ACTIONS(1064),
    [aux_sym_switch_block_token1] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_BANG] = ACTIONS(1062),
    [anon_sym_AT] = ACTIONS(1062),
    [aux_sym_clone_expression_token1] = ACTIONS(1064),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1064),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1064),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [aux_sym__list_destructing_token1] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1062),
    [anon_sym_self] = ACTIONS(1064),
    [anon_sym_parent] = ACTIONS(1064),
    [aux_sym__argument_name_token1] = ACTIONS(1064),
    [aux_sym__argument_name_token2] = ACTIONS(1064),
    [anon_sym_POUND_LBRACK] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [aux_sym_encapsed_string_token1] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [aux_sym_string_token1] = ACTIONS(1062),
    [anon_sym_LT_LT_LT] = ACTIONS(1062),
    [anon_sym_BQUOTE] = ACTIONS(1062),
    [anon_sym_DOLLAR] = ACTIONS(1062),
    [aux_sym_yield_expression_token1] = ACTIONS(1064),
    [aux_sym_include_expression_token1] = ACTIONS(1064),
    [aux_sym_include_once_expression_token1] = ACTIONS(1064),
    [aux_sym_require_expression_token1] = ACTIONS(1064),
    [aux_sym_require_once_expression_token1] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
  },
  [475] = {
    [ts_builtin_sym_end] = ACTIONS(1230),
    [sym_name] = ACTIONS(1232),
    [anon_sym_QMARK_GT] = ACTIONS(1230),
    [anon_sym_SEMI] = ACTIONS(1230),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1232),
    [aux_sym_global_declaration_token1] = ACTIONS(1232),
    [aux_sym_namespace_definition_token1] = ACTIONS(1232),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1232),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1232),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1232),
    [anon_sym_BSLASH] = ACTIONS(1230),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1230),
    [aux_sym_trait_declaration_token1] = ACTIONS(1232),
    [aux_sym_interface_declaration_token1] = ACTIONS(1232),
    [aux_sym_enum_declaration_token1] = ACTIONS(1232),
    [aux_sym_enum_case_token1] = ACTIONS(1232),
    [aux_sym_class_declaration_token1] = ACTIONS(1232),
    [aux_sym_final_modifier_token1] = ACTIONS(1232),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1232),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1232),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1232),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1232),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1232),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [aux_sym_cast_type_token1] = ACTIONS(1232),
    [aux_sym_echo_statement_token1] = ACTIONS(1232),
    [anon_sym_unset] = ACTIONS(1232),
    [aux_sym_declare_statement_token1] = ACTIONS(1232),
    [aux_sym_declare_statement_token2] = ACTIONS(1232),
    [sym_float] = ACTIONS(1232),
    [aux_sym_try_statement_token1] = ACTIONS(1232),
    [aux_sym_goto_statement_token1] = ACTIONS(1232),
    [aux_sym_continue_statement_token1] = ACTIONS(1232),
    [aux_sym_break_statement_token1] = ACTIONS(1232),
    [sym_integer] = ACTIONS(1232),
    [aux_sym_return_statement_token1] = ACTIONS(1232),
    [aux_sym_throw_expression_token1] = ACTIONS(1232),
    [aux_sym_while_statement_token1] = ACTIONS(1232),
    [aux_sym_while_statement_token2] = ACTIONS(1232),
    [aux_sym_do_statement_token1] = ACTIONS(1232),
    [aux_sym_for_statement_token1] = ACTIONS(1232),
    [aux_sym_for_statement_token2] = ACTIONS(1232),
    [aux_sym_foreach_statement_token1] = ACTIONS(1232),
    [aux_sym_foreach_statement_token2] = ACTIONS(1232),
    [aux_sym_if_statement_token1] = ACTIONS(1232),
    [aux_sym_if_statement_token2] = ACTIONS(1232),
    [aux_sym_else_if_clause_token1] = ACTIONS(1232),
    [aux_sym_else_clause_token1] = ACTIONS(1232),
    [aux_sym_match_expression_token1] = ACTIONS(1232),
    [aux_sym_match_default_expression_token1] = ACTIONS(1232),
    [aux_sym_switch_statement_token1] = ACTIONS(1232),
    [aux_sym_switch_block_token1] = ACTIONS(1232),
    [anon_sym_PLUS] = ACTIONS(1232),
    [anon_sym_DASH] = ACTIONS(1232),
    [anon_sym_TILDE] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(1230),
    [aux_sym_clone_expression_token1] = ACTIONS(1232),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1232),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1232),
    [anon_sym_DASH_DASH] = ACTIONS(1230),
    [anon_sym_PLUS_PLUS] = ACTIONS(1230),
    [aux_sym__list_destructing_token1] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1230),
    [anon_sym_self] = ACTIONS(1232),
    [anon_sym_parent] = ACTIONS(1232),
    [aux_sym__argument_name_token1] = ACTIONS(1232),
    [aux_sym__argument_name_token2] = ACTIONS(1232),
    [anon_sym_POUND_LBRACK] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(1230),
    [aux_sym_encapsed_string_token1] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(1230),
    [aux_sym_string_token1] = ACTIONS(1230),
    [anon_sym_LT_LT_LT] = ACTIONS(1230),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [anon_sym_DOLLAR] = ACTIONS(1230),
    [aux_sym_yield_expression_token1] = ACTIONS(1232),
    [aux_sym_include_expression_token1] = ACTIONS(1232),
    [aux_sym_include_once_expression_token1] = ACTIONS(1232),
    [aux_sym_require_expression_token1] = ACTIONS(1232),
    [aux_sym_require_once_expression_token1] = ACTIONS(1232),
    [sym_comment] = ACTIONS(3),
  },
  [476] = {
    [ts_builtin_sym_end] = ACTIONS(1234),
    [sym_name] = ACTIONS(1236),
    [anon_sym_QMARK_GT] = ACTIONS(1234),
    [anon_sym_SEMI] = ACTIONS(1234),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1236),
    [aux_sym_global_declaration_token1] = ACTIONS(1236),
    [aux_sym_namespace_definition_token1] = ACTIONS(1236),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1236),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1236),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1236),
    [anon_sym_BSLASH] = ACTIONS(1234),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_RBRACE] = ACTIONS(1234),
    [aux_sym_trait_declaration_token1] = ACTIONS(1236),
    [aux_sym_interface_declaration_token1] = ACTIONS(1236),
    [aux_sym_enum_declaration_token1] = ACTIONS(1236),
    [aux_sym_enum_case_token1] = ACTIONS(1236),
    [aux_sym_class_declaration_token1] = ACTIONS(1236),
    [aux_sym_final_modifier_token1] = ACTIONS(1236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1236),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1236),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1236),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1236),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1236),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [aux_sym_cast_type_token1] = ACTIONS(1236),
    [aux_sym_echo_statement_token1] = ACTIONS(1236),
    [anon_sym_unset] = ACTIONS(1236),
    [aux_sym_declare_statement_token1] = ACTIONS(1236),
    [aux_sym_declare_statement_token2] = ACTIONS(1236),
    [sym_float] = ACTIONS(1236),
    [aux_sym_try_statement_token1] = ACTIONS(1236),
    [aux_sym_goto_statement_token1] = ACTIONS(1236),
    [aux_sym_continue_statement_token1] = ACTIONS(1236),
    [aux_sym_break_statement_token1] = ACTIONS(1236),
    [sym_integer] = ACTIONS(1236),
    [aux_sym_return_statement_token1] = ACTIONS(1236),
    [aux_sym_throw_expression_token1] = ACTIONS(1236),
    [aux_sym_while_statement_token1] = ACTIONS(1236),
    [aux_sym_while_statement_token2] = ACTIONS(1236),
    [aux_sym_do_statement_token1] = ACTIONS(1236),
    [aux_sym_for_statement_token1] = ACTIONS(1236),
    [aux_sym_for_statement_token2] = ACTIONS(1236),
    [aux_sym_foreach_statement_token1] = ACTIONS(1236),
    [aux_sym_foreach_statement_token2] = ACTIONS(1236),
    [aux_sym_if_statement_token1] = ACTIONS(1236),
    [aux_sym_if_statement_token2] = ACTIONS(1236),
    [aux_sym_else_if_clause_token1] = ACTIONS(1236),
    [aux_sym_else_clause_token1] = ACTIONS(1236),
    [aux_sym_match_expression_token1] = ACTIONS(1236),
    [aux_sym_match_default_expression_token1] = ACTIONS(1236),
    [aux_sym_switch_statement_token1] = ACTIONS(1236),
    [aux_sym_switch_block_token1] = ACTIONS(1236),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_TILDE] = ACTIONS(1234),
    [anon_sym_BANG] = ACTIONS(1234),
    [anon_sym_AT] = ACTIONS(1234),
    [aux_sym_clone_expression_token1] = ACTIONS(1236),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1236),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1236),
    [anon_sym_DASH_DASH] = ACTIONS(1234),
    [anon_sym_PLUS_PLUS] = ACTIONS(1234),
    [aux_sym__list_destructing_token1] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(1234),
    [anon_sym_self] = ACTIONS(1236),
    [anon_sym_parent] = ACTIONS(1236),
    [aux_sym__argument_name_token1] = ACTIONS(1236),
    [aux_sym__argument_name_token2] = ACTIONS(1236),
    [anon_sym_POUND_LBRACK] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(1234),
    [aux_sym_encapsed_string_token1] = ACTIONS(1234),
    [anon_sym_DQUOTE] = ACTIONS(1234),
    [aux_sym_string_token1] = ACTIONS(1234),
    [anon_sym_LT_LT_LT] = ACTIONS(1234),
    [anon_sym_BQUOTE] = ACTIONS(1234),
    [anon_sym_DOLLAR] = ACTIONS(1234),
    [aux_sym_yield_expression_token1] = ACTIONS(1236),
    [aux_sym_include_expression_token1] = ACTIONS(1236),
    [aux_sym_include_once_expression_token1] = ACTIONS(1236),
    [aux_sym_require_expression_token1] = ACTIONS(1236),
    [aux_sym_require_once_expression_token1] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
  },
  [477] = {
    [ts_builtin_sym_end] = ACTIONS(1238),
    [sym_name] = ACTIONS(1240),
    [anon_sym_QMARK_GT] = ACTIONS(1238),
    [anon_sym_SEMI] = ACTIONS(1238),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1240),
    [aux_sym_global_declaration_token1] = ACTIONS(1240),
    [aux_sym_namespace_definition_token1] = ACTIONS(1240),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1240),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1240),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1240),
    [anon_sym_BSLASH] = ACTIONS(1238),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_RBRACE] = ACTIONS(1238),
    [aux_sym_trait_declaration_token1] = ACTIONS(1240),
    [aux_sym_interface_declaration_token1] = ACTIONS(1240),
    [aux_sym_enum_declaration_token1] = ACTIONS(1240),
    [aux_sym_enum_case_token1] = ACTIONS(1240),
    [aux_sym_class_declaration_token1] = ACTIONS(1240),
    [aux_sym_final_modifier_token1] = ACTIONS(1240),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1240),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1240),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1240),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1240),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1238),
    [aux_sym_cast_type_token1] = ACTIONS(1240),
    [aux_sym_echo_statement_token1] = ACTIONS(1240),
    [anon_sym_unset] = ACTIONS(1240),
    [aux_sym_declare_statement_token1] = ACTIONS(1240),
    [aux_sym_declare_statement_token2] = ACTIONS(1240),
    [sym_float] = ACTIONS(1240),
    [aux_sym_try_statement_token1] = ACTIONS(1240),
    [aux_sym_goto_statement_token1] = ACTIONS(1240),
    [aux_sym_continue_statement_token1] = ACTIONS(1240),
    [aux_sym_break_statement_token1] = ACTIONS(1240),
    [sym_integer] = ACTIONS(1240),
    [aux_sym_return_statement_token1] = ACTIONS(1240),
    [aux_sym_throw_expression_token1] = ACTIONS(1240),
    [aux_sym_while_statement_token1] = ACTIONS(1240),
    [aux_sym_while_statement_token2] = ACTIONS(1240),
    [aux_sym_do_statement_token1] = ACTIONS(1240),
    [aux_sym_for_statement_token1] = ACTIONS(1240),
    [aux_sym_for_statement_token2] = ACTIONS(1240),
    [aux_sym_foreach_statement_token1] = ACTIONS(1240),
    [aux_sym_foreach_statement_token2] = ACTIONS(1240),
    [aux_sym_if_statement_token1] = ACTIONS(1240),
    [aux_sym_if_statement_token2] = ACTIONS(1240),
    [aux_sym_else_if_clause_token1] = ACTIONS(1240),
    [aux_sym_else_clause_token1] = ACTIONS(1240),
    [aux_sym_match_expression_token1] = ACTIONS(1240),
    [aux_sym_match_default_expression_token1] = ACTIONS(1240),
    [aux_sym_switch_statement_token1] = ACTIONS(1240),
    [aux_sym_switch_block_token1] = ACTIONS(1240),
    [anon_sym_PLUS] = ACTIONS(1240),
    [anon_sym_DASH] = ACTIONS(1240),
    [anon_sym_TILDE] = ACTIONS(1238),
    [anon_sym_BANG] = ACTIONS(1238),
    [anon_sym_AT] = ACTIONS(1238),
    [aux_sym_clone_expression_token1] = ACTIONS(1240),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1240),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1240),
    [anon_sym_DASH_DASH] = ACTIONS(1238),
    [anon_sym_PLUS_PLUS] = ACTIONS(1238),
    [aux_sym__list_destructing_token1] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [anon_sym_self] = ACTIONS(1240),
    [anon_sym_parent] = ACTIONS(1240),
    [aux_sym__argument_name_token1] = ACTIONS(1240),
    [aux_sym__argument_name_token2] = ACTIONS(1240),
    [anon_sym_POUND_LBRACK] = ACTIONS(1238),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [aux_sym_encapsed_string_token1] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1238),
    [aux_sym_string_token1] = ACTIONS(1238),
    [anon_sym_LT_LT_LT] = ACTIONS(1238),
    [anon_sym_BQUOTE] = ACTIONS(1238),
    [anon_sym_DOLLAR] = ACTIONS(1238),
    [aux_sym_yield_expression_token1] = ACTIONS(1240),
    [aux_sym_include_expression_token1] = ACTIONS(1240),
    [aux_sym_include_once_expression_token1] = ACTIONS(1240),
    [aux_sym_require_expression_token1] = ACTIONS(1240),
    [aux_sym_require_once_expression_token1] = ACTIONS(1240),
    [sym_comment] = ACTIONS(3),
  },
  [478] = {
    [ts_builtin_sym_end] = ACTIONS(1242),
    [sym_name] = ACTIONS(1244),
    [anon_sym_QMARK_GT] = ACTIONS(1242),
    [anon_sym_SEMI] = ACTIONS(1242),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1244),
    [aux_sym_global_declaration_token1] = ACTIONS(1244),
    [aux_sym_namespace_definition_token1] = ACTIONS(1244),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1244),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1244),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1244),
    [anon_sym_BSLASH] = ACTIONS(1242),
    [anon_sym_LBRACE] = ACTIONS(1242),
    [anon_sym_RBRACE] = ACTIONS(1242),
    [aux_sym_trait_declaration_token1] = ACTIONS(1244),
    [aux_sym_interface_declaration_token1] = ACTIONS(1244),
    [aux_sym_enum_declaration_token1] = ACTIONS(1244),
    [aux_sym_enum_case_token1] = ACTIONS(1244),
    [aux_sym_class_declaration_token1] = ACTIONS(1244),
    [aux_sym_final_modifier_token1] = ACTIONS(1244),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1244),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1244),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1244),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1244),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1244),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1242),
    [aux_sym_cast_type_token1] = ACTIONS(1244),
    [aux_sym_echo_statement_token1] = ACTIONS(1244),
    [anon_sym_unset] = ACTIONS(1244),
    [aux_sym_declare_statement_token1] = ACTIONS(1244),
    [aux_sym_declare_statement_token2] = ACTIONS(1244),
    [sym_float] = ACTIONS(1244),
    [aux_sym_try_statement_token1] = ACTIONS(1244),
    [aux_sym_goto_statement_token1] = ACTIONS(1244),
    [aux_sym_continue_statement_token1] = ACTIONS(1244),
    [aux_sym_break_statement_token1] = ACTIONS(1244),
    [sym_integer] = ACTIONS(1244),
    [aux_sym_return_statement_token1] = ACTIONS(1244),
    [aux_sym_throw_expression_token1] = ACTIONS(1244),
    [aux_sym_while_statement_token1] = ACTIONS(1244),
    [aux_sym_while_statement_token2] = ACTIONS(1244),
    [aux_sym_do_statement_token1] = ACTIONS(1244),
    [aux_sym_for_statement_token1] = ACTIONS(1244),
    [aux_sym_for_statement_token2] = ACTIONS(1244),
    [aux_sym_foreach_statement_token1] = ACTIONS(1244),
    [aux_sym_foreach_statement_token2] = ACTIONS(1244),
    [aux_sym_if_statement_token1] = ACTIONS(1244),
    [aux_sym_if_statement_token2] = ACTIONS(1244),
    [aux_sym_else_if_clause_token1] = ACTIONS(1244),
    [aux_sym_else_clause_token1] = ACTIONS(1244),
    [aux_sym_match_expression_token1] = ACTIONS(1244),
    [aux_sym_match_default_expression_token1] = ACTIONS(1244),
    [aux_sym_switch_statement_token1] = ACTIONS(1244),
    [aux_sym_switch_block_token1] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(1244),
    [anon_sym_TILDE] = ACTIONS(1242),
    [anon_sym_BANG] = ACTIONS(1242),
    [anon_sym_AT] = ACTIONS(1242),
    [aux_sym_clone_expression_token1] = ACTIONS(1244),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1244),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1244),
    [anon_sym_DASH_DASH] = ACTIONS(1242),
    [anon_sym_PLUS_PLUS] = ACTIONS(1242),
    [aux_sym__list_destructing_token1] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_self] = ACTIONS(1244),
    [anon_sym_parent] = ACTIONS(1244),
    [aux_sym__argument_name_token1] = ACTIONS(1244),
    [aux_sym__argument_name_token2] = ACTIONS(1244),
    [anon_sym_POUND_LBRACK] = ACTIONS(1242),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [aux_sym_encapsed_string_token1] = ACTIONS(1242),
    [anon_sym_DQUOTE] = ACTIONS(1242),
    [aux_sym_string_token1] = ACTIONS(1242),
    [anon_sym_LT_LT_LT] = ACTIONS(1242),
    [anon_sym_BQUOTE] = ACTIONS(1242),
    [anon_sym_DOLLAR] = ACTIONS(1242),
    [aux_sym_yield_expression_token1] = ACTIONS(1244),
    [aux_sym_include_expression_token1] = ACTIONS(1244),
    [aux_sym_include_once_expression_token1] = ACTIONS(1244),
    [aux_sym_require_expression_token1] = ACTIONS(1244),
    [aux_sym_require_once_expression_token1] = ACTIONS(1244),
    [sym_comment] = ACTIONS(3),
  },
  [479] = {
    [ts_builtin_sym_end] = ACTIONS(1246),
    [sym_name] = ACTIONS(1248),
    [anon_sym_QMARK_GT] = ACTIONS(1246),
    [anon_sym_SEMI] = ACTIONS(1246),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1248),
    [aux_sym_global_declaration_token1] = ACTIONS(1248),
    [aux_sym_namespace_definition_token1] = ACTIONS(1248),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1248),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1248),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1248),
    [anon_sym_BSLASH] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(1246),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [aux_sym_trait_declaration_token1] = ACTIONS(1248),
    [aux_sym_interface_declaration_token1] = ACTIONS(1248),
    [aux_sym_enum_declaration_token1] = ACTIONS(1248),
    [aux_sym_enum_case_token1] = ACTIONS(1248),
    [aux_sym_class_declaration_token1] = ACTIONS(1248),
    [aux_sym_final_modifier_token1] = ACTIONS(1248),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1248),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1248),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1248),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1248),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1248),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [aux_sym_cast_type_token1] = ACTIONS(1248),
    [aux_sym_echo_statement_token1] = ACTIONS(1248),
    [anon_sym_unset] = ACTIONS(1248),
    [aux_sym_declare_statement_token1] = ACTIONS(1248),
    [aux_sym_declare_statement_token2] = ACTIONS(1248),
    [sym_float] = ACTIONS(1248),
    [aux_sym_try_statement_token1] = ACTIONS(1248),
    [aux_sym_goto_statement_token1] = ACTIONS(1248),
    [aux_sym_continue_statement_token1] = ACTIONS(1248),
    [aux_sym_break_statement_token1] = ACTIONS(1248),
    [sym_integer] = ACTIONS(1248),
    [aux_sym_return_statement_token1] = ACTIONS(1248),
    [aux_sym_throw_expression_token1] = ACTIONS(1248),
    [aux_sym_while_statement_token1] = ACTIONS(1248),
    [aux_sym_while_statement_token2] = ACTIONS(1248),
    [aux_sym_do_statement_token1] = ACTIONS(1248),
    [aux_sym_for_statement_token1] = ACTIONS(1248),
    [aux_sym_for_statement_token2] = ACTIONS(1248),
    [aux_sym_foreach_statement_token1] = ACTIONS(1248),
    [aux_sym_foreach_statement_token2] = ACTIONS(1248),
    [aux_sym_if_statement_token1] = ACTIONS(1248),
    [aux_sym_if_statement_token2] = ACTIONS(1248),
    [aux_sym_else_if_clause_token1] = ACTIONS(1248),
    [aux_sym_else_clause_token1] = ACTIONS(1248),
    [aux_sym_match_expression_token1] = ACTIONS(1248),
    [aux_sym_match_default_expression_token1] = ACTIONS(1248),
    [aux_sym_switch_statement_token1] = ACTIONS(1248),
    [aux_sym_switch_block_token1] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1248),
    [anon_sym_TILDE] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(1246),
    [aux_sym_clone_expression_token1] = ACTIONS(1248),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1248),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1248),
    [anon_sym_DASH_DASH] = ACTIONS(1246),
    [anon_sym_PLUS_PLUS] = ACTIONS(1246),
    [aux_sym__list_destructing_token1] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1246),
    [anon_sym_self] = ACTIONS(1248),
    [anon_sym_parent] = ACTIONS(1248),
    [aux_sym__argument_name_token1] = ACTIONS(1248),
    [aux_sym__argument_name_token2] = ACTIONS(1248),
    [anon_sym_POUND_LBRACK] = ACTIONS(1246),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [aux_sym_encapsed_string_token1] = ACTIONS(1246),
    [anon_sym_DQUOTE] = ACTIONS(1246),
    [aux_sym_string_token1] = ACTIONS(1246),
    [anon_sym_LT_LT_LT] = ACTIONS(1246),
    [anon_sym_BQUOTE] = ACTIONS(1246),
    [anon_sym_DOLLAR] = ACTIONS(1246),
    [aux_sym_yield_expression_token1] = ACTIONS(1248),
    [aux_sym_include_expression_token1] = ACTIONS(1248),
    [aux_sym_include_once_expression_token1] = ACTIONS(1248),
    [aux_sym_require_expression_token1] = ACTIONS(1248),
    [aux_sym_require_once_expression_token1] = ACTIONS(1248),
    [sym_comment] = ACTIONS(3),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(1246),
    [sym_name] = ACTIONS(1248),
    [anon_sym_QMARK_GT] = ACTIONS(1246),
    [anon_sym_SEMI] = ACTIONS(1246),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1248),
    [aux_sym_global_declaration_token1] = ACTIONS(1248),
    [aux_sym_namespace_definition_token1] = ACTIONS(1248),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1248),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1248),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1248),
    [anon_sym_BSLASH] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(1246),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [aux_sym_trait_declaration_token1] = ACTIONS(1248),
    [aux_sym_interface_declaration_token1] = ACTIONS(1248),
    [aux_sym_enum_declaration_token1] = ACTIONS(1248),
    [aux_sym_enum_case_token1] = ACTIONS(1248),
    [aux_sym_class_declaration_token1] = ACTIONS(1248),
    [aux_sym_final_modifier_token1] = ACTIONS(1248),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1248),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1248),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1248),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1248),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1248),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [aux_sym_cast_type_token1] = ACTIONS(1248),
    [aux_sym_echo_statement_token1] = ACTIONS(1248),
    [anon_sym_unset] = ACTIONS(1248),
    [aux_sym_declare_statement_token1] = ACTIONS(1248),
    [aux_sym_declare_statement_token2] = ACTIONS(1248),
    [sym_float] = ACTIONS(1248),
    [aux_sym_try_statement_token1] = ACTIONS(1248),
    [aux_sym_goto_statement_token1] = ACTIONS(1248),
    [aux_sym_continue_statement_token1] = ACTIONS(1248),
    [aux_sym_break_statement_token1] = ACTIONS(1248),
    [sym_integer] = ACTIONS(1248),
    [aux_sym_return_statement_token1] = ACTIONS(1248),
    [aux_sym_throw_expression_token1] = ACTIONS(1248),
    [aux_sym_while_statement_token1] = ACTIONS(1248),
    [aux_sym_while_statement_token2] = ACTIONS(1248),
    [aux_sym_do_statement_token1] = ACTIONS(1248),
    [aux_sym_for_statement_token1] = ACTIONS(1248),
    [aux_sym_for_statement_token2] = ACTIONS(1248),
    [aux_sym_foreach_statement_token1] = ACTIONS(1248),
    [aux_sym_foreach_statement_token2] = ACTIONS(1248),
    [aux_sym_if_statement_token1] = ACTIONS(1248),
    [aux_sym_if_statement_token2] = ACTIONS(1248),
    [aux_sym_else_if_clause_token1] = ACTIONS(1248),
    [aux_sym_else_clause_token1] = ACTIONS(1248),
    [aux_sym_match_expression_token1] = ACTIONS(1248),
    [aux_sym_match_default_expression_token1] = ACTIONS(1248),
    [aux_sym_switch_statement_token1] = ACTIONS(1248),
    [aux_sym_switch_block_token1] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1248),
    [anon_sym_TILDE] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(1246),
    [aux_sym_clone_expression_token1] = ACTIONS(1248),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1248),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1248),
    [anon_sym_DASH_DASH] = ACTIONS(1246),
    [anon_sym_PLUS_PLUS] = ACTIONS(1246),
    [aux_sym__list_destructing_token1] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1246),
    [anon_sym_self] = ACTIONS(1248),
    [anon_sym_parent] = ACTIONS(1248),
    [aux_sym__argument_name_token1] = ACTIONS(1248),
    [aux_sym__argument_name_token2] = ACTIONS(1248),
    [anon_sym_POUND_LBRACK] = ACTIONS(1246),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [aux_sym_encapsed_string_token1] = ACTIONS(1246),
    [anon_sym_DQUOTE] = ACTIONS(1246),
    [aux_sym_string_token1] = ACTIONS(1246),
    [anon_sym_LT_LT_LT] = ACTIONS(1246),
    [anon_sym_BQUOTE] = ACTIONS(1246),
    [anon_sym_DOLLAR] = ACTIONS(1246),
    [aux_sym_yield_expression_token1] = ACTIONS(1248),
    [aux_sym_include_expression_token1] = ACTIONS(1248),
    [aux_sym_include_once_expression_token1] = ACTIONS(1248),
    [aux_sym_require_expression_token1] = ACTIONS(1248),
    [aux_sym_require_once_expression_token1] = ACTIONS(1248),
    [sym_comment] = ACTIONS(3),
  },
  [481] = {
    [ts_builtin_sym_end] = ACTIONS(1250),
    [sym_name] = ACTIONS(1252),
    [anon_sym_QMARK_GT] = ACTIONS(1250),
    [anon_sym_SEMI] = ACTIONS(1250),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1252),
    [aux_sym_global_declaration_token1] = ACTIONS(1252),
    [aux_sym_namespace_definition_token1] = ACTIONS(1252),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1252),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1252),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(1250),
    [anon_sym_RBRACE] = ACTIONS(1250),
    [aux_sym_trait_declaration_token1] = ACTIONS(1252),
    [aux_sym_interface_declaration_token1] = ACTIONS(1252),
    [aux_sym_enum_declaration_token1] = ACTIONS(1252),
    [aux_sym_enum_case_token1] = ACTIONS(1252),
    [aux_sym_class_declaration_token1] = ACTIONS(1252),
    [aux_sym_final_modifier_token1] = ACTIONS(1252),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1252),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1252),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1252),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1252),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1252),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1250),
    [aux_sym_cast_type_token1] = ACTIONS(1252),
    [aux_sym_echo_statement_token1] = ACTIONS(1252),
    [anon_sym_unset] = ACTIONS(1252),
    [aux_sym_declare_statement_token1] = ACTIONS(1252),
    [aux_sym_declare_statement_token2] = ACTIONS(1252),
    [sym_float] = ACTIONS(1252),
    [aux_sym_try_statement_token1] = ACTIONS(1252),
    [aux_sym_goto_statement_token1] = ACTIONS(1252),
    [aux_sym_continue_statement_token1] = ACTIONS(1252),
    [aux_sym_break_statement_token1] = ACTIONS(1252),
    [sym_integer] = ACTIONS(1252),
    [aux_sym_return_statement_token1] = ACTIONS(1252),
    [aux_sym_throw_expression_token1] = ACTIONS(1252),
    [aux_sym_while_statement_token1] = ACTIONS(1252),
    [aux_sym_while_statement_token2] = ACTIONS(1252),
    [aux_sym_do_statement_token1] = ACTIONS(1252),
    [aux_sym_for_statement_token1] = ACTIONS(1252),
    [aux_sym_for_statement_token2] = ACTIONS(1252),
    [aux_sym_foreach_statement_token1] = ACTIONS(1252),
    [aux_sym_foreach_statement_token2] = ACTIONS(1252),
    [aux_sym_if_statement_token1] = ACTIONS(1252),
    [aux_sym_if_statement_token2] = ACTIONS(1252),
    [aux_sym_else_if_clause_token1] = ACTIONS(1252),
    [aux_sym_else_clause_token1] = ACTIONS(1252),
    [aux_sym_match_expression_token1] = ACTIONS(1252),
    [aux_sym_match_default_expression_token1] = ACTIONS(1252),
    [aux_sym_switch_statement_token1] = ACTIONS(1252),
    [aux_sym_switch_block_token1] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1252),
    [anon_sym_DASH] = ACTIONS(1252),
    [anon_sym_TILDE] = ACTIONS(1250),
    [anon_sym_BANG] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1250),
    [aux_sym_clone_expression_token1] = ACTIONS(1252),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1252),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1252),
    [anon_sym_DASH_DASH] = ACTIONS(1250),
    [anon_sym_PLUS_PLUS] = ACTIONS(1250),
    [aux_sym__list_destructing_token1] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1250),
    [anon_sym_self] = ACTIONS(1252),
    [anon_sym_parent] = ACTIONS(1252),
    [aux_sym__argument_name_token1] = ACTIONS(1252),
    [aux_sym__argument_name_token2] = ACTIONS(1252),
    [anon_sym_POUND_LBRACK] = ACTIONS(1250),
    [anon_sym_SQUOTE] = ACTIONS(1250),
    [aux_sym_encapsed_string_token1] = ACTIONS(1250),
    [anon_sym_DQUOTE] = ACTIONS(1250),
    [aux_sym_string_token1] = ACTIONS(1250),
    [anon_sym_LT_LT_LT] = ACTIONS(1250),
    [anon_sym_BQUOTE] = ACTIONS(1250),
    [anon_sym_DOLLAR] = ACTIONS(1250),
    [aux_sym_yield_expression_token1] = ACTIONS(1252),
    [aux_sym_include_expression_token1] = ACTIONS(1252),
    [aux_sym_include_once_expression_token1] = ACTIONS(1252),
    [aux_sym_require_expression_token1] = ACTIONS(1252),
    [aux_sym_require_once_expression_token1] = ACTIONS(1252),
    [sym_comment] = ACTIONS(3),
  },
  [482] = {
    [ts_builtin_sym_end] = ACTIONS(1250),
    [sym_name] = ACTIONS(1252),
    [anon_sym_QMARK_GT] = ACTIONS(1250),
    [anon_sym_SEMI] = ACTIONS(1250),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1252),
    [aux_sym_global_declaration_token1] = ACTIONS(1252),
    [aux_sym_namespace_definition_token1] = ACTIONS(1252),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1252),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1252),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(1250),
    [anon_sym_RBRACE] = ACTIONS(1250),
    [aux_sym_trait_declaration_token1] = ACTIONS(1252),
    [aux_sym_interface_declaration_token1] = ACTIONS(1252),
    [aux_sym_enum_declaration_token1] = ACTIONS(1252),
    [aux_sym_enum_case_token1] = ACTIONS(1252),
    [aux_sym_class_declaration_token1] = ACTIONS(1252),
    [aux_sym_final_modifier_token1] = ACTIONS(1252),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1252),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1252),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1252),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1252),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1252),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1250),
    [aux_sym_cast_type_token1] = ACTIONS(1252),
    [aux_sym_echo_statement_token1] = ACTIONS(1252),
    [anon_sym_unset] = ACTIONS(1252),
    [aux_sym_declare_statement_token1] = ACTIONS(1252),
    [aux_sym_declare_statement_token2] = ACTIONS(1252),
    [sym_float] = ACTIONS(1252),
    [aux_sym_try_statement_token1] = ACTIONS(1252),
    [aux_sym_goto_statement_token1] = ACTIONS(1252),
    [aux_sym_continue_statement_token1] = ACTIONS(1252),
    [aux_sym_break_statement_token1] = ACTIONS(1252),
    [sym_integer] = ACTIONS(1252),
    [aux_sym_return_statement_token1] = ACTIONS(1252),
    [aux_sym_throw_expression_token1] = ACTIONS(1252),
    [aux_sym_while_statement_token1] = ACTIONS(1252),
    [aux_sym_while_statement_token2] = ACTIONS(1252),
    [aux_sym_do_statement_token1] = ACTIONS(1252),
    [aux_sym_for_statement_token1] = ACTIONS(1252),
    [aux_sym_for_statement_token2] = ACTIONS(1252),
    [aux_sym_foreach_statement_token1] = ACTIONS(1252),
    [aux_sym_foreach_statement_token2] = ACTIONS(1252),
    [aux_sym_if_statement_token1] = ACTIONS(1252),
    [aux_sym_if_statement_token2] = ACTIONS(1252),
    [aux_sym_else_if_clause_token1] = ACTIONS(1252),
    [aux_sym_else_clause_token1] = ACTIONS(1252),
    [aux_sym_match_expression_token1] = ACTIONS(1252),
    [aux_sym_match_default_expression_token1] = ACTIONS(1252),
    [aux_sym_switch_statement_token1] = ACTIONS(1252),
    [aux_sym_switch_block_token1] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1252),
    [anon_sym_DASH] = ACTIONS(1252),
    [anon_sym_TILDE] = ACTIONS(1250),
    [anon_sym_BANG] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1250),
    [aux_sym_clone_expression_token1] = ACTIONS(1252),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1252),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1252),
    [anon_sym_DASH_DASH] = ACTIONS(1250),
    [anon_sym_PLUS_PLUS] = ACTIONS(1250),
    [aux_sym__list_destructing_token1] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1250),
    [anon_sym_self] = ACTIONS(1252),
    [anon_sym_parent] = ACTIONS(1252),
    [aux_sym__argument_name_token1] = ACTIONS(1252),
    [aux_sym__argument_name_token2] = ACTIONS(1252),
    [anon_sym_POUND_LBRACK] = ACTIONS(1250),
    [anon_sym_SQUOTE] = ACTIONS(1250),
    [aux_sym_encapsed_string_token1] = ACTIONS(1250),
    [anon_sym_DQUOTE] = ACTIONS(1250),
    [aux_sym_string_token1] = ACTIONS(1250),
    [anon_sym_LT_LT_LT] = ACTIONS(1250),
    [anon_sym_BQUOTE] = ACTIONS(1250),
    [anon_sym_DOLLAR] = ACTIONS(1250),
    [aux_sym_yield_expression_token1] = ACTIONS(1252),
    [aux_sym_include_expression_token1] = ACTIONS(1252),
    [aux_sym_include_once_expression_token1] = ACTIONS(1252),
    [aux_sym_require_expression_token1] = ACTIONS(1252),
    [aux_sym_require_once_expression_token1] = ACTIONS(1252),
    [sym_comment] = ACTIONS(3),
  },
  [483] = {
    [ts_builtin_sym_end] = ACTIONS(1254),
    [sym_name] = ACTIONS(1256),
    [anon_sym_QMARK_GT] = ACTIONS(1254),
    [anon_sym_SEMI] = ACTIONS(1254),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1256),
    [aux_sym_global_declaration_token1] = ACTIONS(1256),
    [aux_sym_namespace_definition_token1] = ACTIONS(1256),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1256),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1256),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1256),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(1254),
    [anon_sym_RBRACE] = ACTIONS(1254),
    [aux_sym_trait_declaration_token1] = ACTIONS(1256),
    [aux_sym_interface_declaration_token1] = ACTIONS(1256),
    [aux_sym_enum_declaration_token1] = ACTIONS(1256),
    [aux_sym_enum_case_token1] = ACTIONS(1256),
    [aux_sym_class_declaration_token1] = ACTIONS(1256),
    [aux_sym_final_modifier_token1] = ACTIONS(1256),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1256),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1256),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1256),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1256),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1256),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1256),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [aux_sym_cast_type_token1] = ACTIONS(1256),
    [aux_sym_echo_statement_token1] = ACTIONS(1256),
    [anon_sym_unset] = ACTIONS(1256),
    [aux_sym_declare_statement_token1] = ACTIONS(1256),
    [aux_sym_declare_statement_token2] = ACTIONS(1256),
    [sym_float] = ACTIONS(1256),
    [aux_sym_try_statement_token1] = ACTIONS(1256),
    [aux_sym_goto_statement_token1] = ACTIONS(1256),
    [aux_sym_continue_statement_token1] = ACTIONS(1256),
    [aux_sym_break_statement_token1] = ACTIONS(1256),
    [sym_integer] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1256),
    [aux_sym_throw_expression_token1] = ACTIONS(1256),
    [aux_sym_while_statement_token1] = ACTIONS(1256),
    [aux_sym_while_statement_token2] = ACTIONS(1256),
    [aux_sym_do_statement_token1] = ACTIONS(1256),
    [aux_sym_for_statement_token1] = ACTIONS(1256),
    [aux_sym_for_statement_token2] = ACTIONS(1256),
    [aux_sym_foreach_statement_token1] = ACTIONS(1256),
    [aux_sym_foreach_statement_token2] = ACTIONS(1256),
    [aux_sym_if_statement_token1] = ACTIONS(1256),
    [aux_sym_if_statement_token2] = ACTIONS(1256),
    [aux_sym_else_if_clause_token1] = ACTIONS(1256),
    [aux_sym_else_clause_token1] = ACTIONS(1256),
    [aux_sym_match_expression_token1] = ACTIONS(1256),
    [aux_sym_match_default_expression_token1] = ACTIONS(1256),
    [aux_sym_switch_statement_token1] = ACTIONS(1256),
    [aux_sym_switch_block_token1] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1256),
    [anon_sym_TILDE] = ACTIONS(1254),
    [anon_sym_BANG] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(1254),
    [aux_sym_clone_expression_token1] = ACTIONS(1256),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1256),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1256),
    [anon_sym_DASH_DASH] = ACTIONS(1254),
    [anon_sym_PLUS_PLUS] = ACTIONS(1254),
    [aux_sym__list_destructing_token1] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1254),
    [anon_sym_self] = ACTIONS(1256),
    [anon_sym_parent] = ACTIONS(1256),
    [aux_sym__argument_name_token1] = ACTIONS(1256),
    [aux_sym__argument_name_token2] = ACTIONS(1256),
    [anon_sym_POUND_LBRACK] = ACTIONS(1254),
    [anon_sym_SQUOTE] = ACTIONS(1254),
    [aux_sym_encapsed_string_token1] = ACTIONS(1254),
    [anon_sym_DQUOTE] = ACTIONS(1254),
    [aux_sym_string_token1] = ACTIONS(1254),
    [anon_sym_LT_LT_LT] = ACTIONS(1254),
    [anon_sym_BQUOTE] = ACTIONS(1254),
    [anon_sym_DOLLAR] = ACTIONS(1254),
    [aux_sym_yield_expression_token1] = ACTIONS(1256),
    [aux_sym_include_expression_token1] = ACTIONS(1256),
    [aux_sym_include_once_expression_token1] = ACTIONS(1256),
    [aux_sym_require_expression_token1] = ACTIONS(1256),
    [aux_sym_require_once_expression_token1] = ACTIONS(1256),
    [sym_comment] = ACTIONS(3),
  },
  [484] = {
    [ts_builtin_sym_end] = ACTIONS(1258),
    [sym_name] = ACTIONS(1260),
    [anon_sym_QMARK_GT] = ACTIONS(1258),
    [anon_sym_SEMI] = ACTIONS(1258),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1260),
    [aux_sym_global_declaration_token1] = ACTIONS(1260),
    [aux_sym_namespace_definition_token1] = ACTIONS(1260),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1260),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1260),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1260),
    [anon_sym_BSLASH] = ACTIONS(1258),
    [anon_sym_LBRACE] = ACTIONS(1258),
    [anon_sym_RBRACE] = ACTIONS(1258),
    [aux_sym_trait_declaration_token1] = ACTIONS(1260),
    [aux_sym_interface_declaration_token1] = ACTIONS(1260),
    [aux_sym_enum_declaration_token1] = ACTIONS(1260),
    [aux_sym_enum_case_token1] = ACTIONS(1260),
    [aux_sym_class_declaration_token1] = ACTIONS(1260),
    [aux_sym_final_modifier_token1] = ACTIONS(1260),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1260),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1260),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1260),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1260),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1260),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1258),
    [aux_sym_cast_type_token1] = ACTIONS(1260),
    [aux_sym_echo_statement_token1] = ACTIONS(1260),
    [anon_sym_unset] = ACTIONS(1260),
    [aux_sym_declare_statement_token1] = ACTIONS(1260),
    [aux_sym_declare_statement_token2] = ACTIONS(1260),
    [sym_float] = ACTIONS(1260),
    [aux_sym_try_statement_token1] = ACTIONS(1260),
    [aux_sym_goto_statement_token1] = ACTIONS(1260),
    [aux_sym_continue_statement_token1] = ACTIONS(1260),
    [aux_sym_break_statement_token1] = ACTIONS(1260),
    [sym_integer] = ACTIONS(1260),
    [aux_sym_return_statement_token1] = ACTIONS(1260),
    [aux_sym_throw_expression_token1] = ACTIONS(1260),
    [aux_sym_while_statement_token1] = ACTIONS(1260),
    [aux_sym_while_statement_token2] = ACTIONS(1260),
    [aux_sym_do_statement_token1] = ACTIONS(1260),
    [aux_sym_for_statement_token1] = ACTIONS(1260),
    [aux_sym_for_statement_token2] = ACTIONS(1260),
    [aux_sym_foreach_statement_token1] = ACTIONS(1260),
    [aux_sym_foreach_statement_token2] = ACTIONS(1260),
    [aux_sym_if_statement_token1] = ACTIONS(1260),
    [aux_sym_if_statement_token2] = ACTIONS(1260),
    [aux_sym_else_if_clause_token1] = ACTIONS(1260),
    [aux_sym_else_clause_token1] = ACTIONS(1260),
    [aux_sym_match_expression_token1] = ACTIONS(1260),
    [aux_sym_match_default_expression_token1] = ACTIONS(1260),
    [aux_sym_switch_statement_token1] = ACTIONS(1260),
    [aux_sym_switch_block_token1] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1260),
    [anon_sym_DASH] = ACTIONS(1260),
    [anon_sym_TILDE] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1258),
    [anon_sym_AT] = ACTIONS(1258),
    [aux_sym_clone_expression_token1] = ACTIONS(1260),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1260),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1260),
    [anon_sym_DASH_DASH] = ACTIONS(1258),
    [anon_sym_PLUS_PLUS] = ACTIONS(1258),
    [aux_sym__list_destructing_token1] = ACTIONS(1260),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_self] = ACTIONS(1260),
    [anon_sym_parent] = ACTIONS(1260),
    [aux_sym__argument_name_token1] = ACTIONS(1260),
    [aux_sym__argument_name_token2] = ACTIONS(1260),
    [anon_sym_POUND_LBRACK] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1258),
    [aux_sym_encapsed_string_token1] = ACTIONS(1258),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [aux_sym_string_token1] = ACTIONS(1258),
    [anon_sym_LT_LT_LT] = ACTIONS(1258),
    [anon_sym_BQUOTE] = ACTIONS(1258),
    [anon_sym_DOLLAR] = ACTIONS(1258),
    [aux_sym_yield_expression_token1] = ACTIONS(1260),
    [aux_sym_include_expression_token1] = ACTIONS(1260),
    [aux_sym_include_once_expression_token1] = ACTIONS(1260),
    [aux_sym_require_expression_token1] = ACTIONS(1260),
    [aux_sym_require_once_expression_token1] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
  },
  [485] = {
    [ts_builtin_sym_end] = ACTIONS(1262),
    [sym_name] = ACTIONS(1264),
    [anon_sym_QMARK_GT] = ACTIONS(1262),
    [anon_sym_SEMI] = ACTIONS(1262),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1264),
    [aux_sym_global_declaration_token1] = ACTIONS(1264),
    [aux_sym_namespace_definition_token1] = ACTIONS(1264),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1264),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1264),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1264),
    [anon_sym_BSLASH] = ACTIONS(1262),
    [anon_sym_LBRACE] = ACTIONS(1262),
    [anon_sym_RBRACE] = ACTIONS(1262),
    [aux_sym_trait_declaration_token1] = ACTIONS(1264),
    [aux_sym_interface_declaration_token1] = ACTIONS(1264),
    [aux_sym_enum_declaration_token1] = ACTIONS(1264),
    [aux_sym_enum_case_token1] = ACTIONS(1264),
    [aux_sym_class_declaration_token1] = ACTIONS(1264),
    [aux_sym_final_modifier_token1] = ACTIONS(1264),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1264),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1264),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1264),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1264),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1264),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [aux_sym_cast_type_token1] = ACTIONS(1264),
    [aux_sym_echo_statement_token1] = ACTIONS(1264),
    [anon_sym_unset] = ACTIONS(1264),
    [aux_sym_declare_statement_token1] = ACTIONS(1264),
    [aux_sym_declare_statement_token2] = ACTIONS(1264),
    [sym_float] = ACTIONS(1264),
    [aux_sym_try_statement_token1] = ACTIONS(1264),
    [aux_sym_goto_statement_token1] = ACTIONS(1264),
    [aux_sym_continue_statement_token1] = ACTIONS(1264),
    [aux_sym_break_statement_token1] = ACTIONS(1264),
    [sym_integer] = ACTIONS(1264),
    [aux_sym_return_statement_token1] = ACTIONS(1264),
    [aux_sym_throw_expression_token1] = ACTIONS(1264),
    [aux_sym_while_statement_token1] = ACTIONS(1264),
    [aux_sym_while_statement_token2] = ACTIONS(1264),
    [aux_sym_do_statement_token1] = ACTIONS(1264),
    [aux_sym_for_statement_token1] = ACTIONS(1264),
    [aux_sym_for_statement_token2] = ACTIONS(1264),
    [aux_sym_foreach_statement_token1] = ACTIONS(1264),
    [aux_sym_foreach_statement_token2] = ACTIONS(1264),
    [aux_sym_if_statement_token1] = ACTIONS(1264),
    [aux_sym_if_statement_token2] = ACTIONS(1264),
    [aux_sym_else_if_clause_token1] = ACTIONS(1264),
    [aux_sym_else_clause_token1] = ACTIONS(1264),
    [aux_sym_match_expression_token1] = ACTIONS(1264),
    [aux_sym_match_default_expression_token1] = ACTIONS(1264),
    [aux_sym_switch_statement_token1] = ACTIONS(1264),
    [aux_sym_switch_block_token1] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1264),
    [anon_sym_TILDE] = ACTIONS(1262),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(1262),
    [aux_sym_clone_expression_token1] = ACTIONS(1264),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1264),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1264),
    [anon_sym_DASH_DASH] = ACTIONS(1262),
    [anon_sym_PLUS_PLUS] = ACTIONS(1262),
    [aux_sym__list_destructing_token1] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(1262),
    [anon_sym_self] = ACTIONS(1264),
    [anon_sym_parent] = ACTIONS(1264),
    [aux_sym__argument_name_token1] = ACTIONS(1264),
    [aux_sym__argument_name_token2] = ACTIONS(1264),
    [anon_sym_POUND_LBRACK] = ACTIONS(1262),
    [anon_sym_SQUOTE] = ACTIONS(1262),
    [aux_sym_encapsed_string_token1] = ACTIONS(1262),
    [anon_sym_DQUOTE] = ACTIONS(1262),
    [aux_sym_string_token1] = ACTIONS(1262),
    [anon_sym_LT_LT_LT] = ACTIONS(1262),
    [anon_sym_BQUOTE] = ACTIONS(1262),
    [anon_sym_DOLLAR] = ACTIONS(1262),
    [aux_sym_yield_expression_token1] = ACTIONS(1264),
    [aux_sym_include_expression_token1] = ACTIONS(1264),
    [aux_sym_include_once_expression_token1] = ACTIONS(1264),
    [aux_sym_require_expression_token1] = ACTIONS(1264),
    [aux_sym_require_once_expression_token1] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [486] = {
    [ts_builtin_sym_end] = ACTIONS(1258),
    [sym_name] = ACTIONS(1260),
    [anon_sym_QMARK_GT] = ACTIONS(1258),
    [anon_sym_SEMI] = ACTIONS(1258),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1260),
    [aux_sym_global_declaration_token1] = ACTIONS(1260),
    [aux_sym_namespace_definition_token1] = ACTIONS(1260),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1260),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1260),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1260),
    [anon_sym_BSLASH] = ACTIONS(1258),
    [anon_sym_LBRACE] = ACTIONS(1258),
    [anon_sym_RBRACE] = ACTIONS(1258),
    [aux_sym_trait_declaration_token1] = ACTIONS(1260),
    [aux_sym_interface_declaration_token1] = ACTIONS(1260),
    [aux_sym_enum_declaration_token1] = ACTIONS(1260),
    [aux_sym_enum_case_token1] = ACTIONS(1260),
    [aux_sym_class_declaration_token1] = ACTIONS(1260),
    [aux_sym_final_modifier_token1] = ACTIONS(1260),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1260),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1260),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1260),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1260),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1260),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1258),
    [aux_sym_cast_type_token1] = ACTIONS(1260),
    [aux_sym_echo_statement_token1] = ACTIONS(1260),
    [anon_sym_unset] = ACTIONS(1260),
    [aux_sym_declare_statement_token1] = ACTIONS(1260),
    [aux_sym_declare_statement_token2] = ACTIONS(1260),
    [sym_float] = ACTIONS(1260),
    [aux_sym_try_statement_token1] = ACTIONS(1260),
    [aux_sym_goto_statement_token1] = ACTIONS(1260),
    [aux_sym_continue_statement_token1] = ACTIONS(1260),
    [aux_sym_break_statement_token1] = ACTIONS(1260),
    [sym_integer] = ACTIONS(1260),
    [aux_sym_return_statement_token1] = ACTIONS(1260),
    [aux_sym_throw_expression_token1] = ACTIONS(1260),
    [aux_sym_while_statement_token1] = ACTIONS(1260),
    [aux_sym_while_statement_token2] = ACTIONS(1260),
    [aux_sym_do_statement_token1] = ACTIONS(1260),
    [aux_sym_for_statement_token1] = ACTIONS(1260),
    [aux_sym_for_statement_token2] = ACTIONS(1260),
    [aux_sym_foreach_statement_token1] = ACTIONS(1260),
    [aux_sym_foreach_statement_token2] = ACTIONS(1260),
    [aux_sym_if_statement_token1] = ACTIONS(1260),
    [aux_sym_if_statement_token2] = ACTIONS(1260),
    [aux_sym_else_if_clause_token1] = ACTIONS(1260),
    [aux_sym_else_clause_token1] = ACTIONS(1260),
    [aux_sym_match_expression_token1] = ACTIONS(1260),
    [aux_sym_match_default_expression_token1] = ACTIONS(1260),
    [aux_sym_switch_statement_token1] = ACTIONS(1260),
    [aux_sym_switch_block_token1] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1260),
    [anon_sym_DASH] = ACTIONS(1260),
    [anon_sym_TILDE] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1258),
    [anon_sym_AT] = ACTIONS(1258),
    [aux_sym_clone_expression_token1] = ACTIONS(1260),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1260),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1260),
    [anon_sym_DASH_DASH] = ACTIONS(1258),
    [anon_sym_PLUS_PLUS] = ACTIONS(1258),
    [aux_sym__list_destructing_token1] = ACTIONS(1260),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_self] = ACTIONS(1260),
    [anon_sym_parent] = ACTIONS(1260),
    [aux_sym__argument_name_token1] = ACTIONS(1260),
    [aux_sym__argument_name_token2] = ACTIONS(1260),
    [anon_sym_POUND_LBRACK] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1258),
    [aux_sym_encapsed_string_token1] = ACTIONS(1258),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [aux_sym_string_token1] = ACTIONS(1258),
    [anon_sym_LT_LT_LT] = ACTIONS(1258),
    [anon_sym_BQUOTE] = ACTIONS(1258),
    [anon_sym_DOLLAR] = ACTIONS(1258),
    [aux_sym_yield_expression_token1] = ACTIONS(1260),
    [aux_sym_include_expression_token1] = ACTIONS(1260),
    [aux_sym_include_once_expression_token1] = ACTIONS(1260),
    [aux_sym_require_expression_token1] = ACTIONS(1260),
    [aux_sym_require_once_expression_token1] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
  },
  [487] = {
    [ts_builtin_sym_end] = ACTIONS(1266),
    [sym_name] = ACTIONS(1268),
    [anon_sym_QMARK_GT] = ACTIONS(1266),
    [anon_sym_SEMI] = ACTIONS(1266),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1268),
    [aux_sym_global_declaration_token1] = ACTIONS(1268),
    [aux_sym_namespace_definition_token1] = ACTIONS(1268),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1268),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1268),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1268),
    [anon_sym_BSLASH] = ACTIONS(1266),
    [anon_sym_LBRACE] = ACTIONS(1266),
    [anon_sym_RBRACE] = ACTIONS(1266),
    [aux_sym_trait_declaration_token1] = ACTIONS(1268),
    [aux_sym_interface_declaration_token1] = ACTIONS(1268),
    [aux_sym_enum_declaration_token1] = ACTIONS(1268),
    [aux_sym_enum_case_token1] = ACTIONS(1268),
    [aux_sym_class_declaration_token1] = ACTIONS(1268),
    [aux_sym_final_modifier_token1] = ACTIONS(1268),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1268),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1268),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1268),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1268),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1268),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1268),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [aux_sym_cast_type_token1] = ACTIONS(1268),
    [aux_sym_echo_statement_token1] = ACTIONS(1268),
    [anon_sym_unset] = ACTIONS(1268),
    [aux_sym_declare_statement_token1] = ACTIONS(1268),
    [aux_sym_declare_statement_token2] = ACTIONS(1268),
    [sym_float] = ACTIONS(1268),
    [aux_sym_try_statement_token1] = ACTIONS(1268),
    [aux_sym_goto_statement_token1] = ACTIONS(1268),
    [aux_sym_continue_statement_token1] = ACTIONS(1268),
    [aux_sym_break_statement_token1] = ACTIONS(1268),
    [sym_integer] = ACTIONS(1268),
    [aux_sym_return_statement_token1] = ACTIONS(1268),
    [aux_sym_throw_expression_token1] = ACTIONS(1268),
    [aux_sym_while_statement_token1] = ACTIONS(1268),
    [aux_sym_while_statement_token2] = ACTIONS(1268),
    [aux_sym_do_statement_token1] = ACTIONS(1268),
    [aux_sym_for_statement_token1] = ACTIONS(1268),
    [aux_sym_for_statement_token2] = ACTIONS(1268),
    [aux_sym_foreach_statement_token1] = ACTIONS(1268),
    [aux_sym_foreach_statement_token2] = ACTIONS(1268),
    [aux_sym_if_statement_token1] = ACTIONS(1268),
    [aux_sym_if_statement_token2] = ACTIONS(1268),
    [aux_sym_else_if_clause_token1] = ACTIONS(1268),
    [aux_sym_else_clause_token1] = ACTIONS(1268),
    [aux_sym_match_expression_token1] = ACTIONS(1268),
    [aux_sym_match_default_expression_token1] = ACTIONS(1268),
    [aux_sym_switch_statement_token1] = ACTIONS(1268),
    [aux_sym_switch_block_token1] = ACTIONS(1268),
    [anon_sym_PLUS] = ACTIONS(1268),
    [anon_sym_DASH] = ACTIONS(1268),
    [anon_sym_TILDE] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1266),
    [anon_sym_AT] = ACTIONS(1266),
    [aux_sym_clone_expression_token1] = ACTIONS(1268),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1268),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1268),
    [anon_sym_DASH_DASH] = ACTIONS(1266),
    [anon_sym_PLUS_PLUS] = ACTIONS(1266),
    [aux_sym__list_destructing_token1] = ACTIONS(1268),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_self] = ACTIONS(1268),
    [anon_sym_parent] = ACTIONS(1268),
    [aux_sym__argument_name_token1] = ACTIONS(1268),
    [aux_sym__argument_name_token2] = ACTIONS(1268),
    [anon_sym_POUND_LBRACK] = ACTIONS(1266),
    [anon_sym_SQUOTE] = ACTIONS(1266),
    [aux_sym_encapsed_string_token1] = ACTIONS(1266),
    [anon_sym_DQUOTE] = ACTIONS(1266),
    [aux_sym_string_token1] = ACTIONS(1266),
    [anon_sym_LT_LT_LT] = ACTIONS(1266),
    [anon_sym_BQUOTE] = ACTIONS(1266),
    [anon_sym_DOLLAR] = ACTIONS(1266),
    [aux_sym_yield_expression_token1] = ACTIONS(1268),
    [aux_sym_include_expression_token1] = ACTIONS(1268),
    [aux_sym_include_once_expression_token1] = ACTIONS(1268),
    [aux_sym_require_expression_token1] = ACTIONS(1268),
    [aux_sym_require_once_expression_token1] = ACTIONS(1268),
    [sym_comment] = ACTIONS(3),
  },
  [488] = {
    [ts_builtin_sym_end] = ACTIONS(1270),
    [sym_name] = ACTIONS(1272),
    [anon_sym_QMARK_GT] = ACTIONS(1270),
    [anon_sym_SEMI] = ACTIONS(1270),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1272),
    [aux_sym_global_declaration_token1] = ACTIONS(1272),
    [aux_sym_namespace_definition_token1] = ACTIONS(1272),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1272),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1272),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1272),
    [anon_sym_BSLASH] = ACTIONS(1270),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(1270),
    [aux_sym_trait_declaration_token1] = ACTIONS(1272),
    [aux_sym_interface_declaration_token1] = ACTIONS(1272),
    [aux_sym_enum_declaration_token1] = ACTIONS(1272),
    [aux_sym_enum_case_token1] = ACTIONS(1272),
    [aux_sym_class_declaration_token1] = ACTIONS(1272),
    [aux_sym_final_modifier_token1] = ACTIONS(1272),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1272),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1272),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1272),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1272),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1272),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1270),
    [aux_sym_cast_type_token1] = ACTIONS(1272),
    [aux_sym_echo_statement_token1] = ACTIONS(1272),
    [anon_sym_unset] = ACTIONS(1272),
    [aux_sym_declare_statement_token1] = ACTIONS(1272),
    [aux_sym_declare_statement_token2] = ACTIONS(1272),
    [sym_float] = ACTIONS(1272),
    [aux_sym_try_statement_token1] = ACTIONS(1272),
    [aux_sym_goto_statement_token1] = ACTIONS(1272),
    [aux_sym_continue_statement_token1] = ACTIONS(1272),
    [aux_sym_break_statement_token1] = ACTIONS(1272),
    [sym_integer] = ACTIONS(1272),
    [aux_sym_return_statement_token1] = ACTIONS(1272),
    [aux_sym_throw_expression_token1] = ACTIONS(1272),
    [aux_sym_while_statement_token1] = ACTIONS(1272),
    [aux_sym_while_statement_token2] = ACTIONS(1272),
    [aux_sym_do_statement_token1] = ACTIONS(1272),
    [aux_sym_for_statement_token1] = ACTIONS(1272),
    [aux_sym_for_statement_token2] = ACTIONS(1272),
    [aux_sym_foreach_statement_token1] = ACTIONS(1272),
    [aux_sym_foreach_statement_token2] = ACTIONS(1272),
    [aux_sym_if_statement_token1] = ACTIONS(1272),
    [aux_sym_if_statement_token2] = ACTIONS(1272),
    [aux_sym_else_if_clause_token1] = ACTIONS(1272),
    [aux_sym_else_clause_token1] = ACTIONS(1272),
    [aux_sym_match_expression_token1] = ACTIONS(1272),
    [aux_sym_match_default_expression_token1] = ACTIONS(1272),
    [aux_sym_switch_statement_token1] = ACTIONS(1272),
    [aux_sym_switch_block_token1] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_TILDE] = ACTIONS(1270),
    [anon_sym_BANG] = ACTIONS(1270),
    [anon_sym_AT] = ACTIONS(1270),
    [aux_sym_clone_expression_token1] = ACTIONS(1272),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1272),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1272),
    [anon_sym_DASH_DASH] = ACTIONS(1270),
    [anon_sym_PLUS_PLUS] = ACTIONS(1270),
    [aux_sym__list_destructing_token1] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_self] = ACTIONS(1272),
    [anon_sym_parent] = ACTIONS(1272),
    [aux_sym__argument_name_token1] = ACTIONS(1272),
    [aux_sym__argument_name_token2] = ACTIONS(1272),
    [anon_sym_POUND_LBRACK] = ACTIONS(1270),
    [anon_sym_SQUOTE] = ACTIONS(1270),
    [aux_sym_encapsed_string_token1] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1270),
    [aux_sym_string_token1] = ACTIONS(1270),
    [anon_sym_LT_LT_LT] = ACTIONS(1270),
    [anon_sym_BQUOTE] = ACTIONS(1270),
    [anon_sym_DOLLAR] = ACTIONS(1270),
    [aux_sym_yield_expression_token1] = ACTIONS(1272),
    [aux_sym_include_expression_token1] = ACTIONS(1272),
    [aux_sym_include_once_expression_token1] = ACTIONS(1272),
    [aux_sym_require_expression_token1] = ACTIONS(1272),
    [aux_sym_require_once_expression_token1] = ACTIONS(1272),
    [sym_comment] = ACTIONS(3),
  },
  [489] = {
    [ts_builtin_sym_end] = ACTIONS(1274),
    [sym_name] = ACTIONS(1276),
    [anon_sym_QMARK_GT] = ACTIONS(1274),
    [anon_sym_SEMI] = ACTIONS(1274),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1276),
    [aux_sym_global_declaration_token1] = ACTIONS(1276),
    [aux_sym_namespace_definition_token1] = ACTIONS(1276),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1276),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1276),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1276),
    [anon_sym_BSLASH] = ACTIONS(1274),
    [anon_sym_LBRACE] = ACTIONS(1274),
    [anon_sym_RBRACE] = ACTIONS(1274),
    [aux_sym_trait_declaration_token1] = ACTIONS(1276),
    [aux_sym_interface_declaration_token1] = ACTIONS(1276),
    [aux_sym_enum_declaration_token1] = ACTIONS(1276),
    [aux_sym_enum_case_token1] = ACTIONS(1276),
    [aux_sym_class_declaration_token1] = ACTIONS(1276),
    [aux_sym_final_modifier_token1] = ACTIONS(1276),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1276),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1276),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1276),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1276),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1276),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1276),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [aux_sym_cast_type_token1] = ACTIONS(1276),
    [aux_sym_echo_statement_token1] = ACTIONS(1276),
    [anon_sym_unset] = ACTIONS(1276),
    [aux_sym_declare_statement_token1] = ACTIONS(1276),
    [aux_sym_declare_statement_token2] = ACTIONS(1276),
    [sym_float] = ACTIONS(1276),
    [aux_sym_try_statement_token1] = ACTIONS(1276),
    [aux_sym_goto_statement_token1] = ACTIONS(1276),
    [aux_sym_continue_statement_token1] = ACTIONS(1276),
    [aux_sym_break_statement_token1] = ACTIONS(1276),
    [sym_integer] = ACTIONS(1276),
    [aux_sym_return_statement_token1] = ACTIONS(1276),
    [aux_sym_throw_expression_token1] = ACTIONS(1276),
    [aux_sym_while_statement_token1] = ACTIONS(1276),
    [aux_sym_while_statement_token2] = ACTIONS(1276),
    [aux_sym_do_statement_token1] = ACTIONS(1276),
    [aux_sym_for_statement_token1] = ACTIONS(1276),
    [aux_sym_for_statement_token2] = ACTIONS(1276),
    [aux_sym_foreach_statement_token1] = ACTIONS(1276),
    [aux_sym_foreach_statement_token2] = ACTIONS(1276),
    [aux_sym_if_statement_token1] = ACTIONS(1276),
    [aux_sym_if_statement_token2] = ACTIONS(1276),
    [aux_sym_else_if_clause_token1] = ACTIONS(1276),
    [aux_sym_else_clause_token1] = ACTIONS(1276),
    [aux_sym_match_expression_token1] = ACTIONS(1276),
    [aux_sym_match_default_expression_token1] = ACTIONS(1276),
    [aux_sym_switch_statement_token1] = ACTIONS(1276),
    [aux_sym_switch_block_token1] = ACTIONS(1276),
    [anon_sym_PLUS] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1276),
    [anon_sym_TILDE] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(1274),
    [aux_sym_clone_expression_token1] = ACTIONS(1276),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1276),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1276),
    [anon_sym_DASH_DASH] = ACTIONS(1274),
    [anon_sym_PLUS_PLUS] = ACTIONS(1274),
    [aux_sym__list_destructing_token1] = ACTIONS(1276),
    [anon_sym_LBRACK] = ACTIONS(1274),
    [anon_sym_self] = ACTIONS(1276),
    [anon_sym_parent] = ACTIONS(1276),
    [aux_sym__argument_name_token1] = ACTIONS(1276),
    [aux_sym__argument_name_token2] = ACTIONS(1276),
    [anon_sym_POUND_LBRACK] = ACTIONS(1274),
    [anon_sym_SQUOTE] = ACTIONS(1274),
    [aux_sym_encapsed_string_token1] = ACTIONS(1274),
    [anon_sym_DQUOTE] = ACTIONS(1274),
    [aux_sym_string_token1] = ACTIONS(1274),
    [anon_sym_LT_LT_LT] = ACTIONS(1274),
    [anon_sym_BQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR] = ACTIONS(1274),
    [aux_sym_yield_expression_token1] = ACTIONS(1276),
    [aux_sym_include_expression_token1] = ACTIONS(1276),
    [aux_sym_include_once_expression_token1] = ACTIONS(1276),
    [aux_sym_require_expression_token1] = ACTIONS(1276),
    [aux_sym_require_once_expression_token1] = ACTIONS(1276),
    [sym_comment] = ACTIONS(3),
  },
  [490] = {
    [ts_builtin_sym_end] = ACTIONS(1278),
    [sym_name] = ACTIONS(1280),
    [anon_sym_QMARK_GT] = ACTIONS(1278),
    [anon_sym_SEMI] = ACTIONS(1278),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1280),
    [aux_sym_global_declaration_token1] = ACTIONS(1280),
    [aux_sym_namespace_definition_token1] = ACTIONS(1280),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1280),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1280),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1280),
    [anon_sym_BSLASH] = ACTIONS(1278),
    [anon_sym_LBRACE] = ACTIONS(1278),
    [anon_sym_RBRACE] = ACTIONS(1278),
    [aux_sym_trait_declaration_token1] = ACTIONS(1280),
    [aux_sym_interface_declaration_token1] = ACTIONS(1280),
    [aux_sym_enum_declaration_token1] = ACTIONS(1280),
    [aux_sym_enum_case_token1] = ACTIONS(1280),
    [aux_sym_class_declaration_token1] = ACTIONS(1280),
    [aux_sym_final_modifier_token1] = ACTIONS(1280),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1280),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1280),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1280),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1280),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1280),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1280),
    [anon_sym_LPAREN] = ACTIONS(1278),
    [aux_sym_cast_type_token1] = ACTIONS(1280),
    [aux_sym_echo_statement_token1] = ACTIONS(1280),
    [anon_sym_unset] = ACTIONS(1280),
    [aux_sym_declare_statement_token1] = ACTIONS(1280),
    [aux_sym_declare_statement_token2] = ACTIONS(1280),
    [sym_float] = ACTIONS(1280),
    [aux_sym_try_statement_token1] = ACTIONS(1280),
    [aux_sym_goto_statement_token1] = ACTIONS(1280),
    [aux_sym_continue_statement_token1] = ACTIONS(1280),
    [aux_sym_break_statement_token1] = ACTIONS(1280),
    [sym_integer] = ACTIONS(1280),
    [aux_sym_return_statement_token1] = ACTIONS(1280),
    [aux_sym_throw_expression_token1] = ACTIONS(1280),
    [aux_sym_while_statement_token1] = ACTIONS(1280),
    [aux_sym_while_statement_token2] = ACTIONS(1280),
    [aux_sym_do_statement_token1] = ACTIONS(1280),
    [aux_sym_for_statement_token1] = ACTIONS(1280),
    [aux_sym_for_statement_token2] = ACTIONS(1280),
    [aux_sym_foreach_statement_token1] = ACTIONS(1280),
    [aux_sym_foreach_statement_token2] = ACTIONS(1280),
    [aux_sym_if_statement_token1] = ACTIONS(1280),
    [aux_sym_if_statement_token2] = ACTIONS(1280),
    [aux_sym_else_if_clause_token1] = ACTIONS(1280),
    [aux_sym_else_clause_token1] = ACTIONS(1280),
    [aux_sym_match_expression_token1] = ACTIONS(1280),
    [aux_sym_match_default_expression_token1] = ACTIONS(1280),
    [aux_sym_switch_statement_token1] = ACTIONS(1280),
    [aux_sym_switch_block_token1] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1280),
    [anon_sym_DASH] = ACTIONS(1280),
    [anon_sym_TILDE] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1278),
    [anon_sym_AT] = ACTIONS(1278),
    [aux_sym_clone_expression_token1] = ACTIONS(1280),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1280),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1280),
    [anon_sym_DASH_DASH] = ACTIONS(1278),
    [anon_sym_PLUS_PLUS] = ACTIONS(1278),
    [aux_sym__list_destructing_token1] = ACTIONS(1280),
    [anon_sym_LBRACK] = ACTIONS(1278),
    [anon_sym_self] = ACTIONS(1280),
    [anon_sym_parent] = ACTIONS(1280),
    [aux_sym__argument_name_token1] = ACTIONS(1280),
    [aux_sym__argument_name_token2] = ACTIONS(1280),
    [anon_sym_POUND_LBRACK] = ACTIONS(1278),
    [anon_sym_SQUOTE] = ACTIONS(1278),
    [aux_sym_encapsed_string_token1] = ACTIONS(1278),
    [anon_sym_DQUOTE] = ACTIONS(1278),
    [aux_sym_string_token1] = ACTIONS(1278),
    [anon_sym_LT_LT_LT] = ACTIONS(1278),
    [anon_sym_BQUOTE] = ACTIONS(1278),
    [anon_sym_DOLLAR] = ACTIONS(1278),
    [aux_sym_yield_expression_token1] = ACTIONS(1280),
    [aux_sym_include_expression_token1] = ACTIONS(1280),
    [aux_sym_include_once_expression_token1] = ACTIONS(1280),
    [aux_sym_require_expression_token1] = ACTIONS(1280),
    [aux_sym_require_once_expression_token1] = ACTIONS(1280),
    [sym_comment] = ACTIONS(3),
  },
  [491] = {
    [ts_builtin_sym_end] = ACTIONS(1282),
    [sym_name] = ACTIONS(1284),
    [anon_sym_QMARK_GT] = ACTIONS(1282),
    [anon_sym_SEMI] = ACTIONS(1282),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1284),
    [aux_sym_global_declaration_token1] = ACTIONS(1284),
    [aux_sym_namespace_definition_token1] = ACTIONS(1284),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1284),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1284),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1284),
    [anon_sym_BSLASH] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(1282),
    [anon_sym_RBRACE] = ACTIONS(1282),
    [aux_sym_trait_declaration_token1] = ACTIONS(1284),
    [aux_sym_interface_declaration_token1] = ACTIONS(1284),
    [aux_sym_enum_declaration_token1] = ACTIONS(1284),
    [aux_sym_enum_case_token1] = ACTIONS(1284),
    [aux_sym_class_declaration_token1] = ACTIONS(1284),
    [aux_sym_final_modifier_token1] = ACTIONS(1284),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1284),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1284),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1284),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1284),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1284),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1284),
    [anon_sym_LPAREN] = ACTIONS(1282),
    [aux_sym_cast_type_token1] = ACTIONS(1284),
    [aux_sym_echo_statement_token1] = ACTIONS(1284),
    [anon_sym_unset] = ACTIONS(1284),
    [aux_sym_declare_statement_token1] = ACTIONS(1284),
    [aux_sym_declare_statement_token2] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [aux_sym_try_statement_token1] = ACTIONS(1284),
    [aux_sym_goto_statement_token1] = ACTIONS(1284),
    [aux_sym_continue_statement_token1] = ACTIONS(1284),
    [aux_sym_break_statement_token1] = ACTIONS(1284),
    [sym_integer] = ACTIONS(1284),
    [aux_sym_return_statement_token1] = ACTIONS(1284),
    [aux_sym_throw_expression_token1] = ACTIONS(1284),
    [aux_sym_while_statement_token1] = ACTIONS(1284),
    [aux_sym_while_statement_token2] = ACTIONS(1284),
    [aux_sym_do_statement_token1] = ACTIONS(1284),
    [aux_sym_for_statement_token1] = ACTIONS(1284),
    [aux_sym_for_statement_token2] = ACTIONS(1284),
    [aux_sym_foreach_statement_token1] = ACTIONS(1284),
    [aux_sym_foreach_statement_token2] = ACTIONS(1284),
    [aux_sym_if_statement_token1] = ACTIONS(1284),
    [aux_sym_if_statement_token2] = ACTIONS(1284),
    [aux_sym_else_if_clause_token1] = ACTIONS(1284),
    [aux_sym_else_clause_token1] = ACTIONS(1284),
    [aux_sym_match_expression_token1] = ACTIONS(1284),
    [aux_sym_match_default_expression_token1] = ACTIONS(1284),
    [aux_sym_switch_statement_token1] = ACTIONS(1284),
    [aux_sym_switch_block_token1] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(1284),
    [anon_sym_DASH] = ACTIONS(1284),
    [anon_sym_TILDE] = ACTIONS(1282),
    [anon_sym_BANG] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(1282),
    [aux_sym_clone_expression_token1] = ACTIONS(1284),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1284),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1284),
    [anon_sym_DASH_DASH] = ACTIONS(1282),
    [anon_sym_PLUS_PLUS] = ACTIONS(1282),
    [aux_sym__list_destructing_token1] = ACTIONS(1284),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [anon_sym_self] = ACTIONS(1284),
    [anon_sym_parent] = ACTIONS(1284),
    [aux_sym__argument_name_token1] = ACTIONS(1284),
    [aux_sym__argument_name_token2] = ACTIONS(1284),
    [anon_sym_POUND_LBRACK] = ACTIONS(1282),
    [anon_sym_SQUOTE] = ACTIONS(1282),
    [aux_sym_encapsed_string_token1] = ACTIONS(1282),
    [anon_sym_DQUOTE] = ACTIONS(1282),
    [aux_sym_string_token1] = ACTIONS(1282),
    [anon_sym_LT_LT_LT] = ACTIONS(1282),
    [anon_sym_BQUOTE] = ACTIONS(1282),
    [anon_sym_DOLLAR] = ACTIONS(1282),
    [aux_sym_yield_expression_token1] = ACTIONS(1284),
    [aux_sym_include_expression_token1] = ACTIONS(1284),
    [aux_sym_include_once_expression_token1] = ACTIONS(1284),
    [aux_sym_require_expression_token1] = ACTIONS(1284),
    [aux_sym_require_once_expression_token1] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [492] = {
    [ts_builtin_sym_end] = ACTIONS(1286),
    [sym_name] = ACTIONS(1288),
    [anon_sym_QMARK_GT] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(1286),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1288),
    [aux_sym_global_declaration_token1] = ACTIONS(1288),
    [aux_sym_namespace_definition_token1] = ACTIONS(1288),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1288),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1288),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1288),
    [anon_sym_BSLASH] = ACTIONS(1286),
    [anon_sym_LBRACE] = ACTIONS(1286),
    [anon_sym_RBRACE] = ACTIONS(1286),
    [aux_sym_trait_declaration_token1] = ACTIONS(1288),
    [aux_sym_interface_declaration_token1] = ACTIONS(1288),
    [aux_sym_enum_declaration_token1] = ACTIONS(1288),
    [aux_sym_enum_case_token1] = ACTIONS(1288),
    [aux_sym_class_declaration_token1] = ACTIONS(1288),
    [aux_sym_final_modifier_token1] = ACTIONS(1288),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1288),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1288),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1288),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1288),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1288),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1286),
    [aux_sym_cast_type_token1] = ACTIONS(1288),
    [aux_sym_echo_statement_token1] = ACTIONS(1288),
    [anon_sym_unset] = ACTIONS(1288),
    [aux_sym_declare_statement_token1] = ACTIONS(1288),
    [aux_sym_declare_statement_token2] = ACTIONS(1288),
    [sym_float] = ACTIONS(1288),
    [aux_sym_try_statement_token1] = ACTIONS(1288),
    [aux_sym_goto_statement_token1] = ACTIONS(1288),
    [aux_sym_continue_statement_token1] = ACTIONS(1288),
    [aux_sym_break_statement_token1] = ACTIONS(1288),
    [sym_integer] = ACTIONS(1288),
    [aux_sym_return_statement_token1] = ACTIONS(1288),
    [aux_sym_throw_expression_token1] = ACTIONS(1288),
    [aux_sym_while_statement_token1] = ACTIONS(1288),
    [aux_sym_while_statement_token2] = ACTIONS(1288),
    [aux_sym_do_statement_token1] = ACTIONS(1288),
    [aux_sym_for_statement_token1] = ACTIONS(1288),
    [aux_sym_for_statement_token2] = ACTIONS(1288),
    [aux_sym_foreach_statement_token1] = ACTIONS(1288),
    [aux_sym_foreach_statement_token2] = ACTIONS(1288),
    [aux_sym_if_statement_token1] = ACTIONS(1288),
    [aux_sym_if_statement_token2] = ACTIONS(1288),
    [aux_sym_else_if_clause_token1] = ACTIONS(1288),
    [aux_sym_else_clause_token1] = ACTIONS(1288),
    [aux_sym_match_expression_token1] = ACTIONS(1288),
    [aux_sym_match_default_expression_token1] = ACTIONS(1288),
    [aux_sym_switch_statement_token1] = ACTIONS(1288),
    [aux_sym_switch_block_token1] = ACTIONS(1288),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_TILDE] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1286),
    [anon_sym_AT] = ACTIONS(1286),
    [aux_sym_clone_expression_token1] = ACTIONS(1288),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1288),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1288),
    [anon_sym_DASH_DASH] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1286),
    [aux_sym__list_destructing_token1] = ACTIONS(1288),
    [anon_sym_LBRACK] = ACTIONS(1286),
    [anon_sym_self] = ACTIONS(1288),
    [anon_sym_parent] = ACTIONS(1288),
    [aux_sym__argument_name_token1] = ACTIONS(1288),
    [aux_sym__argument_name_token2] = ACTIONS(1288),
    [anon_sym_POUND_LBRACK] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [aux_sym_encapsed_string_token1] = ACTIONS(1286),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [aux_sym_string_token1] = ACTIONS(1286),
    [anon_sym_LT_LT_LT] = ACTIONS(1286),
    [anon_sym_BQUOTE] = ACTIONS(1286),
    [anon_sym_DOLLAR] = ACTIONS(1286),
    [aux_sym_yield_expression_token1] = ACTIONS(1288),
    [aux_sym_include_expression_token1] = ACTIONS(1288),
    [aux_sym_include_once_expression_token1] = ACTIONS(1288),
    [aux_sym_require_expression_token1] = ACTIONS(1288),
    [aux_sym_require_once_expression_token1] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
  },
  [493] = {
    [ts_builtin_sym_end] = ACTIONS(1290),
    [sym_name] = ACTIONS(1292),
    [anon_sym_QMARK_GT] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1290),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1292),
    [aux_sym_global_declaration_token1] = ACTIONS(1292),
    [aux_sym_namespace_definition_token1] = ACTIONS(1292),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1292),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1292),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1292),
    [anon_sym_BSLASH] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [aux_sym_trait_declaration_token1] = ACTIONS(1292),
    [aux_sym_interface_declaration_token1] = ACTIONS(1292),
    [aux_sym_enum_declaration_token1] = ACTIONS(1292),
    [aux_sym_enum_case_token1] = ACTIONS(1292),
    [aux_sym_class_declaration_token1] = ACTIONS(1292),
    [aux_sym_final_modifier_token1] = ACTIONS(1292),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1292),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1292),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1292),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1292),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1292),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1292),
    [anon_sym_LPAREN] = ACTIONS(1290),
    [aux_sym_cast_type_token1] = ACTIONS(1292),
    [aux_sym_echo_statement_token1] = ACTIONS(1292),
    [anon_sym_unset] = ACTIONS(1292),
    [aux_sym_declare_statement_token1] = ACTIONS(1292),
    [aux_sym_declare_statement_token2] = ACTIONS(1292),
    [sym_float] = ACTIONS(1292),
    [aux_sym_try_statement_token1] = ACTIONS(1292),
    [aux_sym_goto_statement_token1] = ACTIONS(1292),
    [aux_sym_continue_statement_token1] = ACTIONS(1292),
    [aux_sym_break_statement_token1] = ACTIONS(1292),
    [sym_integer] = ACTIONS(1292),
    [aux_sym_return_statement_token1] = ACTIONS(1292),
    [aux_sym_throw_expression_token1] = ACTIONS(1292),
    [aux_sym_while_statement_token1] = ACTIONS(1292),
    [aux_sym_while_statement_token2] = ACTIONS(1292),
    [aux_sym_do_statement_token1] = ACTIONS(1292),
    [aux_sym_for_statement_token1] = ACTIONS(1292),
    [aux_sym_for_statement_token2] = ACTIONS(1292),
    [aux_sym_foreach_statement_token1] = ACTIONS(1292),
    [aux_sym_foreach_statement_token2] = ACTIONS(1292),
    [aux_sym_if_statement_token1] = ACTIONS(1292),
    [aux_sym_if_statement_token2] = ACTIONS(1292),
    [aux_sym_else_if_clause_token1] = ACTIONS(1292),
    [aux_sym_else_clause_token1] = ACTIONS(1292),
    [aux_sym_match_expression_token1] = ACTIONS(1292),
    [aux_sym_match_default_expression_token1] = ACTIONS(1292),
    [aux_sym_switch_statement_token1] = ACTIONS(1292),
    [aux_sym_switch_block_token1] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_TILDE] = ACTIONS(1290),
    [anon_sym_BANG] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(1290),
    [aux_sym_clone_expression_token1] = ACTIONS(1292),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1292),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [aux_sym__list_destructing_token1] = ACTIONS(1292),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_self] = ACTIONS(1292),
    [anon_sym_parent] = ACTIONS(1292),
    [aux_sym__argument_name_token1] = ACTIONS(1292),
    [aux_sym__argument_name_token2] = ACTIONS(1292),
    [anon_sym_POUND_LBRACK] = ACTIONS(1290),
    [anon_sym_SQUOTE] = ACTIONS(1290),
    [aux_sym_encapsed_string_token1] = ACTIONS(1290),
    [anon_sym_DQUOTE] = ACTIONS(1290),
    [aux_sym_string_token1] = ACTIONS(1290),
    [anon_sym_LT_LT_LT] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_DOLLAR] = ACTIONS(1290),
    [aux_sym_yield_expression_token1] = ACTIONS(1292),
    [aux_sym_include_expression_token1] = ACTIONS(1292),
    [aux_sym_include_once_expression_token1] = ACTIONS(1292),
    [aux_sym_require_expression_token1] = ACTIONS(1292),
    [aux_sym_require_once_expression_token1] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
  },
  [494] = {
    [ts_builtin_sym_end] = ACTIONS(1294),
    [sym_name] = ACTIONS(1296),
    [anon_sym_QMARK_GT] = ACTIONS(1294),
    [anon_sym_SEMI] = ACTIONS(1294),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1296),
    [aux_sym_global_declaration_token1] = ACTIONS(1296),
    [aux_sym_namespace_definition_token1] = ACTIONS(1296),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1296),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1296),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1296),
    [anon_sym_BSLASH] = ACTIONS(1294),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_RBRACE] = ACTIONS(1294),
    [aux_sym_trait_declaration_token1] = ACTIONS(1296),
    [aux_sym_interface_declaration_token1] = ACTIONS(1296),
    [aux_sym_enum_declaration_token1] = ACTIONS(1296),
    [aux_sym_enum_case_token1] = ACTIONS(1296),
    [aux_sym_class_declaration_token1] = ACTIONS(1296),
    [aux_sym_final_modifier_token1] = ACTIONS(1296),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1296),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1296),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1296),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1296),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1296),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1296),
    [anon_sym_LPAREN] = ACTIONS(1294),
    [aux_sym_cast_type_token1] = ACTIONS(1296),
    [aux_sym_echo_statement_token1] = ACTIONS(1296),
    [anon_sym_unset] = ACTIONS(1296),
    [aux_sym_declare_statement_token1] = ACTIONS(1296),
    [aux_sym_declare_statement_token2] = ACTIONS(1296),
    [sym_float] = ACTIONS(1296),
    [aux_sym_try_statement_token1] = ACTIONS(1296),
    [aux_sym_goto_statement_token1] = ACTIONS(1296),
    [aux_sym_continue_statement_token1] = ACTIONS(1296),
    [aux_sym_break_statement_token1] = ACTIONS(1296),
    [sym_integer] = ACTIONS(1296),
    [aux_sym_return_statement_token1] = ACTIONS(1296),
    [aux_sym_throw_expression_token1] = ACTIONS(1296),
    [aux_sym_while_statement_token1] = ACTIONS(1296),
    [aux_sym_while_statement_token2] = ACTIONS(1296),
    [aux_sym_do_statement_token1] = ACTIONS(1296),
    [aux_sym_for_statement_token1] = ACTIONS(1296),
    [aux_sym_for_statement_token2] = ACTIONS(1296),
    [aux_sym_foreach_statement_token1] = ACTIONS(1296),
    [aux_sym_foreach_statement_token2] = ACTIONS(1296),
    [aux_sym_if_statement_token1] = ACTIONS(1296),
    [aux_sym_if_statement_token2] = ACTIONS(1296),
    [aux_sym_else_if_clause_token1] = ACTIONS(1296),
    [aux_sym_else_clause_token1] = ACTIONS(1296),
    [aux_sym_match_expression_token1] = ACTIONS(1296),
    [aux_sym_match_default_expression_token1] = ACTIONS(1296),
    [aux_sym_switch_statement_token1] = ACTIONS(1296),
    [aux_sym_switch_block_token1] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1296),
    [anon_sym_DASH] = ACTIONS(1296),
    [anon_sym_TILDE] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_AT] = ACTIONS(1294),
    [aux_sym_clone_expression_token1] = ACTIONS(1296),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1296),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1296),
    [anon_sym_DASH_DASH] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1294),
    [aux_sym__list_destructing_token1] = ACTIONS(1296),
    [anon_sym_LBRACK] = ACTIONS(1294),
    [anon_sym_self] = ACTIONS(1296),
    [anon_sym_parent] = ACTIONS(1296),
    [aux_sym__argument_name_token1] = ACTIONS(1296),
    [aux_sym__argument_name_token2] = ACTIONS(1296),
    [anon_sym_POUND_LBRACK] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [aux_sym_encapsed_string_token1] = ACTIONS(1294),
    [anon_sym_DQUOTE] = ACTIONS(1294),
    [aux_sym_string_token1] = ACTIONS(1294),
    [anon_sym_LT_LT_LT] = ACTIONS(1294),
    [anon_sym_BQUOTE] = ACTIONS(1294),
    [anon_sym_DOLLAR] = ACTIONS(1294),
    [aux_sym_yield_expression_token1] = ACTIONS(1296),
    [aux_sym_include_expression_token1] = ACTIONS(1296),
    [aux_sym_include_once_expression_token1] = ACTIONS(1296),
    [aux_sym_require_expression_token1] = ACTIONS(1296),
    [aux_sym_require_once_expression_token1] = ACTIONS(1296),
    [sym_comment] = ACTIONS(3),
  },
  [495] = {
    [ts_builtin_sym_end] = ACTIONS(1298),
    [sym_name] = ACTIONS(1300),
    [anon_sym_QMARK_GT] = ACTIONS(1298),
    [anon_sym_SEMI] = ACTIONS(1298),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1300),
    [aux_sym_global_declaration_token1] = ACTIONS(1300),
    [aux_sym_namespace_definition_token1] = ACTIONS(1300),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1300),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1300),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1300),
    [anon_sym_BSLASH] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1298),
    [anon_sym_RBRACE] = ACTIONS(1298),
    [aux_sym_trait_declaration_token1] = ACTIONS(1300),
    [aux_sym_interface_declaration_token1] = ACTIONS(1300),
    [aux_sym_enum_declaration_token1] = ACTIONS(1300),
    [aux_sym_enum_case_token1] = ACTIONS(1300),
    [aux_sym_class_declaration_token1] = ACTIONS(1300),
    [aux_sym_final_modifier_token1] = ACTIONS(1300),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1300),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1300),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1300),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1300),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1300),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1298),
    [aux_sym_cast_type_token1] = ACTIONS(1300),
    [aux_sym_echo_statement_token1] = ACTIONS(1300),
    [anon_sym_unset] = ACTIONS(1300),
    [aux_sym_declare_statement_token1] = ACTIONS(1300),
    [aux_sym_declare_statement_token2] = ACTIONS(1300),
    [sym_float] = ACTIONS(1300),
    [aux_sym_try_statement_token1] = ACTIONS(1300),
    [aux_sym_goto_statement_token1] = ACTIONS(1300),
    [aux_sym_continue_statement_token1] = ACTIONS(1300),
    [aux_sym_break_statement_token1] = ACTIONS(1300),
    [sym_integer] = ACTIONS(1300),
    [aux_sym_return_statement_token1] = ACTIONS(1300),
    [aux_sym_throw_expression_token1] = ACTIONS(1300),
    [aux_sym_while_statement_token1] = ACTIONS(1300),
    [aux_sym_while_statement_token2] = ACTIONS(1300),
    [aux_sym_do_statement_token1] = ACTIONS(1300),
    [aux_sym_for_statement_token1] = ACTIONS(1300),
    [aux_sym_for_statement_token2] = ACTIONS(1300),
    [aux_sym_foreach_statement_token1] = ACTIONS(1300),
    [aux_sym_foreach_statement_token2] = ACTIONS(1300),
    [aux_sym_if_statement_token1] = ACTIONS(1300),
    [aux_sym_if_statement_token2] = ACTIONS(1300),
    [aux_sym_else_if_clause_token1] = ACTIONS(1300),
    [aux_sym_else_clause_token1] = ACTIONS(1300),
    [aux_sym_match_expression_token1] = ACTIONS(1300),
    [aux_sym_match_default_expression_token1] = ACTIONS(1300),
    [aux_sym_switch_statement_token1] = ACTIONS(1300),
    [aux_sym_switch_block_token1] = ACTIONS(1300),
    [anon_sym_PLUS] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1298),
    [anon_sym_BANG] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(1298),
    [aux_sym_clone_expression_token1] = ACTIONS(1300),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1300),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1300),
    [anon_sym_DASH_DASH] = ACTIONS(1298),
    [anon_sym_PLUS_PLUS] = ACTIONS(1298),
    [aux_sym__list_destructing_token1] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1298),
    [anon_sym_self] = ACTIONS(1300),
    [anon_sym_parent] = ACTIONS(1300),
    [aux_sym__argument_name_token1] = ACTIONS(1300),
    [aux_sym__argument_name_token2] = ACTIONS(1300),
    [anon_sym_POUND_LBRACK] = ACTIONS(1298),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [aux_sym_encapsed_string_token1] = ACTIONS(1298),
    [anon_sym_DQUOTE] = ACTIONS(1298),
    [aux_sym_string_token1] = ACTIONS(1298),
    [anon_sym_LT_LT_LT] = ACTIONS(1298),
    [anon_sym_BQUOTE] = ACTIONS(1298),
    [anon_sym_DOLLAR] = ACTIONS(1298),
    [aux_sym_yield_expression_token1] = ACTIONS(1300),
    [aux_sym_include_expression_token1] = ACTIONS(1300),
    [aux_sym_include_once_expression_token1] = ACTIONS(1300),
    [aux_sym_require_expression_token1] = ACTIONS(1300),
    [aux_sym_require_once_expression_token1] = ACTIONS(1300),
    [sym_comment] = ACTIONS(3),
  },
  [496] = {
    [ts_builtin_sym_end] = ACTIONS(1302),
    [sym_name] = ACTIONS(1304),
    [anon_sym_QMARK_GT] = ACTIONS(1302),
    [anon_sym_SEMI] = ACTIONS(1302),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1304),
    [aux_sym_global_declaration_token1] = ACTIONS(1304),
    [aux_sym_namespace_definition_token1] = ACTIONS(1304),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1304),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1304),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1304),
    [anon_sym_BSLASH] = ACTIONS(1302),
    [anon_sym_LBRACE] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(1302),
    [aux_sym_trait_declaration_token1] = ACTIONS(1304),
    [aux_sym_interface_declaration_token1] = ACTIONS(1304),
    [aux_sym_enum_declaration_token1] = ACTIONS(1304),
    [aux_sym_enum_case_token1] = ACTIONS(1304),
    [aux_sym_class_declaration_token1] = ACTIONS(1304),
    [aux_sym_final_modifier_token1] = ACTIONS(1304),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1304),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1304),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1304),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1304),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1304),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1302),
    [aux_sym_cast_type_token1] = ACTIONS(1304),
    [aux_sym_echo_statement_token1] = ACTIONS(1304),
    [anon_sym_unset] = ACTIONS(1304),
    [aux_sym_declare_statement_token1] = ACTIONS(1304),
    [aux_sym_declare_statement_token2] = ACTIONS(1304),
    [sym_float] = ACTIONS(1304),
    [aux_sym_try_statement_token1] = ACTIONS(1304),
    [aux_sym_goto_statement_token1] = ACTIONS(1304),
    [aux_sym_continue_statement_token1] = ACTIONS(1304),
    [aux_sym_break_statement_token1] = ACTIONS(1304),
    [sym_integer] = ACTIONS(1304),
    [aux_sym_return_statement_token1] = ACTIONS(1304),
    [aux_sym_throw_expression_token1] = ACTIONS(1304),
    [aux_sym_while_statement_token1] = ACTIONS(1304),
    [aux_sym_while_statement_token2] = ACTIONS(1304),
    [aux_sym_do_statement_token1] = ACTIONS(1304),
    [aux_sym_for_statement_token1] = ACTIONS(1304),
    [aux_sym_for_statement_token2] = ACTIONS(1304),
    [aux_sym_foreach_statement_token1] = ACTIONS(1304),
    [aux_sym_foreach_statement_token2] = ACTIONS(1304),
    [aux_sym_if_statement_token1] = ACTIONS(1304),
    [aux_sym_if_statement_token2] = ACTIONS(1304),
    [aux_sym_else_if_clause_token1] = ACTIONS(1304),
    [aux_sym_else_clause_token1] = ACTIONS(1304),
    [aux_sym_match_expression_token1] = ACTIONS(1304),
    [aux_sym_match_default_expression_token1] = ACTIONS(1304),
    [aux_sym_switch_statement_token1] = ACTIONS(1304),
    [aux_sym_switch_block_token1] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(1302),
    [anon_sym_BANG] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(1302),
    [aux_sym_clone_expression_token1] = ACTIONS(1304),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1304),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(1302),
    [anon_sym_PLUS_PLUS] = ACTIONS(1302),
    [aux_sym__list_destructing_token1] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [anon_sym_self] = ACTIONS(1304),
    [anon_sym_parent] = ACTIONS(1304),
    [aux_sym__argument_name_token1] = ACTIONS(1304),
    [aux_sym__argument_name_token2] = ACTIONS(1304),
    [anon_sym_POUND_LBRACK] = ACTIONS(1302),
    [anon_sym_SQUOTE] = ACTIONS(1302),
    [aux_sym_encapsed_string_token1] = ACTIONS(1302),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [aux_sym_string_token1] = ACTIONS(1302),
    [anon_sym_LT_LT_LT] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [aux_sym_yield_expression_token1] = ACTIONS(1304),
    [aux_sym_include_expression_token1] = ACTIONS(1304),
    [aux_sym_include_once_expression_token1] = ACTIONS(1304),
    [aux_sym_require_expression_token1] = ACTIONS(1304),
    [aux_sym_require_once_expression_token1] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
  },
  [497] = {
    [ts_builtin_sym_end] = ACTIONS(1306),
    [sym_name] = ACTIONS(1308),
    [anon_sym_QMARK_GT] = ACTIONS(1306),
    [anon_sym_SEMI] = ACTIONS(1306),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1308),
    [aux_sym_global_declaration_token1] = ACTIONS(1308),
    [aux_sym_namespace_definition_token1] = ACTIONS(1308),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1308),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1308),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1308),
    [anon_sym_BSLASH] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1306),
    [anon_sym_RBRACE] = ACTIONS(1306),
    [aux_sym_trait_declaration_token1] = ACTIONS(1308),
    [aux_sym_interface_declaration_token1] = ACTIONS(1308),
    [aux_sym_enum_declaration_token1] = ACTIONS(1308),
    [aux_sym_enum_case_token1] = ACTIONS(1308),
    [aux_sym_class_declaration_token1] = ACTIONS(1308),
    [aux_sym_final_modifier_token1] = ACTIONS(1308),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1308),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1308),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1308),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1308),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1308),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1308),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [aux_sym_cast_type_token1] = ACTIONS(1308),
    [aux_sym_echo_statement_token1] = ACTIONS(1308),
    [anon_sym_unset] = ACTIONS(1308),
    [aux_sym_declare_statement_token1] = ACTIONS(1308),
    [aux_sym_declare_statement_token2] = ACTIONS(1308),
    [sym_float] = ACTIONS(1308),
    [aux_sym_try_statement_token1] = ACTIONS(1308),
    [aux_sym_goto_statement_token1] = ACTIONS(1308),
    [aux_sym_continue_statement_token1] = ACTIONS(1308),
    [aux_sym_break_statement_token1] = ACTIONS(1308),
    [sym_integer] = ACTIONS(1308),
    [aux_sym_return_statement_token1] = ACTIONS(1308),
    [aux_sym_throw_expression_token1] = ACTIONS(1308),
    [aux_sym_while_statement_token1] = ACTIONS(1308),
    [aux_sym_while_statement_token2] = ACTIONS(1308),
    [aux_sym_do_statement_token1] = ACTIONS(1308),
    [aux_sym_for_statement_token1] = ACTIONS(1308),
    [aux_sym_for_statement_token2] = ACTIONS(1308),
    [aux_sym_foreach_statement_token1] = ACTIONS(1308),
    [aux_sym_foreach_statement_token2] = ACTIONS(1308),
    [aux_sym_if_statement_token1] = ACTIONS(1308),
    [aux_sym_if_statement_token2] = ACTIONS(1308),
    [aux_sym_else_if_clause_token1] = ACTIONS(1308),
    [aux_sym_else_clause_token1] = ACTIONS(1308),
    [aux_sym_match_expression_token1] = ACTIONS(1308),
    [aux_sym_match_default_expression_token1] = ACTIONS(1308),
    [aux_sym_switch_statement_token1] = ACTIONS(1308),
    [aux_sym_switch_block_token1] = ACTIONS(1308),
    [anon_sym_PLUS] = ACTIONS(1308),
    [anon_sym_DASH] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(1306),
    [anon_sym_BANG] = ACTIONS(1306),
    [anon_sym_AT] = ACTIONS(1306),
    [aux_sym_clone_expression_token1] = ACTIONS(1308),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1308),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1308),
    [anon_sym_DASH_DASH] = ACTIONS(1306),
    [anon_sym_PLUS_PLUS] = ACTIONS(1306),
    [aux_sym__list_destructing_token1] = ACTIONS(1308),
    [anon_sym_LBRACK] = ACTIONS(1306),
    [anon_sym_self] = ACTIONS(1308),
    [anon_sym_parent] = ACTIONS(1308),
    [aux_sym__argument_name_token1] = ACTIONS(1308),
    [aux_sym__argument_name_token2] = ACTIONS(1308),
    [anon_sym_POUND_LBRACK] = ACTIONS(1306),
    [anon_sym_SQUOTE] = ACTIONS(1306),
    [aux_sym_encapsed_string_token1] = ACTIONS(1306),
    [anon_sym_DQUOTE] = ACTIONS(1306),
    [aux_sym_string_token1] = ACTIONS(1306),
    [anon_sym_LT_LT_LT] = ACTIONS(1306),
    [anon_sym_BQUOTE] = ACTIONS(1306),
    [anon_sym_DOLLAR] = ACTIONS(1306),
    [aux_sym_yield_expression_token1] = ACTIONS(1308),
    [aux_sym_include_expression_token1] = ACTIONS(1308),
    [aux_sym_include_once_expression_token1] = ACTIONS(1308),
    [aux_sym_require_expression_token1] = ACTIONS(1308),
    [aux_sym_require_once_expression_token1] = ACTIONS(1308),
    [sym_comment] = ACTIONS(3),
  },
  [498] = {
    [ts_builtin_sym_end] = ACTIONS(1310),
    [sym_name] = ACTIONS(1312),
    [anon_sym_QMARK_GT] = ACTIONS(1310),
    [anon_sym_SEMI] = ACTIONS(1310),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1312),
    [aux_sym_global_declaration_token1] = ACTIONS(1312),
    [aux_sym_namespace_definition_token1] = ACTIONS(1312),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1312),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1312),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1312),
    [anon_sym_BSLASH] = ACTIONS(1310),
    [anon_sym_LBRACE] = ACTIONS(1310),
    [anon_sym_RBRACE] = ACTIONS(1310),
    [aux_sym_trait_declaration_token1] = ACTIONS(1312),
    [aux_sym_interface_declaration_token1] = ACTIONS(1312),
    [aux_sym_enum_declaration_token1] = ACTIONS(1312),
    [aux_sym_enum_case_token1] = ACTIONS(1312),
    [aux_sym_class_declaration_token1] = ACTIONS(1312),
    [aux_sym_final_modifier_token1] = ACTIONS(1312),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1312),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1312),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1312),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1312),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1312),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1310),
    [aux_sym_cast_type_token1] = ACTIONS(1312),
    [aux_sym_echo_statement_token1] = ACTIONS(1312),
    [anon_sym_unset] = ACTIONS(1312),
    [aux_sym_declare_statement_token1] = ACTIONS(1312),
    [aux_sym_declare_statement_token2] = ACTIONS(1312),
    [sym_float] = ACTIONS(1312),
    [aux_sym_try_statement_token1] = ACTIONS(1312),
    [aux_sym_goto_statement_token1] = ACTIONS(1312),
    [aux_sym_continue_statement_token1] = ACTIONS(1312),
    [aux_sym_break_statement_token1] = ACTIONS(1312),
    [sym_integer] = ACTIONS(1312),
    [aux_sym_return_statement_token1] = ACTIONS(1312),
    [aux_sym_throw_expression_token1] = ACTIONS(1312),
    [aux_sym_while_statement_token1] = ACTIONS(1312),
    [aux_sym_while_statement_token2] = ACTIONS(1312),
    [aux_sym_do_statement_token1] = ACTIONS(1312),
    [aux_sym_for_statement_token1] = ACTIONS(1312),
    [aux_sym_for_statement_token2] = ACTIONS(1312),
    [aux_sym_foreach_statement_token1] = ACTIONS(1312),
    [aux_sym_foreach_statement_token2] = ACTIONS(1312),
    [aux_sym_if_statement_token1] = ACTIONS(1312),
    [aux_sym_if_statement_token2] = ACTIONS(1312),
    [aux_sym_else_if_clause_token1] = ACTIONS(1312),
    [aux_sym_else_clause_token1] = ACTIONS(1312),
    [aux_sym_match_expression_token1] = ACTIONS(1312),
    [aux_sym_match_default_expression_token1] = ACTIONS(1312),
    [aux_sym_switch_statement_token1] = ACTIONS(1312),
    [aux_sym_switch_block_token1] = ACTIONS(1312),
    [anon_sym_PLUS] = ACTIONS(1312),
    [anon_sym_DASH] = ACTIONS(1312),
    [anon_sym_TILDE] = ACTIONS(1310),
    [anon_sym_BANG] = ACTIONS(1310),
    [anon_sym_AT] = ACTIONS(1310),
    [aux_sym_clone_expression_token1] = ACTIONS(1312),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1312),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1312),
    [anon_sym_DASH_DASH] = ACTIONS(1310),
    [anon_sym_PLUS_PLUS] = ACTIONS(1310),
    [aux_sym__list_destructing_token1] = ACTIONS(1312),
    [anon_sym_LBRACK] = ACTIONS(1310),
    [anon_sym_self] = ACTIONS(1312),
    [anon_sym_parent] = ACTIONS(1312),
    [aux_sym__argument_name_token1] = ACTIONS(1312),
    [aux_sym__argument_name_token2] = ACTIONS(1312),
    [anon_sym_POUND_LBRACK] = ACTIONS(1310),
    [anon_sym_SQUOTE] = ACTIONS(1310),
    [aux_sym_encapsed_string_token1] = ACTIONS(1310),
    [anon_sym_DQUOTE] = ACTIONS(1310),
    [aux_sym_string_token1] = ACTIONS(1310),
    [anon_sym_LT_LT_LT] = ACTIONS(1310),
    [anon_sym_BQUOTE] = ACTIONS(1310),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [aux_sym_yield_expression_token1] = ACTIONS(1312),
    [aux_sym_include_expression_token1] = ACTIONS(1312),
    [aux_sym_include_once_expression_token1] = ACTIONS(1312),
    [aux_sym_require_expression_token1] = ACTIONS(1312),
    [aux_sym_require_once_expression_token1] = ACTIONS(1312),
    [sym_comment] = ACTIONS(3),
  },
  [499] = {
    [ts_builtin_sym_end] = ACTIONS(1314),
    [sym_name] = ACTIONS(1316),
    [anon_sym_QMARK_GT] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1314),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1316),
    [aux_sym_global_declaration_token1] = ACTIONS(1316),
    [aux_sym_namespace_definition_token1] = ACTIONS(1316),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1316),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1316),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1316),
    [anon_sym_BSLASH] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1314),
    [anon_sym_RBRACE] = ACTIONS(1314),
    [aux_sym_trait_declaration_token1] = ACTIONS(1316),
    [aux_sym_interface_declaration_token1] = ACTIONS(1316),
    [aux_sym_enum_declaration_token1] = ACTIONS(1316),
    [aux_sym_enum_case_token1] = ACTIONS(1316),
    [aux_sym_class_declaration_token1] = ACTIONS(1316),
    [aux_sym_final_modifier_token1] = ACTIONS(1316),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1316),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1316),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1316),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1316),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1316),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_cast_type_token1] = ACTIONS(1316),
    [aux_sym_echo_statement_token1] = ACTIONS(1316),
    [anon_sym_unset] = ACTIONS(1316),
    [aux_sym_declare_statement_token1] = ACTIONS(1316),
    [aux_sym_declare_statement_token2] = ACTIONS(1316),
    [sym_float] = ACTIONS(1316),
    [aux_sym_try_statement_token1] = ACTIONS(1316),
    [aux_sym_goto_statement_token1] = ACTIONS(1316),
    [aux_sym_continue_statement_token1] = ACTIONS(1316),
    [aux_sym_break_statement_token1] = ACTIONS(1316),
    [sym_integer] = ACTIONS(1316),
    [aux_sym_return_statement_token1] = ACTIONS(1316),
    [aux_sym_throw_expression_token1] = ACTIONS(1316),
    [aux_sym_while_statement_token1] = ACTIONS(1316),
    [aux_sym_while_statement_token2] = ACTIONS(1316),
    [aux_sym_do_statement_token1] = ACTIONS(1316),
    [aux_sym_for_statement_token1] = ACTIONS(1316),
    [aux_sym_for_statement_token2] = ACTIONS(1316),
    [aux_sym_foreach_statement_token1] = ACTIONS(1316),
    [aux_sym_foreach_statement_token2] = ACTIONS(1316),
    [aux_sym_if_statement_token1] = ACTIONS(1316),
    [aux_sym_if_statement_token2] = ACTIONS(1316),
    [aux_sym_else_if_clause_token1] = ACTIONS(1316),
    [aux_sym_else_clause_token1] = ACTIONS(1316),
    [aux_sym_match_expression_token1] = ACTIONS(1316),
    [aux_sym_match_default_expression_token1] = ACTIONS(1316),
    [aux_sym_switch_statement_token1] = ACTIONS(1316),
    [aux_sym_switch_block_token1] = ACTIONS(1316),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1314),
    [anon_sym_BANG] = ACTIONS(1314),
    [anon_sym_AT] = ACTIONS(1314),
    [aux_sym_clone_expression_token1] = ACTIONS(1316),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1316),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1316),
    [anon_sym_DASH_DASH] = ACTIONS(1314),
    [anon_sym_PLUS_PLUS] = ACTIONS(1314),
    [aux_sym__list_destructing_token1] = ACTIONS(1316),
    [anon_sym_LBRACK] = ACTIONS(1314),
    [anon_sym_self] = ACTIONS(1316),
    [anon_sym_parent] = ACTIONS(1316),
    [aux_sym__argument_name_token1] = ACTIONS(1316),
    [aux_sym__argument_name_token2] = ACTIONS(1316),
    [anon_sym_POUND_LBRACK] = ACTIONS(1314),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [aux_sym_encapsed_string_token1] = ACTIONS(1314),
    [anon_sym_DQUOTE] = ACTIONS(1314),
    [aux_sym_string_token1] = ACTIONS(1314),
    [anon_sym_LT_LT_LT] = ACTIONS(1314),
    [anon_sym_BQUOTE] = ACTIONS(1314),
    [anon_sym_DOLLAR] = ACTIONS(1314),
    [aux_sym_yield_expression_token1] = ACTIONS(1316),
    [aux_sym_include_expression_token1] = ACTIONS(1316),
    [aux_sym_include_once_expression_token1] = ACTIONS(1316),
    [aux_sym_require_expression_token1] = ACTIONS(1316),
    [aux_sym_require_once_expression_token1] = ACTIONS(1316),
    [sym_comment] = ACTIONS(3),
  },
  [500] = {
    [ts_builtin_sym_end] = ACTIONS(1318),
    [sym_name] = ACTIONS(1320),
    [anon_sym_QMARK_GT] = ACTIONS(1318),
    [anon_sym_SEMI] = ACTIONS(1318),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1320),
    [aux_sym_global_declaration_token1] = ACTIONS(1320),
    [aux_sym_namespace_definition_token1] = ACTIONS(1320),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1320),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1320),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1320),
    [anon_sym_BSLASH] = ACTIONS(1318),
    [anon_sym_LBRACE] = ACTIONS(1318),
    [anon_sym_RBRACE] = ACTIONS(1318),
    [aux_sym_trait_declaration_token1] = ACTIONS(1320),
    [aux_sym_interface_declaration_token1] = ACTIONS(1320),
    [aux_sym_enum_declaration_token1] = ACTIONS(1320),
    [aux_sym_enum_case_token1] = ACTIONS(1320),
    [aux_sym_class_declaration_token1] = ACTIONS(1320),
    [aux_sym_final_modifier_token1] = ACTIONS(1320),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1320),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1320),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1320),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1320),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1320),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1320),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [aux_sym_cast_type_token1] = ACTIONS(1320),
    [aux_sym_echo_statement_token1] = ACTIONS(1320),
    [anon_sym_unset] = ACTIONS(1320),
    [aux_sym_declare_statement_token1] = ACTIONS(1320),
    [aux_sym_declare_statement_token2] = ACTIONS(1320),
    [sym_float] = ACTIONS(1320),
    [aux_sym_try_statement_token1] = ACTIONS(1320),
    [aux_sym_goto_statement_token1] = ACTIONS(1320),
    [aux_sym_continue_statement_token1] = ACTIONS(1320),
    [aux_sym_break_statement_token1] = ACTIONS(1320),
    [sym_integer] = ACTIONS(1320),
    [aux_sym_return_statement_token1] = ACTIONS(1320),
    [aux_sym_throw_expression_token1] = ACTIONS(1320),
    [aux_sym_while_statement_token1] = ACTIONS(1320),
    [aux_sym_while_statement_token2] = ACTIONS(1320),
    [aux_sym_do_statement_token1] = ACTIONS(1320),
    [aux_sym_for_statement_token1] = ACTIONS(1320),
    [aux_sym_for_statement_token2] = ACTIONS(1320),
    [aux_sym_foreach_statement_token1] = ACTIONS(1320),
    [aux_sym_foreach_statement_token2] = ACTIONS(1320),
    [aux_sym_if_statement_token1] = ACTIONS(1320),
    [aux_sym_if_statement_token2] = ACTIONS(1320),
    [aux_sym_else_if_clause_token1] = ACTIONS(1320),
    [aux_sym_else_clause_token1] = ACTIONS(1320),
    [aux_sym_match_expression_token1] = ACTIONS(1320),
    [aux_sym_match_default_expression_token1] = ACTIONS(1320),
    [aux_sym_switch_statement_token1] = ACTIONS(1320),
    [aux_sym_switch_block_token1] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1320),
    [anon_sym_DASH] = ACTIONS(1320),
    [anon_sym_TILDE] = ACTIONS(1318),
    [anon_sym_BANG] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1318),
    [aux_sym_clone_expression_token1] = ACTIONS(1320),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1320),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1318),
    [anon_sym_PLUS_PLUS] = ACTIONS(1318),
    [aux_sym__list_destructing_token1] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1318),
    [anon_sym_self] = ACTIONS(1320),
    [anon_sym_parent] = ACTIONS(1320),
    [aux_sym__argument_name_token1] = ACTIONS(1320),
    [aux_sym__argument_name_token2] = ACTIONS(1320),
    [anon_sym_POUND_LBRACK] = ACTIONS(1318),
    [anon_sym_SQUOTE] = ACTIONS(1318),
    [aux_sym_encapsed_string_token1] = ACTIONS(1318),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [aux_sym_string_token1] = ACTIONS(1318),
    [anon_sym_LT_LT_LT] = ACTIONS(1318),
    [anon_sym_BQUOTE] = ACTIONS(1318),
    [anon_sym_DOLLAR] = ACTIONS(1318),
    [aux_sym_yield_expression_token1] = ACTIONS(1320),
    [aux_sym_include_expression_token1] = ACTIONS(1320),
    [aux_sym_include_once_expression_token1] = ACTIONS(1320),
    [aux_sym_require_expression_token1] = ACTIONS(1320),
    [aux_sym_require_once_expression_token1] = ACTIONS(1320),
    [sym_comment] = ACTIONS(3),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(1322),
    [sym_name] = ACTIONS(1324),
    [anon_sym_QMARK_GT] = ACTIONS(1322),
    [anon_sym_SEMI] = ACTIONS(1322),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1324),
    [aux_sym_global_declaration_token1] = ACTIONS(1324),
    [aux_sym_namespace_definition_token1] = ACTIONS(1324),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1324),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1324),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1324),
    [anon_sym_BSLASH] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1322),
    [aux_sym_trait_declaration_token1] = ACTIONS(1324),
    [aux_sym_interface_declaration_token1] = ACTIONS(1324),
    [aux_sym_enum_declaration_token1] = ACTIONS(1324),
    [aux_sym_enum_case_token1] = ACTIONS(1324),
    [aux_sym_class_declaration_token1] = ACTIONS(1324),
    [aux_sym_final_modifier_token1] = ACTIONS(1324),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1324),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1324),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1324),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1324),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1324),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(1322),
    [aux_sym_cast_type_token1] = ACTIONS(1324),
    [aux_sym_echo_statement_token1] = ACTIONS(1324),
    [anon_sym_unset] = ACTIONS(1324),
    [aux_sym_declare_statement_token1] = ACTIONS(1324),
    [aux_sym_declare_statement_token2] = ACTIONS(1324),
    [sym_float] = ACTIONS(1324),
    [aux_sym_try_statement_token1] = ACTIONS(1324),
    [aux_sym_goto_statement_token1] = ACTIONS(1324),
    [aux_sym_continue_statement_token1] = ACTIONS(1324),
    [aux_sym_break_statement_token1] = ACTIONS(1324),
    [sym_integer] = ACTIONS(1324),
    [aux_sym_return_statement_token1] = ACTIONS(1324),
    [aux_sym_throw_expression_token1] = ACTIONS(1324),
    [aux_sym_while_statement_token1] = ACTIONS(1324),
    [aux_sym_while_statement_token2] = ACTIONS(1324),
    [aux_sym_do_statement_token1] = ACTIONS(1324),
    [aux_sym_for_statement_token1] = ACTIONS(1324),
    [aux_sym_for_statement_token2] = ACTIONS(1324),
    [aux_sym_foreach_statement_token1] = ACTIONS(1324),
    [aux_sym_foreach_statement_token2] = ACTIONS(1324),
    [aux_sym_if_statement_token1] = ACTIONS(1324),
    [aux_sym_if_statement_token2] = ACTIONS(1324),
    [aux_sym_else_if_clause_token1] = ACTIONS(1324),
    [aux_sym_else_clause_token1] = ACTIONS(1324),
    [aux_sym_match_expression_token1] = ACTIONS(1324),
    [aux_sym_match_default_expression_token1] = ACTIONS(1324),
    [aux_sym_switch_statement_token1] = ACTIONS(1324),
    [aux_sym_switch_block_token1] = ACTIONS(1324),
    [anon_sym_PLUS] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1324),
    [anon_sym_TILDE] = ACTIONS(1322),
    [anon_sym_BANG] = ACTIONS(1322),
    [anon_sym_AT] = ACTIONS(1322),
    [aux_sym_clone_expression_token1] = ACTIONS(1324),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1324),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1324),
    [anon_sym_DASH_DASH] = ACTIONS(1322),
    [anon_sym_PLUS_PLUS] = ACTIONS(1322),
    [aux_sym__list_destructing_token1] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(1322),
    [anon_sym_self] = ACTIONS(1324),
    [anon_sym_parent] = ACTIONS(1324),
    [aux_sym__argument_name_token1] = ACTIONS(1324),
    [aux_sym__argument_name_token2] = ACTIONS(1324),
    [anon_sym_POUND_LBRACK] = ACTIONS(1322),
    [anon_sym_SQUOTE] = ACTIONS(1322),
    [aux_sym_encapsed_string_token1] = ACTIONS(1322),
    [anon_sym_DQUOTE] = ACTIONS(1322),
    [aux_sym_string_token1] = ACTIONS(1322),
    [anon_sym_LT_LT_LT] = ACTIONS(1322),
    [anon_sym_BQUOTE] = ACTIONS(1322),
    [anon_sym_DOLLAR] = ACTIONS(1322),
    [aux_sym_yield_expression_token1] = ACTIONS(1324),
    [aux_sym_include_expression_token1] = ACTIONS(1324),
    [aux_sym_include_once_expression_token1] = ACTIONS(1324),
    [aux_sym_require_expression_token1] = ACTIONS(1324),
    [aux_sym_require_once_expression_token1] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
  },
  [502] = {
    [ts_builtin_sym_end] = ACTIONS(1326),
    [sym_name] = ACTIONS(1328),
    [anon_sym_QMARK_GT] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1326),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1328),
    [aux_sym_global_declaration_token1] = ACTIONS(1328),
    [aux_sym_namespace_definition_token1] = ACTIONS(1328),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1328),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1328),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1328),
    [anon_sym_BSLASH] = ACTIONS(1326),
    [anon_sym_LBRACE] = ACTIONS(1326),
    [anon_sym_RBRACE] = ACTIONS(1326),
    [aux_sym_trait_declaration_token1] = ACTIONS(1328),
    [aux_sym_interface_declaration_token1] = ACTIONS(1328),
    [aux_sym_enum_declaration_token1] = ACTIONS(1328),
    [aux_sym_enum_case_token1] = ACTIONS(1328),
    [aux_sym_class_declaration_token1] = ACTIONS(1328),
    [aux_sym_final_modifier_token1] = ACTIONS(1328),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1328),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1328),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1328),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1328),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1328),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1328),
    [anon_sym_LPAREN] = ACTIONS(1326),
    [aux_sym_cast_type_token1] = ACTIONS(1328),
    [aux_sym_echo_statement_token1] = ACTIONS(1328),
    [anon_sym_unset] = ACTIONS(1328),
    [aux_sym_declare_statement_token1] = ACTIONS(1328),
    [aux_sym_declare_statement_token2] = ACTIONS(1328),
    [sym_float] = ACTIONS(1328),
    [aux_sym_try_statement_token1] = ACTIONS(1328),
    [aux_sym_goto_statement_token1] = ACTIONS(1328),
    [aux_sym_continue_statement_token1] = ACTIONS(1328),
    [aux_sym_break_statement_token1] = ACTIONS(1328),
    [sym_integer] = ACTIONS(1328),
    [aux_sym_return_statement_token1] = ACTIONS(1328),
    [aux_sym_throw_expression_token1] = ACTIONS(1328),
    [aux_sym_while_statement_token1] = ACTIONS(1328),
    [aux_sym_while_statement_token2] = ACTIONS(1328),
    [aux_sym_do_statement_token1] = ACTIONS(1328),
    [aux_sym_for_statement_token1] = ACTIONS(1328),
    [aux_sym_for_statement_token2] = ACTIONS(1328),
    [aux_sym_foreach_statement_token1] = ACTIONS(1328),
    [aux_sym_foreach_statement_token2] = ACTIONS(1328),
    [aux_sym_if_statement_token1] = ACTIONS(1328),
    [aux_sym_if_statement_token2] = ACTIONS(1328),
    [aux_sym_else_if_clause_token1] = ACTIONS(1328),
    [aux_sym_else_clause_token1] = ACTIONS(1328),
    [aux_sym_match_expression_token1] = ACTIONS(1328),
    [aux_sym_match_default_expression_token1] = ACTIONS(1328),
    [aux_sym_switch_statement_token1] = ACTIONS(1328),
    [aux_sym_switch_block_token1] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1328),
    [anon_sym_TILDE] = ACTIONS(1326),
    [anon_sym_BANG] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(1326),
    [aux_sym_clone_expression_token1] = ACTIONS(1328),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1328),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1328),
    [anon_sym_DASH_DASH] = ACTIONS(1326),
    [anon_sym_PLUS_PLUS] = ACTIONS(1326),
    [aux_sym__list_destructing_token1] = ACTIONS(1328),
    [anon_sym_LBRACK] = ACTIONS(1326),
    [anon_sym_self] = ACTIONS(1328),
    [anon_sym_parent] = ACTIONS(1328),
    [aux_sym__argument_name_token1] = ACTIONS(1328),
    [aux_sym__argument_name_token2] = ACTIONS(1328),
    [anon_sym_POUND_LBRACK] = ACTIONS(1326),
    [anon_sym_SQUOTE] = ACTIONS(1326),
    [aux_sym_encapsed_string_token1] = ACTIONS(1326),
    [anon_sym_DQUOTE] = ACTIONS(1326),
    [aux_sym_string_token1] = ACTIONS(1326),
    [anon_sym_LT_LT_LT] = ACTIONS(1326),
    [anon_sym_BQUOTE] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1326),
    [aux_sym_yield_expression_token1] = ACTIONS(1328),
    [aux_sym_include_expression_token1] = ACTIONS(1328),
    [aux_sym_include_once_expression_token1] = ACTIONS(1328),
    [aux_sym_require_expression_token1] = ACTIONS(1328),
    [aux_sym_require_once_expression_token1] = ACTIONS(1328),
    [sym_comment] = ACTIONS(3),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(1330),
    [sym_name] = ACTIONS(1332),
    [anon_sym_QMARK_GT] = ACTIONS(1330),
    [anon_sym_SEMI] = ACTIONS(1330),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1332),
    [aux_sym_global_declaration_token1] = ACTIONS(1332),
    [aux_sym_namespace_definition_token1] = ACTIONS(1332),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1332),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1332),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1332),
    [anon_sym_BSLASH] = ACTIONS(1330),
    [anon_sym_LBRACE] = ACTIONS(1330),
    [anon_sym_RBRACE] = ACTIONS(1330),
    [aux_sym_trait_declaration_token1] = ACTIONS(1332),
    [aux_sym_interface_declaration_token1] = ACTIONS(1332),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym_enum_case_token1] = ACTIONS(1332),
    [aux_sym_class_declaration_token1] = ACTIONS(1332),
    [aux_sym_final_modifier_token1] = ACTIONS(1332),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1332),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1332),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1332),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1332),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1332),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1330),
    [aux_sym_cast_type_token1] = ACTIONS(1332),
    [aux_sym_echo_statement_token1] = ACTIONS(1332),
    [anon_sym_unset] = ACTIONS(1332),
    [aux_sym_declare_statement_token1] = ACTIONS(1332),
    [aux_sym_declare_statement_token2] = ACTIONS(1332),
    [sym_float] = ACTIONS(1332),
    [aux_sym_try_statement_token1] = ACTIONS(1332),
    [aux_sym_goto_statement_token1] = ACTIONS(1332),
    [aux_sym_continue_statement_token1] = ACTIONS(1332),
    [aux_sym_break_statement_token1] = ACTIONS(1332),
    [sym_integer] = ACTIONS(1332),
    [aux_sym_return_statement_token1] = ACTIONS(1332),
    [aux_sym_throw_expression_token1] = ACTIONS(1332),
    [aux_sym_while_statement_token1] = ACTIONS(1332),
    [aux_sym_while_statement_token2] = ACTIONS(1332),
    [aux_sym_do_statement_token1] = ACTIONS(1332),
    [aux_sym_for_statement_token1] = ACTIONS(1332),
    [aux_sym_for_statement_token2] = ACTIONS(1332),
    [aux_sym_foreach_statement_token1] = ACTIONS(1332),
    [aux_sym_foreach_statement_token2] = ACTIONS(1332),
    [aux_sym_if_statement_token1] = ACTIONS(1332),
    [aux_sym_if_statement_token2] = ACTIONS(1332),
    [aux_sym_else_if_clause_token1] = ACTIONS(1332),
    [aux_sym_else_clause_token1] = ACTIONS(1332),
    [aux_sym_match_expression_token1] = ACTIONS(1332),
    [aux_sym_match_default_expression_token1] = ACTIONS(1332),
    [aux_sym_switch_statement_token1] = ACTIONS(1332),
    [aux_sym_switch_block_token1] = ACTIONS(1332),
    [anon_sym_PLUS] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1330),
    [anon_sym_BANG] = ACTIONS(1330),
    [anon_sym_AT] = ACTIONS(1330),
    [aux_sym_clone_expression_token1] = ACTIONS(1332),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1332),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1332),
    [anon_sym_DASH_DASH] = ACTIONS(1330),
    [anon_sym_PLUS_PLUS] = ACTIONS(1330),
    [aux_sym__list_destructing_token1] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1330),
    [anon_sym_self] = ACTIONS(1332),
    [anon_sym_parent] = ACTIONS(1332),
    [aux_sym__argument_name_token1] = ACTIONS(1332),
    [aux_sym__argument_name_token2] = ACTIONS(1332),
    [anon_sym_POUND_LBRACK] = ACTIONS(1330),
    [anon_sym_SQUOTE] = ACTIONS(1330),
    [aux_sym_encapsed_string_token1] = ACTIONS(1330),
    [anon_sym_DQUOTE] = ACTIONS(1330),
    [aux_sym_string_token1] = ACTIONS(1330),
    [anon_sym_LT_LT_LT] = ACTIONS(1330),
    [anon_sym_BQUOTE] = ACTIONS(1330),
    [anon_sym_DOLLAR] = ACTIONS(1330),
    [aux_sym_yield_expression_token1] = ACTIONS(1332),
    [aux_sym_include_expression_token1] = ACTIONS(1332),
    [aux_sym_include_once_expression_token1] = ACTIONS(1332),
    [aux_sym_require_expression_token1] = ACTIONS(1332),
    [aux_sym_require_once_expression_token1] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(1334),
    [sym_name] = ACTIONS(1336),
    [anon_sym_QMARK_GT] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1334),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1336),
    [aux_sym_global_declaration_token1] = ACTIONS(1336),
    [aux_sym_namespace_definition_token1] = ACTIONS(1336),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1336),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1336),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1336),
    [anon_sym_BSLASH] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1334),
    [anon_sym_RBRACE] = ACTIONS(1334),
    [aux_sym_trait_declaration_token1] = ACTIONS(1336),
    [aux_sym_interface_declaration_token1] = ACTIONS(1336),
    [aux_sym_enum_declaration_token1] = ACTIONS(1336),
    [aux_sym_enum_case_token1] = ACTIONS(1336),
    [aux_sym_class_declaration_token1] = ACTIONS(1336),
    [aux_sym_final_modifier_token1] = ACTIONS(1336),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1336),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1336),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1336),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1336),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1336),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [aux_sym_cast_type_token1] = ACTIONS(1336),
    [aux_sym_echo_statement_token1] = ACTIONS(1336),
    [anon_sym_unset] = ACTIONS(1336),
    [aux_sym_declare_statement_token1] = ACTIONS(1336),
    [aux_sym_declare_statement_token2] = ACTIONS(1336),
    [sym_float] = ACTIONS(1336),
    [aux_sym_try_statement_token1] = ACTIONS(1336),
    [aux_sym_goto_statement_token1] = ACTIONS(1336),
    [aux_sym_continue_statement_token1] = ACTIONS(1336),
    [aux_sym_break_statement_token1] = ACTIONS(1336),
    [sym_integer] = ACTIONS(1336),
    [aux_sym_return_statement_token1] = ACTIONS(1336),
    [aux_sym_throw_expression_token1] = ACTIONS(1336),
    [aux_sym_while_statement_token1] = ACTIONS(1336),
    [aux_sym_while_statement_token2] = ACTIONS(1336),
    [aux_sym_do_statement_token1] = ACTIONS(1336),
    [aux_sym_for_statement_token1] = ACTIONS(1336),
    [aux_sym_for_statement_token2] = ACTIONS(1336),
    [aux_sym_foreach_statement_token1] = ACTIONS(1336),
    [aux_sym_foreach_statement_token2] = ACTIONS(1336),
    [aux_sym_if_statement_token1] = ACTIONS(1336),
    [aux_sym_if_statement_token2] = ACTIONS(1336),
    [aux_sym_else_if_clause_token1] = ACTIONS(1336),
    [aux_sym_else_clause_token1] = ACTIONS(1336),
    [aux_sym_match_expression_token1] = ACTIONS(1336),
    [aux_sym_match_default_expression_token1] = ACTIONS(1336),
    [aux_sym_switch_statement_token1] = ACTIONS(1336),
    [aux_sym_switch_block_token1] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1334),
    [anon_sym_BANG] = ACTIONS(1334),
    [anon_sym_AT] = ACTIONS(1334),
    [aux_sym_clone_expression_token1] = ACTIONS(1336),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1336),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1334),
    [anon_sym_PLUS_PLUS] = ACTIONS(1334),
    [aux_sym__list_destructing_token1] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_self] = ACTIONS(1336),
    [anon_sym_parent] = ACTIONS(1336),
    [aux_sym__argument_name_token1] = ACTIONS(1336),
    [aux_sym__argument_name_token2] = ACTIONS(1336),
    [anon_sym_POUND_LBRACK] = ACTIONS(1334),
    [anon_sym_SQUOTE] = ACTIONS(1334),
    [aux_sym_encapsed_string_token1] = ACTIONS(1334),
    [anon_sym_DQUOTE] = ACTIONS(1334),
    [aux_sym_string_token1] = ACTIONS(1334),
    [anon_sym_LT_LT_LT] = ACTIONS(1334),
    [anon_sym_BQUOTE] = ACTIONS(1334),
    [anon_sym_DOLLAR] = ACTIONS(1334),
    [aux_sym_yield_expression_token1] = ACTIONS(1336),
    [aux_sym_include_expression_token1] = ACTIONS(1336),
    [aux_sym_include_once_expression_token1] = ACTIONS(1336),
    [aux_sym_require_expression_token1] = ACTIONS(1336),
    [aux_sym_require_once_expression_token1] = ACTIONS(1336),
    [sym_comment] = ACTIONS(3),
  },
  [505] = {
    [ts_builtin_sym_end] = ACTIONS(1338),
    [sym_name] = ACTIONS(1340),
    [anon_sym_QMARK_GT] = ACTIONS(1338),
    [anon_sym_SEMI] = ACTIONS(1338),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1340),
    [aux_sym_global_declaration_token1] = ACTIONS(1340),
    [aux_sym_namespace_definition_token1] = ACTIONS(1340),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1340),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1340),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1340),
    [anon_sym_BSLASH] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_RBRACE] = ACTIONS(1338),
    [aux_sym_trait_declaration_token1] = ACTIONS(1340),
    [aux_sym_interface_declaration_token1] = ACTIONS(1340),
    [aux_sym_enum_declaration_token1] = ACTIONS(1340),
    [aux_sym_enum_case_token1] = ACTIONS(1340),
    [aux_sym_class_declaration_token1] = ACTIONS(1340),
    [aux_sym_final_modifier_token1] = ACTIONS(1340),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1340),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1340),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1340),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1340),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1340),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1340),
    [anon_sym_LPAREN] = ACTIONS(1338),
    [aux_sym_cast_type_token1] = ACTIONS(1340),
    [aux_sym_echo_statement_token1] = ACTIONS(1340),
    [anon_sym_unset] = ACTIONS(1340),
    [aux_sym_declare_statement_token1] = ACTIONS(1340),
    [aux_sym_declare_statement_token2] = ACTIONS(1340),
    [sym_float] = ACTIONS(1340),
    [aux_sym_try_statement_token1] = ACTIONS(1340),
    [aux_sym_goto_statement_token1] = ACTIONS(1340),
    [aux_sym_continue_statement_token1] = ACTIONS(1340),
    [aux_sym_break_statement_token1] = ACTIONS(1340),
    [sym_integer] = ACTIONS(1340),
    [aux_sym_return_statement_token1] = ACTIONS(1340),
    [aux_sym_throw_expression_token1] = ACTIONS(1340),
    [aux_sym_while_statement_token1] = ACTIONS(1340),
    [aux_sym_while_statement_token2] = ACTIONS(1340),
    [aux_sym_do_statement_token1] = ACTIONS(1340),
    [aux_sym_for_statement_token1] = ACTIONS(1340),
    [aux_sym_for_statement_token2] = ACTIONS(1340),
    [aux_sym_foreach_statement_token1] = ACTIONS(1340),
    [aux_sym_foreach_statement_token2] = ACTIONS(1340),
    [aux_sym_if_statement_token1] = ACTIONS(1340),
    [aux_sym_if_statement_token2] = ACTIONS(1340),
    [aux_sym_else_if_clause_token1] = ACTIONS(1340),
    [aux_sym_else_clause_token1] = ACTIONS(1340),
    [aux_sym_match_expression_token1] = ACTIONS(1340),
    [aux_sym_match_default_expression_token1] = ACTIONS(1340),
    [aux_sym_switch_statement_token1] = ACTIONS(1340),
    [aux_sym_switch_block_token1] = ACTIONS(1340),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_TILDE] = ACTIONS(1338),
    [anon_sym_BANG] = ACTIONS(1338),
    [anon_sym_AT] = ACTIONS(1338),
    [aux_sym_clone_expression_token1] = ACTIONS(1340),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1340),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1340),
    [anon_sym_DASH_DASH] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(1338),
    [aux_sym__list_destructing_token1] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [anon_sym_self] = ACTIONS(1340),
    [anon_sym_parent] = ACTIONS(1340),
    [aux_sym__argument_name_token1] = ACTIONS(1340),
    [aux_sym__argument_name_token2] = ACTIONS(1340),
    [anon_sym_POUND_LBRACK] = ACTIONS(1338),
    [anon_sym_SQUOTE] = ACTIONS(1338),
    [aux_sym_encapsed_string_token1] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(1338),
    [aux_sym_string_token1] = ACTIONS(1338),
    [anon_sym_LT_LT_LT] = ACTIONS(1338),
    [anon_sym_BQUOTE] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(1338),
    [aux_sym_yield_expression_token1] = ACTIONS(1340),
    [aux_sym_include_expression_token1] = ACTIONS(1340),
    [aux_sym_include_once_expression_token1] = ACTIONS(1340),
    [aux_sym_require_expression_token1] = ACTIONS(1340),
    [aux_sym_require_once_expression_token1] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
  },
  [506] = {
    [ts_builtin_sym_end] = ACTIONS(1342),
    [sym_name] = ACTIONS(1344),
    [anon_sym_QMARK_GT] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1342),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1344),
    [aux_sym_global_declaration_token1] = ACTIONS(1344),
    [aux_sym_namespace_definition_token1] = ACTIONS(1344),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1344),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1344),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1344),
    [anon_sym_BSLASH] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(1342),
    [anon_sym_RBRACE] = ACTIONS(1342),
    [aux_sym_trait_declaration_token1] = ACTIONS(1344),
    [aux_sym_interface_declaration_token1] = ACTIONS(1344),
    [aux_sym_enum_declaration_token1] = ACTIONS(1344),
    [aux_sym_enum_case_token1] = ACTIONS(1344),
    [aux_sym_class_declaration_token1] = ACTIONS(1344),
    [aux_sym_final_modifier_token1] = ACTIONS(1344),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1344),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1344),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1344),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1344),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1344),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1344),
    [anon_sym_LPAREN] = ACTIONS(1342),
    [aux_sym_cast_type_token1] = ACTIONS(1344),
    [aux_sym_echo_statement_token1] = ACTIONS(1344),
    [anon_sym_unset] = ACTIONS(1344),
    [aux_sym_declare_statement_token1] = ACTIONS(1344),
    [aux_sym_declare_statement_token2] = ACTIONS(1344),
    [sym_float] = ACTIONS(1344),
    [aux_sym_try_statement_token1] = ACTIONS(1344),
    [aux_sym_goto_statement_token1] = ACTIONS(1344),
    [aux_sym_continue_statement_token1] = ACTIONS(1344),
    [aux_sym_break_statement_token1] = ACTIONS(1344),
    [sym_integer] = ACTIONS(1344),
    [aux_sym_return_statement_token1] = ACTIONS(1344),
    [aux_sym_throw_expression_token1] = ACTIONS(1344),
    [aux_sym_while_statement_token1] = ACTIONS(1344),
    [aux_sym_while_statement_token2] = ACTIONS(1344),
    [aux_sym_do_statement_token1] = ACTIONS(1344),
    [aux_sym_for_statement_token1] = ACTIONS(1344),
    [aux_sym_for_statement_token2] = ACTIONS(1344),
    [aux_sym_foreach_statement_token1] = ACTIONS(1344),
    [aux_sym_foreach_statement_token2] = ACTIONS(1344),
    [aux_sym_if_statement_token1] = ACTIONS(1344),
    [aux_sym_if_statement_token2] = ACTIONS(1344),
    [aux_sym_else_if_clause_token1] = ACTIONS(1344),
    [aux_sym_else_clause_token1] = ACTIONS(1344),
    [aux_sym_match_expression_token1] = ACTIONS(1344),
    [aux_sym_match_default_expression_token1] = ACTIONS(1344),
    [aux_sym_switch_statement_token1] = ACTIONS(1344),
    [aux_sym_switch_block_token1] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1344),
    [anon_sym_DASH] = ACTIONS(1344),
    [anon_sym_TILDE] = ACTIONS(1342),
    [anon_sym_BANG] = ACTIONS(1342),
    [anon_sym_AT] = ACTIONS(1342),
    [aux_sym_clone_expression_token1] = ACTIONS(1344),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1344),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1344),
    [anon_sym_DASH_DASH] = ACTIONS(1342),
    [anon_sym_PLUS_PLUS] = ACTIONS(1342),
    [aux_sym__list_destructing_token1] = ACTIONS(1344),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_self] = ACTIONS(1344),
    [anon_sym_parent] = ACTIONS(1344),
    [aux_sym__argument_name_token1] = ACTIONS(1344),
    [aux_sym__argument_name_token2] = ACTIONS(1344),
    [anon_sym_POUND_LBRACK] = ACTIONS(1342),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [aux_sym_encapsed_string_token1] = ACTIONS(1342),
    [anon_sym_DQUOTE] = ACTIONS(1342),
    [aux_sym_string_token1] = ACTIONS(1342),
    [anon_sym_LT_LT_LT] = ACTIONS(1342),
    [anon_sym_BQUOTE] = ACTIONS(1342),
    [anon_sym_DOLLAR] = ACTIONS(1342),
    [aux_sym_yield_expression_token1] = ACTIONS(1344),
    [aux_sym_include_expression_token1] = ACTIONS(1344),
    [aux_sym_include_once_expression_token1] = ACTIONS(1344),
    [aux_sym_require_expression_token1] = ACTIONS(1344),
    [aux_sym_require_once_expression_token1] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(1338),
    [sym_name] = ACTIONS(1340),
    [anon_sym_QMARK_GT] = ACTIONS(1338),
    [anon_sym_SEMI] = ACTIONS(1338),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1340),
    [aux_sym_global_declaration_token1] = ACTIONS(1340),
    [aux_sym_namespace_definition_token1] = ACTIONS(1340),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1340),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1340),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1340),
    [anon_sym_BSLASH] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_RBRACE] = ACTIONS(1338),
    [aux_sym_trait_declaration_token1] = ACTIONS(1340),
    [aux_sym_interface_declaration_token1] = ACTIONS(1340),
    [aux_sym_enum_declaration_token1] = ACTIONS(1340),
    [aux_sym_enum_case_token1] = ACTIONS(1340),
    [aux_sym_class_declaration_token1] = ACTIONS(1340),
    [aux_sym_final_modifier_token1] = ACTIONS(1340),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1340),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1340),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1340),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1340),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1340),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1340),
    [anon_sym_LPAREN] = ACTIONS(1338),
    [aux_sym_cast_type_token1] = ACTIONS(1340),
    [aux_sym_echo_statement_token1] = ACTIONS(1340),
    [anon_sym_unset] = ACTIONS(1340),
    [aux_sym_declare_statement_token1] = ACTIONS(1340),
    [aux_sym_declare_statement_token2] = ACTIONS(1340),
    [sym_float] = ACTIONS(1340),
    [aux_sym_try_statement_token1] = ACTIONS(1340),
    [aux_sym_goto_statement_token1] = ACTIONS(1340),
    [aux_sym_continue_statement_token1] = ACTIONS(1340),
    [aux_sym_break_statement_token1] = ACTIONS(1340),
    [sym_integer] = ACTIONS(1340),
    [aux_sym_return_statement_token1] = ACTIONS(1340),
    [aux_sym_throw_expression_token1] = ACTIONS(1340),
    [aux_sym_while_statement_token1] = ACTIONS(1340),
    [aux_sym_while_statement_token2] = ACTIONS(1340),
    [aux_sym_do_statement_token1] = ACTIONS(1340),
    [aux_sym_for_statement_token1] = ACTIONS(1340),
    [aux_sym_for_statement_token2] = ACTIONS(1340),
    [aux_sym_foreach_statement_token1] = ACTIONS(1340),
    [aux_sym_foreach_statement_token2] = ACTIONS(1340),
    [aux_sym_if_statement_token1] = ACTIONS(1340),
    [aux_sym_if_statement_token2] = ACTIONS(1340),
    [aux_sym_else_if_clause_token1] = ACTIONS(1340),
    [aux_sym_else_clause_token1] = ACTIONS(1340),
    [aux_sym_match_expression_token1] = ACTIONS(1340),
    [aux_sym_match_default_expression_token1] = ACTIONS(1340),
    [aux_sym_switch_statement_token1] = ACTIONS(1340),
    [aux_sym_switch_block_token1] = ACTIONS(1340),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_TILDE] = ACTIONS(1338),
    [anon_sym_BANG] = ACTIONS(1338),
    [anon_sym_AT] = ACTIONS(1338),
    [aux_sym_clone_expression_token1] = ACTIONS(1340),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1340),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1340),
    [anon_sym_DASH_DASH] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(1338),
    [aux_sym__list_destructing_token1] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [anon_sym_self] = ACTIONS(1340),
    [anon_sym_parent] = ACTIONS(1340),
    [aux_sym__argument_name_token1] = ACTIONS(1340),
    [aux_sym__argument_name_token2] = ACTIONS(1340),
    [anon_sym_POUND_LBRACK] = ACTIONS(1338),
    [anon_sym_SQUOTE] = ACTIONS(1338),
    [aux_sym_encapsed_string_token1] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(1338),
    [aux_sym_string_token1] = ACTIONS(1338),
    [anon_sym_LT_LT_LT] = ACTIONS(1338),
    [anon_sym_BQUOTE] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(1338),
    [aux_sym_yield_expression_token1] = ACTIONS(1340),
    [aux_sym_include_expression_token1] = ACTIONS(1340),
    [aux_sym_include_once_expression_token1] = ACTIONS(1340),
    [aux_sym_require_expression_token1] = ACTIONS(1340),
    [aux_sym_require_once_expression_token1] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(1346),
    [sym_name] = ACTIONS(1348),
    [anon_sym_QMARK_GT] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1346),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1348),
    [aux_sym_global_declaration_token1] = ACTIONS(1348),
    [aux_sym_namespace_definition_token1] = ACTIONS(1348),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1348),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1348),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1348),
    [anon_sym_BSLASH] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1346),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [aux_sym_trait_declaration_token1] = ACTIONS(1348),
    [aux_sym_interface_declaration_token1] = ACTIONS(1348),
    [aux_sym_enum_declaration_token1] = ACTIONS(1348),
    [aux_sym_enum_case_token1] = ACTIONS(1348),
    [aux_sym_class_declaration_token1] = ACTIONS(1348),
    [aux_sym_final_modifier_token1] = ACTIONS(1348),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1348),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1348),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1348),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1348),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1348),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1348),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [aux_sym_cast_type_token1] = ACTIONS(1348),
    [aux_sym_echo_statement_token1] = ACTIONS(1348),
    [anon_sym_unset] = ACTIONS(1348),
    [aux_sym_declare_statement_token1] = ACTIONS(1348),
    [aux_sym_declare_statement_token2] = ACTIONS(1348),
    [sym_float] = ACTIONS(1348),
    [aux_sym_try_statement_token1] = ACTIONS(1348),
    [aux_sym_goto_statement_token1] = ACTIONS(1348),
    [aux_sym_continue_statement_token1] = ACTIONS(1348),
    [aux_sym_break_statement_token1] = ACTIONS(1348),
    [sym_integer] = ACTIONS(1348),
    [aux_sym_return_statement_token1] = ACTIONS(1348),
    [aux_sym_throw_expression_token1] = ACTIONS(1348),
    [aux_sym_while_statement_token1] = ACTIONS(1348),
    [aux_sym_while_statement_token2] = ACTIONS(1348),
    [aux_sym_do_statement_token1] = ACTIONS(1348),
    [aux_sym_for_statement_token1] = ACTIONS(1348),
    [aux_sym_for_statement_token2] = ACTIONS(1348),
    [aux_sym_foreach_statement_token1] = ACTIONS(1348),
    [aux_sym_foreach_statement_token2] = ACTIONS(1348),
    [aux_sym_if_statement_token1] = ACTIONS(1348),
    [aux_sym_if_statement_token2] = ACTIONS(1348),
    [aux_sym_else_if_clause_token1] = ACTIONS(1348),
    [aux_sym_else_clause_token1] = ACTIONS(1348),
    [aux_sym_match_expression_token1] = ACTIONS(1348),
    [aux_sym_match_default_expression_token1] = ACTIONS(1348),
    [aux_sym_switch_statement_token1] = ACTIONS(1348),
    [aux_sym_switch_block_token1] = ACTIONS(1348),
    [anon_sym_PLUS] = ACTIONS(1348),
    [anon_sym_DASH] = ACTIONS(1348),
    [anon_sym_TILDE] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1346),
    [anon_sym_AT] = ACTIONS(1346),
    [aux_sym_clone_expression_token1] = ACTIONS(1348),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1348),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1348),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [aux_sym__list_destructing_token1] = ACTIONS(1348),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_self] = ACTIONS(1348),
    [anon_sym_parent] = ACTIONS(1348),
    [aux_sym__argument_name_token1] = ACTIONS(1348),
    [aux_sym__argument_name_token2] = ACTIONS(1348),
    [anon_sym_POUND_LBRACK] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1346),
    [aux_sym_encapsed_string_token1] = ACTIONS(1346),
    [anon_sym_DQUOTE] = ACTIONS(1346),
    [aux_sym_string_token1] = ACTIONS(1346),
    [anon_sym_LT_LT_LT] = ACTIONS(1346),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_DOLLAR] = ACTIONS(1346),
    [aux_sym_yield_expression_token1] = ACTIONS(1348),
    [aux_sym_include_expression_token1] = ACTIONS(1348),
    [aux_sym_include_once_expression_token1] = ACTIONS(1348),
    [aux_sym_require_expression_token1] = ACTIONS(1348),
    [aux_sym_require_once_expression_token1] = ACTIONS(1348),
    [sym_comment] = ACTIONS(3),
  },
  [509] = {
    [ts_builtin_sym_end] = ACTIONS(1350),
    [sym_name] = ACTIONS(1352),
    [anon_sym_QMARK_GT] = ACTIONS(1350),
    [anon_sym_SEMI] = ACTIONS(1350),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1352),
    [aux_sym_global_declaration_token1] = ACTIONS(1352),
    [aux_sym_namespace_definition_token1] = ACTIONS(1352),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1352),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1352),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1352),
    [anon_sym_BSLASH] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_RBRACE] = ACTIONS(1350),
    [aux_sym_trait_declaration_token1] = ACTIONS(1352),
    [aux_sym_interface_declaration_token1] = ACTIONS(1352),
    [aux_sym_enum_declaration_token1] = ACTIONS(1352),
    [aux_sym_enum_case_token1] = ACTIONS(1352),
    [aux_sym_class_declaration_token1] = ACTIONS(1352),
    [aux_sym_final_modifier_token1] = ACTIONS(1352),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1352),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1352),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1352),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1352),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1352),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1352),
    [anon_sym_LPAREN] = ACTIONS(1350),
    [aux_sym_cast_type_token1] = ACTIONS(1352),
    [aux_sym_echo_statement_token1] = ACTIONS(1352),
    [anon_sym_unset] = ACTIONS(1352),
    [aux_sym_declare_statement_token1] = ACTIONS(1352),
    [aux_sym_declare_statement_token2] = ACTIONS(1352),
    [sym_float] = ACTIONS(1352),
    [aux_sym_try_statement_token1] = ACTIONS(1352),
    [aux_sym_goto_statement_token1] = ACTIONS(1352),
    [aux_sym_continue_statement_token1] = ACTIONS(1352),
    [aux_sym_break_statement_token1] = ACTIONS(1352),
    [sym_integer] = ACTIONS(1352),
    [aux_sym_return_statement_token1] = ACTIONS(1352),
    [aux_sym_throw_expression_token1] = ACTIONS(1352),
    [aux_sym_while_statement_token1] = ACTIONS(1352),
    [aux_sym_while_statement_token2] = ACTIONS(1352),
    [aux_sym_do_statement_token1] = ACTIONS(1352),
    [aux_sym_for_statement_token1] = ACTIONS(1352),
    [aux_sym_for_statement_token2] = ACTIONS(1352),
    [aux_sym_foreach_statement_token1] = ACTIONS(1352),
    [aux_sym_foreach_statement_token2] = ACTIONS(1352),
    [aux_sym_if_statement_token1] = ACTIONS(1352),
    [aux_sym_if_statement_token2] = ACTIONS(1352),
    [aux_sym_else_if_clause_token1] = ACTIONS(1352),
    [aux_sym_else_clause_token1] = ACTIONS(1352),
    [aux_sym_match_expression_token1] = ACTIONS(1352),
    [aux_sym_match_default_expression_token1] = ACTIONS(1352),
    [aux_sym_switch_statement_token1] = ACTIONS(1352),
    [aux_sym_switch_block_token1] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_AT] = ACTIONS(1350),
    [aux_sym_clone_expression_token1] = ACTIONS(1352),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1352),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1352),
    [anon_sym_DASH_DASH] = ACTIONS(1350),
    [anon_sym_PLUS_PLUS] = ACTIONS(1350),
    [aux_sym__list_destructing_token1] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(1350),
    [anon_sym_self] = ACTIONS(1352),
    [anon_sym_parent] = ACTIONS(1352),
    [aux_sym__argument_name_token1] = ACTIONS(1352),
    [aux_sym__argument_name_token2] = ACTIONS(1352),
    [anon_sym_POUND_LBRACK] = ACTIONS(1350),
    [anon_sym_SQUOTE] = ACTIONS(1350),
    [aux_sym_encapsed_string_token1] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(1350),
    [aux_sym_string_token1] = ACTIONS(1350),
    [anon_sym_LT_LT_LT] = ACTIONS(1350),
    [anon_sym_BQUOTE] = ACTIONS(1350),
    [anon_sym_DOLLAR] = ACTIONS(1350),
    [aux_sym_yield_expression_token1] = ACTIONS(1352),
    [aux_sym_include_expression_token1] = ACTIONS(1352),
    [aux_sym_include_once_expression_token1] = ACTIONS(1352),
    [aux_sym_require_expression_token1] = ACTIONS(1352),
    [aux_sym_require_once_expression_token1] = ACTIONS(1352),
    [sym_comment] = ACTIONS(3),
  },
  [510] = {
    [ts_builtin_sym_end] = ACTIONS(1354),
    [sym_name] = ACTIONS(1356),
    [anon_sym_QMARK_GT] = ACTIONS(1354),
    [anon_sym_SEMI] = ACTIONS(1354),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1356),
    [aux_sym_global_declaration_token1] = ACTIONS(1356),
    [aux_sym_namespace_definition_token1] = ACTIONS(1356),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1356),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1356),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1356),
    [anon_sym_BSLASH] = ACTIONS(1354),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_RBRACE] = ACTIONS(1354),
    [aux_sym_trait_declaration_token1] = ACTIONS(1356),
    [aux_sym_interface_declaration_token1] = ACTIONS(1356),
    [aux_sym_enum_declaration_token1] = ACTIONS(1356),
    [aux_sym_enum_case_token1] = ACTIONS(1356),
    [aux_sym_class_declaration_token1] = ACTIONS(1356),
    [aux_sym_final_modifier_token1] = ACTIONS(1356),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1356),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1356),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1356),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1356),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1356),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1354),
    [aux_sym_cast_type_token1] = ACTIONS(1356),
    [aux_sym_echo_statement_token1] = ACTIONS(1356),
    [anon_sym_unset] = ACTIONS(1356),
    [aux_sym_declare_statement_token1] = ACTIONS(1356),
    [aux_sym_declare_statement_token2] = ACTIONS(1356),
    [sym_float] = ACTIONS(1356),
    [aux_sym_try_statement_token1] = ACTIONS(1356),
    [aux_sym_goto_statement_token1] = ACTIONS(1356),
    [aux_sym_continue_statement_token1] = ACTIONS(1356),
    [aux_sym_break_statement_token1] = ACTIONS(1356),
    [sym_integer] = ACTIONS(1356),
    [aux_sym_return_statement_token1] = ACTIONS(1356),
    [aux_sym_throw_expression_token1] = ACTIONS(1356),
    [aux_sym_while_statement_token1] = ACTIONS(1356),
    [aux_sym_while_statement_token2] = ACTIONS(1356),
    [aux_sym_do_statement_token1] = ACTIONS(1356),
    [aux_sym_for_statement_token1] = ACTIONS(1356),
    [aux_sym_for_statement_token2] = ACTIONS(1356),
    [aux_sym_foreach_statement_token1] = ACTIONS(1356),
    [aux_sym_foreach_statement_token2] = ACTIONS(1356),
    [aux_sym_if_statement_token1] = ACTIONS(1356),
    [aux_sym_if_statement_token2] = ACTIONS(1356),
    [aux_sym_else_if_clause_token1] = ACTIONS(1356),
    [aux_sym_else_clause_token1] = ACTIONS(1356),
    [aux_sym_match_expression_token1] = ACTIONS(1356),
    [aux_sym_match_default_expression_token1] = ACTIONS(1356),
    [aux_sym_switch_statement_token1] = ACTIONS(1356),
    [aux_sym_switch_block_token1] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1356),
    [anon_sym_DASH] = ACTIONS(1356),
    [anon_sym_TILDE] = ACTIONS(1354),
    [anon_sym_BANG] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(1354),
    [aux_sym_clone_expression_token1] = ACTIONS(1356),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1356),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1356),
    [anon_sym_DASH_DASH] = ACTIONS(1354),
    [anon_sym_PLUS_PLUS] = ACTIONS(1354),
    [aux_sym__list_destructing_token1] = ACTIONS(1356),
    [anon_sym_LBRACK] = ACTIONS(1354),
    [anon_sym_self] = ACTIONS(1356),
    [anon_sym_parent] = ACTIONS(1356),
    [aux_sym__argument_name_token1] = ACTIONS(1356),
    [aux_sym__argument_name_token2] = ACTIONS(1356),
    [anon_sym_POUND_LBRACK] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(1354),
    [aux_sym_encapsed_string_token1] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1354),
    [aux_sym_string_token1] = ACTIONS(1354),
    [anon_sym_LT_LT_LT] = ACTIONS(1354),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(1354),
    [aux_sym_yield_expression_token1] = ACTIONS(1356),
    [aux_sym_include_expression_token1] = ACTIONS(1356),
    [aux_sym_include_once_expression_token1] = ACTIONS(1356),
    [aux_sym_require_expression_token1] = ACTIONS(1356),
    [aux_sym_require_once_expression_token1] = ACTIONS(1356),
    [sym_comment] = ACTIONS(3),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(1358),
    [sym_name] = ACTIONS(1360),
    [anon_sym_QMARK_GT] = ACTIONS(1358),
    [anon_sym_SEMI] = ACTIONS(1358),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1360),
    [aux_sym_global_declaration_token1] = ACTIONS(1360),
    [aux_sym_namespace_definition_token1] = ACTIONS(1360),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1360),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1360),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1360),
    [anon_sym_BSLASH] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1358),
    [anon_sym_RBRACE] = ACTIONS(1358),
    [aux_sym_trait_declaration_token1] = ACTIONS(1360),
    [aux_sym_interface_declaration_token1] = ACTIONS(1360),
    [aux_sym_enum_declaration_token1] = ACTIONS(1360),
    [aux_sym_enum_case_token1] = ACTIONS(1360),
    [aux_sym_class_declaration_token1] = ACTIONS(1360),
    [aux_sym_final_modifier_token1] = ACTIONS(1360),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1360),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1360),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1360),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1360),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1360),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1360),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [aux_sym_cast_type_token1] = ACTIONS(1360),
    [aux_sym_echo_statement_token1] = ACTIONS(1360),
    [anon_sym_unset] = ACTIONS(1360),
    [aux_sym_declare_statement_token1] = ACTIONS(1360),
    [aux_sym_declare_statement_token2] = ACTIONS(1360),
    [sym_float] = ACTIONS(1360),
    [aux_sym_try_statement_token1] = ACTIONS(1360),
    [aux_sym_goto_statement_token1] = ACTIONS(1360),
    [aux_sym_continue_statement_token1] = ACTIONS(1360),
    [aux_sym_break_statement_token1] = ACTIONS(1360),
    [sym_integer] = ACTIONS(1360),
    [aux_sym_return_statement_token1] = ACTIONS(1360),
    [aux_sym_throw_expression_token1] = ACTIONS(1360),
    [aux_sym_while_statement_token1] = ACTIONS(1360),
    [aux_sym_while_statement_token2] = ACTIONS(1360),
    [aux_sym_do_statement_token1] = ACTIONS(1360),
    [aux_sym_for_statement_token1] = ACTIONS(1360),
    [aux_sym_for_statement_token2] = ACTIONS(1360),
    [aux_sym_foreach_statement_token1] = ACTIONS(1360),
    [aux_sym_foreach_statement_token2] = ACTIONS(1360),
    [aux_sym_if_statement_token1] = ACTIONS(1360),
    [aux_sym_if_statement_token2] = ACTIONS(1360),
    [aux_sym_else_if_clause_token1] = ACTIONS(1360),
    [aux_sym_else_clause_token1] = ACTIONS(1360),
    [aux_sym_match_expression_token1] = ACTIONS(1360),
    [aux_sym_match_default_expression_token1] = ACTIONS(1360),
    [aux_sym_switch_statement_token1] = ACTIONS(1360),
    [aux_sym_switch_block_token1] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(1360),
    [anon_sym_DASH] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(1358),
    [aux_sym_clone_expression_token1] = ACTIONS(1360),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1360),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1360),
    [anon_sym_DASH_DASH] = ACTIONS(1358),
    [anon_sym_PLUS_PLUS] = ACTIONS(1358),
    [aux_sym__list_destructing_token1] = ACTIONS(1360),
    [anon_sym_LBRACK] = ACTIONS(1358),
    [anon_sym_self] = ACTIONS(1360),
    [anon_sym_parent] = ACTIONS(1360),
    [aux_sym__argument_name_token1] = ACTIONS(1360),
    [aux_sym__argument_name_token2] = ACTIONS(1360),
    [anon_sym_POUND_LBRACK] = ACTIONS(1358),
    [anon_sym_SQUOTE] = ACTIONS(1358),
    [aux_sym_encapsed_string_token1] = ACTIONS(1358),
    [anon_sym_DQUOTE] = ACTIONS(1358),
    [aux_sym_string_token1] = ACTIONS(1358),
    [anon_sym_LT_LT_LT] = ACTIONS(1358),
    [anon_sym_BQUOTE] = ACTIONS(1358),
    [anon_sym_DOLLAR] = ACTIONS(1358),
    [aux_sym_yield_expression_token1] = ACTIONS(1360),
    [aux_sym_include_expression_token1] = ACTIONS(1360),
    [aux_sym_include_once_expression_token1] = ACTIONS(1360),
    [aux_sym_require_expression_token1] = ACTIONS(1360),
    [aux_sym_require_once_expression_token1] = ACTIONS(1360),
    [sym_comment] = ACTIONS(3),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(1350),
    [sym_name] = ACTIONS(1352),
    [anon_sym_QMARK_GT] = ACTIONS(1350),
    [anon_sym_SEMI] = ACTIONS(1350),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1352),
    [aux_sym_global_declaration_token1] = ACTIONS(1352),
    [aux_sym_namespace_definition_token1] = ACTIONS(1352),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1352),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1352),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1352),
    [anon_sym_BSLASH] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_RBRACE] = ACTIONS(1350),
    [aux_sym_trait_declaration_token1] = ACTIONS(1352),
    [aux_sym_interface_declaration_token1] = ACTIONS(1352),
    [aux_sym_enum_declaration_token1] = ACTIONS(1352),
    [aux_sym_enum_case_token1] = ACTIONS(1352),
    [aux_sym_class_declaration_token1] = ACTIONS(1352),
    [aux_sym_final_modifier_token1] = ACTIONS(1352),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1352),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1352),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1352),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1352),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1352),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1352),
    [anon_sym_LPAREN] = ACTIONS(1350),
    [aux_sym_cast_type_token1] = ACTIONS(1352),
    [aux_sym_echo_statement_token1] = ACTIONS(1352),
    [anon_sym_unset] = ACTIONS(1352),
    [aux_sym_declare_statement_token1] = ACTIONS(1352),
    [aux_sym_declare_statement_token2] = ACTIONS(1352),
    [sym_float] = ACTIONS(1352),
    [aux_sym_try_statement_token1] = ACTIONS(1352),
    [aux_sym_goto_statement_token1] = ACTIONS(1352),
    [aux_sym_continue_statement_token1] = ACTIONS(1352),
    [aux_sym_break_statement_token1] = ACTIONS(1352),
    [sym_integer] = ACTIONS(1352),
    [aux_sym_return_statement_token1] = ACTIONS(1352),
    [aux_sym_throw_expression_token1] = ACTIONS(1352),
    [aux_sym_while_statement_token1] = ACTIONS(1352),
    [aux_sym_while_statement_token2] = ACTIONS(1352),
    [aux_sym_do_statement_token1] = ACTIONS(1352),
    [aux_sym_for_statement_token1] = ACTIONS(1352),
    [aux_sym_for_statement_token2] = ACTIONS(1352),
    [aux_sym_foreach_statement_token1] = ACTIONS(1352),
    [aux_sym_foreach_statement_token2] = ACTIONS(1352),
    [aux_sym_if_statement_token1] = ACTIONS(1352),
    [aux_sym_if_statement_token2] = ACTIONS(1352),
    [aux_sym_else_if_clause_token1] = ACTIONS(1352),
    [aux_sym_else_clause_token1] = ACTIONS(1352),
    [aux_sym_match_expression_token1] = ACTIONS(1352),
    [aux_sym_match_default_expression_token1] = ACTIONS(1352),
    [aux_sym_switch_statement_token1] = ACTIONS(1352),
    [aux_sym_switch_block_token1] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_AT] = ACTIONS(1350),
    [aux_sym_clone_expression_token1] = ACTIONS(1352),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1352),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1352),
    [anon_sym_DASH_DASH] = ACTIONS(1350),
    [anon_sym_PLUS_PLUS] = ACTIONS(1350),
    [aux_sym__list_destructing_token1] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(1350),
    [anon_sym_self] = ACTIONS(1352),
    [anon_sym_parent] = ACTIONS(1352),
    [aux_sym__argument_name_token1] = ACTIONS(1352),
    [aux_sym__argument_name_token2] = ACTIONS(1352),
    [anon_sym_POUND_LBRACK] = ACTIONS(1350),
    [anon_sym_SQUOTE] = ACTIONS(1350),
    [aux_sym_encapsed_string_token1] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(1350),
    [aux_sym_string_token1] = ACTIONS(1350),
    [anon_sym_LT_LT_LT] = ACTIONS(1350),
    [anon_sym_BQUOTE] = ACTIONS(1350),
    [anon_sym_DOLLAR] = ACTIONS(1350),
    [aux_sym_yield_expression_token1] = ACTIONS(1352),
    [aux_sym_include_expression_token1] = ACTIONS(1352),
    [aux_sym_include_once_expression_token1] = ACTIONS(1352),
    [aux_sym_require_expression_token1] = ACTIONS(1352),
    [aux_sym_require_once_expression_token1] = ACTIONS(1352),
    [sym_comment] = ACTIONS(3),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(1362),
    [sym_name] = ACTIONS(1364),
    [anon_sym_QMARK_GT] = ACTIONS(1362),
    [anon_sym_SEMI] = ACTIONS(1362),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1364),
    [aux_sym_global_declaration_token1] = ACTIONS(1364),
    [aux_sym_namespace_definition_token1] = ACTIONS(1364),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1364),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1364),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1364),
    [anon_sym_BSLASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(1362),
    [anon_sym_RBRACE] = ACTIONS(1362),
    [aux_sym_trait_declaration_token1] = ACTIONS(1364),
    [aux_sym_interface_declaration_token1] = ACTIONS(1364),
    [aux_sym_enum_declaration_token1] = ACTIONS(1364),
    [aux_sym_enum_case_token1] = ACTIONS(1364),
    [aux_sym_class_declaration_token1] = ACTIONS(1364),
    [aux_sym_final_modifier_token1] = ACTIONS(1364),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1364),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1364),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1364),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1364),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1364),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1362),
    [aux_sym_cast_type_token1] = ACTIONS(1364),
    [aux_sym_echo_statement_token1] = ACTIONS(1364),
    [anon_sym_unset] = ACTIONS(1364),
    [aux_sym_declare_statement_token1] = ACTIONS(1364),
    [aux_sym_declare_statement_token2] = ACTIONS(1364),
    [sym_float] = ACTIONS(1364),
    [aux_sym_try_statement_token1] = ACTIONS(1364),
    [aux_sym_goto_statement_token1] = ACTIONS(1364),
    [aux_sym_continue_statement_token1] = ACTIONS(1364),
    [aux_sym_break_statement_token1] = ACTIONS(1364),
    [sym_integer] = ACTIONS(1364),
    [aux_sym_return_statement_token1] = ACTIONS(1364),
    [aux_sym_throw_expression_token1] = ACTIONS(1364),
    [aux_sym_while_statement_token1] = ACTIONS(1364),
    [aux_sym_while_statement_token2] = ACTIONS(1364),
    [aux_sym_do_statement_token1] = ACTIONS(1364),
    [aux_sym_for_statement_token1] = ACTIONS(1364),
    [aux_sym_for_statement_token2] = ACTIONS(1364),
    [aux_sym_foreach_statement_token1] = ACTIONS(1364),
    [aux_sym_foreach_statement_token2] = ACTIONS(1364),
    [aux_sym_if_statement_token1] = ACTIONS(1364),
    [aux_sym_if_statement_token2] = ACTIONS(1364),
    [aux_sym_else_if_clause_token1] = ACTIONS(1364),
    [aux_sym_else_clause_token1] = ACTIONS(1364),
    [aux_sym_match_expression_token1] = ACTIONS(1364),
    [aux_sym_match_default_expression_token1] = ACTIONS(1364),
    [aux_sym_switch_statement_token1] = ACTIONS(1364),
    [aux_sym_switch_block_token1] = ACTIONS(1364),
    [anon_sym_PLUS] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1362),
    [anon_sym_AT] = ACTIONS(1362),
    [aux_sym_clone_expression_token1] = ACTIONS(1364),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1364),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1364),
    [anon_sym_DASH_DASH] = ACTIONS(1362),
    [anon_sym_PLUS_PLUS] = ACTIONS(1362),
    [aux_sym__list_destructing_token1] = ACTIONS(1364),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_self] = ACTIONS(1364),
    [anon_sym_parent] = ACTIONS(1364),
    [aux_sym__argument_name_token1] = ACTIONS(1364),
    [aux_sym__argument_name_token2] = ACTIONS(1364),
    [anon_sym_POUND_LBRACK] = ACTIONS(1362),
    [anon_sym_SQUOTE] = ACTIONS(1362),
    [aux_sym_encapsed_string_token1] = ACTIONS(1362),
    [anon_sym_DQUOTE] = ACTIONS(1362),
    [aux_sym_string_token1] = ACTIONS(1362),
    [anon_sym_LT_LT_LT] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(1362),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [aux_sym_yield_expression_token1] = ACTIONS(1364),
    [aux_sym_include_expression_token1] = ACTIONS(1364),
    [aux_sym_include_once_expression_token1] = ACTIONS(1364),
    [aux_sym_require_expression_token1] = ACTIONS(1364),
    [aux_sym_require_once_expression_token1] = ACTIONS(1364),
    [sym_comment] = ACTIONS(3),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(1366),
    [sym_name] = ACTIONS(1368),
    [anon_sym_QMARK_GT] = ACTIONS(1366),
    [anon_sym_SEMI] = ACTIONS(1366),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1368),
    [aux_sym_global_declaration_token1] = ACTIONS(1368),
    [aux_sym_namespace_definition_token1] = ACTIONS(1368),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1368),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1368),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1368),
    [anon_sym_BSLASH] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(1366),
    [anon_sym_RBRACE] = ACTIONS(1366),
    [aux_sym_trait_declaration_token1] = ACTIONS(1368),
    [aux_sym_interface_declaration_token1] = ACTIONS(1368),
    [aux_sym_enum_declaration_token1] = ACTIONS(1368),
    [aux_sym_enum_case_token1] = ACTIONS(1368),
    [aux_sym_class_declaration_token1] = ACTIONS(1368),
    [aux_sym_final_modifier_token1] = ACTIONS(1368),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1368),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1368),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1368),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1368),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1368),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1368),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [aux_sym_cast_type_token1] = ACTIONS(1368),
    [aux_sym_echo_statement_token1] = ACTIONS(1368),
    [anon_sym_unset] = ACTIONS(1368),
    [aux_sym_declare_statement_token1] = ACTIONS(1368),
    [aux_sym_declare_statement_token2] = ACTIONS(1368),
    [sym_float] = ACTIONS(1368),
    [aux_sym_try_statement_token1] = ACTIONS(1368),
    [aux_sym_goto_statement_token1] = ACTIONS(1368),
    [aux_sym_continue_statement_token1] = ACTIONS(1368),
    [aux_sym_break_statement_token1] = ACTIONS(1368),
    [sym_integer] = ACTIONS(1368),
    [aux_sym_return_statement_token1] = ACTIONS(1368),
    [aux_sym_throw_expression_token1] = ACTIONS(1368),
    [aux_sym_while_statement_token1] = ACTIONS(1368),
    [aux_sym_while_statement_token2] = ACTIONS(1368),
    [aux_sym_do_statement_token1] = ACTIONS(1368),
    [aux_sym_for_statement_token1] = ACTIONS(1368),
    [aux_sym_for_statement_token2] = ACTIONS(1368),
    [aux_sym_foreach_statement_token1] = ACTIONS(1368),
    [aux_sym_foreach_statement_token2] = ACTIONS(1368),
    [aux_sym_if_statement_token1] = ACTIONS(1368),
    [aux_sym_if_statement_token2] = ACTIONS(1368),
    [aux_sym_else_if_clause_token1] = ACTIONS(1368),
    [aux_sym_else_clause_token1] = ACTIONS(1368),
    [aux_sym_match_expression_token1] = ACTIONS(1368),
    [aux_sym_match_default_expression_token1] = ACTIONS(1368),
    [aux_sym_switch_statement_token1] = ACTIONS(1368),
    [aux_sym_switch_block_token1] = ACTIONS(1368),
    [anon_sym_PLUS] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1368),
    [anon_sym_TILDE] = ACTIONS(1366),
    [anon_sym_BANG] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(1366),
    [aux_sym_clone_expression_token1] = ACTIONS(1368),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1368),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1368),
    [anon_sym_DASH_DASH] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1366),
    [aux_sym__list_destructing_token1] = ACTIONS(1368),
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_self] = ACTIONS(1368),
    [anon_sym_parent] = ACTIONS(1368),
    [aux_sym__argument_name_token1] = ACTIONS(1368),
    [aux_sym__argument_name_token2] = ACTIONS(1368),
    [anon_sym_POUND_LBRACK] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1366),
    [aux_sym_encapsed_string_token1] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1366),
    [aux_sym_string_token1] = ACTIONS(1366),
    [anon_sym_LT_LT_LT] = ACTIONS(1366),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_DOLLAR] = ACTIONS(1366),
    [aux_sym_yield_expression_token1] = ACTIONS(1368),
    [aux_sym_include_expression_token1] = ACTIONS(1368),
    [aux_sym_include_once_expression_token1] = ACTIONS(1368),
    [aux_sym_require_expression_token1] = ACTIONS(1368),
    [aux_sym_require_once_expression_token1] = ACTIONS(1368),
    [sym_comment] = ACTIONS(3),
  },
  [515] = {
    [ts_builtin_sym_end] = ACTIONS(1370),
    [sym_name] = ACTIONS(1372),
    [anon_sym_QMARK_GT] = ACTIONS(1370),
    [anon_sym_SEMI] = ACTIONS(1370),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1372),
    [aux_sym_global_declaration_token1] = ACTIONS(1372),
    [aux_sym_namespace_definition_token1] = ACTIONS(1372),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1372),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1372),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1372),
    [anon_sym_BSLASH] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [aux_sym_trait_declaration_token1] = ACTIONS(1372),
    [aux_sym_interface_declaration_token1] = ACTIONS(1372),
    [aux_sym_enum_declaration_token1] = ACTIONS(1372),
    [aux_sym_enum_case_token1] = ACTIONS(1372),
    [aux_sym_class_declaration_token1] = ACTIONS(1372),
    [aux_sym_final_modifier_token1] = ACTIONS(1372),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1372),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1372),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1372),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1372),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1372),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1372),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [aux_sym_cast_type_token1] = ACTIONS(1372),
    [aux_sym_echo_statement_token1] = ACTIONS(1372),
    [anon_sym_unset] = ACTIONS(1372),
    [aux_sym_declare_statement_token1] = ACTIONS(1372),
    [aux_sym_declare_statement_token2] = ACTIONS(1372),
    [sym_float] = ACTIONS(1372),
    [aux_sym_try_statement_token1] = ACTIONS(1372),
    [aux_sym_goto_statement_token1] = ACTIONS(1372),
    [aux_sym_continue_statement_token1] = ACTIONS(1372),
    [aux_sym_break_statement_token1] = ACTIONS(1372),
    [sym_integer] = ACTIONS(1372),
    [aux_sym_return_statement_token1] = ACTIONS(1372),
    [aux_sym_throw_expression_token1] = ACTIONS(1372),
    [aux_sym_while_statement_token1] = ACTIONS(1372),
    [aux_sym_while_statement_token2] = ACTIONS(1372),
    [aux_sym_do_statement_token1] = ACTIONS(1372),
    [aux_sym_for_statement_token1] = ACTIONS(1372),
    [aux_sym_for_statement_token2] = ACTIONS(1372),
    [aux_sym_foreach_statement_token1] = ACTIONS(1372),
    [aux_sym_foreach_statement_token2] = ACTIONS(1372),
    [aux_sym_if_statement_token1] = ACTIONS(1372),
    [aux_sym_if_statement_token2] = ACTIONS(1372),
    [aux_sym_else_if_clause_token1] = ACTIONS(1372),
    [aux_sym_else_clause_token1] = ACTIONS(1372),
    [aux_sym_match_expression_token1] = ACTIONS(1372),
    [aux_sym_match_default_expression_token1] = ACTIONS(1372),
    [aux_sym_switch_statement_token1] = ACTIONS(1372),
    [aux_sym_switch_block_token1] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_AT] = ACTIONS(1370),
    [aux_sym_clone_expression_token1] = ACTIONS(1372),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1372),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1372),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [aux_sym__list_destructing_token1] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_self] = ACTIONS(1372),
    [anon_sym_parent] = ACTIONS(1372),
    [aux_sym__argument_name_token1] = ACTIONS(1372),
    [aux_sym__argument_name_token2] = ACTIONS(1372),
    [anon_sym_POUND_LBRACK] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [aux_sym_encapsed_string_token1] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [aux_sym_string_token1] = ACTIONS(1370),
    [anon_sym_LT_LT_LT] = ACTIONS(1370),
    [anon_sym_BQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR] = ACTIONS(1370),
    [aux_sym_yield_expression_token1] = ACTIONS(1372),
    [aux_sym_include_expression_token1] = ACTIONS(1372),
    [aux_sym_include_once_expression_token1] = ACTIONS(1372),
    [aux_sym_require_expression_token1] = ACTIONS(1372),
    [aux_sym_require_once_expression_token1] = ACTIONS(1372),
    [sym_comment] = ACTIONS(3),
  },
  [516] = {
    [ts_builtin_sym_end] = ACTIONS(1374),
    [sym_name] = ACTIONS(1376),
    [anon_sym_QMARK_GT] = ACTIONS(1374),
    [anon_sym_SEMI] = ACTIONS(1374),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1376),
    [aux_sym_global_declaration_token1] = ACTIONS(1376),
    [aux_sym_namespace_definition_token1] = ACTIONS(1376),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1376),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1376),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1376),
    [anon_sym_BSLASH] = ACTIONS(1374),
    [anon_sym_LBRACE] = ACTIONS(1374),
    [anon_sym_RBRACE] = ACTIONS(1374),
    [aux_sym_trait_declaration_token1] = ACTIONS(1376),
    [aux_sym_interface_declaration_token1] = ACTIONS(1376),
    [aux_sym_enum_declaration_token1] = ACTIONS(1376),
    [aux_sym_enum_case_token1] = ACTIONS(1376),
    [aux_sym_class_declaration_token1] = ACTIONS(1376),
    [aux_sym_final_modifier_token1] = ACTIONS(1376),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1376),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1376),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1376),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1376),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1376),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1376),
    [anon_sym_LPAREN] = ACTIONS(1374),
    [aux_sym_cast_type_token1] = ACTIONS(1376),
    [aux_sym_echo_statement_token1] = ACTIONS(1376),
    [anon_sym_unset] = ACTIONS(1376),
    [aux_sym_declare_statement_token1] = ACTIONS(1376),
    [aux_sym_declare_statement_token2] = ACTIONS(1376),
    [sym_float] = ACTIONS(1376),
    [aux_sym_try_statement_token1] = ACTIONS(1376),
    [aux_sym_goto_statement_token1] = ACTIONS(1376),
    [aux_sym_continue_statement_token1] = ACTIONS(1376),
    [aux_sym_break_statement_token1] = ACTIONS(1376),
    [sym_integer] = ACTIONS(1376),
    [aux_sym_return_statement_token1] = ACTIONS(1376),
    [aux_sym_throw_expression_token1] = ACTIONS(1376),
    [aux_sym_while_statement_token1] = ACTIONS(1376),
    [aux_sym_while_statement_token2] = ACTIONS(1376),
    [aux_sym_do_statement_token1] = ACTIONS(1376),
    [aux_sym_for_statement_token1] = ACTIONS(1376),
    [aux_sym_for_statement_token2] = ACTIONS(1376),
    [aux_sym_foreach_statement_token1] = ACTIONS(1376),
    [aux_sym_foreach_statement_token2] = ACTIONS(1376),
    [aux_sym_if_statement_token1] = ACTIONS(1376),
    [aux_sym_if_statement_token2] = ACTIONS(1376),
    [aux_sym_else_if_clause_token1] = ACTIONS(1376),
    [aux_sym_else_clause_token1] = ACTIONS(1376),
    [aux_sym_match_expression_token1] = ACTIONS(1376),
    [aux_sym_match_default_expression_token1] = ACTIONS(1376),
    [aux_sym_switch_statement_token1] = ACTIONS(1376),
    [aux_sym_switch_block_token1] = ACTIONS(1376),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_TILDE] = ACTIONS(1374),
    [anon_sym_BANG] = ACTIONS(1374),
    [anon_sym_AT] = ACTIONS(1374),
    [aux_sym_clone_expression_token1] = ACTIONS(1376),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1376),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1376),
    [anon_sym_DASH_DASH] = ACTIONS(1374),
    [anon_sym_PLUS_PLUS] = ACTIONS(1374),
    [aux_sym__list_destructing_token1] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_self] = ACTIONS(1376),
    [anon_sym_parent] = ACTIONS(1376),
    [aux_sym__argument_name_token1] = ACTIONS(1376),
    [aux_sym__argument_name_token2] = ACTIONS(1376),
    [anon_sym_POUND_LBRACK] = ACTIONS(1374),
    [anon_sym_SQUOTE] = ACTIONS(1374),
    [aux_sym_encapsed_string_token1] = ACTIONS(1374),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [aux_sym_string_token1] = ACTIONS(1374),
    [anon_sym_LT_LT_LT] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1374),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [aux_sym_yield_expression_token1] = ACTIONS(1376),
    [aux_sym_include_expression_token1] = ACTIONS(1376),
    [aux_sym_include_once_expression_token1] = ACTIONS(1376),
    [aux_sym_require_expression_token1] = ACTIONS(1376),
    [aux_sym_require_once_expression_token1] = ACTIONS(1376),
    [sym_comment] = ACTIONS(3),
  },
  [517] = {
    [ts_builtin_sym_end] = ACTIONS(1378),
    [sym_name] = ACTIONS(1380),
    [anon_sym_QMARK_GT] = ACTIONS(1378),
    [anon_sym_SEMI] = ACTIONS(1378),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1380),
    [aux_sym_global_declaration_token1] = ACTIONS(1380),
    [aux_sym_namespace_definition_token1] = ACTIONS(1380),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1380),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1380),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1380),
    [anon_sym_BSLASH] = ACTIONS(1378),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_RBRACE] = ACTIONS(1378),
    [aux_sym_trait_declaration_token1] = ACTIONS(1380),
    [aux_sym_interface_declaration_token1] = ACTIONS(1380),
    [aux_sym_enum_declaration_token1] = ACTIONS(1380),
    [aux_sym_enum_case_token1] = ACTIONS(1380),
    [aux_sym_class_declaration_token1] = ACTIONS(1380),
    [aux_sym_final_modifier_token1] = ACTIONS(1380),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1380),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1380),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1380),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1380),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1380),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1380),
    [anon_sym_LPAREN] = ACTIONS(1378),
    [aux_sym_cast_type_token1] = ACTIONS(1380),
    [aux_sym_echo_statement_token1] = ACTIONS(1380),
    [anon_sym_unset] = ACTIONS(1380),
    [aux_sym_declare_statement_token1] = ACTIONS(1380),
    [aux_sym_declare_statement_token2] = ACTIONS(1380),
    [sym_float] = ACTIONS(1380),
    [aux_sym_try_statement_token1] = ACTIONS(1380),
    [aux_sym_goto_statement_token1] = ACTIONS(1380),
    [aux_sym_continue_statement_token1] = ACTIONS(1380),
    [aux_sym_break_statement_token1] = ACTIONS(1380),
    [sym_integer] = ACTIONS(1380),
    [aux_sym_return_statement_token1] = ACTIONS(1380),
    [aux_sym_throw_expression_token1] = ACTIONS(1380),
    [aux_sym_while_statement_token1] = ACTIONS(1380),
    [aux_sym_while_statement_token2] = ACTIONS(1380),
    [aux_sym_do_statement_token1] = ACTIONS(1380),
    [aux_sym_for_statement_token1] = ACTIONS(1380),
    [aux_sym_for_statement_token2] = ACTIONS(1380),
    [aux_sym_foreach_statement_token1] = ACTIONS(1380),
    [aux_sym_foreach_statement_token2] = ACTIONS(1380),
    [aux_sym_if_statement_token1] = ACTIONS(1380),
    [aux_sym_if_statement_token2] = ACTIONS(1380),
    [aux_sym_else_if_clause_token1] = ACTIONS(1380),
    [aux_sym_else_clause_token1] = ACTIONS(1380),
    [aux_sym_match_expression_token1] = ACTIONS(1380),
    [aux_sym_match_default_expression_token1] = ACTIONS(1380),
    [aux_sym_switch_statement_token1] = ACTIONS(1380),
    [aux_sym_switch_block_token1] = ACTIONS(1380),
    [anon_sym_PLUS] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1380),
    [anon_sym_TILDE] = ACTIONS(1378),
    [anon_sym_BANG] = ACTIONS(1378),
    [anon_sym_AT] = ACTIONS(1378),
    [aux_sym_clone_expression_token1] = ACTIONS(1380),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1380),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1380),
    [anon_sym_DASH_DASH] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(1378),
    [aux_sym__list_destructing_token1] = ACTIONS(1380),
    [anon_sym_LBRACK] = ACTIONS(1378),
    [anon_sym_self] = ACTIONS(1380),
    [anon_sym_parent] = ACTIONS(1380),
    [aux_sym__argument_name_token1] = ACTIONS(1380),
    [aux_sym__argument_name_token2] = ACTIONS(1380),
    [anon_sym_POUND_LBRACK] = ACTIONS(1378),
    [anon_sym_SQUOTE] = ACTIONS(1378),
    [aux_sym_encapsed_string_token1] = ACTIONS(1378),
    [anon_sym_DQUOTE] = ACTIONS(1378),
    [aux_sym_string_token1] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [anon_sym_DOLLAR] = ACTIONS(1378),
    [aux_sym_yield_expression_token1] = ACTIONS(1380),
    [aux_sym_include_expression_token1] = ACTIONS(1380),
    [aux_sym_include_once_expression_token1] = ACTIONS(1380),
    [aux_sym_require_expression_token1] = ACTIONS(1380),
    [aux_sym_require_once_expression_token1] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
  },
  [518] = {
    [ts_builtin_sym_end] = ACTIONS(1382),
    [sym_name] = ACTIONS(1384),
    [anon_sym_QMARK_GT] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1382),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1384),
    [aux_sym_global_declaration_token1] = ACTIONS(1384),
    [aux_sym_namespace_definition_token1] = ACTIONS(1384),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1384),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1384),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1384),
    [anon_sym_BSLASH] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(1382),
    [anon_sym_RBRACE] = ACTIONS(1382),
    [aux_sym_trait_declaration_token1] = ACTIONS(1384),
    [aux_sym_interface_declaration_token1] = ACTIONS(1384),
    [aux_sym_enum_declaration_token1] = ACTIONS(1384),
    [aux_sym_enum_case_token1] = ACTIONS(1384),
    [aux_sym_class_declaration_token1] = ACTIONS(1384),
    [aux_sym_final_modifier_token1] = ACTIONS(1384),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1384),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1384),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1384),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1384),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1384),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1384),
    [anon_sym_LPAREN] = ACTIONS(1382),
    [aux_sym_cast_type_token1] = ACTIONS(1384),
    [aux_sym_echo_statement_token1] = ACTIONS(1384),
    [anon_sym_unset] = ACTIONS(1384),
    [aux_sym_declare_statement_token1] = ACTIONS(1384),
    [aux_sym_declare_statement_token2] = ACTIONS(1384),
    [sym_float] = ACTIONS(1384),
    [aux_sym_try_statement_token1] = ACTIONS(1384),
    [aux_sym_goto_statement_token1] = ACTIONS(1384),
    [aux_sym_continue_statement_token1] = ACTIONS(1384),
    [aux_sym_break_statement_token1] = ACTIONS(1384),
    [sym_integer] = ACTIONS(1384),
    [aux_sym_return_statement_token1] = ACTIONS(1384),
    [aux_sym_throw_expression_token1] = ACTIONS(1384),
    [aux_sym_while_statement_token1] = ACTIONS(1384),
    [aux_sym_while_statement_token2] = ACTIONS(1384),
    [aux_sym_do_statement_token1] = ACTIONS(1384),
    [aux_sym_for_statement_token1] = ACTIONS(1384),
    [aux_sym_for_statement_token2] = ACTIONS(1384),
    [aux_sym_foreach_statement_token1] = ACTIONS(1384),
    [aux_sym_foreach_statement_token2] = ACTIONS(1384),
    [aux_sym_if_statement_token1] = ACTIONS(1384),
    [aux_sym_if_statement_token2] = ACTIONS(1384),
    [aux_sym_else_if_clause_token1] = ACTIONS(1384),
    [aux_sym_else_clause_token1] = ACTIONS(1384),
    [aux_sym_match_expression_token1] = ACTIONS(1384),
    [aux_sym_match_default_expression_token1] = ACTIONS(1384),
    [aux_sym_switch_statement_token1] = ACTIONS(1384),
    [aux_sym_switch_block_token1] = ACTIONS(1384),
    [anon_sym_PLUS] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1382),
    [anon_sym_AT] = ACTIONS(1382),
    [aux_sym_clone_expression_token1] = ACTIONS(1384),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1384),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1384),
    [anon_sym_DASH_DASH] = ACTIONS(1382),
    [anon_sym_PLUS_PLUS] = ACTIONS(1382),
    [aux_sym__list_destructing_token1] = ACTIONS(1384),
    [anon_sym_LBRACK] = ACTIONS(1382),
    [anon_sym_self] = ACTIONS(1384),
    [anon_sym_parent] = ACTIONS(1384),
    [aux_sym__argument_name_token1] = ACTIONS(1384),
    [aux_sym__argument_name_token2] = ACTIONS(1384),
    [anon_sym_POUND_LBRACK] = ACTIONS(1382),
    [anon_sym_SQUOTE] = ACTIONS(1382),
    [aux_sym_encapsed_string_token1] = ACTIONS(1382),
    [anon_sym_DQUOTE] = ACTIONS(1382),
    [aux_sym_string_token1] = ACTIONS(1382),
    [anon_sym_LT_LT_LT] = ACTIONS(1382),
    [anon_sym_BQUOTE] = ACTIONS(1382),
    [anon_sym_DOLLAR] = ACTIONS(1382),
    [aux_sym_yield_expression_token1] = ACTIONS(1384),
    [aux_sym_include_expression_token1] = ACTIONS(1384),
    [aux_sym_include_once_expression_token1] = ACTIONS(1384),
    [aux_sym_require_expression_token1] = ACTIONS(1384),
    [aux_sym_require_once_expression_token1] = ACTIONS(1384),
    [sym_comment] = ACTIONS(3),
  },
  [519] = {
    [ts_builtin_sym_end] = ACTIONS(1386),
    [sym_name] = ACTIONS(1388),
    [anon_sym_QMARK_GT] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(1386),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1388),
    [aux_sym_global_declaration_token1] = ACTIONS(1388),
    [aux_sym_namespace_definition_token1] = ACTIONS(1388),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1388),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1388),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1388),
    [anon_sym_BSLASH] = ACTIONS(1386),
    [anon_sym_LBRACE] = ACTIONS(1386),
    [anon_sym_RBRACE] = ACTIONS(1386),
    [aux_sym_trait_declaration_token1] = ACTIONS(1388),
    [aux_sym_interface_declaration_token1] = ACTIONS(1388),
    [aux_sym_enum_declaration_token1] = ACTIONS(1388),
    [aux_sym_enum_case_token1] = ACTIONS(1388),
    [aux_sym_class_declaration_token1] = ACTIONS(1388),
    [aux_sym_final_modifier_token1] = ACTIONS(1388),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1388),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1388),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1388),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1388),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1388),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1388),
    [anon_sym_LPAREN] = ACTIONS(1386),
    [aux_sym_cast_type_token1] = ACTIONS(1388),
    [aux_sym_echo_statement_token1] = ACTIONS(1388),
    [anon_sym_unset] = ACTIONS(1388),
    [aux_sym_declare_statement_token1] = ACTIONS(1388),
    [aux_sym_declare_statement_token2] = ACTIONS(1388),
    [sym_float] = ACTIONS(1388),
    [aux_sym_try_statement_token1] = ACTIONS(1388),
    [aux_sym_goto_statement_token1] = ACTIONS(1388),
    [aux_sym_continue_statement_token1] = ACTIONS(1388),
    [aux_sym_break_statement_token1] = ACTIONS(1388),
    [sym_integer] = ACTIONS(1388),
    [aux_sym_return_statement_token1] = ACTIONS(1388),
    [aux_sym_throw_expression_token1] = ACTIONS(1388),
    [aux_sym_while_statement_token1] = ACTIONS(1388),
    [aux_sym_while_statement_token2] = ACTIONS(1388),
    [aux_sym_do_statement_token1] = ACTIONS(1388),
    [aux_sym_for_statement_token1] = ACTIONS(1388),
    [aux_sym_for_statement_token2] = ACTIONS(1388),
    [aux_sym_foreach_statement_token1] = ACTIONS(1388),
    [aux_sym_foreach_statement_token2] = ACTIONS(1388),
    [aux_sym_if_statement_token1] = ACTIONS(1388),
    [aux_sym_if_statement_token2] = ACTIONS(1388),
    [aux_sym_else_if_clause_token1] = ACTIONS(1388),
    [aux_sym_else_clause_token1] = ACTIONS(1388),
    [aux_sym_match_expression_token1] = ACTIONS(1388),
    [aux_sym_match_default_expression_token1] = ACTIONS(1388),
    [aux_sym_switch_statement_token1] = ACTIONS(1388),
    [aux_sym_switch_block_token1] = ACTIONS(1388),
    [anon_sym_PLUS] = ACTIONS(1388),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1386),
    [anon_sym_BANG] = ACTIONS(1386),
    [anon_sym_AT] = ACTIONS(1386),
    [aux_sym_clone_expression_token1] = ACTIONS(1388),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1388),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1386),
    [anon_sym_PLUS_PLUS] = ACTIONS(1386),
    [aux_sym__list_destructing_token1] = ACTIONS(1388),
    [anon_sym_LBRACK] = ACTIONS(1386),
    [anon_sym_self] = ACTIONS(1388),
    [anon_sym_parent] = ACTIONS(1388),
    [aux_sym__argument_name_token1] = ACTIONS(1388),
    [aux_sym__argument_name_token2] = ACTIONS(1388),
    [anon_sym_POUND_LBRACK] = ACTIONS(1386),
    [anon_sym_SQUOTE] = ACTIONS(1386),
    [aux_sym_encapsed_string_token1] = ACTIONS(1386),
    [anon_sym_DQUOTE] = ACTIONS(1386),
    [aux_sym_string_token1] = ACTIONS(1386),
    [anon_sym_LT_LT_LT] = ACTIONS(1386),
    [anon_sym_BQUOTE] = ACTIONS(1386),
    [anon_sym_DOLLAR] = ACTIONS(1386),
    [aux_sym_yield_expression_token1] = ACTIONS(1388),
    [aux_sym_include_expression_token1] = ACTIONS(1388),
    [aux_sym_include_once_expression_token1] = ACTIONS(1388),
    [aux_sym_require_expression_token1] = ACTIONS(1388),
    [aux_sym_require_once_expression_token1] = ACTIONS(1388),
    [sym_comment] = ACTIONS(3),
  },
  [520] = {
    [ts_builtin_sym_end] = ACTIONS(1390),
    [sym_name] = ACTIONS(1392),
    [anon_sym_QMARK_GT] = ACTIONS(1390),
    [anon_sym_SEMI] = ACTIONS(1390),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1392),
    [aux_sym_global_declaration_token1] = ACTIONS(1392),
    [aux_sym_namespace_definition_token1] = ACTIONS(1392),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1392),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1392),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1392),
    [anon_sym_BSLASH] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_RBRACE] = ACTIONS(1390),
    [aux_sym_trait_declaration_token1] = ACTIONS(1392),
    [aux_sym_interface_declaration_token1] = ACTIONS(1392),
    [aux_sym_enum_declaration_token1] = ACTIONS(1392),
    [aux_sym_enum_case_token1] = ACTIONS(1392),
    [aux_sym_class_declaration_token1] = ACTIONS(1392),
    [aux_sym_final_modifier_token1] = ACTIONS(1392),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1392),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1392),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1392),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1392),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1392),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1390),
    [aux_sym_cast_type_token1] = ACTIONS(1392),
    [aux_sym_echo_statement_token1] = ACTIONS(1392),
    [anon_sym_unset] = ACTIONS(1392),
    [aux_sym_declare_statement_token1] = ACTIONS(1392),
    [aux_sym_declare_statement_token2] = ACTIONS(1392),
    [sym_float] = ACTIONS(1392),
    [aux_sym_try_statement_token1] = ACTIONS(1392),
    [aux_sym_goto_statement_token1] = ACTIONS(1392),
    [aux_sym_continue_statement_token1] = ACTIONS(1392),
    [aux_sym_break_statement_token1] = ACTIONS(1392),
    [sym_integer] = ACTIONS(1392),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_throw_expression_token1] = ACTIONS(1392),
    [aux_sym_while_statement_token1] = ACTIONS(1392),
    [aux_sym_while_statement_token2] = ACTIONS(1392),
    [aux_sym_do_statement_token1] = ACTIONS(1392),
    [aux_sym_for_statement_token1] = ACTIONS(1392),
    [aux_sym_for_statement_token2] = ACTIONS(1392),
    [aux_sym_foreach_statement_token1] = ACTIONS(1392),
    [aux_sym_foreach_statement_token2] = ACTIONS(1392),
    [aux_sym_if_statement_token1] = ACTIONS(1392),
    [aux_sym_if_statement_token2] = ACTIONS(1392),
    [aux_sym_else_if_clause_token1] = ACTIONS(1392),
    [aux_sym_else_clause_token1] = ACTIONS(1392),
    [aux_sym_match_expression_token1] = ACTIONS(1392),
    [aux_sym_match_default_expression_token1] = ACTIONS(1392),
    [aux_sym_switch_statement_token1] = ACTIONS(1392),
    [aux_sym_switch_block_token1] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_BANG] = ACTIONS(1390),
    [anon_sym_AT] = ACTIONS(1390),
    [aux_sym_clone_expression_token1] = ACTIONS(1392),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1392),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1390),
    [anon_sym_PLUS_PLUS] = ACTIONS(1390),
    [aux_sym__list_destructing_token1] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(1390),
    [anon_sym_self] = ACTIONS(1392),
    [anon_sym_parent] = ACTIONS(1392),
    [aux_sym__argument_name_token1] = ACTIONS(1392),
    [aux_sym__argument_name_token2] = ACTIONS(1392),
    [anon_sym_POUND_LBRACK] = ACTIONS(1390),
    [anon_sym_SQUOTE] = ACTIONS(1390),
    [aux_sym_encapsed_string_token1] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [aux_sym_string_token1] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [aux_sym_yield_expression_token1] = ACTIONS(1392),
    [aux_sym_include_expression_token1] = ACTIONS(1392),
    [aux_sym_include_once_expression_token1] = ACTIONS(1392),
    [aux_sym_require_expression_token1] = ACTIONS(1392),
    [aux_sym_require_once_expression_token1] = ACTIONS(1392),
    [sym_comment] = ACTIONS(3),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(1394),
    [sym_name] = ACTIONS(1396),
    [anon_sym_QMARK_GT] = ACTIONS(1394),
    [anon_sym_SEMI] = ACTIONS(1394),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1396),
    [aux_sym_global_declaration_token1] = ACTIONS(1396),
    [aux_sym_namespace_definition_token1] = ACTIONS(1396),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1396),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1396),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1396),
    [anon_sym_BSLASH] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1394),
    [anon_sym_RBRACE] = ACTIONS(1394),
    [aux_sym_trait_declaration_token1] = ACTIONS(1396),
    [aux_sym_interface_declaration_token1] = ACTIONS(1396),
    [aux_sym_enum_declaration_token1] = ACTIONS(1396),
    [aux_sym_enum_case_token1] = ACTIONS(1396),
    [aux_sym_class_declaration_token1] = ACTIONS(1396),
    [aux_sym_final_modifier_token1] = ACTIONS(1396),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1396),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1396),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1396),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1396),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1396),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1396),
    [anon_sym_LPAREN] = ACTIONS(1394),
    [aux_sym_cast_type_token1] = ACTIONS(1396),
    [aux_sym_echo_statement_token1] = ACTIONS(1396),
    [anon_sym_unset] = ACTIONS(1396),
    [aux_sym_declare_statement_token1] = ACTIONS(1396),
    [aux_sym_declare_statement_token2] = ACTIONS(1396),
    [sym_float] = ACTIONS(1396),
    [aux_sym_try_statement_token1] = ACTIONS(1396),
    [aux_sym_goto_statement_token1] = ACTIONS(1396),
    [aux_sym_continue_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1396),
    [sym_integer] = ACTIONS(1396),
    [aux_sym_return_statement_token1] = ACTIONS(1396),
    [aux_sym_throw_expression_token1] = ACTIONS(1396),
    [aux_sym_while_statement_token1] = ACTIONS(1396),
    [aux_sym_while_statement_token2] = ACTIONS(1396),
    [aux_sym_do_statement_token1] = ACTIONS(1396),
    [aux_sym_for_statement_token1] = ACTIONS(1396),
    [aux_sym_for_statement_token2] = ACTIONS(1396),
    [aux_sym_foreach_statement_token1] = ACTIONS(1396),
    [aux_sym_foreach_statement_token2] = ACTIONS(1396),
    [aux_sym_if_statement_token1] = ACTIONS(1396),
    [aux_sym_if_statement_token2] = ACTIONS(1396),
    [aux_sym_else_if_clause_token1] = ACTIONS(1396),
    [aux_sym_else_clause_token1] = ACTIONS(1396),
    [aux_sym_match_expression_token1] = ACTIONS(1396),
    [aux_sym_match_default_expression_token1] = ACTIONS(1396),
    [aux_sym_switch_statement_token1] = ACTIONS(1396),
    [aux_sym_switch_block_token1] = ACTIONS(1396),
    [anon_sym_PLUS] = ACTIONS(1396),
    [anon_sym_DASH] = ACTIONS(1396),
    [anon_sym_TILDE] = ACTIONS(1394),
    [anon_sym_BANG] = ACTIONS(1394),
    [anon_sym_AT] = ACTIONS(1394),
    [aux_sym_clone_expression_token1] = ACTIONS(1396),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1396),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1396),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [aux_sym__list_destructing_token1] = ACTIONS(1396),
    [anon_sym_LBRACK] = ACTIONS(1394),
    [anon_sym_self] = ACTIONS(1396),
    [anon_sym_parent] = ACTIONS(1396),
    [aux_sym__argument_name_token1] = ACTIONS(1396),
    [aux_sym__argument_name_token2] = ACTIONS(1396),
    [anon_sym_POUND_LBRACK] = ACTIONS(1394),
    [anon_sym_SQUOTE] = ACTIONS(1394),
    [aux_sym_encapsed_string_token1] = ACTIONS(1394),
    [anon_sym_DQUOTE] = ACTIONS(1394),
    [aux_sym_string_token1] = ACTIONS(1394),
    [anon_sym_LT_LT_LT] = ACTIONS(1394),
    [anon_sym_BQUOTE] = ACTIONS(1394),
    [anon_sym_DOLLAR] = ACTIONS(1394),
    [aux_sym_yield_expression_token1] = ACTIONS(1396),
    [aux_sym_include_expression_token1] = ACTIONS(1396),
    [aux_sym_include_once_expression_token1] = ACTIONS(1396),
    [aux_sym_require_expression_token1] = ACTIONS(1396),
    [aux_sym_require_once_expression_token1] = ACTIONS(1396),
    [sym_comment] = ACTIONS(3),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(1398),
    [sym_name] = ACTIONS(1400),
    [anon_sym_QMARK_GT] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1398),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1400),
    [aux_sym_global_declaration_token1] = ACTIONS(1400),
    [aux_sym_namespace_definition_token1] = ACTIONS(1400),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1400),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1400),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1400),
    [anon_sym_BSLASH] = ACTIONS(1398),
    [anon_sym_LBRACE] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [aux_sym_trait_declaration_token1] = ACTIONS(1400),
    [aux_sym_interface_declaration_token1] = ACTIONS(1400),
    [aux_sym_enum_declaration_token1] = ACTIONS(1400),
    [aux_sym_enum_case_token1] = ACTIONS(1400),
    [aux_sym_class_declaration_token1] = ACTIONS(1400),
    [aux_sym_final_modifier_token1] = ACTIONS(1400),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1400),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1400),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1400),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1400),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1400),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1400),
    [anon_sym_LPAREN] = ACTIONS(1398),
    [aux_sym_cast_type_token1] = ACTIONS(1400),
    [aux_sym_echo_statement_token1] = ACTIONS(1400),
    [anon_sym_unset] = ACTIONS(1400),
    [aux_sym_declare_statement_token1] = ACTIONS(1400),
    [aux_sym_declare_statement_token2] = ACTIONS(1400),
    [sym_float] = ACTIONS(1400),
    [aux_sym_try_statement_token1] = ACTIONS(1400),
    [aux_sym_goto_statement_token1] = ACTIONS(1400),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_break_statement_token1] = ACTIONS(1400),
    [sym_integer] = ACTIONS(1400),
    [aux_sym_return_statement_token1] = ACTIONS(1400),
    [aux_sym_throw_expression_token1] = ACTIONS(1400),
    [aux_sym_while_statement_token1] = ACTIONS(1400),
    [aux_sym_while_statement_token2] = ACTIONS(1400),
    [aux_sym_do_statement_token1] = ACTIONS(1400),
    [aux_sym_for_statement_token1] = ACTIONS(1400),
    [aux_sym_for_statement_token2] = ACTIONS(1400),
    [aux_sym_foreach_statement_token1] = ACTIONS(1400),
    [aux_sym_foreach_statement_token2] = ACTIONS(1400),
    [aux_sym_if_statement_token1] = ACTIONS(1400),
    [aux_sym_if_statement_token2] = ACTIONS(1400),
    [aux_sym_else_if_clause_token1] = ACTIONS(1400),
    [aux_sym_else_clause_token1] = ACTIONS(1400),
    [aux_sym_match_expression_token1] = ACTIONS(1400),
    [aux_sym_match_default_expression_token1] = ACTIONS(1400),
    [aux_sym_switch_statement_token1] = ACTIONS(1400),
    [aux_sym_switch_block_token1] = ACTIONS(1400),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_TILDE] = ACTIONS(1398),
    [anon_sym_BANG] = ACTIONS(1398),
    [anon_sym_AT] = ACTIONS(1398),
    [aux_sym_clone_expression_token1] = ACTIONS(1400),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1400),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1400),
    [anon_sym_DASH_DASH] = ACTIONS(1398),
    [anon_sym_PLUS_PLUS] = ACTIONS(1398),
    [aux_sym__list_destructing_token1] = ACTIONS(1400),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_self] = ACTIONS(1400),
    [anon_sym_parent] = ACTIONS(1400),
    [aux_sym__argument_name_token1] = ACTIONS(1400),
    [aux_sym__argument_name_token2] = ACTIONS(1400),
    [anon_sym_POUND_LBRACK] = ACTIONS(1398),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [aux_sym_encapsed_string_token1] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [aux_sym_string_token1] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1398),
    [aux_sym_yield_expression_token1] = ACTIONS(1400),
    [aux_sym_include_expression_token1] = ACTIONS(1400),
    [aux_sym_include_once_expression_token1] = ACTIONS(1400),
    [aux_sym_require_expression_token1] = ACTIONS(1400),
    [aux_sym_require_once_expression_token1] = ACTIONS(1400),
    [sym_comment] = ACTIONS(3),
  },
  [523] = {
    [ts_builtin_sym_end] = ACTIONS(1190),
    [sym_name] = ACTIONS(1192),
    [anon_sym_QMARK_GT] = ACTIONS(1190),
    [anon_sym_SEMI] = ACTIONS(1190),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1192),
    [aux_sym_global_declaration_token1] = ACTIONS(1192),
    [aux_sym_namespace_definition_token1] = ACTIONS(1192),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1192),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1192),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1192),
    [anon_sym_BSLASH] = ACTIONS(1190),
    [anon_sym_LBRACE] = ACTIONS(1190),
    [anon_sym_RBRACE] = ACTIONS(1190),
    [aux_sym_trait_declaration_token1] = ACTIONS(1192),
    [aux_sym_interface_declaration_token1] = ACTIONS(1192),
    [aux_sym_enum_declaration_token1] = ACTIONS(1192),
    [aux_sym_enum_case_token1] = ACTIONS(1192),
    [aux_sym_class_declaration_token1] = ACTIONS(1192),
    [aux_sym_final_modifier_token1] = ACTIONS(1192),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1192),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1192),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1192),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1192),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1192),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1192),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [aux_sym_cast_type_token1] = ACTIONS(1192),
    [aux_sym_echo_statement_token1] = ACTIONS(1192),
    [anon_sym_unset] = ACTIONS(1192),
    [aux_sym_declare_statement_token1] = ACTIONS(1192),
    [aux_sym_declare_statement_token2] = ACTIONS(1192),
    [sym_float] = ACTIONS(1192),
    [aux_sym_try_statement_token1] = ACTIONS(1192),
    [aux_sym_goto_statement_token1] = ACTIONS(1192),
    [aux_sym_continue_statement_token1] = ACTIONS(1192),
    [aux_sym_break_statement_token1] = ACTIONS(1192),
    [sym_integer] = ACTIONS(1192),
    [aux_sym_return_statement_token1] = ACTIONS(1192),
    [aux_sym_throw_expression_token1] = ACTIONS(1192),
    [aux_sym_while_statement_token1] = ACTIONS(1192),
    [aux_sym_while_statement_token2] = ACTIONS(1192),
    [aux_sym_do_statement_token1] = ACTIONS(1192),
    [aux_sym_for_statement_token1] = ACTIONS(1192),
    [aux_sym_for_statement_token2] = ACTIONS(1192),
    [aux_sym_foreach_statement_token1] = ACTIONS(1192),
    [aux_sym_foreach_statement_token2] = ACTIONS(1192),
    [aux_sym_if_statement_token1] = ACTIONS(1192),
    [aux_sym_if_statement_token2] = ACTIONS(1192),
    [aux_sym_else_if_clause_token1] = ACTIONS(1192),
    [aux_sym_else_clause_token1] = ACTIONS(1192),
    [aux_sym_match_expression_token1] = ACTIONS(1192),
    [aux_sym_match_default_expression_token1] = ACTIONS(1192),
    [aux_sym_switch_statement_token1] = ACTIONS(1192),
    [aux_sym_switch_block_token1] = ACTIONS(1192),
    [anon_sym_PLUS] = ACTIONS(1192),
    [anon_sym_DASH] = ACTIONS(1192),
    [anon_sym_TILDE] = ACTIONS(1190),
    [anon_sym_BANG] = ACTIONS(1190),
    [anon_sym_AT] = ACTIONS(1190),
    [aux_sym_clone_expression_token1] = ACTIONS(1192),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1192),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1192),
    [anon_sym_DASH_DASH] = ACTIONS(1190),
    [anon_sym_PLUS_PLUS] = ACTIONS(1190),
    [aux_sym__list_destructing_token1] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1190),
    [anon_sym_self] = ACTIONS(1192),
    [anon_sym_parent] = ACTIONS(1192),
    [aux_sym__argument_name_token1] = ACTIONS(1192),
    [aux_sym__argument_name_token2] = ACTIONS(1192),
    [anon_sym_POUND_LBRACK] = ACTIONS(1190),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [aux_sym_encapsed_string_token1] = ACTIONS(1190),
    [anon_sym_DQUOTE] = ACTIONS(1190),
    [aux_sym_string_token1] = ACTIONS(1190),
    [anon_sym_LT_LT_LT] = ACTIONS(1190),
    [anon_sym_BQUOTE] = ACTIONS(1190),
    [anon_sym_DOLLAR] = ACTIONS(1190),
    [aux_sym_yield_expression_token1] = ACTIONS(1192),
    [aux_sym_include_expression_token1] = ACTIONS(1192),
    [aux_sym_include_once_expression_token1] = ACTIONS(1192),
    [aux_sym_require_expression_token1] = ACTIONS(1192),
    [aux_sym_require_once_expression_token1] = ACTIONS(1192),
    [sym_comment] = ACTIONS(3),
  },
  [524] = {
    [ts_builtin_sym_end] = ACTIONS(1402),
    [sym_name] = ACTIONS(1404),
    [anon_sym_QMARK_GT] = ACTIONS(1402),
    [anon_sym_SEMI] = ACTIONS(1402),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1404),
    [aux_sym_global_declaration_token1] = ACTIONS(1404),
    [aux_sym_namespace_definition_token1] = ACTIONS(1404),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1404),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1404),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1404),
    [anon_sym_BSLASH] = ACTIONS(1402),
    [anon_sym_LBRACE] = ACTIONS(1402),
    [anon_sym_RBRACE] = ACTIONS(1402),
    [aux_sym_trait_declaration_token1] = ACTIONS(1404),
    [aux_sym_interface_declaration_token1] = ACTIONS(1404),
    [aux_sym_enum_declaration_token1] = ACTIONS(1404),
    [aux_sym_enum_case_token1] = ACTIONS(1404),
    [aux_sym_class_declaration_token1] = ACTIONS(1404),
    [aux_sym_final_modifier_token1] = ACTIONS(1404),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1404),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1404),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1404),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1404),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1404),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1404),
    [anon_sym_LPAREN] = ACTIONS(1402),
    [aux_sym_cast_type_token1] = ACTIONS(1404),
    [aux_sym_echo_statement_token1] = ACTIONS(1404),
    [anon_sym_unset] = ACTIONS(1404),
    [aux_sym_declare_statement_token1] = ACTIONS(1404),
    [aux_sym_declare_statement_token2] = ACTIONS(1404),
    [sym_float] = ACTIONS(1404),
    [aux_sym_try_statement_token1] = ACTIONS(1404),
    [aux_sym_goto_statement_token1] = ACTIONS(1404),
    [aux_sym_continue_statement_token1] = ACTIONS(1404),
    [aux_sym_break_statement_token1] = ACTIONS(1404),
    [sym_integer] = ACTIONS(1404),
    [aux_sym_return_statement_token1] = ACTIONS(1404),
    [aux_sym_throw_expression_token1] = ACTIONS(1404),
    [aux_sym_while_statement_token1] = ACTIONS(1404),
    [aux_sym_while_statement_token2] = ACTIONS(1404),
    [aux_sym_do_statement_token1] = ACTIONS(1404),
    [aux_sym_for_statement_token1] = ACTIONS(1404),
    [aux_sym_for_statement_token2] = ACTIONS(1404),
    [aux_sym_foreach_statement_token1] = ACTIONS(1404),
    [aux_sym_foreach_statement_token2] = ACTIONS(1404),
    [aux_sym_if_statement_token1] = ACTIONS(1404),
    [aux_sym_if_statement_token2] = ACTIONS(1404),
    [aux_sym_else_if_clause_token1] = ACTIONS(1404),
    [aux_sym_else_clause_token1] = ACTIONS(1404),
    [aux_sym_match_expression_token1] = ACTIONS(1404),
    [aux_sym_match_default_expression_token1] = ACTIONS(1404),
    [aux_sym_switch_statement_token1] = ACTIONS(1404),
    [aux_sym_switch_block_token1] = ACTIONS(1404),
    [anon_sym_PLUS] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1404),
    [anon_sym_TILDE] = ACTIONS(1402),
    [anon_sym_BANG] = ACTIONS(1402),
    [anon_sym_AT] = ACTIONS(1402),
    [aux_sym_clone_expression_token1] = ACTIONS(1404),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1404),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1404),
    [anon_sym_DASH_DASH] = ACTIONS(1402),
    [anon_sym_PLUS_PLUS] = ACTIONS(1402),
    [aux_sym__list_destructing_token1] = ACTIONS(1404),
    [anon_sym_LBRACK] = ACTIONS(1402),
    [anon_sym_self] = ACTIONS(1404),
    [anon_sym_parent] = ACTIONS(1404),
    [aux_sym__argument_name_token1] = ACTIONS(1404),
    [aux_sym__argument_name_token2] = ACTIONS(1404),
    [anon_sym_POUND_LBRACK] = ACTIONS(1402),
    [anon_sym_SQUOTE] = ACTIONS(1402),
    [aux_sym_encapsed_string_token1] = ACTIONS(1402),
    [anon_sym_DQUOTE] = ACTIONS(1402),
    [aux_sym_string_token1] = ACTIONS(1402),
    [anon_sym_LT_LT_LT] = ACTIONS(1402),
    [anon_sym_BQUOTE] = ACTIONS(1402),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [aux_sym_yield_expression_token1] = ACTIONS(1404),
    [aux_sym_include_expression_token1] = ACTIONS(1404),
    [aux_sym_include_once_expression_token1] = ACTIONS(1404),
    [aux_sym_require_expression_token1] = ACTIONS(1404),
    [aux_sym_require_once_expression_token1] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
  },
  [525] = {
    [ts_builtin_sym_end] = ACTIONS(1162),
    [sym_name] = ACTIONS(1164),
    [anon_sym_QMARK_GT] = ACTIONS(1162),
    [anon_sym_SEMI] = ACTIONS(1162),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1164),
    [aux_sym_global_declaration_token1] = ACTIONS(1164),
    [aux_sym_namespace_definition_token1] = ACTIONS(1164),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1164),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1164),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1164),
    [anon_sym_BSLASH] = ACTIONS(1162),
    [anon_sym_LBRACE] = ACTIONS(1162),
    [anon_sym_RBRACE] = ACTIONS(1162),
    [aux_sym_trait_declaration_token1] = ACTIONS(1164),
    [aux_sym_interface_declaration_token1] = ACTIONS(1164),
    [aux_sym_enum_declaration_token1] = ACTIONS(1164),
    [aux_sym_enum_case_token1] = ACTIONS(1164),
    [aux_sym_class_declaration_token1] = ACTIONS(1164),
    [aux_sym_final_modifier_token1] = ACTIONS(1164),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1164),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1164),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1164),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1164),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1164),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1164),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [aux_sym_cast_type_token1] = ACTIONS(1164),
    [aux_sym_echo_statement_token1] = ACTIONS(1164),
    [anon_sym_unset] = ACTIONS(1164),
    [aux_sym_declare_statement_token1] = ACTIONS(1164),
    [aux_sym_declare_statement_token2] = ACTIONS(1164),
    [sym_float] = ACTIONS(1164),
    [aux_sym_try_statement_token1] = ACTIONS(1164),
    [aux_sym_goto_statement_token1] = ACTIONS(1164),
    [aux_sym_continue_statement_token1] = ACTIONS(1164),
    [aux_sym_break_statement_token1] = ACTIONS(1164),
    [sym_integer] = ACTIONS(1164),
    [aux_sym_return_statement_token1] = ACTIONS(1164),
    [aux_sym_throw_expression_token1] = ACTIONS(1164),
    [aux_sym_while_statement_token1] = ACTIONS(1164),
    [aux_sym_while_statement_token2] = ACTIONS(1164),
    [aux_sym_do_statement_token1] = ACTIONS(1164),
    [aux_sym_for_statement_token1] = ACTIONS(1164),
    [aux_sym_for_statement_token2] = ACTIONS(1164),
    [aux_sym_foreach_statement_token1] = ACTIONS(1164),
    [aux_sym_foreach_statement_token2] = ACTIONS(1164),
    [aux_sym_if_statement_token1] = ACTIONS(1164),
    [aux_sym_if_statement_token2] = ACTIONS(1164),
    [aux_sym_else_if_clause_token1] = ACTIONS(1164),
    [aux_sym_else_clause_token1] = ACTIONS(1164),
    [aux_sym_match_expression_token1] = ACTIONS(1164),
    [aux_sym_match_default_expression_token1] = ACTIONS(1164),
    [aux_sym_switch_statement_token1] = ACTIONS(1164),
    [aux_sym_switch_block_token1] = ACTIONS(1164),
    [anon_sym_PLUS] = ACTIONS(1164),
    [anon_sym_DASH] = ACTIONS(1164),
    [anon_sym_TILDE] = ACTIONS(1162),
    [anon_sym_BANG] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(1162),
    [aux_sym_clone_expression_token1] = ACTIONS(1164),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1164),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1164),
    [anon_sym_DASH_DASH] = ACTIONS(1162),
    [anon_sym_PLUS_PLUS] = ACTIONS(1162),
    [aux_sym__list_destructing_token1] = ACTIONS(1164),
    [anon_sym_LBRACK] = ACTIONS(1162),
    [anon_sym_self] = ACTIONS(1164),
    [anon_sym_parent] = ACTIONS(1164),
    [aux_sym__argument_name_token1] = ACTIONS(1164),
    [aux_sym__argument_name_token2] = ACTIONS(1164),
    [anon_sym_POUND_LBRACK] = ACTIONS(1162),
    [anon_sym_SQUOTE] = ACTIONS(1162),
    [aux_sym_encapsed_string_token1] = ACTIONS(1162),
    [anon_sym_DQUOTE] = ACTIONS(1162),
    [aux_sym_string_token1] = ACTIONS(1162),
    [anon_sym_LT_LT_LT] = ACTIONS(1162),
    [anon_sym_BQUOTE] = ACTIONS(1162),
    [anon_sym_DOLLAR] = ACTIONS(1162),
    [aux_sym_yield_expression_token1] = ACTIONS(1164),
    [aux_sym_include_expression_token1] = ACTIONS(1164),
    [aux_sym_include_once_expression_token1] = ACTIONS(1164),
    [aux_sym_require_expression_token1] = ACTIONS(1164),
    [aux_sym_require_once_expression_token1] = ACTIONS(1164),
    [sym_comment] = ACTIONS(3),
  },
  [526] = {
    [ts_builtin_sym_end] = ACTIONS(1126),
    [sym_name] = ACTIONS(1128),
    [anon_sym_QMARK_GT] = ACTIONS(1126),
    [anon_sym_SEMI] = ACTIONS(1126),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1128),
    [aux_sym_global_declaration_token1] = ACTIONS(1128),
    [aux_sym_namespace_definition_token1] = ACTIONS(1128),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1128),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1128),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1128),
    [anon_sym_BSLASH] = ACTIONS(1126),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_RBRACE] = ACTIONS(1126),
    [aux_sym_trait_declaration_token1] = ACTIONS(1128),
    [aux_sym_interface_declaration_token1] = ACTIONS(1128),
    [aux_sym_enum_declaration_token1] = ACTIONS(1128),
    [aux_sym_enum_case_token1] = ACTIONS(1128),
    [aux_sym_class_declaration_token1] = ACTIONS(1128),
    [aux_sym_final_modifier_token1] = ACTIONS(1128),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1128),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1128),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1128),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1128),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1128),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1128),
    [anon_sym_LPAREN] = ACTIONS(1126),
    [aux_sym_cast_type_token1] = ACTIONS(1128),
    [aux_sym_echo_statement_token1] = ACTIONS(1128),
    [anon_sym_unset] = ACTIONS(1128),
    [aux_sym_declare_statement_token1] = ACTIONS(1128),
    [aux_sym_declare_statement_token2] = ACTIONS(1128),
    [sym_float] = ACTIONS(1128),
    [aux_sym_try_statement_token1] = ACTIONS(1128),
    [aux_sym_goto_statement_token1] = ACTIONS(1128),
    [aux_sym_continue_statement_token1] = ACTIONS(1128),
    [aux_sym_break_statement_token1] = ACTIONS(1128),
    [sym_integer] = ACTIONS(1128),
    [aux_sym_return_statement_token1] = ACTIONS(1128),
    [aux_sym_throw_expression_token1] = ACTIONS(1128),
    [aux_sym_while_statement_token1] = ACTIONS(1128),
    [aux_sym_while_statement_token2] = ACTIONS(1128),
    [aux_sym_do_statement_token1] = ACTIONS(1128),
    [aux_sym_for_statement_token1] = ACTIONS(1128),
    [aux_sym_for_statement_token2] = ACTIONS(1128),
    [aux_sym_foreach_statement_token1] = ACTIONS(1128),
    [aux_sym_foreach_statement_token2] = ACTIONS(1128),
    [aux_sym_if_statement_token1] = ACTIONS(1128),
    [aux_sym_if_statement_token2] = ACTIONS(1128),
    [aux_sym_else_if_clause_token1] = ACTIONS(1128),
    [aux_sym_else_clause_token1] = ACTIONS(1128),
    [aux_sym_match_expression_token1] = ACTIONS(1128),
    [aux_sym_match_default_expression_token1] = ACTIONS(1128),
    [aux_sym_switch_statement_token1] = ACTIONS(1128),
    [aux_sym_switch_block_token1] = ACTIONS(1128),
    [anon_sym_PLUS] = ACTIONS(1128),
    [anon_sym_DASH] = ACTIONS(1128),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_BANG] = ACTIONS(1126),
    [anon_sym_AT] = ACTIONS(1126),
    [aux_sym_clone_expression_token1] = ACTIONS(1128),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1128),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1128),
    [anon_sym_DASH_DASH] = ACTIONS(1126),
    [anon_sym_PLUS_PLUS] = ACTIONS(1126),
    [aux_sym__list_destructing_token1] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(1126),
    [anon_sym_self] = ACTIONS(1128),
    [anon_sym_parent] = ACTIONS(1128),
    [aux_sym__argument_name_token1] = ACTIONS(1128),
    [aux_sym__argument_name_token2] = ACTIONS(1128),
    [anon_sym_POUND_LBRACK] = ACTIONS(1126),
    [anon_sym_SQUOTE] = ACTIONS(1126),
    [aux_sym_encapsed_string_token1] = ACTIONS(1126),
    [anon_sym_DQUOTE] = ACTIONS(1126),
    [aux_sym_string_token1] = ACTIONS(1126),
    [anon_sym_LT_LT_LT] = ACTIONS(1126),
    [anon_sym_BQUOTE] = ACTIONS(1126),
    [anon_sym_DOLLAR] = ACTIONS(1126),
    [aux_sym_yield_expression_token1] = ACTIONS(1128),
    [aux_sym_include_expression_token1] = ACTIONS(1128),
    [aux_sym_include_once_expression_token1] = ACTIONS(1128),
    [aux_sym_require_expression_token1] = ACTIONS(1128),
    [aux_sym_require_once_expression_token1] = ACTIONS(1128),
    [sym_comment] = ACTIONS(3),
  },
  [527] = {
    [ts_builtin_sym_end] = ACTIONS(1406),
    [sym_name] = ACTIONS(1408),
    [anon_sym_QMARK_GT] = ACTIONS(1406),
    [anon_sym_SEMI] = ACTIONS(1406),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1408),
    [aux_sym_global_declaration_token1] = ACTIONS(1408),
    [aux_sym_namespace_definition_token1] = ACTIONS(1408),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1408),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1408),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1408),
    [anon_sym_BSLASH] = ACTIONS(1406),
    [anon_sym_LBRACE] = ACTIONS(1406),
    [anon_sym_RBRACE] = ACTIONS(1406),
    [aux_sym_trait_declaration_token1] = ACTIONS(1408),
    [aux_sym_interface_declaration_token1] = ACTIONS(1408),
    [aux_sym_enum_declaration_token1] = ACTIONS(1408),
    [aux_sym_enum_case_token1] = ACTIONS(1408),
    [aux_sym_class_declaration_token1] = ACTIONS(1408),
    [aux_sym_final_modifier_token1] = ACTIONS(1408),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1408),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1408),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1408),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1408),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1408),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(1406),
    [aux_sym_cast_type_token1] = ACTIONS(1408),
    [aux_sym_echo_statement_token1] = ACTIONS(1408),
    [anon_sym_unset] = ACTIONS(1408),
    [aux_sym_declare_statement_token1] = ACTIONS(1408),
    [aux_sym_declare_statement_token2] = ACTIONS(1408),
    [sym_float] = ACTIONS(1408),
    [aux_sym_try_statement_token1] = ACTIONS(1408),
    [aux_sym_goto_statement_token1] = ACTIONS(1408),
    [aux_sym_continue_statement_token1] = ACTIONS(1408),
    [aux_sym_break_statement_token1] = ACTIONS(1408),
    [sym_integer] = ACTIONS(1408),
    [aux_sym_return_statement_token1] = ACTIONS(1408),
    [aux_sym_throw_expression_token1] = ACTIONS(1408),
    [aux_sym_while_statement_token1] = ACTIONS(1408),
    [aux_sym_while_statement_token2] = ACTIONS(1408),
    [aux_sym_do_statement_token1] = ACTIONS(1408),
    [aux_sym_for_statement_token1] = ACTIONS(1408),
    [aux_sym_for_statement_token2] = ACTIONS(1408),
    [aux_sym_foreach_statement_token1] = ACTIONS(1408),
    [aux_sym_foreach_statement_token2] = ACTIONS(1408),
    [aux_sym_if_statement_token1] = ACTIONS(1408),
    [aux_sym_if_statement_token2] = ACTIONS(1408),
    [aux_sym_else_if_clause_token1] = ACTIONS(1408),
    [aux_sym_else_clause_token1] = ACTIONS(1408),
    [aux_sym_match_expression_token1] = ACTIONS(1408),
    [aux_sym_match_default_expression_token1] = ACTIONS(1408),
    [aux_sym_switch_statement_token1] = ACTIONS(1408),
    [aux_sym_switch_block_token1] = ACTIONS(1408),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(1406),
    [anon_sym_AT] = ACTIONS(1406),
    [aux_sym_clone_expression_token1] = ACTIONS(1408),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1408),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1408),
    [anon_sym_DASH_DASH] = ACTIONS(1406),
    [anon_sym_PLUS_PLUS] = ACTIONS(1406),
    [aux_sym__list_destructing_token1] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1406),
    [anon_sym_self] = ACTIONS(1408),
    [anon_sym_parent] = ACTIONS(1408),
    [aux_sym__argument_name_token1] = ACTIONS(1408),
    [aux_sym__argument_name_token2] = ACTIONS(1408),
    [anon_sym_POUND_LBRACK] = ACTIONS(1406),
    [anon_sym_SQUOTE] = ACTIONS(1406),
    [aux_sym_encapsed_string_token1] = ACTIONS(1406),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [aux_sym_string_token1] = ACTIONS(1406),
    [anon_sym_LT_LT_LT] = ACTIONS(1406),
    [anon_sym_BQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [aux_sym_yield_expression_token1] = ACTIONS(1408),
    [aux_sym_include_expression_token1] = ACTIONS(1408),
    [aux_sym_include_once_expression_token1] = ACTIONS(1408),
    [aux_sym_require_expression_token1] = ACTIONS(1408),
    [aux_sym_require_once_expression_token1] = ACTIONS(1408),
    [sym_comment] = ACTIONS(3),
  },
  [528] = {
    [ts_builtin_sym_end] = ACTIONS(1410),
    [sym_name] = ACTIONS(1412),
    [anon_sym_QMARK_GT] = ACTIONS(1410),
    [anon_sym_SEMI] = ACTIONS(1410),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1412),
    [aux_sym_global_declaration_token1] = ACTIONS(1412),
    [aux_sym_namespace_definition_token1] = ACTIONS(1412),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1412),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1412),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1410),
    [anon_sym_LBRACE] = ACTIONS(1410),
    [anon_sym_RBRACE] = ACTIONS(1410),
    [aux_sym_trait_declaration_token1] = ACTIONS(1412),
    [aux_sym_interface_declaration_token1] = ACTIONS(1412),
    [aux_sym_enum_declaration_token1] = ACTIONS(1412),
    [aux_sym_enum_case_token1] = ACTIONS(1412),
    [aux_sym_class_declaration_token1] = ACTIONS(1412),
    [aux_sym_final_modifier_token1] = ACTIONS(1412),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1412),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1412),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1412),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1412),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1412),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1412),
    [anon_sym_LPAREN] = ACTIONS(1410),
    [aux_sym_cast_type_token1] = ACTIONS(1412),
    [aux_sym_echo_statement_token1] = ACTIONS(1412),
    [anon_sym_unset] = ACTIONS(1412),
    [aux_sym_declare_statement_token1] = ACTIONS(1412),
    [aux_sym_declare_statement_token2] = ACTIONS(1412),
    [sym_float] = ACTIONS(1412),
    [aux_sym_try_statement_token1] = ACTIONS(1412),
    [aux_sym_goto_statement_token1] = ACTIONS(1412),
    [aux_sym_continue_statement_token1] = ACTIONS(1412),
    [aux_sym_break_statement_token1] = ACTIONS(1412),
    [sym_integer] = ACTIONS(1412),
    [aux_sym_return_statement_token1] = ACTIONS(1412),
    [aux_sym_throw_expression_token1] = ACTIONS(1412),
    [aux_sym_while_statement_token1] = ACTIONS(1412),
    [aux_sym_while_statement_token2] = ACTIONS(1412),
    [aux_sym_do_statement_token1] = ACTIONS(1412),
    [aux_sym_for_statement_token1] = ACTIONS(1412),
    [aux_sym_for_statement_token2] = ACTIONS(1412),
    [aux_sym_foreach_statement_token1] = ACTIONS(1412),
    [aux_sym_foreach_statement_token2] = ACTIONS(1412),
    [aux_sym_if_statement_token1] = ACTIONS(1412),
    [aux_sym_if_statement_token2] = ACTIONS(1412),
    [aux_sym_else_if_clause_token1] = ACTIONS(1412),
    [aux_sym_else_clause_token1] = ACTIONS(1412),
    [aux_sym_match_expression_token1] = ACTIONS(1412),
    [aux_sym_match_default_expression_token1] = ACTIONS(1412),
    [aux_sym_switch_statement_token1] = ACTIONS(1412),
    [aux_sym_switch_block_token1] = ACTIONS(1412),
    [anon_sym_PLUS] = ACTIONS(1412),
    [anon_sym_DASH] = ACTIONS(1412),
    [anon_sym_TILDE] = ACTIONS(1410),
    [anon_sym_BANG] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(1410),
    [aux_sym_clone_expression_token1] = ACTIONS(1412),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1412),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1412),
    [anon_sym_DASH_DASH] = ACTIONS(1410),
    [anon_sym_PLUS_PLUS] = ACTIONS(1410),
    [aux_sym__list_destructing_token1] = ACTIONS(1412),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_self] = ACTIONS(1412),
    [anon_sym_parent] = ACTIONS(1412),
    [aux_sym__argument_name_token1] = ACTIONS(1412),
    [aux_sym__argument_name_token2] = ACTIONS(1412),
    [anon_sym_POUND_LBRACK] = ACTIONS(1410),
    [anon_sym_SQUOTE] = ACTIONS(1410),
    [aux_sym_encapsed_string_token1] = ACTIONS(1410),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [aux_sym_string_token1] = ACTIONS(1410),
    [anon_sym_LT_LT_LT] = ACTIONS(1410),
    [anon_sym_BQUOTE] = ACTIONS(1410),
    [anon_sym_DOLLAR] = ACTIONS(1410),
    [aux_sym_yield_expression_token1] = ACTIONS(1412),
    [aux_sym_include_expression_token1] = ACTIONS(1412),
    [aux_sym_include_once_expression_token1] = ACTIONS(1412),
    [aux_sym_require_expression_token1] = ACTIONS(1412),
    [aux_sym_require_once_expression_token1] = ACTIONS(1412),
    [sym_comment] = ACTIONS(3),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(1414),
    [sym_name] = ACTIONS(1416),
    [anon_sym_QMARK_GT] = ACTIONS(1414),
    [anon_sym_SEMI] = ACTIONS(1414),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1416),
    [aux_sym_global_declaration_token1] = ACTIONS(1416),
    [aux_sym_namespace_definition_token1] = ACTIONS(1416),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1416),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1416),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1416),
    [anon_sym_BSLASH] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1414),
    [anon_sym_RBRACE] = ACTIONS(1414),
    [aux_sym_trait_declaration_token1] = ACTIONS(1416),
    [aux_sym_interface_declaration_token1] = ACTIONS(1416),
    [aux_sym_enum_declaration_token1] = ACTIONS(1416),
    [aux_sym_enum_case_token1] = ACTIONS(1416),
    [aux_sym_class_declaration_token1] = ACTIONS(1416),
    [aux_sym_final_modifier_token1] = ACTIONS(1416),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1416),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1416),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1416),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1416),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1416),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1416),
    [anon_sym_LPAREN] = ACTIONS(1414),
    [aux_sym_cast_type_token1] = ACTIONS(1416),
    [aux_sym_echo_statement_token1] = ACTIONS(1416),
    [anon_sym_unset] = ACTIONS(1416),
    [aux_sym_declare_statement_token1] = ACTIONS(1416),
    [aux_sym_declare_statement_token2] = ACTIONS(1416),
    [sym_float] = ACTIONS(1416),
    [aux_sym_try_statement_token1] = ACTIONS(1416),
    [aux_sym_goto_statement_token1] = ACTIONS(1416),
    [aux_sym_continue_statement_token1] = ACTIONS(1416),
    [aux_sym_break_statement_token1] = ACTIONS(1416),
    [sym_integer] = ACTIONS(1416),
    [aux_sym_return_statement_token1] = ACTIONS(1416),
    [aux_sym_throw_expression_token1] = ACTIONS(1416),
    [aux_sym_while_statement_token1] = ACTIONS(1416),
    [aux_sym_while_statement_token2] = ACTIONS(1416),
    [aux_sym_do_statement_token1] = ACTIONS(1416),
    [aux_sym_for_statement_token1] = ACTIONS(1416),
    [aux_sym_for_statement_token2] = ACTIONS(1416),
    [aux_sym_foreach_statement_token1] = ACTIONS(1416),
    [aux_sym_foreach_statement_token2] = ACTIONS(1416),
    [aux_sym_if_statement_token1] = ACTIONS(1416),
    [aux_sym_if_statement_token2] = ACTIONS(1416),
    [aux_sym_else_if_clause_token1] = ACTIONS(1416),
    [aux_sym_else_clause_token1] = ACTIONS(1416),
    [aux_sym_match_expression_token1] = ACTIONS(1416),
    [aux_sym_match_default_expression_token1] = ACTIONS(1416),
    [aux_sym_switch_statement_token1] = ACTIONS(1416),
    [aux_sym_switch_block_token1] = ACTIONS(1416),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_TILDE] = ACTIONS(1414),
    [anon_sym_BANG] = ACTIONS(1414),
    [anon_sym_AT] = ACTIONS(1414),
    [aux_sym_clone_expression_token1] = ACTIONS(1416),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1416),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1416),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [aux_sym__list_destructing_token1] = ACTIONS(1416),
    [anon_sym_LBRACK] = ACTIONS(1414),
    [anon_sym_self] = ACTIONS(1416),
    [anon_sym_parent] = ACTIONS(1416),
    [aux_sym__argument_name_token1] = ACTIONS(1416),
    [aux_sym__argument_name_token2] = ACTIONS(1416),
    [anon_sym_POUND_LBRACK] = ACTIONS(1414),
    [anon_sym_SQUOTE] = ACTIONS(1414),
    [aux_sym_encapsed_string_token1] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(1414),
    [aux_sym_string_token1] = ACTIONS(1414),
    [anon_sym_LT_LT_LT] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1414),
    [anon_sym_DOLLAR] = ACTIONS(1414),
    [aux_sym_yield_expression_token1] = ACTIONS(1416),
    [aux_sym_include_expression_token1] = ACTIONS(1416),
    [aux_sym_include_once_expression_token1] = ACTIONS(1416),
    [aux_sym_require_expression_token1] = ACTIONS(1416),
    [aux_sym_require_once_expression_token1] = ACTIONS(1416),
    [sym_comment] = ACTIONS(3),
  },
  [530] = {
    [ts_builtin_sym_end] = ACTIONS(1418),
    [sym_name] = ACTIONS(1420),
    [anon_sym_QMARK_GT] = ACTIONS(1418),
    [anon_sym_SEMI] = ACTIONS(1418),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1420),
    [aux_sym_global_declaration_token1] = ACTIONS(1420),
    [aux_sym_namespace_definition_token1] = ACTIONS(1420),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1420),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1420),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1420),
    [anon_sym_BSLASH] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [aux_sym_trait_declaration_token1] = ACTIONS(1420),
    [aux_sym_interface_declaration_token1] = ACTIONS(1420),
    [aux_sym_enum_declaration_token1] = ACTIONS(1420),
    [aux_sym_enum_case_token1] = ACTIONS(1420),
    [aux_sym_class_declaration_token1] = ACTIONS(1420),
    [aux_sym_final_modifier_token1] = ACTIONS(1420),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1420),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1420),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1420),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1420),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1420),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1418),
    [aux_sym_cast_type_token1] = ACTIONS(1420),
    [aux_sym_echo_statement_token1] = ACTIONS(1420),
    [anon_sym_unset] = ACTIONS(1420),
    [aux_sym_declare_statement_token1] = ACTIONS(1420),
    [aux_sym_declare_statement_token2] = ACTIONS(1420),
    [sym_float] = ACTIONS(1420),
    [aux_sym_try_statement_token1] = ACTIONS(1420),
    [aux_sym_goto_statement_token1] = ACTIONS(1420),
    [aux_sym_continue_statement_token1] = ACTIONS(1420),
    [aux_sym_break_statement_token1] = ACTIONS(1420),
    [sym_integer] = ACTIONS(1420),
    [aux_sym_return_statement_token1] = ACTIONS(1420),
    [aux_sym_throw_expression_token1] = ACTIONS(1420),
    [aux_sym_while_statement_token1] = ACTIONS(1420),
    [aux_sym_while_statement_token2] = ACTIONS(1420),
    [aux_sym_do_statement_token1] = ACTIONS(1420),
    [aux_sym_for_statement_token1] = ACTIONS(1420),
    [aux_sym_for_statement_token2] = ACTIONS(1420),
    [aux_sym_foreach_statement_token1] = ACTIONS(1420),
    [aux_sym_foreach_statement_token2] = ACTIONS(1420),
    [aux_sym_if_statement_token1] = ACTIONS(1420),
    [aux_sym_if_statement_token2] = ACTIONS(1420),
    [aux_sym_else_if_clause_token1] = ACTIONS(1420),
    [aux_sym_else_clause_token1] = ACTIONS(1420),
    [aux_sym_match_expression_token1] = ACTIONS(1420),
    [aux_sym_match_default_expression_token1] = ACTIONS(1420),
    [aux_sym_switch_statement_token1] = ACTIONS(1420),
    [aux_sym_switch_block_token1] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_TILDE] = ACTIONS(1418),
    [anon_sym_BANG] = ACTIONS(1418),
    [anon_sym_AT] = ACTIONS(1418),
    [aux_sym_clone_expression_token1] = ACTIONS(1420),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1420),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1420),
    [anon_sym_DASH_DASH] = ACTIONS(1418),
    [anon_sym_PLUS_PLUS] = ACTIONS(1418),
    [aux_sym__list_destructing_token1] = ACTIONS(1420),
    [anon_sym_LBRACK] = ACTIONS(1418),
    [anon_sym_self] = ACTIONS(1420),
    [anon_sym_parent] = ACTIONS(1420),
    [aux_sym__argument_name_token1] = ACTIONS(1420),
    [aux_sym__argument_name_token2] = ACTIONS(1420),
    [anon_sym_POUND_LBRACK] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1418),
    [aux_sym_encapsed_string_token1] = ACTIONS(1418),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [aux_sym_string_token1] = ACTIONS(1418),
    [anon_sym_LT_LT_LT] = ACTIONS(1418),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_DOLLAR] = ACTIONS(1418),
    [aux_sym_yield_expression_token1] = ACTIONS(1420),
    [aux_sym_include_expression_token1] = ACTIONS(1420),
    [aux_sym_include_once_expression_token1] = ACTIONS(1420),
    [aux_sym_require_expression_token1] = ACTIONS(1420),
    [aux_sym_require_once_expression_token1] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
  },
  [531] = {
    [ts_builtin_sym_end] = ACTIONS(1422),
    [sym_name] = ACTIONS(1424),
    [anon_sym_QMARK_GT] = ACTIONS(1422),
    [anon_sym_SEMI] = ACTIONS(1422),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1424),
    [aux_sym_global_declaration_token1] = ACTIONS(1424),
    [aux_sym_namespace_definition_token1] = ACTIONS(1424),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1424),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1424),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1424),
    [anon_sym_BSLASH] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(1422),
    [anon_sym_RBRACE] = ACTIONS(1422),
    [aux_sym_trait_declaration_token1] = ACTIONS(1424),
    [aux_sym_interface_declaration_token1] = ACTIONS(1424),
    [aux_sym_enum_declaration_token1] = ACTIONS(1424),
    [aux_sym_enum_case_token1] = ACTIONS(1424),
    [aux_sym_class_declaration_token1] = ACTIONS(1424),
    [aux_sym_final_modifier_token1] = ACTIONS(1424),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1424),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1424),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1424),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1424),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1424),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1424),
    [anon_sym_LPAREN] = ACTIONS(1422),
    [aux_sym_cast_type_token1] = ACTIONS(1424),
    [aux_sym_echo_statement_token1] = ACTIONS(1424),
    [anon_sym_unset] = ACTIONS(1424),
    [aux_sym_declare_statement_token1] = ACTIONS(1424),
    [aux_sym_declare_statement_token2] = ACTIONS(1424),
    [sym_float] = ACTIONS(1424),
    [aux_sym_try_statement_token1] = ACTIONS(1424),
    [aux_sym_goto_statement_token1] = ACTIONS(1424),
    [aux_sym_continue_statement_token1] = ACTIONS(1424),
    [aux_sym_break_statement_token1] = ACTIONS(1424),
    [sym_integer] = ACTIONS(1424),
    [aux_sym_return_statement_token1] = ACTIONS(1424),
    [aux_sym_throw_expression_token1] = ACTIONS(1424),
    [aux_sym_while_statement_token1] = ACTIONS(1424),
    [aux_sym_while_statement_token2] = ACTIONS(1424),
    [aux_sym_do_statement_token1] = ACTIONS(1424),
    [aux_sym_for_statement_token1] = ACTIONS(1424),
    [aux_sym_for_statement_token2] = ACTIONS(1424),
    [aux_sym_foreach_statement_token1] = ACTIONS(1424),
    [aux_sym_foreach_statement_token2] = ACTIONS(1424),
    [aux_sym_if_statement_token1] = ACTIONS(1424),
    [aux_sym_if_statement_token2] = ACTIONS(1424),
    [aux_sym_else_if_clause_token1] = ACTIONS(1424),
    [aux_sym_else_clause_token1] = ACTIONS(1424),
    [aux_sym_match_expression_token1] = ACTIONS(1424),
    [aux_sym_match_default_expression_token1] = ACTIONS(1424),
    [aux_sym_switch_statement_token1] = ACTIONS(1424),
    [aux_sym_switch_block_token1] = ACTIONS(1424),
    [anon_sym_PLUS] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1424),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_BANG] = ACTIONS(1422),
    [anon_sym_AT] = ACTIONS(1422),
    [aux_sym_clone_expression_token1] = ACTIONS(1424),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1424),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1424),
    [anon_sym_DASH_DASH] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1422),
    [aux_sym__list_destructing_token1] = ACTIONS(1424),
    [anon_sym_LBRACK] = ACTIONS(1422),
    [anon_sym_self] = ACTIONS(1424),
    [anon_sym_parent] = ACTIONS(1424),
    [aux_sym__argument_name_token1] = ACTIONS(1424),
    [aux_sym__argument_name_token2] = ACTIONS(1424),
    [anon_sym_POUND_LBRACK] = ACTIONS(1422),
    [anon_sym_SQUOTE] = ACTIONS(1422),
    [aux_sym_encapsed_string_token1] = ACTIONS(1422),
    [anon_sym_DQUOTE] = ACTIONS(1422),
    [aux_sym_string_token1] = ACTIONS(1422),
    [anon_sym_LT_LT_LT] = ACTIONS(1422),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [anon_sym_DOLLAR] = ACTIONS(1422),
    [aux_sym_yield_expression_token1] = ACTIONS(1424),
    [aux_sym_include_expression_token1] = ACTIONS(1424),
    [aux_sym_include_once_expression_token1] = ACTIONS(1424),
    [aux_sym_require_expression_token1] = ACTIONS(1424),
    [aux_sym_require_once_expression_token1] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
  },
  [532] = {
    [ts_builtin_sym_end] = ACTIONS(1426),
    [sym_name] = ACTIONS(1428),
    [anon_sym_QMARK_GT] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1426),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1428),
    [aux_sym_global_declaration_token1] = ACTIONS(1428),
    [aux_sym_namespace_definition_token1] = ACTIONS(1428),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1428),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1428),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1426),
    [anon_sym_LBRACE] = ACTIONS(1426),
    [anon_sym_RBRACE] = ACTIONS(1426),
    [aux_sym_trait_declaration_token1] = ACTIONS(1428),
    [aux_sym_interface_declaration_token1] = ACTIONS(1428),
    [aux_sym_enum_declaration_token1] = ACTIONS(1428),
    [aux_sym_enum_case_token1] = ACTIONS(1428),
    [aux_sym_class_declaration_token1] = ACTIONS(1428),
    [aux_sym_final_modifier_token1] = ACTIONS(1428),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1428),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1428),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1428),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1428),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1428),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1428),
    [anon_sym_LPAREN] = ACTIONS(1426),
    [aux_sym_cast_type_token1] = ACTIONS(1428),
    [aux_sym_echo_statement_token1] = ACTIONS(1428),
    [anon_sym_unset] = ACTIONS(1428),
    [aux_sym_declare_statement_token1] = ACTIONS(1428),
    [aux_sym_declare_statement_token2] = ACTIONS(1428),
    [sym_float] = ACTIONS(1428),
    [aux_sym_try_statement_token1] = ACTIONS(1428),
    [aux_sym_goto_statement_token1] = ACTIONS(1428),
    [aux_sym_continue_statement_token1] = ACTIONS(1428),
    [aux_sym_break_statement_token1] = ACTIONS(1428),
    [sym_integer] = ACTIONS(1428),
    [aux_sym_return_statement_token1] = ACTIONS(1428),
    [aux_sym_throw_expression_token1] = ACTIONS(1428),
    [aux_sym_while_statement_token1] = ACTIONS(1428),
    [aux_sym_while_statement_token2] = ACTIONS(1428),
    [aux_sym_do_statement_token1] = ACTIONS(1428),
    [aux_sym_for_statement_token1] = ACTIONS(1428),
    [aux_sym_for_statement_token2] = ACTIONS(1428),
    [aux_sym_foreach_statement_token1] = ACTIONS(1428),
    [aux_sym_foreach_statement_token2] = ACTIONS(1428),
    [aux_sym_if_statement_token1] = ACTIONS(1428),
    [aux_sym_if_statement_token2] = ACTIONS(1428),
    [aux_sym_else_if_clause_token1] = ACTIONS(1428),
    [aux_sym_else_clause_token1] = ACTIONS(1428),
    [aux_sym_match_expression_token1] = ACTIONS(1428),
    [aux_sym_match_default_expression_token1] = ACTIONS(1428),
    [aux_sym_switch_statement_token1] = ACTIONS(1428),
    [aux_sym_switch_block_token1] = ACTIONS(1428),
    [anon_sym_PLUS] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_TILDE] = ACTIONS(1426),
    [anon_sym_BANG] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(1426),
    [aux_sym_clone_expression_token1] = ACTIONS(1428),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1428),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1428),
    [anon_sym_DASH_DASH] = ACTIONS(1426),
    [anon_sym_PLUS_PLUS] = ACTIONS(1426),
    [aux_sym__list_destructing_token1] = ACTIONS(1428),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_self] = ACTIONS(1428),
    [anon_sym_parent] = ACTIONS(1428),
    [aux_sym__argument_name_token1] = ACTIONS(1428),
    [aux_sym__argument_name_token2] = ACTIONS(1428),
    [anon_sym_POUND_LBRACK] = ACTIONS(1426),
    [anon_sym_SQUOTE] = ACTIONS(1426),
    [aux_sym_encapsed_string_token1] = ACTIONS(1426),
    [anon_sym_DQUOTE] = ACTIONS(1426),
    [aux_sym_string_token1] = ACTIONS(1426),
    [anon_sym_LT_LT_LT] = ACTIONS(1426),
    [anon_sym_BQUOTE] = ACTIONS(1426),
    [anon_sym_DOLLAR] = ACTIONS(1426),
    [aux_sym_yield_expression_token1] = ACTIONS(1428),
    [aux_sym_include_expression_token1] = ACTIONS(1428),
    [aux_sym_include_once_expression_token1] = ACTIONS(1428),
    [aux_sym_require_expression_token1] = ACTIONS(1428),
    [aux_sym_require_once_expression_token1] = ACTIONS(1428),
    [sym_comment] = ACTIONS(3),
  },
  [533] = {
    [ts_builtin_sym_end] = ACTIONS(1430),
    [sym_name] = ACTIONS(1432),
    [anon_sym_QMARK_GT] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1430),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1432),
    [aux_sym_global_declaration_token1] = ACTIONS(1432),
    [aux_sym_namespace_definition_token1] = ACTIONS(1432),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1432),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1432),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1432),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1430),
    [anon_sym_RBRACE] = ACTIONS(1430),
    [aux_sym_trait_declaration_token1] = ACTIONS(1432),
    [aux_sym_interface_declaration_token1] = ACTIONS(1432),
    [aux_sym_enum_declaration_token1] = ACTIONS(1432),
    [aux_sym_enum_case_token1] = ACTIONS(1432),
    [aux_sym_class_declaration_token1] = ACTIONS(1432),
    [aux_sym_final_modifier_token1] = ACTIONS(1432),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1432),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1432),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1432),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1432),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1432),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1432),
    [anon_sym_LPAREN] = ACTIONS(1430),
    [aux_sym_cast_type_token1] = ACTIONS(1432),
    [aux_sym_echo_statement_token1] = ACTIONS(1432),
    [anon_sym_unset] = ACTIONS(1432),
    [aux_sym_declare_statement_token1] = ACTIONS(1432),
    [aux_sym_declare_statement_token2] = ACTIONS(1432),
    [sym_float] = ACTIONS(1432),
    [aux_sym_try_statement_token1] = ACTIONS(1432),
    [aux_sym_goto_statement_token1] = ACTIONS(1432),
    [aux_sym_continue_statement_token1] = ACTIONS(1432),
    [aux_sym_break_statement_token1] = ACTIONS(1432),
    [sym_integer] = ACTIONS(1432),
    [aux_sym_return_statement_token1] = ACTIONS(1432),
    [aux_sym_throw_expression_token1] = ACTIONS(1432),
    [aux_sym_while_statement_token1] = ACTIONS(1432),
    [aux_sym_while_statement_token2] = ACTIONS(1432),
    [aux_sym_do_statement_token1] = ACTIONS(1432),
    [aux_sym_for_statement_token1] = ACTIONS(1432),
    [aux_sym_for_statement_token2] = ACTIONS(1432),
    [aux_sym_foreach_statement_token1] = ACTIONS(1432),
    [aux_sym_foreach_statement_token2] = ACTIONS(1432),
    [aux_sym_if_statement_token1] = ACTIONS(1432),
    [aux_sym_if_statement_token2] = ACTIONS(1432),
    [aux_sym_else_if_clause_token1] = ACTIONS(1432),
    [aux_sym_else_clause_token1] = ACTIONS(1432),
    [aux_sym_match_expression_token1] = ACTIONS(1432),
    [aux_sym_match_default_expression_token1] = ACTIONS(1432),
    [aux_sym_switch_statement_token1] = ACTIONS(1432),
    [aux_sym_switch_block_token1] = ACTIONS(1432),
    [anon_sym_PLUS] = ACTIONS(1432),
    [anon_sym_DASH] = ACTIONS(1432),
    [anon_sym_TILDE] = ACTIONS(1430),
    [anon_sym_BANG] = ACTIONS(1430),
    [anon_sym_AT] = ACTIONS(1430),
    [aux_sym_clone_expression_token1] = ACTIONS(1432),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1432),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1432),
    [anon_sym_DASH_DASH] = ACTIONS(1430),
    [anon_sym_PLUS_PLUS] = ACTIONS(1430),
    [aux_sym__list_destructing_token1] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1430),
    [anon_sym_self] = ACTIONS(1432),
    [anon_sym_parent] = ACTIONS(1432),
    [aux_sym__argument_name_token1] = ACTIONS(1432),
    [aux_sym__argument_name_token2] = ACTIONS(1432),
    [anon_sym_POUND_LBRACK] = ACTIONS(1430),
    [anon_sym_SQUOTE] = ACTIONS(1430),
    [aux_sym_encapsed_string_token1] = ACTIONS(1430),
    [anon_sym_DQUOTE] = ACTIONS(1430),
    [aux_sym_string_token1] = ACTIONS(1430),
    [anon_sym_LT_LT_LT] = ACTIONS(1430),
    [anon_sym_BQUOTE] = ACTIONS(1430),
    [anon_sym_DOLLAR] = ACTIONS(1430),
    [aux_sym_yield_expression_token1] = ACTIONS(1432),
    [aux_sym_include_expression_token1] = ACTIONS(1432),
    [aux_sym_include_once_expression_token1] = ACTIONS(1432),
    [aux_sym_require_expression_token1] = ACTIONS(1432),
    [aux_sym_require_once_expression_token1] = ACTIONS(1432),
    [sym_comment] = ACTIONS(3),
  },
  [534] = {
    [ts_builtin_sym_end] = ACTIONS(1434),
    [sym_name] = ACTIONS(1436),
    [anon_sym_QMARK_GT] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1434),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1436),
    [aux_sym_global_declaration_token1] = ACTIONS(1436),
    [aux_sym_namespace_definition_token1] = ACTIONS(1436),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1436),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1436),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1436),
    [anon_sym_BSLASH] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [aux_sym_trait_declaration_token1] = ACTIONS(1436),
    [aux_sym_interface_declaration_token1] = ACTIONS(1436),
    [aux_sym_enum_declaration_token1] = ACTIONS(1436),
    [aux_sym_enum_case_token1] = ACTIONS(1436),
    [aux_sym_class_declaration_token1] = ACTIONS(1436),
    [aux_sym_final_modifier_token1] = ACTIONS(1436),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1436),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1436),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1436),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1436),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1436),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [aux_sym_cast_type_token1] = ACTIONS(1436),
    [aux_sym_echo_statement_token1] = ACTIONS(1436),
    [anon_sym_unset] = ACTIONS(1436),
    [aux_sym_declare_statement_token1] = ACTIONS(1436),
    [aux_sym_declare_statement_token2] = ACTIONS(1436),
    [sym_float] = ACTIONS(1436),
    [aux_sym_try_statement_token1] = ACTIONS(1436),
    [aux_sym_goto_statement_token1] = ACTIONS(1436),
    [aux_sym_continue_statement_token1] = ACTIONS(1436),
    [aux_sym_break_statement_token1] = ACTIONS(1436),
    [sym_integer] = ACTIONS(1436),
    [aux_sym_return_statement_token1] = ACTIONS(1436),
    [aux_sym_throw_expression_token1] = ACTIONS(1436),
    [aux_sym_while_statement_token1] = ACTIONS(1436),
    [aux_sym_while_statement_token2] = ACTIONS(1436),
    [aux_sym_do_statement_token1] = ACTIONS(1436),
    [aux_sym_for_statement_token1] = ACTIONS(1436),
    [aux_sym_for_statement_token2] = ACTIONS(1436),
    [aux_sym_foreach_statement_token1] = ACTIONS(1436),
    [aux_sym_foreach_statement_token2] = ACTIONS(1436),
    [aux_sym_if_statement_token1] = ACTIONS(1436),
    [aux_sym_if_statement_token2] = ACTIONS(1436),
    [aux_sym_else_if_clause_token1] = ACTIONS(1436),
    [aux_sym_else_clause_token1] = ACTIONS(1436),
    [aux_sym_match_expression_token1] = ACTIONS(1436),
    [aux_sym_match_default_expression_token1] = ACTIONS(1436),
    [aux_sym_switch_statement_token1] = ACTIONS(1436),
    [aux_sym_switch_block_token1] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1436),
    [anon_sym_TILDE] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(1434),
    [aux_sym_clone_expression_token1] = ACTIONS(1436),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1436),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1434),
    [anon_sym_PLUS_PLUS] = ACTIONS(1434),
    [aux_sym__list_destructing_token1] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_self] = ACTIONS(1436),
    [anon_sym_parent] = ACTIONS(1436),
    [aux_sym__argument_name_token1] = ACTIONS(1436),
    [aux_sym__argument_name_token2] = ACTIONS(1436),
    [anon_sym_POUND_LBRACK] = ACTIONS(1434),
    [anon_sym_SQUOTE] = ACTIONS(1434),
    [aux_sym_encapsed_string_token1] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [aux_sym_string_token1] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [aux_sym_yield_expression_token1] = ACTIONS(1436),
    [aux_sym_include_expression_token1] = ACTIONS(1436),
    [aux_sym_include_once_expression_token1] = ACTIONS(1436),
    [aux_sym_require_expression_token1] = ACTIONS(1436),
    [aux_sym_require_once_expression_token1] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
  },
  [535] = {
    [ts_builtin_sym_end] = ACTIONS(1438),
    [sym_name] = ACTIONS(1440),
    [anon_sym_QMARK_GT] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1438),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1440),
    [aux_sym_global_declaration_token1] = ACTIONS(1440),
    [aux_sym_namespace_definition_token1] = ACTIONS(1440),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1440),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1440),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1440),
    [anon_sym_BSLASH] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1438),
    [anon_sym_RBRACE] = ACTIONS(1438),
    [aux_sym_trait_declaration_token1] = ACTIONS(1440),
    [aux_sym_interface_declaration_token1] = ACTIONS(1440),
    [aux_sym_enum_declaration_token1] = ACTIONS(1440),
    [aux_sym_enum_case_token1] = ACTIONS(1440),
    [aux_sym_class_declaration_token1] = ACTIONS(1440),
    [aux_sym_final_modifier_token1] = ACTIONS(1440),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1440),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1440),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1440),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1440),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1440),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1440),
    [anon_sym_LPAREN] = ACTIONS(1438),
    [aux_sym_cast_type_token1] = ACTIONS(1440),
    [aux_sym_echo_statement_token1] = ACTIONS(1440),
    [anon_sym_unset] = ACTIONS(1440),
    [aux_sym_declare_statement_token1] = ACTIONS(1440),
    [aux_sym_declare_statement_token2] = ACTIONS(1440),
    [sym_float] = ACTIONS(1440),
    [aux_sym_try_statement_token1] = ACTIONS(1440),
    [aux_sym_goto_statement_token1] = ACTIONS(1440),
    [aux_sym_continue_statement_token1] = ACTIONS(1440),
    [aux_sym_break_statement_token1] = ACTIONS(1440),
    [sym_integer] = ACTIONS(1440),
    [aux_sym_return_statement_token1] = ACTIONS(1440),
    [aux_sym_throw_expression_token1] = ACTIONS(1440),
    [aux_sym_while_statement_token1] = ACTIONS(1440),
    [aux_sym_while_statement_token2] = ACTIONS(1440),
    [aux_sym_do_statement_token1] = ACTIONS(1440),
    [aux_sym_for_statement_token1] = ACTIONS(1440),
    [aux_sym_for_statement_token2] = ACTIONS(1440),
    [aux_sym_foreach_statement_token1] = ACTIONS(1440),
    [aux_sym_foreach_statement_token2] = ACTIONS(1440),
    [aux_sym_if_statement_token1] = ACTIONS(1440),
    [aux_sym_if_statement_token2] = ACTIONS(1440),
    [aux_sym_else_if_clause_token1] = ACTIONS(1440),
    [aux_sym_else_clause_token1] = ACTIONS(1440),
    [aux_sym_match_expression_token1] = ACTIONS(1440),
    [aux_sym_match_default_expression_token1] = ACTIONS(1440),
    [aux_sym_switch_statement_token1] = ACTIONS(1440),
    [aux_sym_switch_block_token1] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1438),
    [anon_sym_BANG] = ACTIONS(1438),
    [anon_sym_AT] = ACTIONS(1438),
    [aux_sym_clone_expression_token1] = ACTIONS(1440),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1440),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1440),
    [anon_sym_DASH_DASH] = ACTIONS(1438),
    [anon_sym_PLUS_PLUS] = ACTIONS(1438),
    [aux_sym__list_destructing_token1] = ACTIONS(1440),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_self] = ACTIONS(1440),
    [anon_sym_parent] = ACTIONS(1440),
    [aux_sym__argument_name_token1] = ACTIONS(1440),
    [aux_sym__argument_name_token2] = ACTIONS(1440),
    [anon_sym_POUND_LBRACK] = ACTIONS(1438),
    [anon_sym_SQUOTE] = ACTIONS(1438),
    [aux_sym_encapsed_string_token1] = ACTIONS(1438),
    [anon_sym_DQUOTE] = ACTIONS(1438),
    [aux_sym_string_token1] = ACTIONS(1438),
    [anon_sym_LT_LT_LT] = ACTIONS(1438),
    [anon_sym_BQUOTE] = ACTIONS(1438),
    [anon_sym_DOLLAR] = ACTIONS(1438),
    [aux_sym_yield_expression_token1] = ACTIONS(1440),
    [aux_sym_include_expression_token1] = ACTIONS(1440),
    [aux_sym_include_once_expression_token1] = ACTIONS(1440),
    [aux_sym_require_expression_token1] = ACTIONS(1440),
    [aux_sym_require_once_expression_token1] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
  },
  [536] = {
    [ts_builtin_sym_end] = ACTIONS(1442),
    [sym_name] = ACTIONS(1444),
    [anon_sym_QMARK_GT] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1444),
    [aux_sym_global_declaration_token1] = ACTIONS(1444),
    [aux_sym_namespace_definition_token1] = ACTIONS(1444),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1444),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1444),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1444),
    [anon_sym_BSLASH] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [aux_sym_trait_declaration_token1] = ACTIONS(1444),
    [aux_sym_interface_declaration_token1] = ACTIONS(1444),
    [aux_sym_enum_declaration_token1] = ACTIONS(1444),
    [aux_sym_enum_case_token1] = ACTIONS(1444),
    [aux_sym_class_declaration_token1] = ACTIONS(1444),
    [aux_sym_final_modifier_token1] = ACTIONS(1444),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1444),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1444),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1444),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1444),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1444),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1444),
    [anon_sym_LPAREN] = ACTIONS(1442),
    [aux_sym_cast_type_token1] = ACTIONS(1444),
    [aux_sym_echo_statement_token1] = ACTIONS(1444),
    [anon_sym_unset] = ACTIONS(1444),
    [aux_sym_declare_statement_token1] = ACTIONS(1444),
    [aux_sym_declare_statement_token2] = ACTIONS(1444),
    [sym_float] = ACTIONS(1444),
    [aux_sym_try_statement_token1] = ACTIONS(1444),
    [aux_sym_goto_statement_token1] = ACTIONS(1444),
    [aux_sym_continue_statement_token1] = ACTIONS(1444),
    [aux_sym_break_statement_token1] = ACTIONS(1444),
    [sym_integer] = ACTIONS(1444),
    [aux_sym_return_statement_token1] = ACTIONS(1444),
    [aux_sym_throw_expression_token1] = ACTIONS(1444),
    [aux_sym_while_statement_token1] = ACTIONS(1444),
    [aux_sym_while_statement_token2] = ACTIONS(1444),
    [aux_sym_do_statement_token1] = ACTIONS(1444),
    [aux_sym_for_statement_token1] = ACTIONS(1444),
    [aux_sym_for_statement_token2] = ACTIONS(1444),
    [aux_sym_foreach_statement_token1] = ACTIONS(1444),
    [aux_sym_foreach_statement_token2] = ACTIONS(1444),
    [aux_sym_if_statement_token1] = ACTIONS(1444),
    [aux_sym_if_statement_token2] = ACTIONS(1444),
    [aux_sym_else_if_clause_token1] = ACTIONS(1444),
    [aux_sym_else_clause_token1] = ACTIONS(1444),
    [aux_sym_match_expression_token1] = ACTIONS(1444),
    [aux_sym_match_default_expression_token1] = ACTIONS(1444),
    [aux_sym_switch_statement_token1] = ACTIONS(1444),
    [aux_sym_switch_block_token1] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_TILDE] = ACTIONS(1442),
    [anon_sym_BANG] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(1442),
    [aux_sym_clone_expression_token1] = ACTIONS(1444),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1444),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1444),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [aux_sym__list_destructing_token1] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_self] = ACTIONS(1444),
    [anon_sym_parent] = ACTIONS(1444),
    [aux_sym__argument_name_token1] = ACTIONS(1444),
    [aux_sym__argument_name_token2] = ACTIONS(1444),
    [anon_sym_POUND_LBRACK] = ACTIONS(1442),
    [anon_sym_SQUOTE] = ACTIONS(1442),
    [aux_sym_encapsed_string_token1] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(1442),
    [aux_sym_string_token1] = ACTIONS(1442),
    [anon_sym_LT_LT_LT] = ACTIONS(1442),
    [anon_sym_BQUOTE] = ACTIONS(1442),
    [anon_sym_DOLLAR] = ACTIONS(1442),
    [aux_sym_yield_expression_token1] = ACTIONS(1444),
    [aux_sym_include_expression_token1] = ACTIONS(1444),
    [aux_sym_include_once_expression_token1] = ACTIONS(1444),
    [aux_sym_require_expression_token1] = ACTIONS(1444),
    [aux_sym_require_once_expression_token1] = ACTIONS(1444),
    [sym_comment] = ACTIONS(3),
  },
  [537] = {
    [ts_builtin_sym_end] = ACTIONS(1446),
    [sym_name] = ACTIONS(1448),
    [anon_sym_QMARK_GT] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1446),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1448),
    [aux_sym_global_declaration_token1] = ACTIONS(1448),
    [aux_sym_namespace_definition_token1] = ACTIONS(1448),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1448),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1448),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1448),
    [anon_sym_BSLASH] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [aux_sym_trait_declaration_token1] = ACTIONS(1448),
    [aux_sym_interface_declaration_token1] = ACTIONS(1448),
    [aux_sym_enum_declaration_token1] = ACTIONS(1448),
    [aux_sym_enum_case_token1] = ACTIONS(1448),
    [aux_sym_class_declaration_token1] = ACTIONS(1448),
    [aux_sym_final_modifier_token1] = ACTIONS(1448),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1448),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1448),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1448),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1448),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1448),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [aux_sym_cast_type_token1] = ACTIONS(1448),
    [aux_sym_echo_statement_token1] = ACTIONS(1448),
    [anon_sym_unset] = ACTIONS(1448),
    [aux_sym_declare_statement_token1] = ACTIONS(1448),
    [aux_sym_declare_statement_token2] = ACTIONS(1448),
    [sym_float] = ACTIONS(1448),
    [aux_sym_try_statement_token1] = ACTIONS(1448),
    [aux_sym_goto_statement_token1] = ACTIONS(1448),
    [aux_sym_continue_statement_token1] = ACTIONS(1448),
    [aux_sym_break_statement_token1] = ACTIONS(1448),
    [sym_integer] = ACTIONS(1448),
    [aux_sym_return_statement_token1] = ACTIONS(1448),
    [aux_sym_throw_expression_token1] = ACTIONS(1448),
    [aux_sym_while_statement_token1] = ACTIONS(1448),
    [aux_sym_while_statement_token2] = ACTIONS(1448),
    [aux_sym_do_statement_token1] = ACTIONS(1448),
    [aux_sym_for_statement_token1] = ACTIONS(1448),
    [aux_sym_for_statement_token2] = ACTIONS(1448),
    [aux_sym_foreach_statement_token1] = ACTIONS(1448),
    [aux_sym_foreach_statement_token2] = ACTIONS(1448),
    [aux_sym_if_statement_token1] = ACTIONS(1448),
    [aux_sym_if_statement_token2] = ACTIONS(1448),
    [aux_sym_else_if_clause_token1] = ACTIONS(1448),
    [aux_sym_else_clause_token1] = ACTIONS(1448),
    [aux_sym_match_expression_token1] = ACTIONS(1448),
    [aux_sym_match_default_expression_token1] = ACTIONS(1448),
    [aux_sym_switch_statement_token1] = ACTIONS(1448),
    [aux_sym_switch_block_token1] = ACTIONS(1448),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1446),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_AT] = ACTIONS(1446),
    [aux_sym_clone_expression_token1] = ACTIONS(1448),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1448),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1448),
    [anon_sym_DASH_DASH] = ACTIONS(1446),
    [anon_sym_PLUS_PLUS] = ACTIONS(1446),
    [aux_sym__list_destructing_token1] = ACTIONS(1448),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_self] = ACTIONS(1448),
    [anon_sym_parent] = ACTIONS(1448),
    [aux_sym__argument_name_token1] = ACTIONS(1448),
    [aux_sym__argument_name_token2] = ACTIONS(1448),
    [anon_sym_POUND_LBRACK] = ACTIONS(1446),
    [anon_sym_SQUOTE] = ACTIONS(1446),
    [aux_sym_encapsed_string_token1] = ACTIONS(1446),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [aux_sym_string_token1] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [aux_sym_yield_expression_token1] = ACTIONS(1448),
    [aux_sym_include_expression_token1] = ACTIONS(1448),
    [aux_sym_include_once_expression_token1] = ACTIONS(1448),
    [aux_sym_require_expression_token1] = ACTIONS(1448),
    [aux_sym_require_once_expression_token1] = ACTIONS(1448),
    [sym_comment] = ACTIONS(3),
  },
  [538] = {
    [ts_builtin_sym_end] = ACTIONS(1450),
    [sym_name] = ACTIONS(1452),
    [anon_sym_QMARK_GT] = ACTIONS(1450),
    [anon_sym_SEMI] = ACTIONS(1450),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1452),
    [aux_sym_global_declaration_token1] = ACTIONS(1452),
    [aux_sym_namespace_definition_token1] = ACTIONS(1452),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1452),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1452),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1452),
    [anon_sym_BSLASH] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1450),
    [anon_sym_RBRACE] = ACTIONS(1450),
    [aux_sym_trait_declaration_token1] = ACTIONS(1452),
    [aux_sym_interface_declaration_token1] = ACTIONS(1452),
    [aux_sym_enum_declaration_token1] = ACTIONS(1452),
    [aux_sym_enum_case_token1] = ACTIONS(1452),
    [aux_sym_class_declaration_token1] = ACTIONS(1452),
    [aux_sym_final_modifier_token1] = ACTIONS(1452),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1452),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1452),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1452),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1452),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1452),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [aux_sym_cast_type_token1] = ACTIONS(1452),
    [aux_sym_echo_statement_token1] = ACTIONS(1452),
    [anon_sym_unset] = ACTIONS(1452),
    [aux_sym_declare_statement_token1] = ACTIONS(1452),
    [aux_sym_declare_statement_token2] = ACTIONS(1452),
    [sym_float] = ACTIONS(1452),
    [aux_sym_try_statement_token1] = ACTIONS(1452),
    [aux_sym_goto_statement_token1] = ACTIONS(1452),
    [aux_sym_continue_statement_token1] = ACTIONS(1452),
    [aux_sym_break_statement_token1] = ACTIONS(1452),
    [sym_integer] = ACTIONS(1452),
    [aux_sym_return_statement_token1] = ACTIONS(1452),
    [aux_sym_throw_expression_token1] = ACTIONS(1452),
    [aux_sym_while_statement_token1] = ACTIONS(1452),
    [aux_sym_while_statement_token2] = ACTIONS(1452),
    [aux_sym_do_statement_token1] = ACTIONS(1452),
    [aux_sym_for_statement_token1] = ACTIONS(1452),
    [aux_sym_for_statement_token2] = ACTIONS(1452),
    [aux_sym_foreach_statement_token1] = ACTIONS(1452),
    [aux_sym_foreach_statement_token2] = ACTIONS(1452),
    [aux_sym_if_statement_token1] = ACTIONS(1452),
    [aux_sym_if_statement_token2] = ACTIONS(1452),
    [aux_sym_else_if_clause_token1] = ACTIONS(1452),
    [aux_sym_else_clause_token1] = ACTIONS(1452),
    [aux_sym_match_expression_token1] = ACTIONS(1452),
    [aux_sym_match_default_expression_token1] = ACTIONS(1452),
    [aux_sym_switch_statement_token1] = ACTIONS(1452),
    [aux_sym_switch_block_token1] = ACTIONS(1452),
    [anon_sym_PLUS] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1450),
    [anon_sym_BANG] = ACTIONS(1450),
    [anon_sym_AT] = ACTIONS(1450),
    [aux_sym_clone_expression_token1] = ACTIONS(1452),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1452),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1452),
    [anon_sym_DASH_DASH] = ACTIONS(1450),
    [anon_sym_PLUS_PLUS] = ACTIONS(1450),
    [aux_sym__list_destructing_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_self] = ACTIONS(1452),
    [anon_sym_parent] = ACTIONS(1452),
    [aux_sym__argument_name_token1] = ACTIONS(1452),
    [aux_sym__argument_name_token2] = ACTIONS(1452),
    [anon_sym_POUND_LBRACK] = ACTIONS(1450),
    [anon_sym_SQUOTE] = ACTIONS(1450),
    [aux_sym_encapsed_string_token1] = ACTIONS(1450),
    [anon_sym_DQUOTE] = ACTIONS(1450),
    [aux_sym_string_token1] = ACTIONS(1450),
    [anon_sym_LT_LT_LT] = ACTIONS(1450),
    [anon_sym_BQUOTE] = ACTIONS(1450),
    [anon_sym_DOLLAR] = ACTIONS(1450),
    [aux_sym_yield_expression_token1] = ACTIONS(1452),
    [aux_sym_include_expression_token1] = ACTIONS(1452),
    [aux_sym_include_once_expression_token1] = ACTIONS(1452),
    [aux_sym_require_expression_token1] = ACTIONS(1452),
    [aux_sym_require_once_expression_token1] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(1454),
    [sym_name] = ACTIONS(1456),
    [anon_sym_QMARK_GT] = ACTIONS(1454),
    [anon_sym_SEMI] = ACTIONS(1454),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1456),
    [aux_sym_global_declaration_token1] = ACTIONS(1456),
    [aux_sym_namespace_definition_token1] = ACTIONS(1456),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1456),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1456),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1456),
    [anon_sym_BSLASH] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1454),
    [anon_sym_RBRACE] = ACTIONS(1454),
    [aux_sym_trait_declaration_token1] = ACTIONS(1456),
    [aux_sym_interface_declaration_token1] = ACTIONS(1456),
    [aux_sym_enum_declaration_token1] = ACTIONS(1456),
    [aux_sym_enum_case_token1] = ACTIONS(1456),
    [aux_sym_class_declaration_token1] = ACTIONS(1456),
    [aux_sym_final_modifier_token1] = ACTIONS(1456),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1456),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1456),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1456),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1456),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1456),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1454),
    [aux_sym_cast_type_token1] = ACTIONS(1456),
    [aux_sym_echo_statement_token1] = ACTIONS(1456),
    [anon_sym_unset] = ACTIONS(1456),
    [aux_sym_declare_statement_token1] = ACTIONS(1456),
    [aux_sym_declare_statement_token2] = ACTIONS(1456),
    [sym_float] = ACTIONS(1456),
    [aux_sym_try_statement_token1] = ACTIONS(1456),
    [aux_sym_goto_statement_token1] = ACTIONS(1456),
    [aux_sym_continue_statement_token1] = ACTIONS(1456),
    [aux_sym_break_statement_token1] = ACTIONS(1456),
    [sym_integer] = ACTIONS(1456),
    [aux_sym_return_statement_token1] = ACTIONS(1456),
    [aux_sym_throw_expression_token1] = ACTIONS(1456),
    [aux_sym_while_statement_token1] = ACTIONS(1456),
    [aux_sym_while_statement_token2] = ACTIONS(1456),
    [aux_sym_do_statement_token1] = ACTIONS(1456),
    [aux_sym_for_statement_token1] = ACTIONS(1456),
    [aux_sym_for_statement_token2] = ACTIONS(1456),
    [aux_sym_foreach_statement_token1] = ACTIONS(1456),
    [aux_sym_foreach_statement_token2] = ACTIONS(1456),
    [aux_sym_if_statement_token1] = ACTIONS(1456),
    [aux_sym_if_statement_token2] = ACTIONS(1456),
    [aux_sym_else_if_clause_token1] = ACTIONS(1456),
    [aux_sym_else_clause_token1] = ACTIONS(1456),
    [aux_sym_match_expression_token1] = ACTIONS(1456),
    [aux_sym_match_default_expression_token1] = ACTIONS(1456),
    [aux_sym_switch_statement_token1] = ACTIONS(1456),
    [aux_sym_switch_block_token1] = ACTIONS(1456),
    [anon_sym_PLUS] = ACTIONS(1456),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1454),
    [anon_sym_BANG] = ACTIONS(1454),
    [anon_sym_AT] = ACTIONS(1454),
    [aux_sym_clone_expression_token1] = ACTIONS(1456),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1456),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1456),
    [anon_sym_DASH_DASH] = ACTIONS(1454),
    [anon_sym_PLUS_PLUS] = ACTIONS(1454),
    [aux_sym__list_destructing_token1] = ACTIONS(1456),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_self] = ACTIONS(1456),
    [anon_sym_parent] = ACTIONS(1456),
    [aux_sym__argument_name_token1] = ACTIONS(1456),
    [aux_sym__argument_name_token2] = ACTIONS(1456),
    [anon_sym_POUND_LBRACK] = ACTIONS(1454),
    [anon_sym_SQUOTE] = ACTIONS(1454),
    [aux_sym_encapsed_string_token1] = ACTIONS(1454),
    [anon_sym_DQUOTE] = ACTIONS(1454),
    [aux_sym_string_token1] = ACTIONS(1454),
    [anon_sym_LT_LT_LT] = ACTIONS(1454),
    [anon_sym_BQUOTE] = ACTIONS(1454),
    [anon_sym_DOLLAR] = ACTIONS(1454),
    [aux_sym_yield_expression_token1] = ACTIONS(1456),
    [aux_sym_include_expression_token1] = ACTIONS(1456),
    [aux_sym_include_once_expression_token1] = ACTIONS(1456),
    [aux_sym_require_expression_token1] = ACTIONS(1456),
    [aux_sym_require_once_expression_token1] = ACTIONS(1456),
    [sym_comment] = ACTIONS(3),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(1458),
    [sym_name] = ACTIONS(1460),
    [anon_sym_QMARK_GT] = ACTIONS(1458),
    [anon_sym_SEMI] = ACTIONS(1458),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1460),
    [aux_sym_global_declaration_token1] = ACTIONS(1460),
    [aux_sym_namespace_definition_token1] = ACTIONS(1460),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1460),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1460),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1460),
    [anon_sym_BSLASH] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_RBRACE] = ACTIONS(1458),
    [aux_sym_trait_declaration_token1] = ACTIONS(1460),
    [aux_sym_interface_declaration_token1] = ACTIONS(1460),
    [aux_sym_enum_declaration_token1] = ACTIONS(1460),
    [aux_sym_enum_case_token1] = ACTIONS(1460),
    [aux_sym_class_declaration_token1] = ACTIONS(1460),
    [aux_sym_final_modifier_token1] = ACTIONS(1460),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1460),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1460),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1460),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1460),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1460),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1460),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [aux_sym_cast_type_token1] = ACTIONS(1460),
    [aux_sym_echo_statement_token1] = ACTIONS(1460),
    [anon_sym_unset] = ACTIONS(1460),
    [aux_sym_declare_statement_token1] = ACTIONS(1460),
    [aux_sym_declare_statement_token2] = ACTIONS(1460),
    [sym_float] = ACTIONS(1460),
    [aux_sym_try_statement_token1] = ACTIONS(1460),
    [aux_sym_goto_statement_token1] = ACTIONS(1460),
    [aux_sym_continue_statement_token1] = ACTIONS(1460),
    [aux_sym_break_statement_token1] = ACTIONS(1460),
    [sym_integer] = ACTIONS(1460),
    [aux_sym_return_statement_token1] = ACTIONS(1460),
    [aux_sym_throw_expression_token1] = ACTIONS(1460),
    [aux_sym_while_statement_token1] = ACTIONS(1460),
    [aux_sym_while_statement_token2] = ACTIONS(1460),
    [aux_sym_do_statement_token1] = ACTIONS(1460),
    [aux_sym_for_statement_token1] = ACTIONS(1460),
    [aux_sym_for_statement_token2] = ACTIONS(1460),
    [aux_sym_foreach_statement_token1] = ACTIONS(1460),
    [aux_sym_foreach_statement_token2] = ACTIONS(1460),
    [aux_sym_if_statement_token1] = ACTIONS(1460),
    [aux_sym_if_statement_token2] = ACTIONS(1460),
    [aux_sym_else_if_clause_token1] = ACTIONS(1460),
    [aux_sym_else_clause_token1] = ACTIONS(1460),
    [aux_sym_match_expression_token1] = ACTIONS(1460),
    [aux_sym_match_default_expression_token1] = ACTIONS(1460),
    [aux_sym_switch_statement_token1] = ACTIONS(1460),
    [aux_sym_switch_block_token1] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_TILDE] = ACTIONS(1458),
    [anon_sym_BANG] = ACTIONS(1458),
    [anon_sym_AT] = ACTIONS(1458),
    [aux_sym_clone_expression_token1] = ACTIONS(1460),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1460),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1458),
    [anon_sym_PLUS_PLUS] = ACTIONS(1458),
    [aux_sym__list_destructing_token1] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [anon_sym_self] = ACTIONS(1460),
    [anon_sym_parent] = ACTIONS(1460),
    [aux_sym__argument_name_token1] = ACTIONS(1460),
    [aux_sym__argument_name_token2] = ACTIONS(1460),
    [anon_sym_POUND_LBRACK] = ACTIONS(1458),
    [anon_sym_SQUOTE] = ACTIONS(1458),
    [aux_sym_encapsed_string_token1] = ACTIONS(1458),
    [anon_sym_DQUOTE] = ACTIONS(1458),
    [aux_sym_string_token1] = ACTIONS(1458),
    [anon_sym_LT_LT_LT] = ACTIONS(1458),
    [anon_sym_BQUOTE] = ACTIONS(1458),
    [anon_sym_DOLLAR] = ACTIONS(1458),
    [aux_sym_yield_expression_token1] = ACTIONS(1460),
    [aux_sym_include_expression_token1] = ACTIONS(1460),
    [aux_sym_include_once_expression_token1] = ACTIONS(1460),
    [aux_sym_require_expression_token1] = ACTIONS(1460),
    [aux_sym_require_once_expression_token1] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
  },
  [541] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_name] = ACTIONS(1464),
    [anon_sym_QMARK_GT] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1464),
    [aux_sym_global_declaration_token1] = ACTIONS(1464),
    [aux_sym_namespace_definition_token1] = ACTIONS(1464),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1464),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1464),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1464),
    [anon_sym_BSLASH] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [aux_sym_trait_declaration_token1] = ACTIONS(1464),
    [aux_sym_interface_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_case_token1] = ACTIONS(1464),
    [aux_sym_class_declaration_token1] = ACTIONS(1464),
    [aux_sym_final_modifier_token1] = ACTIONS(1464),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1464),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1464),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1464),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1464),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1464),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1464),
    [anon_sym_LPAREN] = ACTIONS(1462),
    [aux_sym_cast_type_token1] = ACTIONS(1464),
    [aux_sym_echo_statement_token1] = ACTIONS(1464),
    [anon_sym_unset] = ACTIONS(1464),
    [aux_sym_declare_statement_token1] = ACTIONS(1464),
    [aux_sym_declare_statement_token2] = ACTIONS(1464),
    [sym_float] = ACTIONS(1464),
    [aux_sym_try_statement_token1] = ACTIONS(1464),
    [aux_sym_goto_statement_token1] = ACTIONS(1464),
    [aux_sym_continue_statement_token1] = ACTIONS(1464),
    [aux_sym_break_statement_token1] = ACTIONS(1464),
    [sym_integer] = ACTIONS(1464),
    [aux_sym_return_statement_token1] = ACTIONS(1464),
    [aux_sym_throw_expression_token1] = ACTIONS(1464),
    [aux_sym_while_statement_token1] = ACTIONS(1464),
    [aux_sym_while_statement_token2] = ACTIONS(1464),
    [aux_sym_do_statement_token1] = ACTIONS(1464),
    [aux_sym_for_statement_token1] = ACTIONS(1464),
    [aux_sym_for_statement_token2] = ACTIONS(1464),
    [aux_sym_foreach_statement_token1] = ACTIONS(1464),
    [aux_sym_foreach_statement_token2] = ACTIONS(1464),
    [aux_sym_if_statement_token1] = ACTIONS(1464),
    [aux_sym_if_statement_token2] = ACTIONS(1464),
    [aux_sym_else_if_clause_token1] = ACTIONS(1464),
    [aux_sym_else_clause_token1] = ACTIONS(1464),
    [aux_sym_match_expression_token1] = ACTIONS(1464),
    [aux_sym_match_default_expression_token1] = ACTIONS(1464),
    [aux_sym_switch_statement_token1] = ACTIONS(1464),
    [aux_sym_switch_block_token1] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1464),
    [anon_sym_DASH] = ACTIONS(1464),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(1462),
    [aux_sym_clone_expression_token1] = ACTIONS(1464),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1464),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1464),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [aux_sym__list_destructing_token1] = ACTIONS(1464),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_self] = ACTIONS(1464),
    [anon_sym_parent] = ACTIONS(1464),
    [aux_sym__argument_name_token1] = ACTIONS(1464),
    [aux_sym__argument_name_token2] = ACTIONS(1464),
    [anon_sym_POUND_LBRACK] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [aux_sym_encapsed_string_token1] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [aux_sym_string_token1] = ACTIONS(1462),
    [anon_sym_LT_LT_LT] = ACTIONS(1462),
    [anon_sym_BQUOTE] = ACTIONS(1462),
    [anon_sym_DOLLAR] = ACTIONS(1462),
    [aux_sym_yield_expression_token1] = ACTIONS(1464),
    [aux_sym_include_expression_token1] = ACTIONS(1464),
    [aux_sym_include_once_expression_token1] = ACTIONS(1464),
    [aux_sym_require_expression_token1] = ACTIONS(1464),
    [aux_sym_require_once_expression_token1] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
  },
  [542] = {
    [ts_builtin_sym_end] = ACTIONS(1022),
    [sym_name] = ACTIONS(1024),
    [anon_sym_QMARK_GT] = ACTIONS(1022),
    [anon_sym_SEMI] = ACTIONS(1022),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1024),
    [aux_sym_global_declaration_token1] = ACTIONS(1024),
    [aux_sym_namespace_definition_token1] = ACTIONS(1024),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1024),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1024),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1024),
    [anon_sym_BSLASH] = ACTIONS(1022),
    [anon_sym_LBRACE] = ACTIONS(1022),
    [anon_sym_RBRACE] = ACTIONS(1022),
    [aux_sym_trait_declaration_token1] = ACTIONS(1024),
    [aux_sym_interface_declaration_token1] = ACTIONS(1024),
    [aux_sym_enum_declaration_token1] = ACTIONS(1024),
    [aux_sym_enum_case_token1] = ACTIONS(1024),
    [aux_sym_class_declaration_token1] = ACTIONS(1024),
    [aux_sym_final_modifier_token1] = ACTIONS(1024),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1024),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1024),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1024),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1024),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1024),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1024),
    [anon_sym_LPAREN] = ACTIONS(1022),
    [aux_sym_cast_type_token1] = ACTIONS(1024),
    [aux_sym_echo_statement_token1] = ACTIONS(1024),
    [anon_sym_unset] = ACTIONS(1024),
    [aux_sym_declare_statement_token1] = ACTIONS(1024),
    [aux_sym_declare_statement_token2] = ACTIONS(1024),
    [sym_float] = ACTIONS(1024),
    [aux_sym_try_statement_token1] = ACTIONS(1024),
    [aux_sym_goto_statement_token1] = ACTIONS(1024),
    [aux_sym_continue_statement_token1] = ACTIONS(1024),
    [aux_sym_break_statement_token1] = ACTIONS(1024),
    [sym_integer] = ACTIONS(1024),
    [aux_sym_return_statement_token1] = ACTIONS(1024),
    [aux_sym_throw_expression_token1] = ACTIONS(1024),
    [aux_sym_while_statement_token1] = ACTIONS(1024),
    [aux_sym_while_statement_token2] = ACTIONS(1024),
    [aux_sym_do_statement_token1] = ACTIONS(1024),
    [aux_sym_for_statement_token1] = ACTIONS(1024),
    [aux_sym_for_statement_token2] = ACTIONS(1024),
    [aux_sym_foreach_statement_token1] = ACTIONS(1024),
    [aux_sym_foreach_statement_token2] = ACTIONS(1024),
    [aux_sym_if_statement_token1] = ACTIONS(1024),
    [aux_sym_if_statement_token2] = ACTIONS(1024),
    [aux_sym_else_if_clause_token1] = ACTIONS(1024),
    [aux_sym_else_clause_token1] = ACTIONS(1024),
    [aux_sym_match_expression_token1] = ACTIONS(1024),
    [aux_sym_match_default_expression_token1] = ACTIONS(1024),
    [aux_sym_switch_statement_token1] = ACTIONS(1024),
    [aux_sym_switch_block_token1] = ACTIONS(1024),
    [anon_sym_PLUS] = ACTIONS(1024),
    [anon_sym_DASH] = ACTIONS(1024),
    [anon_sym_TILDE] = ACTIONS(1022),
    [anon_sym_BANG] = ACTIONS(1022),
    [anon_sym_AT] = ACTIONS(1022),
    [aux_sym_clone_expression_token1] = ACTIONS(1024),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1024),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1024),
    [anon_sym_DASH_DASH] = ACTIONS(1022),
    [anon_sym_PLUS_PLUS] = ACTIONS(1022),
    [aux_sym__list_destructing_token1] = ACTIONS(1024),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [anon_sym_self] = ACTIONS(1024),
    [anon_sym_parent] = ACTIONS(1024),
    [aux_sym__argument_name_token1] = ACTIONS(1024),
    [aux_sym__argument_name_token2] = ACTIONS(1024),
    [anon_sym_POUND_LBRACK] = ACTIONS(1022),
    [anon_sym_SQUOTE] = ACTIONS(1022),
    [aux_sym_encapsed_string_token1] = ACTIONS(1022),
    [anon_sym_DQUOTE] = ACTIONS(1022),
    [aux_sym_string_token1] = ACTIONS(1022),
    [anon_sym_LT_LT_LT] = ACTIONS(1022),
    [anon_sym_BQUOTE] = ACTIONS(1022),
    [anon_sym_DOLLAR] = ACTIONS(1022),
    [aux_sym_yield_expression_token1] = ACTIONS(1024),
    [aux_sym_include_expression_token1] = ACTIONS(1024),
    [aux_sym_include_once_expression_token1] = ACTIONS(1024),
    [aux_sym_require_expression_token1] = ACTIONS(1024),
    [aux_sym_require_once_expression_token1] = ACTIONS(1024),
    [sym_comment] = ACTIONS(3),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(1466),
    [sym_name] = ACTIONS(1468),
    [anon_sym_QMARK_GT] = ACTIONS(1466),
    [anon_sym_SEMI] = ACTIONS(1466),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1468),
    [aux_sym_global_declaration_token1] = ACTIONS(1468),
    [aux_sym_namespace_definition_token1] = ACTIONS(1468),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1468),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1468),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1468),
    [anon_sym_BSLASH] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(1466),
    [anon_sym_RBRACE] = ACTIONS(1466),
    [aux_sym_trait_declaration_token1] = ACTIONS(1468),
    [aux_sym_interface_declaration_token1] = ACTIONS(1468),
    [aux_sym_enum_declaration_token1] = ACTIONS(1468),
    [aux_sym_enum_case_token1] = ACTIONS(1468),
    [aux_sym_class_declaration_token1] = ACTIONS(1468),
    [aux_sym_final_modifier_token1] = ACTIONS(1468),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1468),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1468),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1468),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1468),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1468),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1468),
    [anon_sym_LPAREN] = ACTIONS(1466),
    [aux_sym_cast_type_token1] = ACTIONS(1468),
    [aux_sym_echo_statement_token1] = ACTIONS(1468),
    [anon_sym_unset] = ACTIONS(1468),
    [aux_sym_declare_statement_token1] = ACTIONS(1468),
    [aux_sym_declare_statement_token2] = ACTIONS(1468),
    [sym_float] = ACTIONS(1468),
    [aux_sym_try_statement_token1] = ACTIONS(1468),
    [aux_sym_goto_statement_token1] = ACTIONS(1468),
    [aux_sym_continue_statement_token1] = ACTIONS(1468),
    [aux_sym_break_statement_token1] = ACTIONS(1468),
    [sym_integer] = ACTIONS(1468),
    [aux_sym_return_statement_token1] = ACTIONS(1468),
    [aux_sym_throw_expression_token1] = ACTIONS(1468),
    [aux_sym_while_statement_token1] = ACTIONS(1468),
    [aux_sym_while_statement_token2] = ACTIONS(1468),
    [aux_sym_do_statement_token1] = ACTIONS(1468),
    [aux_sym_for_statement_token1] = ACTIONS(1468),
    [aux_sym_for_statement_token2] = ACTIONS(1468),
    [aux_sym_foreach_statement_token1] = ACTIONS(1468),
    [aux_sym_foreach_statement_token2] = ACTIONS(1468),
    [aux_sym_if_statement_token1] = ACTIONS(1468),
    [aux_sym_if_statement_token2] = ACTIONS(1468),
    [aux_sym_else_if_clause_token1] = ACTIONS(1468),
    [aux_sym_else_clause_token1] = ACTIONS(1468),
    [aux_sym_match_expression_token1] = ACTIONS(1468),
    [aux_sym_match_default_expression_token1] = ACTIONS(1468),
    [aux_sym_switch_statement_token1] = ACTIONS(1468),
    [aux_sym_switch_block_token1] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1468),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_TILDE] = ACTIONS(1466),
    [anon_sym_BANG] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1466),
    [aux_sym_clone_expression_token1] = ACTIONS(1468),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1468),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1468),
    [anon_sym_DASH_DASH] = ACTIONS(1466),
    [anon_sym_PLUS_PLUS] = ACTIONS(1466),
    [aux_sym__list_destructing_token1] = ACTIONS(1468),
    [anon_sym_LBRACK] = ACTIONS(1466),
    [anon_sym_self] = ACTIONS(1468),
    [anon_sym_parent] = ACTIONS(1468),
    [aux_sym__argument_name_token1] = ACTIONS(1468),
    [aux_sym__argument_name_token2] = ACTIONS(1468),
    [anon_sym_POUND_LBRACK] = ACTIONS(1466),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [aux_sym_encapsed_string_token1] = ACTIONS(1466),
    [anon_sym_DQUOTE] = ACTIONS(1466),
    [aux_sym_string_token1] = ACTIONS(1466),
    [anon_sym_LT_LT_LT] = ACTIONS(1466),
    [anon_sym_BQUOTE] = ACTIONS(1466),
    [anon_sym_DOLLAR] = ACTIONS(1466),
    [aux_sym_yield_expression_token1] = ACTIONS(1468),
    [aux_sym_include_expression_token1] = ACTIONS(1468),
    [aux_sym_include_once_expression_token1] = ACTIONS(1468),
    [aux_sym_require_expression_token1] = ACTIONS(1468),
    [aux_sym_require_once_expression_token1] = ACTIONS(1468),
    [sym_comment] = ACTIONS(3),
  },
  [544] = {
    [ts_builtin_sym_end] = ACTIONS(1470),
    [sym_name] = ACTIONS(1472),
    [anon_sym_QMARK_GT] = ACTIONS(1470),
    [anon_sym_SEMI] = ACTIONS(1470),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1472),
    [aux_sym_global_declaration_token1] = ACTIONS(1472),
    [aux_sym_namespace_definition_token1] = ACTIONS(1472),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1472),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1472),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1472),
    [anon_sym_BSLASH] = ACTIONS(1470),
    [anon_sym_LBRACE] = ACTIONS(1470),
    [anon_sym_RBRACE] = ACTIONS(1470),
    [aux_sym_trait_declaration_token1] = ACTIONS(1472),
    [aux_sym_interface_declaration_token1] = ACTIONS(1472),
    [aux_sym_enum_declaration_token1] = ACTIONS(1472),
    [aux_sym_enum_case_token1] = ACTIONS(1472),
    [aux_sym_class_declaration_token1] = ACTIONS(1472),
    [aux_sym_final_modifier_token1] = ACTIONS(1472),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1472),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1472),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1472),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1472),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1472),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [aux_sym_cast_type_token1] = ACTIONS(1472),
    [aux_sym_echo_statement_token1] = ACTIONS(1472),
    [anon_sym_unset] = ACTIONS(1472),
    [aux_sym_declare_statement_token1] = ACTIONS(1472),
    [aux_sym_declare_statement_token2] = ACTIONS(1472),
    [sym_float] = ACTIONS(1472),
    [aux_sym_try_statement_token1] = ACTIONS(1472),
    [aux_sym_goto_statement_token1] = ACTIONS(1472),
    [aux_sym_continue_statement_token1] = ACTIONS(1472),
    [aux_sym_break_statement_token1] = ACTIONS(1472),
    [sym_integer] = ACTIONS(1472),
    [aux_sym_return_statement_token1] = ACTIONS(1472),
    [aux_sym_throw_expression_token1] = ACTIONS(1472),
    [aux_sym_while_statement_token1] = ACTIONS(1472),
    [aux_sym_while_statement_token2] = ACTIONS(1472),
    [aux_sym_do_statement_token1] = ACTIONS(1472),
    [aux_sym_for_statement_token1] = ACTIONS(1472),
    [aux_sym_for_statement_token2] = ACTIONS(1472),
    [aux_sym_foreach_statement_token1] = ACTIONS(1472),
    [aux_sym_foreach_statement_token2] = ACTIONS(1472),
    [aux_sym_if_statement_token1] = ACTIONS(1472),
    [aux_sym_if_statement_token2] = ACTIONS(1472),
    [aux_sym_else_if_clause_token1] = ACTIONS(1472),
    [aux_sym_else_clause_token1] = ACTIONS(1472),
    [aux_sym_match_expression_token1] = ACTIONS(1472),
    [aux_sym_match_default_expression_token1] = ACTIONS(1472),
    [aux_sym_switch_statement_token1] = ACTIONS(1472),
    [aux_sym_switch_block_token1] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(1470),
    [aux_sym_clone_expression_token1] = ACTIONS(1472),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1472),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1472),
    [anon_sym_DASH_DASH] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1470),
    [aux_sym__list_destructing_token1] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_self] = ACTIONS(1472),
    [anon_sym_parent] = ACTIONS(1472),
    [aux_sym__argument_name_token1] = ACTIONS(1472),
    [aux_sym__argument_name_token2] = ACTIONS(1472),
    [anon_sym_POUND_LBRACK] = ACTIONS(1470),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [aux_sym_encapsed_string_token1] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [aux_sym_string_token1] = ACTIONS(1470),
    [anon_sym_LT_LT_LT] = ACTIONS(1470),
    [anon_sym_BQUOTE] = ACTIONS(1470),
    [anon_sym_DOLLAR] = ACTIONS(1470),
    [aux_sym_yield_expression_token1] = ACTIONS(1472),
    [aux_sym_include_expression_token1] = ACTIONS(1472),
    [aux_sym_include_once_expression_token1] = ACTIONS(1472),
    [aux_sym_require_expression_token1] = ACTIONS(1472),
    [aux_sym_require_once_expression_token1] = ACTIONS(1472),
    [sym_comment] = ACTIONS(3),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(1474),
    [sym_name] = ACTIONS(1476),
    [anon_sym_QMARK_GT] = ACTIONS(1474),
    [anon_sym_SEMI] = ACTIONS(1474),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1476),
    [aux_sym_global_declaration_token1] = ACTIONS(1476),
    [aux_sym_namespace_definition_token1] = ACTIONS(1476),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1476),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1476),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1476),
    [anon_sym_BSLASH] = ACTIONS(1474),
    [anon_sym_LBRACE] = ACTIONS(1474),
    [anon_sym_RBRACE] = ACTIONS(1474),
    [aux_sym_trait_declaration_token1] = ACTIONS(1476),
    [aux_sym_interface_declaration_token1] = ACTIONS(1476),
    [aux_sym_enum_declaration_token1] = ACTIONS(1476),
    [aux_sym_enum_case_token1] = ACTIONS(1476),
    [aux_sym_class_declaration_token1] = ACTIONS(1476),
    [aux_sym_final_modifier_token1] = ACTIONS(1476),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1476),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1476),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1476),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1476),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1476),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1476),
    [anon_sym_LPAREN] = ACTIONS(1474),
    [aux_sym_cast_type_token1] = ACTIONS(1476),
    [aux_sym_echo_statement_token1] = ACTIONS(1476),
    [anon_sym_unset] = ACTIONS(1476),
    [aux_sym_declare_statement_token1] = ACTIONS(1476),
    [aux_sym_declare_statement_token2] = ACTIONS(1476),
    [sym_float] = ACTIONS(1476),
    [aux_sym_try_statement_token1] = ACTIONS(1476),
    [aux_sym_goto_statement_token1] = ACTIONS(1476),
    [aux_sym_continue_statement_token1] = ACTIONS(1476),
    [aux_sym_break_statement_token1] = ACTIONS(1476),
    [sym_integer] = ACTIONS(1476),
    [aux_sym_return_statement_token1] = ACTIONS(1476),
    [aux_sym_throw_expression_token1] = ACTIONS(1476),
    [aux_sym_while_statement_token1] = ACTIONS(1476),
    [aux_sym_while_statement_token2] = ACTIONS(1476),
    [aux_sym_do_statement_token1] = ACTIONS(1476),
    [aux_sym_for_statement_token1] = ACTIONS(1476),
    [aux_sym_for_statement_token2] = ACTIONS(1476),
    [aux_sym_foreach_statement_token1] = ACTIONS(1476),
    [aux_sym_foreach_statement_token2] = ACTIONS(1476),
    [aux_sym_if_statement_token1] = ACTIONS(1476),
    [aux_sym_if_statement_token2] = ACTIONS(1476),
    [aux_sym_else_if_clause_token1] = ACTIONS(1476),
    [aux_sym_else_clause_token1] = ACTIONS(1476),
    [aux_sym_match_expression_token1] = ACTIONS(1476),
    [aux_sym_match_default_expression_token1] = ACTIONS(1476),
    [aux_sym_switch_statement_token1] = ACTIONS(1476),
    [aux_sym_switch_block_token1] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1476),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1474),
    [anon_sym_AT] = ACTIONS(1474),
    [aux_sym_clone_expression_token1] = ACTIONS(1476),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1476),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1476),
    [anon_sym_DASH_DASH] = ACTIONS(1474),
    [anon_sym_PLUS_PLUS] = ACTIONS(1474),
    [aux_sym__list_destructing_token1] = ACTIONS(1476),
    [anon_sym_LBRACK] = ACTIONS(1474),
    [anon_sym_self] = ACTIONS(1476),
    [anon_sym_parent] = ACTIONS(1476),
    [aux_sym__argument_name_token1] = ACTIONS(1476),
    [aux_sym__argument_name_token2] = ACTIONS(1476),
    [anon_sym_POUND_LBRACK] = ACTIONS(1474),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [aux_sym_encapsed_string_token1] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [aux_sym_string_token1] = ACTIONS(1474),
    [anon_sym_LT_LT_LT] = ACTIONS(1474),
    [anon_sym_BQUOTE] = ACTIONS(1474),
    [anon_sym_DOLLAR] = ACTIONS(1474),
    [aux_sym_yield_expression_token1] = ACTIONS(1476),
    [aux_sym_include_expression_token1] = ACTIONS(1476),
    [aux_sym_include_once_expression_token1] = ACTIONS(1476),
    [aux_sym_require_expression_token1] = ACTIONS(1476),
    [aux_sym_require_once_expression_token1] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
  },
  [546] = {
    [ts_builtin_sym_end] = ACTIONS(1478),
    [sym_name] = ACTIONS(1480),
    [anon_sym_QMARK_GT] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1478),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1480),
    [aux_sym_global_declaration_token1] = ACTIONS(1480),
    [aux_sym_namespace_definition_token1] = ACTIONS(1480),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1480),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1480),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1480),
    [anon_sym_BSLASH] = ACTIONS(1478),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_RBRACE] = ACTIONS(1478),
    [aux_sym_trait_declaration_token1] = ACTIONS(1480),
    [aux_sym_interface_declaration_token1] = ACTIONS(1480),
    [aux_sym_enum_declaration_token1] = ACTIONS(1480),
    [aux_sym_enum_case_token1] = ACTIONS(1480),
    [aux_sym_class_declaration_token1] = ACTIONS(1480),
    [aux_sym_final_modifier_token1] = ACTIONS(1480),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1480),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1480),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1480),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1480),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1480),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1480),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [aux_sym_cast_type_token1] = ACTIONS(1480),
    [aux_sym_echo_statement_token1] = ACTIONS(1480),
    [anon_sym_unset] = ACTIONS(1480),
    [aux_sym_declare_statement_token1] = ACTIONS(1480),
    [aux_sym_declare_statement_token2] = ACTIONS(1480),
    [sym_float] = ACTIONS(1480),
    [aux_sym_try_statement_token1] = ACTIONS(1480),
    [aux_sym_goto_statement_token1] = ACTIONS(1480),
    [aux_sym_continue_statement_token1] = ACTIONS(1480),
    [aux_sym_break_statement_token1] = ACTIONS(1480),
    [sym_integer] = ACTIONS(1480),
    [aux_sym_return_statement_token1] = ACTIONS(1480),
    [aux_sym_throw_expression_token1] = ACTIONS(1480),
    [aux_sym_while_statement_token1] = ACTIONS(1480),
    [aux_sym_while_statement_token2] = ACTIONS(1480),
    [aux_sym_do_statement_token1] = ACTIONS(1480),
    [aux_sym_for_statement_token1] = ACTIONS(1480),
    [aux_sym_for_statement_token2] = ACTIONS(1480),
    [aux_sym_foreach_statement_token1] = ACTIONS(1480),
    [aux_sym_foreach_statement_token2] = ACTIONS(1480),
    [aux_sym_if_statement_token1] = ACTIONS(1480),
    [aux_sym_if_statement_token2] = ACTIONS(1480),
    [aux_sym_else_if_clause_token1] = ACTIONS(1480),
    [aux_sym_else_clause_token1] = ACTIONS(1480),
    [aux_sym_match_expression_token1] = ACTIONS(1480),
    [aux_sym_match_default_expression_token1] = ACTIONS(1480),
    [aux_sym_switch_statement_token1] = ACTIONS(1480),
    [aux_sym_switch_block_token1] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1480),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1478),
    [aux_sym_clone_expression_token1] = ACTIONS(1480),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1480),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1480),
    [anon_sym_DASH_DASH] = ACTIONS(1478),
    [anon_sym_PLUS_PLUS] = ACTIONS(1478),
    [aux_sym__list_destructing_token1] = ACTIONS(1480),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_self] = ACTIONS(1480),
    [anon_sym_parent] = ACTIONS(1480),
    [aux_sym__argument_name_token1] = ACTIONS(1480),
    [aux_sym__argument_name_token2] = ACTIONS(1480),
    [anon_sym_POUND_LBRACK] = ACTIONS(1478),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [aux_sym_encapsed_string_token1] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [aux_sym_string_token1] = ACTIONS(1478),
    [anon_sym_LT_LT_LT] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1478),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [aux_sym_yield_expression_token1] = ACTIONS(1480),
    [aux_sym_include_expression_token1] = ACTIONS(1480),
    [aux_sym_include_once_expression_token1] = ACTIONS(1480),
    [aux_sym_require_expression_token1] = ACTIONS(1480),
    [aux_sym_require_once_expression_token1] = ACTIONS(1480),
    [sym_comment] = ACTIONS(3),
  },
  [547] = {
    [ts_builtin_sym_end] = ACTIONS(1482),
    [sym_name] = ACTIONS(1484),
    [anon_sym_QMARK_GT] = ACTIONS(1482),
    [anon_sym_SEMI] = ACTIONS(1482),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1484),
    [aux_sym_global_declaration_token1] = ACTIONS(1484),
    [aux_sym_namespace_definition_token1] = ACTIONS(1484),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1484),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1484),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1484),
    [anon_sym_BSLASH] = ACTIONS(1482),
    [anon_sym_LBRACE] = ACTIONS(1482),
    [anon_sym_RBRACE] = ACTIONS(1482),
    [aux_sym_trait_declaration_token1] = ACTIONS(1484),
    [aux_sym_interface_declaration_token1] = ACTIONS(1484),
    [aux_sym_enum_declaration_token1] = ACTIONS(1484),
    [aux_sym_enum_case_token1] = ACTIONS(1484),
    [aux_sym_class_declaration_token1] = ACTIONS(1484),
    [aux_sym_final_modifier_token1] = ACTIONS(1484),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1484),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1484),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1484),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1484),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1484),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1484),
    [anon_sym_LPAREN] = ACTIONS(1482),
    [aux_sym_cast_type_token1] = ACTIONS(1484),
    [aux_sym_echo_statement_token1] = ACTIONS(1484),
    [anon_sym_unset] = ACTIONS(1484),
    [aux_sym_declare_statement_token1] = ACTIONS(1484),
    [aux_sym_declare_statement_token2] = ACTIONS(1484),
    [sym_float] = ACTIONS(1484),
    [aux_sym_try_statement_token1] = ACTIONS(1484),
    [aux_sym_goto_statement_token1] = ACTIONS(1484),
    [aux_sym_continue_statement_token1] = ACTIONS(1484),
    [aux_sym_break_statement_token1] = ACTIONS(1484),
    [sym_integer] = ACTIONS(1484),
    [aux_sym_return_statement_token1] = ACTIONS(1484),
    [aux_sym_throw_expression_token1] = ACTIONS(1484),
    [aux_sym_while_statement_token1] = ACTIONS(1484),
    [aux_sym_while_statement_token2] = ACTIONS(1484),
    [aux_sym_do_statement_token1] = ACTIONS(1484),
    [aux_sym_for_statement_token1] = ACTIONS(1484),
    [aux_sym_for_statement_token2] = ACTIONS(1484),
    [aux_sym_foreach_statement_token1] = ACTIONS(1484),
    [aux_sym_foreach_statement_token2] = ACTIONS(1484),
    [aux_sym_if_statement_token1] = ACTIONS(1484),
    [aux_sym_if_statement_token2] = ACTIONS(1484),
    [aux_sym_else_if_clause_token1] = ACTIONS(1484),
    [aux_sym_else_clause_token1] = ACTIONS(1484),
    [aux_sym_match_expression_token1] = ACTIONS(1484),
    [aux_sym_match_default_expression_token1] = ACTIONS(1484),
    [aux_sym_switch_statement_token1] = ACTIONS(1484),
    [aux_sym_switch_block_token1] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1484),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1482),
    [aux_sym_clone_expression_token1] = ACTIONS(1484),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1484),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1484),
    [anon_sym_DASH_DASH] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1482),
    [aux_sym__list_destructing_token1] = ACTIONS(1484),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_self] = ACTIONS(1484),
    [anon_sym_parent] = ACTIONS(1484),
    [aux_sym__argument_name_token1] = ACTIONS(1484),
    [aux_sym__argument_name_token2] = ACTIONS(1484),
    [anon_sym_POUND_LBRACK] = ACTIONS(1482),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [aux_sym_encapsed_string_token1] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [aux_sym_string_token1] = ACTIONS(1482),
    [anon_sym_LT_LT_LT] = ACTIONS(1482),
    [anon_sym_BQUOTE] = ACTIONS(1482),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [aux_sym_yield_expression_token1] = ACTIONS(1484),
    [aux_sym_include_expression_token1] = ACTIONS(1484),
    [aux_sym_include_once_expression_token1] = ACTIONS(1484),
    [aux_sym_require_expression_token1] = ACTIONS(1484),
    [aux_sym_require_once_expression_token1] = ACTIONS(1484),
    [sym_comment] = ACTIONS(3),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(1486),
    [sym_name] = ACTIONS(1488),
    [anon_sym_QMARK_GT] = ACTIONS(1486),
    [anon_sym_SEMI] = ACTIONS(1486),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1488),
    [aux_sym_global_declaration_token1] = ACTIONS(1488),
    [aux_sym_namespace_definition_token1] = ACTIONS(1488),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1488),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1488),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1488),
    [anon_sym_BSLASH] = ACTIONS(1486),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_RBRACE] = ACTIONS(1486),
    [aux_sym_trait_declaration_token1] = ACTIONS(1488),
    [aux_sym_interface_declaration_token1] = ACTIONS(1488),
    [aux_sym_enum_declaration_token1] = ACTIONS(1488),
    [aux_sym_enum_case_token1] = ACTIONS(1488),
    [aux_sym_class_declaration_token1] = ACTIONS(1488),
    [aux_sym_final_modifier_token1] = ACTIONS(1488),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1488),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1488),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1488),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1488),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1488),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1488),
    [anon_sym_LPAREN] = ACTIONS(1486),
    [aux_sym_cast_type_token1] = ACTIONS(1488),
    [aux_sym_echo_statement_token1] = ACTIONS(1488),
    [anon_sym_unset] = ACTIONS(1488),
    [aux_sym_declare_statement_token1] = ACTIONS(1488),
    [aux_sym_declare_statement_token2] = ACTIONS(1488),
    [sym_float] = ACTIONS(1488),
    [aux_sym_try_statement_token1] = ACTIONS(1488),
    [aux_sym_goto_statement_token1] = ACTIONS(1488),
    [aux_sym_continue_statement_token1] = ACTIONS(1488),
    [aux_sym_break_statement_token1] = ACTIONS(1488),
    [sym_integer] = ACTIONS(1488),
    [aux_sym_return_statement_token1] = ACTIONS(1488),
    [aux_sym_throw_expression_token1] = ACTIONS(1488),
    [aux_sym_while_statement_token1] = ACTIONS(1488),
    [aux_sym_while_statement_token2] = ACTIONS(1488),
    [aux_sym_do_statement_token1] = ACTIONS(1488),
    [aux_sym_for_statement_token1] = ACTIONS(1488),
    [aux_sym_for_statement_token2] = ACTIONS(1488),
    [aux_sym_foreach_statement_token1] = ACTIONS(1488),
    [aux_sym_foreach_statement_token2] = ACTIONS(1488),
    [aux_sym_if_statement_token1] = ACTIONS(1488),
    [aux_sym_if_statement_token2] = ACTIONS(1488),
    [aux_sym_else_if_clause_token1] = ACTIONS(1488),
    [aux_sym_else_clause_token1] = ACTIONS(1488),
    [aux_sym_match_expression_token1] = ACTIONS(1488),
    [aux_sym_match_default_expression_token1] = ACTIONS(1488),
    [aux_sym_switch_statement_token1] = ACTIONS(1488),
    [aux_sym_switch_block_token1] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1486),
    [anon_sym_AT] = ACTIONS(1486),
    [aux_sym_clone_expression_token1] = ACTIONS(1488),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1488),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [aux_sym__list_destructing_token1] = ACTIONS(1488),
    [anon_sym_LBRACK] = ACTIONS(1486),
    [anon_sym_self] = ACTIONS(1488),
    [anon_sym_parent] = ACTIONS(1488),
    [aux_sym__argument_name_token1] = ACTIONS(1488),
    [aux_sym__argument_name_token2] = ACTIONS(1488),
    [anon_sym_POUND_LBRACK] = ACTIONS(1486),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [aux_sym_encapsed_string_token1] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [aux_sym_string_token1] = ACTIONS(1486),
    [anon_sym_LT_LT_LT] = ACTIONS(1486),
    [anon_sym_BQUOTE] = ACTIONS(1486),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [aux_sym_yield_expression_token1] = ACTIONS(1488),
    [aux_sym_include_expression_token1] = ACTIONS(1488),
    [aux_sym_include_once_expression_token1] = ACTIONS(1488),
    [aux_sym_require_expression_token1] = ACTIONS(1488),
    [aux_sym_require_once_expression_token1] = ACTIONS(1488),
    [sym_comment] = ACTIONS(3),
  },
  [549] = {
    [ts_builtin_sym_end] = ACTIONS(1490),
    [sym_name] = ACTIONS(1492),
    [anon_sym_QMARK_GT] = ACTIONS(1490),
    [anon_sym_SEMI] = ACTIONS(1490),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1492),
    [aux_sym_global_declaration_token1] = ACTIONS(1492),
    [aux_sym_namespace_definition_token1] = ACTIONS(1492),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1492),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1492),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1492),
    [anon_sym_BSLASH] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1490),
    [anon_sym_RBRACE] = ACTIONS(1490),
    [aux_sym_trait_declaration_token1] = ACTIONS(1492),
    [aux_sym_interface_declaration_token1] = ACTIONS(1492),
    [aux_sym_enum_declaration_token1] = ACTIONS(1492),
    [aux_sym_enum_case_token1] = ACTIONS(1492),
    [aux_sym_class_declaration_token1] = ACTIONS(1492),
    [aux_sym_final_modifier_token1] = ACTIONS(1492),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1492),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1492),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1492),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1492),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1492),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1492),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [aux_sym_cast_type_token1] = ACTIONS(1492),
    [aux_sym_echo_statement_token1] = ACTIONS(1492),
    [anon_sym_unset] = ACTIONS(1492),
    [aux_sym_declare_statement_token1] = ACTIONS(1492),
    [aux_sym_declare_statement_token2] = ACTIONS(1492),
    [sym_float] = ACTIONS(1492),
    [aux_sym_try_statement_token1] = ACTIONS(1492),
    [aux_sym_goto_statement_token1] = ACTIONS(1492),
    [aux_sym_continue_statement_token1] = ACTIONS(1492),
    [aux_sym_break_statement_token1] = ACTIONS(1492),
    [sym_integer] = ACTIONS(1492),
    [aux_sym_return_statement_token1] = ACTIONS(1492),
    [aux_sym_throw_expression_token1] = ACTIONS(1492),
    [aux_sym_while_statement_token1] = ACTIONS(1492),
    [aux_sym_while_statement_token2] = ACTIONS(1492),
    [aux_sym_do_statement_token1] = ACTIONS(1492),
    [aux_sym_for_statement_token1] = ACTIONS(1492),
    [aux_sym_for_statement_token2] = ACTIONS(1492),
    [aux_sym_foreach_statement_token1] = ACTIONS(1492),
    [aux_sym_foreach_statement_token2] = ACTIONS(1492),
    [aux_sym_if_statement_token1] = ACTIONS(1492),
    [aux_sym_if_statement_token2] = ACTIONS(1492),
    [aux_sym_else_if_clause_token1] = ACTIONS(1492),
    [aux_sym_else_clause_token1] = ACTIONS(1492),
    [aux_sym_match_expression_token1] = ACTIONS(1492),
    [aux_sym_match_default_expression_token1] = ACTIONS(1492),
    [aux_sym_switch_statement_token1] = ACTIONS(1492),
    [aux_sym_switch_block_token1] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_TILDE] = ACTIONS(1490),
    [anon_sym_BANG] = ACTIONS(1490),
    [anon_sym_AT] = ACTIONS(1490),
    [aux_sym_clone_expression_token1] = ACTIONS(1492),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1492),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1492),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [aux_sym__list_destructing_token1] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_self] = ACTIONS(1492),
    [anon_sym_parent] = ACTIONS(1492),
    [aux_sym__argument_name_token1] = ACTIONS(1492),
    [aux_sym__argument_name_token2] = ACTIONS(1492),
    [anon_sym_POUND_LBRACK] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(1490),
    [aux_sym_encapsed_string_token1] = ACTIONS(1490),
    [anon_sym_DQUOTE] = ACTIONS(1490),
    [aux_sym_string_token1] = ACTIONS(1490),
    [anon_sym_LT_LT_LT] = ACTIONS(1490),
    [anon_sym_BQUOTE] = ACTIONS(1490),
    [anon_sym_DOLLAR] = ACTIONS(1490),
    [aux_sym_yield_expression_token1] = ACTIONS(1492),
    [aux_sym_include_expression_token1] = ACTIONS(1492),
    [aux_sym_include_once_expression_token1] = ACTIONS(1492),
    [aux_sym_require_expression_token1] = ACTIONS(1492),
    [aux_sym_require_once_expression_token1] = ACTIONS(1492),
    [sym_comment] = ACTIONS(3),
  },
  [550] = {
    [ts_builtin_sym_end] = ACTIONS(1494),
    [sym_name] = ACTIONS(1496),
    [anon_sym_QMARK_GT] = ACTIONS(1494),
    [anon_sym_SEMI] = ACTIONS(1494),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1496),
    [aux_sym_global_declaration_token1] = ACTIONS(1496),
    [aux_sym_namespace_definition_token1] = ACTIONS(1496),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1496),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1496),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1496),
    [anon_sym_BSLASH] = ACTIONS(1494),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_RBRACE] = ACTIONS(1494),
    [aux_sym_trait_declaration_token1] = ACTIONS(1496),
    [aux_sym_interface_declaration_token1] = ACTIONS(1496),
    [aux_sym_enum_declaration_token1] = ACTIONS(1496),
    [aux_sym_enum_case_token1] = ACTIONS(1496),
    [aux_sym_class_declaration_token1] = ACTIONS(1496),
    [aux_sym_final_modifier_token1] = ACTIONS(1496),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1496),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1496),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1496),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1496),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1496),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1496),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [aux_sym_cast_type_token1] = ACTIONS(1496),
    [aux_sym_echo_statement_token1] = ACTIONS(1496),
    [anon_sym_unset] = ACTIONS(1496),
    [aux_sym_declare_statement_token1] = ACTIONS(1496),
    [aux_sym_declare_statement_token2] = ACTIONS(1496),
    [sym_float] = ACTIONS(1496),
    [aux_sym_try_statement_token1] = ACTIONS(1496),
    [aux_sym_goto_statement_token1] = ACTIONS(1496),
    [aux_sym_continue_statement_token1] = ACTIONS(1496),
    [aux_sym_break_statement_token1] = ACTIONS(1496),
    [sym_integer] = ACTIONS(1496),
    [aux_sym_return_statement_token1] = ACTIONS(1496),
    [aux_sym_throw_expression_token1] = ACTIONS(1496),
    [aux_sym_while_statement_token1] = ACTIONS(1496),
    [aux_sym_while_statement_token2] = ACTIONS(1496),
    [aux_sym_do_statement_token1] = ACTIONS(1496),
    [aux_sym_for_statement_token1] = ACTIONS(1496),
    [aux_sym_for_statement_token2] = ACTIONS(1496),
    [aux_sym_foreach_statement_token1] = ACTIONS(1496),
    [aux_sym_foreach_statement_token2] = ACTIONS(1496),
    [aux_sym_if_statement_token1] = ACTIONS(1496),
    [aux_sym_if_statement_token2] = ACTIONS(1496),
    [aux_sym_else_if_clause_token1] = ACTIONS(1496),
    [aux_sym_else_clause_token1] = ACTIONS(1496),
    [aux_sym_match_expression_token1] = ACTIONS(1496),
    [aux_sym_match_default_expression_token1] = ACTIONS(1496),
    [aux_sym_switch_statement_token1] = ACTIONS(1496),
    [aux_sym_switch_block_token1] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [aux_sym_clone_expression_token1] = ACTIONS(1496),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1496),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1496),
    [anon_sym_DASH_DASH] = ACTIONS(1494),
    [anon_sym_PLUS_PLUS] = ACTIONS(1494),
    [aux_sym__list_destructing_token1] = ACTIONS(1496),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_self] = ACTIONS(1496),
    [anon_sym_parent] = ACTIONS(1496),
    [aux_sym__argument_name_token1] = ACTIONS(1496),
    [aux_sym__argument_name_token2] = ACTIONS(1496),
    [anon_sym_POUND_LBRACK] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [aux_sym_encapsed_string_token1] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [aux_sym_string_token1] = ACTIONS(1494),
    [anon_sym_LT_LT_LT] = ACTIONS(1494),
    [anon_sym_BQUOTE] = ACTIONS(1494),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [aux_sym_yield_expression_token1] = ACTIONS(1496),
    [aux_sym_include_expression_token1] = ACTIONS(1496),
    [aux_sym_include_once_expression_token1] = ACTIONS(1496),
    [aux_sym_require_expression_token1] = ACTIONS(1496),
    [aux_sym_require_once_expression_token1] = ACTIONS(1496),
    [sym_comment] = ACTIONS(3),
  },
  [551] = {
    [ts_builtin_sym_end] = ACTIONS(1490),
    [sym_name] = ACTIONS(1492),
    [anon_sym_QMARK_GT] = ACTIONS(1490),
    [anon_sym_SEMI] = ACTIONS(1490),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1492),
    [aux_sym_global_declaration_token1] = ACTIONS(1492),
    [aux_sym_namespace_definition_token1] = ACTIONS(1492),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1492),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1492),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1492),
    [anon_sym_BSLASH] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1490),
    [anon_sym_RBRACE] = ACTIONS(1490),
    [aux_sym_trait_declaration_token1] = ACTIONS(1492),
    [aux_sym_interface_declaration_token1] = ACTIONS(1492),
    [aux_sym_enum_declaration_token1] = ACTIONS(1492),
    [aux_sym_enum_case_token1] = ACTIONS(1492),
    [aux_sym_class_declaration_token1] = ACTIONS(1492),
    [aux_sym_final_modifier_token1] = ACTIONS(1492),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1492),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1492),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1492),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1492),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1492),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1492),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [aux_sym_cast_type_token1] = ACTIONS(1492),
    [aux_sym_echo_statement_token1] = ACTIONS(1492),
    [anon_sym_unset] = ACTIONS(1492),
    [aux_sym_declare_statement_token1] = ACTIONS(1492),
    [aux_sym_declare_statement_token2] = ACTIONS(1492),
    [sym_float] = ACTIONS(1492),
    [aux_sym_try_statement_token1] = ACTIONS(1492),
    [aux_sym_goto_statement_token1] = ACTIONS(1492),
    [aux_sym_continue_statement_token1] = ACTIONS(1492),
    [aux_sym_break_statement_token1] = ACTIONS(1492),
    [sym_integer] = ACTIONS(1492),
    [aux_sym_return_statement_token1] = ACTIONS(1492),
    [aux_sym_throw_expression_token1] = ACTIONS(1492),
    [aux_sym_while_statement_token1] = ACTIONS(1492),
    [aux_sym_while_statement_token2] = ACTIONS(1492),
    [aux_sym_do_statement_token1] = ACTIONS(1492),
    [aux_sym_for_statement_token1] = ACTIONS(1492),
    [aux_sym_for_statement_token2] = ACTIONS(1492),
    [aux_sym_foreach_statement_token1] = ACTIONS(1492),
    [aux_sym_foreach_statement_token2] = ACTIONS(1492),
    [aux_sym_if_statement_token1] = ACTIONS(1492),
    [aux_sym_if_statement_token2] = ACTIONS(1492),
    [aux_sym_else_if_clause_token1] = ACTIONS(1492),
    [aux_sym_else_clause_token1] = ACTIONS(1492),
    [aux_sym_match_expression_token1] = ACTIONS(1492),
    [aux_sym_match_default_expression_token1] = ACTIONS(1492),
    [aux_sym_switch_statement_token1] = ACTIONS(1492),
    [aux_sym_switch_block_token1] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_TILDE] = ACTIONS(1490),
    [anon_sym_BANG] = ACTIONS(1490),
    [anon_sym_AT] = ACTIONS(1490),
    [aux_sym_clone_expression_token1] = ACTIONS(1492),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1492),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1492),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [aux_sym__list_destructing_token1] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_self] = ACTIONS(1492),
    [anon_sym_parent] = ACTIONS(1492),
    [aux_sym__argument_name_token1] = ACTIONS(1492),
    [aux_sym__argument_name_token2] = ACTIONS(1492),
    [anon_sym_POUND_LBRACK] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(1490),
    [aux_sym_encapsed_string_token1] = ACTIONS(1490),
    [anon_sym_DQUOTE] = ACTIONS(1490),
    [aux_sym_string_token1] = ACTIONS(1490),
    [anon_sym_LT_LT_LT] = ACTIONS(1490),
    [anon_sym_BQUOTE] = ACTIONS(1490),
    [anon_sym_DOLLAR] = ACTIONS(1490),
    [aux_sym_yield_expression_token1] = ACTIONS(1492),
    [aux_sym_include_expression_token1] = ACTIONS(1492),
    [aux_sym_include_once_expression_token1] = ACTIONS(1492),
    [aux_sym_require_expression_token1] = ACTIONS(1492),
    [aux_sym_require_once_expression_token1] = ACTIONS(1492),
    [sym_comment] = ACTIONS(3),
  },
  [552] = {
    [ts_builtin_sym_end] = ACTIONS(1498),
    [sym_name] = ACTIONS(1500),
    [anon_sym_QMARK_GT] = ACTIONS(1498),
    [anon_sym_SEMI] = ACTIONS(1498),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1500),
    [aux_sym_global_declaration_token1] = ACTIONS(1500),
    [aux_sym_namespace_definition_token1] = ACTIONS(1500),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1500),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1500),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1500),
    [anon_sym_BSLASH] = ACTIONS(1498),
    [anon_sym_LBRACE] = ACTIONS(1498),
    [anon_sym_RBRACE] = ACTIONS(1498),
    [aux_sym_trait_declaration_token1] = ACTIONS(1500),
    [aux_sym_interface_declaration_token1] = ACTIONS(1500),
    [aux_sym_enum_declaration_token1] = ACTIONS(1500),
    [aux_sym_enum_case_token1] = ACTIONS(1500),
    [aux_sym_class_declaration_token1] = ACTIONS(1500),
    [aux_sym_final_modifier_token1] = ACTIONS(1500),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1500),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1500),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1500),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1500),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1500),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1500),
    [anon_sym_LPAREN] = ACTIONS(1498),
    [aux_sym_cast_type_token1] = ACTIONS(1500),
    [aux_sym_echo_statement_token1] = ACTIONS(1500),
    [anon_sym_unset] = ACTIONS(1500),
    [aux_sym_declare_statement_token1] = ACTIONS(1500),
    [aux_sym_declare_statement_token2] = ACTIONS(1500),
    [sym_float] = ACTIONS(1500),
    [aux_sym_try_statement_token1] = ACTIONS(1500),
    [aux_sym_goto_statement_token1] = ACTIONS(1500),
    [aux_sym_continue_statement_token1] = ACTIONS(1500),
    [aux_sym_break_statement_token1] = ACTIONS(1500),
    [sym_integer] = ACTIONS(1500),
    [aux_sym_return_statement_token1] = ACTIONS(1500),
    [aux_sym_throw_expression_token1] = ACTIONS(1500),
    [aux_sym_while_statement_token1] = ACTIONS(1500),
    [aux_sym_while_statement_token2] = ACTIONS(1500),
    [aux_sym_do_statement_token1] = ACTIONS(1500),
    [aux_sym_for_statement_token1] = ACTIONS(1500),
    [aux_sym_for_statement_token2] = ACTIONS(1500),
    [aux_sym_foreach_statement_token1] = ACTIONS(1500),
    [aux_sym_foreach_statement_token2] = ACTIONS(1500),
    [aux_sym_if_statement_token1] = ACTIONS(1500),
    [aux_sym_if_statement_token2] = ACTIONS(1500),
    [aux_sym_else_if_clause_token1] = ACTIONS(1500),
    [aux_sym_else_clause_token1] = ACTIONS(1500),
    [aux_sym_match_expression_token1] = ACTIONS(1500),
    [aux_sym_match_default_expression_token1] = ACTIONS(1500),
    [aux_sym_switch_statement_token1] = ACTIONS(1500),
    [aux_sym_switch_block_token1] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_TILDE] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1498),
    [anon_sym_AT] = ACTIONS(1498),
    [aux_sym_clone_expression_token1] = ACTIONS(1500),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1500),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1500),
    [anon_sym_DASH_DASH] = ACTIONS(1498),
    [anon_sym_PLUS_PLUS] = ACTIONS(1498),
    [aux_sym__list_destructing_token1] = ACTIONS(1500),
    [anon_sym_LBRACK] = ACTIONS(1498),
    [anon_sym_self] = ACTIONS(1500),
    [anon_sym_parent] = ACTIONS(1500),
    [aux_sym__argument_name_token1] = ACTIONS(1500),
    [aux_sym__argument_name_token2] = ACTIONS(1500),
    [anon_sym_POUND_LBRACK] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1498),
    [aux_sym_encapsed_string_token1] = ACTIONS(1498),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [aux_sym_string_token1] = ACTIONS(1498),
    [anon_sym_LT_LT_LT] = ACTIONS(1498),
    [anon_sym_BQUOTE] = ACTIONS(1498),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [aux_sym_yield_expression_token1] = ACTIONS(1500),
    [aux_sym_include_expression_token1] = ACTIONS(1500),
    [aux_sym_include_once_expression_token1] = ACTIONS(1500),
    [aux_sym_require_expression_token1] = ACTIONS(1500),
    [aux_sym_require_once_expression_token1] = ACTIONS(1500),
    [sym_comment] = ACTIONS(3),
  },
  [553] = {
    [ts_builtin_sym_end] = ACTIONS(1502),
    [sym_name] = ACTIONS(1504),
    [anon_sym_QMARK_GT] = ACTIONS(1502),
    [anon_sym_SEMI] = ACTIONS(1502),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1504),
    [aux_sym_global_declaration_token1] = ACTIONS(1504),
    [aux_sym_namespace_definition_token1] = ACTIONS(1504),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1504),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1504),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1504),
    [anon_sym_BSLASH] = ACTIONS(1502),
    [anon_sym_LBRACE] = ACTIONS(1502),
    [anon_sym_RBRACE] = ACTIONS(1502),
    [aux_sym_trait_declaration_token1] = ACTIONS(1504),
    [aux_sym_interface_declaration_token1] = ACTIONS(1504),
    [aux_sym_enum_declaration_token1] = ACTIONS(1504),
    [aux_sym_enum_case_token1] = ACTIONS(1504),
    [aux_sym_class_declaration_token1] = ACTIONS(1504),
    [aux_sym_final_modifier_token1] = ACTIONS(1504),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1504),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1504),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1504),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1504),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1504),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [aux_sym_cast_type_token1] = ACTIONS(1504),
    [aux_sym_echo_statement_token1] = ACTIONS(1504),
    [anon_sym_unset] = ACTIONS(1504),
    [aux_sym_declare_statement_token1] = ACTIONS(1504),
    [aux_sym_declare_statement_token2] = ACTIONS(1504),
    [sym_float] = ACTIONS(1504),
    [aux_sym_try_statement_token1] = ACTIONS(1504),
    [aux_sym_goto_statement_token1] = ACTIONS(1504),
    [aux_sym_continue_statement_token1] = ACTIONS(1504),
    [aux_sym_break_statement_token1] = ACTIONS(1504),
    [sym_integer] = ACTIONS(1504),
    [aux_sym_return_statement_token1] = ACTIONS(1504),
    [aux_sym_throw_expression_token1] = ACTIONS(1504),
    [aux_sym_while_statement_token1] = ACTIONS(1504),
    [aux_sym_while_statement_token2] = ACTIONS(1504),
    [aux_sym_do_statement_token1] = ACTIONS(1504),
    [aux_sym_for_statement_token1] = ACTIONS(1504),
    [aux_sym_for_statement_token2] = ACTIONS(1504),
    [aux_sym_foreach_statement_token1] = ACTIONS(1504),
    [aux_sym_foreach_statement_token2] = ACTIONS(1504),
    [aux_sym_if_statement_token1] = ACTIONS(1504),
    [aux_sym_if_statement_token2] = ACTIONS(1504),
    [aux_sym_else_if_clause_token1] = ACTIONS(1504),
    [aux_sym_else_clause_token1] = ACTIONS(1504),
    [aux_sym_match_expression_token1] = ACTIONS(1504),
    [aux_sym_match_default_expression_token1] = ACTIONS(1504),
    [aux_sym_switch_statement_token1] = ACTIONS(1504),
    [aux_sym_switch_block_token1] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1504),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(1502),
    [aux_sym_clone_expression_token1] = ACTIONS(1504),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1504),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1504),
    [anon_sym_DASH_DASH] = ACTIONS(1502),
    [anon_sym_PLUS_PLUS] = ACTIONS(1502),
    [aux_sym__list_destructing_token1] = ACTIONS(1504),
    [anon_sym_LBRACK] = ACTIONS(1502),
    [anon_sym_self] = ACTIONS(1504),
    [anon_sym_parent] = ACTIONS(1504),
    [aux_sym__argument_name_token1] = ACTIONS(1504),
    [aux_sym__argument_name_token2] = ACTIONS(1504),
    [anon_sym_POUND_LBRACK] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [aux_sym_encapsed_string_token1] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [aux_sym_string_token1] = ACTIONS(1502),
    [anon_sym_LT_LT_LT] = ACTIONS(1502),
    [anon_sym_BQUOTE] = ACTIONS(1502),
    [anon_sym_DOLLAR] = ACTIONS(1502),
    [aux_sym_yield_expression_token1] = ACTIONS(1504),
    [aux_sym_include_expression_token1] = ACTIONS(1504),
    [aux_sym_include_once_expression_token1] = ACTIONS(1504),
    [aux_sym_require_expression_token1] = ACTIONS(1504),
    [aux_sym_require_once_expression_token1] = ACTIONS(1504),
    [sym_comment] = ACTIONS(3),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(1506),
    [sym_name] = ACTIONS(1508),
    [anon_sym_QMARK_GT] = ACTIONS(1506),
    [anon_sym_SEMI] = ACTIONS(1506),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1508),
    [aux_sym_global_declaration_token1] = ACTIONS(1508),
    [aux_sym_namespace_definition_token1] = ACTIONS(1508),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1508),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1508),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1508),
    [anon_sym_BSLASH] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(1506),
    [aux_sym_trait_declaration_token1] = ACTIONS(1508),
    [aux_sym_interface_declaration_token1] = ACTIONS(1508),
    [aux_sym_enum_declaration_token1] = ACTIONS(1508),
    [aux_sym_enum_case_token1] = ACTIONS(1508),
    [aux_sym_class_declaration_token1] = ACTIONS(1508),
    [aux_sym_final_modifier_token1] = ACTIONS(1508),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1508),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1508),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1508),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1508),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1508),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1508),
    [anon_sym_LPAREN] = ACTIONS(1506),
    [aux_sym_cast_type_token1] = ACTIONS(1508),
    [aux_sym_echo_statement_token1] = ACTIONS(1508),
    [anon_sym_unset] = ACTIONS(1508),
    [aux_sym_declare_statement_token1] = ACTIONS(1508),
    [aux_sym_declare_statement_token2] = ACTIONS(1508),
    [sym_float] = ACTIONS(1508),
    [aux_sym_try_statement_token1] = ACTIONS(1508),
    [aux_sym_goto_statement_token1] = ACTIONS(1508),
    [aux_sym_continue_statement_token1] = ACTIONS(1508),
    [aux_sym_break_statement_token1] = ACTIONS(1508),
    [sym_integer] = ACTIONS(1508),
    [aux_sym_return_statement_token1] = ACTIONS(1508),
    [aux_sym_throw_expression_token1] = ACTIONS(1508),
    [aux_sym_while_statement_token1] = ACTIONS(1508),
    [aux_sym_while_statement_token2] = ACTIONS(1508),
    [aux_sym_do_statement_token1] = ACTIONS(1508),
    [aux_sym_for_statement_token1] = ACTIONS(1508),
    [aux_sym_for_statement_token2] = ACTIONS(1508),
    [aux_sym_foreach_statement_token1] = ACTIONS(1508),
    [aux_sym_foreach_statement_token2] = ACTIONS(1508),
    [aux_sym_if_statement_token1] = ACTIONS(1508),
    [aux_sym_if_statement_token2] = ACTIONS(1508),
    [aux_sym_else_if_clause_token1] = ACTIONS(1508),
    [aux_sym_else_clause_token1] = ACTIONS(1508),
    [aux_sym_match_expression_token1] = ACTIONS(1508),
    [aux_sym_match_default_expression_token1] = ACTIONS(1508),
    [aux_sym_switch_statement_token1] = ACTIONS(1508),
    [aux_sym_switch_block_token1] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1506),
    [aux_sym_clone_expression_token1] = ACTIONS(1508),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1508),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1508),
    [anon_sym_DASH_DASH] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1506),
    [aux_sym__list_destructing_token1] = ACTIONS(1508),
    [anon_sym_LBRACK] = ACTIONS(1506),
    [anon_sym_self] = ACTIONS(1508),
    [anon_sym_parent] = ACTIONS(1508),
    [aux_sym__argument_name_token1] = ACTIONS(1508),
    [aux_sym__argument_name_token2] = ACTIONS(1508),
    [anon_sym_POUND_LBRACK] = ACTIONS(1506),
    [anon_sym_SQUOTE] = ACTIONS(1506),
    [aux_sym_encapsed_string_token1] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1506),
    [aux_sym_string_token1] = ACTIONS(1506),
    [anon_sym_LT_LT_LT] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [aux_sym_yield_expression_token1] = ACTIONS(1508),
    [aux_sym_include_expression_token1] = ACTIONS(1508),
    [aux_sym_include_once_expression_token1] = ACTIONS(1508),
    [aux_sym_require_expression_token1] = ACTIONS(1508),
    [aux_sym_require_once_expression_token1] = ACTIONS(1508),
    [sym_comment] = ACTIONS(3),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(1510),
    [sym_name] = ACTIONS(1512),
    [anon_sym_QMARK_GT] = ACTIONS(1510),
    [anon_sym_SEMI] = ACTIONS(1510),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1512),
    [aux_sym_global_declaration_token1] = ACTIONS(1512),
    [aux_sym_namespace_definition_token1] = ACTIONS(1512),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1512),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1512),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1512),
    [anon_sym_BSLASH] = ACTIONS(1510),
    [anon_sym_LBRACE] = ACTIONS(1510),
    [anon_sym_RBRACE] = ACTIONS(1510),
    [aux_sym_trait_declaration_token1] = ACTIONS(1512),
    [aux_sym_interface_declaration_token1] = ACTIONS(1512),
    [aux_sym_enum_declaration_token1] = ACTIONS(1512),
    [aux_sym_enum_case_token1] = ACTIONS(1512),
    [aux_sym_class_declaration_token1] = ACTIONS(1512),
    [aux_sym_final_modifier_token1] = ACTIONS(1512),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1512),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1512),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1512),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1512),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1512),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1512),
    [anon_sym_LPAREN] = ACTIONS(1510),
    [aux_sym_cast_type_token1] = ACTIONS(1512),
    [aux_sym_echo_statement_token1] = ACTIONS(1512),
    [anon_sym_unset] = ACTIONS(1512),
    [aux_sym_declare_statement_token1] = ACTIONS(1512),
    [aux_sym_declare_statement_token2] = ACTIONS(1512),
    [sym_float] = ACTIONS(1512),
    [aux_sym_try_statement_token1] = ACTIONS(1512),
    [aux_sym_goto_statement_token1] = ACTIONS(1512),
    [aux_sym_continue_statement_token1] = ACTIONS(1512),
    [aux_sym_break_statement_token1] = ACTIONS(1512),
    [sym_integer] = ACTIONS(1512),
    [aux_sym_return_statement_token1] = ACTIONS(1512),
    [aux_sym_throw_expression_token1] = ACTIONS(1512),
    [aux_sym_while_statement_token1] = ACTIONS(1512),
    [aux_sym_while_statement_token2] = ACTIONS(1512),
    [aux_sym_do_statement_token1] = ACTIONS(1512),
    [aux_sym_for_statement_token1] = ACTIONS(1512),
    [aux_sym_for_statement_token2] = ACTIONS(1512),
    [aux_sym_foreach_statement_token1] = ACTIONS(1512),
    [aux_sym_foreach_statement_token2] = ACTIONS(1512),
    [aux_sym_if_statement_token1] = ACTIONS(1512),
    [aux_sym_if_statement_token2] = ACTIONS(1512),
    [aux_sym_else_if_clause_token1] = ACTIONS(1512),
    [aux_sym_else_clause_token1] = ACTIONS(1512),
    [aux_sym_match_expression_token1] = ACTIONS(1512),
    [aux_sym_match_default_expression_token1] = ACTIONS(1512),
    [aux_sym_switch_statement_token1] = ACTIONS(1512),
    [aux_sym_switch_block_token1] = ACTIONS(1512),
    [anon_sym_PLUS] = ACTIONS(1512),
    [anon_sym_DASH] = ACTIONS(1512),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1510),
    [aux_sym_clone_expression_token1] = ACTIONS(1512),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1512),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1512),
    [anon_sym_DASH_DASH] = ACTIONS(1510),
    [anon_sym_PLUS_PLUS] = ACTIONS(1510),
    [aux_sym__list_destructing_token1] = ACTIONS(1512),
    [anon_sym_LBRACK] = ACTIONS(1510),
    [anon_sym_self] = ACTIONS(1512),
    [anon_sym_parent] = ACTIONS(1512),
    [aux_sym__argument_name_token1] = ACTIONS(1512),
    [aux_sym__argument_name_token2] = ACTIONS(1512),
    [anon_sym_POUND_LBRACK] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [aux_sym_encapsed_string_token1] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(1510),
    [aux_sym_string_token1] = ACTIONS(1510),
    [anon_sym_LT_LT_LT] = ACTIONS(1510),
    [anon_sym_BQUOTE] = ACTIONS(1510),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [aux_sym_yield_expression_token1] = ACTIONS(1512),
    [aux_sym_include_expression_token1] = ACTIONS(1512),
    [aux_sym_include_once_expression_token1] = ACTIONS(1512),
    [aux_sym_require_expression_token1] = ACTIONS(1512),
    [aux_sym_require_once_expression_token1] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(1514),
    [sym_name] = ACTIONS(1516),
    [anon_sym_QMARK_GT] = ACTIONS(1514),
    [anon_sym_SEMI] = ACTIONS(1514),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1516),
    [aux_sym_global_declaration_token1] = ACTIONS(1516),
    [aux_sym_namespace_definition_token1] = ACTIONS(1516),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1516),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1516),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1516),
    [anon_sym_BSLASH] = ACTIONS(1514),
    [anon_sym_LBRACE] = ACTIONS(1514),
    [anon_sym_RBRACE] = ACTIONS(1514),
    [aux_sym_trait_declaration_token1] = ACTIONS(1516),
    [aux_sym_interface_declaration_token1] = ACTIONS(1516),
    [aux_sym_enum_declaration_token1] = ACTIONS(1516),
    [aux_sym_enum_case_token1] = ACTIONS(1516),
    [aux_sym_class_declaration_token1] = ACTIONS(1516),
    [aux_sym_final_modifier_token1] = ACTIONS(1516),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1516),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1516),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1516),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1516),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1516),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1514),
    [aux_sym_cast_type_token1] = ACTIONS(1516),
    [aux_sym_echo_statement_token1] = ACTIONS(1516),
    [anon_sym_unset] = ACTIONS(1516),
    [aux_sym_declare_statement_token1] = ACTIONS(1516),
    [aux_sym_declare_statement_token2] = ACTIONS(1516),
    [sym_float] = ACTIONS(1516),
    [aux_sym_try_statement_token1] = ACTIONS(1516),
    [aux_sym_goto_statement_token1] = ACTIONS(1516),
    [aux_sym_continue_statement_token1] = ACTIONS(1516),
    [aux_sym_break_statement_token1] = ACTIONS(1516),
    [sym_integer] = ACTIONS(1516),
    [aux_sym_return_statement_token1] = ACTIONS(1516),
    [aux_sym_throw_expression_token1] = ACTIONS(1516),
    [aux_sym_while_statement_token1] = ACTIONS(1516),
    [aux_sym_while_statement_token2] = ACTIONS(1516),
    [aux_sym_do_statement_token1] = ACTIONS(1516),
    [aux_sym_for_statement_token1] = ACTIONS(1516),
    [aux_sym_for_statement_token2] = ACTIONS(1516),
    [aux_sym_foreach_statement_token1] = ACTIONS(1516),
    [aux_sym_foreach_statement_token2] = ACTIONS(1516),
    [aux_sym_if_statement_token1] = ACTIONS(1516),
    [aux_sym_if_statement_token2] = ACTIONS(1516),
    [aux_sym_else_if_clause_token1] = ACTIONS(1516),
    [aux_sym_else_clause_token1] = ACTIONS(1516),
    [aux_sym_match_expression_token1] = ACTIONS(1516),
    [aux_sym_match_default_expression_token1] = ACTIONS(1516),
    [aux_sym_switch_statement_token1] = ACTIONS(1516),
    [aux_sym_switch_block_token1] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1514),
    [anon_sym_BANG] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(1514),
    [aux_sym_clone_expression_token1] = ACTIONS(1516),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1516),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1516),
    [anon_sym_DASH_DASH] = ACTIONS(1514),
    [anon_sym_PLUS_PLUS] = ACTIONS(1514),
    [aux_sym__list_destructing_token1] = ACTIONS(1516),
    [anon_sym_LBRACK] = ACTIONS(1514),
    [anon_sym_self] = ACTIONS(1516),
    [anon_sym_parent] = ACTIONS(1516),
    [aux_sym__argument_name_token1] = ACTIONS(1516),
    [aux_sym__argument_name_token2] = ACTIONS(1516),
    [anon_sym_POUND_LBRACK] = ACTIONS(1514),
    [anon_sym_SQUOTE] = ACTIONS(1514),
    [aux_sym_encapsed_string_token1] = ACTIONS(1514),
    [anon_sym_DQUOTE] = ACTIONS(1514),
    [aux_sym_string_token1] = ACTIONS(1514),
    [anon_sym_LT_LT_LT] = ACTIONS(1514),
    [anon_sym_BQUOTE] = ACTIONS(1514),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [aux_sym_yield_expression_token1] = ACTIONS(1516),
    [aux_sym_include_expression_token1] = ACTIONS(1516),
    [aux_sym_include_once_expression_token1] = ACTIONS(1516),
    [aux_sym_require_expression_token1] = ACTIONS(1516),
    [aux_sym_require_once_expression_token1] = ACTIONS(1516),
    [sym_comment] = ACTIONS(3),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(1518),
    [sym_name] = ACTIONS(1520),
    [anon_sym_QMARK_GT] = ACTIONS(1518),
    [anon_sym_SEMI] = ACTIONS(1518),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1520),
    [aux_sym_global_declaration_token1] = ACTIONS(1520),
    [aux_sym_namespace_definition_token1] = ACTIONS(1520),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1520),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1520),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1520),
    [anon_sym_BSLASH] = ACTIONS(1518),
    [anon_sym_LBRACE] = ACTIONS(1518),
    [anon_sym_RBRACE] = ACTIONS(1518),
    [aux_sym_trait_declaration_token1] = ACTIONS(1520),
    [aux_sym_interface_declaration_token1] = ACTIONS(1520),
    [aux_sym_enum_declaration_token1] = ACTIONS(1520),
    [aux_sym_enum_case_token1] = ACTIONS(1520),
    [aux_sym_class_declaration_token1] = ACTIONS(1520),
    [aux_sym_final_modifier_token1] = ACTIONS(1520),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1520),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1520),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1520),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1520),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1520),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1520),
    [anon_sym_LPAREN] = ACTIONS(1518),
    [aux_sym_cast_type_token1] = ACTIONS(1520),
    [aux_sym_echo_statement_token1] = ACTIONS(1520),
    [anon_sym_unset] = ACTIONS(1520),
    [aux_sym_declare_statement_token1] = ACTIONS(1520),
    [aux_sym_declare_statement_token2] = ACTIONS(1520),
    [sym_float] = ACTIONS(1520),
    [aux_sym_try_statement_token1] = ACTIONS(1520),
    [aux_sym_goto_statement_token1] = ACTIONS(1520),
    [aux_sym_continue_statement_token1] = ACTIONS(1520),
    [aux_sym_break_statement_token1] = ACTIONS(1520),
    [sym_integer] = ACTIONS(1520),
    [aux_sym_return_statement_token1] = ACTIONS(1520),
    [aux_sym_throw_expression_token1] = ACTIONS(1520),
    [aux_sym_while_statement_token1] = ACTIONS(1520),
    [aux_sym_while_statement_token2] = ACTIONS(1520),
    [aux_sym_do_statement_token1] = ACTIONS(1520),
    [aux_sym_for_statement_token1] = ACTIONS(1520),
    [aux_sym_for_statement_token2] = ACTIONS(1520),
    [aux_sym_foreach_statement_token1] = ACTIONS(1520),
    [aux_sym_foreach_statement_token2] = ACTIONS(1520),
    [aux_sym_if_statement_token1] = ACTIONS(1520),
    [aux_sym_if_statement_token2] = ACTIONS(1520),
    [aux_sym_else_if_clause_token1] = ACTIONS(1520),
    [aux_sym_else_clause_token1] = ACTIONS(1520),
    [aux_sym_match_expression_token1] = ACTIONS(1520),
    [aux_sym_match_default_expression_token1] = ACTIONS(1520),
    [aux_sym_switch_statement_token1] = ACTIONS(1520),
    [aux_sym_switch_block_token1] = ACTIONS(1520),
    [anon_sym_PLUS] = ACTIONS(1520),
    [anon_sym_DASH] = ACTIONS(1520),
    [anon_sym_TILDE] = ACTIONS(1518),
    [anon_sym_BANG] = ACTIONS(1518),
    [anon_sym_AT] = ACTIONS(1518),
    [aux_sym_clone_expression_token1] = ACTIONS(1520),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1520),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1520),
    [anon_sym_DASH_DASH] = ACTIONS(1518),
    [anon_sym_PLUS_PLUS] = ACTIONS(1518),
    [aux_sym__list_destructing_token1] = ACTIONS(1520),
    [anon_sym_LBRACK] = ACTIONS(1518),
    [anon_sym_self] = ACTIONS(1520),
    [anon_sym_parent] = ACTIONS(1520),
    [aux_sym__argument_name_token1] = ACTIONS(1520),
    [aux_sym__argument_name_token2] = ACTIONS(1520),
    [anon_sym_POUND_LBRACK] = ACTIONS(1518),
    [anon_sym_SQUOTE] = ACTIONS(1518),
    [aux_sym_encapsed_string_token1] = ACTIONS(1518),
    [anon_sym_DQUOTE] = ACTIONS(1518),
    [aux_sym_string_token1] = ACTIONS(1518),
    [anon_sym_LT_LT_LT] = ACTIONS(1518),
    [anon_sym_BQUOTE] = ACTIONS(1518),
    [anon_sym_DOLLAR] = ACTIONS(1518),
    [aux_sym_yield_expression_token1] = ACTIONS(1520),
    [aux_sym_include_expression_token1] = ACTIONS(1520),
    [aux_sym_include_once_expression_token1] = ACTIONS(1520),
    [aux_sym_require_expression_token1] = ACTIONS(1520),
    [aux_sym_require_once_expression_token1] = ACTIONS(1520),
    [sym_comment] = ACTIONS(3),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(1522),
    [sym_name] = ACTIONS(1524),
    [anon_sym_QMARK_GT] = ACTIONS(1522),
    [anon_sym_SEMI] = ACTIONS(1522),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1524),
    [aux_sym_global_declaration_token1] = ACTIONS(1524),
    [aux_sym_namespace_definition_token1] = ACTIONS(1524),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1524),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1524),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1524),
    [anon_sym_BSLASH] = ACTIONS(1522),
    [anon_sym_LBRACE] = ACTIONS(1522),
    [anon_sym_RBRACE] = ACTIONS(1522),
    [aux_sym_trait_declaration_token1] = ACTIONS(1524),
    [aux_sym_interface_declaration_token1] = ACTIONS(1524),
    [aux_sym_enum_declaration_token1] = ACTIONS(1524),
    [aux_sym_enum_case_token1] = ACTIONS(1524),
    [aux_sym_class_declaration_token1] = ACTIONS(1524),
    [aux_sym_final_modifier_token1] = ACTIONS(1524),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1524),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1524),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1524),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1524),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1524),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1522),
    [aux_sym_cast_type_token1] = ACTIONS(1524),
    [aux_sym_echo_statement_token1] = ACTIONS(1524),
    [anon_sym_unset] = ACTIONS(1524),
    [aux_sym_declare_statement_token1] = ACTIONS(1524),
    [aux_sym_declare_statement_token2] = ACTIONS(1524),
    [sym_float] = ACTIONS(1524),
    [aux_sym_try_statement_token1] = ACTIONS(1524),
    [aux_sym_goto_statement_token1] = ACTIONS(1524),
    [aux_sym_continue_statement_token1] = ACTIONS(1524),
    [aux_sym_break_statement_token1] = ACTIONS(1524),
    [sym_integer] = ACTIONS(1524),
    [aux_sym_return_statement_token1] = ACTIONS(1524),
    [aux_sym_throw_expression_token1] = ACTIONS(1524),
    [aux_sym_while_statement_token1] = ACTIONS(1524),
    [aux_sym_while_statement_token2] = ACTIONS(1524),
    [aux_sym_do_statement_token1] = ACTIONS(1524),
    [aux_sym_for_statement_token1] = ACTIONS(1524),
    [aux_sym_for_statement_token2] = ACTIONS(1524),
    [aux_sym_foreach_statement_token1] = ACTIONS(1524),
    [aux_sym_foreach_statement_token2] = ACTIONS(1524),
    [aux_sym_if_statement_token1] = ACTIONS(1524),
    [aux_sym_if_statement_token2] = ACTIONS(1524),
    [aux_sym_else_if_clause_token1] = ACTIONS(1524),
    [aux_sym_else_clause_token1] = ACTIONS(1524),
    [aux_sym_match_expression_token1] = ACTIONS(1524),
    [aux_sym_match_default_expression_token1] = ACTIONS(1524),
    [aux_sym_switch_statement_token1] = ACTIONS(1524),
    [aux_sym_switch_block_token1] = ACTIONS(1524),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(1522),
    [anon_sym_AT] = ACTIONS(1522),
    [aux_sym_clone_expression_token1] = ACTIONS(1524),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1524),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1524),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [aux_sym__list_destructing_token1] = ACTIONS(1524),
    [anon_sym_LBRACK] = ACTIONS(1522),
    [anon_sym_self] = ACTIONS(1524),
    [anon_sym_parent] = ACTIONS(1524),
    [aux_sym__argument_name_token1] = ACTIONS(1524),
    [aux_sym__argument_name_token2] = ACTIONS(1524),
    [anon_sym_POUND_LBRACK] = ACTIONS(1522),
    [anon_sym_SQUOTE] = ACTIONS(1522),
    [aux_sym_encapsed_string_token1] = ACTIONS(1522),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [aux_sym_string_token1] = ACTIONS(1522),
    [anon_sym_LT_LT_LT] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(1522),
    [aux_sym_yield_expression_token1] = ACTIONS(1524),
    [aux_sym_include_expression_token1] = ACTIONS(1524),
    [aux_sym_include_once_expression_token1] = ACTIONS(1524),
    [aux_sym_require_expression_token1] = ACTIONS(1524),
    [aux_sym_require_once_expression_token1] = ACTIONS(1524),
    [sym_comment] = ACTIONS(3),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(1526),
    [sym_name] = ACTIONS(1528),
    [anon_sym_QMARK_GT] = ACTIONS(1526),
    [anon_sym_SEMI] = ACTIONS(1526),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1528),
    [aux_sym_global_declaration_token1] = ACTIONS(1528),
    [aux_sym_namespace_definition_token1] = ACTIONS(1528),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1528),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1528),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1528),
    [anon_sym_BSLASH] = ACTIONS(1526),
    [anon_sym_LBRACE] = ACTIONS(1526),
    [anon_sym_RBRACE] = ACTIONS(1526),
    [aux_sym_trait_declaration_token1] = ACTIONS(1528),
    [aux_sym_interface_declaration_token1] = ACTIONS(1528),
    [aux_sym_enum_declaration_token1] = ACTIONS(1528),
    [aux_sym_enum_case_token1] = ACTIONS(1528),
    [aux_sym_class_declaration_token1] = ACTIONS(1528),
    [aux_sym_final_modifier_token1] = ACTIONS(1528),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1528),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1528),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1528),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1528),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1528),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1528),
    [anon_sym_LPAREN] = ACTIONS(1526),
    [aux_sym_cast_type_token1] = ACTIONS(1528),
    [aux_sym_echo_statement_token1] = ACTIONS(1528),
    [anon_sym_unset] = ACTIONS(1528),
    [aux_sym_declare_statement_token1] = ACTIONS(1528),
    [aux_sym_declare_statement_token2] = ACTIONS(1528),
    [sym_float] = ACTIONS(1528),
    [aux_sym_try_statement_token1] = ACTIONS(1528),
    [aux_sym_goto_statement_token1] = ACTIONS(1528),
    [aux_sym_continue_statement_token1] = ACTIONS(1528),
    [aux_sym_break_statement_token1] = ACTIONS(1528),
    [sym_integer] = ACTIONS(1528),
    [aux_sym_return_statement_token1] = ACTIONS(1528),
    [aux_sym_throw_expression_token1] = ACTIONS(1528),
    [aux_sym_while_statement_token1] = ACTIONS(1528),
    [aux_sym_while_statement_token2] = ACTIONS(1528),
    [aux_sym_do_statement_token1] = ACTIONS(1528),
    [aux_sym_for_statement_token1] = ACTIONS(1528),
    [aux_sym_for_statement_token2] = ACTIONS(1528),
    [aux_sym_foreach_statement_token1] = ACTIONS(1528),
    [aux_sym_foreach_statement_token2] = ACTIONS(1528),
    [aux_sym_if_statement_token1] = ACTIONS(1528),
    [aux_sym_if_statement_token2] = ACTIONS(1528),
    [aux_sym_else_if_clause_token1] = ACTIONS(1528),
    [aux_sym_else_clause_token1] = ACTIONS(1528),
    [aux_sym_match_expression_token1] = ACTIONS(1528),
    [aux_sym_match_default_expression_token1] = ACTIONS(1528),
    [aux_sym_switch_statement_token1] = ACTIONS(1528),
    [aux_sym_switch_block_token1] = ACTIONS(1528),
    [anon_sym_PLUS] = ACTIONS(1528),
    [anon_sym_DASH] = ACTIONS(1528),
    [anon_sym_TILDE] = ACTIONS(1526),
    [anon_sym_BANG] = ACTIONS(1526),
    [anon_sym_AT] = ACTIONS(1526),
    [aux_sym_clone_expression_token1] = ACTIONS(1528),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1528),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1528),
    [anon_sym_DASH_DASH] = ACTIONS(1526),
    [anon_sym_PLUS_PLUS] = ACTIONS(1526),
    [aux_sym__list_destructing_token1] = ACTIONS(1528),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_self] = ACTIONS(1528),
    [anon_sym_parent] = ACTIONS(1528),
    [aux_sym__argument_name_token1] = ACTIONS(1528),
    [aux_sym__argument_name_token2] = ACTIONS(1528),
    [anon_sym_POUND_LBRACK] = ACTIONS(1526),
    [anon_sym_SQUOTE] = ACTIONS(1526),
    [aux_sym_encapsed_string_token1] = ACTIONS(1526),
    [anon_sym_DQUOTE] = ACTIONS(1526),
    [aux_sym_string_token1] = ACTIONS(1526),
    [anon_sym_LT_LT_LT] = ACTIONS(1526),
    [anon_sym_BQUOTE] = ACTIONS(1526),
    [anon_sym_DOLLAR] = ACTIONS(1526),
    [aux_sym_yield_expression_token1] = ACTIONS(1528),
    [aux_sym_include_expression_token1] = ACTIONS(1528),
    [aux_sym_include_once_expression_token1] = ACTIONS(1528),
    [aux_sym_require_expression_token1] = ACTIONS(1528),
    [aux_sym_require_once_expression_token1] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(1530),
    [sym_name] = ACTIONS(1532),
    [anon_sym_QMARK_GT] = ACTIONS(1530),
    [anon_sym_SEMI] = ACTIONS(1530),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1532),
    [aux_sym_global_declaration_token1] = ACTIONS(1532),
    [aux_sym_namespace_definition_token1] = ACTIONS(1532),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1532),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1532),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1532),
    [anon_sym_BSLASH] = ACTIONS(1530),
    [anon_sym_LBRACE] = ACTIONS(1530),
    [anon_sym_RBRACE] = ACTIONS(1530),
    [aux_sym_trait_declaration_token1] = ACTIONS(1532),
    [aux_sym_interface_declaration_token1] = ACTIONS(1532),
    [aux_sym_enum_declaration_token1] = ACTIONS(1532),
    [aux_sym_enum_case_token1] = ACTIONS(1532),
    [aux_sym_class_declaration_token1] = ACTIONS(1532),
    [aux_sym_final_modifier_token1] = ACTIONS(1532),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1532),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1532),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1532),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1532),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1532),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1532),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [aux_sym_cast_type_token1] = ACTIONS(1532),
    [aux_sym_echo_statement_token1] = ACTIONS(1532),
    [anon_sym_unset] = ACTIONS(1532),
    [aux_sym_declare_statement_token1] = ACTIONS(1532),
    [aux_sym_declare_statement_token2] = ACTIONS(1532),
    [sym_float] = ACTIONS(1532),
    [aux_sym_try_statement_token1] = ACTIONS(1532),
    [aux_sym_goto_statement_token1] = ACTIONS(1532),
    [aux_sym_continue_statement_token1] = ACTIONS(1532),
    [aux_sym_break_statement_token1] = ACTIONS(1532),
    [sym_integer] = ACTIONS(1532),
    [aux_sym_return_statement_token1] = ACTIONS(1532),
    [aux_sym_throw_expression_token1] = ACTIONS(1532),
    [aux_sym_while_statement_token1] = ACTIONS(1532),
    [aux_sym_while_statement_token2] = ACTIONS(1532),
    [aux_sym_do_statement_token1] = ACTIONS(1532),
    [aux_sym_for_statement_token1] = ACTIONS(1532),
    [aux_sym_for_statement_token2] = ACTIONS(1532),
    [aux_sym_foreach_statement_token1] = ACTIONS(1532),
    [aux_sym_foreach_statement_token2] = ACTIONS(1532),
    [aux_sym_if_statement_token1] = ACTIONS(1532),
    [aux_sym_if_statement_token2] = ACTIONS(1532),
    [aux_sym_else_if_clause_token1] = ACTIONS(1532),
    [aux_sym_else_clause_token1] = ACTIONS(1532),
    [aux_sym_match_expression_token1] = ACTIONS(1532),
    [aux_sym_match_default_expression_token1] = ACTIONS(1532),
    [aux_sym_switch_statement_token1] = ACTIONS(1532),
    [aux_sym_switch_block_token1] = ACTIONS(1532),
    [anon_sym_PLUS] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1532),
    [anon_sym_TILDE] = ACTIONS(1530),
    [anon_sym_BANG] = ACTIONS(1530),
    [anon_sym_AT] = ACTIONS(1530),
    [aux_sym_clone_expression_token1] = ACTIONS(1532),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1532),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1532),
    [anon_sym_DASH_DASH] = ACTIONS(1530),
    [anon_sym_PLUS_PLUS] = ACTIONS(1530),
    [aux_sym__list_destructing_token1] = ACTIONS(1532),
    [anon_sym_LBRACK] = ACTIONS(1530),
    [anon_sym_self] = ACTIONS(1532),
    [anon_sym_parent] = ACTIONS(1532),
    [aux_sym__argument_name_token1] = ACTIONS(1532),
    [aux_sym__argument_name_token2] = ACTIONS(1532),
    [anon_sym_POUND_LBRACK] = ACTIONS(1530),
    [anon_sym_SQUOTE] = ACTIONS(1530),
    [aux_sym_encapsed_string_token1] = ACTIONS(1530),
    [anon_sym_DQUOTE] = ACTIONS(1530),
    [aux_sym_string_token1] = ACTIONS(1530),
    [anon_sym_LT_LT_LT] = ACTIONS(1530),
    [anon_sym_BQUOTE] = ACTIONS(1530),
    [anon_sym_DOLLAR] = ACTIONS(1530),
    [aux_sym_yield_expression_token1] = ACTIONS(1532),
    [aux_sym_include_expression_token1] = ACTIONS(1532),
    [aux_sym_include_once_expression_token1] = ACTIONS(1532),
    [aux_sym_require_expression_token1] = ACTIONS(1532),
    [aux_sym_require_once_expression_token1] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
  },
  [561] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__unary_expression] = STATE(951),
    [sym_unary_op_expression] = STATE(951),
    [sym_clone_expression] = STATE(951),
    [sym__primary_expression] = STATE(951),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(951),
    [sym_cast_variable] = STATE(594),
    [sym_member_access_expression] = STATE(594),
    [sym_nullsafe_member_access_expression] = STATE(594),
    [sym_scoped_property_access_expression] = STATE(594),
    [sym_function_call_expression] = STATE(580),
    [sym_scoped_call_expression] = STATE(580),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(580),
    [sym_nullsafe_member_call_expression] = STATE(580),
    [sym_subscript_expression] = STATE(580),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(580),
    [sym_variable_name] = STATE(580),
    [sym_include_expression] = STATE(951),
    [sym_include_once_expression] = STATE(951),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [sym_comment] = ACTIONS(3),
  },
  [562] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__unary_expression] = STATE(951),
    [sym_unary_op_expression] = STATE(951),
    [sym_clone_expression] = STATE(951),
    [sym__primary_expression] = STATE(951),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(951),
    [sym_cast_variable] = STATE(594),
    [sym_member_access_expression] = STATE(594),
    [sym_nullsafe_member_access_expression] = STATE(594),
    [sym_scoped_property_access_expression] = STATE(594),
    [sym_function_call_expression] = STATE(580),
    [sym_scoped_call_expression] = STATE(580),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(580),
    [sym_nullsafe_member_call_expression] = STATE(580),
    [sym_subscript_expression] = STATE(580),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(580),
    [sym_variable_name] = STATE(580),
    [sym_include_expression] = STATE(951),
    [sym_include_once_expression] = STATE(951),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [sym_comment] = ACTIONS(3),
  },
  [563] = {
    [sym_qualified_name] = STATE(824),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym__unary_expression] = STATE(1106),
    [sym_unary_op_expression] = STATE(1106),
    [sym_clone_expression] = STATE(1106),
    [sym__primary_expression] = STATE(1106),
    [sym_parenthesized_expression] = STATE(841),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_expression] = STATE(1106),
    [sym_cast_variable] = STATE(631),
    [sym_member_access_expression] = STATE(631),
    [sym_nullsafe_member_access_expression] = STATE(631),
    [sym_scoped_property_access_expression] = STATE(631),
    [sym_function_call_expression] = STATE(600),
    [sym_scoped_call_expression] = STATE(600),
    [sym__scope_resolution_qualifier] = STATE(2534),
    [sym_relative_scope] = STATE(2534),
    [sym_member_call_expression] = STATE(600),
    [sym_nullsafe_member_call_expression] = STATE(600),
    [sym_subscript_expression] = STATE(600),
    [sym__dereferencable_expression] = STATE(1723),
    [sym_array_creation_expression] = STATE(841),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(841),
    [sym_string] = STATE(841),
    [sym_heredoc] = STATE(841),
    [sym_nowdoc] = STATE(841),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(841),
    [sym_dynamic_variable_name] = STATE(600),
    [sym_variable_name] = STATE(600),
    [sym_include_expression] = STATE(1106),
    [sym_include_once_expression] = STATE(1106),
    [sym__reserved_identifier] = STATE(1560),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(1536),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
  },
  [564] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__unary_expression] = STATE(951),
    [sym_unary_op_expression] = STATE(951),
    [sym_clone_expression] = STATE(951),
    [sym__primary_expression] = STATE(951),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(951),
    [sym_cast_variable] = STATE(594),
    [sym_member_access_expression] = STATE(594),
    [sym_nullsafe_member_access_expression] = STATE(594),
    [sym_scoped_property_access_expression] = STATE(594),
    [sym_function_call_expression] = STATE(580),
    [sym_scoped_call_expression] = STATE(580),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(580),
    [sym_nullsafe_member_call_expression] = STATE(580),
    [sym_subscript_expression] = STATE(580),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(580),
    [sym_variable_name] = STATE(580),
    [sym_include_expression] = STATE(951),
    [sym_include_once_expression] = STATE(951),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
  },
  [565] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__unary_expression] = STATE(951),
    [sym_unary_op_expression] = STATE(951),
    [sym_clone_expression] = STATE(951),
    [sym__primary_expression] = STATE(951),
    [sym_parenthesized_expression] = STATE(703),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_expression] = STATE(951),
    [sym_cast_variable] = STATE(630),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_function_call_expression] = STATE(603),
    [sym_scoped_call_expression] = STATE(603),
    [sym__scope_resolution_qualifier] = STATE(2553),
    [sym_relative_scope] = STATE(2553),
    [sym_member_call_expression] = STATE(603),
    [sym_nullsafe_member_call_expression] = STATE(603),
    [sym_subscript_expression] = STATE(603),
    [sym__dereferencable_expression] = STATE(1688),
    [sym_array_creation_expression] = STATE(703),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(703),
    [sym_string] = STATE(703),
    [sym_heredoc] = STATE(703),
    [sym_nowdoc] = STATE(703),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(703),
    [sym_dynamic_variable_name] = STATE(603),
    [sym_variable_name] = STATE(603),
    [sym_include_expression] = STATE(951),
    [sym_include_once_expression] = STATE(951),
    [sym__reserved_identifier] = STATE(1586),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(853),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
  },
  [566] = {
    [sym_name] = ACTIONS(1538),
    [anon_sym_SEMI] = ACTIONS(1540),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1538),
    [aux_sym_global_declaration_token1] = ACTIONS(1538),
    [aux_sym_namespace_definition_token1] = ACTIONS(1538),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1538),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1538),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1538),
    [anon_sym_BSLASH] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(1540),
    [aux_sym_trait_declaration_token1] = ACTIONS(1538),
    [aux_sym_interface_declaration_token1] = ACTIONS(1538),
    [aux_sym_enum_declaration_token1] = ACTIONS(1538),
    [anon_sym_COLON] = ACTIONS(1540),
    [aux_sym_class_declaration_token1] = ACTIONS(1538),
    [aux_sym_final_modifier_token1] = ACTIONS(1538),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1538),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1538),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1538),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1538),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1538),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1538),
    [anon_sym_LPAREN] = ACTIONS(1540),
    [aux_sym_cast_type_token1] = ACTIONS(1538),
    [aux_sym_echo_statement_token1] = ACTIONS(1538),
    [anon_sym_unset] = ACTIONS(1538),
    [aux_sym_declare_statement_token1] = ACTIONS(1538),
    [sym_float] = ACTIONS(1538),
    [aux_sym_try_statement_token1] = ACTIONS(1538),
    [aux_sym_goto_statement_token1] = ACTIONS(1538),
    [aux_sym_continue_statement_token1] = ACTIONS(1538),
    [aux_sym_break_statement_token1] = ACTIONS(1538),
    [sym_integer] = ACTIONS(1538),
    [aux_sym_return_statement_token1] = ACTIONS(1538),
    [aux_sym_throw_expression_token1] = ACTIONS(1538),
    [aux_sym_while_statement_token1] = ACTIONS(1538),
    [aux_sym_do_statement_token1] = ACTIONS(1538),
    [aux_sym_for_statement_token1] = ACTIONS(1538),
    [aux_sym_foreach_statement_token1] = ACTIONS(1538),
    [aux_sym_if_statement_token1] = ACTIONS(1538),
    [aux_sym_match_expression_token1] = ACTIONS(1538),
    [aux_sym_switch_statement_token1] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1538),
    [anon_sym_DASH] = ACTIONS(1538),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_AT] = ACTIONS(1540),
    [aux_sym_clone_expression_token1] = ACTIONS(1538),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1538),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1538),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [aux_sym__list_destructing_token1] = ACTIONS(1538),
    [anon_sym_LBRACK] = ACTIONS(1540),
    [anon_sym_self] = ACTIONS(1538),
    [anon_sym_parent] = ACTIONS(1538),
    [aux_sym__argument_name_token1] = ACTIONS(1538),
    [aux_sym__argument_name_token2] = ACTIONS(1538),
    [anon_sym_POUND_LBRACK] = ACTIONS(1540),
    [anon_sym_SQUOTE] = ACTIONS(1540),
    [aux_sym_encapsed_string_token1] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [aux_sym_string_token1] = ACTIONS(1540),
    [anon_sym_LT_LT_LT] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [aux_sym_yield_expression_token1] = ACTIONS(1538),
    [aux_sym_include_expression_token1] = ACTIONS(1538),
    [aux_sym_include_once_expression_token1] = ACTIONS(1538),
    [aux_sym_require_expression_token1] = ACTIONS(1538),
    [aux_sym_require_once_expression_token1] = ACTIONS(1538),
    [sym_comment] = ACTIONS(3),
  },
  [567] = {
    [sym_qualified_name] = STATE(685),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2455),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__primary_expression] = STATE(958),
    [sym_parenthesized_expression] = STATE(689),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_variable] = STATE(711),
    [sym_member_access_expression] = STATE(711),
    [sym_nullsafe_member_access_expression] = STATE(711),
    [sym_scoped_property_access_expression] = STATE(711),
    [sym_function_call_expression] = STATE(655),
    [sym_scoped_call_expression] = STATE(655),
    [sym__scope_resolution_qualifier] = STATE(2660),
    [sym_relative_scope] = STATE(2660),
    [sym_member_call_expression] = STATE(655),
    [sym_nullsafe_member_call_expression] = STATE(655),
    [sym_subscript_expression] = STATE(655),
    [sym__dereferencable_expression] = STATE(1721),
    [sym_array_creation_expression] = STATE(689),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(689),
    [sym_string] = STATE(689),
    [sym_heredoc] = STATE(689),
    [sym_nowdoc] = STATE(689),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(689),
    [sym_dynamic_variable_name] = STATE(655),
    [sym_variable_name] = STATE(655),
    [sym__reserved_identifier] = STATE(1582),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(1542),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(1546),
    [sym_comment] = ACTIONS(3),
  },
  [568] = {
    [sym_qualified_name] = STATE(838),
    [sym_namespace_name_as_prefix] = STATE(2551),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2542),
    [sym_arrow_function] = STATE(1123),
    [sym_throw_expression] = STATE(1123),
    [sym__primary_expression] = STATE(1102),
    [sym_parenthesized_expression] = STATE(840),
    [sym_class_constant_access_expression] = STATE(900),
    [sym_print_intrinsic] = STATE(1123),
    [sym_anonymous_function_creation_expression] = STATE(1123),
    [sym_object_creation_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_cast_variable] = STATE(826),
    [sym_member_access_expression] = STATE(826),
    [sym_nullsafe_member_access_expression] = STATE(826),
    [sym_scoped_property_access_expression] = STATE(826),
    [sym_function_call_expression] = STATE(764),
    [sym_scoped_call_expression] = STATE(764),
    [sym__scope_resolution_qualifier] = STATE(2580),
    [sym_relative_scope] = STATE(2580),
    [sym_member_call_expression] = STATE(764),
    [sym_nullsafe_member_call_expression] = STATE(764),
    [sym_subscript_expression] = STATE(764),
    [sym__dereferencable_expression] = STATE(1701),
    [sym_array_creation_expression] = STATE(840),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1809),
    [sym_encapsed_string] = STATE(840),
    [sym_string] = STATE(840),
    [sym_heredoc] = STATE(840),
    [sym_nowdoc] = STATE(840),
    [sym_shell_command_expression] = STATE(1123),
    [sym_boolean] = STATE(1123),
    [sym_null] = STATE(1123),
    [sym__string] = STATE(840),
    [sym_dynamic_variable_name] = STATE(764),
    [sym_variable_name] = STATE(764),
    [sym__reserved_identifier] = STATE(1579),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(1548),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1550),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(1536),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(113),
    [aux_sym_encapsed_string_token1] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(115),
    [aux_sym_string_token1] = ACTIONS(113),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(1552),
    [sym_comment] = ACTIONS(3),
  },
  [569] = {
    [sym_qualified_name] = STATE(685),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2556),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__primary_expression] = STATE(958),
    [sym_parenthesized_expression] = STATE(689),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_variable] = STATE(711),
    [sym_member_access_expression] = STATE(711),
    [sym_nullsafe_member_access_expression] = STATE(711),
    [sym_scoped_property_access_expression] = STATE(711),
    [sym_function_call_expression] = STATE(655),
    [sym_scoped_call_expression] = STATE(655),
    [sym__scope_resolution_qualifier] = STATE(2660),
    [sym_relative_scope] = STATE(2660),
    [sym_member_call_expression] = STATE(655),
    [sym_nullsafe_member_call_expression] = STATE(655),
    [sym_subscript_expression] = STATE(655),
    [sym__dereferencable_expression] = STATE(1721),
    [sym_array_creation_expression] = STATE(689),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(689),
    [sym_string] = STATE(689),
    [sym_heredoc] = STATE(689),
    [sym_nowdoc] = STATE(689),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(689),
    [sym_dynamic_variable_name] = STATE(655),
    [sym_variable_name] = STATE(655),
    [sym__reserved_identifier] = STATE(1582),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(1542),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(1546),
    [sym_comment] = ACTIONS(3),
  },
  [570] = {
    [sym_qualified_name] = STATE(685),
    [sym_namespace_name_as_prefix] = STATE(2558),
    [sym_namespace_name] = STATE(2549),
    [sym_static_modifier] = STATE(2546),
    [sym__arrow_function_header] = STATE(2522),
    [sym_arrow_function] = STATE(908),
    [sym_throw_expression] = STATE(908),
    [sym__primary_expression] = STATE(958),
    [sym_parenthesized_expression] = STATE(689),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(908),
    [sym_anonymous_function_creation_expression] = STATE(908),
    [sym_object_creation_expression] = STATE(908),
    [sym_update_expression] = STATE(908),
    [sym_cast_variable] = STATE(711),
    [sym_member_access_expression] = STATE(711),
    [sym_nullsafe_member_access_expression] = STATE(711),
    [sym_scoped_property_access_expression] = STATE(711),
    [sym_function_call_expression] = STATE(655),
    [sym_scoped_call_expression] = STATE(655),
    [sym__scope_resolution_qualifier] = STATE(2660),
    [sym_relative_scope] = STATE(2660),
    [sym_member_call_expression] = STATE(655),
    [sym_nullsafe_member_call_expression] = STATE(655),
    [sym_subscript_expression] = STATE(655),
    [sym__dereferencable_expression] = STATE(1721),
    [sym_array_creation_expression] = STATE(689),
    [sym_attribute_group] = STATE(1351),
    [sym_attribute_list] = STATE(1888),
    [sym_encapsed_string] = STATE(689),
    [sym_string] = STATE(689),
    [sym_heredoc] = STATE(689),
    [sym_nowdoc] = STATE(689),
    [sym_shell_command_expression] = STATE(908),
    [sym_boolean] = STATE(908),
    [sym_null] = STATE(908),
    [sym__string] = STATE(689),
    [sym_dynamic_variable_name] = STATE(655),
    [sym_variable_name] = STATE(655),
    [sym__reserved_identifier] = STATE(1582),
    [aux_sym_attribute_list_repeat1] = STATE(1351),
    [sym_name] = ACTIONS(1542),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [anon_sym_SQUOTE] = ACTIONS(601),
    [aux_sym_encapsed_string_token1] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(603),
    [aux_sym_string_token1] = ACTIONS(601),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(1546),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1554), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_base_clause_token1,
      aux_sym_class_interface_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [70] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1558), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_base_clause_token1,
      aux_sym_class_interface_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1562), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_base_clause_token1,
      aux_sym_class_interface_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1566), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_base_clause_token1,
      aux_sym_class_interface_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [280] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(591), 1,
      sym_arguments,
    ACTIONS(1572), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1570), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(581), 1,
      sym_arguments,
    ACTIONS(1578), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1576), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [426] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(1582), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1580), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [499] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(584), 1,
      sym_arguments,
    ACTIONS(1586), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1584), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1590), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1588), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [645] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1596), 1,
      anon_sym_EQ,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1602), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1594), 20,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1604), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1608), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1612), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1616), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1620), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1624), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1628), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1632), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1636), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1640), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1644), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1648), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1654), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1652), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1610] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1596), 1,
      anon_sym_EQ,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1602), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1594), 20,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1685] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1656), 1,
      anon_sym_EQ,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1658), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 16,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1594), 20,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1764] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1660), 1,
      anon_sym_EQ,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1662), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1842] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    STATE(613), 1,
      sym_arguments,
    ACTIONS(1590), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1588), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1911] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    ACTIONS(1666), 1,
      anon_sym_EQ,
    STATE(627), 1,
      sym_arguments,
    ACTIONS(1668), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1670), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1988] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    STATE(618), 1,
      sym_arguments,
    ACTIONS(1582), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1580), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2057] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1596), 1,
      anon_sym_EQ,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    STATE(627), 1,
      sym_arguments,
    ACTIONS(1668), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1602), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2134] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(851), 1,
      anon_sym_COMMA,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1656), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_RPAREN,
    STATE(592), 1,
      sym_arguments,
    STATE(2099), 1,
      aux_sym__list_destructing_repeat1,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1658), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2217] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    STATE(623), 1,
      sym_arguments,
    ACTIONS(1586), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1584), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2286] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1596), 1,
      anon_sym_EQ,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1602), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_RBRACK,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2363] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    STATE(615), 1,
      sym_arguments,
    ACTIONS(1578), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1576), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2432] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    STATE(617), 1,
      sym_arguments,
    ACTIONS(1572), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1570), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2501] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1656), 1,
      anon_sym_EQ,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1658), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 16,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1594), 20,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1628), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2638] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1674), 1,
      anon_sym_EQ,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1676), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 14,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2714] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1656), 1,
      anon_sym_EQ,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1678), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1658), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1632), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1654), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1652), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1620), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1608), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1566), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1604), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1612), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1644), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1624), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1640), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1562), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3496] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1656), 1,
      anon_sym_EQ,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1680), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1658), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3574] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1660), 1,
      anon_sym_EQ,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1662), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1616), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1636), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3774] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1660), 1,
      anon_sym_EQ,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1682), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1662), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1554), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1648), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1558), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [4044] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(851), 1,
      anon_sym_COMMA,
    ACTIONS(1656), 1,
      anon_sym_EQ,
    ACTIONS(1672), 1,
      anon_sym_RPAREN,
    STATE(2099), 1,
      aux_sym__list_destructing_repeat1,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1658), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4121] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1596), 1,
      anon_sym_EQ,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1602), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_RBRACK,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4192] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1596), 1,
      anon_sym_EQ,
    ACTIONS(1668), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1602), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4263] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_EQ,
    ACTIONS(1668), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1670), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4334] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1660), 1,
      anon_sym_EQ,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1685), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 11,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1662), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4411] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1674), 1,
      anon_sym_EQ,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1676), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 14,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4481] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1660), 1,
      anon_sym_EQ,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1682), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1662), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4553] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1656), 1,
      anon_sym_EQ,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1680), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1658), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4625] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1656), 1,
      anon_sym_EQ,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1678), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1658), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4697] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1660), 1,
      anon_sym_EQ,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1685), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 11,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1662), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1594), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1688), 21,
      anon_sym_AMP,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_COLON,
      aux_sym_class_interface_clause_token1,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_self,
      anon_sym_parent,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      sym_name,
    ACTIONS(1690), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4826] = 25,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(39), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(41), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1694), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(1696), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(1700), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(1702), 1,
      sym_var_modifier,
    ACTIONS(1706), 1,
      anon_sym_LPAREN,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1710), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1696), 1,
      sym_variable_name,
    STATE(1868), 1,
      sym_property_element,
    STATE(1871), 1,
      sym__function_definition_header,
    STATE(1967), 1,
      sym__type,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(1704), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1015), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [4927] = 25,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(39), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(41), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1694), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(1696), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(1700), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(1702), 1,
      sym_var_modifier,
    ACTIONS(1706), 1,
      anon_sym_LPAREN,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1710), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1696), 1,
      sym_variable_name,
    STATE(1854), 1,
      sym_property_element,
    STATE(1855), 1,
      sym__function_definition_header,
    STATE(1992), 1,
      sym__type,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(1704), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1015), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [5028] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_LPAREN,
    STATE(680), 1,
      sym_arguments,
    ACTIONS(1578), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1576), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [5087] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_LPAREN,
    STATE(678), 1,
      sym_arguments,
    ACTIONS(1572), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1570), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [5146] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_LPAREN,
    STATE(669), 1,
      sym_arguments,
    ACTIONS(1582), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1580), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [5205] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_LPAREN,
    STATE(673), 1,
      sym_arguments,
    ACTIONS(1586), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1584), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [5264] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_LPAREN,
    STATE(666), 1,
      sym_arguments,
    ACTIONS(1590), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1588), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [5323] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    STATE(592), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1718), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [5388] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1725), 1,
      anon_sym_COMMA,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1729), 1,
      anon_sym_RPAREN,
    ACTIONS(1731), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(959), 1,
      sym_attribute_list,
    STATE(1167), 1,
      sym_visibility_modifier,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1665), 1,
      sym__type,
    STATE(2160), 1,
      sym_variable_name,
    STATE(2173), 1,
      sym_reference_modifier,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2607), 1,
      sym_namespace_name_as_prefix,
    STATE(1314), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2167), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    STATE(1587), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [5489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 12,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1612), 35,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_class_interface_clause_token1,
      aux_sym_use_instead_of_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [5544] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_LPAREN,
    STATE(664), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1596), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1602), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [5605] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1731), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(1739), 1,
      anon_sym_COMMA,
    ACTIONS(1741), 1,
      anon_sym_RPAREN,
    STATE(959), 1,
      sym_attribute_list,
    STATE(1167), 1,
      sym_visibility_modifier,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1665), 1,
      sym__type,
    STATE(2160), 1,
      sym_variable_name,
    STATE(2173), 1,
      sym_reference_modifier,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2607), 1,
      sym_namespace_name_as_prefix,
    STATE(1314), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1958), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    STATE(1587), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [5706] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    STATE(592), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [5771] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_LPAREN,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    STATE(664), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [5836] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(759), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1745), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1743), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [5901] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_LPAREN,
    STATE(664), 1,
      sym_arguments,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [5964] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1731), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(1749), 1,
      anon_sym_RPAREN,
    STATE(959), 1,
      sym_attribute_list,
    STATE(1167), 1,
      sym_visibility_modifier,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1665), 1,
      sym__type,
    STATE(2160), 1,
      sym_variable_name,
    STATE(2173), 1,
      sym_reference_modifier,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2607), 1,
      sym_namespace_name_as_prefix,
    STATE(1314), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2265), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    STATE(1587), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [6062] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1731), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(1751), 1,
      anon_sym_RPAREN,
    STATE(959), 1,
      sym_attribute_list,
    STATE(1167), 1,
      sym_visibility_modifier,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1665), 1,
      sym__type,
    STATE(2160), 1,
      sym_variable_name,
    STATE(2173), 1,
      sym_reference_modifier,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2607), 1,
      sym_namespace_name_as_prefix,
    STATE(1314), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2265), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    STATE(1587), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [6160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1640), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [6214] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1753), 1,
      sym_name,
    ACTIONS(1755), 1,
      aux_sym_class_declaration_token1,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1759), 1,
      anon_sym_DOLLAR,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(2561), 1,
      sym_attribute_list,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(709), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    STATE(2662), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(707), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(708), 3,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1725), 3,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym__dereferencable_expression,
    STATE(1547), 11,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [6310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1654), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1652), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [6364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1628), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [6418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1554), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [6472] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1731), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(1761), 1,
      anon_sym_RPAREN,
    STATE(959), 1,
      sym_attribute_list,
    STATE(1167), 1,
      sym_visibility_modifier,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1665), 1,
      sym__type,
    STATE(2160), 1,
      sym_variable_name,
    STATE(2173), 1,
      sym_reference_modifier,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2607), 1,
      sym_namespace_name_as_prefix,
    STATE(1314), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2265), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    STATE(1587), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [6570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1648), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [6624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1562), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [6678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1608), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [6732] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1763), 1,
      sym_name,
    ACTIONS(1767), 1,
      aux_sym_class_declaration_token1,
    ACTIONS(1769), 1,
      anon_sym_DOLLAR,
    STATE(2477), 1,
      sym_attribute_list,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2551), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(820), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    STATE(2610), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(1765), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(818), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(819), 3,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1731), 3,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym__dereferencable_expression,
    STATE(1547), 11,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [6828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1636), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [6882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1624), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [6936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1620), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [6990] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1731), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(1771), 1,
      anon_sym_RPAREN,
    STATE(959), 1,
      sym_attribute_list,
    STATE(1167), 1,
      sym_visibility_modifier,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1665), 1,
      sym__type,
    STATE(2160), 1,
      sym_variable_name,
    STATE(2173), 1,
      sym_reference_modifier,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2607), 1,
      sym_namespace_name_as_prefix,
    STATE(1314), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2265), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    STATE(1587), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [7088] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(1775), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1773), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_use_instead_of_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [7146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1616), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [7200] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(588), 1,
      sym_arguments,
    ACTIONS(1779), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1777), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_use_instead_of_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [7258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1566), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [7312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1558), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [7366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1612), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [7420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1644), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [7474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1632), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [7528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1604), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [7582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1596), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1602), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [7637] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [7696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(1582), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1580), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [7753] = 22,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1781), 1,
      sym_name,
    ACTIONS(1787), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1790), 1,
      anon_sym_BSLASH,
    ACTIONS(1793), 1,
      anon_sym_RBRACE,
    ACTIONS(1795), 1,
      anon_sym_LPAREN,
    ACTIONS(1798), 1,
      aux_sym_cast_type_token1,
    ACTIONS(1801), 1,
      anon_sym_LBRACK,
    ACTIONS(1810), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1813), 1,
      anon_sym_DOLLAR,
    STATE(684), 1,
      aux_sym_use_list_repeat1,
    STATE(1566), 1,
      sym_class_constant_access_expression,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(1804), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(1807), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1586), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2385), 2,
      sym_use_instead_of_clause,
      sym_use_as_clause,
    STATE(2553), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(1784), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1732), 5,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
      sym__dereferencable_expression,
    STATE(1547), 14,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
      sym_dynamic_variable_name,
      sym_variable_name,
  [7844] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_LPAREN,
    STATE(664), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [7903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(1582), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1580), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [7958] = 24,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(101), 1,
      aux_sym__list_destructing_token1,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(731), 1,
      anon_sym_AMP,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1816), 1,
      sym_name,
    STATE(1957), 1,
      sym__list_destructing,
    STATE(2008), 1,
      sym_by_ref,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1586), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1732), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2553), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1544), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1461), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1547), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [8053] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(746), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1820), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1818), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [8112] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_LPAREN,
    STATE(664), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [8171] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1590), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1588), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [8228] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1718), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [8287] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(581), 1,
      sym_arguments,
    ACTIONS(1578), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1576), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [8344] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1718), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [8403] = 24,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(101), 1,
      aux_sym__list_destructing_token1,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(731), 1,
      anon_sym_AMP,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1816), 1,
      sym_name,
    STATE(2436), 1,
      sym_by_ref,
    STATE(2439), 1,
      sym__list_destructing,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1586), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1732), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2553), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1575), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1524), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1547), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [8498] = 22,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1822), 1,
      sym_name,
    ACTIONS(1824), 1,
      anon_sym_RBRACE,
    STATE(684), 1,
      aux_sym_use_list_repeat1,
    STATE(1566), 1,
      sym_class_constant_access_expression,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1586), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2385), 2,
      sym_use_instead_of_clause,
      sym_use_as_clause,
    STATE(2553), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1732), 5,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
      sym__dereferencable_expression,
    STATE(1547), 14,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
      sym_dynamic_variable_name,
      sym_variable_name,
  [8589] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(591), 1,
      sym_arguments,
    ACTIONS(1572), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1570), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [8646] = 22,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1822), 1,
      sym_name,
    ACTIONS(1826), 1,
      anon_sym_RBRACE,
    STATE(695), 1,
      aux_sym_use_list_repeat1,
    STATE(1566), 1,
      sym_class_constant_access_expression,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1586), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2385), 2,
      sym_use_instead_of_clause,
      sym_use_as_clause,
    STATE(2553), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1732), 5,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
      sym__dereferencable_expression,
    STATE(1547), 14,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
      sym_dynamic_variable_name,
      sym_variable_name,
  [8737] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_LPAREN,
    STATE(669), 1,
      sym_arguments,
    ACTIONS(1775), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1773), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [8794] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1731), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(959), 1,
      sym_attribute_list,
    STATE(1167), 1,
      sym_visibility_modifier,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1665), 1,
      sym__type,
    STATE(2160), 1,
      sym_variable_name,
    STATE(2173), 1,
      sym_reference_modifier,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2607), 1,
      sym_namespace_name_as_prefix,
    STATE(1314), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2265), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    STATE(1587), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [8889] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(584), 1,
      sym_arguments,
    ACTIONS(1586), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1584), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [8946] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_LPAREN,
    STATE(679), 1,
      sym_arguments,
    ACTIONS(1779), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1777), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9003] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1835), 1,
      anon_sym_EQ,
    ACTIONS(1832), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1830), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1828), 31,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9060] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9119] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(746), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1839), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1837), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9178] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(732), 1,
      sym_arguments,
    ACTIONS(1572), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1570), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(733), 1,
      sym_arguments,
    ACTIONS(1578), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1576), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9292] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(759), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1745), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1743), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9351] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1841), 1,
      anon_sym_LPAREN,
    STATE(964), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1745), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1743), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9410] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(759), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1745), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1743), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9469] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(737), 1,
      sym_arguments,
    ACTIONS(1590), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1588), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9526] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1600), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9583] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(738), 1,
      sym_arguments,
    ACTIONS(1586), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1584), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9640] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(740), 1,
      sym_arguments,
    ACTIONS(1582), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1580), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(591), 1,
      sym_arguments,
    ACTIONS(1572), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1570), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(581), 1,
      sym_arguments,
    ACTIONS(1578), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1576), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9807] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(746), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1596), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1602), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1590), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1588), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(584), 1,
      sym_arguments,
    ACTIONS(1586), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1584), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [9976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1845), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1843), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1654), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1652), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1562), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1566), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1628), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1554), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1640), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1540), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1849), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1847), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1614), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1612), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1558), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1855), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1853), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1857), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1644), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1604), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1632), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1861), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1865), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1608), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [10966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1616), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1620), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1624), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1869), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1875), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1873), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1877), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1636), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1881), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1648), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1887), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1885), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1889), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1895), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1893), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1899), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1897), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1903), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1901), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1905), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1911), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1909), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1913), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1919), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1917), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1923), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1921), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [11954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1828), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12006] = 23,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(731), 1,
      anon_sym_AMP,
    ACTIONS(859), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1816), 1,
      sym_name,
    STATE(2248), 1,
      sym_by_ref,
    STATE(2255), 1,
      sym__array_destructing,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1586), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1732), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2553), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1558), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1507), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1547), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [12098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1648), 6,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1927), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1925), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1028), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1026), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12203] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    STATE(627), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12264] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(861), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1745), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1743), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12325] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1596), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1602), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12378] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(788), 1,
      sym_arguments,
    ACTIONS(1668), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1718), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12490] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(788), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1596), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1602), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12547] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(788), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1820), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1818), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1935), 18,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LBRACK,
      anon_sym_POUND_LBRACK,
      anon_sym_SQUOTE,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
      aux_sym_string_token1,
      anon_sym_LT_LT_LT,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
    ACTIONS(1933), 25,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym__arrow_function_header_token1,
      aux_sym_cast_type_token1,
      sym_float,
      sym_integer,
      aux_sym_throw_expression_token1,
      aux_sym_match_expression_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_clone_expression_token1,
      aux_sym_print_intrinsic_token1,
      aux_sym_object_creation_expression_token1,
      aux_sym__list_destructing_token1,
      anon_sym_self,
      anon_sym_parent,
      aux_sym__argument_name_token1,
      aux_sym__argument_name_token2,
      aux_sym_yield_expression_token1,
      aux_sym_include_expression_token1,
      aux_sym_include_once_expression_token1,
      aux_sym_require_expression_token1,
      aux_sym_require_once_expression_token1,
      sym_name,
  [12712] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1832), 1,
      anon_sym_RPAREN,
    ACTIONS(1835), 1,
      anon_sym_EQ,
    ACTIONS(1830), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1828), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1022), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12871] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    STATE(592), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1718), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1839), 11,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1837), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [12985] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(789), 1,
      sym_arguments,
    ACTIONS(1590), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1588), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(784), 1,
      sym_arguments,
    ACTIONS(1578), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1576), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13095] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(782), 1,
      sym_arguments,
    ACTIONS(1572), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1570), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13150] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(794), 1,
      sym_arguments,
    ACTIONS(1582), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1580), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13205] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(792), 1,
      sym_arguments,
    ACTIONS(1586), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1584), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13260] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    ACTIONS(1937), 1,
      anon_sym_COLON,
    STATE(627), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 22,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1632), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1644), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1554), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1604), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1558), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1562), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1636), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1648), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1608), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1654), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1652), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1628), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1616), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1620), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [13972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1624), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [14022] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    ACTIONS(1939), 1,
      anon_sym_COLON,
    STATE(592), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 22,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [14084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1566), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [14134] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    ACTIONS(1941), 1,
      anon_sym_COLON,
    STATE(627), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 22,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [14196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1945), 17,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LBRACK,
      anon_sym_POUND_LBRACK,
      anon_sym_SQUOTE,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
      aux_sym_string_token1,
      anon_sym_LT_LT_LT,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
    ACTIONS(1943), 25,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym__arrow_function_header_token1,
      aux_sym_cast_type_token1,
      sym_float,
      sym_integer,
      aux_sym_throw_expression_token1,
      aux_sym_match_expression_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_clone_expression_token1,
      aux_sym_print_intrinsic_token1,
      aux_sym_object_creation_expression_token1,
      aux_sym__list_destructing_token1,
      anon_sym_self,
      anon_sym_parent,
      aux_sym__argument_name_token1,
      aux_sym__argument_name_token2,
      aux_sym_yield_expression_token1,
      aux_sym_include_expression_token1,
      aux_sym_include_once_expression_token1,
      aux_sym_require_expression_token1,
      aux_sym_require_once_expression_token1,
      sym_name,
  [14246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1640), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [14296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1612), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [14346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1596), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1602), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [14397] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1759), 1,
      anon_sym_DOLLAR,
    ACTIONS(1947), 1,
      sym_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(693), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2608), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(691), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(765), 3,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1734), 3,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym__dereferencable_expression,
    STATE(1547), 11,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [14480] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1769), 1,
      anon_sym_DOLLAR,
    ACTIONS(1949), 1,
      sym_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2551), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(811), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2628), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(1765), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(809), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(896), 3,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1671), 3,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym__dereferencable_expression,
    STATE(1547), 11,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [14563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1128), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1126), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [14612] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(862), 1,
      sym_arguments,
    ACTIONS(1578), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1576), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [14665] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    STATE(618), 1,
      sym_arguments,
    ACTIONS(1775), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1773), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [14718] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(867), 1,
      sym_arguments,
    ACTIONS(1572), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1570), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [14771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1835), 1,
      anon_sym_EQ,
    ACTIONS(1830), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1828), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [14822] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1718), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [14877] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1816), 1,
      sym_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(768), 2,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
    STATE(1586), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2553), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1732), 4,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym_scoped_property_access_expression,
      sym__dereferencable_expression,
    STATE(1447), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1547), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [14960] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1718), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1590), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1588), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(584), 1,
      sym_arguments,
    ACTIONS(1586), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1584), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15117] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(1582), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1580), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15168] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(892), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1839), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1837), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15223] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    STATE(610), 1,
      sym_arguments,
    ACTIONS(1779), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1777), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15276] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_DOLLAR,
    ACTIONS(1951), 1,
      sym_name,
    ACTIONS(1953), 1,
      anon_sym_LPAREN,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1590), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1727), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2639), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(763), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(716), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1577), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [15359] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(861), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1745), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1743), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15414] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1955), 1,
      anon_sym_LPAREN,
    STATE(1124), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1745), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1743), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(861), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1745), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1743), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15524] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(892), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1596), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1602), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15579] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1544), 1,
      anon_sym_LPAREN,
    ACTIONS(1546), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1957), 1,
      sym_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1582), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1721), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2660), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(681), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(650), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1583), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [15662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(581), 1,
      sym_arguments,
    ACTIONS(1578), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1576), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15713] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    STATE(627), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1064), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1062), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15817] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1668), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15870] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(892), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1820), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1818), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1688), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1690), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [15974] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1769), 1,
      anon_sym_DOLLAR,
    ACTIONS(1959), 1,
      sym_name,
    ACTIONS(1961), 1,
      anon_sym_LPAREN,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1574), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1680), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2632), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(898), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(821), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1565), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [16057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(865), 1,
      sym_arguments,
    ACTIONS(1590), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1588), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [16110] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(876), 1,
      sym_arguments,
    ACTIONS(1586), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1584), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [16163] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1816), 1,
      sym_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1586), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1732), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2553), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1539), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1464), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1547), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [16246] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_DOLLAR,
    ACTIONS(1951), 1,
      sym_name,
    ACTIONS(1953), 1,
      anon_sym_LPAREN,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1590), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1727), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2639), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(774), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(704), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1577), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [16329] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1759), 1,
      anon_sym_DOLLAR,
    ACTIONS(1951), 1,
      sym_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(768), 2,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
    STATE(1590), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2524), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1727), 4,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym_scoped_property_access_expression,
      sym__dereferencable_expression,
    STATE(688), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1577), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [16412] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1552), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1963), 1,
      sym_name,
    ACTIONS(1965), 1,
      anon_sym_LPAREN,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1579), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1701), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2603), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(801), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(766), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1549), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [16495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(591), 1,
      sym_arguments,
    ACTIONS(1572), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1570), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [16546] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1769), 1,
      anon_sym_DOLLAR,
    ACTIONS(1959), 1,
      sym_name,
    ACTIONS(1961), 1,
      anon_sym_LPAREN,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1574), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1680), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2632), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(897), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(815), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1565), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [16629] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(788), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [16684] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(880), 1,
      sym_arguments,
    ACTIONS(1582), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1580), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [16737] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(788), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [16792] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    STATE(627), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [16847] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1816), 1,
      sym_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1586), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1732), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2553), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1554), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1510), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1547), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [16930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1612), 31,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [16979] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1769), 1,
      anon_sym_DOLLAR,
    ACTIONS(1959), 1,
      sym_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(899), 2,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
    STATE(1574), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2458), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1680), 4,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym_scoped_property_access_expression,
      sym__dereferencable_expression,
    STATE(827), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1565), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [17062] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(591), 1,
      sym_arguments,
    ACTIONS(1572), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1570), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17115] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(581), 1,
      sym_arguments,
    ACTIONS(1578), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1576), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1590), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1588), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(794), 1,
      sym_arguments,
    ACTIONS(1775), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1773), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17274] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1816), 1,
      sym_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1586), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1732), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2553), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(681), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1453), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1547), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [17357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(584), 1,
      sym_arguments,
    ACTIONS(1586), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1584), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(1582), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1580), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17463] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1757), 1,
      anon_sym_LPAREN,
    ACTIONS(1816), 1,
      sym_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(1586), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1732), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2553), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1535), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1452), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1547), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [17546] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(781), 1,
      sym_arguments,
    ACTIONS(1779), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1777), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1640), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1861), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1828), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1632), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1857), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1903), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1901), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1919), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1917), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1648), 6,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1927), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1925), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [17985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1604), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1540), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1849), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1847), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1608), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1554), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1644), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1636), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1877), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1915), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1913), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1923), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1921), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18465] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1835), 1,
      anon_sym_EQ,
    ACTIONS(1967), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1830), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1828), 27,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1845), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1843), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1875), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1873), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1911), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1909), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1616), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1905), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1620), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1869), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1624), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1566), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1855), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1853), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [18997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1895), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1893), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1899), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1897), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1562), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1865), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1614), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1612), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1835), 1,
      anon_sym_EQ,
    ACTIONS(1830), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1828), 29,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1628), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1881), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1654), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1652), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1648), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1889), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1887), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1885), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1558), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1718), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1839), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1837), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1596), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1602), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1820), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1818), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1969), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1975), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1973), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [19962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1977), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1983), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1981), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1985), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1989), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1993), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1594), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1997), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2001), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2007), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2005), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2009), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2013), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2019), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2017), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2021), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2025), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2029), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2033), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2039), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2037), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2043), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2041), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2047), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2045), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2049), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2055), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2053), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2059), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2057), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [20974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2061), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2067), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2065), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2071), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2069), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2075), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2073), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2079), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2077), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1558), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1566), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2083), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2081), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1562), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1554), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2087), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2085), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2091), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2089), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2095), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2093), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2099), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2097), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2103), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2101), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2107), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2105), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2111), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2109), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2115), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2113), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2119), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2117), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2123), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2121), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2127), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2125), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2129), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(2127), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2125), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [21988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2131), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2135), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2141), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2139), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2145), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2143), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2149), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2147), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2151), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2157), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2155), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2161), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2159), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2163), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2169), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2167), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2173), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2171), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2177), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2175), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22540] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(2179), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1137), 1,
      sym_visibility_modifier,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1687), 1,
      sym__type,
    STATE(1926), 1,
      sym_reference_modifier,
    STATE(2074), 1,
      sym_variable_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2607), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1587), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [22620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2181), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2187), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2185), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2189), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2193), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1927), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1925), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2199), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2197), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1064), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1062), 27,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1128), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1126), 27,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [22986] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2201), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [23068] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2243), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [23150] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [23226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1718), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 26,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [23272] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [23348] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 24,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [23398] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(1718), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 13,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [23466] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 14,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [23530] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2245), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [23612] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2247), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [23694] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(1718), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 14,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [23760] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1718), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1716), 18,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23820] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 19,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [23876] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 22,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [23928] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 8,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
  [24008] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 13,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [24078] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2249), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [24160] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2251), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [24242] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 20,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DOT,
  [24296] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2253), 1,
      anon_sym_EQ_GT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2143), 6,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [24380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1718), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 26,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [24426] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2255), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [24508] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2257), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [24590] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2259), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [24666] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2261), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [24742] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2131), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [24824] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2263), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [24906] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2267), 1,
      anon_sym_QMARK,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2265), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [24982] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2269), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [25058] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2273), 1,
      anon_sym_QMARK,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2271), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [25134] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 12,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
  [25206] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 9,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [25284] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [25347] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 1,
      anon_sym_QMARK,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2271), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [25422] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2131), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [25503] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2263), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [25584] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2257), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [25665] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2315), 1,
      anon_sym_EQ_GT,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2143), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [25748] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2243), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [25829] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2245), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [25910] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2251), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [25991] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2201), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [26072] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2247), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [26153] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2249), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [26234] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(1718), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [26301] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [26350] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_QMARK,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [26425] = 10,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2319), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2324), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2327), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2330), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2333), 1,
      sym_var_modifier,
    ACTIONS(2336), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    ACTIONS(2322), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    STATE(1015), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
    ACTIONS(2317), 16,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [26482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1718), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [26527] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [26602] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
  [26681] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [26758] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_QMARK,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
  [26829] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_QMARK,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [26898] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(1718), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [26963] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2269), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [27038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1718), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [27083] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 1,
      anon_sym_QMARK,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2265), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [27158] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DOT,
  [27211] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [27266] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2261), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [27341] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2259), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [27416] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2255), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [27497] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [27548] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1718), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1716), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [27607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2011), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2009), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [27649] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2201), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [27729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1568), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1566), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [27771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1564), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1562), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [27813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1554), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [27855] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2261), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [27929] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2259), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [28003] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1718), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [28047] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 18,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DOT,
  [28099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2047), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2045), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [28141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2115), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2113), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [28183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2123), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2121), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [28225] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 1,
      anon_sym_QMARK,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2271), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [28299] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 20,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [28349] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 17,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [28403] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1718), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1716), 16,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [28461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2127), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2125), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [28503] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(1718), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 12,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [28567] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_QMARK,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [28635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2043), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2041), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [28677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2039), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2037), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [28719] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_QMARK,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 10,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
  [28789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2111), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2109), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [28831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2079), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2077), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [28873] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 7,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [28949] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
  [29027] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [29101] = 16,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1706), 1,
      anon_sym_LPAREN,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2379), 1,
      sym_name,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1612), 1,
      sym__type,
    STATE(1787), 1,
      sym_const_element,
    STATE(2468), 1,
      sym__reserved_identifier,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [29169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1977), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [29211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1718), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [29255] = 16,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1706), 1,
      anon_sym_LPAREN,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2379), 1,
      sym_name,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1618), 1,
      sym__type,
    STATE(1796), 1,
      sym_const_element,
    STATE(2468), 1,
      sym__reserved_identifier,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [29323] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_QMARK,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [29397] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 22,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [29445] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(1718), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [29511] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 12,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [29573] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2249), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [29653] = 16,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1706), 1,
      anon_sym_LPAREN,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2379), 1,
      sym_name,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1628), 1,
      sym__type,
    STATE(1755), 1,
      sym_const_element,
    STATE(2468), 1,
      sym__reserved_identifier,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [29721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2119), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2117), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [29763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2075), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2073), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [29805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2033), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [29847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2029), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [29889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2025), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [29931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2023), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2021), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [29973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1022), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2019), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2017), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2013), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1983), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1981), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2095), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2093), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30183] = 16,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1706), 1,
      anon_sym_LPAREN,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2379), 1,
      sym_name,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1595), 1,
      sym__type,
    STATE(1911), 1,
      sym_const_element,
    STATE(2468), 1,
      sym__reserved_identifier,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [30251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2169), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2167), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1985), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1989), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30377] = 16,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1706), 1,
      anon_sym_LPAREN,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2379), 1,
      sym_name,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1634), 1,
      sym__type,
    STATE(1834), 1,
      sym_const_element,
    STATE(2468), 1,
      sym__reserved_identifier,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [30445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2161), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2159), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2157), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2155), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2091), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2089), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1993), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2107), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2105), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2103), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2101), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30697] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2269), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [30771] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 1,
      anon_sym_QMARK,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2265), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [30845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1028), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1026), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2163), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2071), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2069), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [30971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2001), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2067), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2065), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2145), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2143), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2099), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2097), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2173), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2171), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2177), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2175), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31223] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2257), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [31303] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2247), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [31383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2199), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2197), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2149), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2147), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2007), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2005), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31509] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2263), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [31589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2131), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1969), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31673] = 16,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1706), 1,
      anon_sym_LPAREN,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2379), 1,
      sym_name,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1637), 1,
      sym__type,
    STATE(1775), 1,
      sym_const_element,
    STATE(2468), 1,
      sym__reserved_identifier,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [31741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2061), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2087), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2085), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2059), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2057), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2055), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2053), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2189), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2135), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [31993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1558), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [32035] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2251), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [32115] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2131), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [32195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2151), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [32237] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2255), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [32317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1594), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1592), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [32359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1927), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1925), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [32401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1975), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1973), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [32443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1997), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [32485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2141), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2139), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [32527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2181), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [32569] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2245), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [32649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2193), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [32691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2083), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2081), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [32733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2383), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(2127), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2125), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [32777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2049), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [32819] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2243), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [32899] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2385), 1,
      anon_sym_EQ_GT,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2143), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_binary_expression_token1,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [32981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2187), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2185), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [33023] = 17,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(43), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1706), 1,
      anon_sym_LPAREN,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(1227), 1,
      sym_readonly_modifier,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2046), 1,
      sym_variable_name,
    STATE(2301), 1,
      sym__type,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [33092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1718), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 23,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [33135] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2201), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [33214] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2255), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [33293] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2261), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [33366] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_QMARK,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 10,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [33433] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [33506] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2251), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [33585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1718), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1716), 23,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [33628] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_QMARK,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [33701] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_QMARK,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 9,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
  [33770] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2245), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [33849] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 6,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [33924] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 11,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [33985] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2243), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [34064] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 19,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [34113] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 5,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
  [34190] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 21,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [34237] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(1718), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 10,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [34302] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 17,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DOT,
  [34353] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2131), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [34432] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2263), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [34511] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 1,
      anon_sym_QMARK,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2271), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [34584] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2257), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [34663] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2259), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [34736] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1718), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 16,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [34789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2427), 1,
      anon_sym_COLON,
    ACTIONS(1999), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(1997), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [34832] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [34911] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 1,
      anon_sym_QMARK,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2265), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [34984] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(1718), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1716), 11,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [35047] = 17,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(43), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1706), 1,
      anon_sym_LPAREN,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(1219), 1,
      sym_readonly_modifier,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1988), 1,
      sym_variable_name,
    STATE(2210), 1,
      sym__type,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [35116] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2247), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2427), 1,
      anon_sym_COLON,
    ACTIONS(2083), 9,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
    ACTIONS(2081), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [35238] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2269), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [35311] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1718), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1716), 15,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35368] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2429), 1,
      anon_sym_EQ_GT,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2143), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35449] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2431), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35527] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2433), 1,
      anon_sym_EQ_GT,
    ACTIONS(2143), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35607] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2437), 1,
      anon_sym_COMMA,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2435), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35687] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2437), 1,
      anon_sym_COMMA,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2439), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35767] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2441), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35845] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2443), 1,
      anon_sym_EQ_GT,
    ACTIONS(2143), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35925] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2445), 1,
      anon_sym_COMMA,
    ACTIONS(2447), 1,
      anon_sym_EQ_GT,
    STATE(1938), 1,
      aux_sym_match_condition_list_repeat1,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36007] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2449), 1,
      anon_sym_EQ_GT,
    ACTIONS(2143), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36087] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2451), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36165] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2453), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36242] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2455), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36319] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2457), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36396] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2459), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2461), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2467), 1,
      anon_sym_RBRACE,
    ACTIONS(2469), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2471), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2473), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2475), 1,
      sym_var_modifier,
    STATE(1234), 1,
      sym_final_modifier,
    STATE(1308), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1409), 1,
      sym__const_declaration,
    STATE(1411), 1,
      sym__class_const_declaration,
    STATE(1764), 1,
      sym__function_definition_header,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2477), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(641), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1205), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [36471] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2479), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36548] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2481), 1,
      anon_sym_EQ_GT,
    ACTIONS(2483), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36627] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2485), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36704] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2435), 1,
      anon_sym_SEMI,
    ACTIONS(2487), 1,
      anon_sym_COMMA,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36783] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2459), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2461), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2469), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2471), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2473), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2475), 1,
      sym_var_modifier,
    ACTIONS(2489), 1,
      anon_sym_RBRACE,
    STATE(1234), 1,
      sym_final_modifier,
    STATE(1308), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1409), 1,
      sym__const_declaration,
    STATE(1411), 1,
      sym__class_const_declaration,
    STATE(1764), 1,
      sym__function_definition_header,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2477), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(641), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1185), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [36858] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2491), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36935] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2439), 1,
      anon_sym_RPAREN,
    ACTIONS(2493), 1,
      anon_sym_COMMA,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37014] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2495), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37091] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2497), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37168] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2499), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37245] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2501), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37322] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2503), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37399] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2505), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37476] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2507), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37553] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2511), 1,
      aux_sym_namespace_use_declaration_token3,
    STATE(1396), 1,
      sym__const_declaration,
    STATE(2616), 1,
      sym_visibility_modifier,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    ACTIONS(2513), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2509), 21,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [37600] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2515), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37677] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2517), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37754] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2519), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37831] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2521), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37908] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2523), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2526), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2529), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2532), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2535), 1,
      anon_sym_RBRACE,
    ACTIONS(2537), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2540), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2543), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2546), 1,
      sym_var_modifier,
    ACTIONS(2552), 1,
      anon_sym_POUND_LBRACK,
    STATE(1234), 1,
      sym_final_modifier,
    STATE(1308), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1409), 1,
      sym__const_declaration,
    STATE(1411), 1,
      sym__class_const_declaration,
    STATE(1764), 1,
      sym__function_definition_header,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2549), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(641), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1205), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [37983] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2555), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38060] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2459), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2461), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2469), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2471), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2473), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2475), 1,
      sym_var_modifier,
    ACTIONS(2557), 1,
      anon_sym_RBRACE,
    STATE(1234), 1,
      sym_final_modifier,
    STATE(1308), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1409), 1,
      sym__const_declaration,
    STATE(1411), 1,
      sym__class_const_declaration,
    STATE(1764), 1,
      sym__function_definition_header,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2477), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(641), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1208), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [38135] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2459), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2461), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2469), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2471), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2473), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2475), 1,
      sym_var_modifier,
    ACTIONS(2559), 1,
      anon_sym_RBRACE,
    STATE(1234), 1,
      sym_final_modifier,
    STATE(1308), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1409), 1,
      sym__const_declaration,
    STATE(1411), 1,
      sym__class_const_declaration,
    STATE(1764), 1,
      sym__function_definition_header,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2477), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(641), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1205), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [38210] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2561), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38287] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2459), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2461), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2469), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2471), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2473), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2475), 1,
      sym_var_modifier,
    ACTIONS(2563), 1,
      anon_sym_RBRACE,
    STATE(1234), 1,
      sym_final_modifier,
    STATE(1308), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1409), 1,
      sym__const_declaration,
    STATE(1411), 1,
      sym__class_const_declaration,
    STATE(1764), 1,
      sym__function_definition_header,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2477), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(641), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1218), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [38362] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2565), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38439] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2567), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38516] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2569), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38593] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2571), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38670] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2573), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38747] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2435), 1,
      anon_sym_RPAREN,
    ACTIONS(2493), 1,
      anon_sym_COMMA,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38826] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2459), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2461), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2469), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2471), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2473), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2475), 1,
      sym_var_modifier,
    ACTIONS(2575), 1,
      anon_sym_RBRACE,
    STATE(1234), 1,
      sym_final_modifier,
    STATE(1308), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1409), 1,
      sym__const_declaration,
    STATE(1411), 1,
      sym__class_const_declaration,
    STATE(1764), 1,
      sym__function_definition_header,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2477), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(641), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1228), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [38901] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2459), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2461), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2469), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2471), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2473), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2475), 1,
      sym_var_modifier,
    ACTIONS(2577), 1,
      anon_sym_RBRACE,
    STATE(1234), 1,
      sym_final_modifier,
    STATE(1308), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1409), 1,
      sym__const_declaration,
    STATE(1411), 1,
      sym__class_const_declaration,
    STATE(1764), 1,
      sym__function_definition_header,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2477), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(641), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1205), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [38976] = 15,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1706), 1,
      anon_sym_LPAREN,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2076), 1,
      sym_variable_name,
    STATE(2245), 1,
      sym__type,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [39039] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2579), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39116] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2581), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39193] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2389), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_QMARK,
    ACTIONS(2393), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2407), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2409), 1,
      anon_sym_CARET,
    ACTIONS(2417), 1,
      anon_sym_GT_EQ,
    ACTIONS(2421), 1,
      anon_sym_DOT,
    ACTIONS(2423), 1,
      anon_sym_STAR,
    ACTIONS(2395), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2411), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2419), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2425), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2583), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2415), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2413), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39270] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2439), 1,
      anon_sym_SEMI,
    ACTIONS(2487), 1,
      anon_sym_COMMA,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39349] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2481), 1,
      anon_sym_EQ_GT,
    ACTIONS(2585), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39428] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2587), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39505] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2589), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39582] = 15,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1706), 1,
      anon_sym_LPAREN,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2048), 1,
      sym_variable_name,
    STATE(2279), 1,
      sym__type,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [39645] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2459), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2461), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2469), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2471), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2473), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2475), 1,
      sym_var_modifier,
    ACTIONS(2591), 1,
      anon_sym_RBRACE,
    STATE(1234), 1,
      sym_final_modifier,
    STATE(1308), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1409), 1,
      sym__const_declaration,
    STATE(1411), 1,
      sym__class_const_declaration,
    STATE(1764), 1,
      sym__function_definition_header,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2477), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(641), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1205), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [39720] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2593), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39797] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2595), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39874] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2481), 1,
      anon_sym_EQ_GT,
    ACTIONS(2597), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39953] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2481), 1,
      anon_sym_EQ_GT,
    ACTIONS(2599), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40032] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_AMP,
    ACTIONS(2341), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_PIPE,
    ACTIONS(2347), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2349), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2351), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2353), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2357), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2359), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2361), 1,
      anon_sym_CARET,
    ACTIONS(2369), 1,
      anon_sym_GT_EQ,
    ACTIONS(2373), 1,
      anon_sym_DOT,
    ACTIONS(2375), 1,
      anon_sym_STAR,
    ACTIONS(2345), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2363), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2371), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2377), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2601), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2367), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2365), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40109] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2511), 1,
      aux_sym_namespace_use_declaration_token3,
    STATE(1390), 1,
      sym__const_declaration,
    STATE(2616), 1,
      sym_visibility_modifier,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    ACTIONS(2513), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2509), 21,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [40156] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2603), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40232] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_EQ_GT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40308] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2607), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40384] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2609), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40460] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2611), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40536] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2613), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40612] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2615), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40688] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2617), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40764] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2619), 1,
      aux_sym_namespace_aliasing_clause_token1,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40840] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2621), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40916] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2623), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40992] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41068] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2627), 1,
      anon_sym_EQ_GT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41144] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2629), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41220] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2631), 1,
      anon_sym_RBRACK,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41296] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2633), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41372] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2635), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41448] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2631), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41524] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2637), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41600] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2639), 1,
      anon_sym_COLON,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41676] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2641), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41752] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2629), 1,
      anon_sym_RBRACK,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41828] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2643), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41904] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2645), 1,
      aux_sym_namespace_aliasing_clause_token1,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41980] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2647), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42056] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2649), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42132] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2651), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42208] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2653), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42284] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2655), 1,
      anon_sym_RBRACK,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42360] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2657), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42436] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2655), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42512] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2659), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42588] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2661), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42664] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2663), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42740] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2665), 1,
      anon_sym_RBRACK,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42816] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2665), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42892] = 14,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2667), 1,
      sym_name,
    ACTIONS(2671), 1,
      anon_sym_LPAREN,
    ACTIONS(2673), 1,
      anon_sym_QMARK,
    ACTIONS(2675), 1,
      sym_bottom_type,
    STATE(1663), 1,
      sym_qualified_name,
    STATE(1962), 1,
      sym__type,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2551), 1,
      sym_namespace_name_as_prefix,
    STATE(2171), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1533), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(2669), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [42952] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2677), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43028] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2679), 1,
      aux_sym_namespace_aliasing_clause_token1,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43104] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2681), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43180] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2683), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43256] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2685), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43332] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2687), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43408] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2689), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43484] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2691), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43560] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2693), 1,
      anon_sym_RBRACK,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43636] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2693), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43712] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2695), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43788] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2697), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43864] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2699), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43940] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2701), 1,
      anon_sym_EQ_GT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44016] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2705), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2703), 26,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_string,
      anon_sym_int,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [44054] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2707), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44130] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2709), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44206] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2711), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44282] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2713), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44358] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44434] = 14,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1706), 1,
      anon_sym_LPAREN,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2717), 1,
      sym_bottom_type,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2191), 1,
      sym__type,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1509), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [44494] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2719), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44570] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2721), 1,
      aux_sym_namespace_aliasing_clause_token1,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44646] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2723), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44722] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2285), 1,
      anon_sym_GT_EQ,
    ACTIONS(2289), 1,
      anon_sym_DOT,
    ACTIONS(2291), 1,
      anon_sym_STAR,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2297), 1,
      anon_sym_PIPE,
    ACTIONS(2299), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2301), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2303), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_CARET,
    ACTIONS(2307), 1,
      anon_sym_QMARK,
    ACTIONS(2309), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2603), 1,
      anon_sym_RBRACK,
    ACTIONS(2275), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2279), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2287), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2293), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2283), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2281), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44798] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2725), 1,
      anon_sym_COLON,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44874] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2727), 1,
      anon_sym_COLON,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44950] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2729), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45026] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2731), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45102] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2733), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45178] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2735), 1,
      anon_sym_COLON,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45254] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    ACTIONS(2737), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2241), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45330] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2742), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2745), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2748), 1,
      anon_sym_RBRACE,
    ACTIONS(2750), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2753), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2756), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2759), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2762), 1,
      sym_var_modifier,
    ACTIONS(2768), 1,
      anon_sym_POUND_LBRACK,
    STATE(1343), 1,
      sym_attribute_list,
    STATE(1764), 1,
      sym__function_definition_header,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2765), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1304), 5,
      sym__enum_member_declaration,
      sym_enum_case,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_enum_declaration_list_repeat1,
    STATE(1346), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [45395] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2461), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2771), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2773), 1,
      anon_sym_RBRACE,
    ACTIONS(2775), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2777), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2779), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2781), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2783), 1,
      sym_var_modifier,
    STATE(1343), 1,
      sym_attribute_list,
    STATE(1764), 1,
      sym__function_definition_header,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2785), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1307), 5,
      sym__enum_member_declaration,
      sym_enum_case,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_enum_declaration_list_repeat1,
    STATE(1346), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [45460] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2461), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2771), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2775), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2777), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2779), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2781), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2783), 1,
      sym_var_modifier,
    ACTIONS(2787), 1,
      anon_sym_RBRACE,
    STATE(1343), 1,
      sym_attribute_list,
    STATE(1764), 1,
      sym__function_definition_header,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2785), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1304), 5,
      sym__enum_member_declaration,
      sym_enum_case,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_enum_declaration_list_repeat1,
    STATE(1346), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [45525] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2461), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2771), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2775), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2777), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2779), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2781), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2783), 1,
      sym_var_modifier,
    ACTIONS(2789), 1,
      anon_sym_RBRACE,
    STATE(1343), 1,
      sym_attribute_list,
    STATE(1764), 1,
      sym__function_definition_header,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2785), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1304), 5,
      sym__enum_member_declaration,
      sym_enum_case,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_enum_declaration_list_repeat1,
    STATE(1346), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [45590] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2791), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2513), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2509), 24,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [45629] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2795), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2793), 25,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [45666] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2461), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2771), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2775), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2777), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2779), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2781), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2783), 1,
      sym_var_modifier,
    ACTIONS(2797), 1,
      anon_sym_RBRACE,
    STATE(1343), 1,
      sym_attribute_list,
    STATE(1764), 1,
      sym__function_definition_header,
    STATE(1351), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2785), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1306), 5,
      sym__enum_member_declaration,
      sym_enum_case,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_enum_declaration_list_repeat1,
    STATE(1346), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [45731] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2801), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2799), 25,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [45768] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2805), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2803), 24,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [45804] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2809), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2807), 24,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [45840] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    STATE(1315), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2813), 6,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2811), 18,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [45879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2819), 1,
      anon_sym_POUND_LBRACK,
    STATE(1315), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2817), 6,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2815), 18,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [45918] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2475), 1,
      sym_intersection_type,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(2133), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [45967] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2667), 1,
      sym_name,
    ACTIONS(2673), 1,
      anon_sym_QMARK,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    STATE(1663), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2551), 1,
      sym_namespace_name_as_prefix,
    STATE(1899), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(2669), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46016] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2667), 1,
      sym_name,
    ACTIONS(2673), 1,
      anon_sym_QMARK,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    STATE(1663), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2551), 1,
      sym_namespace_name_as_prefix,
    STATE(1844), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(2669), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 7,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_POUND_LBRACK,
      anon_sym_DOLLAR,
    ACTIONS(2824), 18,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [46098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2830), 7,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_POUND_LBRACK,
      anon_sym_DOLLAR,
    ACTIONS(2828), 18,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [46131] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2508), 1,
      sym_intersection_type,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(2133), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46180] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2832), 1,
      anon_sym_LPAREN,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1466), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46229] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2832), 1,
      anon_sym_LPAREN,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1445), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2836), 7,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_POUND_LBRACK,
      anon_sym_DOLLAR,
    ACTIONS(2834), 18,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [46311] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2503), 1,
      sym_intersection_type,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(2133), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46360] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(2832), 1,
      anon_sym_LPAREN,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2607), 1,
      sym_namespace_name_as_prefix,
    STATE(1466), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46409] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(2631), 1,
      sym_intersection_type,
    STATE(2133), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46458] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(2643), 1,
      sym_intersection_type,
    STATE(2133), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46507] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(2832), 1,
      anon_sym_LPAREN,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2607), 1,
      sym_namespace_name_as_prefix,
    STATE(1445), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46556] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2667), 1,
      sym_name,
    ACTIONS(2673), 1,
      anon_sym_QMARK,
    STATE(1663), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2551), 1,
      sym_namespace_name_as_prefix,
    STATE(1886), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(2669), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46602] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2607), 1,
      sym_namespace_name_as_prefix,
    STATE(1463), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46648] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2667), 1,
      sym_name,
    ACTIONS(2673), 1,
      anon_sym_QMARK,
    STATE(1663), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2551), 1,
      sym_namespace_name_as_prefix,
    STATE(1848), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(2669), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46694] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1439), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46740] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1708), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1463), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46786] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2607), 1,
      sym_namespace_name_as_prefix,
    STATE(1439), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46832] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2667), 1,
      sym_name,
    STATE(1663), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2551), 1,
      sym_namespace_name_as_prefix,
    STATE(1675), 2,
      sym_named_type,
      sym_primitive_type,
    ACTIONS(2669), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46873] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2801), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2799), 17,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_string,
      anon_sym_int,
      aux_sym_readonly_modifier_token1,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [46902] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2607), 1,
      sym_namespace_name_as_prefix,
    STATE(1430), 2,
      sym_named_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46943] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1430), 2,
      sym_named_type,
      sym_primitive_type,
    ACTIONS(1698), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46984] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2805), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2803), 16,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_class_declaration_token1,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [47012] = 14,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2459), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2469), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2471), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2473), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2838), 1,
      sym_var_modifier,
    STATE(1200), 1,
      sym_final_modifier,
    STATE(1308), 1,
      sym_visibility_modifier,
    STATE(1416), 1,
      sym__const_declaration,
    STATE(1849), 1,
      sym__function_definition_header,
    ACTIONS(2477), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(640), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
  [47061] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_LBRACE,
    ACTIONS(2842), 1,
      sym_escape_sequence,
    ACTIONS(2846), 1,
      sym__new_line,
    ACTIONS(2849), 1,
      anon_sym_DOLLAR,
    ACTIONS(2851), 1,
      sym_encapsed_string_chars_heredoc,
    ACTIONS(2853), 1,
      sym_heredoc_end,
    STATE(1344), 1,
      aux_sym_heredoc_body_repeat1,
    STATE(1395), 1,
      sym_variable_name,
    STATE(1451), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2844), 4,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
    STATE(1350), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body_heredoc,
      sym_dynamic_variable_name,
  [47105] = 11,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2771), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2777), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2779), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2781), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2855), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2857), 1,
      sym_var_modifier,
    STATE(1849), 1,
      sym__function_definition_header,
    ACTIONS(2785), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1349), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [47147] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2859), 1,
      anon_sym_LBRACE,
    ACTIONS(2862), 1,
      sym_escape_sequence,
    ACTIONS(2868), 1,
      sym__new_line,
    ACTIONS(2871), 1,
      anon_sym_DOLLAR,
    ACTIONS(2874), 1,
      sym_encapsed_string_chars_heredoc,
    ACTIONS(2877), 1,
      sym_heredoc_end,
    STATE(1344), 1,
      aux_sym_heredoc_body_repeat1,
    STATE(1395), 1,
      sym_variable_name,
    STATE(1451), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2865), 4,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
    STATE(1350), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body_heredoc,
      sym_dynamic_variable_name,
  [47191] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2879), 1,
      anon_sym_LBRACE,
    ACTIONS(2882), 1,
      sym_escape_sequence,
    ACTIONS(2888), 1,
      sym__new_line,
    ACTIONS(2890), 1,
      anon_sym_DOLLAR,
    ACTIONS(2893), 1,
      sym_encapsed_string_chars_heredoc,
    ACTIONS(2896), 1,
      sym_heredoc_end,
    STATE(1395), 1,
      sym_variable_name,
    STATE(1451), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2885), 4,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
    STATE(1345), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body_heredoc,
      sym_dynamic_variable_name,
  [47232] = 10,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2771), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2777), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2779), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2781), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2898), 1,
      sym_var_modifier,
    STATE(1855), 1,
      sym__function_definition_header,
    ACTIONS(2785), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1354), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [47271] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_LBRACE,
    ACTIONS(2842), 1,
      sym_escape_sequence,
    ACTIONS(2849), 1,
      anon_sym_DOLLAR,
    ACTIONS(2851), 1,
      sym_encapsed_string_chars_heredoc,
    ACTIONS(2900), 1,
      sym__new_line,
    STATE(1342), 1,
      aux_sym_heredoc_body_repeat1,
    STATE(1395), 1,
      sym_variable_name,
    STATE(1451), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2844), 4,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
    STATE(1350), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body_heredoc,
      sym_dynamic_variable_name,
  [47312] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_LBRACE,
    ACTIONS(2849), 1,
      anon_sym_DOLLAR,
    ACTIONS(2851), 1,
      sym_encapsed_string_chars_heredoc,
    ACTIONS(2877), 1,
      sym_heredoc_end,
    ACTIONS(2902), 1,
      sym_escape_sequence,
    ACTIONS(2904), 1,
      sym__new_line,
    STATE(1395), 1,
      sym_variable_name,
    STATE(1451), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2844), 4,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
    STATE(1345), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body_heredoc,
      sym_dynamic_variable_name,
  [47353] = 10,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2463), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2771), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2777), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2779), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2781), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2898), 1,
      sym_var_modifier,
    STATE(1871), 1,
      sym__function_definition_header,
    ACTIONS(2785), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1354), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [47392] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_LBRACE,
    ACTIONS(2849), 1,
      anon_sym_DOLLAR,
    ACTIONS(2851), 1,
      sym_encapsed_string_chars_heredoc,
    ACTIONS(2902), 1,
      sym_escape_sequence,
    ACTIONS(2906), 1,
      sym__new_line,
    ACTIONS(2908), 1,
      sym_heredoc_end,
    STATE(1395), 1,
      sym_variable_name,
    STATE(1451), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2844), 4,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
    STATE(1345), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body_heredoc,
      sym_dynamic_variable_name,
  [47433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    STATE(1352), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2813), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
  [47460] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_POUND_LBRACK,
    STATE(1352), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2817), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
  [47487] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2913), 6,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_cast_type_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(1793), 10,
      anon_sym_BSLASH,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
      aux_sym_string_token1,
      anon_sym_LT_LT_LT,
      anon_sym_DOLLAR,
  [47511] = 9,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2322), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2915), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2918), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2921), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2924), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2927), 1,
      sym_var_modifier,
    ACTIONS(2930), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1354), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [47547] = 9,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2933), 1,
      sym_float,
    ACTIONS(2935), 1,
      sym_integer,
    ACTIONS(2937), 1,
      aux_sym__argument_name_token1,
    ACTIONS(2939), 1,
      aux_sym__argument_name_token2,
    ACTIONS(601), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(603), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(2453), 7,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym_boolean,
      sym_null,
      sym__string,
  [47583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 15,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
      anon_sym_POUND_LBRACK,
  [47604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2836), 15,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
      anon_sym_POUND_LBRACK,
  [47625] = 9,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2844), 1,
      anon_sym_BSLASHu,
    ACTIONS(2941), 1,
      anon_sym_LBRACE,
    ACTIONS(2943), 1,
      sym_escape_sequence,
    ACTIONS(2945), 1,
      anon_sym_DOLLAR,
    STATE(1395), 1,
      sym_variable_name,
    STATE(1451), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2851), 4,
      sym_encapsed_string_chars_heredoc,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
    STATE(1348), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body_heredoc,
      sym_dynamic_variable_name,
  [47660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2830), 15,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
      anon_sym_POUND_LBRACK,
  [47681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1022), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47781] = 10,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_LBRACE,
    ACTIONS(2955), 1,
      sym_escape_sequence,
    ACTIONS(2957), 1,
      anon_sym_BSLASHu,
    ACTIONS(2961), 1,
      anon_sym_DQUOTE,
    ACTIONS(2963), 1,
      anon_sym_DOLLAR,
    STATE(1462), 1,
      sym_variable_name,
    STATE(1556), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2959), 2,
      sym_encapsed_string_chars,
      anon_sym_SQUOTE,
    STATE(1373), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body,
      sym_dynamic_variable_name,
  [47817] = 10,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_LBRACE,
    ACTIONS(2957), 1,
      anon_sym_BSLASHu,
    ACTIONS(2963), 1,
      anon_sym_DOLLAR,
    ACTIONS(2965), 1,
      sym_escape_sequence,
    ACTIONS(2967), 1,
      anon_sym_DQUOTE,
    STATE(1462), 1,
      sym_variable_name,
    STATE(1556), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2959), 2,
      sym_encapsed_string_chars,
      anon_sym_SQUOTE,
    STATE(1381), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body,
      sym_dynamic_variable_name,
  [47853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2973), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47933] = 10,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_LBRACE,
    ACTIONS(2957), 1,
      anon_sym_BSLASHu,
    ACTIONS(2963), 1,
      anon_sym_DOLLAR,
    ACTIONS(2975), 1,
      sym_escape_sequence,
    ACTIONS(2977), 1,
      anon_sym_DQUOTE,
    STATE(1462), 1,
      sym_variable_name,
    STATE(1556), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2959), 2,
      sym_encapsed_string_chars,
      anon_sym_SQUOTE,
    STATE(1365), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body,
      sym_dynamic_variable_name,
  [47969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2973), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47989] = 10,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2979), 1,
      anon_sym_LBRACE,
    ACTIONS(2982), 1,
      sym_escape_sequence,
    ACTIONS(2985), 1,
      anon_sym_BSLASHu,
    ACTIONS(2991), 1,
      anon_sym_DQUOTE,
    ACTIONS(2993), 1,
      anon_sym_DOLLAR,
    STATE(1462), 1,
      sym_variable_name,
    STATE(1556), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2988), 2,
      sym_encapsed_string_chars,
      anon_sym_SQUOTE,
    STATE(1373), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body,
      sym_dynamic_variable_name,
  [48025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3000), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2998), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3002), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3004), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48165] = 10,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_LBRACE,
    ACTIONS(2955), 1,
      sym_escape_sequence,
    ACTIONS(2957), 1,
      anon_sym_BSLASHu,
    ACTIONS(2963), 1,
      anon_sym_DOLLAR,
    ACTIONS(3006), 1,
      anon_sym_DQUOTE,
    STATE(1462), 1,
      sym_variable_name,
    STATE(1556), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2959), 2,
      sym_encapsed_string_chars,
      anon_sym_SQUOTE,
    STATE(1373), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body,
      sym_dynamic_variable_name,
  [48201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3008), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1494), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3010), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3012), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3014), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48297] = 10,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3016), 1,
      sym_name,
    ACTIONS(3022), 1,
      anon_sym_BSLASH,
    STATE(1830), 1,
      sym_namespace_use_clause,
    STATE(2551), 1,
      sym_namespace_name_as_prefix,
    STATE(2567), 1,
      sym_namespace_name,
    ACTIONS(3020), 2,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
    STATE(1710), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(3018), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [48332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3024), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1158), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3026), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1182), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48408] = 9,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3028), 1,
      anon_sym_LBRACE,
    ACTIONS(3032), 1,
      anon_sym_BSLASHu,
    ACTIONS(3034), 1,
      anon_sym_BQUOTE,
    ACTIONS(3036), 1,
      anon_sym_DOLLAR,
    STATE(1480), 1,
      sym_variable_name,
    STATE(1617), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3030), 2,
      sym_execution_string_chars,
      sym_escape_sequence,
    STATE(1394), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_execution_operator_body,
      sym_dynamic_variable_name,
  [48441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3038), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48460] = 9,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3040), 1,
      anon_sym_LBRACE,
    ACTIONS(3046), 1,
      anon_sym_BSLASHu,
    ACTIONS(3049), 1,
      anon_sym_BQUOTE,
    ACTIONS(3051), 1,
      anon_sym_DOLLAR,
    STATE(1480), 1,
      sym_variable_name,
    STATE(1617), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3043), 2,
      sym_execution_string_chars,
      sym_escape_sequence,
    STATE(1394), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_execution_operator_body,
      sym_dynamic_variable_name,
  [48493] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3056), 1,
      anon_sym_DASH_GT,
    ACTIONS(3058), 1,
      anon_sym_LBRACK,
    ACTIONS(3062), 1,
      sym_encapsed_string_chars_after_variable_heredoc,
    ACTIONS(3060), 3,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
    ACTIONS(3054), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
      sym__new_line,
      anon_sym_DOLLAR,
  [48520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3064), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48539] = 10,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3016), 1,
      sym_name,
    ACTIONS(3068), 1,
      anon_sym_BSLASH,
    STATE(1909), 1,
      sym_namespace_use_clause,
    STATE(2483), 1,
      sym_namespace_name,
    STATE(2551), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(3066), 2,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
    STATE(1710), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(3018), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [48574] = 13,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2469), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2471), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(3070), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(3072), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(3074), 1,
      aux_sym_enum_declaration_token1,
    ACTIONS(3076), 1,
      aux_sym_class_declaration_token1,
    ACTIONS(3078), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(3080), 1,
      aux_sym__arrow_function_header_token1,
    STATE(2334), 1,
      sym__function_definition_header,
    STATE(2470), 1,
      sym_static_modifier,
    STATE(2577), 1,
      sym_readonly_modifier,
    STATE(2064), 2,
      sym_final_modifier,
      sym_abstract_modifier,
  [48615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1628), 4,
      sym_encapsed_string_chars_heredoc,
      sym_encapsed_string_chars_after_variable_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
    ACTIONS(1630), 9,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
      sym__new_line,
      anon_sym_DOLLAR,
  [48636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3082), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48655] = 13,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2469), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2471), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(3070), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(3072), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(3078), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(3080), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3084), 1,
      aux_sym_enum_declaration_token1,
    ACTIONS(3086), 1,
      aux_sym_class_declaration_token1,
    STATE(2310), 1,
      sym__function_definition_header,
    STATE(2470), 1,
      sym_static_modifier,
    STATE(2527), 1,
      sym_readonly_modifier,
    STATE(2034), 2,
      sym_final_modifier,
      sym_abstract_modifier,
  [48696] = 9,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3028), 1,
      anon_sym_LBRACE,
    ACTIONS(3032), 1,
      anon_sym_BSLASHu,
    ACTIONS(3036), 1,
      anon_sym_DOLLAR,
    ACTIONS(3088), 1,
      anon_sym_BQUOTE,
    STATE(1480), 1,
      sym_variable_name,
    STATE(1617), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3030), 2,
      sym_execution_string_chars,
      sym_escape_sequence,
    STATE(1394), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_execution_operator_body,
      sym_dynamic_variable_name,
  [48729] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3090), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3092), 7,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [48754] = 9,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3028), 1,
      anon_sym_LBRACE,
    ACTIONS(3036), 1,
      anon_sym_DOLLAR,
    ACTIONS(3096), 1,
      anon_sym_BSLASHu,
    ACTIONS(3098), 1,
      anon_sym_BQUOTE,
    STATE(1480), 1,
      sym_variable_name,
    STATE(1617), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3094), 2,
      sym_execution_string_chars,
      sym_escape_sequence,
    STATE(1402), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_execution_operator_body,
      sym_dynamic_variable_name,
  [48787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1398), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48806] = 9,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3028), 1,
      anon_sym_LBRACE,
    ACTIONS(3036), 1,
      anon_sym_DOLLAR,
    ACTIONS(3102), 1,
      anon_sym_BSLASHu,
    ACTIONS(3104), 1,
      anon_sym_BQUOTE,
    STATE(1480), 1,
      sym_variable_name,
    STATE(1617), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3100), 2,
      sym_execution_string_chars,
      sym_escape_sequence,
    STATE(1392), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_execution_operator_body,
      sym_dynamic_variable_name,
  [48839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3106), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3108), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3110), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3112), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3114), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3116), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3118), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [49010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3120), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [49029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1370), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [49048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3122), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [49067] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3124), 1,
      sym_name,
    ACTIONS(3126), 1,
      anon_sym_RBRACK,
    STATE(2212), 1,
      sym_attribute,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1847), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49101] = 8,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_AMP,
    ACTIONS(3140), 1,
      anon_sym_PIPE,
    STATE(1444), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1526), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    STATE(1531), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3135), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3128), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [49131] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3124), 1,
      sym_name,
    ACTIONS(3142), 1,
      anon_sym_RBRACK,
    STATE(2212), 1,
      sym_attribute,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1847), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49165] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3124), 1,
      sym_name,
    ACTIONS(3144), 1,
      anon_sym_RBRACK,
    STATE(2212), 1,
      sym_attribute,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1847), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49199] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3124), 1,
      sym_name,
    ACTIONS(3146), 1,
      anon_sym_RBRACK,
    STATE(2212), 1,
      sym_attribute,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1847), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49233] = 8,
    ACTIONS(1710), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2809), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3148), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(1898), 1,
      sym_static_variable_declaration,
    STATE(1900), 1,
      sym_variable_name,
    ACTIONS(1612), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49262] = 6,
    ACTIONS(117), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3150), 1,
      sym_integer,
    ACTIONS(113), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(115), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(2199), 5,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [49287] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3124), 1,
      sym_name,
    STATE(2007), 1,
      sym_attribute,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1847), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49318] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1939), 1,
      anon_sym_COLON,
    ACTIONS(2809), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3152), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(1612), 7,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49343] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3090), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3092), 7,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [49362] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3154), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3156), 7,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [49381] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3158), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3160), 7,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [49400] = 9,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3016), 1,
      sym_name,
    ACTIONS(3162), 1,
      anon_sym_BSLASH,
    STATE(1879), 1,
      sym_namespace_use_clause,
    STATE(2551), 1,
      sym_namespace_name_as_prefix,
    STATE(2578), 1,
      sym_namespace_name,
    STATE(1710), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(3018), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49431] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3124), 1,
      sym_name,
    STATE(2212), 1,
      sym_attribute,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1847), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49462] = 8,
    ACTIONS(1710), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2809), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3148), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(1827), 1,
      sym_static_variable_declaration,
    STATE(1900), 1,
      sym_variable_name,
    ACTIONS(1612), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49491] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3016), 1,
      sym_name,
    STATE(1919), 1,
      sym_namespace_use_clause,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2551), 1,
      sym_namespace_name_as_prefix,
    STATE(1710), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(3018), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49522] = 6,
    ACTIONS(117), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3164), 1,
      sym_integer,
    ACTIONS(113), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token1,
    ACTIONS(115), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    STATE(2369), 5,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [49547] = 9,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3016), 1,
      sym_name,
    ACTIONS(3166), 1,
      anon_sym_BSLASH,
    STATE(1805), 1,
      sym_namespace_use_clause,
    STATE(2551), 1,
      sym_namespace_name_as_prefix,
    STATE(2612), 1,
      sym_namespace_name,
    STATE(1710), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(3018), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49578] = 8,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    ACTIONS(3168), 1,
      aux_sym_namespace_aliasing_clause_token1,
    ACTIONS(3170), 1,
      aux_sym_use_instead_of_clause_token1,
    STATE(592), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49607] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3124), 1,
      sym_name,
    STATE(1981), 1,
      sym_attribute,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1847), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49638] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3172), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3174), 6,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [49656] = 3,
    ACTIONS(1630), 1,
      anon_sym_BSLASHu,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1628), 9,
      sym_encapsed_string_chars,
      sym_encapsed_string_chars_after_variable,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [49674] = 8,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3176), 1,
      sym_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1953), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49702] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3180), 1,
      anon_sym_AMP,
    STATE(1442), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3178), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3183), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
  [49724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 3,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
    ACTIONS(3185), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
      sym__new_line,
      anon_sym_DOLLAR,
  [49742] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_AMP,
    STATE(1442), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3189), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3191), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
  [49764] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3193), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3195), 6,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [49782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3199), 3,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
    ACTIONS(3197), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
      sym__new_line,
      anon_sym_DOLLAR,
  [49800] = 5,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1818), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1652), 3,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
    ACTIONS(1654), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
      sym__new_line,
      anon_sym_DOLLAR,
  [49840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3203), 3,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
    ACTIONS(3201), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
      sym__new_line,
      anon_sym_DOLLAR,
  [49858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 3,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
    ACTIONS(1642), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
      sym__new_line,
      anon_sym_DOLLAR,
  [49876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3207), 3,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
    ACTIONS(3205), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
      sym__new_line,
      anon_sym_DOLLAR,
  [49894] = 7,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3209), 1,
      anon_sym_COMMA,
    ACTIONS(3211), 1,
      anon_sym_RPAREN,
    STATE(592), 1,
      sym_arguments,
    STATE(2035), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49920] = 5,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1602), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49942] = 8,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3213), 1,
      sym_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(1790), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1628), 3,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
    ACTIONS(1630), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
      sym__new_line,
      anon_sym_DOLLAR,
  [49988] = 8,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3215), 1,
      sym_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2551), 1,
      sym_namespace_name_as_prefix,
    STATE(1613), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(3018), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50016] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2809), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3152), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(1612), 7,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50038] = 8,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3217), 1,
      sym_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
    STATE(2078), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2896), 3,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
    ACTIONS(2888), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
      sym__new_line,
      anon_sym_DOLLAR,
  [50084] = 8,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3219), 1,
      sym_name,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2551), 1,
      sym_namespace_name_as_prefix,
    STATE(1771), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(3018), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50112] = 7,
    ACTIONS(851), 1,
      anon_sym_COMMA,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3221), 1,
      anon_sym_RPAREN,
    STATE(592), 1,
      sym_arguments,
    STATE(1948), 1,
      aux_sym__list_destructing_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50138] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3054), 1,
      anon_sym_BSLASHu,
    ACTIONS(3223), 1,
      anon_sym_DASH_GT,
    ACTIONS(3225), 1,
      anon_sym_LBRACK,
    ACTIONS(3227), 1,
      sym_encapsed_string_chars_after_variable,
    ACTIONS(3060), 6,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [50162] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3178), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3183), 6,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [50180] = 7,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3209), 1,
      anon_sym_COMMA,
    ACTIONS(3229), 1,
      anon_sym_RPAREN,
    STATE(592), 1,
      sym_arguments,
    STATE(1969), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3233), 3,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
    ACTIONS(3231), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_SQUOTE,
      anon_sym_LT_QMARK,
      anon_sym_QMARK_GT2,
      sym__new_line,
      anon_sym_DOLLAR,
  [50224] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3235), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3238), 6,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [50242] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3241), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3243), 6,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [50260] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1769), 1,
      anon_sym_DOLLAR,
    ACTIONS(3245), 1,
      sym_name,
    ACTIONS(3247), 1,
      anon_sym_LBRACE,
    ACTIONS(3018), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(830), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50283] = 8,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3249), 1,
      sym_name,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1589), 1,
      sym_reference_modifier,
    STATE(1603), 1,
      sym_formal_parameters,
    STATE(2372), 1,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50310] = 5,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(2555), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50331] = 7,
    ACTIONS(1552), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3253), 1,
      sym_name,
    ACTIONS(3255), 1,
      anon_sym_LBRACE,
    STATE(1585), 1,
      sym__reserved_identifier,
    STATE(778), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50356] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_DOLLAR,
    ACTIONS(3257), 1,
      sym_name,
    ACTIONS(3259), 1,
      anon_sym_LBRACE,
    STATE(672), 1,
      sym__reserved_identifier,
    STATE(683), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50381] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_DOLLAR,
    ACTIONS(3261), 1,
      sym_name,
    ACTIONS(3263), 1,
      anon_sym_LBRACE,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(690), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50404] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_DOLLAR,
    ACTIONS(3265), 1,
      sym_name,
    ACTIONS(3267), 1,
      anon_sym_LBRACE,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(700), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50427] = 6,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3269), 1,
      sym_name,
    ACTIONS(3273), 1,
      anon_sym_LBRACE,
    ACTIONS(3271), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(579), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50450] = 7,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3275), 1,
      sym_name,
    ACTIONS(3277), 1,
      anon_sym_LBRACE,
    STATE(1567), 1,
      sym__reserved_identifier,
    STATE(1572), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50475] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1769), 1,
      anon_sym_DOLLAR,
    ACTIONS(3257), 1,
      sym_name,
    ACTIONS(3259), 1,
      anon_sym_LBRACE,
    STATE(672), 1,
      sym__reserved_identifier,
    STATE(851), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50500] = 6,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3269), 1,
      sym_name,
    ACTIONS(3273), 1,
      anon_sym_LBRACE,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(579), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50523] = 6,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3279), 1,
      sym_name,
    ACTIONS(3281), 1,
      anon_sym_LBRACE,
    ACTIONS(3271), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(578), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50546] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3054), 1,
      anon_sym_BSLASHu,
    ACTIONS(3283), 1,
      anon_sym_DASH_GT,
    ACTIONS(3285), 1,
      anon_sym_LBRACK,
    ACTIONS(3287), 1,
      sym_execution_string_chars_after_variable,
    ACTIONS(3060), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [50569] = 7,
    ACTIONS(1552), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3289), 1,
      sym_name,
    ACTIONS(3291), 1,
      anon_sym_LBRACE,
    STATE(848), 1,
      sym__reserved_identifier,
    STATE(778), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(3018), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50594] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2801), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [50609] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1769), 1,
      anon_sym_DOLLAR,
    ACTIONS(3257), 1,
      sym_name,
    ACTIONS(3259), 1,
      anon_sym_LBRACE,
    STATE(672), 1,
      sym__reserved_identifier,
    STATE(814), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50634] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1769), 1,
      anon_sym_DOLLAR,
    ACTIONS(3293), 1,
      sym_name,
    ACTIONS(3295), 1,
      anon_sym_LBRACE,
    ACTIONS(3018), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(831), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50657] = 6,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3279), 1,
      sym_name,
    ACTIONS(3281), 1,
      anon_sym_LBRACE,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(578), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50680] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(746), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50703] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2705), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [50718] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2795), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [50733] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1939), 1,
      anon_sym_COLON,
    ACTIONS(1612), 7,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50752] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_DOLLAR,
    ACTIONS(3297), 1,
      sym_name,
    ACTIONS(3299), 1,
      anon_sym_LBRACE,
    STATE(1578), 1,
      sym__reserved_identifier,
    STATE(713), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50777] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2809), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [50792] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(788), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50815] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_DOLLAR,
    ACTIONS(3301), 1,
      sym_name,
    ACTIONS(3303), 1,
      anon_sym_LBRACE,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(710), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50838] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(892), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50861] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_DOLLAR,
    ACTIONS(3305), 1,
      sym_name,
    ACTIONS(3307), 1,
      anon_sym_LBRACE,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(712), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50884] = 8,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3249), 1,
      sym_name,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1573), 1,
      sym_reference_modifier,
    STATE(1606), 1,
      sym_formal_parameters,
    STATE(2372), 1,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50911] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_DOLLAR,
    ACTIONS(3257), 1,
      sym_name,
    ACTIONS(3259), 1,
      anon_sym_LBRACE,
    STATE(672), 1,
      sym__reserved_identifier,
    STATE(686), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50936] = 6,
    ACTIONS(1546), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3309), 1,
      sym_name,
    ACTIONS(3313), 1,
      anon_sym_LBRACE,
    ACTIONS(3311), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(645), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50959] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    ACTIONS(3315), 1,
      anon_sym_EQ,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3092), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3090), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [50982] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_DOLLAR,
    ACTIONS(3317), 1,
      sym_name,
    ACTIONS(3319), 1,
      anon_sym_LBRACE,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(717), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51005] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3321), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3174), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3172), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [51026] = 5,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(2573), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51047] = 6,
    ACTIONS(121), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3324), 1,
      sym_name,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    ACTIONS(3326), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(602), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51070] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_DOLLAR,
    ACTIONS(3330), 1,
      sym_name,
    ACTIONS(3332), 1,
      anon_sym_LBRACE,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(718), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51093] = 3,
    ACTIONS(1630), 1,
      anon_sym_BSLASHu,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1628), 8,
      sym_execution_string_chars,
      sym_execution_string_chars_after_variable,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [51110] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_LPAREN,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    STATE(664), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51133] = 5,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(3334), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51154] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1769), 1,
      anon_sym_DOLLAR,
    ACTIONS(3336), 1,
      sym_name,
    ACTIONS(3338), 1,
      anon_sym_LBRACE,
    ACTIONS(3018), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(847), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51177] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3340), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3342), 5,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [51194] = 5,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(3344), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51215] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1769), 1,
      anon_sym_DOLLAR,
    ACTIONS(3346), 1,
      sym_name,
    ACTIONS(3348), 1,
      anon_sym_LBRACE,
    ACTIONS(3018), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(850), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51238] = 5,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(2581), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51259] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2805), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [51274] = 7,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3257), 1,
      sym_name,
    ACTIONS(3259), 1,
      anon_sym_LBRACE,
    STATE(672), 1,
      sym__reserved_identifier,
    STATE(577), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [51299] = 6,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    STATE(592), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51322] = 7,
    ACTIONS(1546), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3350), 1,
      sym_name,
    ACTIONS(3352), 1,
      anon_sym_LBRACE,
    STATE(698), 1,
      sym__reserved_identifier,
    STATE(644), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [51347] = 6,
    ACTIONS(1552), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3354), 1,
      sym_name,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(779), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51370] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1769), 1,
      anon_sym_DOLLAR,
    ACTIONS(3360), 1,
      sym_name,
    ACTIONS(3362), 1,
      anon_sym_LBRACE,
    ACTIONS(3018), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(813), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51393] = 6,
    ACTIONS(1552), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3364), 1,
      sym_name,
    ACTIONS(3366), 1,
      anon_sym_LBRACE,
    ACTIONS(3356), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(775), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51416] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1769), 1,
      anon_sym_DOLLAR,
    ACTIONS(3368), 1,
      sym_name,
    ACTIONS(3370), 1,
      anon_sym_LBRACE,
    ACTIONS(3018), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(812), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51439] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1769), 1,
      anon_sym_DOLLAR,
    ACTIONS(3275), 1,
      sym_name,
    ACTIONS(3277), 1,
      anon_sym_LBRACE,
    STATE(1567), 1,
      sym__reserved_identifier,
    STATE(839), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [51464] = 6,
    ACTIONS(1546), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3372), 1,
      sym_name,
    ACTIONS(3374), 1,
      anon_sym_LBRACE,
    ACTIONS(3311), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(646), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51487] = 5,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(2583), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51508] = 5,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(3376), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51529] = 6,
    ACTIONS(121), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3378), 1,
      sym_name,
    ACTIONS(3380), 1,
      anon_sym_LBRACE,
    ACTIONS(3326), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(597), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51552] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3386), 1,
      anon_sym_PIPE,
    STATE(1530), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3384), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3382), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [51573] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3386), 1,
      anon_sym_PIPE,
    STATE(1530), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3390), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3388), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [51594] = 7,
    ACTIONS(121), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3392), 1,
      sym_name,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(806), 1,
      sym__reserved_identifier,
    STATE(599), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(3018), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [51619] = 7,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3297), 1,
      sym_name,
    ACTIONS(3299), 1,
      anon_sym_LBRACE,
    STATE(1578), 1,
      sym__reserved_identifier,
    STATE(1555), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [51644] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3396), 1,
      anon_sym_PIPE,
    STATE(1530), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3195), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3193), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [51665] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3403), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3401), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3399), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [51686] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3386), 1,
      anon_sym_PIPE,
    STATE(1527), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3407), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3405), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [51707] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    ACTIONS(3411), 1,
      anon_sym_PIPE,
    STATE(1670), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1676), 1,
      aux_sym_union_type_repeat1,
    STATE(1677), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3135), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [51731] = 9,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    STATE(948), 1,
      sym_declaration_list,
    STATE(1653), 1,
      sym_arguments,
    STATE(1876), 1,
      sym_base_clause,
    STATE(2428), 1,
      sym_class_interface_clause,
  [51759] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3209), 1,
      anon_sym_COMMA,
    ACTIONS(3211), 1,
      anon_sym_RPAREN,
    STATE(2035), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51779] = 9,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1124), 1,
      sym_declaration_list,
    STATE(1643), 1,
      sym_arguments,
    STATE(1852), 1,
      sym_base_clause,
    STATE(2397), 1,
      sym_class_interface_clause,
  [51807] = 6,
    ACTIONS(971), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3421), 1,
      aux_sym_catch_clause_token1,
    ACTIONS(3423), 1,
      aux_sym_finally_clause_token1,
    ACTIONS(969), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    STATE(1538), 3,
      sym_catch_clause,
      sym_finally_clause,
      aux_sym_try_statement_repeat1,
  [51829] = 6,
    ACTIONS(979), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3425), 1,
      aux_sym_catch_clause_token1,
    ACTIONS(3428), 1,
      aux_sym_finally_clause_token1,
    ACTIONS(977), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    STATE(1538), 3,
      sym_catch_clause,
      sym_finally_clause,
      aux_sym_try_statement_repeat1,
  [51851] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3209), 1,
      anon_sym_COMMA,
    ACTIONS(3229), 1,
      anon_sym_RPAREN,
    STATE(1969), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51871] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2809), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3148), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(1612), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51891] = 9,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1117), 1,
      sym_declaration_list,
    STATE(1600), 1,
      sym_arguments,
    STATE(1802), 1,
      sym_base_clause,
    STATE(2251), 1,
      sym_class_interface_clause,
  [51919] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1869), 1,
      sym_named_type,
    STATE(2029), 1,
      sym_type_list,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
  [51947] = 8,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    ACTIONS(3433), 1,
      anon_sym_COMMA,
    ACTIONS(3435), 1,
      anon_sym_LBRACE,
    STATE(1376), 1,
      sym_use_list,
    STATE(1608), 1,
      aux_sym_base_clause_repeat1,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3431), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [51973] = 5,
    ACTIONS(851), 1,
      anon_sym_COMMA,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3221), 1,
      anon_sym_RPAREN,
    STATE(1948), 1,
      aux_sym__list_destructing_repeat1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51993] = 9,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    STATE(964), 1,
      sym_declaration_list,
    STATE(1644), 1,
      sym_arguments,
    STATE(1904), 1,
      sym_base_clause,
    STATE(2357), 1,
      sym_class_interface_clause,
  [52021] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(1869), 1,
      sym_named_type,
    STATE(1964), 1,
      sym_type_list,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
  [52049] = 4,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52066] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(857), 1,
      sym_arguments,
    ACTIONS(1777), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52083] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(788), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52100] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3197), 1,
      anon_sym_BSLASHu,
    ACTIONS(3199), 6,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [52115] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3185), 1,
      anon_sym_BSLASHu,
    ACTIONS(3187), 6,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [52130] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3439), 1,
      anon_sym_DASH,
    ACTIONS(3437), 2,
      sym_integer,
      sym_name,
    STATE(2452), 3,
      sym__simple_string_subscript_unary_expression,
      sym__simple_string_array_access_argument,
      sym_variable_name,
  [52149] = 8,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1692), 1,
      sym_name,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1428), 1,
      sym_qualified_name,
    STATE(2022), 1,
      sym_named_type,
    STATE(2549), 1,
      sym_namespace_name,
    STATE(2558), 1,
      sym_namespace_name_as_prefix,
  [52174] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3344), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52189] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(740), 1,
      sym_arguments,
    ACTIONS(1580), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52206] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3205), 1,
      anon_sym_BSLASHu,
    ACTIONS(3207), 6,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [52221] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3443), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3446), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3441), 2,
      anon_sym_RBRACE,
      aux_sym_switch_block_token1,
    STATE(1557), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [52240] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3334), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52255] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_BSLASHu,
    ACTIONS(3233), 6,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [52270] = 4,
    ACTIONS(1664), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(627), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52287] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3451), 1,
      anon_sym_BSLASHu,
    ACTIONS(3449), 6,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [52302] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    ACTIONS(3455), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(2103), 1,
      sym_namespace_aliasing_clause,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3453), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [52323] = 3,
    ACTIONS(1630), 1,
      anon_sym_BSLASHu,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1628), 6,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [52338] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1945), 3,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
    ACTIONS(1943), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [52353] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(892), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52370] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3168), 1,
      aux_sym_namespace_aliasing_clause_token1,
    ACTIONS(3170), 1,
      aux_sym_use_instead_of_clause_token1,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52387] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(880), 1,
      sym_arguments,
    ACTIONS(1773), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52404] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3439), 1,
      anon_sym_DASH,
    ACTIONS(3457), 2,
      sym_integer,
      sym_name,
    STATE(2630), 3,
      sym__simple_string_subscript_unary_expression,
      sym__simple_string_array_access_argument,
      sym_variable_name,
  [52423] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3092), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [52440] = 3,
    ACTIONS(1654), 1,
      anon_sym_BSLASHu,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1652), 6,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [52455] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3459), 1,
      sym_name,
    STATE(1694), 1,
      sym_reference_modifier,
    STATE(2285), 1,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [52476] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(880), 1,
      sym_arguments,
    ACTIONS(1580), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52493] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    ACTIONS(3461), 1,
      sym_name,
    STATE(1592), 1,
      sym_formal_parameters,
    STATE(2342), 1,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [52514] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(892), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52531] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3376), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52546] = 3,
    ACTIONS(1642), 1,
      anon_sym_BSLASHu,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1640), 6,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [52561] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(746), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52578] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(740), 1,
      sym_arguments,
    ACTIONS(1773), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52595] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(788), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52612] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(734), 1,
      sym_arguments,
    ACTIONS(1777), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52629] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3463), 1,
      anon_sym_BSLASHu,
    ACTIONS(2991), 6,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [52644] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_LPAREN,
    STATE(664), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52661] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1714), 1,
      anon_sym_LPAREN,
    STATE(664), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52678] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3439), 1,
      anon_sym_DASH,
    ACTIONS(3465), 2,
      sym_integer,
      sym_name,
    STATE(2640), 3,
      sym__simple_string_subscript_unary_expression,
      sym__simple_string_array_access_argument,
      sym_variable_name,
  [52697] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(794), 1,
      sym_arguments,
    ACTIONS(1773), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52714] = 4,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52731] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3467), 1,
      anon_sym_AMP,
    ACTIONS(3473), 1,
      anon_sym_PIPE,
    STATE(1742), 1,
      aux_sym_union_type_repeat1,
    STATE(1743), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    STATE(1782), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3135), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [52754] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(781), 1,
      sym_arguments,
    ACTIONS(1777), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52771] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    ACTIONS(3461), 1,
      sym_name,
    STATE(1602), 1,
      sym_formal_parameters,
    STATE(2342), 1,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [52792] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(746), 1,
      sym_arguments,
    ACTIONS(1598), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52809] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3475), 1,
      sym_name,
    STATE(2161), 1,
      sym_const_element,
    STATE(2468), 1,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [52827] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1086), 1,
      sym_compound_statement,
    STATE(1778), 1,
      sym_anonymous_function_use_clause,
    STATE(2193), 1,
      sym__return_type,
  [52849] = 7,
    ACTIONS(987), 1,
      aux_sym_while_statement_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3483), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3485), 1,
      aux_sym_else_clause_token1,
    STATE(1639), 1,
      aux_sym_if_statement_repeat1,
    STATE(1946), 1,
      sym_else_clause,
    STATE(2111), 1,
      sym_else_if_clause,
  [52871] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3487), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3489), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3491), 1,
      aux_sym_switch_block_token1,
    STATE(1557), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [52889] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3475), 1,
      sym_name,
    STATE(1773), 1,
      sym_const_element,
    STATE(2468), 1,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [52907] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3493), 1,
      aux_sym_if_statement_token2,
    ACTIONS(3495), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3497), 1,
      aux_sym_else_clause_token1,
    STATE(1709), 1,
      aux_sym_if_statement_repeat2,
    STATE(1989), 1,
      sym_else_if_clause_2,
    STATE(2507), 1,
      sym_else_clause_2,
  [52929] = 3,
    ACTIONS(1654), 1,
      anon_sym_BSLASHu,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1652), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [52943] = 7,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(962), 1,
      sym_compound_statement,
    STATE(1887), 1,
      sym_anonymous_function_use_clause,
    STATE(2339), 1,
      sym__return_type,
  [52965] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1679), 1,
      sym_declaration_list,
    STATE(1895), 1,
      sym_base_clause,
    STATE(2346), 1,
      sym_class_interface_clause,
  [52987] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1113), 1,
      sym_declaration_list,
    STATE(1896), 1,
      sym_base_clause,
    STATE(2348), 1,
      sym_class_interface_clause,
  [53009] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3487), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3489), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3499), 1,
      aux_sym_switch_block_token1,
    STATE(1557), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [53027] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1071), 1,
      sym_compound_statement,
    STATE(1885), 1,
      sym_anonymous_function_use_clause,
    STATE(2216), 1,
      sym__return_type,
  [53049] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1044), 1,
      sym_compound_statement,
    STATE(1759), 1,
      sym_anonymous_function_use_clause,
    STATE(2186), 1,
      sym__return_type,
  [53071] = 7,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(943), 1,
      sym_compound_statement,
    STATE(1858), 1,
      sym_anonymous_function_use_clause,
    STATE(2411), 1,
      sym__return_type,
  [53093] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(442), 1,
      sym_declaration_list,
    STATE(1758), 1,
      sym_base_clause,
    STATE(2197), 1,
      sym_class_interface_clause,
  [53115] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1116), 1,
      sym_compound_statement,
    STATE(1772), 1,
      sym_anonymous_function_use_clause,
    STATE(2213), 1,
      sym__return_type,
  [53137] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3503), 1,
      anon_sym_BSLASHu,
    ACTIONS(3049), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [53151] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3433), 1,
      anon_sym_COMMA,
    ACTIONS(3435), 1,
      anon_sym_LBRACE,
    STATE(1361), 1,
      sym_use_list,
    STATE(1748), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(3505), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [53171] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(446), 1,
      sym_declaration_list,
    STATE(1857), 1,
      sym_base_clause,
    STATE(2407), 1,
      sym_class_interface_clause,
  [53193] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1072), 1,
      sym_compound_statement,
    STATE(1862), 1,
      sym_anonymous_function_use_clause,
    STATE(2417), 1,
      sym__return_type,
  [53215] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3487), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3489), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3507), 1,
      anon_sym_RBRACE,
    STATE(1557), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [53233] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3475), 1,
      sym_name,
    STATE(1784), 1,
      sym_const_element,
    STATE(2468), 1,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [53251] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3433), 1,
      anon_sym_COMMA,
    ACTIONS(3435), 1,
      anon_sym_LBRACE,
    STATE(1376), 1,
      sym_use_list,
    STATE(1608), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(3431), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [53271] = 3,
    ACTIONS(1642), 1,
      anon_sym_BSLASHu,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1640), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [53285] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(437), 1,
      sym_declaration_list,
    STATE(1756), 1,
      sym_base_clause,
    STATE(2225), 1,
      sym_class_interface_clause,
  [53307] = 6,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    STATE(2324), 1,
      sym_arguments,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3509), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [53327] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3205), 1,
      anon_sym_BSLASHu,
    ACTIONS(3207), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [53341] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3475), 1,
      sym_name,
    STATE(1794), 1,
      sym_const_element,
    STATE(2468), 1,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [53359] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1070), 1,
      sym_compound_statement,
    STATE(1770), 1,
      sym_anonymous_function_use_clause,
    STATE(2208), 1,
      sym__return_type,
  [53381] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3231), 1,
      anon_sym_BSLASHu,
    ACTIONS(3233), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [53395] = 3,
    ACTIONS(1630), 1,
      anon_sym_BSLASHu,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1628), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [53409] = 7,
    ACTIONS(995), 1,
      aux_sym_while_statement_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3511), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3514), 1,
      aux_sym_else_clause_token1,
    STATE(1736), 1,
      aux_sym_if_statement_repeat1,
    STATE(2065), 1,
      sym_else_clause,
    STATE(2111), 1,
      sym_else_if_clause,
  [53431] = 7,
    ACTIONS(987), 1,
      aux_sym_while_statement_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3517), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3520), 1,
      aux_sym_else_clause_token1,
    STATE(1622), 1,
      aux_sym_if_statement_repeat1,
    STATE(1946), 1,
      sym_else_clause,
    STATE(2111), 1,
      sym_else_if_clause,
  [53453] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(445), 1,
      sym_declaration_list,
    STATE(1791), 1,
      sym_base_clause,
    STATE(2198), 1,
      sym_class_interface_clause,
  [53475] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3487), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3489), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3523), 1,
      anon_sym_RBRACE,
    STATE(1557), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [53493] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3495), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3497), 1,
      aux_sym_else_clause_token1,
    ACTIONS(3525), 1,
      aux_sym_if_statement_token2,
    STATE(1640), 1,
      aux_sym_if_statement_repeat2,
    STATE(1989), 1,
      sym_else_if_clause_2,
    STATE(2476), 1,
      sym_else_clause_2,
  [53515] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    ACTIONS(3527), 1,
      anon_sym_COMMA,
    STATE(1859), 1,
      aux_sym_base_clause_repeat1,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3529), 2,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [53535] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3475), 1,
      sym_name,
    STATE(1867), 1,
      sym_const_element,
    STATE(2468), 1,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [53553] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3185), 1,
      anon_sym_BSLASHu,
    ACTIONS(3187), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [53567] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3197), 1,
      anon_sym_BSLASHu,
    ACTIONS(3199), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [53581] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3487), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3489), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3531), 1,
      aux_sym_switch_block_token1,
    STATE(1601), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [53599] = 7,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(956), 1,
      sym_compound_statement,
    STATE(1913), 1,
      sym_anonymous_function_use_clause,
    STATE(2410), 1,
      sym__return_type,
  [53621] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1747), 1,
      sym_declaration_list,
    STATE(1819), 1,
      sym_base_clause,
    STATE(2316), 1,
      sym_class_interface_clause,
  [53643] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3475), 1,
      sym_name,
    STATE(1889), 1,
      sym_const_element,
    STATE(2468), 1,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [53661] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(441), 1,
      sym_declaration_list,
    STATE(1800), 1,
      sym_base_clause,
    STATE(2247), 1,
      sym_class_interface_clause,
  [53683] = 7,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(918), 1,
      sym_compound_statement,
    STATE(1821), 1,
      sym_anonymous_function_use_clause,
    STATE(2325), 1,
      sym__return_type,
  [53705] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3475), 1,
      sym_name,
    STATE(1763), 1,
      sym_const_element,
    STATE(2468), 1,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [53723] = 7,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(954), 1,
      sym_compound_statement,
    STATE(1908), 1,
      sym_anonymous_function_use_clause,
    STATE(2314), 1,
      sym__return_type,
  [53745] = 7,
    ACTIONS(995), 1,
      aux_sym_while_statement_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3483), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3485), 1,
      aux_sym_else_clause_token1,
    STATE(1736), 1,
      aux_sym_if_statement_repeat1,
    STATE(2065), 1,
      sym_else_clause,
    STATE(2111), 1,
      sym_else_if_clause,
  [53767] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3495), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3497), 1,
      aux_sym_else_clause_token1,
    ACTIONS(3533), 1,
      aux_sym_if_statement_token2,
    STATE(1709), 1,
      aux_sym_if_statement_repeat2,
    STATE(1989), 1,
      sym_else_if_clause_2,
    STATE(2479), 1,
      sym_else_clause_2,
  [53789] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1082), 1,
      sym_compound_statement,
    STATE(1846), 1,
      sym_anonymous_function_use_clause,
    STATE(2229), 1,
      sym__return_type,
  [53811] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3487), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3489), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3535), 1,
      anon_sym_RBRACE,
    STATE(1611), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [53829] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1127), 1,
      sym_declaration_list,
    STATE(1804), 1,
      sym_base_clause,
    STATE(2266), 1,
      sym_class_interface_clause,
  [53851] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    STATE(949), 1,
      sym_declaration_list,
    STATE(1883), 1,
      sym_base_clause,
    STATE(2429), 1,
      sym_class_interface_clause,
  [53873] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1751), 1,
      sym_declaration_list,
    STATE(1826), 1,
      sym_base_clause,
    STATE(2373), 1,
      sym_class_interface_clause,
  [53895] = 7,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(928), 1,
      sym_compound_statement,
    STATE(1833), 1,
      sym_anonymous_function_use_clause,
    STATE(2376), 1,
      sym__return_type,
  [53917] = 7,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(929), 1,
      sym_compound_statement,
    STATE(1835), 1,
      sym_anonymous_function_use_clause,
    STATE(2377), 1,
      sym__return_type,
  [53939] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3537), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [53955] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1056), 1,
      sym_compound_statement,
    STATE(1872), 1,
      sym_anonymous_function_use_clause,
    STATE(2211), 1,
      sym__return_type,
  [53977] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1741), 1,
      sym_declaration_list,
    STATE(1843), 1,
      sym_base_clause,
    STATE(2379), 1,
      sym_class_interface_clause,
  [53999] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3487), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3489), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3539), 1,
      anon_sym_RBRACE,
    STATE(1625), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [54017] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1715), 1,
      sym_declaration_list,
    STATE(1870), 1,
      sym_base_clause,
    STATE(2424), 1,
      sym_class_interface_clause,
  [54039] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    STATE(935), 1,
      sym_declaration_list,
    STATE(1850), 1,
      sym_base_clause,
    STATE(2386), 1,
      sym_class_interface_clause,
  [54061] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3495), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3497), 1,
      aux_sym_else_clause_token1,
    ACTIONS(3541), 1,
      aux_sym_if_statement_token2,
    STATE(1596), 1,
      aux_sym_if_statement_repeat2,
    STATE(1989), 1,
      sym_else_if_clause_2,
    STATE(2521), 1,
      sym_else_clause_2,
  [54083] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3487), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3489), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3543), 1,
      aux_sym_switch_block_token1,
    STATE(1594), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [54101] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(440), 1,
      sym_declaration_list,
    STATE(1765), 1,
      sym_base_clause,
    STATE(2187), 1,
      sym_class_interface_clause,
  [54123] = 7,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(944), 1,
      sym_compound_statement,
    STATE(1863), 1,
      sym_anonymous_function_use_clause,
    STATE(2422), 1,
      sym__return_type,
  [54145] = 7,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1716), 1,
      sym_declaration_list,
    STATE(1861), 1,
      sym_base_clause,
    STATE(2416), 1,
      sym_class_interface_clause,
  [54167] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(2427), 1,
      anon_sym_COLON,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1942), 1,
      sym_formal_parameters,
    STATE(2443), 1,
      sym_reference_modifier,
  [54186] = 4,
    ACTIONS(1132), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1130), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3545), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [54201] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3547), 1,
      sym_name,
    ACTIONS(3549), 1,
      anon_sym_LBRACE,
    ACTIONS(3551), 1,
      anon_sym_DOLLAR,
    STATE(1597), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54218] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3156), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [54229] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3092), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [54240] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3555), 1,
      anon_sym_BSLASH,
    STATE(1668), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3553), 3,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
  [54255] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3557), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2031), 1,
      sym_reference_modifier,
    STATE(2037), 1,
      sym_variable_name,
  [54274] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3559), 1,
      sym_name,
    ACTIONS(3561), 1,
      anon_sym_LBRACE,
    ACTIONS(3563), 1,
      anon_sym_DOLLAR,
    STATE(1570), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54291] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3567), 1,
      anon_sym_BSLASH,
    STATE(1689), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3565), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54306] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3555), 1,
      anon_sym_BSLASH,
    STATE(1746), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3565), 3,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
  [54321] = 5,
    ACTIONS(1546), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3570), 1,
      sym_name,
    ACTIONS(3572), 1,
      anon_sym_LBRACE,
    STATE(660), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54338] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_AMP,
    STATE(1704), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3191), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54353] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3574), 1,
      anon_sym_LBRACE,
    ACTIONS(3576), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3578), 1,
      anon_sym_DASH_GT,
    ACTIONS(3580), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3582), 1,
      anon_sym_LBRACK,
  [54372] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1769), 1,
      anon_sym_DOLLAR,
    ACTIONS(3584), 1,
      sym_name,
    ACTIONS(3586), 1,
      anon_sym_LBRACE,
    STATE(891), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54389] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3590), 1,
      anon_sym_COLON,
    STATE(1971), 1,
      sym__return_type,
    ACTIONS(3588), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54404] = 6,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3592), 1,
      sym_name,
    ACTIONS(3594), 1,
      anon_sym_BSLASH,
    STATE(490), 1,
      sym_compound_statement,
    STATE(1712), 1,
      sym_namespace_name,
  [54423] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3160), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [54434] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3596), 1,
      anon_sym_PIPE,
    STATE(1702), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3401), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54449] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_PIPE,
    STATE(1705), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3384), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54464] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_DOLLAR,
    ACTIONS(3600), 1,
      sym_name,
    ACTIONS(3602), 1,
      anon_sym_LBRACE,
    STATE(720), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54481] = 4,
    ACTIONS(1080), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1078), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3604), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [54496] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3574), 1,
      anon_sym_LBRACE,
    ACTIONS(3576), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3582), 1,
      anon_sym_LBRACK,
    ACTIONS(3606), 1,
      anon_sym_DASH_GT,
    ACTIONS(3608), 1,
      anon_sym_QMARK_DASH_GT,
  [54515] = 4,
    ACTIONS(1092), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1090), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3610), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [54530] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3561), 1,
      anon_sym_LBRACE,
    ACTIONS(3563), 1,
      anon_sym_DOLLAR,
    ACTIONS(3612), 1,
      sym_name,
    STATE(1570), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54547] = 5,
    ACTIONS(1552), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3614), 1,
      sym_name,
    ACTIONS(3616), 1,
      anon_sym_LBRACE,
    STATE(790), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54564] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3549), 1,
      anon_sym_LBRACE,
    ACTIONS(3551), 1,
      anon_sym_DOLLAR,
    ACTIONS(3618), 1,
      sym_name,
    STATE(1597), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54581] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3620), 1,
      sym_name,
    ACTIONS(3622), 1,
      anon_sym_LBRACE,
    ACTIONS(3624), 1,
      anon_sym_DOLLAR,
    STATE(1448), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54598] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3622), 1,
      anon_sym_LBRACE,
    ACTIONS(3624), 1,
      anon_sym_DOLLAR,
    ACTIONS(3626), 1,
      sym_name,
    STATE(1448), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54615] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3628), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2040), 1,
      sym_variable_name,
    STATE(2042), 1,
      sym_reference_modifier,
  [54634] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3576), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3630), 1,
      anon_sym_LBRACE,
    ACTIONS(3632), 1,
      anon_sym_DASH_GT,
    ACTIONS(3634), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3636), 1,
      anon_sym_LBRACK,
  [54653] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3640), 1,
      anon_sym_BSLASH,
    STATE(1689), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3638), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54668] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3643), 1,
      sym_name,
    STATE(2079), 1,
      sym_visibility_modifier,
    ACTIONS(3645), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [54683] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3647), 1,
      anon_sym_PIPE,
    STATE(1691), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3174), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [54698] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3650), 1,
      anon_sym_PIPE,
    STATE(1692), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3195), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [54713] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_PIPE,
    STATE(1692), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3390), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [54728] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3655), 1,
      sym_name,
    STATE(2336), 1,
      sym__reserved_identifier,
    ACTIONS(2381), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [54743] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3657), 1,
      anon_sym_AMP,
    ACTIONS(3659), 1,
      anon_sym_RPAREN,
    STATE(2391), 2,
      sym_variable_name,
      sym_variable_reference,
  [54760] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3663), 1,
      anon_sym_EQ,
    STATE(1928), 1,
      sym_property_initializer,
    ACTIONS(3661), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [54775] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3590), 1,
      anon_sym_COLON,
    STATE(1995), 1,
      sym__return_type,
    ACTIONS(3665), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54790] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3667), 1,
      aux_sym_catch_clause_token1,
    ACTIONS(3669), 1,
      aux_sym_finally_clause_token1,
    STATE(422), 3,
      sym_catch_clause,
      sym_finally_clause,
      aux_sym_try_statement_repeat1,
  [54805] = 3,
    ACTIONS(1020), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1018), 4,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [54818] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_PIPE,
    STATE(1719), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3407), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54833] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3576), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3671), 1,
      anon_sym_LBRACE,
    ACTIONS(3673), 1,
      anon_sym_DASH_GT,
    ACTIONS(3675), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3677), 1,
      anon_sym_LBRACK,
  [54852] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3679), 1,
      anon_sym_PIPE,
    STATE(1702), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3174), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54867] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3682), 1,
      anon_sym_LBRACE,
    ACTIONS(3684), 1,
      anon_sym_COLON,
    STATE(559), 1,
      sym_enum_declaration_list,
    STATE(2246), 1,
      sym_class_interface_clause,
  [54886] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3686), 1,
      anon_sym_AMP,
    STATE(1704), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3183), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54901] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3689), 1,
      anon_sym_PIPE,
    STATE(1705), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3195), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54916] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3692), 1,
      sym_name,
    STATE(1795), 1,
      sym_namespace_name,
    STATE(2083), 1,
      sym_namespace_use_group_clause,
    ACTIONS(3694), 2,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
  [54933] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3696), 1,
      anon_sym_LBRACE,
    ACTIONS(3698), 1,
      anon_sym_COLON,
    STATE(1986), 1,
      sym_enum_declaration_list,
    STATE(2419), 1,
      sym_class_interface_clause,
  [54952] = 4,
    ACTIONS(1068), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1066), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3700), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [54967] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3702), 1,
      aux_sym_if_statement_token2,
    ACTIONS(3704), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3707), 1,
      aux_sym_else_clause_token1,
    STATE(1709), 1,
      aux_sym_if_statement_repeat2,
    STATE(1989), 1,
      sym_else_if_clause_2,
  [54986] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3455), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(2103), 1,
      sym_namespace_aliasing_clause,
    ACTIONS(3453), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [55001] = 3,
    ACTIONS(1036), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1034), 4,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [55014] = 5,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym_BSLASH,
    STATE(530), 1,
      sym_compound_statement,
    ACTIONS(3709), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55031] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3713), 1,
      anon_sym_BSLASH,
    STATE(1667), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3553), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [55046] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3537), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [55061] = 4,
    ACTIONS(1074), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1072), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3716), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55076] = 4,
    ACTIONS(1086), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1084), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3718), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55091] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3657), 1,
      anon_sym_AMP,
    ACTIONS(3720), 1,
      anon_sym_RPAREN,
    STATE(2391), 2,
      sym_variable_name,
      sym_variable_reference,
  [55108] = 4,
    ACTIONS(1150), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1148), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3722), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55123] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3598), 1,
      anon_sym_PIPE,
    STATE(1705), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3390), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [55138] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3421), 1,
      aux_sym_catch_clause_token1,
    ACTIONS(3423), 1,
      aux_sym_finally_clause_token1,
    STATE(1537), 3,
      sym_catch_clause,
      sym_finally_clause,
      aux_sym_try_statement_repeat1,
  [55153] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3576), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3724), 1,
      anon_sym_LBRACE,
    ACTIONS(3726), 1,
      anon_sym_DASH_GT,
    ACTIONS(3728), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3730), 1,
      anon_sym_LBRACK,
  [55172] = 4,
    ACTIONS(1138), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1136), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3732), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55187] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3576), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3734), 1,
      anon_sym_LBRACE,
    ACTIONS(3736), 1,
      anon_sym_DASH_GT,
    ACTIONS(3738), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3740), 1,
      anon_sym_LBRACK,
  [55206] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3696), 1,
      anon_sym_LBRACE,
    ACTIONS(3742), 1,
      anon_sym_COLON,
    STATE(2102), 1,
      sym_enum_declaration_list,
    STATE(2344), 1,
      sym_class_interface_clause,
  [55225] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3576), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3744), 1,
      anon_sym_LBRACE,
    ACTIONS(3746), 1,
      anon_sym_DASH_GT,
    ACTIONS(3748), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3750), 1,
      anon_sym_LBRACK,
  [55244] = 4,
    ACTIONS(1040), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1038), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3752), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55259] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3576), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3744), 1,
      anon_sym_LBRACE,
    ACTIONS(3750), 1,
      anon_sym_LBRACK,
    ACTIONS(3754), 1,
      anon_sym_DASH_GT,
    ACTIONS(3756), 1,
      anon_sym_QMARK_DASH_GT,
  [55278] = 4,
    ACTIONS(1116), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1114), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3758), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55293] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3692), 1,
      sym_name,
    STATE(1795), 1,
      sym_namespace_name,
    STATE(2402), 1,
      sym_namespace_use_group_clause,
    ACTIONS(3694), 2,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
  [55310] = 5,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym_BSLASH,
    STATE(2124), 1,
      sym_compound_statement,
    ACTIONS(3760), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55327] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3574), 1,
      anon_sym_LBRACE,
    ACTIONS(3576), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3582), 1,
      anon_sym_LBRACK,
    ACTIONS(3762), 1,
      anon_sym_DASH_GT,
    ACTIONS(3764), 1,
      anon_sym_QMARK_DASH_GT,
  [55346] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3576), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3630), 1,
      anon_sym_LBRACE,
    ACTIONS(3636), 1,
      anon_sym_LBRACK,
    ACTIONS(3766), 1,
      anon_sym_DASH_GT,
    ACTIONS(3768), 1,
      anon_sym_QMARK_DASH_GT,
  [55365] = 5,
    ACTIONS(121), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3770), 1,
      sym_name,
    ACTIONS(3772), 1,
      anon_sym_LBRACE,
    STATE(611), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [55382] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3576), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3744), 1,
      anon_sym_LBRACE,
    ACTIONS(3750), 1,
      anon_sym_LBRACK,
    ACTIONS(3774), 1,
      anon_sym_DASH_GT,
    ACTIONS(3776), 1,
      anon_sym_QMARK_DASH_GT,
  [55401] = 5,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3778), 1,
      sym_name,
    ACTIONS(3780), 1,
      anon_sym_LBRACE,
    STATE(593), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [55418] = 6,
    ACTIONS(1011), 1,
      aux_sym_while_statement_token1,
    ACTIONS(1013), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3782), 1,
      aux_sym_else_if_clause_token1,
    STATE(1736), 1,
      aux_sym_if_statement_repeat1,
    STATE(2111), 1,
      sym_else_if_clause,
  [55437] = 6,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3592), 1,
      sym_name,
    ACTIONS(3594), 1,
      anon_sym_BSLASH,
    STATE(1730), 1,
      sym_namespace_name,
    STATE(2176), 1,
      sym_compound_statement,
  [55456] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3682), 1,
      anon_sym_LBRACE,
    ACTIONS(3785), 1,
      anon_sym_COLON,
    STATE(546), 1,
      sym_enum_declaration_list,
    STATE(2194), 1,
      sym_class_interface_clause,
  [55475] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    ACTIONS(3527), 1,
      anon_sym_COMMA,
    ACTIONS(3787), 1,
      anon_sym_LBRACE,
    STATE(1979), 1,
      aux_sym_base_clause_repeat1,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
  [55494] = 4,
    ACTIONS(1144), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1142), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3789), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55509] = 4,
    ACTIONS(1104), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1102), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3791), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55524] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3793), 1,
      anon_sym_PIPE,
    STATE(1691), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3401), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [55539] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_PIPE,
    STATE(1692), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3384), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [55554] = 3,
    ACTIONS(1032), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1030), 4,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [55567] = 4,
    ACTIONS(1122), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1120), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3795), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55582] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3797), 1,
      anon_sym_BSLASH,
    STATE(1746), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3638), 3,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
  [55597] = 4,
    ACTIONS(1110), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1108), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3800), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55612] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3802), 1,
      anon_sym_COMMA,
    STATE(1748), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(3537), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [55627] = 4,
    ACTIONS(1098), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1096), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3805), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55642] = 4,
    ACTIONS(1046), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1044), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3807), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55657] = 4,
    ACTIONS(1058), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1056), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3809), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55672] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3653), 1,
      anon_sym_PIPE,
    STATE(1693), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3407), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [55687] = 4,
    ACTIONS(1052), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1050), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3811), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55702] = 6,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(2427), 1,
      anon_sym_COLON,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1598), 1,
      sym_formal_parameters,
    STATE(2249), 1,
      sym_reference_modifier,
  [55721] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1866), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3813), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55735] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(444), 1,
      sym_declaration_list,
    STATE(2409), 1,
      sym_class_interface_clause,
  [55751] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3817), 4,
      aux_sym_namespace_use_declaration_token1,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [55761] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(436), 1,
      sym_declaration_list,
    STATE(2224), 1,
      sym_class_interface_clause,
  [55777] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1098), 1,
      sym_compound_statement,
    STATE(2221), 1,
      sym__return_type,
  [55793] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3821), 1,
      anon_sym_COMMA,
    STATE(1760), 1,
      aux_sym_global_declaration_repeat1,
    ACTIONS(3819), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55807] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1762), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3824), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55821] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3828), 1,
      anon_sym_COMMA,
    STATE(1762), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3826), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55835] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1799), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3831), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55849] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3833), 1,
      anon_sym_SEMI,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      sym__automatic_semicolon,
    STATE(1379), 1,
      sym_compound_statement,
  [55865] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(452), 1,
      sym_declaration_list,
    STATE(2192), 1,
      sym_class_interface_clause,
  [55881] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1690), 4,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [55891] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1762), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3839), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55905] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3843), 1,
      anon_sym_COMMA,
    STATE(1797), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(3841), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55919] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3845), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [55929] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1114), 1,
      sym_compound_statement,
    STATE(2231), 1,
      sym__return_type,
  [55945] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3537), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [55955] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1121), 1,
      sym_compound_statement,
    STATE(2261), 1,
      sym__return_type,
  [55971] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1767), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3847), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55985] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1762), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3849), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55999] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1761), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3851), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56013] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3817), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [56023] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3657), 1,
      anon_sym_AMP,
    STATE(2026), 2,
      sym_variable_name,
      sym_variable_reference,
  [56037] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1091), 1,
      sym_compound_statement,
    STATE(2329), 1,
      sym__return_type,
  [56053] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3243), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [56063] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3853), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [56073] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3853), 4,
      aux_sym_namespace_use_declaration_token1,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [56083] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3855), 1,
      anon_sym_AMP,
    STATE(1820), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3191), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [56097] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1762), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3858), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56111] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1774), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3860), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56125] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1762), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3851), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56139] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1762), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3862), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56153] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1783), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3864), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56167] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2427), 1,
      anon_sym_COLON,
    ACTIONS(3594), 1,
      anon_sym_BSLASH,
    ACTIONS(3866), 1,
      sym_name,
    STATE(2467), 1,
      sym_namespace_name,
  [56183] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1649), 1,
      sym_formal_parameters,
    STATE(2425), 1,
      sym_reference_modifier,
  [56199] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_COMMA,
    STATE(1859), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(3529), 2,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [56213] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(450), 1,
      sym_declaration_list,
    STATE(2420), 1,
      sym_class_interface_clause,
  [56229] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1762), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3864), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56243] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3638), 4,
      anon_sym_COMMA,
      anon_sym_BSLASH,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
  [56253] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1786), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3868), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56267] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3872), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(2235), 1,
      sym_namespace_aliasing_clause,
    ACTIONS(3870), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [56281] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1792), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3874), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56295] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    STATE(1797), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(3876), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56309] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3682), 1,
      anon_sym_LBRACE,
    STATE(455), 1,
      sym_enum_declaration_list,
    STATE(2418), 1,
      sym_class_interface_clause,
  [56325] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1762), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3881), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56339] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(439), 1,
      sym_declaration_list,
    STATE(2293), 1,
      sym_class_interface_clause,
  [56355] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1657), 1,
      sym_formal_parameters,
    STATE(2304), 1,
      sym_reference_modifier,
  [56371] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1113), 1,
      sym_declaration_list,
    STATE(2348), 1,
      sym_class_interface_clause,
  [56387] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3883), 4,
      aux_sym_namespace_use_declaration_token1,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [56397] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1088), 1,
      sym_declaration_list,
    STATE(2350), 1,
      sym_class_interface_clause,
  [56413] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3843), 1,
      anon_sym_COMMA,
    STATE(1903), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(3841), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56427] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3638), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LBRACE,
  [56437] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(2539), 1,
      sym_declare_directive,
    ACTIONS(3885), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [56449] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1632), 1,
      sym_formal_parameters,
    STATE(2288), 1,
      sym_reference_modifier,
  [56465] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3070), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(3080), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3887), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(2470), 1,
      sym_static_modifier,
  [56481] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3891), 1,
      anon_sym_COMMA,
    STATE(1760), 1,
      aux_sym_global_declaration_repeat1,
    ACTIONS(3889), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56495] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3893), 1,
      anon_sym_SQUOTE,
    ACTIONS(3895), 1,
      aux_sym_string_token2,
    ACTIONS(3897), 1,
      sym_string_value,
    STATE(1864), 1,
      aux_sym_string_repeat1,
  [56511] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3901), 1,
      anon_sym_COMMA,
    STATE(1853), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(3899), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56525] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3905), 1,
      anon_sym_COMMA,
    STATE(1832), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(3903), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56539] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1603), 1,
      sym_formal_parameters,
    STATE(2321), 1,
      sym_reference_modifier,
  [56555] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3907), 1,
      anon_sym_SQUOTE,
    ACTIONS(3909), 1,
      aux_sym_string_token2,
    ACTIONS(3911), 1,
      sym_string_value,
    STATE(1842), 1,
      aux_sym_string_repeat1,
  [56571] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(2582), 1,
      sym_declare_directive,
    ACTIONS(3885), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [56583] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3657), 1,
      anon_sym_AMP,
    STATE(2391), 2,
      sym_variable_name,
      sym_variable_reference,
  [56597] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1647), 1,
      sym_formal_parameters,
    STATE(2331), 1,
      sym_reference_modifier,
  [56613] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1718), 1,
      sym_declaration_list,
    STATE(2295), 1,
      sym_class_interface_clause,
  [56629] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3913), 1,
      anon_sym_AMP,
    STATE(1820), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3183), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [56643] = 5,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(906), 1,
      sym_compound_statement,
    STATE(2307), 1,
      sym__return_type,
  [56659] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(2033), 1,
      sym_formal_parameters,
    STATE(2238), 1,
      sym_reference_modifier,
  [56675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3918), 1,
      sym_nowdoc_string,
    STATE(1823), 1,
      aux_sym_nowdoc_body_repeat1,
    ACTIONS(3916), 2,
      sym_heredoc_end,
      sym__new_line,
  [56689] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(2122), 1,
      sym_formal_parameters,
    STATE(2226), 1,
      sym_reference_modifier,
  [56705] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3923), 1,
      anon_sym_PIPE,
    STATE(1825), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3921), 2,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
  [56719] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1749), 1,
      sym_declaration_list,
    STATE(2317), 1,
      sym_class_interface_clause,
  [56735] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3901), 1,
      anon_sym_COMMA,
    STATE(1877), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(3926), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56749] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3891), 1,
      anon_sym_COMMA,
    STATE(1878), 1,
      aux_sym_global_declaration_repeat1,
    ACTIONS(3928), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56763] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3905), 1,
      anon_sym_COMMA,
    STATE(1832), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(3930), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56777] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3843), 1,
      anon_sym_COMMA,
    STATE(1881), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(3932), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56791] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3696), 1,
      anon_sym_LBRACE,
    STATE(2177), 1,
      sym_enum_declaration_list,
    STATE(2318), 1,
      sym_class_interface_clause,
  [56807] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3936), 1,
      anon_sym_COMMA,
    STATE(1832), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(3934), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56821] = 5,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(914), 1,
      sym_compound_statement,
    STATE(2320), 1,
      sym__return_type,
  [56837] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1890), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3939), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56851] = 5,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(916), 1,
      sym_compound_statement,
    STATE(2322), 1,
      sym__return_type,
  [56867] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(2148), 1,
      sym_formal_parameters,
    STATE(2205), 1,
      sym_reference_modifier,
  [56883] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    STATE(2106), 1,
      sym_declaration_list,
    STATE(2341), 1,
      sym_base_clause,
  [56899] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3905), 1,
      anon_sym_COMMA,
    STATE(1813), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(3941), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56913] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3905), 1,
      anon_sym_COMMA,
    STATE(1832), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(3943), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56927] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1606), 1,
      sym_formal_parameters,
    STATE(2347), 1,
      sym_reference_modifier,
  [56943] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1762), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3945), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56957] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3947), 1,
      anon_sym_SQUOTE,
    ACTIONS(3949), 1,
      aux_sym_string_token2,
    ACTIONS(3951), 1,
      sym_string_value,
    STATE(1851), 1,
      aux_sym_string_repeat1,
  [56973] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1660), 1,
      sym_declaration_list,
    STATE(2326), 1,
      sym_class_interface_clause,
  [56989] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3195), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [56999] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3872), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(2404), 1,
      sym_namespace_aliasing_clause,
    ACTIONS(3953), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [57013] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1055), 1,
      sym_compound_statement,
    STATE(2219), 1,
      sym__return_type,
  [57029] = 4,
    ACTIONS(1574), 1,
      anon_sym_LPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(2324), 1,
      sym_arguments,
    ACTIONS(3509), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [57043] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3174), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [57053] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    ACTIONS(3955), 1,
      anon_sym_SEMI,
    ACTIONS(3957), 1,
      sym__automatic_semicolon,
    STATE(1374), 1,
      sym_compound_statement,
  [57069] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    STATE(919), 1,
      sym_declaration_list,
    STATE(2337), 1,
      sym_class_interface_clause,
  [57085] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3959), 1,
      anon_sym_SQUOTE,
    ACTIONS(3961), 1,
      aux_sym_string_token2,
    ACTIONS(3964), 1,
      sym_string_value,
    STATE(1851), 1,
      aux_sym_string_repeat1,
  [57101] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1127), 1,
      sym_declaration_list,
    STATE(2266), 1,
      sym_class_interface_clause,
  [57117] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3969), 1,
      anon_sym_COMMA,
    STATE(1853), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(3967), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57131] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3905), 1,
      anon_sym_COMMA,
    STATE(1880), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(3972), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57145] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    ACTIONS(3974), 1,
      anon_sym_SEMI,
    ACTIONS(3976), 1,
      sym__automatic_semicolon,
    STATE(1363), 1,
      sym_compound_statement,
  [57161] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3883), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [57171] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(453), 1,
      sym_declaration_list,
    STATE(2303), 1,
      sym_class_interface_clause,
  [57187] = 5,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(924), 1,
      sym_compound_statement,
    STATE(2367), 1,
      sym__return_type,
  [57203] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_COMMA,
    STATE(1892), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(3978), 2,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [57217] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1641), 1,
      sym_formal_parameters,
    STATE(2297), 1,
      sym_reference_modifier,
  [57233] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1753), 1,
      sym_declaration_list,
    STATE(2374), 1,
      sym_class_interface_clause,
  [57249] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1084), 1,
      sym_compound_statement,
    STATE(2319), 1,
      sym__return_type,
  [57265] = 5,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(926), 1,
      sym_compound_statement,
    STATE(2375), 1,
      sym__return_type,
  [57281] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3949), 1,
      aux_sym_string_token2,
    ACTIONS(3951), 1,
      sym_string_value,
    ACTIONS(3980), 1,
      anon_sym_SQUOTE,
    STATE(1851), 1,
      aux_sym_string_repeat1,
  [57297] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3982), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [57307] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1762), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3984), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57321] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1841), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3986), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57335] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3905), 1,
      anon_sym_COMMA,
    STATE(1839), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(3988), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57349] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3992), 1,
      anon_sym_PIPE,
    STATE(1897), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3990), 2,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
  [57363] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1740), 1,
      sym_declaration_list,
    STATE(2380), 1,
      sym_class_interface_clause,
  [57379] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    ACTIONS(3994), 1,
      anon_sym_SEMI,
    ACTIONS(3996), 1,
      sym__automatic_semicolon,
    STATE(1369), 1,
      sym_compound_statement,
  [57395] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1074), 1,
      sym_compound_statement,
    STATE(2415), 1,
      sym__return_type,
  [57411] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(2466), 1,
      sym_declare_directive,
    ACTIONS(3885), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [57423] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3998), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [57433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4002), 1,
      sym_nowdoc_string,
    STATE(1823), 1,
      aux_sym_nowdoc_body_repeat1,
    ACTIONS(4000), 2,
      sym_heredoc_end,
      sym__new_line,
  [57447] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    STATE(935), 1,
      sym_declaration_list,
    STATE(2386), 1,
      sym_class_interface_clause,
  [57463] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3901), 1,
      anon_sym_COMMA,
    STATE(1853), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(4004), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57477] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3891), 1,
      anon_sym_COMMA,
    STATE(1760), 1,
      aux_sym_global_declaration_repeat1,
    ACTIONS(4006), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57491] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3843), 1,
      anon_sym_COMMA,
    STATE(1912), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(4008), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57505] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3905), 1,
      anon_sym_COMMA,
    STATE(1832), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(4010), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57519] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3843), 1,
      anon_sym_COMMA,
    STATE(1797), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(4008), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57533] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3905), 1,
      anon_sym_COMMA,
    STATE(1829), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(4012), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57547] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    STATE(936), 1,
      sym_declaration_list,
    STATE(2387), 1,
      sym_class_interface_clause,
  [57563] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(2576), 1,
      sym_declare_directive,
    ACTIONS(3885), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [57575] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(1077), 1,
      sym_compound_statement,
    STATE(2414), 1,
      sym__return_type,
  [57591] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3183), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
  [57601] = 5,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(952), 1,
      sym_compound_statement,
    STATE(2445), 1,
      sym__return_type,
  [57617] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3080), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(4014), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(4016), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(2470), 1,
      sym_static_modifier,
  [57633] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1906), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(4018), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57647] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1762), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3813), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57661] = 5,
    ACTIONS(851), 1,
      anon_sym_COMMA,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4020), 1,
      anon_sym_EQ,
    ACTIONS(4022), 1,
      anon_sym_RPAREN,
    STATE(2129), 1,
      aux_sym__list_destructing_repeat1,
  [57677] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_COMMA,
    STATE(1892), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(3537), 2,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [57691] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1598), 1,
      sym_formal_parameters,
    STATE(2249), 1,
      sym_reference_modifier,
  [57707] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3696), 1,
      anon_sym_LBRACE,
    STATE(2013), 1,
      sym_enum_declaration_list,
    STATE(2398), 1,
      sym_class_interface_clause,
  [57723] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1708), 1,
      sym_declaration_list,
    STATE(2444), 1,
      sym_class_interface_clause,
  [57739] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1053), 1,
      sym_declaration_list,
    STATE(2440), 1,
      sym_class_interface_clause,
  [57755] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3992), 1,
      anon_sym_PIPE,
    STATE(1825), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(4027), 2,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
  [57769] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3901), 1,
      anon_sym_COMMA,
    STATE(1812), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(4029), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57783] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3238), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [57793] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4033), 1,
      anon_sym_EQ,
    ACTIONS(4031), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [57805] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3891), 1,
      anon_sym_COMMA,
    STATE(1810), 1,
      aux_sym_global_declaration_repeat1,
    ACTIONS(4035), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57819] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1942), 1,
      sym_formal_parameters,
    STATE(2443), 1,
      sym_reference_modifier,
  [57835] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3843), 1,
      anon_sym_COMMA,
    STATE(1797), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(4037), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57849] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    STATE(949), 1,
      sym_declaration_list,
    STATE(2429), 1,
      sym_class_interface_clause,
  [57865] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3417), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3682), 1,
      anon_sym_LBRACE,
    STATE(468), 1,
      sym_enum_declaration_list,
    STATE(2413), 1,
      sym_class_interface_clause,
  [57881] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1762), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(4039), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57895] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3982), 4,
      aux_sym_namespace_use_declaration_token1,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [57905] = 5,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(939), 1,
      sym_compound_statement,
    STATE(2405), 1,
      sym__return_type,
  [57921] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3843), 1,
      anon_sym_COMMA,
    STATE(1768), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(4041), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57935] = 5,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3415), 1,
      aux_sym_base_clause_token1,
    ACTIONS(4043), 1,
      anon_sym_LBRACE,
    STATE(547), 1,
      sym_declaration_list,
    STATE(2232), 1,
      sym_base_clause,
  [57951] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3815), 1,
      anon_sym_COMMA,
    STATE(1785), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(4045), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57965] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3843), 1,
      anon_sym_COMMA,
    STATE(1797), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(4047), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57979] = 5,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    STATE(941), 1,
      sym_compound_statement,
    STATE(2281), 1,
      sym__return_type,
  [57995] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4049), 1,
      anon_sym_COMMA,
    ACTIONS(4051), 1,
      anon_sym_RBRACK,
    STATE(1936), 1,
      aux_sym_array_creation_expression_repeat1,
  [58008] = 3,
    ACTIONS(1504), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1502), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58019] = 3,
    ACTIONS(1440), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1438), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58030] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4055), 1,
      anon_sym_EQ,
    ACTIONS(4053), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [58041] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4057), 1,
      anon_sym_COMMA,
    ACTIONS(4059), 1,
      anon_sym_RPAREN,
    STATE(1968), 1,
      aux_sym_arguments_repeat1,
  [58054] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3876), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [58063] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    ACTIONS(4061), 1,
      anon_sym_EQ_GT,
    STATE(2625), 1,
      sym__return_type,
  [58076] = 3,
    ACTIONS(1464), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1462), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58087] = 3,
    ACTIONS(1488), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1486), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58098] = 3,
    ACTIONS(1508), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1506), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58109] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4063), 1,
      anon_sym_COMMA,
    ACTIONS(4066), 1,
      anon_sym_RBRACE,
    STATE(1924), 1,
      aux_sym_match_block_repeat1,
  [58122] = 3,
    ACTIONS(1524), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1522), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58133] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(4068), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2050), 1,
      sym_variable_name,
  [58146] = 3,
    ACTIONS(1328), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1326), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58157] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4070), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [58166] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2595), 1,
      anon_sym_EQ_GT,
    ACTIONS(4072), 1,
      anon_sym_COMMA,
    STATE(1929), 1,
      aux_sym_match_condition_list_repeat1,
  [58179] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4075), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [58188] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4077), 1,
      sym_name,
    ACTIONS(4079), 1,
      anon_sym_LBRACE,
    STATE(2227), 1,
      sym_namespace_use_group,
  [58201] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3126), 1,
      anon_sym_RBRACK,
    ACTIONS(4081), 1,
      anon_sym_COMMA,
    STATE(2144), 1,
      aux_sym_attribute_group_repeat1,
  [58214] = 4,
    ACTIONS(851), 1,
      anon_sym_COMMA,
    ACTIONS(1672), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(2130), 1,
      aux_sym__list_destructing_repeat1,
  [58227] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_RPAREN,
    ACTIONS(4083), 1,
      anon_sym_COMMA,
    STATE(2060), 1,
      aux_sym_formal_parameters_repeat1,
  [58240] = 3,
    ACTIONS(1416), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1414), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58251] = 4,
    ACTIONS(835), 1,
      anon_sym_RBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4085), 1,
      anon_sym_COMMA,
    STATE(2141), 1,
      aux_sym_array_creation_expression_repeat1,
  [58264] = 4,
    ACTIONS(845), 1,
      anon_sym_RBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4087), 1,
      anon_sym_COMMA,
    STATE(1924), 1,
      aux_sym_match_block_repeat1,
  [58277] = 4,
    ACTIONS(943), 1,
      anon_sym_EQ_GT,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4089), 1,
      anon_sym_COMMA,
    STATE(1929), 1,
      aux_sym_match_condition_list_repeat1,
  [58290] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4079), 1,
      anon_sym_LBRACE,
    ACTIONS(4091), 1,
      sym_name,
    STATE(2227), 1,
      sym_namespace_use_group,
  [58303] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3594), 1,
      anon_sym_BSLASH,
    ACTIONS(3866), 1,
      sym_name,
    STATE(2467), 1,
      sym_namespace_name,
  [58316] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4093), 1,
      anon_sym_COMMA,
    ACTIONS(4095), 1,
      anon_sym_RPAREN,
    STATE(1944), 1,
      aux_sym_array_creation_expression_repeat1,
  [58329] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    ACTIONS(4097), 1,
      anon_sym_EQ_GT,
    STATE(2601), 1,
      sym__return_type,
  [58342] = 4,
    ACTIONS(851), 1,
      anon_sym_COMMA,
    ACTIONS(1672), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(2099), 1,
      aux_sym__list_destructing_repeat1,
  [58355] = 4,
    ACTIONS(831), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4099), 1,
      anon_sym_COMMA,
    STATE(2120), 1,
      aux_sym_array_creation_expression_repeat1,
  [58368] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4103), 1,
      anon_sym_EQ,
    ACTIONS(4101), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [58379] = 3,
    ACTIONS(1448), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1446), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58390] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4105), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [58399] = 4,
    ACTIONS(851), 1,
      anon_sym_COMMA,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4107), 1,
      anon_sym_RPAREN,
    STATE(2130), 1,
      aux_sym__list_destructing_repeat1,
  [58412] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4109), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [58421] = 3,
    ACTIONS(1228), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1226), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58432] = 4,
    ACTIONS(851), 1,
      anon_sym_COMMA,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4111), 1,
      anon_sym_RPAREN,
    STATE(2130), 1,
      aux_sym__list_destructing_repeat1,
  [58445] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4113), 1,
      anon_sym_COMMA,
    ACTIONS(4115), 1,
      anon_sym_RBRACE,
    STATE(1999), 1,
      aux_sym_match_block_repeat1,
  [58458] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3537), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [58467] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    ACTIONS(4117), 1,
      anon_sym_EQ_GT,
    STATE(2471), 1,
      sym__return_type,
  [58480] = 3,
    ACTIONS(1496), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1494), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58491] = 3,
    ACTIONS(1512), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1510), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58502] = 4,
    ACTIONS(851), 1,
      anon_sym_COMMA,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4119), 1,
      anon_sym_RPAREN,
    STATE(1951), 1,
      aux_sym__list_destructing_repeat1,
  [58515] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4121), 1,
      anon_sym_COMMA,
    ACTIONS(4123), 1,
      anon_sym_RPAREN,
    STATE(1934), 1,
      aux_sym_formal_parameters_repeat1,
  [58528] = 4,
    ACTIONS(1710), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1696), 1,
      sym_variable_name,
    STATE(2015), 1,
      sym_property_element,
  [58541] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4127), 1,
      anon_sym_EQ,
    ACTIONS(4125), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [58552] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4129), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [58561] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4131), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [58570] = 3,
    ACTIONS(1344), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1342), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58581] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(4133), 1,
      anon_sym_RPAREN,
    STATE(2497), 1,
      sym_variable_name,
  [58594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4135), 1,
      sym__new_line,
    ACTIONS(4137), 1,
      sym_heredoc_end,
    STATE(2383), 1,
      sym_nowdoc_body,
  [58607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4139), 1,
      sym__new_line,
    ACTIONS(4141), 1,
      sym_heredoc_end,
    STATE(2382), 1,
      sym_heredoc_body,
  [58620] = 4,
    ACTIONS(1710), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1696), 1,
      sym_variable_name,
    STATE(1838), 1,
      sym_property_element,
  [58633] = 4,
    ACTIONS(779), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4143), 1,
      anon_sym_COMMA,
    STATE(2108), 1,
      aux_sym_arguments_repeat1,
  [58646] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3209), 1,
      anon_sym_COMMA,
    ACTIONS(4145), 1,
      anon_sym_RPAREN,
    STATE(1975), 1,
      aux_sym_unset_statement_repeat1,
  [58659] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4147), 1,
      anon_sym_COMMA,
    ACTIONS(4149), 1,
      anon_sym_RBRACK,
    STATE(1985), 1,
      aux_sym__array_destructing_repeat1,
  [58672] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4151), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [58681] = 4,
    ACTIONS(833), 1,
      anon_sym_RBRACK,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4153), 1,
      anon_sym_COMMA,
    STATE(2141), 1,
      aux_sym_array_creation_expression_repeat1,
  [58694] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3720), 1,
      anon_sym_RPAREN,
    ACTIONS(4155), 1,
      anon_sym_COMMA,
    STATE(1997), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
  [58707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4139), 1,
      sym__new_line,
    ACTIONS(4157), 1,
      sym_heredoc_end,
    STATE(2371), 1,
      sym_heredoc_body,
  [58720] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3344), 1,
      anon_sym_RPAREN,
    ACTIONS(4159), 1,
      anon_sym_COMMA,
    STATE(1975), 1,
      aux_sym_unset_statement_repeat1,
  [58733] = 3,
    ACTIONS(1384), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1382), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58744] = 3,
    ACTIONS(1368), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1366), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58755] = 3,
    ACTIONS(1356), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1354), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58766] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_COMMA,
    ACTIONS(4162), 1,
      anon_sym_LBRACE,
    STATE(1892), 1,
      aux_sym_base_clause_repeat1,
  [58779] = 4,
    ACTIONS(827), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4164), 1,
      anon_sym_COMMA,
    STATE(2120), 1,
      aux_sym_array_creation_expression_repeat1,
  [58792] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4166), 1,
      anon_sym_COMMA,
    ACTIONS(4168), 1,
      anon_sym_RBRACK,
    STATE(1932), 1,
      aux_sym_attribute_group_repeat1,
  [58805] = 3,
    ACTIONS(1232), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1230), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58816] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4172), 1,
      anon_sym_EQ,
    ACTIONS(4170), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [58827] = 3,
    ACTIONS(1336), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1334), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58838] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4174), 1,
      anon_sym_COMMA,
    ACTIONS(4177), 1,
      anon_sym_RBRACK,
    STATE(1985), 1,
      aux_sym__array_destructing_repeat1,
  [58851] = 3,
    ACTIONS(1480), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1478), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58862] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3819), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [58871] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4181), 1,
      anon_sym_EQ,
    ACTIONS(4179), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [58882] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4185), 1,
      aux_sym_else_clause_token1,
    ACTIONS(4183), 2,
      aux_sym_if_statement_token2,
      aux_sym_else_if_clause_token1,
  [58893] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4187), 1,
      anon_sym_COMMA,
    ACTIONS(4190), 1,
      anon_sym_RBRACE,
    STATE(1990), 1,
      aux_sym_namespace_use_group_repeat1,
  [58906] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4192), 1,
      anon_sym_LBRACE,
    ACTIONS(4194), 1,
      anon_sym_COLON,
    STATE(513), 1,
      sym_switch_block,
  [58919] = 4,
    ACTIONS(1710), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1696), 1,
      sym_variable_name,
    STATE(1882), 1,
      sym_property_element,
  [58932] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4198), 1,
      anon_sym_EQ,
    ACTIONS(4196), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [58943] = 3,
    ACTIONS(1408), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1406), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58954] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4200), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [58963] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1771), 1,
      anon_sym_RPAREN,
    ACTIONS(4202), 1,
      anon_sym_COMMA,
    STATE(2060), 1,
      aux_sym_formal_parameters_repeat1,
  [58976] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4204), 1,
      anon_sym_COMMA,
    ACTIONS(4207), 1,
      anon_sym_RPAREN,
    STATE(1997), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
  [58989] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_LBRACE,
    ACTIONS(4211), 1,
      anon_sym_COLON,
    STATE(2069), 1,
      sym_switch_block,
  [59002] = 4,
    ACTIONS(861), 1,
      anon_sym_RBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4213), 1,
      anon_sym_COMMA,
    STATE(1924), 1,
      aux_sym_match_block_repeat1,
  [59015] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4020), 1,
      anon_sym_EQ,
    ACTIONS(4215), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [59026] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4147), 1,
      anon_sym_COMMA,
    ACTIONS(4217), 1,
      anon_sym_RBRACK,
    STATE(1970), 1,
      aux_sym__array_destructing_repeat1,
  [59039] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4219), 1,
      anon_sym_COMMA,
    ACTIONS(4221), 1,
      anon_sym_RBRACK,
    STATE(1972), 1,
      aux_sym_array_creation_expression_repeat1,
  [59052] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3146), 1,
      anon_sym_RBRACK,
    ACTIONS(4223), 1,
      anon_sym_COMMA,
    STATE(2144), 1,
      aux_sym_attribute_group_repeat1,
  [59065] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4147), 1,
      anon_sym_COMMA,
    ACTIONS(4217), 1,
      anon_sym_RBRACK,
    STATE(1985), 1,
      aux_sym__array_destructing_repeat1,
  [59078] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3967), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [59087] = 3,
    ACTIONS(1264), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1262), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59098] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4225), 1,
      anon_sym_COMMA,
    ACTIONS(4227), 1,
      anon_sym_RBRACK,
    STATE(2003), 1,
      aux_sym_attribute_group_repeat1,
  [59111] = 4,
    ACTIONS(851), 1,
      anon_sym_COMMA,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3221), 1,
      anon_sym_RPAREN,
    STATE(1948), 1,
      aux_sym__list_destructing_repeat1,
  [59124] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4231), 1,
      anon_sym_EQ,
    ACTIONS(4229), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59135] = 3,
    ACTIONS(1324), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1322), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59146] = 3,
    ACTIONS(1200), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1198), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59157] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4233), 1,
      anon_sym_COMMA,
    ACTIONS(4235), 1,
      anon_sym_RBRACE,
    STATE(1937), 1,
      aux_sym_match_block_repeat1,
  [59170] = 3,
    ACTIONS(1156), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1154), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59181] = 3,
    ACTIONS(1320), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1318), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59192] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3934), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [59201] = 3,
    ACTIONS(1180), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1178), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59212] = 3,
    ACTIONS(1316), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1314), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59223] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4237), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [59232] = 3,
    ACTIONS(1308), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1306), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59243] = 3,
    ACTIONS(1304), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1302), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4139), 1,
      sym__new_line,
    ACTIONS(4239), 1,
      sym_heredoc_end,
    STATE(2278), 1,
      sym_heredoc_body,
  [59267] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3921), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [59276] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3078), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(4241), 1,
      aux_sym_class_declaration_token1,
    STATE(2499), 1,
      sym_readonly_modifier,
  [59289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4243), 1,
      anon_sym_,
    ACTIONS(4245), 1,
      sym_nowdoc_string,
    STATE(1875), 1,
      aux_sym_nowdoc_body_repeat1,
  [59302] = 3,
    ACTIONS(1172), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1170), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59313] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4247), 1,
      anon_sym_COMMA,
    ACTIONS(4249), 1,
      anon_sym_RPAREN,
    STATE(1973), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
  [59326] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4251), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [59335] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4253), 1,
      anon_sym_COMMA,
    ACTIONS(4255), 1,
      anon_sym_RBRACE,
    STATE(1990), 1,
      aux_sym_namespace_use_group_repeat1,
  [59348] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(4257), 1,
      anon_sym_RPAREN,
    STATE(2505), 1,
      sym_variable_name,
  [59361] = 3,
    ACTIONS(1376), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1374), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59372] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(4259), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2057), 1,
      sym_variable_name,
  [59385] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4077), 1,
      sym_name,
    ACTIONS(4079), 1,
      anon_sym_LBRACE,
    STATE(2366), 1,
      sym_namespace_use_group,
  [59398] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    ACTIONS(4261), 1,
      anon_sym_EQ_GT,
    STATE(2655), 1,
      sym__return_type,
  [59411] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3078), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(4263), 1,
      aux_sym_class_declaration_token1,
    STATE(2611), 1,
      sym_readonly_modifier,
  [59424] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3209), 1,
      anon_sym_COMMA,
    ACTIONS(4265), 1,
      anon_sym_RPAREN,
    STATE(1975), 1,
      aux_sym_unset_statement_repeat1,
  [59437] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4269), 1,
      anon_sym_EQ,
    ACTIONS(4267), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59448] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_EQ,
    ACTIONS(4271), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59459] = 3,
    ACTIONS(1164), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1162), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59470] = 3,
    ACTIONS(1352), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1350), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59481] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_EQ,
    ACTIONS(4275), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59492] = 3,
    ACTIONS(1164), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1162), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59503] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(4279), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2009), 1,
      sym_variable_name,
  [59516] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4077), 1,
      sym_name,
    ACTIONS(4079), 1,
      anon_sym_LBRACE,
    STATE(2408), 1,
      sym_namespace_use_group,
  [59529] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4079), 1,
      anon_sym_LBRACE,
    ACTIONS(4091), 1,
      sym_name,
    STATE(2408), 1,
      sym_namespace_use_group,
  [59542] = 3,
    ACTIONS(1260), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1258), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59553] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4283), 1,
      anon_sym_EQ,
    ACTIONS(4281), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59564] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4285), 1,
      anon_sym_SQUOTE,
    ACTIONS(4287), 1,
      anon_sym_DQUOTE,
    ACTIONS(4289), 1,
      sym_heredoc_start,
  [59577] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4293), 1,
      anon_sym_EQ,
    ACTIONS(4291), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59588] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4297), 1,
      aux_sym_else_clause_token1,
    ACTIONS(4295), 2,
      aux_sym_if_statement_token2,
      aux_sym_else_if_clause_token1,
  [59599] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4301), 1,
      anon_sym_EQ,
    ACTIONS(4299), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59610] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4079), 1,
      anon_sym_LBRACE,
    ACTIONS(4091), 1,
      sym_name,
    STATE(2403), 1,
      sym_namespace_use_group,
  [59623] = 3,
    ACTIONS(1260), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1258), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59634] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4303), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [59643] = 3,
    ACTIONS(1220), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1218), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59654] = 3,
    ACTIONS(121), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1987), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [59665] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4305), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [59674] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4309), 1,
      anon_sym_EQ,
    ACTIONS(4307), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59685] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3078), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(4311), 1,
      aux_sym_class_declaration_token1,
    STATE(2574), 1,
      sym_readonly_modifier,
  [59698] = 3,
    ACTIONS(1424), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1422), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59709] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4313), 1,
      anon_sym_COMMA,
    ACTIONS(4316), 1,
      anon_sym_RPAREN,
    STATE(2060), 1,
      aux_sym_formal_parameters_repeat1,
  [59722] = 3,
    ACTIONS(1300), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1298), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59733] = 3,
    ACTIONS(1352), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1350), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59744] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4318), 1,
      anon_sym_SQUOTE,
    ACTIONS(4320), 1,
      anon_sym_DQUOTE,
    ACTIONS(4322), 1,
      sym_heredoc_start,
  [59757] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3078), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(4324), 1,
      aux_sym_class_declaration_token1,
    STATE(2586), 1,
      sym_readonly_modifier,
  [59770] = 3,
    ACTIONS(1276), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1274), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59781] = 3,
    ACTIONS(1256), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1254), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59792] = 3,
    ACTIONS(1284), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1282), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59803] = 3,
    ACTIONS(121), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1828), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [59814] = 3,
    ACTIONS(1364), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1362), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59825] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4326), 1,
      anon_sym_COMMA,
    ACTIONS(4328), 1,
      anon_sym_RPAREN,
    STATE(1980), 1,
      aux_sym_array_creation_expression_repeat1,
  [59838] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4332), 1,
      anon_sym_EQ,
    ACTIONS(4330), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59849] = 3,
    ACTIONS(1476), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1474), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59860] = 3,
    ACTIONS(1380), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1378), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59871] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4336), 1,
      anon_sym_EQ,
    ACTIONS(4334), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59882] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    ACTIONS(4338), 1,
      anon_sym_EQ_GT,
    STATE(2564), 1,
      sym__return_type,
  [59895] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4342), 1,
      anon_sym_EQ,
    ACTIONS(4340), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59906] = 3,
    ACTIONS(1252), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1250), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59917] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_COMMA,
    ACTIONS(3787), 1,
      anon_sym_LBRACE,
    STATE(1979), 1,
      aux_sym_base_clause_repeat1,
  [59930] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4344), 1,
      sym_name,
    ACTIONS(4346), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [59941] = 3,
    ACTIONS(1396), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1394), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59952] = 3,
    ACTIONS(1388), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1386), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59963] = 3,
    ACTIONS(1392), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1390), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59974] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4253), 1,
      anon_sym_COMMA,
    ACTIONS(4348), 1,
      anon_sym_RBRACE,
    STATE(2028), 1,
      aux_sym_namespace_use_group_repeat1,
  [59987] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    ACTIONS(3665), 1,
      anon_sym_LBRACE,
    STATE(2520), 1,
      sym__return_type,
  [60000] = 3,
    ACTIONS(1216), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1214), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60011] = 3,
    ACTIONS(1252), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1250), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60022] = 3,
    ACTIONS(1240), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1238), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60033] = 4,
    ACTIONS(775), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4350), 1,
      anon_sym_COMMA,
    STATE(2108), 1,
      aux_sym_arguments_repeat1,
  [60046] = 3,
    ACTIONS(1532), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1530), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60057] = 3,
    ACTIONS(1268), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1266), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60068] = 3,
    ACTIONS(1436), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1434), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60079] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4020), 1,
      anon_sym_EQ,
    ACTIONS(4352), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [60090] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4354), 1,
      anon_sym_COMMA,
    ACTIONS(4356), 1,
      anon_sym_RPAREN,
    STATE(2088), 1,
      aux_sym_arguments_repeat1,
  [60103] = 3,
    ACTIONS(1456), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1454), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60114] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4077), 1,
      sym_name,
    ACTIONS(4079), 1,
      anon_sym_LBRACE,
    STATE(2233), 1,
      sym_namespace_use_group,
  [60127] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4358), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [60136] = 3,
    ACTIONS(1248), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1246), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60147] = 3,
    ACTIONS(1372), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1370), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60158] = 4,
    ACTIONS(851), 1,
      anon_sym_COMMA,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4360), 1,
      anon_sym_RPAREN,
    STATE(2130), 1,
      aux_sym__list_destructing_repeat1,
  [60171] = 3,
    ACTIONS(1160), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1158), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60182] = 3,
    ACTIONS(1192), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1190), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60193] = 3,
    ACTIONS(1528), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1526), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60204] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4362), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [60213] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4364), 1,
      anon_sym_COMMA,
    ACTIONS(4366), 1,
      anon_sym_RPAREN,
    STATE(2114), 1,
      aux_sym_arguments_repeat1,
  [60226] = 3,
    ACTIONS(1248), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1246), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60237] = 3,
    ACTIONS(1484), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1482), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60248] = 3,
    ACTIONS(1472), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1470), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60259] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4368), 1,
      anon_sym_COMMA,
    ACTIONS(4371), 1,
      anon_sym_RPAREN,
    STATE(2108), 1,
      aux_sym_arguments_repeat1,
  [60272] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4373), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [60281] = 3,
    ACTIONS(1400), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1398), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60292] = 3,
    ACTIONS(1460), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1458), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60303] = 4,
    ACTIONS(813), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4375), 1,
      anon_sym_COMMA,
    STATE(2108), 1,
      aux_sym_arguments_repeat1,
  [60316] = 3,
    ACTIONS(1192), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1190), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60327] = 4,
    ACTIONS(791), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4377), 1,
      anon_sym_COMMA,
    STATE(2108), 1,
      aux_sym_arguments_repeat1,
  [60340] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2427), 1,
      anon_sym_COLON,
    ACTIONS(4379), 1,
      anon_sym_LPAREN,
    STATE(2312), 1,
      sym_parenthesized_expression,
  [60353] = 3,
    ACTIONS(1288), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1286), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60364] = 3,
    ACTIONS(1296), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1294), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60375] = 3,
    ACTIONS(1412), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1410), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60386] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_COMMA,
    ACTIONS(4383), 1,
      anon_sym_RPAREN,
    STATE(2157), 1,
      aux_sym_arguments_repeat1,
  [60399] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4385), 1,
      anon_sym_COMMA,
    ACTIONS(4388), 1,
      anon_sym_RPAREN,
    STATE(2120), 1,
      aux_sym_array_creation_expression_repeat1,
  [60412] = 3,
    ACTIONS(1204), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60423] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    ACTIONS(4390), 1,
      anon_sym_EQ_GT,
    STATE(2667), 1,
      sym__return_type,
  [60436] = 3,
    ACTIONS(1468), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1466), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60447] = 3,
    ACTIONS(1420), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1418), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60458] = 3,
    ACTIONS(1272), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1270), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60469] = 3,
    ACTIONS(1520), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1518), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60480] = 3,
    ACTIONS(1244), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1242), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60491] = 3,
    ACTIONS(1236), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1234), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60502] = 4,
    ACTIONS(851), 1,
      anon_sym_COMMA,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_RPAREN,
    STATE(2130), 1,
      aux_sym__list_destructing_repeat1,
  [60515] = 4,
    ACTIONS(1678), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_COMMA,
    STATE(2130), 1,
      aux_sym__list_destructing_repeat1,
  [60528] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4020), 1,
      anon_sym_EQ,
    ACTIONS(4397), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [60539] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4399), 1,
      anon_sym_COMMA,
    ACTIONS(4401), 1,
      anon_sym_RPAREN,
    STATE(2112), 1,
      aux_sym_arguments_repeat1,
  [60552] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_AMP,
    ACTIONS(4403), 1,
      anon_sym_RPAREN,
    STATE(1444), 1,
      aux_sym_intersection_type_repeat1,
  [60565] = 3,
    ACTIONS(1516), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1514), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60576] = 3,
    ACTIONS(1500), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1498), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60587] = 3,
    ACTIONS(1492), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1490), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60598] = 3,
    ACTIONS(121), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1901), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [60609] = 3,
    ACTIONS(1224), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1222), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60620] = 3,
    ACTIONS(1492), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1490), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60631] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4388), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [60640] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4388), 1,
      anon_sym_RBRACK,
    ACTIONS(4405), 1,
      anon_sym_COMMA,
    STATE(2141), 1,
      aux_sym_array_creation_expression_repeat1,
  [60653] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2801), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      sym_name,
  [60662] = 3,
    ACTIONS(1360), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1358), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60673] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4408), 1,
      anon_sym_COMMA,
    ACTIONS(4411), 1,
      anon_sym_RBRACK,
    STATE(2144), 1,
      aux_sym_attribute_group_repeat1,
  [60686] = 3,
    ACTIONS(1348), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1346), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60697] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4079), 1,
      anon_sym_LBRACE,
    ACTIONS(4091), 1,
      sym_name,
    STATE(2223), 1,
      sym_namespace_use_group,
  [60710] = 3,
    ACTIONS(1196), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1194), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60721] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    ACTIONS(4413), 1,
      anon_sym_EQ_GT,
    STATE(2614), 1,
      sym__return_type,
  [60734] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4415), 1,
      anon_sym_COMMA,
    ACTIONS(4417), 1,
      anon_sym_RPAREN,
    STATE(2154), 1,
      aux_sym_arguments_repeat1,
  [60747] = 3,
    ACTIONS(1188), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1186), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60758] = 4,
    ACTIONS(797), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4419), 1,
      anon_sym_COMMA,
    STATE(2108), 1,
      aux_sym_arguments_repeat1,
  [60771] = 3,
    ACTIONS(1340), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1338), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4135), 1,
      sym__new_line,
    ACTIONS(4421), 1,
      sym_heredoc_end,
    STATE(2201), 1,
      sym_nowdoc_body,
  [60795] = 4,
    ACTIONS(783), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4423), 1,
      anon_sym_COMMA,
    STATE(2108), 1,
      aux_sym_arguments_repeat1,
  [60808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4139), 1,
      sym__new_line,
    ACTIONS(4425), 1,
      sym_heredoc_end,
    STATE(2196), 1,
      sym_heredoc_body,
  [60821] = 4,
    ACTIONS(1710), 1,
      anon_sym_DOLLAR,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1900), 1,
      sym_variable_name,
    STATE(2005), 1,
      sym_static_variable_declaration,
  [60834] = 4,
    ACTIONS(777), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4427), 1,
      anon_sym_COMMA,
    STATE(2108), 1,
      aux_sym_arguments_repeat1,
  [60847] = 3,
    ACTIONS(1340), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1338), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60858] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    ACTIONS(3588), 1,
      anon_sym_LBRACE,
    STATE(2658), 1,
      sym__return_type,
  [60871] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_EQ,
    ACTIONS(4429), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [60882] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3826), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [60891] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    ACTIONS(4433), 1,
      anon_sym_EQ_GT,
    STATE(2653), 1,
      sym__return_type,
  [60904] = 3,
    ACTIONS(1452), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1450), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60915] = 3,
    ACTIONS(1168), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1166), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60926] = 3,
    ACTIONS(1176), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1174), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60937] = 3,
    ACTIONS(1312), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1310), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60948] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4435), 1,
      anon_sym_COMMA,
    ACTIONS(4437), 1,
      anon_sym_RPAREN,
    STATE(1996), 1,
      aux_sym_formal_parameters_repeat1,
  [60961] = 3,
    ACTIONS(1332), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1330), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60972] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4439), 1,
      anon_sym_COMMA,
    ACTIONS(4441), 1,
      anon_sym_RPAREN,
    STATE(2174), 1,
      aux_sym_arguments_repeat1,
  [60985] = 3,
    ACTIONS(1444), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1442), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60996] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3342), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [61005] = 3,
    ACTIONS(1184), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1182), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [61016] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(4443), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1960), 1,
      sym_variable_name,
  [61029] = 4,
    ACTIONS(793), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4445), 1,
      anon_sym_COMMA,
    STATE(2108), 1,
      aux_sym_arguments_repeat1,
  [61042] = 3,
    ACTIONS(1432), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1430), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [61053] = 3,
    ACTIONS(1280), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1278), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [61064] = 3,
    ACTIONS(1208), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1206), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [61075] = 3,
    ACTIONS(1292), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1290), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [61086] = 3,
    ACTIONS(1428), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1426), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [61097] = 3,
    ACTIONS(1212), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1210), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [61108] = 3,
    ACTIONS(1404), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1402), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [61119] = 4,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_COMMA,
    ACTIONS(4449), 1,
      anon_sym_RPAREN,
    STATE(2151), 1,
      aux_sym_arguments_repeat1,
  [61132] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4451), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61140] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1699), 1,
      sym_compound_statement,
  [61150] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_BSLASH,
    STATE(2359), 1,
      aux_sym_namespace_name_repeat1,
  [61160] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1096), 1,
      sym_compound_statement,
  [61170] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(452), 1,
      sym_declaration_list,
  [61180] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4453), 2,
      anon_sym_string,
      anon_sym_int,
  [61188] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2218), 1,
      sym_variable_name,
  [61198] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4371), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61206] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4131), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [61214] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(448), 1,
      sym_declaration_list,
  [61224] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1090), 1,
      sym_compound_statement,
  [61234] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3682), 1,
      anon_sym_LBRACE,
    STATE(467), 1,
      sym_enum_declaration_list,
  [61244] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2581), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4455), 1,
      sym__new_line,
    ACTIONS(4457), 1,
      sym_heredoc_end,
  [61262] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(436), 1,
      sym_declaration_list,
  [61272] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(450), 1,
      sym_declaration_list,
  [61282] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4459), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61290] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2583), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4461), 1,
      sym__new_line,
    ACTIONS(4463), 1,
      sym_heredoc_end,
  [61308] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4465), 1,
      sym_name,
    STATE(2467), 1,
      sym_namespace_name,
  [61318] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4468), 1,
      anon_sym_LPAREN,
    STATE(2338), 1,
      sym_parenthesized_expression,
  [61328] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2275), 1,
      sym_variable_name,
  [61338] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1954), 1,
      sym_formal_parameters,
  [61348] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4465), 1,
      sym_name,
    STATE(2587), 1,
      sym_namespace_name,
  [61358] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2271), 1,
      sym_variable_name,
  [61368] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1112), 1,
      sym_compound_statement,
  [61378] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4465), 1,
      sym_name,
    STATE(2579), 1,
      sym_namespace_name,
  [61388] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2071), 1,
      sym_variable_name,
  [61398] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1073), 1,
      sym_compound_statement,
  [61408] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4411), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [61416] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1087), 1,
      sym_compound_statement,
  [61426] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4470), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [61434] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2239), 1,
      sym_variable_name,
  [61444] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1075), 1,
      sym_compound_statement,
  [61454] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4473), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61462] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4475), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61470] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1115), 1,
      sym_compound_statement,
  [61480] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4477), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61488] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1078), 1,
      sym_compound_statement,
  [61498] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4479), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61506] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4037), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61514] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(435), 1,
      sym_declaration_list,
  [61524] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(444), 1,
      sym_declaration_list,
  [61534] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(2162), 1,
      sym_formal_parameters,
  [61544] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4481), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61552] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4483), 1,
      sym_name,
    STATE(1845), 1,
      sym_namespace_name,
  [61562] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1043), 1,
      sym_compound_statement,
  [61572] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1678), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61580] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1033), 1,
      sym_compound_statement,
  [61590] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4043), 1,
      anon_sym_LBRACE,
    STATE(554), 1,
      sym_declaration_list,
  [61600] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4485), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61608] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4487), 2,
      anon_sym_string,
      anon_sym_int,
  [61616] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3953), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [61624] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4489), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61632] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4491), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61640] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1920), 1,
      sym_formal_parameters,
  [61650] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4493), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61658] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4495), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61666] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1698), 1,
      sym_compound_statement,
  [61676] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4346), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61684] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4497), 1,
      anon_sym_LPAREN,
    STATE(38), 1,
      sym_parenthesized_expression,
  [61694] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2483), 1,
      anon_sym_RPAREN,
    ACTIONS(4499), 1,
      anon_sym_EQ,
  [61704] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2036), 1,
      sym_variable_name,
  [61714] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3682), 1,
      anon_sym_LBRACE,
    STATE(541), 1,
      sym_enum_declaration_list,
  [61724] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(439), 1,
      sym_declaration_list,
  [61734] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3334), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [61742] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1638), 1,
      sym_formal_parameters,
  [61752] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2573), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61760] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1113), 1,
      sym_declaration_list,
  [61770] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4501), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61778] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2427), 1,
      anon_sym_COLON,
    ACTIONS(4503), 1,
      anon_sym_LPAREN,
  [61788] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4497), 1,
      anon_sym_LPAREN,
    STATE(76), 1,
      sym_parenthesized_expression,
  [61798] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4397), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [61806] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4497), 1,
      anon_sym_LPAREN,
    STATE(74), 1,
      sym_parenthesized_expression,
  [61816] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4505), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61824] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4379), 1,
      anon_sym_LPAREN,
    STATE(2400), 1,
      sym_parenthesized_expression,
  [61834] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4465), 1,
      sym_name,
    STATE(2623), 1,
      sym_namespace_name,
  [61844] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1720), 1,
      sym_compound_statement,
  [61854] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1100), 1,
      sym_compound_statement,
  [61864] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4497), 1,
      anon_sym_LPAREN,
    STATE(42), 1,
      sym_parenthesized_expression,
  [61874] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4379), 1,
      anon_sym_LPAREN,
    STATE(2312), 1,
      sym_parenthesized_expression,
  [61884] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4379), 1,
      anon_sym_LPAREN,
    STATE(1998), 1,
      sym_parenthesized_expression,
  [61894] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4316), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61902] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1088), 1,
      sym_declaration_list,
  [61912] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4497), 1,
      anon_sym_LPAREN,
    STATE(65), 1,
      sym_parenthesized_expression,
  [61922] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2809), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(4507), 1,
      aux_sym_namespace_use_declaration_token2,
  [61932] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4379), 1,
      anon_sym_LPAREN,
    STATE(1991), 1,
      sym_parenthesized_expression,
  [61942] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3523), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61950] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4509), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61958] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2257), 1,
      sym_variable_name,
  [61968] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(469), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61976] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4511), 1,
      anon_sym_LBRACE,
    STATE(433), 1,
      sym_compound_statement,
  [61986] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4513), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61994] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4497), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym_parenthesized_expression,
  [62004] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4515), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4517), 1,
      sym__new_line,
    ACTIONS(4519), 1,
      sym_heredoc_end,
  [62022] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(1993), 1,
      sym_variable_name,
  [62032] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(2150), 1,
      sym_compound_statement,
  [62042] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(923), 1,
      sym_compound_statement,
  [62052] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2555), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62060] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2277), 1,
      sym_variable_name,
  [62070] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4521), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62078] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN,
    STATE(1673), 1,
      sym_formal_parameters,
  [62088] = 3,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(463), 1,
      sym_compound_statement,
  [62098] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4525), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62106] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1604), 1,
      sym_formal_parameters,
  [62116] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4527), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62124] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4529), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62132] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    STATE(2107), 1,
      sym_declaration_list,
  [62142] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4531), 2,
      anon_sym_string,
      anon_sym_int,
  [62150] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(434), 1,
      sym_declaration_list,
  [62160] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(499), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62168] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1681), 1,
      sym_declaration_list,
  [62178] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4533), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62186] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1619), 1,
      sym_formal_parameters,
  [62196] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4497), 1,
      anon_sym_LPAREN,
    STATE(64), 1,
      sym_parenthesized_expression,
  [62206] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4468), 1,
      anon_sym_LPAREN,
    STATE(2435), 1,
      sym_parenthesized_expression,
  [62216] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4535), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62224] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(1917), 1,
      sym_variable_name,
  [62234] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4020), 2,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [62242] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(443), 1,
      sym_declaration_list,
  [62252] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1646), 1,
      sym_formal_parameters,
  [62262] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2393), 1,
      sym_variable_name,
  [62272] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4537), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62280] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(903), 1,
      sym_compound_statement,
  [62290] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4539), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62298] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2296), 1,
      sym_variable_name,
  [62308] = 3,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(504), 1,
      sym_compound_statement,
  [62318] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4541), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
  [62326] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4543), 1,
      anon_sym_LBRACE,
    STATE(963), 1,
      sym_match_block,
  [62336] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(493), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62344] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(940), 1,
      sym_compound_statement,
  [62354] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4545), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62362] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1718), 1,
      sym_declaration_list,
  [62372] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1722), 1,
      sym_declaration_list,
  [62382] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3696), 1,
      anon_sym_LBRACE,
    STATE(2017), 1,
      sym_enum_declaration_list,
  [62392] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1061), 1,
      sym_compound_statement,
  [62402] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(904), 1,
      sym_compound_statement,
  [62412] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1602), 1,
      sym_formal_parameters,
  [62422] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(905), 1,
      sym_compound_statement,
  [62432] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4547), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62440] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4549), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [62448] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(907), 1,
      sym_compound_statement,
  [62458] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1728), 1,
      sym_declaration_list,
  [62468] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4551), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [62476] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2435), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62484] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1133), 1,
      sym_compound_statement,
  [62494] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2323), 1,
      sym_variable_name,
  [62504] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1636), 1,
      sym_formal_parameters,
  [62514] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4553), 2,
      anon_sym_string,
      anon_sym_int,
  [62522] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4555), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62530] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1984), 1,
      sym_compound_statement,
  [62540] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4557), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62548] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN,
    STATE(1697), 1,
      sym_formal_parameters,
  [62558] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    STATE(910), 1,
      sym_declaration_list,
  [62568] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4559), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62576] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(953), 1,
      sym_compound_statement,
  [62586] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4561), 1,
      anon_sym_SEMI,
    ACTIONS(4563), 1,
      sym__automatic_semicolon,
  [62596] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    STATE(1923), 1,
      sym_declaration_list,
  [62606] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(2084), 1,
      sym_formal_parameters,
  [62616] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_RPAREN,
    ACTIONS(4499), 1,
      anon_sym_EQ,
  [62626] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3696), 1,
      anon_sym_LBRACE,
    STATE(1921), 1,
      sym_enum_declaration_list,
  [62636] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2809), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(4565), 1,
      aux_sym_namespace_use_declaration_token2,
  [62646] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1708), 1,
      sym_declaration_list,
  [62656] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1592), 1,
      sym_formal_parameters,
  [62666] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1053), 1,
      sym_declaration_list,
  [62676] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4567), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62684] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1052), 1,
      sym_declaration_list,
  [62694] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1711), 1,
      sym_compound_statement,
  [62704] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2709), 1,
      anon_sym_RPAREN,
    ACTIONS(4499), 1,
      anon_sym_EQ,
  [62714] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(1744), 1,
      sym_compound_statement,
  [62724] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4511), 1,
      anon_sym_LBRACE,
    STATE(432), 1,
      sym_compound_statement,
  [62734] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4569), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62742] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4571), 1,
      sym_name,
    STATE(2563), 1,
      sym_namespace_name,
  [62752] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    STATE(949), 1,
      sym_declaration_list,
  [62762] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2435), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [62770] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4574), 1,
      anon_sym_BSLASH,
    STATE(1746), 1,
      aux_sym_namespace_name_repeat1,
  [62780] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4177), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [62788] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4465), 1,
      sym_name,
    STATE(2617), 1,
      sym_namespace_name,
  [62798] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4497), 1,
      anon_sym_LPAREN,
    STATE(82), 1,
      sym_parenthesized_expression,
  [62808] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4577), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62816] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(483), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62824] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4511), 1,
      anon_sym_LBRACE,
    STATE(429), 1,
      sym_compound_statement,
  [62834] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4579), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62842] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(912), 1,
      sym_compound_statement,
  [62852] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4581), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62860] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4583), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62868] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4379), 1,
      anon_sym_LPAREN,
    STATE(2399), 1,
      sym_parenthesized_expression,
  [62878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4585), 1,
      sym__new_line,
    ACTIONS(4587), 1,
      sym_heredoc_end,
  [62888] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(2159), 1,
      sym_formal_parameters,
  [62898] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1749), 1,
      sym_declaration_list,
  [62908] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1750), 1,
      sym_declaration_list,
  [62918] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(913), 1,
      sym_compound_statement,
  [62928] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(915), 1,
      sym_compound_statement,
  [62938] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(917), 1,
      sym_compound_statement,
  [62948] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4589), 1,
      anon_sym_SEMI,
    ACTIONS(4591), 1,
      sym__automatic_semicolon,
  [62958] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1660), 1,
      sym_declaration_list,
  [62968] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1745), 1,
      sym_declaration_list,
  [62978] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4593), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4595), 1,
      sym__new_line,
    ACTIONS(4597), 1,
      sym_heredoc_end,
  [62996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4599), 1,
      sym__new_line,
    ACTIONS(4601), 1,
      sym_heredoc_end,
  [63006] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4603), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [63014] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4606), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63022] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    STATE(919), 1,
      sym_declaration_list,
  [63032] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    STATE(920), 1,
      sym_declaration_list,
  [63042] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4608), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63050] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4610), 1,
      anon_sym_SEMI,
    ACTIONS(4612), 1,
      sym__automatic_semicolon,
  [63060] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4614), 1,
      anon_sym_SEMI,
    ACTIONS(4616), 1,
      sym__automatic_semicolon,
  [63070] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4207), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [63078] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4618), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [63086] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4620), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [63094] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4622), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63102] = 3,
    ACTIONS(387), 1,
      anon_sym_COLON,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(2474), 1,
      sym_colon_block,
  [63112] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4624), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63120] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1127), 1,
      sym_declaration_list,
  [63130] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3696), 1,
      anon_sym_LBRACE,
    STATE(2126), 1,
      sym_enum_declaration_list,
  [63140] = 3,
    ACTIONS(515), 1,
      anon_sym_COLON,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(2049), 1,
      sym_colon_block,
  [63150] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4626), 1,
      anon_sym_LBRACE,
    STATE(1130), 1,
      sym_match_block,
  [63160] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4628), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63168] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4190), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [63176] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4047), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63184] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4630), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [63192] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(922), 1,
      sym_compound_statement,
  [63202] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2597), 1,
      anon_sym_RPAREN,
    ACTIONS(4499), 1,
      anon_sym_EQ,
  [63212] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(453), 1,
      sym_declaration_list,
  [63222] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4632), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63230] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(451), 1,
      sym_declaration_list,
  [63240] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(942), 1,
      sym_compound_statement,
  [63250] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(925), 1,
      sym_compound_statement,
  [63260] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4066), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [63268] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3682), 1,
      anon_sym_LBRACE,
    STATE(499), 1,
      sym_enum_declaration_list,
  [63278] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1079), 1,
      sym_compound_statement,
  [63288] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1083), 1,
      sym_compound_statement,
  [63298] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1753), 1,
      sym_declaration_list,
  [63308] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3479), 1,
      anon_sym_LBRACE,
    STATE(1089), 1,
      sym_compound_statement,
  [63318] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3682), 1,
      anon_sym_LBRACE,
    STATE(557), 1,
      sym_enum_declaration_list,
  [63328] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3696), 1,
      anon_sym_LBRACE,
    STATE(2121), 1,
      sym_enum_declaration_list,
  [63338] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3501), 1,
      anon_sym_LBRACE,
    STATE(447), 1,
      sym_declaration_list,
  [63348] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4634), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63356] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(927), 1,
      sym_compound_statement,
  [63366] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4075), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [63374] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1740), 1,
      sym_declaration_list,
  [63384] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(1610), 1,
      sym_formal_parameters,
  [63394] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4497), 1,
      anon_sym_LPAREN,
    STATE(35), 1,
      sym_parenthesized_expression,
  [63404] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4636), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63412] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    STATE(935), 1,
      sym_declaration_list,
  [63422] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_LBRACE,
    STATE(936), 1,
      sym_declaration_list,
  [63432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4000), 2,
      sym_heredoc_end,
      sym__new_line,
  [63440] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3507), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63448] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4638), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63456] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4640), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63464] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4497), 1,
      anon_sym_LPAREN,
    STATE(81), 1,
      sym_parenthesized_expression,
  [63474] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4642), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63482] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3376), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [63490] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4503), 1,
      anon_sym_LPAREN,
    ACTIONS(4644), 1,
      anon_sym_RPAREN,
  [63500] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4646), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63508] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4648), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [63516] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1097), 1,
      sym_declaration_list,
  [63526] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2599), 1,
      anon_sym_RPAREN,
    ACTIONS(4499), 1,
      anon_sym_EQ,
  [63536] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4650), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63544] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3251), 1,
      anon_sym_LPAREN,
    STATE(2075), 1,
      sym_formal_parameters,
  [63554] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    STATE(1726), 1,
      sym_declaration_list,
  [63564] = 3,
    ACTIONS(379), 1,
      anon_sym_LBRACE,
    ACTIONS(1712), 1,
      sym_comment,
    STATE(938), 1,
      sym_compound_statement,
  [63574] = 3,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4043), 1,
      anon_sym_LBRACE,
    STATE(544), 1,
      sym_declaration_list,
  [63584] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4652), 1,
      sym_heredoc_end,
  [63591] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4654), 1,
      anon_sym_SEMI,
  [63598] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4656), 1,
      sym_heredoc_end,
  [63605] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4658), 1,
      anon_sym_RPAREN,
  [63612] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4644), 1,
      anon_sym_RPAREN,
  [63619] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4660), 1,
      anon_sym_RBRACK,
  [63626] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4662), 1,
      anon_sym_RPAREN,
  [63633] = 2,
    ACTIONS(913), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
  [63640] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4664), 1,
      anon_sym_EQ_GT,
  [63647] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2599), 1,
      anon_sym_RPAREN,
  [63654] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4666), 1,
      anon_sym_EQ,
  [63661] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4668), 1,
      anon_sym_COLON_COLON,
  [63668] = 2,
    ACTIONS(909), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
  [63675] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4670), 1,
      anon_sym_RPAREN,
  [63682] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4672), 1,
      anon_sym_RPAREN,
  [63689] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4115), 1,
      anon_sym_RBRACE,
  [63696] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2597), 1,
      anon_sym_RPAREN,
  [63703] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4674), 1,
      sym_heredoc_end,
  [63710] = 2,
    ACTIONS(917), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
  [63717] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4676), 1,
      anon_sym_RPAREN,
  [63724] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym_BSLASH,
  [63731] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3315), 1,
      anon_sym_EQ,
  [63738] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4678), 1,
      anon_sym_RPAREN,
  [63745] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4680), 1,
      aux_sym__arrow_function_header_token1,
  [63752] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4682), 1,
      anon_sym_EQ_GT,
  [63759] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4684), 1,
      aux_sym_while_statement_token1,
  [63766] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4686), 1,
      anon_sym_RPAREN,
  [63773] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4688), 1,
      aux_sym_if_statement_token2,
  [63780] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4690), 1,
      anon_sym_RPAREN,
  [63787] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4692), 1,
      aux_sym_if_statement_token2,
  [63794] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4694), 1,
      aux_sym_class_declaration_token1,
  [63801] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4221), 1,
      anon_sym_RBRACK,
  [63808] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4696), 1,
      aux_sym_if_statement_token2,
  [63815] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4059), 1,
      anon_sym_RPAREN,
  [63822] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4698), 1,
      anon_sym_RPAREN,
  [63829] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4700), 1,
      anon_sym_EQ_GT,
  [63836] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4702), 1,
      anon_sym_BSLASH,
  [63843] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4704), 1,
      sym_name,
  [63850] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4706), 1,
      sym_heredoc_start,
  [63857] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4708), 1,
      sym_heredoc_start,
  [63864] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4710), 1,
      anon_sym_RPAREN,
  [63871] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4712), 1,
      aux_sym_foreach_statement_token2,
  [63878] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4714), 1,
      sym_name,
  [63885] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4091), 1,
      sym_name,
  [63892] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4051), 1,
      anon_sym_RBRACK,
  [63899] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4716), 1,
      aux_sym_foreach_statement_token2,
  [63906] = 2,
    ACTIONS(897), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
  [63913] = 2,
    ACTIONS(885), 1,
      anon_sym_SEMI,
    ACTIONS(1712), 1,
      sym_comment,
  [63920] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4718), 1,
      anon_sym_RPAREN,
  [63927] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4235), 1,
      anon_sym_RBRACE,
  [63934] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4720), 1,
      anon_sym_RPAREN,
  [63941] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4722), 1,
      sym_name,
  [63948] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4724), 1,
      aux_sym_class_declaration_token1,
  [63955] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4095), 1,
      anon_sym_RPAREN,
  [63962] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2709), 1,
      anon_sym_RPAREN,
  [63969] = 2,
    ACTIONS(887), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
  [63976] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4726), 1,
      anon_sym_RPAREN,
  [63983] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4728), 1,
      anon_sym_EQ_GT,
  [63990] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4730), 1,
      anon_sym_RPAREN,
  [63997] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4732), 1,
      sym_name,
  [64004] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4734), 1,
      aux_sym_if_statement_token2,
  [64011] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4736), 1,
      anon_sym_RPAREN,
  [64018] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_RPAREN,
  [64025] = 2,
    ACTIONS(903), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
  [64032] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4738), 1,
      sym_name,
  [64039] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4123), 1,
      anon_sym_RPAREN,
  [64046] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4740), 1,
      sym_name,
  [64053] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4742), 1,
      sym_name,
  [64060] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3770), 1,
      sym_name,
  [64067] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4744), 1,
      sym_heredoc_end,
  [64074] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4746), 1,
      sym_heredoc_end,
  [64081] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4748), 1,
      sym_name,
  [64088] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4750), 1,
      sym_name,
  [64095] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4200), 1,
      anon_sym_LBRACE,
  [64102] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4752), 1,
      aux_sym_if_statement_token2,
  [64109] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4754), 1,
      anon_sym_EQ_GT,
  [64116] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4756), 1,
      anon_sym_EQ,
  [64123] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4758), 1,
      anon_sym_COLON_COLON,
  [64130] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4760), 1,
      anon_sym_RPAREN,
  [64137] = 2,
    ACTIONS(425), 1,
      ts_builtin_sym_end,
    ACTIONS(1712), 1,
      sym_comment,
  [64144] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4263), 1,
      aux_sym_class_declaration_token1,
  [64151] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4762), 1,
      sym_name,
  [64158] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4764), 1,
      sym_name,
  [64165] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4766), 1,
      ts_builtin_sym_end,
  [64172] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4768), 1,
      sym_name,
  [64179] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4770), 1,
      anon_sym_RPAREN,
  [64186] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4772), 1,
      anon_sym_DQUOTE2,
  [64193] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4774), 1,
      anon_sym_COLON_COLON,
  [64200] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4776), 1,
      anon_sym_SQUOTE2,
  [64207] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4778), 1,
      anon_sym_EQ,
  [64214] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4780), 1,
      anon_sym_RPAREN,
  [64221] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4782), 1,
      aux_sym_while_statement_token2,
  [64228] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4784), 1,
      anon_sym_RPAREN,
  [64235] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4786), 1,
      anon_sym_RPAREN,
  [64242] = 2,
    ACTIONS(421), 1,
      ts_builtin_sym_end,
    ACTIONS(1712), 1,
      sym_comment,
  [64249] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4788), 1,
      anon_sym_EQ_GT,
  [64256] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4441), 1,
      anon_sym_RPAREN,
  [64263] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4790), 1,
      sym_name,
  [64270] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4792), 1,
      aux_sym_namespace_use_declaration_token3,
  [64277] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4794), 1,
      aux_sym__arrow_function_header_token1,
  [64284] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4241), 1,
      aux_sym_class_declaration_token1,
  [64291] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4796), 1,
      sym_name,
  [64298] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4798), 1,
      anon_sym_BSLASH,
  [64305] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(3778), 1,
      sym_name,
  [64312] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4800), 1,
      sym_name,
  [64319] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4802), 1,
      ts_builtin_sym_end,
  [64326] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4804), 1,
      anon_sym_COLON_COLON,
  [64333] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4499), 1,
      anon_sym_EQ,
  [64340] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4806), 1,
      sym_name,
  [64347] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4808), 1,
      anon_sym_EQ_GT,
  [64354] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4810), 1,
      sym_name,
  [64361] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4812), 1,
      sym_name,
  [64368] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4814), 1,
      anon_sym_SEMI,
  [64375] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4816), 1,
      aux_sym_while_statement_token2,
  [64382] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4818), 1,
      aux_sym_class_declaration_token1,
  [64389] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4820), 1,
      anon_sym_LPAREN,
  [64396] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4822), 1,
      anon_sym_BSLASH,
  [64403] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4824), 1,
      anon_sym_EQ_GT,
  [64410] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4311), 1,
      aux_sym_class_declaration_token1,
  [64417] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4826), 1,
      aux_sym_namespace_use_declaration_token3,
  [64424] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4828), 1,
      anon_sym_BSLASH,
  [64431] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4830), 1,
      anon_sym_SQUOTE2,
  [64438] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4077), 1,
      sym_name,
  [64445] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4832), 1,
      anon_sym_DQUOTE2,
  [64452] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4834), 1,
      aux_sym_while_statement_token1,
  [64459] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4836), 1,
      sym_heredoc_start,
  [64466] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4838), 1,
      sym_heredoc_start,
  [64473] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4840), 1,
      aux_sym_class_declaration_token1,
  [64480] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4842), 1,
      anon_sym_LPAREN,
  [64487] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4844), 1,
      anon_sym_RPAREN,
  [64494] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4324), 1,
      aux_sym_class_declaration_token1,
  [64501] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4846), 1,
      anon_sym_BSLASH,
  [64508] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4848), 1,
      anon_sym_BSLASH,
  [64515] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4850), 1,
      anon_sym_COLON_COLON,
  [64522] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4852), 1,
      sym_name,
  [64529] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4854), 1,
      anon_sym_RPAREN,
  [64536] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4856), 1,
      sym_name,
  [64543] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4503), 1,
      anon_sym_LPAREN,
  [64550] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4858), 1,
      anon_sym_EQ,
  [64557] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4860), 1,
      aux_sym_class_declaration_token1,
  [64564] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4862), 1,
      anon_sym_BSLASH,
  [64571] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4383), 1,
      anon_sym_RPAREN,
  [64578] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4864), 1,
      sym_name,
  [64585] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4866), 1,
      anon_sym_LPAREN,
  [64592] = 2,
    ACTIONS(907), 1,
      anon_sym_SEMI,
    ACTIONS(1712), 1,
      sym_comment,
  [64599] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4868), 1,
      anon_sym_LPAREN,
  [64606] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4870), 1,
      sym_name,
  [64613] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4872), 1,
      sym_name,
  [64620] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4874), 1,
      sym_name,
  [64627] = 2,
    ACTIONS(901), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
  [64634] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4876), 1,
      sym_name,
  [64641] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4878), 1,
      anon_sym_SEMI,
  [64648] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(2483), 1,
      anon_sym_RPAREN,
  [64655] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4328), 1,
      anon_sym_RPAREN,
  [64662] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4880), 1,
      anon_sym_EQ_GT,
  [64669] = 2,
    ACTIONS(873), 1,
      anon_sym_RPAREN,
    ACTIONS(1712), 1,
      sym_comment,
  [64676] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4882), 1,
      anon_sym_COLON_COLON,
  [64683] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4884), 1,
      anon_sym_RPAREN,
  [64690] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4886), 1,
      sym_name,
  [64697] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4888), 1,
      anon_sym_LPAREN,
  [64704] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4890), 1,
      sym_name,
  [64711] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4892), 1,
      anon_sym_COLON_COLON,
  [64718] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4894), 1,
      sym_name,
  [64725] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4896), 1,
      anon_sym_COLON_COLON,
  [64732] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4898), 1,
      aux_sym_class_declaration_token1,
  [64739] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4900), 1,
      anon_sym_BSLASH,
  [64746] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4902), 1,
      anon_sym_RPAREN,
  [64753] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4904), 1,
      anon_sym_EQ_GT,
  [64760] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4906), 1,
      anon_sym_LPAREN,
  [64767] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4908), 1,
      aux_sym_namespace_use_declaration_token3,
  [64774] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_BSLASH,
  [64781] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4912), 1,
      anon_sym_LPAREN,
  [64788] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4356), 1,
      anon_sym_RPAREN,
  [64795] = 2,
    ACTIONS(893), 1,
      anon_sym_SEMI,
    ACTIONS(1712), 1,
      sym_comment,
  [64802] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4914), 1,
      sym_name,
  [64809] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4916), 1,
      sym_name,
  [64816] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4918), 1,
      anon_sym_BSLASH,
  [64823] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4920), 1,
      anon_sym_SEMI,
  [64830] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4922), 1,
      anon_sym_EQ_GT,
  [64837] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4924), 1,
      anon_sym_RBRACK,
  [64844] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4926), 1,
      sym_name,
  [64851] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4928), 1,
      anon_sym_COLON_COLON,
  [64858] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4366), 1,
      anon_sym_RPAREN,
  [64865] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4930), 1,
      anon_sym_RBRACK,
  [64872] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4932), 1,
      anon_sym_RPAREN,
  [64879] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4934), 1,
      anon_sym_COLON_COLON,
  [64886] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4401), 1,
      anon_sym_RPAREN,
  [64893] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4936), 1,
      sym_integer,
  [64900] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4938), 1,
      sym_name,
  [64907] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4940), 1,
      anon_sym_LPAREN,
  [64914] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4942), 1,
      anon_sym_LPAREN,
  [64921] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4944), 1,
      sym_name,
  [64928] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4946), 1,
      anon_sym_COLON_COLON,
  [64935] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4948), 1,
      anon_sym_RBRACK,
  [64942] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4950), 1,
      sym_name,
  [64949] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4417), 1,
      anon_sym_RPAREN,
  [64956] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4952), 1,
      anon_sym_RPAREN,
  [64963] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4954), 1,
      anon_sym_LPAREN,
  [64970] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4956), 1,
      sym_name,
  [64977] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4958), 1,
      anon_sym_SEMI,
  [64984] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4960), 1,
      sym_heredoc_end,
  [64991] = 2,
    ACTIONS(879), 1,
      anon_sym_SEMI,
    ACTIONS(1712), 1,
      sym_comment,
  [64998] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4962), 1,
      sym_name,
  [65005] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4437), 1,
      anon_sym_RPAREN,
  [65012] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4964), 1,
      anon_sym_SEMI,
  [65019] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4966), 1,
      anon_sym_LPAREN,
  [65026] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4968), 1,
      anon_sym_EQ_GT,
  [65033] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4970), 1,
      anon_sym_SEMI,
  [65040] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4972), 1,
      anon_sym_EQ_GT,
  [65047] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4974), 1,
      anon_sym_LPAREN,
  [65054] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4976), 1,
      anon_sym_LPAREN,
  [65061] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_LBRACE,
  [65068] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4449), 1,
      anon_sym_RPAREN,
  [65075] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4978), 1,
      anon_sym_COLON_COLON,
  [65082] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4980), 1,
      anon_sym_SEMI,
  [65089] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4982), 1,
      anon_sym_COLON_COLON,
  [65096] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4984), 1,
      anon_sym_LPAREN,
  [65103] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4986), 1,
      anon_sym_LPAREN,
  [65110] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4988), 1,
      anon_sym_LPAREN,
  [65117] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4990), 1,
      anon_sym_LPAREN,
  [65124] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4992), 1,
      anon_sym_EQ_GT,
  [65131] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4994), 1,
      anon_sym_LPAREN,
  [65138] = 2,
    ACTIONS(1712), 1,
      sym_comment,
    ACTIONS(4996), 1,
      anon_sym_LPAREN,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(571)] = 0,
  [SMALL_STATE(572)] = 70,
  [SMALL_STATE(573)] = 140,
  [SMALL_STATE(574)] = 210,
  [SMALL_STATE(575)] = 280,
  [SMALL_STATE(576)] = 353,
  [SMALL_STATE(577)] = 426,
  [SMALL_STATE(578)] = 499,
  [SMALL_STATE(579)] = 572,
  [SMALL_STATE(580)] = 645,
  [SMALL_STATE(581)] = 726,
  [SMALL_STATE(582)] = 794,
  [SMALL_STATE(583)] = 862,
  [SMALL_STATE(584)] = 930,
  [SMALL_STATE(585)] = 998,
  [SMALL_STATE(586)] = 1066,
  [SMALL_STATE(587)] = 1134,
  [SMALL_STATE(588)] = 1202,
  [SMALL_STATE(589)] = 1270,
  [SMALL_STATE(590)] = 1338,
  [SMALL_STATE(591)] = 1406,
  [SMALL_STATE(592)] = 1474,
  [SMALL_STATE(593)] = 1542,
  [SMALL_STATE(594)] = 1610,
  [SMALL_STATE(595)] = 1685,
  [SMALL_STATE(596)] = 1764,
  [SMALL_STATE(597)] = 1842,
  [SMALL_STATE(598)] = 1911,
  [SMALL_STATE(599)] = 1988,
  [SMALL_STATE(600)] = 2057,
  [SMALL_STATE(601)] = 2134,
  [SMALL_STATE(602)] = 2217,
  [SMALL_STATE(603)] = 2286,
  [SMALL_STATE(604)] = 2363,
  [SMALL_STATE(605)] = 2432,
  [SMALL_STATE(606)] = 2501,
  [SMALL_STATE(607)] = 2574,
  [SMALL_STATE(608)] = 2638,
  [SMALL_STATE(609)] = 2714,
  [SMALL_STATE(610)] = 2792,
  [SMALL_STATE(611)] = 2856,
  [SMALL_STATE(612)] = 2920,
  [SMALL_STATE(613)] = 2984,
  [SMALL_STATE(614)] = 3048,
  [SMALL_STATE(615)] = 3112,
  [SMALL_STATE(616)] = 3176,
  [SMALL_STATE(617)] = 3240,
  [SMALL_STATE(618)] = 3304,
  [SMALL_STATE(619)] = 3368,
  [SMALL_STATE(620)] = 3432,
  [SMALL_STATE(621)] = 3496,
  [SMALL_STATE(622)] = 3574,
  [SMALL_STATE(623)] = 3646,
  [SMALL_STATE(624)] = 3710,
  [SMALL_STATE(625)] = 3774,
  [SMALL_STATE(626)] = 3852,
  [SMALL_STATE(627)] = 3916,
  [SMALL_STATE(628)] = 3980,
  [SMALL_STATE(629)] = 4044,
  [SMALL_STATE(630)] = 4121,
  [SMALL_STATE(631)] = 4192,
  [SMALL_STATE(632)] = 4263,
  [SMALL_STATE(633)] = 4334,
  [SMALL_STATE(634)] = 4411,
  [SMALL_STATE(635)] = 4481,
  [SMALL_STATE(636)] = 4553,
  [SMALL_STATE(637)] = 4625,
  [SMALL_STATE(638)] = 4697,
  [SMALL_STATE(639)] = 4768,
  [SMALL_STATE(640)] = 4826,
  [SMALL_STATE(641)] = 4927,
  [SMALL_STATE(642)] = 5028,
  [SMALL_STATE(643)] = 5087,
  [SMALL_STATE(644)] = 5146,
  [SMALL_STATE(645)] = 5205,
  [SMALL_STATE(646)] = 5264,
  [SMALL_STATE(647)] = 5323,
  [SMALL_STATE(648)] = 5388,
  [SMALL_STATE(649)] = 5489,
  [SMALL_STATE(650)] = 5544,
  [SMALL_STATE(651)] = 5605,
  [SMALL_STATE(652)] = 5706,
  [SMALL_STATE(653)] = 5771,
  [SMALL_STATE(654)] = 5836,
  [SMALL_STATE(655)] = 5901,
  [SMALL_STATE(656)] = 5964,
  [SMALL_STATE(657)] = 6062,
  [SMALL_STATE(658)] = 6160,
  [SMALL_STATE(659)] = 6214,
  [SMALL_STATE(660)] = 6310,
  [SMALL_STATE(661)] = 6364,
  [SMALL_STATE(662)] = 6418,
  [SMALL_STATE(663)] = 6472,
  [SMALL_STATE(664)] = 6570,
  [SMALL_STATE(665)] = 6624,
  [SMALL_STATE(666)] = 6678,
  [SMALL_STATE(667)] = 6732,
  [SMALL_STATE(668)] = 6828,
  [SMALL_STATE(669)] = 6882,
  [SMALL_STATE(670)] = 6936,
  [SMALL_STATE(671)] = 6990,
  [SMALL_STATE(672)] = 7088,
  [SMALL_STATE(673)] = 7146,
  [SMALL_STATE(674)] = 7200,
  [SMALL_STATE(675)] = 7258,
  [SMALL_STATE(676)] = 7312,
  [SMALL_STATE(677)] = 7366,
  [SMALL_STATE(678)] = 7420,
  [SMALL_STATE(679)] = 7474,
  [SMALL_STATE(680)] = 7528,
  [SMALL_STATE(681)] = 7582,
  [SMALL_STATE(682)] = 7637,
  [SMALL_STATE(683)] = 7696,
  [SMALL_STATE(684)] = 7753,
  [SMALL_STATE(685)] = 7844,
  [SMALL_STATE(686)] = 7903,
  [SMALL_STATE(687)] = 7958,
  [SMALL_STATE(688)] = 8053,
  [SMALL_STATE(689)] = 8112,
  [SMALL_STATE(690)] = 8171,
  [SMALL_STATE(691)] = 8228,
  [SMALL_STATE(692)] = 8287,
  [SMALL_STATE(693)] = 8344,
  [SMALL_STATE(694)] = 8403,
  [SMALL_STATE(695)] = 8498,
  [SMALL_STATE(696)] = 8589,
  [SMALL_STATE(697)] = 8646,
  [SMALL_STATE(698)] = 8737,
  [SMALL_STATE(699)] = 8794,
  [SMALL_STATE(700)] = 8889,
  [SMALL_STATE(701)] = 8946,
  [SMALL_STATE(702)] = 9003,
  [SMALL_STATE(703)] = 9060,
  [SMALL_STATE(704)] = 9119,
  [SMALL_STATE(705)] = 9178,
  [SMALL_STATE(706)] = 9235,
  [SMALL_STATE(707)] = 9292,
  [SMALL_STATE(708)] = 9351,
  [SMALL_STATE(709)] = 9410,
  [SMALL_STATE(710)] = 9469,
  [SMALL_STATE(711)] = 9526,
  [SMALL_STATE(712)] = 9583,
  [SMALL_STATE(713)] = 9640,
  [SMALL_STATE(714)] = 9697,
  [SMALL_STATE(715)] = 9752,
  [SMALL_STATE(716)] = 9807,
  [SMALL_STATE(717)] = 9866,
  [SMALL_STATE(718)] = 9921,
  [SMALL_STATE(719)] = 9976,
  [SMALL_STATE(720)] = 10028,
  [SMALL_STATE(721)] = 10080,
  [SMALL_STATE(722)] = 10132,
  [SMALL_STATE(723)] = 10184,
  [SMALL_STATE(724)] = 10236,
  [SMALL_STATE(725)] = 10288,
  [SMALL_STATE(726)] = 10340,
  [SMALL_STATE(727)] = 10392,
  [SMALL_STATE(728)] = 10444,
  [SMALL_STATE(729)] = 10498,
  [SMALL_STATE(730)] = 10550,
  [SMALL_STATE(731)] = 10602,
  [SMALL_STATE(732)] = 10654,
  [SMALL_STATE(733)] = 10706,
  [SMALL_STATE(734)] = 10758,
  [SMALL_STATE(735)] = 10810,
  [SMALL_STATE(736)] = 10862,
  [SMALL_STATE(737)] = 10914,
  [SMALL_STATE(738)] = 10966,
  [SMALL_STATE(739)] = 11018,
  [SMALL_STATE(740)] = 11070,
  [SMALL_STATE(741)] = 11122,
  [SMALL_STATE(742)] = 11174,
  [SMALL_STATE(743)] = 11226,
  [SMALL_STATE(744)] = 11278,
  [SMALL_STATE(745)] = 11330,
  [SMALL_STATE(746)] = 11382,
  [SMALL_STATE(747)] = 11434,
  [SMALL_STATE(748)] = 11486,
  [SMALL_STATE(749)] = 11538,
  [SMALL_STATE(750)] = 11590,
  [SMALL_STATE(751)] = 11642,
  [SMALL_STATE(752)] = 11694,
  [SMALL_STATE(753)] = 11746,
  [SMALL_STATE(754)] = 11798,
  [SMALL_STATE(755)] = 11850,
  [SMALL_STATE(756)] = 11902,
  [SMALL_STATE(757)] = 11954,
  [SMALL_STATE(758)] = 12006,
  [SMALL_STATE(759)] = 12098,
  [SMALL_STATE(760)] = 12152,
  [SMALL_STATE(761)] = 12203,
  [SMALL_STATE(762)] = 12264,
  [SMALL_STATE(763)] = 12325,
  [SMALL_STATE(764)] = 12378,
  [SMALL_STATE(765)] = 12437,
  [SMALL_STATE(766)] = 12490,
  [SMALL_STATE(767)] = 12547,
  [SMALL_STATE(768)] = 12608,
  [SMALL_STATE(769)] = 12661,
  [SMALL_STATE(770)] = 12712,
  [SMALL_STATE(771)] = 12767,
  [SMALL_STATE(772)] = 12820,
  [SMALL_STATE(773)] = 12871,
  [SMALL_STATE(774)] = 12932,
  [SMALL_STATE(775)] = 12985,
  [SMALL_STATE(776)] = 13040,
  [SMALL_STATE(777)] = 13095,
  [SMALL_STATE(778)] = 13150,
  [SMALL_STATE(779)] = 13205,
  [SMALL_STATE(780)] = 13260,
  [SMALL_STATE(781)] = 13322,
  [SMALL_STATE(782)] = 13372,
  [SMALL_STATE(783)] = 13422,
  [SMALL_STATE(784)] = 13472,
  [SMALL_STATE(785)] = 13522,
  [SMALL_STATE(786)] = 13572,
  [SMALL_STATE(787)] = 13622,
  [SMALL_STATE(788)] = 13672,
  [SMALL_STATE(789)] = 13722,
  [SMALL_STATE(790)] = 13772,
  [SMALL_STATE(791)] = 13822,
  [SMALL_STATE(792)] = 13872,
  [SMALL_STATE(793)] = 13922,
  [SMALL_STATE(794)] = 13972,
  [SMALL_STATE(795)] = 14022,
  [SMALL_STATE(796)] = 14084,
  [SMALL_STATE(797)] = 14134,
  [SMALL_STATE(798)] = 14196,
  [SMALL_STATE(799)] = 14246,
  [SMALL_STATE(800)] = 14296,
  [SMALL_STATE(801)] = 14346,
  [SMALL_STATE(802)] = 14397,
  [SMALL_STATE(803)] = 14480,
  [SMALL_STATE(804)] = 14563,
  [SMALL_STATE(805)] = 14612,
  [SMALL_STATE(806)] = 14665,
  [SMALL_STATE(807)] = 14718,
  [SMALL_STATE(808)] = 14771,
  [SMALL_STATE(809)] = 14822,
  [SMALL_STATE(810)] = 14877,
  [SMALL_STATE(811)] = 14960,
  [SMALL_STATE(812)] = 15015,
  [SMALL_STATE(813)] = 15066,
  [SMALL_STATE(814)] = 15117,
  [SMALL_STATE(815)] = 15168,
  [SMALL_STATE(816)] = 15223,
  [SMALL_STATE(817)] = 15276,
  [SMALL_STATE(818)] = 15359,
  [SMALL_STATE(819)] = 15414,
  [SMALL_STATE(820)] = 15469,
  [SMALL_STATE(821)] = 15524,
  [SMALL_STATE(822)] = 15579,
  [SMALL_STATE(823)] = 15662,
  [SMALL_STATE(824)] = 15713,
  [SMALL_STATE(825)] = 15768,
  [SMALL_STATE(826)] = 15817,
  [SMALL_STATE(827)] = 15870,
  [SMALL_STATE(828)] = 15925,
  [SMALL_STATE(829)] = 15974,
  [SMALL_STATE(830)] = 16057,
  [SMALL_STATE(831)] = 16110,
  [SMALL_STATE(832)] = 16163,
  [SMALL_STATE(833)] = 16246,
  [SMALL_STATE(834)] = 16329,
  [SMALL_STATE(835)] = 16412,
  [SMALL_STATE(836)] = 16495,
  [SMALL_STATE(837)] = 16546,
  [SMALL_STATE(838)] = 16629,
  [SMALL_STATE(839)] = 16684,
  [SMALL_STATE(840)] = 16737,
  [SMALL_STATE(841)] = 16792,
  [SMALL_STATE(842)] = 16847,
  [SMALL_STATE(843)] = 16930,
  [SMALL_STATE(844)] = 16979,
  [SMALL_STATE(845)] = 17062,
  [SMALL_STATE(846)] = 17115,
  [SMALL_STATE(847)] = 17168,
  [SMALL_STATE(848)] = 17221,
  [SMALL_STATE(849)] = 17274,
  [SMALL_STATE(850)] = 17357,
  [SMALL_STATE(851)] = 17410,
  [SMALL_STATE(852)] = 17463,
  [SMALL_STATE(853)] = 17546,
  [SMALL_STATE(854)] = 17599,
  [SMALL_STATE(855)] = 17647,
  [SMALL_STATE(856)] = 17695,
  [SMALL_STATE(857)] = 17743,
  [SMALL_STATE(858)] = 17791,
  [SMALL_STATE(859)] = 17839,
  [SMALL_STATE(860)] = 17887,
  [SMALL_STATE(861)] = 17935,
  [SMALL_STATE(862)] = 17985,
  [SMALL_STATE(863)] = 18033,
  [SMALL_STATE(864)] = 18081,
  [SMALL_STATE(865)] = 18129,
  [SMALL_STATE(866)] = 18177,
  [SMALL_STATE(867)] = 18225,
  [SMALL_STATE(868)] = 18273,
  [SMALL_STATE(869)] = 18321,
  [SMALL_STATE(870)] = 18369,
  [SMALL_STATE(871)] = 18417,
  [SMALL_STATE(872)] = 18465,
  [SMALL_STATE(873)] = 18517,
  [SMALL_STATE(874)] = 18565,
  [SMALL_STATE(875)] = 18613,
  [SMALL_STATE(876)] = 18661,
  [SMALL_STATE(877)] = 18709,
  [SMALL_STATE(878)] = 18757,
  [SMALL_STATE(879)] = 18805,
  [SMALL_STATE(880)] = 18853,
  [SMALL_STATE(881)] = 18901,
  [SMALL_STATE(882)] = 18949,
  [SMALL_STATE(883)] = 18997,
  [SMALL_STATE(884)] = 19045,
  [SMALL_STATE(885)] = 19093,
  [SMALL_STATE(886)] = 19141,
  [SMALL_STATE(887)] = 19189,
  [SMALL_STATE(888)] = 19239,
  [SMALL_STATE(889)] = 19289,
  [SMALL_STATE(890)] = 19337,
  [SMALL_STATE(891)] = 19385,
  [SMALL_STATE(892)] = 19433,
  [SMALL_STATE(893)] = 19481,
  [SMALL_STATE(894)] = 19529,
  [SMALL_STATE(895)] = 19577,
  [SMALL_STATE(896)] = 19625,
  [SMALL_STATE(897)] = 19674,
  [SMALL_STATE(898)] = 19723,
  [SMALL_STATE(899)] = 19772,
  [SMALL_STATE(900)] = 19821,
  [SMALL_STATE(901)] = 19870,
  [SMALL_STATE(902)] = 19916,
  [SMALL_STATE(903)] = 19962,
  [SMALL_STATE(904)] = 20008,
  [SMALL_STATE(905)] = 20054,
  [SMALL_STATE(906)] = 20100,
  [SMALL_STATE(907)] = 20146,
  [SMALL_STATE(908)] = 20192,
  [SMALL_STATE(909)] = 20238,
  [SMALL_STATE(910)] = 20284,
  [SMALL_STATE(911)] = 20330,
  [SMALL_STATE(912)] = 20376,
  [SMALL_STATE(913)] = 20422,
  [SMALL_STATE(914)] = 20468,
  [SMALL_STATE(915)] = 20514,
  [SMALL_STATE(916)] = 20560,
  [SMALL_STATE(917)] = 20606,
  [SMALL_STATE(918)] = 20652,
  [SMALL_STATE(919)] = 20698,
  [SMALL_STATE(920)] = 20744,
  [SMALL_STATE(921)] = 20790,
  [SMALL_STATE(922)] = 20836,
  [SMALL_STATE(923)] = 20882,
  [SMALL_STATE(924)] = 20928,
  [SMALL_STATE(925)] = 20974,
  [SMALL_STATE(926)] = 21020,
  [SMALL_STATE(927)] = 21066,
  [SMALL_STATE(928)] = 21112,
  [SMALL_STATE(929)] = 21158,
  [SMALL_STATE(930)] = 21204,
  [SMALL_STATE(931)] = 21250,
  [SMALL_STATE(932)] = 21296,
  [SMALL_STATE(933)] = 21342,
  [SMALL_STATE(934)] = 21388,
  [SMALL_STATE(935)] = 21434,
  [SMALL_STATE(936)] = 21480,
  [SMALL_STATE(937)] = 21526,
  [SMALL_STATE(938)] = 21572,
  [SMALL_STATE(939)] = 21618,
  [SMALL_STATE(940)] = 21664,
  [SMALL_STATE(941)] = 21710,
  [SMALL_STATE(942)] = 21756,
  [SMALL_STATE(943)] = 21802,
  [SMALL_STATE(944)] = 21848,
  [SMALL_STATE(945)] = 21894,
  [SMALL_STATE(946)] = 21940,
  [SMALL_STATE(947)] = 21988,
  [SMALL_STATE(948)] = 22034,
  [SMALL_STATE(949)] = 22080,
  [SMALL_STATE(950)] = 22126,
  [SMALL_STATE(951)] = 22172,
  [SMALL_STATE(952)] = 22218,
  [SMALL_STATE(953)] = 22264,
  [SMALL_STATE(954)] = 22310,
  [SMALL_STATE(955)] = 22356,
  [SMALL_STATE(956)] = 22402,
  [SMALL_STATE(957)] = 22448,
  [SMALL_STATE(958)] = 22494,
  [SMALL_STATE(959)] = 22540,
  [SMALL_STATE(960)] = 22620,
  [SMALL_STATE(961)] = 22666,
  [SMALL_STATE(962)] = 22712,
  [SMALL_STATE(963)] = 22758,
  [SMALL_STATE(964)] = 22804,
  [SMALL_STATE(965)] = 22850,
  [SMALL_STATE(966)] = 22896,
  [SMALL_STATE(967)] = 22941,
  [SMALL_STATE(968)] = 22986,
  [SMALL_STATE(969)] = 23068,
  [SMALL_STATE(970)] = 23150,
  [SMALL_STATE(971)] = 23226,
  [SMALL_STATE(972)] = 23272,
  [SMALL_STATE(973)] = 23348,
  [SMALL_STATE(974)] = 23398,
  [SMALL_STATE(975)] = 23466,
  [SMALL_STATE(976)] = 23530,
  [SMALL_STATE(977)] = 23612,
  [SMALL_STATE(978)] = 23694,
  [SMALL_STATE(979)] = 23760,
  [SMALL_STATE(980)] = 23820,
  [SMALL_STATE(981)] = 23876,
  [SMALL_STATE(982)] = 23928,
  [SMALL_STATE(983)] = 24008,
  [SMALL_STATE(984)] = 24078,
  [SMALL_STATE(985)] = 24160,
  [SMALL_STATE(986)] = 24242,
  [SMALL_STATE(987)] = 24296,
  [SMALL_STATE(988)] = 24380,
  [SMALL_STATE(989)] = 24426,
  [SMALL_STATE(990)] = 24508,
  [SMALL_STATE(991)] = 24590,
  [SMALL_STATE(992)] = 24666,
  [SMALL_STATE(993)] = 24742,
  [SMALL_STATE(994)] = 24824,
  [SMALL_STATE(995)] = 24906,
  [SMALL_STATE(996)] = 24982,
  [SMALL_STATE(997)] = 25058,
  [SMALL_STATE(998)] = 25134,
  [SMALL_STATE(999)] = 25206,
  [SMALL_STATE(1000)] = 25284,
  [SMALL_STATE(1001)] = 25347,
  [SMALL_STATE(1002)] = 25422,
  [SMALL_STATE(1003)] = 25503,
  [SMALL_STATE(1004)] = 25584,
  [SMALL_STATE(1005)] = 25665,
  [SMALL_STATE(1006)] = 25748,
  [SMALL_STATE(1007)] = 25829,
  [SMALL_STATE(1008)] = 25910,
  [SMALL_STATE(1009)] = 25991,
  [SMALL_STATE(1010)] = 26072,
  [SMALL_STATE(1011)] = 26153,
  [SMALL_STATE(1012)] = 26234,
  [SMALL_STATE(1013)] = 26301,
  [SMALL_STATE(1014)] = 26350,
  [SMALL_STATE(1015)] = 26425,
  [SMALL_STATE(1016)] = 26482,
  [SMALL_STATE(1017)] = 26527,
  [SMALL_STATE(1018)] = 26602,
  [SMALL_STATE(1019)] = 26681,
  [SMALL_STATE(1020)] = 26758,
  [SMALL_STATE(1021)] = 26829,
  [SMALL_STATE(1022)] = 26898,
  [SMALL_STATE(1023)] = 26963,
  [SMALL_STATE(1024)] = 27038,
  [SMALL_STATE(1025)] = 27083,
  [SMALL_STATE(1026)] = 27158,
  [SMALL_STATE(1027)] = 27211,
  [SMALL_STATE(1028)] = 27266,
  [SMALL_STATE(1029)] = 27341,
  [SMALL_STATE(1030)] = 27416,
  [SMALL_STATE(1031)] = 27497,
  [SMALL_STATE(1032)] = 27548,
  [SMALL_STATE(1033)] = 27607,
  [SMALL_STATE(1034)] = 27649,
  [SMALL_STATE(1035)] = 27729,
  [SMALL_STATE(1036)] = 27771,
  [SMALL_STATE(1037)] = 27813,
  [SMALL_STATE(1038)] = 27855,
  [SMALL_STATE(1039)] = 27929,
  [SMALL_STATE(1040)] = 28003,
  [SMALL_STATE(1041)] = 28047,
  [SMALL_STATE(1042)] = 28099,
  [SMALL_STATE(1043)] = 28141,
  [SMALL_STATE(1044)] = 28183,
  [SMALL_STATE(1045)] = 28225,
  [SMALL_STATE(1046)] = 28299,
  [SMALL_STATE(1047)] = 28349,
  [SMALL_STATE(1048)] = 28403,
  [SMALL_STATE(1049)] = 28461,
  [SMALL_STATE(1050)] = 28503,
  [SMALL_STATE(1051)] = 28567,
  [SMALL_STATE(1052)] = 28635,
  [SMALL_STATE(1053)] = 28677,
  [SMALL_STATE(1054)] = 28719,
  [SMALL_STATE(1055)] = 28789,
  [SMALL_STATE(1056)] = 28831,
  [SMALL_STATE(1057)] = 28873,
  [SMALL_STATE(1058)] = 28949,
  [SMALL_STATE(1059)] = 29027,
  [SMALL_STATE(1060)] = 29101,
  [SMALL_STATE(1061)] = 29169,
  [SMALL_STATE(1062)] = 29211,
  [SMALL_STATE(1063)] = 29255,
  [SMALL_STATE(1064)] = 29323,
  [SMALL_STATE(1065)] = 29397,
  [SMALL_STATE(1066)] = 29445,
  [SMALL_STATE(1067)] = 29511,
  [SMALL_STATE(1068)] = 29573,
  [SMALL_STATE(1069)] = 29653,
  [SMALL_STATE(1070)] = 29721,
  [SMALL_STATE(1071)] = 29763,
  [SMALL_STATE(1072)] = 29805,
  [SMALL_STATE(1073)] = 29847,
  [SMALL_STATE(1074)] = 29889,
  [SMALL_STATE(1075)] = 29931,
  [SMALL_STATE(1076)] = 29973,
  [SMALL_STATE(1077)] = 30015,
  [SMALL_STATE(1078)] = 30057,
  [SMALL_STATE(1079)] = 30099,
  [SMALL_STATE(1080)] = 30141,
  [SMALL_STATE(1081)] = 30183,
  [SMALL_STATE(1082)] = 30251,
  [SMALL_STATE(1083)] = 30293,
  [SMALL_STATE(1084)] = 30335,
  [SMALL_STATE(1085)] = 30377,
  [SMALL_STATE(1086)] = 30445,
  [SMALL_STATE(1087)] = 30487,
  [SMALL_STATE(1088)] = 30529,
  [SMALL_STATE(1089)] = 30571,
  [SMALL_STATE(1090)] = 30613,
  [SMALL_STATE(1091)] = 30655,
  [SMALL_STATE(1092)] = 30697,
  [SMALL_STATE(1093)] = 30771,
  [SMALL_STATE(1094)] = 30845,
  [SMALL_STATE(1095)] = 30887,
  [SMALL_STATE(1096)] = 30929,
  [SMALL_STATE(1097)] = 30971,
  [SMALL_STATE(1098)] = 31013,
  [SMALL_STATE(1099)] = 31055,
  [SMALL_STATE(1100)] = 31097,
  [SMALL_STATE(1101)] = 31139,
  [SMALL_STATE(1102)] = 31181,
  [SMALL_STATE(1103)] = 31223,
  [SMALL_STATE(1104)] = 31303,
  [SMALL_STATE(1105)] = 31383,
  [SMALL_STATE(1106)] = 31425,
  [SMALL_STATE(1107)] = 31467,
  [SMALL_STATE(1108)] = 31509,
  [SMALL_STATE(1109)] = 31589,
  [SMALL_STATE(1110)] = 31631,
  [SMALL_STATE(1111)] = 31673,
  [SMALL_STATE(1112)] = 31741,
  [SMALL_STATE(1113)] = 31783,
  [SMALL_STATE(1114)] = 31825,
  [SMALL_STATE(1115)] = 31867,
  [SMALL_STATE(1116)] = 31909,
  [SMALL_STATE(1117)] = 31951,
  [SMALL_STATE(1118)] = 31993,
  [SMALL_STATE(1119)] = 32035,
  [SMALL_STATE(1120)] = 32115,
  [SMALL_STATE(1121)] = 32195,
  [SMALL_STATE(1122)] = 32237,
  [SMALL_STATE(1123)] = 32317,
  [SMALL_STATE(1124)] = 32359,
  [SMALL_STATE(1125)] = 32401,
  [SMALL_STATE(1126)] = 32443,
  [SMALL_STATE(1127)] = 32485,
  [SMALL_STATE(1128)] = 32527,
  [SMALL_STATE(1129)] = 32569,
  [SMALL_STATE(1130)] = 32649,
  [SMALL_STATE(1131)] = 32691,
  [SMALL_STATE(1132)] = 32733,
  [SMALL_STATE(1133)] = 32777,
  [SMALL_STATE(1134)] = 32819,
  [SMALL_STATE(1135)] = 32899,
  [SMALL_STATE(1136)] = 32981,
  [SMALL_STATE(1137)] = 33023,
  [SMALL_STATE(1138)] = 33092,
  [SMALL_STATE(1139)] = 33135,
  [SMALL_STATE(1140)] = 33214,
  [SMALL_STATE(1141)] = 33293,
  [SMALL_STATE(1142)] = 33366,
  [SMALL_STATE(1143)] = 33433,
  [SMALL_STATE(1144)] = 33506,
  [SMALL_STATE(1145)] = 33585,
  [SMALL_STATE(1146)] = 33628,
  [SMALL_STATE(1147)] = 33701,
  [SMALL_STATE(1148)] = 33770,
  [SMALL_STATE(1149)] = 33849,
  [SMALL_STATE(1150)] = 33924,
  [SMALL_STATE(1151)] = 33985,
  [SMALL_STATE(1152)] = 34064,
  [SMALL_STATE(1153)] = 34113,
  [SMALL_STATE(1154)] = 34190,
  [SMALL_STATE(1155)] = 34237,
  [SMALL_STATE(1156)] = 34302,
  [SMALL_STATE(1157)] = 34353,
  [SMALL_STATE(1158)] = 34432,
  [SMALL_STATE(1159)] = 34511,
  [SMALL_STATE(1160)] = 34584,
  [SMALL_STATE(1161)] = 34663,
  [SMALL_STATE(1162)] = 34736,
  [SMALL_STATE(1163)] = 34789,
  [SMALL_STATE(1164)] = 34832,
  [SMALL_STATE(1165)] = 34911,
  [SMALL_STATE(1166)] = 34984,
  [SMALL_STATE(1167)] = 35047,
  [SMALL_STATE(1168)] = 35116,
  [SMALL_STATE(1169)] = 35195,
  [SMALL_STATE(1170)] = 35238,
  [SMALL_STATE(1171)] = 35311,
  [SMALL_STATE(1172)] = 35368,
  [SMALL_STATE(1173)] = 35449,
  [SMALL_STATE(1174)] = 35527,
  [SMALL_STATE(1175)] = 35607,
  [SMALL_STATE(1176)] = 35687,
  [SMALL_STATE(1177)] = 35767,
  [SMALL_STATE(1178)] = 35845,
  [SMALL_STATE(1179)] = 35925,
  [SMALL_STATE(1180)] = 36007,
  [SMALL_STATE(1181)] = 36087,
  [SMALL_STATE(1182)] = 36165,
  [SMALL_STATE(1183)] = 36242,
  [SMALL_STATE(1184)] = 36319,
  [SMALL_STATE(1185)] = 36396,
  [SMALL_STATE(1186)] = 36471,
  [SMALL_STATE(1187)] = 36548,
  [SMALL_STATE(1188)] = 36627,
  [SMALL_STATE(1189)] = 36704,
  [SMALL_STATE(1190)] = 36783,
  [SMALL_STATE(1191)] = 36858,
  [SMALL_STATE(1192)] = 36935,
  [SMALL_STATE(1193)] = 37014,
  [SMALL_STATE(1194)] = 37091,
  [SMALL_STATE(1195)] = 37168,
  [SMALL_STATE(1196)] = 37245,
  [SMALL_STATE(1197)] = 37322,
  [SMALL_STATE(1198)] = 37399,
  [SMALL_STATE(1199)] = 37476,
  [SMALL_STATE(1200)] = 37553,
  [SMALL_STATE(1201)] = 37600,
  [SMALL_STATE(1202)] = 37677,
  [SMALL_STATE(1203)] = 37754,
  [SMALL_STATE(1204)] = 37831,
  [SMALL_STATE(1205)] = 37908,
  [SMALL_STATE(1206)] = 37983,
  [SMALL_STATE(1207)] = 38060,
  [SMALL_STATE(1208)] = 38135,
  [SMALL_STATE(1209)] = 38210,
  [SMALL_STATE(1210)] = 38287,
  [SMALL_STATE(1211)] = 38362,
  [SMALL_STATE(1212)] = 38439,
  [SMALL_STATE(1213)] = 38516,
  [SMALL_STATE(1214)] = 38593,
  [SMALL_STATE(1215)] = 38670,
  [SMALL_STATE(1216)] = 38747,
  [SMALL_STATE(1217)] = 38826,
  [SMALL_STATE(1218)] = 38901,
  [SMALL_STATE(1219)] = 38976,
  [SMALL_STATE(1220)] = 39039,
  [SMALL_STATE(1221)] = 39116,
  [SMALL_STATE(1222)] = 39193,
  [SMALL_STATE(1223)] = 39270,
  [SMALL_STATE(1224)] = 39349,
  [SMALL_STATE(1225)] = 39428,
  [SMALL_STATE(1226)] = 39505,
  [SMALL_STATE(1227)] = 39582,
  [SMALL_STATE(1228)] = 39645,
  [SMALL_STATE(1229)] = 39720,
  [SMALL_STATE(1230)] = 39797,
  [SMALL_STATE(1231)] = 39874,
  [SMALL_STATE(1232)] = 39953,
  [SMALL_STATE(1233)] = 40032,
  [SMALL_STATE(1234)] = 40109,
  [SMALL_STATE(1235)] = 40156,
  [SMALL_STATE(1236)] = 40232,
  [SMALL_STATE(1237)] = 40308,
  [SMALL_STATE(1238)] = 40384,
  [SMALL_STATE(1239)] = 40460,
  [SMALL_STATE(1240)] = 40536,
  [SMALL_STATE(1241)] = 40612,
  [SMALL_STATE(1242)] = 40688,
  [SMALL_STATE(1243)] = 40764,
  [SMALL_STATE(1244)] = 40840,
  [SMALL_STATE(1245)] = 40916,
  [SMALL_STATE(1246)] = 40992,
  [SMALL_STATE(1247)] = 41068,
  [SMALL_STATE(1248)] = 41144,
  [SMALL_STATE(1249)] = 41220,
  [SMALL_STATE(1250)] = 41296,
  [SMALL_STATE(1251)] = 41372,
  [SMALL_STATE(1252)] = 41448,
  [SMALL_STATE(1253)] = 41524,
  [SMALL_STATE(1254)] = 41600,
  [SMALL_STATE(1255)] = 41676,
  [SMALL_STATE(1256)] = 41752,
  [SMALL_STATE(1257)] = 41828,
  [SMALL_STATE(1258)] = 41904,
  [SMALL_STATE(1259)] = 41980,
  [SMALL_STATE(1260)] = 42056,
  [SMALL_STATE(1261)] = 42132,
  [SMALL_STATE(1262)] = 42208,
  [SMALL_STATE(1263)] = 42284,
  [SMALL_STATE(1264)] = 42360,
  [SMALL_STATE(1265)] = 42436,
  [SMALL_STATE(1266)] = 42512,
  [SMALL_STATE(1267)] = 42588,
  [SMALL_STATE(1268)] = 42664,
  [SMALL_STATE(1269)] = 42740,
  [SMALL_STATE(1270)] = 42816,
  [SMALL_STATE(1271)] = 42892,
  [SMALL_STATE(1272)] = 42952,
  [SMALL_STATE(1273)] = 43028,
  [SMALL_STATE(1274)] = 43104,
  [SMALL_STATE(1275)] = 43180,
  [SMALL_STATE(1276)] = 43256,
  [SMALL_STATE(1277)] = 43332,
  [SMALL_STATE(1278)] = 43408,
  [SMALL_STATE(1279)] = 43484,
  [SMALL_STATE(1280)] = 43560,
  [SMALL_STATE(1281)] = 43636,
  [SMALL_STATE(1282)] = 43712,
  [SMALL_STATE(1283)] = 43788,
  [SMALL_STATE(1284)] = 43864,
  [SMALL_STATE(1285)] = 43940,
  [SMALL_STATE(1286)] = 44016,
  [SMALL_STATE(1287)] = 44054,
  [SMALL_STATE(1288)] = 44130,
  [SMALL_STATE(1289)] = 44206,
  [SMALL_STATE(1290)] = 44282,
  [SMALL_STATE(1291)] = 44358,
  [SMALL_STATE(1292)] = 44434,
  [SMALL_STATE(1293)] = 44494,
  [SMALL_STATE(1294)] = 44570,
  [SMALL_STATE(1295)] = 44646,
  [SMALL_STATE(1296)] = 44722,
  [SMALL_STATE(1297)] = 44798,
  [SMALL_STATE(1298)] = 44874,
  [SMALL_STATE(1299)] = 44950,
  [SMALL_STATE(1300)] = 45026,
  [SMALL_STATE(1301)] = 45102,
  [SMALL_STATE(1302)] = 45178,
  [SMALL_STATE(1303)] = 45254,
  [SMALL_STATE(1304)] = 45330,
  [SMALL_STATE(1305)] = 45395,
  [SMALL_STATE(1306)] = 45460,
  [SMALL_STATE(1307)] = 45525,
  [SMALL_STATE(1308)] = 45590,
  [SMALL_STATE(1309)] = 45629,
  [SMALL_STATE(1310)] = 45666,
  [SMALL_STATE(1311)] = 45731,
  [SMALL_STATE(1312)] = 45768,
  [SMALL_STATE(1313)] = 45804,
  [SMALL_STATE(1314)] = 45840,
  [SMALL_STATE(1315)] = 45879,
  [SMALL_STATE(1316)] = 45918,
  [SMALL_STATE(1317)] = 45967,
  [SMALL_STATE(1318)] = 46016,
  [SMALL_STATE(1319)] = 46065,
  [SMALL_STATE(1320)] = 46098,
  [SMALL_STATE(1321)] = 46131,
  [SMALL_STATE(1322)] = 46180,
  [SMALL_STATE(1323)] = 46229,
  [SMALL_STATE(1324)] = 46278,
  [SMALL_STATE(1325)] = 46311,
  [SMALL_STATE(1326)] = 46360,
  [SMALL_STATE(1327)] = 46409,
  [SMALL_STATE(1328)] = 46458,
  [SMALL_STATE(1329)] = 46507,
  [SMALL_STATE(1330)] = 46556,
  [SMALL_STATE(1331)] = 46602,
  [SMALL_STATE(1332)] = 46648,
  [SMALL_STATE(1333)] = 46694,
  [SMALL_STATE(1334)] = 46740,
  [SMALL_STATE(1335)] = 46786,
  [SMALL_STATE(1336)] = 46832,
  [SMALL_STATE(1337)] = 46873,
  [SMALL_STATE(1338)] = 46902,
  [SMALL_STATE(1339)] = 46943,
  [SMALL_STATE(1340)] = 46984,
  [SMALL_STATE(1341)] = 47012,
  [SMALL_STATE(1342)] = 47061,
  [SMALL_STATE(1343)] = 47105,
  [SMALL_STATE(1344)] = 47147,
  [SMALL_STATE(1345)] = 47191,
  [SMALL_STATE(1346)] = 47232,
  [SMALL_STATE(1347)] = 47271,
  [SMALL_STATE(1348)] = 47312,
  [SMALL_STATE(1349)] = 47353,
  [SMALL_STATE(1350)] = 47392,
  [SMALL_STATE(1351)] = 47433,
  [SMALL_STATE(1352)] = 47460,
  [SMALL_STATE(1353)] = 47487,
  [SMALL_STATE(1354)] = 47511,
  [SMALL_STATE(1355)] = 47547,
  [SMALL_STATE(1356)] = 47583,
  [SMALL_STATE(1357)] = 47604,
  [SMALL_STATE(1358)] = 47625,
  [SMALL_STATE(1359)] = 47660,
  [SMALL_STATE(1360)] = 47681,
  [SMALL_STATE(1361)] = 47701,
  [SMALL_STATE(1362)] = 47721,
  [SMALL_STATE(1363)] = 47741,
  [SMALL_STATE(1364)] = 47761,
  [SMALL_STATE(1365)] = 47781,
  [SMALL_STATE(1366)] = 47817,
  [SMALL_STATE(1367)] = 47853,
  [SMALL_STATE(1368)] = 47873,
  [SMALL_STATE(1369)] = 47893,
  [SMALL_STATE(1370)] = 47913,
  [SMALL_STATE(1371)] = 47933,
  [SMALL_STATE(1372)] = 47969,
  [SMALL_STATE(1373)] = 47989,
  [SMALL_STATE(1374)] = 48025,
  [SMALL_STATE(1375)] = 48045,
  [SMALL_STATE(1376)] = 48065,
  [SMALL_STATE(1377)] = 48085,
  [SMALL_STATE(1378)] = 48105,
  [SMALL_STATE(1379)] = 48125,
  [SMALL_STATE(1380)] = 48145,
  [SMALL_STATE(1381)] = 48165,
  [SMALL_STATE(1382)] = 48201,
  [SMALL_STATE(1383)] = 48221,
  [SMALL_STATE(1384)] = 48240,
  [SMALL_STATE(1385)] = 48259,
  [SMALL_STATE(1386)] = 48278,
  [SMALL_STATE(1387)] = 48297,
  [SMALL_STATE(1388)] = 48332,
  [SMALL_STATE(1389)] = 48351,
  [SMALL_STATE(1390)] = 48370,
  [SMALL_STATE(1391)] = 48389,
  [SMALL_STATE(1392)] = 48408,
  [SMALL_STATE(1393)] = 48441,
  [SMALL_STATE(1394)] = 48460,
  [SMALL_STATE(1395)] = 48493,
  [SMALL_STATE(1396)] = 48520,
  [SMALL_STATE(1397)] = 48539,
  [SMALL_STATE(1398)] = 48574,
  [SMALL_STATE(1399)] = 48615,
  [SMALL_STATE(1400)] = 48636,
  [SMALL_STATE(1401)] = 48655,
  [SMALL_STATE(1402)] = 48696,
  [SMALL_STATE(1403)] = 48729,
  [SMALL_STATE(1404)] = 48754,
  [SMALL_STATE(1405)] = 48787,
  [SMALL_STATE(1406)] = 48806,
  [SMALL_STATE(1407)] = 48839,
  [SMALL_STATE(1408)] = 48858,
  [SMALL_STATE(1409)] = 48877,
  [SMALL_STATE(1410)] = 48896,
  [SMALL_STATE(1411)] = 48915,
  [SMALL_STATE(1412)] = 48934,
  [SMALL_STATE(1413)] = 48953,
  [SMALL_STATE(1414)] = 48972,
  [SMALL_STATE(1415)] = 48991,
  [SMALL_STATE(1416)] = 49010,
  [SMALL_STATE(1417)] = 49029,
  [SMALL_STATE(1418)] = 49048,
  [SMALL_STATE(1419)] = 49067,
  [SMALL_STATE(1420)] = 49101,
  [SMALL_STATE(1421)] = 49131,
  [SMALL_STATE(1422)] = 49165,
  [SMALL_STATE(1423)] = 49199,
  [SMALL_STATE(1424)] = 49233,
  [SMALL_STATE(1425)] = 49262,
  [SMALL_STATE(1426)] = 49287,
  [SMALL_STATE(1427)] = 49318,
  [SMALL_STATE(1428)] = 49343,
  [SMALL_STATE(1429)] = 49362,
  [SMALL_STATE(1430)] = 49381,
  [SMALL_STATE(1431)] = 49400,
  [SMALL_STATE(1432)] = 49431,
  [SMALL_STATE(1433)] = 49462,
  [SMALL_STATE(1434)] = 49491,
  [SMALL_STATE(1435)] = 49522,
  [SMALL_STATE(1436)] = 49547,
  [SMALL_STATE(1437)] = 49578,
  [SMALL_STATE(1438)] = 49607,
  [SMALL_STATE(1439)] = 49638,
  [SMALL_STATE(1440)] = 49656,
  [SMALL_STATE(1441)] = 49674,
  [SMALL_STATE(1442)] = 49702,
  [SMALL_STATE(1443)] = 49724,
  [SMALL_STATE(1444)] = 49742,
  [SMALL_STATE(1445)] = 49764,
  [SMALL_STATE(1446)] = 49782,
  [SMALL_STATE(1447)] = 49800,
  [SMALL_STATE(1448)] = 49822,
  [SMALL_STATE(1449)] = 49840,
  [SMALL_STATE(1450)] = 49858,
  [SMALL_STATE(1451)] = 49876,
  [SMALL_STATE(1452)] = 49894,
  [SMALL_STATE(1453)] = 49920,
  [SMALL_STATE(1454)] = 49942,
  [SMALL_STATE(1455)] = 49970,
  [SMALL_STATE(1456)] = 49988,
  [SMALL_STATE(1457)] = 50016,
  [SMALL_STATE(1458)] = 50038,
  [SMALL_STATE(1459)] = 50066,
  [SMALL_STATE(1460)] = 50084,
  [SMALL_STATE(1461)] = 50112,
  [SMALL_STATE(1462)] = 50138,
  [SMALL_STATE(1463)] = 50162,
  [SMALL_STATE(1464)] = 50180,
  [SMALL_STATE(1465)] = 50206,
  [SMALL_STATE(1466)] = 50224,
  [SMALL_STATE(1467)] = 50242,
  [SMALL_STATE(1468)] = 50260,
  [SMALL_STATE(1469)] = 50283,
  [SMALL_STATE(1470)] = 50310,
  [SMALL_STATE(1471)] = 50331,
  [SMALL_STATE(1472)] = 50356,
  [SMALL_STATE(1473)] = 50381,
  [SMALL_STATE(1474)] = 50404,
  [SMALL_STATE(1475)] = 50427,
  [SMALL_STATE(1476)] = 50450,
  [SMALL_STATE(1477)] = 50475,
  [SMALL_STATE(1478)] = 50500,
  [SMALL_STATE(1479)] = 50523,
  [SMALL_STATE(1480)] = 50546,
  [SMALL_STATE(1481)] = 50569,
  [SMALL_STATE(1482)] = 50594,
  [SMALL_STATE(1483)] = 50609,
  [SMALL_STATE(1484)] = 50634,
  [SMALL_STATE(1485)] = 50657,
  [SMALL_STATE(1486)] = 50680,
  [SMALL_STATE(1487)] = 50703,
  [SMALL_STATE(1488)] = 50718,
  [SMALL_STATE(1489)] = 50733,
  [SMALL_STATE(1490)] = 50752,
  [SMALL_STATE(1491)] = 50777,
  [SMALL_STATE(1492)] = 50792,
  [SMALL_STATE(1493)] = 50815,
  [SMALL_STATE(1494)] = 50838,
  [SMALL_STATE(1495)] = 50861,
  [SMALL_STATE(1496)] = 50884,
  [SMALL_STATE(1497)] = 50911,
  [SMALL_STATE(1498)] = 50936,
  [SMALL_STATE(1499)] = 50959,
  [SMALL_STATE(1500)] = 50982,
  [SMALL_STATE(1501)] = 51005,
  [SMALL_STATE(1502)] = 51026,
  [SMALL_STATE(1503)] = 51047,
  [SMALL_STATE(1504)] = 51070,
  [SMALL_STATE(1505)] = 51093,
  [SMALL_STATE(1506)] = 51110,
  [SMALL_STATE(1507)] = 51133,
  [SMALL_STATE(1508)] = 51154,
  [SMALL_STATE(1509)] = 51177,
  [SMALL_STATE(1510)] = 51194,
  [SMALL_STATE(1511)] = 51215,
  [SMALL_STATE(1512)] = 51238,
  [SMALL_STATE(1513)] = 51259,
  [SMALL_STATE(1514)] = 51274,
  [SMALL_STATE(1515)] = 51299,
  [SMALL_STATE(1516)] = 51322,
  [SMALL_STATE(1517)] = 51347,
  [SMALL_STATE(1518)] = 51370,
  [SMALL_STATE(1519)] = 51393,
  [SMALL_STATE(1520)] = 51416,
  [SMALL_STATE(1521)] = 51439,
  [SMALL_STATE(1522)] = 51464,
  [SMALL_STATE(1523)] = 51487,
  [SMALL_STATE(1524)] = 51508,
  [SMALL_STATE(1525)] = 51529,
  [SMALL_STATE(1526)] = 51552,
  [SMALL_STATE(1527)] = 51573,
  [SMALL_STATE(1528)] = 51594,
  [SMALL_STATE(1529)] = 51619,
  [SMALL_STATE(1530)] = 51644,
  [SMALL_STATE(1531)] = 51665,
  [SMALL_STATE(1532)] = 51686,
  [SMALL_STATE(1533)] = 51707,
  [SMALL_STATE(1534)] = 51731,
  [SMALL_STATE(1535)] = 51759,
  [SMALL_STATE(1536)] = 51779,
  [SMALL_STATE(1537)] = 51807,
  [SMALL_STATE(1538)] = 51829,
  [SMALL_STATE(1539)] = 51851,
  [SMALL_STATE(1540)] = 51871,
  [SMALL_STATE(1541)] = 51891,
  [SMALL_STATE(1542)] = 51919,
  [SMALL_STATE(1543)] = 51947,
  [SMALL_STATE(1544)] = 51973,
  [SMALL_STATE(1545)] = 51993,
  [SMALL_STATE(1546)] = 52021,
  [SMALL_STATE(1547)] = 52049,
  [SMALL_STATE(1548)] = 52066,
  [SMALL_STATE(1549)] = 52083,
  [SMALL_STATE(1550)] = 52100,
  [SMALL_STATE(1551)] = 52115,
  [SMALL_STATE(1552)] = 52130,
  [SMALL_STATE(1553)] = 52149,
  [SMALL_STATE(1554)] = 52174,
  [SMALL_STATE(1555)] = 52189,
  [SMALL_STATE(1556)] = 52206,
  [SMALL_STATE(1557)] = 52221,
  [SMALL_STATE(1558)] = 52240,
  [SMALL_STATE(1559)] = 52255,
  [SMALL_STATE(1560)] = 52270,
  [SMALL_STATE(1561)] = 52287,
  [SMALL_STATE(1562)] = 52302,
  [SMALL_STATE(1563)] = 52323,
  [SMALL_STATE(1564)] = 52338,
  [SMALL_STATE(1565)] = 52353,
  [SMALL_STATE(1566)] = 52370,
  [SMALL_STATE(1567)] = 52387,
  [SMALL_STATE(1568)] = 52404,
  [SMALL_STATE(1569)] = 52423,
  [SMALL_STATE(1570)] = 52440,
  [SMALL_STATE(1571)] = 52455,
  [SMALL_STATE(1572)] = 52476,
  [SMALL_STATE(1573)] = 52493,
  [SMALL_STATE(1574)] = 52514,
  [SMALL_STATE(1575)] = 52531,
  [SMALL_STATE(1576)] = 52546,
  [SMALL_STATE(1577)] = 52561,
  [SMALL_STATE(1578)] = 52578,
  [SMALL_STATE(1579)] = 52595,
  [SMALL_STATE(1580)] = 52612,
  [SMALL_STATE(1581)] = 52629,
  [SMALL_STATE(1582)] = 52644,
  [SMALL_STATE(1583)] = 52661,
  [SMALL_STATE(1584)] = 52678,
  [SMALL_STATE(1585)] = 52697,
  [SMALL_STATE(1586)] = 52714,
  [SMALL_STATE(1587)] = 52731,
  [SMALL_STATE(1588)] = 52754,
  [SMALL_STATE(1589)] = 52771,
  [SMALL_STATE(1590)] = 52792,
  [SMALL_STATE(1591)] = 52809,
  [SMALL_STATE(1592)] = 52827,
  [SMALL_STATE(1593)] = 52849,
  [SMALL_STATE(1594)] = 52871,
  [SMALL_STATE(1595)] = 52889,
  [SMALL_STATE(1596)] = 52907,
  [SMALL_STATE(1597)] = 52929,
  [SMALL_STATE(1598)] = 52943,
  [SMALL_STATE(1599)] = 52965,
  [SMALL_STATE(1600)] = 52987,
  [SMALL_STATE(1601)] = 53009,
  [SMALL_STATE(1602)] = 53027,
  [SMALL_STATE(1603)] = 53049,
  [SMALL_STATE(1604)] = 53071,
  [SMALL_STATE(1605)] = 53093,
  [SMALL_STATE(1606)] = 53115,
  [SMALL_STATE(1607)] = 53137,
  [SMALL_STATE(1608)] = 53151,
  [SMALL_STATE(1609)] = 53171,
  [SMALL_STATE(1610)] = 53193,
  [SMALL_STATE(1611)] = 53215,
  [SMALL_STATE(1612)] = 53233,
  [SMALL_STATE(1613)] = 53251,
  [SMALL_STATE(1614)] = 53271,
  [SMALL_STATE(1615)] = 53285,
  [SMALL_STATE(1616)] = 53307,
  [SMALL_STATE(1617)] = 53327,
  [SMALL_STATE(1618)] = 53341,
  [SMALL_STATE(1619)] = 53359,
  [SMALL_STATE(1620)] = 53381,
  [SMALL_STATE(1621)] = 53395,
  [SMALL_STATE(1622)] = 53409,
  [SMALL_STATE(1623)] = 53431,
  [SMALL_STATE(1624)] = 53453,
  [SMALL_STATE(1625)] = 53475,
  [SMALL_STATE(1626)] = 53493,
  [SMALL_STATE(1627)] = 53515,
  [SMALL_STATE(1628)] = 53535,
  [SMALL_STATE(1629)] = 53553,
  [SMALL_STATE(1630)] = 53567,
  [SMALL_STATE(1631)] = 53581,
  [SMALL_STATE(1632)] = 53599,
  [SMALL_STATE(1633)] = 53621,
  [SMALL_STATE(1634)] = 53643,
  [SMALL_STATE(1635)] = 53661,
  [SMALL_STATE(1636)] = 53683,
  [SMALL_STATE(1637)] = 53705,
  [SMALL_STATE(1638)] = 53723,
  [SMALL_STATE(1639)] = 53745,
  [SMALL_STATE(1640)] = 53767,
  [SMALL_STATE(1641)] = 53789,
  [SMALL_STATE(1642)] = 53811,
  [SMALL_STATE(1643)] = 53829,
  [SMALL_STATE(1644)] = 53851,
  [SMALL_STATE(1645)] = 53873,
  [SMALL_STATE(1646)] = 53895,
  [SMALL_STATE(1647)] = 53917,
  [SMALL_STATE(1648)] = 53939,
  [SMALL_STATE(1649)] = 53955,
  [SMALL_STATE(1650)] = 53977,
  [SMALL_STATE(1651)] = 53999,
  [SMALL_STATE(1652)] = 54017,
  [SMALL_STATE(1653)] = 54039,
  [SMALL_STATE(1654)] = 54061,
  [SMALL_STATE(1655)] = 54083,
  [SMALL_STATE(1656)] = 54101,
  [SMALL_STATE(1657)] = 54123,
  [SMALL_STATE(1658)] = 54145,
  [SMALL_STATE(1659)] = 54167,
  [SMALL_STATE(1660)] = 54186,
  [SMALL_STATE(1661)] = 54201,
  [SMALL_STATE(1662)] = 54218,
  [SMALL_STATE(1663)] = 54229,
  [SMALL_STATE(1664)] = 54240,
  [SMALL_STATE(1665)] = 54255,
  [SMALL_STATE(1666)] = 54274,
  [SMALL_STATE(1667)] = 54291,
  [SMALL_STATE(1668)] = 54306,
  [SMALL_STATE(1669)] = 54321,
  [SMALL_STATE(1670)] = 54338,
  [SMALL_STATE(1671)] = 54353,
  [SMALL_STATE(1672)] = 54372,
  [SMALL_STATE(1673)] = 54389,
  [SMALL_STATE(1674)] = 54404,
  [SMALL_STATE(1675)] = 54423,
  [SMALL_STATE(1676)] = 54434,
  [SMALL_STATE(1677)] = 54449,
  [SMALL_STATE(1678)] = 54464,
  [SMALL_STATE(1679)] = 54481,
  [SMALL_STATE(1680)] = 54496,
  [SMALL_STATE(1681)] = 54515,
  [SMALL_STATE(1682)] = 54530,
  [SMALL_STATE(1683)] = 54547,
  [SMALL_STATE(1684)] = 54564,
  [SMALL_STATE(1685)] = 54581,
  [SMALL_STATE(1686)] = 54598,
  [SMALL_STATE(1687)] = 54615,
  [SMALL_STATE(1688)] = 54634,
  [SMALL_STATE(1689)] = 54653,
  [SMALL_STATE(1690)] = 54668,
  [SMALL_STATE(1691)] = 54683,
  [SMALL_STATE(1692)] = 54698,
  [SMALL_STATE(1693)] = 54713,
  [SMALL_STATE(1694)] = 54728,
  [SMALL_STATE(1695)] = 54743,
  [SMALL_STATE(1696)] = 54760,
  [SMALL_STATE(1697)] = 54775,
  [SMALL_STATE(1698)] = 54790,
  [SMALL_STATE(1699)] = 54805,
  [SMALL_STATE(1700)] = 54818,
  [SMALL_STATE(1701)] = 54833,
  [SMALL_STATE(1702)] = 54852,
  [SMALL_STATE(1703)] = 54867,
  [SMALL_STATE(1704)] = 54886,
  [SMALL_STATE(1705)] = 54901,
  [SMALL_STATE(1706)] = 54916,
  [SMALL_STATE(1707)] = 54933,
  [SMALL_STATE(1708)] = 54952,
  [SMALL_STATE(1709)] = 54967,
  [SMALL_STATE(1710)] = 54986,
  [SMALL_STATE(1711)] = 55001,
  [SMALL_STATE(1712)] = 55014,
  [SMALL_STATE(1713)] = 55031,
  [SMALL_STATE(1714)] = 55046,
  [SMALL_STATE(1715)] = 55061,
  [SMALL_STATE(1716)] = 55076,
  [SMALL_STATE(1717)] = 55091,
  [SMALL_STATE(1718)] = 55108,
  [SMALL_STATE(1719)] = 55123,
  [SMALL_STATE(1720)] = 55138,
  [SMALL_STATE(1721)] = 55153,
  [SMALL_STATE(1722)] = 55172,
  [SMALL_STATE(1723)] = 55187,
  [SMALL_STATE(1724)] = 55206,
  [SMALL_STATE(1725)] = 55225,
  [SMALL_STATE(1726)] = 55244,
  [SMALL_STATE(1727)] = 55259,
  [SMALL_STATE(1728)] = 55278,
  [SMALL_STATE(1729)] = 55293,
  [SMALL_STATE(1730)] = 55310,
  [SMALL_STATE(1731)] = 55327,
  [SMALL_STATE(1732)] = 55346,
  [SMALL_STATE(1733)] = 55365,
  [SMALL_STATE(1734)] = 55382,
  [SMALL_STATE(1735)] = 55401,
  [SMALL_STATE(1736)] = 55418,
  [SMALL_STATE(1737)] = 55437,
  [SMALL_STATE(1738)] = 55456,
  [SMALL_STATE(1739)] = 55475,
  [SMALL_STATE(1740)] = 55494,
  [SMALL_STATE(1741)] = 55509,
  [SMALL_STATE(1742)] = 55524,
  [SMALL_STATE(1743)] = 55539,
  [SMALL_STATE(1744)] = 55554,
  [SMALL_STATE(1745)] = 55567,
  [SMALL_STATE(1746)] = 55582,
  [SMALL_STATE(1747)] = 55597,
  [SMALL_STATE(1748)] = 55612,
  [SMALL_STATE(1749)] = 55627,
  [SMALL_STATE(1750)] = 55642,
  [SMALL_STATE(1751)] = 55657,
  [SMALL_STATE(1752)] = 55672,
  [SMALL_STATE(1753)] = 55687,
  [SMALL_STATE(1754)] = 55702,
  [SMALL_STATE(1755)] = 55721,
  [SMALL_STATE(1756)] = 55735,
  [SMALL_STATE(1757)] = 55751,
  [SMALL_STATE(1758)] = 55761,
  [SMALL_STATE(1759)] = 55777,
  [SMALL_STATE(1760)] = 55793,
  [SMALL_STATE(1761)] = 55807,
  [SMALL_STATE(1762)] = 55821,
  [SMALL_STATE(1763)] = 55835,
  [SMALL_STATE(1764)] = 55849,
  [SMALL_STATE(1765)] = 55865,
  [SMALL_STATE(1766)] = 55881,
  [SMALL_STATE(1767)] = 55891,
  [SMALL_STATE(1768)] = 55905,
  [SMALL_STATE(1769)] = 55919,
  [SMALL_STATE(1770)] = 55929,
  [SMALL_STATE(1771)] = 55945,
  [SMALL_STATE(1772)] = 55955,
  [SMALL_STATE(1773)] = 55971,
  [SMALL_STATE(1774)] = 55985,
  [SMALL_STATE(1775)] = 55999,
  [SMALL_STATE(1776)] = 56013,
  [SMALL_STATE(1777)] = 56023,
  [SMALL_STATE(1778)] = 56037,
  [SMALL_STATE(1779)] = 56053,
  [SMALL_STATE(1780)] = 56063,
  [SMALL_STATE(1781)] = 56073,
  [SMALL_STATE(1782)] = 56083,
  [SMALL_STATE(1783)] = 56097,
  [SMALL_STATE(1784)] = 56111,
  [SMALL_STATE(1785)] = 56125,
  [SMALL_STATE(1786)] = 56139,
  [SMALL_STATE(1787)] = 56153,
  [SMALL_STATE(1788)] = 56167,
  [SMALL_STATE(1789)] = 56183,
  [SMALL_STATE(1790)] = 56199,
  [SMALL_STATE(1791)] = 56213,
  [SMALL_STATE(1792)] = 56229,
  [SMALL_STATE(1793)] = 56243,
  [SMALL_STATE(1794)] = 56253,
  [SMALL_STATE(1795)] = 56267,
  [SMALL_STATE(1796)] = 56281,
  [SMALL_STATE(1797)] = 56295,
  [SMALL_STATE(1798)] = 56309,
  [SMALL_STATE(1799)] = 56325,
  [SMALL_STATE(1800)] = 56339,
  [SMALL_STATE(1801)] = 56355,
  [SMALL_STATE(1802)] = 56371,
  [SMALL_STATE(1803)] = 56387,
  [SMALL_STATE(1804)] = 56397,
  [SMALL_STATE(1805)] = 56413,
  [SMALL_STATE(1806)] = 56427,
  [SMALL_STATE(1807)] = 56437,
  [SMALL_STATE(1808)] = 56449,
  [SMALL_STATE(1809)] = 56465,
  [SMALL_STATE(1810)] = 56481,
  [SMALL_STATE(1811)] = 56495,
  [SMALL_STATE(1812)] = 56511,
  [SMALL_STATE(1813)] = 56525,
  [SMALL_STATE(1814)] = 56539,
  [SMALL_STATE(1815)] = 56555,
  [SMALL_STATE(1816)] = 56571,
  [SMALL_STATE(1817)] = 56583,
  [SMALL_STATE(1818)] = 56597,
  [SMALL_STATE(1819)] = 56613,
  [SMALL_STATE(1820)] = 56629,
  [SMALL_STATE(1821)] = 56643,
  [SMALL_STATE(1822)] = 56659,
  [SMALL_STATE(1823)] = 56675,
  [SMALL_STATE(1824)] = 56689,
  [SMALL_STATE(1825)] = 56705,
  [SMALL_STATE(1826)] = 56719,
  [SMALL_STATE(1827)] = 56735,
  [SMALL_STATE(1828)] = 56749,
  [SMALL_STATE(1829)] = 56763,
  [SMALL_STATE(1830)] = 56777,
  [SMALL_STATE(1831)] = 56791,
  [SMALL_STATE(1832)] = 56807,
  [SMALL_STATE(1833)] = 56821,
  [SMALL_STATE(1834)] = 56837,
  [SMALL_STATE(1835)] = 56851,
  [SMALL_STATE(1836)] = 56867,
  [SMALL_STATE(1837)] = 56883,
  [SMALL_STATE(1838)] = 56899,
  [SMALL_STATE(1839)] = 56913,
  [SMALL_STATE(1840)] = 56927,
  [SMALL_STATE(1841)] = 56943,
  [SMALL_STATE(1842)] = 56957,
  [SMALL_STATE(1843)] = 56973,
  [SMALL_STATE(1844)] = 56989,
  [SMALL_STATE(1845)] = 56999,
  [SMALL_STATE(1846)] = 57013,
  [SMALL_STATE(1847)] = 57029,
  [SMALL_STATE(1848)] = 57043,
  [SMALL_STATE(1849)] = 57053,
  [SMALL_STATE(1850)] = 57069,
  [SMALL_STATE(1851)] = 57085,
  [SMALL_STATE(1852)] = 57101,
  [SMALL_STATE(1853)] = 57117,
  [SMALL_STATE(1854)] = 57131,
  [SMALL_STATE(1855)] = 57145,
  [SMALL_STATE(1856)] = 57161,
  [SMALL_STATE(1857)] = 57171,
  [SMALL_STATE(1858)] = 57187,
  [SMALL_STATE(1859)] = 57203,
  [SMALL_STATE(1860)] = 57217,
  [SMALL_STATE(1861)] = 57233,
  [SMALL_STATE(1862)] = 57249,
  [SMALL_STATE(1863)] = 57265,
  [SMALL_STATE(1864)] = 57281,
  [SMALL_STATE(1865)] = 57297,
  [SMALL_STATE(1866)] = 57307,
  [SMALL_STATE(1867)] = 57321,
  [SMALL_STATE(1868)] = 57335,
  [SMALL_STATE(1869)] = 57349,
  [SMALL_STATE(1870)] = 57363,
  [SMALL_STATE(1871)] = 57379,
  [SMALL_STATE(1872)] = 57395,
  [SMALL_STATE(1873)] = 57411,
  [SMALL_STATE(1874)] = 57423,
  [SMALL_STATE(1875)] = 57433,
  [SMALL_STATE(1876)] = 57447,
  [SMALL_STATE(1877)] = 57463,
  [SMALL_STATE(1878)] = 57477,
  [SMALL_STATE(1879)] = 57491,
  [SMALL_STATE(1880)] = 57505,
  [SMALL_STATE(1881)] = 57519,
  [SMALL_STATE(1882)] = 57533,
  [SMALL_STATE(1883)] = 57547,
  [SMALL_STATE(1884)] = 57563,
  [SMALL_STATE(1885)] = 57575,
  [SMALL_STATE(1886)] = 57591,
  [SMALL_STATE(1887)] = 57601,
  [SMALL_STATE(1888)] = 57617,
  [SMALL_STATE(1889)] = 57633,
  [SMALL_STATE(1890)] = 57647,
  [SMALL_STATE(1891)] = 57661,
  [SMALL_STATE(1892)] = 57677,
  [SMALL_STATE(1893)] = 57691,
  [SMALL_STATE(1894)] = 57707,
  [SMALL_STATE(1895)] = 57723,
  [SMALL_STATE(1896)] = 57739,
  [SMALL_STATE(1897)] = 57755,
  [SMALL_STATE(1898)] = 57769,
  [SMALL_STATE(1899)] = 57783,
  [SMALL_STATE(1900)] = 57793,
  [SMALL_STATE(1901)] = 57805,
  [SMALL_STATE(1902)] = 57819,
  [SMALL_STATE(1903)] = 57835,
  [SMALL_STATE(1904)] = 57849,
  [SMALL_STATE(1905)] = 57865,
  [SMALL_STATE(1906)] = 57881,
  [SMALL_STATE(1907)] = 57895,
  [SMALL_STATE(1908)] = 57905,
  [SMALL_STATE(1909)] = 57921,
  [SMALL_STATE(1910)] = 57935,
  [SMALL_STATE(1911)] = 57951,
  [SMALL_STATE(1912)] = 57965,
  [SMALL_STATE(1913)] = 57979,
  [SMALL_STATE(1914)] = 57995,
  [SMALL_STATE(1915)] = 58008,
  [SMALL_STATE(1916)] = 58019,
  [SMALL_STATE(1917)] = 58030,
  [SMALL_STATE(1918)] = 58041,
  [SMALL_STATE(1919)] = 58054,
  [SMALL_STATE(1920)] = 58063,
  [SMALL_STATE(1921)] = 58076,
  [SMALL_STATE(1922)] = 58087,
  [SMALL_STATE(1923)] = 58098,
  [SMALL_STATE(1924)] = 58109,
  [SMALL_STATE(1925)] = 58122,
  [SMALL_STATE(1926)] = 58133,
  [SMALL_STATE(1927)] = 58146,
  [SMALL_STATE(1928)] = 58157,
  [SMALL_STATE(1929)] = 58166,
  [SMALL_STATE(1930)] = 58179,
  [SMALL_STATE(1931)] = 58188,
  [SMALL_STATE(1932)] = 58201,
  [SMALL_STATE(1933)] = 58214,
  [SMALL_STATE(1934)] = 58227,
  [SMALL_STATE(1935)] = 58240,
  [SMALL_STATE(1936)] = 58251,
  [SMALL_STATE(1937)] = 58264,
  [SMALL_STATE(1938)] = 58277,
  [SMALL_STATE(1939)] = 58290,
  [SMALL_STATE(1940)] = 58303,
  [SMALL_STATE(1941)] = 58316,
  [SMALL_STATE(1942)] = 58329,
  [SMALL_STATE(1943)] = 58342,
  [SMALL_STATE(1944)] = 58355,
  [SMALL_STATE(1945)] = 58368,
  [SMALL_STATE(1946)] = 58379,
  [SMALL_STATE(1947)] = 58390,
  [SMALL_STATE(1948)] = 58399,
  [SMALL_STATE(1949)] = 58412,
  [SMALL_STATE(1950)] = 58421,
  [SMALL_STATE(1951)] = 58432,
  [SMALL_STATE(1952)] = 58445,
  [SMALL_STATE(1953)] = 58458,
  [SMALL_STATE(1954)] = 58467,
  [SMALL_STATE(1955)] = 58480,
  [SMALL_STATE(1956)] = 58491,
  [SMALL_STATE(1957)] = 58502,
  [SMALL_STATE(1958)] = 58515,
  [SMALL_STATE(1959)] = 58528,
  [SMALL_STATE(1960)] = 58541,
  [SMALL_STATE(1961)] = 58552,
  [SMALL_STATE(1962)] = 58561,
  [SMALL_STATE(1963)] = 58570,
  [SMALL_STATE(1964)] = 58581,
  [SMALL_STATE(1965)] = 58594,
  [SMALL_STATE(1966)] = 58607,
  [SMALL_STATE(1967)] = 58620,
  [SMALL_STATE(1968)] = 58633,
  [SMALL_STATE(1969)] = 58646,
  [SMALL_STATE(1970)] = 58659,
  [SMALL_STATE(1971)] = 58672,
  [SMALL_STATE(1972)] = 58681,
  [SMALL_STATE(1973)] = 58694,
  [SMALL_STATE(1974)] = 58707,
  [SMALL_STATE(1975)] = 58720,
  [SMALL_STATE(1976)] = 58733,
  [SMALL_STATE(1977)] = 58744,
  [SMALL_STATE(1978)] = 58755,
  [SMALL_STATE(1979)] = 58766,
  [SMALL_STATE(1980)] = 58779,
  [SMALL_STATE(1981)] = 58792,
  [SMALL_STATE(1982)] = 58805,
  [SMALL_STATE(1983)] = 58816,
  [SMALL_STATE(1984)] = 58827,
  [SMALL_STATE(1985)] = 58838,
  [SMALL_STATE(1986)] = 58851,
  [SMALL_STATE(1987)] = 58862,
  [SMALL_STATE(1988)] = 58871,
  [SMALL_STATE(1989)] = 58882,
  [SMALL_STATE(1990)] = 58893,
  [SMALL_STATE(1991)] = 58906,
  [SMALL_STATE(1992)] = 58919,
  [SMALL_STATE(1993)] = 58932,
  [SMALL_STATE(1994)] = 58943,
  [SMALL_STATE(1995)] = 58954,
  [SMALL_STATE(1996)] = 58963,
  [SMALL_STATE(1997)] = 58976,
  [SMALL_STATE(1998)] = 58989,
  [SMALL_STATE(1999)] = 59002,
  [SMALL_STATE(2000)] = 59015,
  [SMALL_STATE(2001)] = 59026,
  [SMALL_STATE(2002)] = 59039,
  [SMALL_STATE(2003)] = 59052,
  [SMALL_STATE(2004)] = 59065,
  [SMALL_STATE(2005)] = 59078,
  [SMALL_STATE(2006)] = 59087,
  [SMALL_STATE(2007)] = 59098,
  [SMALL_STATE(2008)] = 59111,
  [SMALL_STATE(2009)] = 59124,
  [SMALL_STATE(2010)] = 59135,
  [SMALL_STATE(2011)] = 59146,
  [SMALL_STATE(2012)] = 59157,
  [SMALL_STATE(2013)] = 59170,
  [SMALL_STATE(2014)] = 59181,
  [SMALL_STATE(2015)] = 59192,
  [SMALL_STATE(2016)] = 59201,
  [SMALL_STATE(2017)] = 59212,
  [SMALL_STATE(2018)] = 59223,
  [SMALL_STATE(2019)] = 59232,
  [SMALL_STATE(2020)] = 59243,
  [SMALL_STATE(2021)] = 59254,
  [SMALL_STATE(2022)] = 59267,
  [SMALL_STATE(2023)] = 59276,
  [SMALL_STATE(2024)] = 59289,
  [SMALL_STATE(2025)] = 59302,
  [SMALL_STATE(2026)] = 59313,
  [SMALL_STATE(2027)] = 59326,
  [SMALL_STATE(2028)] = 59335,
  [SMALL_STATE(2029)] = 59348,
  [SMALL_STATE(2030)] = 59361,
  [SMALL_STATE(2031)] = 59372,
  [SMALL_STATE(2032)] = 59385,
  [SMALL_STATE(2033)] = 59398,
  [SMALL_STATE(2034)] = 59411,
  [SMALL_STATE(2035)] = 59424,
  [SMALL_STATE(2036)] = 59437,
  [SMALL_STATE(2037)] = 59448,
  [SMALL_STATE(2038)] = 59459,
  [SMALL_STATE(2039)] = 59470,
  [SMALL_STATE(2040)] = 59481,
  [SMALL_STATE(2041)] = 59492,
  [SMALL_STATE(2042)] = 59503,
  [SMALL_STATE(2043)] = 59516,
  [SMALL_STATE(2044)] = 59529,
  [SMALL_STATE(2045)] = 59542,
  [SMALL_STATE(2046)] = 59553,
  [SMALL_STATE(2047)] = 59564,
  [SMALL_STATE(2048)] = 59577,
  [SMALL_STATE(2049)] = 59588,
  [SMALL_STATE(2050)] = 59599,
  [SMALL_STATE(2051)] = 59610,
  [SMALL_STATE(2052)] = 59623,
  [SMALL_STATE(2053)] = 59634,
  [SMALL_STATE(2054)] = 59643,
  [SMALL_STATE(2055)] = 59654,
  [SMALL_STATE(2056)] = 59665,
  [SMALL_STATE(2057)] = 59674,
  [SMALL_STATE(2058)] = 59685,
  [SMALL_STATE(2059)] = 59698,
  [SMALL_STATE(2060)] = 59709,
  [SMALL_STATE(2061)] = 59722,
  [SMALL_STATE(2062)] = 59733,
  [SMALL_STATE(2063)] = 59744,
  [SMALL_STATE(2064)] = 59757,
  [SMALL_STATE(2065)] = 59770,
  [SMALL_STATE(2066)] = 59781,
  [SMALL_STATE(2067)] = 59792,
  [SMALL_STATE(2068)] = 59803,
  [SMALL_STATE(2069)] = 59814,
  [SMALL_STATE(2070)] = 59825,
  [SMALL_STATE(2071)] = 59838,
  [SMALL_STATE(2072)] = 59849,
  [SMALL_STATE(2073)] = 59860,
  [SMALL_STATE(2074)] = 59871,
  [SMALL_STATE(2075)] = 59882,
  [SMALL_STATE(2076)] = 59895,
  [SMALL_STATE(2077)] = 59906,
  [SMALL_STATE(2078)] = 59917,
  [SMALL_STATE(2079)] = 59930,
  [SMALL_STATE(2080)] = 59941,
  [SMALL_STATE(2081)] = 59952,
  [SMALL_STATE(2082)] = 59963,
  [SMALL_STATE(2083)] = 59974,
  [SMALL_STATE(2084)] = 59987,
  [SMALL_STATE(2085)] = 60000,
  [SMALL_STATE(2086)] = 60011,
  [SMALL_STATE(2087)] = 60022,
  [SMALL_STATE(2088)] = 60033,
  [SMALL_STATE(2089)] = 60046,
  [SMALL_STATE(2090)] = 60057,
  [SMALL_STATE(2091)] = 60068,
  [SMALL_STATE(2092)] = 60079,
  [SMALL_STATE(2093)] = 60090,
  [SMALL_STATE(2094)] = 60103,
  [SMALL_STATE(2095)] = 60114,
  [SMALL_STATE(2096)] = 60127,
  [SMALL_STATE(2097)] = 60136,
  [SMALL_STATE(2098)] = 60147,
  [SMALL_STATE(2099)] = 60158,
  [SMALL_STATE(2100)] = 60171,
  [SMALL_STATE(2101)] = 60182,
  [SMALL_STATE(2102)] = 60193,
  [SMALL_STATE(2103)] = 60204,
  [SMALL_STATE(2104)] = 60213,
  [SMALL_STATE(2105)] = 60226,
  [SMALL_STATE(2106)] = 60237,
  [SMALL_STATE(2107)] = 60248,
  [SMALL_STATE(2108)] = 60259,
  [SMALL_STATE(2109)] = 60272,
  [SMALL_STATE(2110)] = 60281,
  [SMALL_STATE(2111)] = 60292,
  [SMALL_STATE(2112)] = 60303,
  [SMALL_STATE(2113)] = 60316,
  [SMALL_STATE(2114)] = 60327,
  [SMALL_STATE(2115)] = 60340,
  [SMALL_STATE(2116)] = 60353,
  [SMALL_STATE(2117)] = 60364,
  [SMALL_STATE(2118)] = 60375,
  [SMALL_STATE(2119)] = 60386,
  [SMALL_STATE(2120)] = 60399,
  [SMALL_STATE(2121)] = 60412,
  [SMALL_STATE(2122)] = 60423,
  [SMALL_STATE(2123)] = 60436,
  [SMALL_STATE(2124)] = 60447,
  [SMALL_STATE(2125)] = 60458,
  [SMALL_STATE(2126)] = 60469,
  [SMALL_STATE(2127)] = 60480,
  [SMALL_STATE(2128)] = 60491,
  [SMALL_STATE(2129)] = 60502,
  [SMALL_STATE(2130)] = 60515,
  [SMALL_STATE(2131)] = 60528,
  [SMALL_STATE(2132)] = 60539,
  [SMALL_STATE(2133)] = 60552,
  [SMALL_STATE(2134)] = 60565,
  [SMALL_STATE(2135)] = 60576,
  [SMALL_STATE(2136)] = 60587,
  [SMALL_STATE(2137)] = 60598,
  [SMALL_STATE(2138)] = 60609,
  [SMALL_STATE(2139)] = 60620,
  [SMALL_STATE(2140)] = 60631,
  [SMALL_STATE(2141)] = 60640,
  [SMALL_STATE(2142)] = 60653,
  [SMALL_STATE(2143)] = 60662,
  [SMALL_STATE(2144)] = 60673,
  [SMALL_STATE(2145)] = 60686,
  [SMALL_STATE(2146)] = 60697,
  [SMALL_STATE(2147)] = 60710,
  [SMALL_STATE(2148)] = 60721,
  [SMALL_STATE(2149)] = 60734,
  [SMALL_STATE(2150)] = 60747,
  [SMALL_STATE(2151)] = 60758,
  [SMALL_STATE(2152)] = 60771,
  [SMALL_STATE(2153)] = 60782,
  [SMALL_STATE(2154)] = 60795,
  [SMALL_STATE(2155)] = 60808,
  [SMALL_STATE(2156)] = 60821,
  [SMALL_STATE(2157)] = 60834,
  [SMALL_STATE(2158)] = 60847,
  [SMALL_STATE(2159)] = 60858,
  [SMALL_STATE(2160)] = 60871,
  [SMALL_STATE(2161)] = 60882,
  [SMALL_STATE(2162)] = 60891,
  [SMALL_STATE(2163)] = 60904,
  [SMALL_STATE(2164)] = 60915,
  [SMALL_STATE(2165)] = 60926,
  [SMALL_STATE(2166)] = 60937,
  [SMALL_STATE(2167)] = 60948,
  [SMALL_STATE(2168)] = 60961,
  [SMALL_STATE(2169)] = 60972,
  [SMALL_STATE(2170)] = 60985,
  [SMALL_STATE(2171)] = 60996,
  [SMALL_STATE(2172)] = 61005,
  [SMALL_STATE(2173)] = 61016,
  [SMALL_STATE(2174)] = 61029,
  [SMALL_STATE(2175)] = 61042,
  [SMALL_STATE(2176)] = 61053,
  [SMALL_STATE(2177)] = 61064,
  [SMALL_STATE(2178)] = 61075,
  [SMALL_STATE(2179)] = 61086,
  [SMALL_STATE(2180)] = 61097,
  [SMALL_STATE(2181)] = 61108,
  [SMALL_STATE(2182)] = 61119,
  [SMALL_STATE(2183)] = 61132,
  [SMALL_STATE(2184)] = 61140,
  [SMALL_STATE(2185)] = 61150,
  [SMALL_STATE(2186)] = 61160,
  [SMALL_STATE(2187)] = 61170,
  [SMALL_STATE(2188)] = 61180,
  [SMALL_STATE(2189)] = 61188,
  [SMALL_STATE(2190)] = 61198,
  [SMALL_STATE(2191)] = 61206,
  [SMALL_STATE(2192)] = 61214,
  [SMALL_STATE(2193)] = 61224,
  [SMALL_STATE(2194)] = 61234,
  [SMALL_STATE(2195)] = 61244,
  [SMALL_STATE(2196)] = 61252,
  [SMALL_STATE(2197)] = 61262,
  [SMALL_STATE(2198)] = 61272,
  [SMALL_STATE(2199)] = 61282,
  [SMALL_STATE(2200)] = 61290,
  [SMALL_STATE(2201)] = 61298,
  [SMALL_STATE(2202)] = 61308,
  [SMALL_STATE(2203)] = 61318,
  [SMALL_STATE(2204)] = 61328,
  [SMALL_STATE(2205)] = 61338,
  [SMALL_STATE(2206)] = 61348,
  [SMALL_STATE(2207)] = 61358,
  [SMALL_STATE(2208)] = 61368,
  [SMALL_STATE(2209)] = 61378,
  [SMALL_STATE(2210)] = 61388,
  [SMALL_STATE(2211)] = 61398,
  [SMALL_STATE(2212)] = 61408,
  [SMALL_STATE(2213)] = 61416,
  [SMALL_STATE(2214)] = 61426,
  [SMALL_STATE(2215)] = 61434,
  [SMALL_STATE(2216)] = 61444,
  [SMALL_STATE(2217)] = 61454,
  [SMALL_STATE(2218)] = 61462,
  [SMALL_STATE(2219)] = 61470,
  [SMALL_STATE(2220)] = 61480,
  [SMALL_STATE(2221)] = 61488,
  [SMALL_STATE(2222)] = 61498,
  [SMALL_STATE(2223)] = 61506,
  [SMALL_STATE(2224)] = 61514,
  [SMALL_STATE(2225)] = 61524,
  [SMALL_STATE(2226)] = 61534,
  [SMALL_STATE(2227)] = 61544,
  [SMALL_STATE(2228)] = 61552,
  [SMALL_STATE(2229)] = 61562,
  [SMALL_STATE(2230)] = 61572,
  [SMALL_STATE(2231)] = 61580,
  [SMALL_STATE(2232)] = 61590,
  [SMALL_STATE(2233)] = 61600,
  [SMALL_STATE(2234)] = 61608,
  [SMALL_STATE(2235)] = 61616,
  [SMALL_STATE(2236)] = 61624,
  [SMALL_STATE(2237)] = 61632,
  [SMALL_STATE(2238)] = 61640,
  [SMALL_STATE(2239)] = 61650,
  [SMALL_STATE(2240)] = 61658,
  [SMALL_STATE(2241)] = 61666,
  [SMALL_STATE(2242)] = 61676,
  [SMALL_STATE(2243)] = 61684,
  [SMALL_STATE(2244)] = 61694,
  [SMALL_STATE(2245)] = 61704,
  [SMALL_STATE(2246)] = 61714,
  [SMALL_STATE(2247)] = 61724,
  [SMALL_STATE(2248)] = 61734,
  [SMALL_STATE(2249)] = 61742,
  [SMALL_STATE(2250)] = 61752,
  [SMALL_STATE(2251)] = 61760,
  [SMALL_STATE(2252)] = 61770,
  [SMALL_STATE(2253)] = 61778,
  [SMALL_STATE(2254)] = 61788,
  [SMALL_STATE(2255)] = 61798,
  [SMALL_STATE(2256)] = 61806,
  [SMALL_STATE(2257)] = 61816,
  [SMALL_STATE(2258)] = 61824,
  [SMALL_STATE(2259)] = 61834,
  [SMALL_STATE(2260)] = 61844,
  [SMALL_STATE(2261)] = 61854,
  [SMALL_STATE(2262)] = 61864,
  [SMALL_STATE(2263)] = 61874,
  [SMALL_STATE(2264)] = 61884,
  [SMALL_STATE(2265)] = 61894,
  [SMALL_STATE(2266)] = 61902,
  [SMALL_STATE(2267)] = 61912,
  [SMALL_STATE(2268)] = 61922,
  [SMALL_STATE(2269)] = 61932,
  [SMALL_STATE(2270)] = 61942,
  [SMALL_STATE(2271)] = 61950,
  [SMALL_STATE(2272)] = 61958,
  [SMALL_STATE(2273)] = 61968,
  [SMALL_STATE(2274)] = 61976,
  [SMALL_STATE(2275)] = 61986,
  [SMALL_STATE(2276)] = 61994,
  [SMALL_STATE(2277)] = 62004,
  [SMALL_STATE(2278)] = 62012,
  [SMALL_STATE(2279)] = 62022,
  [SMALL_STATE(2280)] = 62032,
  [SMALL_STATE(2281)] = 62042,
  [SMALL_STATE(2282)] = 62052,
  [SMALL_STATE(2283)] = 62060,
  [SMALL_STATE(2284)] = 62070,
  [SMALL_STATE(2285)] = 62078,
  [SMALL_STATE(2286)] = 62088,
  [SMALL_STATE(2287)] = 62098,
  [SMALL_STATE(2288)] = 62106,
  [SMALL_STATE(2289)] = 62116,
  [SMALL_STATE(2290)] = 62124,
  [SMALL_STATE(2291)] = 62132,
  [SMALL_STATE(2292)] = 62142,
  [SMALL_STATE(2293)] = 62150,
  [SMALL_STATE(2294)] = 62160,
  [SMALL_STATE(2295)] = 62168,
  [SMALL_STATE(2296)] = 62178,
  [SMALL_STATE(2297)] = 62186,
  [SMALL_STATE(2298)] = 62196,
  [SMALL_STATE(2299)] = 62206,
  [SMALL_STATE(2300)] = 62216,
  [SMALL_STATE(2301)] = 62224,
  [SMALL_STATE(2302)] = 62234,
  [SMALL_STATE(2303)] = 62242,
  [SMALL_STATE(2304)] = 62252,
  [SMALL_STATE(2305)] = 62262,
  [SMALL_STATE(2306)] = 62272,
  [SMALL_STATE(2307)] = 62280,
  [SMALL_STATE(2308)] = 62290,
  [SMALL_STATE(2309)] = 62298,
  [SMALL_STATE(2310)] = 62308,
  [SMALL_STATE(2311)] = 62318,
  [SMALL_STATE(2312)] = 62326,
  [SMALL_STATE(2313)] = 62336,
  [SMALL_STATE(2314)] = 62344,
  [SMALL_STATE(2315)] = 62354,
  [SMALL_STATE(2316)] = 62362,
  [SMALL_STATE(2317)] = 62372,
  [SMALL_STATE(2318)] = 62382,
  [SMALL_STATE(2319)] = 62392,
  [SMALL_STATE(2320)] = 62402,
  [SMALL_STATE(2321)] = 62412,
  [SMALL_STATE(2322)] = 62422,
  [SMALL_STATE(2323)] = 62432,
  [SMALL_STATE(2324)] = 62440,
  [SMALL_STATE(2325)] = 62448,
  [SMALL_STATE(2326)] = 62458,
  [SMALL_STATE(2327)] = 62468,
  [SMALL_STATE(2328)] = 62476,
  [SMALL_STATE(2329)] = 62484,
  [SMALL_STATE(2330)] = 62494,
  [SMALL_STATE(2331)] = 62504,
  [SMALL_STATE(2332)] = 62514,
  [SMALL_STATE(2333)] = 62522,
  [SMALL_STATE(2334)] = 62530,
  [SMALL_STATE(2335)] = 62540,
  [SMALL_STATE(2336)] = 62548,
  [SMALL_STATE(2337)] = 62558,
  [SMALL_STATE(2338)] = 62568,
  [SMALL_STATE(2339)] = 62576,
  [SMALL_STATE(2340)] = 62586,
  [SMALL_STATE(2341)] = 62596,
  [SMALL_STATE(2342)] = 62606,
  [SMALL_STATE(2343)] = 62616,
  [SMALL_STATE(2344)] = 62626,
  [SMALL_STATE(2345)] = 62636,
  [SMALL_STATE(2346)] = 62646,
  [SMALL_STATE(2347)] = 62656,
  [SMALL_STATE(2348)] = 62666,
  [SMALL_STATE(2349)] = 62676,
  [SMALL_STATE(2350)] = 62684,
  [SMALL_STATE(2351)] = 62694,
  [SMALL_STATE(2352)] = 62704,
  [SMALL_STATE(2353)] = 62714,
  [SMALL_STATE(2354)] = 62724,
  [SMALL_STATE(2355)] = 62734,
  [SMALL_STATE(2356)] = 62742,
  [SMALL_STATE(2357)] = 62752,
  [SMALL_STATE(2358)] = 62762,
  [SMALL_STATE(2359)] = 62770,
  [SMALL_STATE(2360)] = 62780,
  [SMALL_STATE(2361)] = 62788,
  [SMALL_STATE(2362)] = 62798,
  [SMALL_STATE(2363)] = 62808,
  [SMALL_STATE(2364)] = 62816,
  [SMALL_STATE(2365)] = 62824,
  [SMALL_STATE(2366)] = 62834,
  [SMALL_STATE(2367)] = 62842,
  [SMALL_STATE(2368)] = 62852,
  [SMALL_STATE(2369)] = 62860,
  [SMALL_STATE(2370)] = 62868,
  [SMALL_STATE(2371)] = 62878,
  [SMALL_STATE(2372)] = 62888,
  [SMALL_STATE(2373)] = 62898,
  [SMALL_STATE(2374)] = 62908,
  [SMALL_STATE(2375)] = 62918,
  [SMALL_STATE(2376)] = 62928,
  [SMALL_STATE(2377)] = 62938,
  [SMALL_STATE(2378)] = 62948,
  [SMALL_STATE(2379)] = 62958,
  [SMALL_STATE(2380)] = 62968,
  [SMALL_STATE(2381)] = 62978,
  [SMALL_STATE(2382)] = 62986,
  [SMALL_STATE(2383)] = 62996,
  [SMALL_STATE(2384)] = 63006,
  [SMALL_STATE(2385)] = 63014,
  [SMALL_STATE(2386)] = 63022,
  [SMALL_STATE(2387)] = 63032,
  [SMALL_STATE(2388)] = 63042,
  [SMALL_STATE(2389)] = 63050,
  [SMALL_STATE(2390)] = 63060,
  [SMALL_STATE(2391)] = 63070,
  [SMALL_STATE(2392)] = 63078,
  [SMALL_STATE(2393)] = 63086,
  [SMALL_STATE(2394)] = 63094,
  [SMALL_STATE(2395)] = 63102,
  [SMALL_STATE(2396)] = 63112,
  [SMALL_STATE(2397)] = 63120,
  [SMALL_STATE(2398)] = 63130,
  [SMALL_STATE(2399)] = 63140,
  [SMALL_STATE(2400)] = 63150,
  [SMALL_STATE(2401)] = 63160,
  [SMALL_STATE(2402)] = 63168,
  [SMALL_STATE(2403)] = 63176,
  [SMALL_STATE(2404)] = 63184,
  [SMALL_STATE(2405)] = 63192,
  [SMALL_STATE(2406)] = 63202,
  [SMALL_STATE(2407)] = 63212,
  [SMALL_STATE(2408)] = 63222,
  [SMALL_STATE(2409)] = 63230,
  [SMALL_STATE(2410)] = 63240,
  [SMALL_STATE(2411)] = 63250,
  [SMALL_STATE(2412)] = 63260,
  [SMALL_STATE(2413)] = 63268,
  [SMALL_STATE(2414)] = 63278,
  [SMALL_STATE(2415)] = 63288,
  [SMALL_STATE(2416)] = 63298,
  [SMALL_STATE(2417)] = 63308,
  [SMALL_STATE(2418)] = 63318,
  [SMALL_STATE(2419)] = 63328,
  [SMALL_STATE(2420)] = 63338,
  [SMALL_STATE(2421)] = 63348,
  [SMALL_STATE(2422)] = 63356,
  [SMALL_STATE(2423)] = 63366,
  [SMALL_STATE(2424)] = 63374,
  [SMALL_STATE(2425)] = 63384,
  [SMALL_STATE(2426)] = 63394,
  [SMALL_STATE(2427)] = 63404,
  [SMALL_STATE(2428)] = 63412,
  [SMALL_STATE(2429)] = 63422,
  [SMALL_STATE(2430)] = 63432,
  [SMALL_STATE(2431)] = 63440,
  [SMALL_STATE(2432)] = 63448,
  [SMALL_STATE(2433)] = 63456,
  [SMALL_STATE(2434)] = 63464,
  [SMALL_STATE(2435)] = 63474,
  [SMALL_STATE(2436)] = 63482,
  [SMALL_STATE(2437)] = 63490,
  [SMALL_STATE(2438)] = 63500,
  [SMALL_STATE(2439)] = 63508,
  [SMALL_STATE(2440)] = 63516,
  [SMALL_STATE(2441)] = 63526,
  [SMALL_STATE(2442)] = 63536,
  [SMALL_STATE(2443)] = 63544,
  [SMALL_STATE(2444)] = 63554,
  [SMALL_STATE(2445)] = 63564,
  [SMALL_STATE(2446)] = 63574,
  [SMALL_STATE(2447)] = 63584,
  [SMALL_STATE(2448)] = 63591,
  [SMALL_STATE(2449)] = 63598,
  [SMALL_STATE(2450)] = 63605,
  [SMALL_STATE(2451)] = 63612,
  [SMALL_STATE(2452)] = 63619,
  [SMALL_STATE(2453)] = 63626,
  [SMALL_STATE(2454)] = 63633,
  [SMALL_STATE(2455)] = 63640,
  [SMALL_STATE(2456)] = 63647,
  [SMALL_STATE(2457)] = 63654,
  [SMALL_STATE(2458)] = 63661,
  [SMALL_STATE(2459)] = 63668,
  [SMALL_STATE(2460)] = 63675,
  [SMALL_STATE(2461)] = 63682,
  [SMALL_STATE(2462)] = 63689,
  [SMALL_STATE(2463)] = 63696,
  [SMALL_STATE(2464)] = 63703,
  [SMALL_STATE(2465)] = 63710,
  [SMALL_STATE(2466)] = 63717,
  [SMALL_STATE(2467)] = 63724,
  [SMALL_STATE(2468)] = 63731,
  [SMALL_STATE(2469)] = 63738,
  [SMALL_STATE(2470)] = 63745,
  [SMALL_STATE(2471)] = 63752,
  [SMALL_STATE(2472)] = 63759,
  [SMALL_STATE(2473)] = 63766,
  [SMALL_STATE(2474)] = 63773,
  [SMALL_STATE(2475)] = 63780,
  [SMALL_STATE(2476)] = 63787,
  [SMALL_STATE(2477)] = 63794,
  [SMALL_STATE(2478)] = 63801,
  [SMALL_STATE(2479)] = 63808,
  [SMALL_STATE(2480)] = 63815,
  [SMALL_STATE(2481)] = 63822,
  [SMALL_STATE(2482)] = 63829,
  [SMALL_STATE(2483)] = 63836,
  [SMALL_STATE(2484)] = 63843,
  [SMALL_STATE(2485)] = 63850,
  [SMALL_STATE(2486)] = 63857,
  [SMALL_STATE(2487)] = 63864,
  [SMALL_STATE(2488)] = 63871,
  [SMALL_STATE(2489)] = 63878,
  [SMALL_STATE(2490)] = 63885,
  [SMALL_STATE(2491)] = 63892,
  [SMALL_STATE(2492)] = 63899,
  [SMALL_STATE(2493)] = 63906,
  [SMALL_STATE(2494)] = 63913,
  [SMALL_STATE(2495)] = 63920,
  [SMALL_STATE(2496)] = 63927,
  [SMALL_STATE(2497)] = 63934,
  [SMALL_STATE(2498)] = 63941,
  [SMALL_STATE(2499)] = 63948,
  [SMALL_STATE(2500)] = 63955,
  [SMALL_STATE(2501)] = 63962,
  [SMALL_STATE(2502)] = 63969,
  [SMALL_STATE(2503)] = 63976,
  [SMALL_STATE(2504)] = 63983,
  [SMALL_STATE(2505)] = 63990,
  [SMALL_STATE(2506)] = 63997,
  [SMALL_STATE(2507)] = 64004,
  [SMALL_STATE(2508)] = 64011,
  [SMALL_STATE(2509)] = 64018,
  [SMALL_STATE(2510)] = 64025,
  [SMALL_STATE(2511)] = 64032,
  [SMALL_STATE(2512)] = 64039,
  [SMALL_STATE(2513)] = 64046,
  [SMALL_STATE(2514)] = 64053,
  [SMALL_STATE(2515)] = 64060,
  [SMALL_STATE(2516)] = 64067,
  [SMALL_STATE(2517)] = 64074,
  [SMALL_STATE(2518)] = 64081,
  [SMALL_STATE(2519)] = 64088,
  [SMALL_STATE(2520)] = 64095,
  [SMALL_STATE(2521)] = 64102,
  [SMALL_STATE(2522)] = 64109,
  [SMALL_STATE(2523)] = 64116,
  [SMALL_STATE(2524)] = 64123,
  [SMALL_STATE(2525)] = 64130,
  [SMALL_STATE(2526)] = 64137,
  [SMALL_STATE(2527)] = 64144,
  [SMALL_STATE(2528)] = 64151,
  [SMALL_STATE(2529)] = 64158,
  [SMALL_STATE(2530)] = 64165,
  [SMALL_STATE(2531)] = 64172,
  [SMALL_STATE(2532)] = 64179,
  [SMALL_STATE(2533)] = 64186,
  [SMALL_STATE(2534)] = 64193,
  [SMALL_STATE(2535)] = 64200,
  [SMALL_STATE(2536)] = 64207,
  [SMALL_STATE(2537)] = 64214,
  [SMALL_STATE(2538)] = 64221,
  [SMALL_STATE(2539)] = 64228,
  [SMALL_STATE(2540)] = 64235,
  [SMALL_STATE(2541)] = 64242,
  [SMALL_STATE(2542)] = 64249,
  [SMALL_STATE(2543)] = 64256,
  [SMALL_STATE(2544)] = 64263,
  [SMALL_STATE(2545)] = 64270,
  [SMALL_STATE(2546)] = 64277,
  [SMALL_STATE(2547)] = 64284,
  [SMALL_STATE(2548)] = 64291,
  [SMALL_STATE(2549)] = 64298,
  [SMALL_STATE(2550)] = 64305,
  [SMALL_STATE(2551)] = 64312,
  [SMALL_STATE(2552)] = 64319,
  [SMALL_STATE(2553)] = 64326,
  [SMALL_STATE(2554)] = 64333,
  [SMALL_STATE(2555)] = 64340,
  [SMALL_STATE(2556)] = 64347,
  [SMALL_STATE(2557)] = 64354,
  [SMALL_STATE(2558)] = 64361,
  [SMALL_STATE(2559)] = 64368,
  [SMALL_STATE(2560)] = 64375,
  [SMALL_STATE(2561)] = 64382,
  [SMALL_STATE(2562)] = 64389,
  [SMALL_STATE(2563)] = 64396,
  [SMALL_STATE(2564)] = 64403,
  [SMALL_STATE(2565)] = 64410,
  [SMALL_STATE(2566)] = 64417,
  [SMALL_STATE(2567)] = 64424,
  [SMALL_STATE(2568)] = 64431,
  [SMALL_STATE(2569)] = 64438,
  [SMALL_STATE(2570)] = 64445,
  [SMALL_STATE(2571)] = 64452,
  [SMALL_STATE(2572)] = 64459,
  [SMALL_STATE(2573)] = 64466,
  [SMALL_STATE(2574)] = 64473,
  [SMALL_STATE(2575)] = 64480,
  [SMALL_STATE(2576)] = 64487,
  [SMALL_STATE(2577)] = 64494,
  [SMALL_STATE(2578)] = 64501,
  [SMALL_STATE(2579)] = 64508,
  [SMALL_STATE(2580)] = 64515,
  [SMALL_STATE(2581)] = 64522,
  [SMALL_STATE(2582)] = 64529,
  [SMALL_STATE(2583)] = 64536,
  [SMALL_STATE(2584)] = 64543,
  [SMALL_STATE(2585)] = 64550,
  [SMALL_STATE(2586)] = 64557,
  [SMALL_STATE(2587)] = 64564,
  [SMALL_STATE(2588)] = 64571,
  [SMALL_STATE(2589)] = 64578,
  [SMALL_STATE(2590)] = 64585,
  [SMALL_STATE(2591)] = 64592,
  [SMALL_STATE(2592)] = 64599,
  [SMALL_STATE(2593)] = 64606,
  [SMALL_STATE(2594)] = 64613,
  [SMALL_STATE(2595)] = 64620,
  [SMALL_STATE(2596)] = 64627,
  [SMALL_STATE(2597)] = 64634,
  [SMALL_STATE(2598)] = 64641,
  [SMALL_STATE(2599)] = 64648,
  [SMALL_STATE(2600)] = 64655,
  [SMALL_STATE(2601)] = 64662,
  [SMALL_STATE(2602)] = 64669,
  [SMALL_STATE(2603)] = 64676,
  [SMALL_STATE(2604)] = 64683,
  [SMALL_STATE(2605)] = 64690,
  [SMALL_STATE(2606)] = 64697,
  [SMALL_STATE(2607)] = 64704,
  [SMALL_STATE(2608)] = 64711,
  [SMALL_STATE(2609)] = 64718,
  [SMALL_STATE(2610)] = 64725,
  [SMALL_STATE(2611)] = 64732,
  [SMALL_STATE(2612)] = 64739,
  [SMALL_STATE(2613)] = 64746,
  [SMALL_STATE(2614)] = 64753,
  [SMALL_STATE(2615)] = 64760,
  [SMALL_STATE(2616)] = 64767,
  [SMALL_STATE(2617)] = 64774,
  [SMALL_STATE(2618)] = 64781,
  [SMALL_STATE(2619)] = 64788,
  [SMALL_STATE(2620)] = 64795,
  [SMALL_STATE(2621)] = 64802,
  [SMALL_STATE(2622)] = 64809,
  [SMALL_STATE(2623)] = 64816,
  [SMALL_STATE(2624)] = 64823,
  [SMALL_STATE(2625)] = 64830,
  [SMALL_STATE(2626)] = 64837,
  [SMALL_STATE(2627)] = 64844,
  [SMALL_STATE(2628)] = 64851,
  [SMALL_STATE(2629)] = 64858,
  [SMALL_STATE(2630)] = 64865,
  [SMALL_STATE(2631)] = 64872,
  [SMALL_STATE(2632)] = 64879,
  [SMALL_STATE(2633)] = 64886,
  [SMALL_STATE(2634)] = 64893,
  [SMALL_STATE(2635)] = 64900,
  [SMALL_STATE(2636)] = 64907,
  [SMALL_STATE(2637)] = 64914,
  [SMALL_STATE(2638)] = 64921,
  [SMALL_STATE(2639)] = 64928,
  [SMALL_STATE(2640)] = 64935,
  [SMALL_STATE(2641)] = 64942,
  [SMALL_STATE(2642)] = 64949,
  [SMALL_STATE(2643)] = 64956,
  [SMALL_STATE(2644)] = 64963,
  [SMALL_STATE(2645)] = 64970,
  [SMALL_STATE(2646)] = 64977,
  [SMALL_STATE(2647)] = 64984,
  [SMALL_STATE(2648)] = 64991,
  [SMALL_STATE(2649)] = 64998,
  [SMALL_STATE(2650)] = 65005,
  [SMALL_STATE(2651)] = 65012,
  [SMALL_STATE(2652)] = 65019,
  [SMALL_STATE(2653)] = 65026,
  [SMALL_STATE(2654)] = 65033,
  [SMALL_STATE(2655)] = 65040,
  [SMALL_STATE(2656)] = 65047,
  [SMALL_STATE(2657)] = 65054,
  [SMALL_STATE(2658)] = 65061,
  [SMALL_STATE(2659)] = 65068,
  [SMALL_STATE(2660)] = 65075,
  [SMALL_STATE(2661)] = 65082,
  [SMALL_STATE(2662)] = 65089,
  [SMALL_STATE(2663)] = 65096,
  [SMALL_STATE(2664)] = 65103,
  [SMALL_STATE(2665)] = 65110,
  [SMALL_STATE(2666)] = 65117,
  [SMALL_STATE(2667)] = 65124,
  [SMALL_STATE(2668)] = 65131,
  [SMALL_STATE(2669)] = 65138,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2645),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2641),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2638),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2635),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2618),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2615),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2606),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2241),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2597),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2592),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2590),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2269),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2562),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(797),
  [138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(472),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1424),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2137),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1674),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1397),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1496),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1081),
  [159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2202),
  [162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(50),
  [165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2645),
  [168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2641),
  [171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2638),
  [174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2635),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1286),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1309),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1340),
  [188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1337),
  [191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1902),
  [194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(90),
  [197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2618),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(198),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2615),
  [206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2606),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1123),
  [212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2241),
  [215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2597),
  [218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(200),
  [221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(199),
  [224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(197),
  [227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(353),
  [230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2254),
  [233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(80),
  [236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2592),
  [239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2590),
  [242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2256),
  [245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2258),
  [248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2269),
  [251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(394),
  [254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(394),
  [257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(410),
  [260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(568),
  [263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(415),
  [266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(667),
  [269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(837),
  [272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2562),
  [275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(109),
  [278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(728),
  [281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1126),
  [284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1131),
  [287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1426),
  [290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1815),
  [293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1371),
  [296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2047),
  [299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1404),
  [302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1733),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(87),
  [308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(373),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(372),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(362),
  [317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(361),
  [320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, .production_id = 135),
  [322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, .production_id = 135),
  [324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_statement, 2),
  [326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_statement, 2),
  [328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_statement, 3),
  [330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_statement, 3),
  [332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, .production_id = 135),
  [334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, .production_id = 135),
  [336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_colon_block, 1),
  [338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_colon_block, 2),
  [340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2656),
  [343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2276),
  [346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2665),
  [349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2669),
  [352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2262),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2656),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2276),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2665),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2669),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2262),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2595),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2594),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2593),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2589),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2636),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2637),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2298),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2657),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2666),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2267),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2264),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2652),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2668),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2236),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2294),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2364),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2315),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2363),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2287),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2349),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2273),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2220),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2217),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2313),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2584),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2437),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__array_destructing_repeat1, 1),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_destructing_repeat1, 1), SHIFT(864),
  [866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_destructing_repeat1, 1), SHIFT(727),
  [869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 1),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_condition_list, 2),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_placeholder, 1),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_condition_list, 3),
  [969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 3),
  [971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 3),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2575),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2274),
  [977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2575),
  [984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2274),
  [987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 19),
  [989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 19),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2362),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 48),
  [997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 48),
  [999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 48), SHIFT(2362),
  [1002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 48), SHIFT(84),
  [1005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 19), SHIFT(2362),
  [1008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 19), SHIFT(84),
  [1011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 92),
  [1013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 92),
  [1015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 92), SHIFT_REPEAT(2362),
  [1018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, .production_id = 185),
  [1020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, .production_id = 185),
  [1022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3),
  [1024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3),
  [1026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2),
  [1028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2),
  [1030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 167),
  [1032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 167),
  [1034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 3),
  [1036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 3),
  [1038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 89),
  [1040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 89),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [1044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 151),
  [1046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 151),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 108),
  [1052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 108),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [1056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 110),
  [1058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 110),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [1062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3),
  [1064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3),
  [1066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 43),
  [1068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 43),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [1072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 56),
  [1074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 56),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 13),
  [1080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 13),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [1084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 64),
  [1086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 64),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 187),
  [1092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 187),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [1096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 152),
  [1098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 152),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 98),
  [1104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 98),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [1108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 153),
  [1110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 153),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 171),
  [1116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 171),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 140),
  [1122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 140),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [1126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2),
  [1128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2),
  [1130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 141),
  [1132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 141),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 177),
  [1138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 177),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 97),
  [1144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 97),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [1148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 178),
  [1150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 178),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, .production_id = 88),
  [1156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, .production_id = 88),
  [1158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 5),
  [1160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 5),
  [1162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_statement, 5),
  [1164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare_statement, 5),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 97),
  [1168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 97),
  [1170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unset_statement, 5),
  [1172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unset_statement, 5),
  [1174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 98),
  [1176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 98),
  [1178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 43),
  [1180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 43),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 6, .production_id = 100),
  [1184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 6, .production_id = 100),
  [1186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 2, .production_id = 10),
  [1188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 2, .production_id = 10),
  [1190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9),
  [1192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9),
  [1194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [1196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration_list, 3),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration_list, 3),
  [1202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, .production_id = 108),
  [1204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, .production_id = 108),
  [1206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, .production_id = 150),
  [1208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, .production_id = 150),
  [1210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 108),
  [1212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 108),
  [1214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [1216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [1218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 7),
  [1220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 7),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [1224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [1226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 2),
  [1228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 2),
  [1230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_statement, 7),
  [1232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare_statement, 7),
  [1234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_static_declaration, 3),
  [1236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_static_declaration, 3),
  [1238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 56),
  [1240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 56),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_declaration, 3),
  [1244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_declaration, 3),
  [1246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7),
  [1248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7),
  [1250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 7),
  [1252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 7),
  [1254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 7, .production_id = 168),
  [1256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 7, .production_id = 168),
  [1258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 91),
  [1260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 91),
  [1262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 5, .production_id = 41),
  [1264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 5, .production_id = 41),
  [1266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3),
  [1268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, .production_id = 12),
  [1272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, .production_id = 12),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 91),
  [1276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 91),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 2, .production_id = 3),
  [1280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 2, .production_id = 3),
  [1282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 19),
  [1284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 19),
  [1286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 64),
  [1288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 64),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 1, .production_id = 1),
  [1292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 1, .production_id = 1),
  [1294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 6),
  [1296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 6),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, .production_id = 3),
  [1300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, .production_id = 3),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 140),
  [1304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 140),
  [1306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 141),
  [1308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 141),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [1312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 7, .production_id = 176),
  [1316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 7, .production_id = 176),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 151),
  [1320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 151),
  [1322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 152),
  [1324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 152),
  [1326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 153),
  [1328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 153),
  [1330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [1332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [1334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, .production_id = 28),
  [1336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, .production_id = 28),
  [1338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 48),
  [1340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 48),
  [1342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_statement, 8),
  [1344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare_statement, 8),
  [1346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 47),
  [1348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 47),
  [1350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8),
  [1352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_static_declaration, 4),
  [1356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_static_declaration, 4),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_clause, 3, .production_id = 19),
  [1360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_clause, 3, .production_id = 19),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 19),
  [1364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 19),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_declaration, 4),
  [1368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_declaration, 4),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 5, .production_id = 100),
  [1372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 5, .production_id = 100),
  [1374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_label_statement, 2),
  [1376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_label_statement, 2),
  [1378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 171),
  [1380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 171),
  [1382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 4),
  [1384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 4),
  [1386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 177),
  [1388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 177),
  [1390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 178),
  [1392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 178),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 19),
  [1396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 19),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 3),
  [1400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 3),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 110),
  [1404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 110),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 5),
  [1408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 5),
  [1410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 9, .production_id = 168),
  [1412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 9, .production_id = 168),
  [1414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 9, .production_id = 187),
  [1416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 9, .production_id = 187),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, .production_id = 13),
  [1420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, .production_id = 13),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10),
  [1424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10),
  [1426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 11),
  [1428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 11),
  [1430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 12),
  [1432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 12),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3),
  [1436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 13),
  [1440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 13),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [1444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 47),
  [1448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 47),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 4),
  [1452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 4),
  [1454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_echo_statement, 3),
  [1456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_echo_statement, 3),
  [1458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 46),
  [1460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 46),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 43),
  [1464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 43),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 3),
  [1468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 3),
  [1470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_declaration, 3, .production_id = 13),
  [1472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_declaration, 3, .production_id = 13),
  [1474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 3),
  [1476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 3),
  [1478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 64),
  [1480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 64),
  [1482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 13),
  [1484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 13),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration_list, 2),
  [1488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration_list, 2),
  [1490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6),
  [1492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6),
  [1494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 4, .production_id = 41),
  [1496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 4, .production_id = 41),
  [1498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unset_statement, 6),
  [1500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unset_statement, 6),
  [1502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 19),
  [1504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 19),
  [1506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 43),
  [1508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 43),
  [1510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 90),
  [1512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 90),
  [1514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 89),
  [1516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 89),
  [1518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, .production_id = 132),
  [1520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, .production_id = 132),
  [1522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 4),
  [1524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 4),
  [1526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 13),
  [1528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 13),
  [1530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3),
  [1532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3),
  [1534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [1540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [1548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [1554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 5),
  [1556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 5),
  [1558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [1560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [1562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [1564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [1566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [1568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [1570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullsafe_member_access_expression, 5, .production_id = 103),
  [1572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullsafe_member_access_expression, 5, .production_id = 103),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_access_expression, 5, .production_id = 103),
  [1578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_access_expression, 5, .production_id = 103),
  [1580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_property_access_expression, 3, .production_id = 25),
  [1582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_property_access_expression, 3, .production_id = 25),
  [1584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_access_expression, 3, .production_id = 26),
  [1586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_access_expression, 3, .production_id = 26),
  [1588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullsafe_member_access_expression, 3, .production_id = 26),
  [1590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullsafe_member_access_expression, 3, .production_id = 26),
  [1592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expression, 1),
  [1594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expression, 1),
  [1596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_variable, 4, .production_id = 45),
  [1598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dereferencable_expression, 1),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [1602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_variable, 4, .production_id = 45),
  [1604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_call_expression, 6, .production_id = 143),
  [1606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_call_expression, 6, .production_id = 143),
  [1608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullsafe_member_call_expression, 4, .production_id = 62),
  [1610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullsafe_member_call_expression, 4, .production_id = 62),
  [1612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__reserved_identifier, 1),
  [1614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__reserved_identifier, 1),
  [1616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_call_expression, 4, .production_id = 62),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_call_expression, 4, .production_id = 62),
  [1620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4),
  [1622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4),
  [1624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_call_expression, 4, .production_id = 61),
  [1626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_call_expression, 4, .production_id = 61),
  [1628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_name, 2),
  [1630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_name, 2),
  [1632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_call_expression, 6, .production_id = 142),
  [1634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_call_expression, 6, .production_id = 142),
  [1636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 3),
  [1638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 3),
  [1640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_variable_name, 4),
  [1642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_variable_name, 4),
  [1644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullsafe_member_call_expression, 6, .production_id = 143),
  [1646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullsafe_member_call_expression, 6, .production_id = 143),
  [1648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call_expression, 2, .production_id = 9),
  [1650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call_expression, 2, .production_id = 9),
  [1652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_variable_name, 2),
  [1654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_variable_name, 2),
  [1656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [1658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [1660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [1670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 2),
  [1680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing_element, 1),
  [1682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1), REDUCE(sym__array_destructing_element, 1),
  [1685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1), REDUCE(sym__array_destructing_element, 3),
  [1688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_name, 2),
  [1690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_name, 2),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [1694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [1696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1571),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [1702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 23),
  [1718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 23),
  [1720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 1), SHIFT(2489),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [1743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 2),
  [1745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 2),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [1755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [1769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [1773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_constant_access_expression, 3),
  [1775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_constant_access_expression, 3),
  [1777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_constant_access_expression, 5, .production_id = 102),
  [1779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_constant_access_expression, 5, .production_id = 102),
  [1781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1437),
  [1784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(728),
  [1787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1940),
  [1790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(2202),
  [1793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2),
  [1795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(98),
  [1798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(2584),
  [1801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(129),
  [1804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1811),
  [1807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1366),
  [1810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(2063),
  [1813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1735),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [1818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_by_ref, 2),
  [1820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_by_ref, 2),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [1828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 2),
  [1830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 2),
  [1832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__array_destructing, 2), REDUCE(sym_array_creation_expression, 2),
  [1835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_destructing, 2),
  [1837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [1839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [1841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4),
  [1845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4),
  [1847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3),
  [1849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3),
  [1851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relative_scope, 1),
  [1853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 7, .production_id = 170),
  [1855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 7, .production_id = 170),
  [1857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nowdoc, 7, .production_id = 169),
  [1859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nowdoc, 7, .production_id = 169),
  [1861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 6, .production_id = 139),
  [1863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 6, .production_id = 139),
  [1865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_encapsed_string, 2),
  [1871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_encapsed_string, 2),
  [1873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nowdoc, 6, .production_id = 138),
  [1875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nowdoc, 6, .production_id = 138),
  [1877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 6, .production_id = 18),
  [1879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 6, .production_id = 18),
  [1881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 5, .production_id = 95),
  [1883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 5, .production_id = 95),
  [1885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nowdoc, 5, .production_id = 94),
  [1887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nowdoc, 5, .production_id = 94),
  [1889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 5, .production_id = 93),
  [1891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 5, .production_id = 93),
  [1893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 5),
  [1895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 5),
  [1897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 5, .production_id = 18),
  [1899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 5, .production_id = 18),
  [1901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 4, .production_id = 52),
  [1903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 4, .production_id = 52),
  [1905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 18),
  [1907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 18),
  [1909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 3, .production_id = 20),
  [1911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 3, .production_id = 20),
  [1913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3, .production_id = 18),
  [1919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3, .production_id = 18),
  [1921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_encapsed_string, 3),
  [1923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_encapsed_string, 3),
  [1925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3),
  [1927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument_name, 2, .production_id = 53),
  [1935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_name, 2, .production_id = 53),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [1939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [1943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_modifier, 1),
  [1945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_modifier, 1),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [1949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing, 2),
  [1969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 11),
  [1971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 11),
  [1973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 2),
  [1975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 2),
  [1977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 8, .production_id = 186),
  [1979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 8, .production_id = 186),
  [1981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 175),
  [1983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 175),
  [1985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 174),
  [1987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 174),
  [1989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 173),
  [1991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 173),
  [1993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 172),
  [1995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 172),
  [1997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1),
  [1999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1),
  [2001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 7, .production_id = 49),
  [2003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 7, .production_id = 49),
  [2005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 5),
  [2007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 5),
  [2009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 155),
  [2011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 155),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 149),
  [2015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 149),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 148),
  [2019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 148),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 147),
  [2023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 147),
  [2025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 146),
  [2027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 146),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 145),
  [2031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 145),
  [2033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 144),
  [2035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 144),
  [2037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 6, .production_id = 49),
  [2039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 6, .production_id = 49),
  [2041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 6),
  [2043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 6),
  [2045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 4),
  [2047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 4),
  [2049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 127),
  [2051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 127),
  [2053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 115),
  [2055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 115),
  [2057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 114),
  [2059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 114),
  [2061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 113),
  [2063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 113),
  [2065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 107),
  [2067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 107),
  [2069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 106),
  [2071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 106),
  [2073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 105),
  [2075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 105),
  [2077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 104),
  [2079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 104),
  [2081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1),
  [2083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1),
  [2085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 5, .production_id = 49),
  [2087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 5, .production_id = 49),
  [2089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 5),
  [2091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 5),
  [2093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 3),
  [2095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 3),
  [2097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 84),
  [2099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 84),
  [2101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 83),
  [2103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 83),
  [2105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 82),
  [2107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 82),
  [2109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 70),
  [2111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 70),
  [2113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 69),
  [2115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 69),
  [2117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 68),
  [2119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 68),
  [2121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 63),
  [2123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 63),
  [2125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [2127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [2131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_element_initializer, 3),
  [2133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_element_initializer, 3),
  [2135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 4, .production_id = 49),
  [2137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 4, .production_id = 49),
  [2139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 4),
  [2141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 4),
  [2143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_element_initializer, 1),
  [2145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_element_initializer, 1),
  [2147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, .production_id = 45),
  [2149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, .production_id = 45),
  [2151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 40),
  [2153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 40),
  [2155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 39),
  [2157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 39),
  [2159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 37),
  [2161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 37),
  [2163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_op_expression, 2, .production_id = 5),
  [2165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_op_expression, 2, .production_id = 5),
  [2167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 29),
  [2169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 29),
  [2171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_suppression_expression, 2),
  [2173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_suppression_expression, 2),
  [2175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_clone_expression, 2),
  [2177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_clone_expression, 2),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [2181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shell_command_expression, 2),
  [2183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shell_command_expression, 2),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [2187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 2),
  [2189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 3, .production_id = 15),
  [2191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 3, .production_id = 15),
  [2193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 3, .production_id = 19),
  [2195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 3, .production_id = 19),
  [2197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shell_command_expression, 3),
  [2199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shell_command_expression, 3),
  [2201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_require_once_expression, 2),
  [2203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [2205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [2227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [2231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [2239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [2243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_expression, 2),
  [2245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_once_expression, 2),
  [2247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [2249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 22),
  [2251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_require_expression, 2),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [2255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_unpacking, 2),
  [2257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_intrinsic, 2),
  [2259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [2261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 23),
  [2263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_expression, 2),
  [2265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, .production_id = 59),
  [2267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, .production_id = 59),
  [2269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_assignment_expression, 4, .production_id = 60),
  [2271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, .production_id = 101),
  [2273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, .production_id = 101),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [2279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [2283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [2291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [2295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [2297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [2307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [2317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2),
  [2319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1313),
  [2322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2),
  [2324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1286),
  [2327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1309),
  [2330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1312),
  [2333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1015),
  [2336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1311),
  [2339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [2341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [2343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [2357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [2363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [2375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [2379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [2381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [2389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [2393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [2399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [2409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [2411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [2415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [2423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [2429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [2431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_variable_declaration, 3, .production_id = 30),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [2435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3),
  [2437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expressions, 1),
  [2441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_element, 3),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [2447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_condition_list, 1),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [2451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_initializer, 2),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [2455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_conditional_expression, 3, .production_id = 134),
  [2457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 3, .production_id = 80),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [2479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 4, .production_id = 116),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [2485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 4, .production_id = 118),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [2491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 6, .production_id = 179),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [2495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 6, .production_id = 180),
  [2497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 6, .production_id = 181),
  [2499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 6, .production_id = 182),
  [2501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 5, .production_id = 161),
  [2503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 4, .production_id = 120),
  [2505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [2507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 4, .production_id = 126),
  [2509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__modifier, 1),
  [2511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [2513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__modifier, 1),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [2519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 5, .production_id = 163),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [2523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1313),
  [2526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1456),
  [2529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1571),
  [2532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1063),
  [2535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2),
  [2537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1286),
  [2540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1309),
  [2543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1312),
  [2546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(641),
  [2549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1311),
  [2552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1426),
  [2555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 3, .production_id = 96),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [2565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 5, .production_id = 159),
  [2567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 5, .production_id = 158),
  [2569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 5, .production_id = 157),
  [2571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 5, .production_id = 156),
  [2573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [2579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 7, .production_id = 188),
  [2581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 2, .production_id = 55),
  [2583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 2, .production_id = 54),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [2593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_default_expression, 3, .production_id = 133),
  [2595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_condition_list_repeat1, 2),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [2667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1569),
  [2669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [2675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [2703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_final_modifier, 1),
  [2705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_final_modifier, 1),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [2709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_pair, 3),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [2717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1491),
  [2742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1456),
  [2745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1571),
  [2748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2),
  [2750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(2581),
  [2753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1487),
  [2756] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1488),
  [2759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1513),
  [2762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1346),
  [2765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1482),
  [2768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1426),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [2791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [2793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_modifier, 1),
  [2795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_modifier, 1),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [2799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 1),
  [2801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 1),
  [2803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readonly_modifier, 1),
  [2805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readonly_modifier, 1),
  [2807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_modifier, 1),
  [2809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_modifier, 1),
  [2811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 1),
  [2813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 1),
  [2815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attribute_list_repeat1, 2),
  [2817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_list_repeat1, 2),
  [2819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_list_repeat1, 2), SHIFT_REPEAT(1438),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [2824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_group, 4),
  [2826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_group, 4),
  [2828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_group, 5),
  [2830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_group, 5),
  [2832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [2834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_group, 3),
  [2836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_group, 3),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [2844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [2846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_heredoc_body, 2), SHIFT(1358),
  [2849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [2853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc_body, 2),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [2859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(334),
  [2862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1350),
  [2865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1449),
  [2868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1358),
  [2871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1685),
  [2874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1449),
  [2877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [2879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2), SHIFT_REPEAT(334),
  [2882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2), SHIFT_REPEAT(1345),
  [2885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2), SHIFT_REPEAT(1449),
  [2888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2),
  [2890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2), SHIFT_REPEAT(1685),
  [2893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2), SHIFT_REPEAT(1449),
  [2896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [2900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [2904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [2906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 1),
  [2908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 1),
  [2910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_list_repeat1, 2), SHIFT_REPEAT(1426),
  [2913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2),
  [2915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1491),
  [2918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1487),
  [2921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1488),
  [2924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1513),
  [2927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1354),
  [2930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1482),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [2935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2453),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [2947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 86),
  [2949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 4),
  [2951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 131),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [2957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [2969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 130),
  [2971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 4, .production_id = 166),
  [2973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 4, .production_id = 165),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [2979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body, 2), SHIFT_REPEAT(264),
  [2982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body, 2), SHIFT_REPEAT(1373),
  [2985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body, 2), SHIFT_REPEAT(1561),
  [2988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body, 2), SHIFT_REPEAT(1561),
  [2991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body, 2),
  [2993] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body, 2), SHIFT_REPEAT(1666),
  [2996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 28),
  [2998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 129),
  [3000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 3),
  [3002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 10),
  [3004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 2),
  [3006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [3008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 3),
  [3010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_case, 4, .production_id = 76),
  [3012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_case, 5, .production_id = 184),
  [3014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, .production_id = 183),
  [3016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [3018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [3020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [3022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [3024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_case, 6, .production_id = 189),
  [3026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_const_declaration, 2, .production_id = 85),
  [3028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [3030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [3032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [3034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [3036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [3038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, .production_id = 164),
  [3040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2), SHIFT_REPEAT(278),
  [3043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2), SHIFT_REPEAT(1394),
  [3046] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2), SHIFT_REPEAT(1394),
  [3049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2),
  [3051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2), SHIFT_REPEAT(1661),
  [3054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_string_part, 1),
  [3056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2622),
  [3058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [3060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_part, 1),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [3064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_const_declaration, 3, .production_id = 128),
  [3066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [3068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [3070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [3074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [3076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [3078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [3080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [3082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 41),
  [3084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [3090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_type, 1),
  [3092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_type, 1),
  [3094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [3096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [3102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [3104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [3106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 3),
  [3108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_const_declaration, 1, .production_id = 1),
  [3110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 164),
  [3112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__member_declaration, 1, .production_id = 42),
  [3114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 183),
  [3116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_case, 3, .production_id = 12),
  [3118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, .production_id = 41),
  [3120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_const_declaration, 2, .production_id = 87),
  [3122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4),
  [3124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [3128] = {.entry = {.count = 4, .reusable = false}}, REDUCE(sym__type, 1), REDUCE(sym_union_type, 1), REDUCE(sym_intersection_type, 1), REDUCE(sym_disjunctive_normal_form_type, 1, .dynamic_precedence = -1),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [3135] = {.entry = {.count = 4, .reusable = true}}, REDUCE(sym__type, 1), REDUCE(sym_union_type, 1), REDUCE(sym_intersection_type, 1), REDUCE(sym_disjunctive_normal_form_type, 1, .dynamic_precedence = -1),
  [3140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [3148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [3150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [3152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [3154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_type, 1),
  [3156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 1),
  [3158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional_type, 2),
  [3160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2),
  [3162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [3170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [3172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_union_type_repeat1, 2),
  [3174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2),
  [3176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [3178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_intersection_type_repeat1, 2),
  [3180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2), SHIFT_REPEAT(1334),
  [3183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2),
  [3185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_string_member_access_expression, 3, .production_id = 26),
  [3187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_member_access_expression, 3, .production_id = 26),
  [3189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [3191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [3193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2),
  [3195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2),
  [3197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__complex_string_part, 3),
  [3199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__complex_string_part, 3),
  [3201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 1, .production_id = 7),
  [3203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 1, .production_id = 7),
  [3205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_string_part, 1, .production_id = 8),
  [3207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_part, 1, .production_id = 8),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [3213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [3215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [3217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [3219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [3231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_string_subscript_expression, 4),
  [3233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_subscript_expression, 4),
  [3235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_type_repeat1, 2), REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2),
  [3238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2), REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2),
  [3241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 4),
  [3243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 4),
  [3245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [3247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [3249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [3253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [3257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [3263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [3265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [3267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [3269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [3271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [3275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [3279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [3281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [3283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [3285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [3287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [3289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [3291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [3293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [3295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [3297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [3299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [3301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [3303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [3305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [3309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [3311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [3313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [3315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [3319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [3321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2), SHIFT_REPEAT(1333),
  [3324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [3326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [3330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [3334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing_element, 3),
  [3336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [3340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [3342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [3344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unset_statement_repeat1, 2),
  [3346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [3350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [3354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [3356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [3360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [3364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [3368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [3372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [3376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 4),
  [3378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [3382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_disjunctive_normal_form_type, 2, .dynamic_precedence = -1),
  [3384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_disjunctive_normal_form_type, 2, .dynamic_precedence = -1),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [3388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_disjunctive_normal_form_type, 4, .dynamic_precedence = -1),
  [3390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_disjunctive_normal_form_type, 4, .dynamic_precedence = -1),
  [3392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [3396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2), SHIFT_REPEAT(1323),
  [3399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [3401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [3403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [3405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_disjunctive_normal_form_type, 3, .dynamic_precedence = -1),
  [3407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_disjunctive_normal_form_type, 3, .dynamic_precedence = -1),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [3411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [3413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [3415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [3417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [3419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [3421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [3423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [3425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2644),
  [3428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2351),
  [3431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [3433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [3435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [3439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2),
  [3443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(256),
  [3446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(2311),
  [3449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body, 1, .production_id = 7),
  [3451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body, 1, .production_id = 7),
  [3453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_clause, 1),
  [3455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [3457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [3459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [3461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [3463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body, 2),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [3467] = {.entry = {.count = 5, .reusable = true}}, REDUCE(sym__type, 1), REDUCE(sym_union_type, 1), REDUCE(sym_intersection_type, 1), REDUCE(sym_disjunctive_normal_form_type, 1, .dynamic_precedence = -1), SHIFT(1331),
  [3473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [3475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2468),
  [3477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [3479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [3483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [3485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [3489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [3491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [3493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [3495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [3497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2395),
  [3499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [3503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [3509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1),
  [3511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 48), SHIFT(2434),
  [3514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 48), SHIFT(83),
  [3517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 19), SHIFT(2434),
  [3520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 19), SHIFT(83),
  [3523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [3529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_clause, 2),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [3533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [3537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_clause_repeat1, 2),
  [3539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [3547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [3553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name, 1),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [3565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name, 2),
  [3567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 2), SHIFT(2518),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [3572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [3576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution_qualifier, 1),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [3588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 3, .production_id = 14),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [3602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [3608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [3618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [3620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [3626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [3634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [3638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_namespace_name_repeat1, 2),
  [3640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_name_repeat1, 2), SHIFT_REPEAT(2518),
  [3643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2242),
  [3645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [3647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2), SHIFT_REPEAT(1335),
  [3650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2), SHIFT_REPEAT(1329),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [3655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2336),
  [3657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [3659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [3661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_element, 1),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [3665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 4, .production_id = 36),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [3675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [3679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2), SHIFT_REPEAT(1332),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [3686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2), SHIFT_REPEAT(1330),
  [3689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2), SHIFT_REPEAT(1318),
  [3692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1664),
  [3694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2228),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [3702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat2, 2, .production_id = 92),
  [3704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat2, 2, .production_id = 92), SHIFT_REPEAT(2370),
  [3707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat2, 2, .production_id = 92),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [3711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [3713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 1), SHIFT(2518),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [3734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [3744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [3746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [3758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [3760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [3776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 92), SHIFT_REPEAT(2434),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [3787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_interface_clause, 2),
  [3789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [3795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [3797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_name_repeat1, 2), SHIFT_REPEAT(2489),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [3802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_clause_repeat1, 2), SHIFT_REPEAT(1460),
  [3805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [3809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [3813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [3817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [3819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_declaration_repeat1, 2),
  [3821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_declaration_repeat1, 2), SHIFT_REPEAT(2055),
  [3824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [3826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__const_declaration_repeat1, 2),
  [3828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__const_declaration_repeat1, 2), SHIFT_REPEAT(1591),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [3835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [3845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing, 4),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [3853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [3855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_intersection_type, 2), SHIFT(1331),
  [3858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [3860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [3864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [3866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [3870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group_clause, 1),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [3876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_namespace_use_declaration_repeat1, 2),
  [3878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_use_declaration_repeat1, 2), SHIFT_REPEAT(1434),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [3883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [3893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [3895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [3907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [3909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [3913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2), SHIFT_REPEAT(1331),
  [3916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_nowdoc_body_repeat1, 2),
  [3918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_nowdoc_body_repeat1, 2), SHIFT_REPEAT(1823),
  [3921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2),
  [3923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2), SHIFT_REPEAT(1553),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [3934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat2, 2),
  [3936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat2, 2), SHIFT_REPEAT(1959),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [3947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [3949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [3953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group_clause, 2),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [3959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [3961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1851),
  [3964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1851),
  [3967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_static_declaration_repeat1, 2),
  [3969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_static_declaration_repeat1, 2), SHIFT_REPEAT(2156),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [3974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [3978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_clause, 3),
  [3980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [3982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [3990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 1),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [3996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [3998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing, 3),
  [4000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nowdoc_body, 2),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [4006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [4008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [4012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [4014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [4018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [4020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 1),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [4024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_clause_repeat1, 2), SHIFT_REPEAT(1441),
  [4027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 2),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [4031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_variable_declaration, 1, .production_id = 2),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [4053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 4, .production_id = 123),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [4057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [4061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 65),
  [4063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(154),
  [4066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [4070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_element, 2),
  [4072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_condition_list_repeat1, 2), SHIFT_REPEAT(395),
  [4075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_aliasing_clause, 2),
  [4077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name_as_prefix, 3),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [4091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name_as_prefix, 2),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [4097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 2, .production_id = 4),
  [4099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [4105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 6),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [4109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 6, .production_id = 137),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [4117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 5, .production_id = 111),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [4125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 2, .production_id = 31),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [4129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 3),
  [4131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__return_type, 2, .production_id = 38),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [4151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 4, .production_id = 35),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [4159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unset_statement_repeat1, 2), SHIFT_REPEAT(842),
  [4162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_interface_clause, 3),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [4174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_destructing_repeat1, 2), SHIFT_REPEAT(150),
  [4177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__array_destructing_repeat1, 2),
  [4179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 2, .production_id = 32),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [4183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat2, 1, .production_id = 46),
  [4185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat2, 1, .production_id = 46),
  [4187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_use_group_repeat1, 2), SHIFT_REPEAT(1729),
  [4190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_namespace_use_group_repeat1, 2),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [4196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 5, .production_id = 160),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [4200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 5, .production_id = 81),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [4204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_anonymous_function_use_clause_repeat1, 2), SHIFT_REPEAT(1817),
  [4207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_anonymous_function_use_clause_repeat1, 2),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [4215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing_element, 1, .production_id = 6),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [4229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 4, .production_id = 125),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [4237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 5),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [4251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 7, .production_id = 137),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [4261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 3, .production_id = 27),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [4267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 4, .production_id = 117),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 2, .production_id = 33),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [4275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 3, .production_id = 79),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [4281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 3, .production_id = 78),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [4291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 4, .production_id = 122),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [4295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_clause_2, 3, .production_id = 19),
  [4297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_clause_2, 3, .production_id = 19),
  [4299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 3, .production_id = 77),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [4303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 7),
  [4305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 5, .production_id = 51),
  [4307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 3, .production_id = 75),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [4313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(699),
  [4316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [4330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 3, .production_id = 73),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [4334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 2, .production_id = 34),
  [4336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [4338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 3, .production_id = 16),
  [4340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 3, .production_id = 72),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [4346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 3),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [4352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 2, .production_id = 50),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [4358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 4),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [4362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_clause, 2),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [4368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(134),
  [4371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2),
  [4373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 4, .production_id = 51),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [4377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [4381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [4385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(149),
  [4388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2),
  [4390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 3, .production_id = 21),
  [4392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [4394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 2), SHIFT_REPEAT(155),
  [4397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing_element, 3, .production_id = 51),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [4403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 1),
  [4405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(145),
  [4408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_group_repeat1, 2), SHIFT_REPEAT(1432),
  [4411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_group_repeat1, 2),
  [4413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 67),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [4429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 1, .production_id = 2),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [4433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 57),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [4437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [4439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [4455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [4457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [4459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [4465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name_as_prefix, 1), SHIFT(2185),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [4470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__array_destructing_element, 3), REDUCE(sym_array_element_initializer, 3),
  [4473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [4475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 2, .production_id = 12),
  [4477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [4479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 4),
  [4481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [4485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [4487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [4489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [4491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group, 3),
  [4493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 3, .production_id = 71),
  [4495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_instead_of_clause, 3),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [4501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [4505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 4, .production_id = 119),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [4509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 3, .production_id = 74),
  [4511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [4513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 3, .production_id = 76),
  [4515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 4, .production_id = 121),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [4533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 4, .production_id = 124),
  [4535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_use_clause, 6),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [4547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_reference, 2),
  [4549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, .production_id = 4),
  [4551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_use_clause, 4),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [4555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [4557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [4559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [4571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name_as_prefix, 2), SHIFT(2185),
  [4574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 2), SHIFT(2489),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [4603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__array_destructing_element, 1), REDUCE(sym_array_element_initializer, 1),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [4618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_use_clause, 5),
  [4620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 5, .production_id = 162),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [4628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group, 4),
  [4630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group_clause, 3),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [4644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_type, 1),
  [4646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [4648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 4, .production_id = 136),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [4662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_directive, 3),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [4682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 6, .production_id = 154),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [4688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause_2, 2, .production_id = 3),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [4728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [4736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [4766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 3),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [4802] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [4824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 44),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [4828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [4832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [4834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [4838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [4840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [4844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [4846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [4852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [4854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [4856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [4858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [4862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [4866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [4868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [4874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [4876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [4878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [4880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 3, .production_id = 17),
  [4882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [4884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [4886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [4888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [4890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [4892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [4894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [4896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [4898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [4900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [4902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [4904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 5, .production_id = 112),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [4910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [4912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [4914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name_as_prefix, 4),
  [4916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [4922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 5, .production_id = 109),
  [4924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_subscript_unary_expression, 2),
  [4926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [4928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [4934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [4940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [4946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [4950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [4960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [4968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 5, .production_id = 99),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [4972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 66),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [4984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [4992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 58),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token_encapsed_string_chars = 1,
  ts_external_token_encapsed_string_chars_after_variable = 2,
  ts_external_token_execution_string_chars = 3,
  ts_external_token_execution_string_chars_after_variable = 4,
  ts_external_token_encapsed_string_chars_heredoc = 5,
  ts_external_token_encapsed_string_chars_after_variable_heredoc = 6,
  ts_external_token__eof = 7,
  ts_external_token_heredoc_start = 8,
  ts_external_token_heredoc_end = 9,
  ts_external_token_nowdoc_string = 10,
  ts_external_token_sentinel_error = 11,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token_encapsed_string_chars] = sym_encapsed_string_chars,
  [ts_external_token_encapsed_string_chars_after_variable] = sym_encapsed_string_chars_after_variable,
  [ts_external_token_execution_string_chars] = sym_execution_string_chars,
  [ts_external_token_execution_string_chars_after_variable] = sym_execution_string_chars_after_variable,
  [ts_external_token_encapsed_string_chars_heredoc] = sym_encapsed_string_chars_heredoc,
  [ts_external_token_encapsed_string_chars_after_variable_heredoc] = sym_encapsed_string_chars_after_variable_heredoc,
  [ts_external_token__eof] = sym__eof,
  [ts_external_token_heredoc_start] = sym_heredoc_start,
  [ts_external_token_heredoc_end] = sym_heredoc_end,
  [ts_external_token_nowdoc_string] = sym_nowdoc_string,
  [ts_external_token_sentinel_error] = sym_sentinel_error,
};

static const bool ts_external_scanner_states[14][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_encapsed_string_chars] = true,
    [ts_external_token_encapsed_string_chars_after_variable] = true,
    [ts_external_token_execution_string_chars] = true,
    [ts_external_token_execution_string_chars_after_variable] = true,
    [ts_external_token_encapsed_string_chars_heredoc] = true,
    [ts_external_token_encapsed_string_chars_after_variable_heredoc] = true,
    [ts_external_token__eof] = true,
    [ts_external_token_heredoc_start] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token_nowdoc_string] = true,
    [ts_external_token_sentinel_error] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [3] = {
    [ts_external_token_encapsed_string_chars_heredoc] = true,
    [ts_external_token_heredoc_end] = true,
  },
  [4] = {
    [ts_external_token_encapsed_string_chars_heredoc] = true,
  },
  [5] = {
    [ts_external_token_encapsed_string_chars] = true,
  },
  [6] = {
    [ts_external_token_execution_string_chars] = true,
  },
  [7] = {
    [ts_external_token_encapsed_string_chars_heredoc] = true,
    [ts_external_token_encapsed_string_chars_after_variable_heredoc] = true,
    [ts_external_token_heredoc_end] = true,
  },
  [8] = {
    [ts_external_token_encapsed_string_chars] = true,
    [ts_external_token_encapsed_string_chars_after_variable] = true,
  },
  [9] = {
    [ts_external_token_execution_string_chars] = true,
    [ts_external_token_execution_string_chars_after_variable] = true,
  },
  [10] = {
    [ts_external_token_heredoc_end] = true,
    [ts_external_token_nowdoc_string] = true,
  },
  [11] = {
    [ts_external_token_heredoc_end] = true,
  },
  [12] = {
    [ts_external_token_nowdoc_string] = true,
  },
  [13] = {
    [ts_external_token_heredoc_start] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_php_only_external_scanner_create(void);
void tree_sitter_php_only_external_scanner_destroy(void *);
bool tree_sitter_php_only_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_php_only_external_scanner_serialize(void *, char *);
void tree_sitter_php_only_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_php_only(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_name,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_php_only_external_scanner_create,
      tree_sitter_php_only_external_scanner_destroy,
      tree_sitter_php_only_external_scanner_scan,
      tree_sitter_php_only_external_scanner_serialize,
      tree_sitter_php_only_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
